(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[   1932368,      34350]
NotebookOptionsPosition[   1927958,      34211]
NotebookOutlinePosition[   1928823,      34241]
CellTagsIndexPosition[   1928780,      34238]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[TextData[StyleBox["LevelScheme examples: Diagrams",
 FontFamily->"Times New Roman",
 FontSize->36]], "Text",
 CellChangeTimes->{{3.491258240734375*^9, 3.491258242390625*^9}},
 FontSize->10],

Cell[TextData[{
 StyleBox["M. A. Caprio, ", "SmallText",
  FontFamily->"Times New Roman",
  FontSize->12],
 "Department of Physics, University of Notre Dame"
}], "Text",
 CellChangeTimes->{{3.39552255203125*^9, 3.3955225581875*^9}, {
   3.396878383875*^9, 3.39687838403125*^9}, 3.397586352671875*^9, {
   3.39854548165625*^9, 3.398545486203125*^9}, {3.430247945015625*^9, 
   3.430247947875*^9}, {3.436820309328125*^9, 3.436820313328125*^9}, {
   3.4972250515*^9, 3.497225051796875*^9}}],

Cell[CellGroupData[{

Cell["Package initialization", "Section"],

Cell[TextData[{
 "If you have not already loaded the LevelScheme package since starting this ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " session, you must do so now.  See the user guide for information first on \
installing the package and then on loading it at the beginning of each ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " session."
}], "Text",
 CellChangeTimes->{{3.4921245209375*^9, 3.492124756234375*^9}, {
  3.492124799609375*^9, 3.492124838453125*^9}, {3.495659733515625*^9, 
  3.495659808359375*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Get", "[", "\"\<LevelScheme`\>\"", "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.492124284765625*^9, 3.49212429721875*^9}, 
   3.492124551328125*^9}],

Cell[BoxData[
 FrameBox[
  TemplateBox[{TagBox[
     GridBox[{{
        RowBox[{
         "LevelScheme", " ", "scientific", " ", "figure", " ", "preparation", 
          " ", "system"}]}, {
        RowBox[{
          RowBox[{"M", ".", " ", "A", ".", " ", "Caprio"}], ",", " ", 
          RowBox[{"Department", " ", "of", " ", "Physics"}], ",", " ", 
          RowBox[{"University", " ", "of", " ", "Notre", " ", "Dame"}]}]}, {
        TemplateBox[{"\"Comput. Phys. Commun. \"", 
          TagBox[
           StyleBox["\"171\"", FontWeight -> "Bold"], 
           StyleForm[#, FontWeight -> "Bold"]& ], "\", 107 (2005)\""}, "Row", 
         DisplayFunction -> (
          RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ), 
         InterpretationFunction -> (RowBox[{"Row", "[", 
            RowBox[{"{", 
              RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )]}, {
        RowBox[{"Version", " ", "3.52", " ", 
          RowBox[{"(", 
            RowBox[{
              RowBox[{"September", " ", "20"}], ",", " ", "2011"}], ")"}]}]}, {
        RowBox[{
          ButtonBox[
           StyleBox[
            RowBox[{"View", " ", "color", " ", "palette"}], FontFamily -> 
            "Times"], Active -> True, Appearance -> {Automatic, "DialogBox"}, 
           ButtonFunction :> (NamedColors`NamedColorPalette[]& ), ButtonNote -> 
           "Named color palette", Evaluator -> Automatic, ImageSize -> 
           Automatic], 
          TagBox[
           ButtonBox[
            StyleBox[
             RowBox[{"Visit", " ", "home", " ", "page"}], FontFamily -> 
             "Times"], Active -> True, Appearance -> {Automatic, "DialogBox"},
             ButtonData :> {
              URL["http://scidraw.nd.edu/landing/levelscheme-3.52.html"], 
              None}, ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookLocate[#2]}]& ), ButtonNote -> 
            "http://scidraw.nd.edu/landing/levelscheme-3.52.html", ImageSize -> 
            Automatic], DisplayForm]}]}}, 
      GridBoxAlignment -> {
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}}], DisplayForm],"\"  \"",GraphicsBox[{{
       GrayLevel[0], 
       AbsoluteThickness[2], 
       Opacity[1], 
       Dashing[{}], 
       LineBox[{{0.1, 200.}, {0.9, 200.}}]}, {
       GrayLevel[0], 
       AbsoluteThickness[2], 
       Opacity[1], 
       Dashing[{}], 
       LineBox[{{0.1, 116.93046875}, {0.1536723484848485, 116.93046875}, {
        0.2610170454545455, 100.}, {0.7389829545454545, 100.}, {
        0.8463276515151515, 116.93046875}, {0.9, 116.93046875}}]}, {
       GrayLevel[0], 
       AbsoluteThickness[2], 
       Opacity[1], 
       Dashing[{}], 
       LineBox[{{0.1, 0.}, {0.9, 0.}}], {
        GrayLevel[0.5], 
        Opacity[1], 
        PolygonBox[{{0.6300000000000001, 200.}, {0.5892415745214576, 200.}, {
         0.6828827683115883, 106.35880620986916`}, {0.675461586050597, 
         105.04604015402995`}, {0.73, 100.}, {0.7595683183418321, 
         119.92405545354092`}, {0.7521471360808408, 118.61128939770171`}, {
         0.6707584254785426, 200.}}]}, {
        GrayLevel[0], 
        AbsoluteThickness[1], 
        Opacity[1], 
        Dashing[{}], 
        LineBox[{{0.6300000000000001, 200.}, {0.5892415745214576, 200.}, {
         0.6828827683115883, 106.35880620986916`}, {0.675461586050597, 
         105.04604015402995`}, {0.73, 100.}, {0.7595683183418321, 
         119.92405545354092`}, {0.7521471360808408, 118.61128939770171`}, {
         0.6707584254785426, 200.}, {0.6300000000000001, 200.}}], {
         GrayLevel[0.5], 
         Opacity[1], 
         PolygonBox[{{0.2700000000000001, 100.}, {0.22924157452145752`, 
          100.}, {0.3228827683115884, 6.358806209869151}, {0.3154615860505971,
           5.046040154029939}, {0.37000000000000005`, 0.}, {
          0.3995683183418322, 19.924055453540902`}, {0.39214713608084084`, 
          18.61128939770171}, {0.3107584254785426, 100.}}]}, {
         GrayLevel[0], 
         AbsoluteThickness[1], 
         Opacity[1], 
         Dashing[{}], 
         LineBox[{{0.2700000000000001, 100.}, {0.22924157452145752`, 100.}, {
          0.3228827683115884, 6.358806209869151}, {0.3154615860505971, 
          5.046040154029939}, {0.37000000000000005`, 0.}, {0.3995683183418322,
           19.924055453540902`}, {0.39214713608084084`, 18.61128939770171}, {
          0.3107584254785426, 100.}, {0.2700000000000001, 100.}}]}, {
         GrayLevel[0], 
         AbsoluteThickness[1], 
         Opacity[1], 
         Dashing[{}], 
         LineBox[{{0.501, 20.}, {0.529, 20.}}]}, {
         GrayLevel[0], 
         AbsoluteThickness[1], 
         Opacity[1], 
         Dashing[{}], 
         LineBox[{{0.531, 21.3}, {0.5589999999999999, 21.3}}]}, {
         GrayLevel[0], 
         AbsoluteThickness[1], 
         Opacity[1], 
         Dashing[{}], 
         LineBox[{{0.5609999999999999, 24.333333333333336`}, {0.589, 
          24.333333333333336`}}]}, {
         GrayLevel[0], 
         AbsoluteThickness[1], 
         Opacity[1], 
         Dashing[{}], 
         LineBox[{{0.591, 29.1}, {0.619, 29.1}}]}, {
         GrayLevel[0], 
         AbsoluteThickness[1], 
         Opacity[1], 
         Dashing[{}], 
         LineBox[{{0.621, 35.6}, {0.649, 35.6}}]}, {
         GrayLevel[0], 
         AbsoluteThickness[1], 
         Opacity[1], 
         Dashing[{}], 
         LineBox[{{0.651, 43.833333333333336`}, {0.679, 
          43.833333333333336`}}]}, {
         GrayLevel[0], 
         AbsoluteThickness[1], 
         Opacity[1], 
         Dashing[{}], 
         LineBox[{{0.681, 53.8}, {0.709, 53.8}}]}, {
         GrayLevel[0], 
         AbsoluteThickness[1], 
         Opacity[1], 
         Dashing[{}], 
         LineBox[{{0.711, 65.5}, {0.739, 65.5}}]}, {
         GrayLevel[0], 
         AbsoluteThickness[1], 
         Opacity[1], 
         Dashing[{}], 
         LineBox[{{0.741, 78.93333333333334}, {0.769, 78.93333333333334}}]}, {
         RGBColor[1, 0, 0], 
         AbsoluteThickness[1], 
         Opacity[1], 
         Dashing[{}], 
         LineBox[{{0.501, 33.}, {0.529, 33.}}]}, {
         RGBColor[1, 0, 0], 
         AbsoluteThickness[1], 
         Opacity[1], 
         Dashing[{}], 
         LineBox[{{0.531, 34.3}, {0.5589999999999999, 34.3}}]}, {
         RGBColor[1, 0, 0], 
         AbsoluteThickness[1], 
         Opacity[1], 
         Dashing[{}], 
         LineBox[{{0.5609999999999999, 37.333333333333336`}, {0.589, 
          37.333333333333336`}}]}, {
         RGBColor[1, 0, 0], 
         AbsoluteThickness[1], 
         Opacity[1], 
         Dashing[{}], 
         LineBox[{{0.591, 42.099999999999994`}, {0.619, 
          42.099999999999994`}}]}, {
         RGBColor[1, 0, 0], 
         AbsoluteThickness[1], 
         Opacity[1], 
         Dashing[{}], 
         LineBox[{{0.621, 48.599999999999994`}, {0.649, 
          48.599999999999994`}}]}, {
         RGBColor[1, 0, 0], 
         AbsoluteThickness[1], 
         Opacity[1], 
         Dashing[{}], 
         LineBox[{{0.651, 56.833333333333336`}, {0.679, 
          56.833333333333336`}}]}, {
         RGBColor[1, 0, 0], 
         AbsoluteThickness[1], 
         Opacity[1], 
         Dashing[{}], 
         LineBox[{{0.681, 66.8}, {0.709, 66.8}}]}, {
         RGBColor[1, 0, 0], 
         AbsoluteThickness[1], 
         Opacity[1], 
         Dashing[{}], 
         LineBox[{{0.711, 78.5}, {0.739, 78.5}}]}, {
         Hue[0.4739282735611543, 0.7, 1], 
         AbsoluteThickness[1], 
         Opacity[1], 
         Dashing[{}], 
         LineBox[{{0.501, 47.761071567264665`}, {0.529, 
          47.761071567264665`}}]}, {
         Hue[0.4739282735611543, 0.7, 1], 
         AbsoluteThickness[1], 
         Opacity[1], 
         Dashing[{}], 
         LineBox[{{0.531, 49.24022665797266}, {0.5589999999999999, 
          49.24022665797266}}]}, {
         Hue[0.4739282735611543, 0.7, 1], 
         AbsoluteThickness[1], 
         Opacity[1], 
         Dashing[{}], 
         LineBox[{{0.5609999999999999, 52.691588536291334`}, {0.589, 
          52.691588536291334`}}]}, {
         Hue[0.4739282735611543, 0.7, 1], 
         AbsoluteThickness[1], 
         Opacity[1], 
         Dashing[{}], 
         LineBox[{{0.591, 58.115157202220665`}, {0.619, 
          58.115157202220665`}}]}, {
         Hue[0.4739282735611543, 0.7, 1], 
         AbsoluteThickness[1], 
         Opacity[1], 
         Dashing[{}], 
         LineBox[{{0.621, 65.51093265576067}, {0.649, 65.51093265576067}}]}, {
         Hue[0.4739282735611543, 0.7, 1], 
         AbsoluteThickness[1], 
         Opacity[1], 
         Dashing[{}], 
         LineBox[{{0.651, 74.87891489691134}, {0.679, 74.87891489691134}}]}, {
         Hue[0.022803460025882117`, 0.7, 1], 
         AbsoluteThickness[1], 
         Opacity[1], 
         Dashing[{}], 
         LineBox[{{0.501, 56.07894755622853}, {0.529, 56.07894755622853}}]}, {
         Hue[0.022803460025882117`, 0.7, 1], 
         AbsoluteThickness[1], 
         Opacity[1], 
         Dashing[{}], 
         LineBox[{{0.531, 57.38554745213195}, {0.5589999999999999, 
          57.38554745213195}}]}, {
         Hue[0.022803460025882117`, 0.7, 1], 
         AbsoluteThickness[1], 
         Opacity[1], 
         Dashing[{}], 
         LineBox[{{0.5609999999999999, 60.434280542573276`}, {0.589, 
          60.434280542573276`}}]}, {
         Hue[0.022803460025882117`, 0.7, 1], 
         AbsoluteThickness[1], 
         Opacity[1], 
         Dashing[{}], 
         LineBox[{{0.591, 65.22514682755249}, {0.619, 65.22514682755249}}]}, {
         Hue[0.022803460025882117`, 0.7, 1], 
         AbsoluteThickness[1], 
         Opacity[1], 
         Dashing[{}], 
         LineBox[{{0.621, 71.75814630706962}, {0.649, 71.75814630706962}}]}, {
         Hue[0.022803460025882117`, 0.7, 1], 
         AbsoluteThickness[1], 
         Opacity[1], 
         Dashing[{}], 
         LineBox[{{0.651, 80.03327898112465}, {0.679, 80.03327898112465}}]}, {
         Hue[0.7490704830227459, 0.7, 1], 
         AbsoluteThickness[1], 
         Opacity[1], 
         Dashing[{}], 
         LineBox[{{0.501, 60.981197953135855`}, {0.529, 
          60.981197953135855`}}]}, {
         Hue[0.7490704830227459, 0.7, 1], 
         AbsoluteThickness[1], 
         Opacity[1], 
         Dashing[{}], 
         LineBox[{{0.531, 62.04756255970392}, {0.5589999999999999, 
          62.04756255970392}}]}, {
         Hue[0.7490704830227459, 0.7, 1], 
         AbsoluteThickness[1], 
         Opacity[1], 
         Dashing[{}], 
         LineBox[{{0.5609999999999999, 64.53574664169608}, {0.589, 
          64.53574664169608}}]}, {
         Hue[0.7490704830227459, 0.7, 1], 
         AbsoluteThickness[1], 
         Opacity[1], 
         Dashing[{}], 
         LineBox[{{0.591, 68.44575019911233}, {0.619, 68.44575019911233}}]}, {
         Hue[0.7490704830227459, 0.7, 1], 
         AbsoluteThickness[1], 
         Opacity[1], 
         Dashing[{}], 
         LineBox[{{0.621, 73.77757323195266}, {0.649, 73.77757323195266}}]}, {
         Hue[0.7490704830227459, 0.7, 1], 
         AbsoluteThickness[1], 
         Opacity[1], 
         Dashing[{}], 
         LineBox[{{0.651, 80.53121574021708}, {0.679, 80.53121574021708}}], 
         InsetBox[
          TagBox["\"LevelScheme\"", DisplayForm], {0.1, 200.}, {-1, -0.75}, 
          Automatic, {1, 0}, 
          BaseStyle -> {
           FontFamily -> "Times", FontSize -> 10, FontSlant -> "Plain", 
            FontTracking -> "Plain", FontWeight -> "Plain", FontColor -> 
            GrayLevel[0], FontOpacity -> 1, ShowAutoStyles -> False}]}}}}, 
     AspectRatio -> 0.7727272727272727, Axes -> False, Background -> 
     RGBColor[0.889996, 0.509995, 0.089999], 
     BaseStyle -> {
      FontFamily -> "Times", FontSize -> 12, FontSlant -> "Plain", 
       FontTracking -> "Plain", FontWeight -> "Plain", FontColor -> 
       GrayLevel[0], FontOpacity -> 1, ShowAutoStyles -> False}, 
     DisplayFunction -> Identity, Frame -> False, 
     FrameLabel -> {None, None, None, None}, FrameStyle -> Directive[{
        GrayLevel[0], 
        Opacity[1], 
        AbsoluteThickness[1], 
        AbsoluteDashing[{}]}], FrameTicks -> None, 
     ImageSize -> {93.17647058823529, 72.}, 
     PlotRange -> {{-0.0001, 1.0001}, {-50.0325, 275.0325}}, Ticks -> None]},
   "Row",
   DisplayFunction->(
    RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
   InterpretationFunction->(RowBox[{"Row", "[", 
      RowBox[{"{", 
        RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
  Background->GrayLevel[0.85],
  FrameMargins->10,
  FrameStyle->None,
  StripOnInput->False]], "Print",
 CellChangeTimes->{3.525527880296875*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Diagram with various special arrow types", "Section"],

Cell["Note the uses of \"squiggle\" and \"multiline\" arrows", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Figure", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"(*", " ", "target", " ", "*)"}], "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"SchemeSquare", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.03", ",", "0.3"}], "}"}], ",", 
       RowBox[{"FillColor", "\[Rule]", "Gold"}]}], "]"}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", "beam", " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"SetOptions", "[", 
      RowBox[{"SchemeArrow", ",", 
       RowBox[{"ArrowType", "\[Rule]", "MultilineArrow"}], ",", 
       RowBox[{"ShaftLines", "\[Rule]", "3"}], ",", 
       RowBox[{"FillColor", "\[Rule]", "Gray"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"SchemeArrow", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "2"}], ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], ",", 
       RowBox[{"ShowHead", "\[Rule]", "False"}], ",", 
       RowBox[{"HeadLength", "\[Rule]", "0"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"SchemeArrow", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "0"}], "}"}], ",", 
       RowBox[{"Dashing", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"ShowFill", "\[Rule]", "False"}]}], "]"}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"gamma", " ", "rays"}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"SetOptions", "[", 
      RowBox[{"SchemeArrow", ",", 
       RowBox[{"ArrowType", "\[Rule]", "SquiggleArrow"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"SchemeArrow", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}], ",", 
       RowBox[{"Color", "\[Rule]", "Blue"}], ",", 
       RowBox[{"SquiggleWavelength", "\[Rule]", "8"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"SchemeArrow", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1"}], ",", 
         RowBox[{"-", "1"}]}], "}"}], ",", 
       RowBox[{"Color", "\[Rule]", "Red"}], ",", 
       RowBox[{"SquiggleWavelength", "\[Rule]", "12"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"SchemeCircle", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], ",", "0.3", ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"Pi", "/", "4"}]}], "}"}], ",", 
       RowBox[{"ShowFill", "\[Rule]", "False"}], ",", 
       RowBox[{"LabR", "\[Rule]", "\"\<\[Theta]\>\""}], ",", 
       RowBox[{"NudgeR", "\[Rule]", "10"}]}], "]"}]}], "\[IndentingNewLine]", 
    "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "2"}], ",", "2"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}]}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"ImageSize", "\[Rule]", 
    RowBox[{"72", "*", 
     RowBox[{"{", 
      RowBox[{"4", ",", "2"}], "}"}]}]}]}], "\[IndentingNewLine]", 
  "]"}]], "Input",
 CellChangeTimes->{3.395521142875*^9, 3.39552154471875*^9}],

Cell[BoxData[
 GraphicsBox[{
   {RGBColor[1., 0.843104, 0.], Opacity[1], 
    PolygonBox[{{-0.03, -0.3}, {-0.03, 0.3}, {0.03, 0.3}, {0.03, -0.3}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-0.03, -0.3}, {-0.03, 0.3}, {0.03, 0.3}, {
     0.03, -0.3}, {-0.03, -0.3}}], 
    {GrayLevel[0.5], Opacity[1], 
     PolygonBox[{{-2., -0.03472916666666681}, {0., -0.03472916666666681}, {0.,
       0.}, {0., 0.03472916666666648}, {-2., 0.03472916666666648}}]}, 
    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
     None], LineBox[{{-2., -0.03472916666666681}, {
      0., -0.03472916666666681}}], LineBox[{{-2., 0.}, {0., 0.}}], 
     LineBox[{{-2., 0.03472916666666648}, {0., 0.03472916666666648}}]}, 
    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], AbsoluteDashing[{4, 2}], 
     CapForm[None], 
     LineBox[{{0., -0.03472916666666681}, {
      1.9621136363636356`, -0.03472916666666681}}], 
     LineBox[{{0., 0.}, {1.9999999999999991`, 0.}}], 
     LineBox[{{0., 0.03472916666666648}, {1.9621136363636356`, 
      0.03472916666666648}}]}, 
    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
     None], LineBox[{{1.9166499999999993`, 0.0764041666666666}, {
      1.9999999999999991`, 0.}, {
      1.9166499999999993`, -0.07640416666666672}}]}, 
    {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
     CapForm[None], LineBox[CompressedData["
1:eJxdl3s0VPv//1VK91RCkTi6iaIbpfQUKnWUURSFJt2INCThKE5USqeECpEJ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      "]]}, 
    {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
     CapForm[None], 
     LineBox[{{0.9115939746821518, 0.9705313248940504}, {0.9999999999999996, 
      0.9999999999999996}, {0.9705313248940506, 0.9115939746821518}}]}, 
    {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
     CapForm[None], LineBox[CompressedData["
1:eJxdlnk01PvDxxGuFq6krFcSkqSSUKnImihlrSvJVpZCSSLabFG4JSlSoVJX
KEuSvG1FY2loMNbZjDFmSLZEy/N9nqfn1znPnDPndV7n8/qc8/7+9f2ucA/Y
7yUkICAwQfz/m///Z1QdssBv3V0I/B/dVDrVxDOQnE22PDuahapie3lVhXTc
T1DZp7D2MS4I7w9rib2D9dMSu48a/gsj+fmGwxF3MBahlDIrWoAL+r3nJlXS
QRUg71m47TkuzLS5P7+ZAXqXxVOt2heoar0W8J2fCWqehKGmZDHuy1B3hyg8
QFXmnOh55RK4zT1nLDfMhrKecOvsOOEPdogodDyEM1+H0hxXCje7dRWHmLlI
yygUj2CXQqCz8O1ZhzzMeLDvQuIlbNe5xYpKFsJttV2i+aKXKPR0jMqTeQHL
iP3qQZxSFDqfj/uuV4wLUstfjj0the3sLt/D7qUw+sWqdGnr6mtlGGME/9Ui
Vwpy0jZbqWflWH/GON+mrwTKbzfalBVXQLbRyDy0rARjca8/C96pRGhyvt7P
khIEqm2fq19dBboT650xjThfPJtL5VdBWeyIwOetpQgM7wtyulEN58qkeXWt
xPNM2nVeVKhBmUNa846cl5A0cq5AVA3uW0SnpRSXQSP907YnH2qQJm+teV2w
HJan8rsFfhA+URtdFPuaeP4GlSypWoSWRMUbG79B7qufd7wW18L27KJ1CerA
fY+fg7NEb+skmCp7qwpG+V4F5fQaOLcula1+VA1ZlTmxkxU1/6FAarL76rQa
9J6kf1Vpq0UafVqTe7YGdP5keCOjDsnx0yGRR2sQ90dgWCb7LQyOr/1k7F2D
UG6RtQn1HcbIFvqssBp4WknvXVBSD8knopQtT2owpEf+Jh/aAA3hTAfVSeL8
ftHb20rvQd2btcX9UC2c5TTX1D16j4YG2ftX2bUQ9tKWFJIkwVLn27GFV+ug
UfX2H95BEhqUypYp7n0L07QobZMrJFSdl5VjrXmHmbnMkIG7JOQeceHFKtUj
t7999HEGCc7nOrkHVRpwP659y7Z4wqd5fvN03sPg49Z53/1IkLVodSm2+E36
rVIbr0ONmCz3LvVbSfjixg/ix5twVaQ5co0ICXFa5i30wGbEFTSRqsbfI1Qi
/n60Rwt0r88zifr8Hm4Bw1nWRh/An/orQU2UhLG1drn5gmQIt/SuitAloZBZ
t2jUngyN1cFPvM+ToLH8wo55t8mgBIcm5gyRIGAmpJPVTEbDyOhES2AjUsab
x5dNkGHq1FZhI9OEHNe11TsXtKLBJNHXtbsJ55K3eN2QbkVxzqi/2stmUAQd
V0wtaUVOjM4O0pMWkDsc6kH0lg+ebbv77AMUv8X9e2+OjFxxBi3LlYxFpXbO
4VwyxH5xJkBJxKmTDF/Xd2S74FaY3tzH1Wsg40Q6ebHGN8J99yUJgowaDYl/
Fke2IaPHf7dHJRnlcutnPb60IVg87FMR0WtbuYXXe33EhbNdb2g0MgKNtrft
rf8I6VUPI+1FWqE9VaCXJE8B33pV0MTmVuRu8PPJcaXA8wozWyyyFZFOI3+b
3KBAdbu9mGVrK6REXimWlRHnujqHyTptUAqS5bE+UED1dKdvfNCGmSy1JN1u
CsgOUbti5D9ij7Tx7tQu4j6ruiEgg3Cu0Wc3MgUayk3zTVUpSJMIbjeqpiCu
YfslxYLf5Ac+n53c3I7QS/PXzWQQ/uz11vfV7ah5bLiEeo0Co61fy1+YdKDq
nOGrrCgKDLQUVEXedGDZqNNpYcILXXY/PLamE+PLveQcEikY27/629jVTvxI
qONceEic/5Hutp7eieubk3OnSMQeU8cbZqpUHDsslZ7ykwIBX2r0gDMV9PTm
5icm7UiWyTE/EElFpu0OHW5qOzIuz1safZMKpvlfV4JmiJ0lkq/a71HheMZm
Qbt3B8jqWqf1Cd9zLODUKnoHmubWKAilUpE1lTcu6d4J6RWHfzJiqMjRebmR
ze2EcM/qvDfBVIj+4mTKpPNtdyq8L2eopv6kwrR81bazdlT4Vz3y8o3tglHS
KpaJFRWVNgMDdvO7kSZgcu/hLipKt4vueXSpG4E6tibTRK8ZoPdh/uduXMgs
WKziR8UJL2n16/t7IGkd3paaTIWWfEx868MeDAV9r9v0ltjjaPxmkNsDt/yy
L1bzuxB2rrYgWqkXyh6aLvEuXVikmRQ4a9ILtwNiRVKVXZBPHd2u/ncvqFcM
dEO0ujFdP8cM8epFU9jBuw0Pu2G9WeYe1ZO4L5am+GJVD6wkZMyyiV7VLOtQ
TEEPUjdarb5s3YuoEekO1y2/OXQzdo/+214EP6Zd2qJBeNs/SQtt+lDVJHVU
Xq4XRm4fJKZa+lDxQEqc/WcvdPd9PmNh2Q/pJdrvzQnPvbji69PSfoyabj1+
i+j5Z37u3ShLw2zhna2163uRpxVUfNKPhkRX72/6jsQ+Hy1ObAENnlFDox3x
vZhJzO9SH6Chvyp7Bb+lF+ZK25qbhenIOL00Zo1KH/ZQ/Is9JOno95voLbrc
hy3HT4leXUqHfcZKV5nxPgyqXRwwJNz6mlm9j18/PCUv6mcRfab8ZXO7kX4s
yL6zWmo+HVlO12JXnabhf78C6BD6xbFXpLyeERp07Dcb+pvRYUj7nvy6n4bi
k5UujlcIL/6uF9NOg+vmQ4q7SXSkqMlNcCg0UDeM2k6KMuDvpH7LgEaDtFXM
YvXtDITWRnt5TtOwyWzKcPgEAzFlGjf44sS95dqfrqQxENjos8hQgw7ym4S4
lHIG8n3qH5pb0VFBbhIcoDCwyFTAefAUHVGPddwzOQxo7wi4/DSHjoRD7rt0
Jxg45vSHaW8PHaHTx9JdZhgY3JsWGi3LgFpByFlxwhOX6RuEHWAg63ZI00mi
l9xU4ex5lwFLreRKJo8BoytTKWTmbwb2abcaajBhMHjQr7KLgfG5os/q/kz0
hwYf0m5jIKNm/3OFZ0y4eAQX3mhmQP41i13HZUJM8VKiKeH2H8MfTSuzMFUc
R/cn+uCW4dbyfSx88y2rF+pngJK7MupgOAvvjJU03owReywu/uV1l4VC+8MP
Fi1k4tuBmtTilyyMjFdskVnLRN16jS8nSCxYN0/xSx2ZIA069Qt3sHCiwVM2
PJaJsvOu69f2sJBL/0bNq2TC08Bfor+bBdWua+KOc0wMqPgfMSH6lntazVaG
LMSVRNsVtbCwt/L5iO4FFvEdxFv94O1vhgTYCiRVEHu8Vb3FFw5ASch3/Ecx
CzrRT2K+7BlABt/HzLOQhd7dlub8pAFYPjyzcinhTqZdYTebBqC7PfL0thIW
rrsEba2fx4bh5DOXj1UsFDnRvRN02RBtXPLm2kcWpHTk5Na4sjHWZ6/XN0Ls
IYe82HSBDa1zLz5w/hzAFtbLNdF32Ih35F2M3TyAeeV/Xd3xjI38fQef7fYd
wIJAm1PtZWwM+Ywfj3gwgGkx+7ff37Dh7n45S71/ANnVR7LzCV+0WsVdYTkb
K/KOTC95xUaixeNLIh5sNGwPH7r8nI3KdHplUO5vjn6Sm+sbYaN0xuzm4Xts
BErcU2jYMAiXhMOxH26xodi+rafi5CC6Tx/u1r3BRmpzy5/eBYOI0T5exr7O
Rhvbm3xrcBDB9acWSKSxMU5vn/tbhoOwiOzP2dls7H8tkT9nxIGJ/fz9rqXE
ngP+FqIeHGgftWp8RmYjzP9ZlUMEB74iuZ5l42zsNFmyQjKZAxKNvsxZcRCW
X3eKPUrngNe9d6eizSD0ru862HKfA/UJjtCeqEEwrZwMzhOexQvV/1I1CLdN
TgkDRG/9QuYLT5AD0YbACPsUDprJGTIdZhx8U+2w25nAwY9fnL64VXP9JWLP
2T+T88kcZEg7KN4P46DwVkphmvQQZH/aB4iEcHDAdWPgNYchvHvpblN6moN2
x7ocvetDKLb1uddP9JIBLl7H3g+hXPR2THAMBxt8G5O1Zodwqe/HoPZtDpJN
hU2aVnLhP7bDLbKI2MM80tthxsXTxLtf49o5KJvKclB340LMp+NfjZ8cXGwS
K6Wf5ELT06yTv24IcZcM7oZEcuF9ru+W0tEhnFbY8SnzMhfM4BNN9dlDWEGx
bt5LePxW8asVA0O4V2mtXEL0iw5ez3ukwYXZPm8ptTNcGOY3Dkmd4GLbL/oL
iaidL+JCd+EGCHhxMaYcb+bzhYvuu1bPAw9xkcbREHE1GMaBOCvhDmcupOmv
Nv9xehjCxs7MGMJtZ/bNGuQNY7zLVbeA6AMnqtS+9w5jJilRwcyHi5bmr50Z
ojxUe0+G/wwn9vg7BT3W4CHv7KapPalczESmDU/v5GFY5kbigTIuqhx+WD13
4MFyvNHoK4OLdwu1dSyO8OAzssX/jdQwXuToRgV485Aj8lHr065huB3a6a5M
uPIPjyNpMcPot9hZEk30pDqhFdfqhxHV/ffjqQM8WLNijc8s5OGcfnUEy/Y3
T6ao27daEHsSZl/tTeVBfpWRubERD9pPz3dv7uYhdbHR7UdbeaAGKt3RVuDD
lGRzxolwe5+Clk4nPtZ72L8/T/SJFy2S5ifxYSAXVbjUmoeCc6XlzeBDYIwr
SXblQcLpk/9xLh98oTXxy8/ysHvKWjR04Qg0H8St1EznQU8s8Xy92gjiwqvb
39fxIECboF00GEFuyHrBxCkeRG+urJcxHcFAYkM1tPiYXKspZ7RrBG6xB6aP
+fCROaj/ZcxyBGJ7ZkoOPeVDqVXfypHo4/0jOixG+aj12Gf4znAE5VWlUsUb
R/D6FwX/5z049h/+F+6pjtU=
      "]]}, 
    {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
     CapForm[None], 
     LineBox[{{-0.9115939746821522, -0.9705313248940509}, \
{-1.0000000000000002`, -1.0000000000000002`}, {-0.9705313248940508, \
-0.9115939746821522}}]}, 
    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
     None], CircleBox[{0., 0.}, 0.3, 
      NCache[{0, Rational[1, 4] Pi}, {0, 0.7853981633974483}]], InsetBox[
      TagBox[
       StyleBox[
        TagBox["\<\"\[Theta]\"\>",
         DisplayForm],
        StripOnInput->False,
        ShowAutoStyles->False,
        SingleLetterItalics->False,
        FontFamily->"Times",
        FontSize->12,
        FontWeight->"Plain",
        FontSlant->"Plain",
        FontTracking->"Plain",
        FontColor->GrayLevel[0],
        FontOpacity->1],
       DisplayForm], {0.3, 0.13891666666666666`}, {-1, 0}, Automatic, {1, 
      0}]}}},
  AspectRatio->NCache[
    Rational[1, 2], 0.5],
  Axes->False,
  Background->None,
  BaseStyle->{
   FontFamily -> "Times", FontSize -> 12, FontSlant -> "Plain", FontTracking -> 
    "Plain", FontWeight -> "Plain", FontColor -> GrayLevel[0], FontOpacity -> 
    1, ShowAutoStyles -> False, SingleLetterItalics -> False},
  DisplayFunction->Identity,
  Frame->False,
  FrameLabel->{None, None, None, None},
  FrameStyle->Directive[{
     GrayLevel[0], 
     Opacity[1], 
     CapForm[None], 
     AbsoluteThickness[1], 
     AbsoluteDashing[{}]}],
  FrameTicks->None,
  ImageSize->{288, 144},
  PlotRange->{{-2.0004, 2.0004}, {-1.0002, 1.0002}},
  Ticks->None]], "Output",
 CellChangeTimes->{3.497225598359375*^9, 3.525527882015625*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["SU(2) laddering", "Section",
 CellChangeTimes->{{3.489885713125*^9, 3.4898857150625*^9}, {
  3.49272478496875*^9, 3.49272479584375*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Figure", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"SchemeLine", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "4"}], ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"ShowHead", "\[Rule]", "True"}], ",", 
       RowBox[{"LabR", "\[Rule]", 
        RowBox[{"textit", "[", "\"\<M\>\"", "]"}]}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"lab", "[", 
       RowBox[{"-", "3"}], "]"}], "=", 
      RowBox[{"Row", "[", 
       RowBox[{"{", 
        RowBox[{"\"\<-\>\"", ",", 
         RowBox[{"textit", "[", "\"\<J\>\"", "]"}]}], "}"}], "]"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"lab", "[", 
       RowBox[{"-", "2"}], "]"}], "=", "None"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"lab", "[", 
       RowBox[{"-", "1"}], "]"}], "=", "None"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"lab", "[", "0", "]"}], "=", "\"\<\[CenterEllipsis]\>\""}], ",",
      "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"lab", "[", 
       RowBox[{"+", "1"}], "]"}], "=", "None"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"lab", "[", 
       RowBox[{"+", "2"}], "]"}], "=", 
      RowBox[{"Row", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"textit", "[", "\"\<J\>\"", "]"}], ",", "\"\<-1\>\""}], 
        "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"lab", "[", 
       RowBox[{"+", "3"}], "]"}], "=", 
      RowBox[{"Row", "[", 
       RowBox[{"{", 
        RowBox[{"textit", "[", "\"\<J\>\"", "]"}], "}"}], "]"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Table", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"SchemeCircle", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"M", ",", "0"}], "}"}], ",", 
         RowBox[{"Point", "[", "3", "]"}], ",", 
         RowBox[{"FillColor", "\[Rule]", "Moccasin"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"LabB", "\[Rule]", 
          RowBox[{"lab", "[", "M", "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"M", ",", 
         RowBox[{"-", "3"}], ",", "3"}], "}"}]}], "\[IndentingNewLine]", 
      "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Table", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"SchemeLine", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"M", "-", "1", "+", "0.05"}], ",", "0.1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"M", "-", "0.05"}], ",", "0.1"}], "}"}]}], "}"}], ",", 
         RowBox[{"ShowTail", "\[Rule]", "True"}], ",", 
         RowBox[{"ShowHead", "\[Rule]", "True"}], ",", 
         RowBox[{"Color", "\[Rule]", "Firebrick"}], ",", 
         RowBox[{"HeadLip", "\[Rule]", "2"}], ",", 
         RowBox[{"HeadLength", "\[Rule]", "3"}], ",", 
         RowBox[{"LabT", "\[Rule]", 
          RowBox[{"Subscript", "[", 
           RowBox[{
            RowBox[{"textit", "[", "\"\<J\>\"", "]"}], ",", 
            "\"\<\[PlusMinus]\>\""}], "]"}]}], ",", 
         RowBox[{"OffsetT", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{"-", "1"}]}], "}"}]}], ",", 
         RowBox[{"PosnT", "\[Rule]", "0.5"}], ",", 
         RowBox[{"BufferT", "\[Rule]", "0"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"M", ",", 
         RowBox[{"-", "2"}], ",", "3"}], "}"}]}], "\[IndentingNewLine]", 
      "]"}], ","}], "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "6"}], ",", "6"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}]}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"ImageSize", "\[Rule]", 
    RowBox[{"72", "*", 
     RowBox[{"{", 
      RowBox[{"4", ",", "2"}], "}"}]}]}]}], "\[IndentingNewLine]", 
  "]"}]], "Input",
 CellChangeTimes->{{3.40243520075*^9, 3.40243524146875*^9}, {
   3.402435289734375*^9, 3.402435537453125*^9}, {3.402435570578125*^9, 
   3.402435759390625*^9}, {3.40243588296875*^9, 3.40243591275*^9}, {
   3.40829301315625*^9, 3.40829302334375*^9}, {3.489876338515625*^9, 
   3.48987651640625*^9}, {3.4898765751875*^9, 3.489877023234375*^9}, {
   3.48987706428125*^9, 3.4898771024375*^9}, {3.4898771391875*^9, 
   3.489877449546875*^9}, {3.489885728828125*^9, 3.489886394046875*^9}, 
   3.492724774671875*^9}],

Cell[BoxData[
 GraphicsBox[{
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-3.999999999999999, 0.}, {4.000000000000001, 0.}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{3.749950000000001, 0.04167499999999991}, {
     4.000000000000001, 0.}, {3.749950000000001, -0.04167500000000013}}], 
    {RGBColor[1., 0.894101, 0.709799], Opacity[1], 
     DiskBox[{-2.999999999999999, 0.}, {0.125025, 0.041675}, 
      NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
     None], CircleBox[{-2.999999999999999, 0.}, {0.125025, 0.041675}, 
      NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
     {RGBColor[1., 0.894101, 0.709799], Opacity[1], 
      DiskBox[{-1.9999999999999991`, 0.}, {0.125025, 0.041675}, 
       NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
     {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
      None], CircleBox[{-1.9999999999999991`, 0.}, {0.125025, 0.041675}, 
       NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
      {RGBColor[1., 0.894101, 0.709799], Opacity[1], 
       DiskBox[{-0.9999999999999991, 0.}, {0.125025, 0.041675}, 
        NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
      {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
       None], CircleBox[{-0.9999999999999991, 0.}, {0.125025, 0.041675}, 
        NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
       {RGBColor[1., 0.894101, 0.709799], Opacity[1], 
        DiskBox[{8.881784197001252*^-16, 0.}, {0.125025, 0.041675}, 
         NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
       {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
        None], CircleBox[{8.881784197001252*^-16, 0.}, {0.125025, 0.041675}, 
         NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
        {RGBColor[1., 0.894101, 0.709799], Opacity[1], 
         DiskBox[{1.0000000000000009`, 0.}, {0.125025, 0.041675}, 
          NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
        {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
         None], CircleBox[{1.0000000000000009`, 0.}, {0.125025, 0.041675}, 
          NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
         {RGBColor[1., 0.894101, 0.709799], Opacity[1], 
          DiskBox[{2.000000000000001, 0.}, {0.125025, 0.041675}, 
           NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          CircleBox[{2.000000000000001, 0.}, {0.125025, 0.041675}, 
           NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
          {RGBColor[1., 0.894101, 0.709799], Opacity[1], 
           DiskBox[{3.000000000000001, 0.}, {0.125025, 0.041675}, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           CircleBox[{3.000000000000001, 0.}, {0.125025, 0.041675}, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Opacity[1], Dashing[{}], CapForm[None], 
           LineBox[{{-2.9499999999999993`, 0.1}, {-2.049999999999999, 0.1}}]}, 
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Opacity[1], Dashing[{}], CapForm[None], 
           LineBox[{{-2.175024999999998, 
            0.12778333333333336`}, {-2.049999999999998, 
            0.09999999999999987}, {-2.175024999999998, 0.0722166666666666}}]}, 
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Opacity[1], Dashing[{}], CapForm[None], 
           LineBox[{{-2.824974999999999, 
            0.0722166666666666}, {-2.949999999999999, 
            0.09999999999999987}, {-2.824974999999999, 
            0.12778333333333336`}}]}, 
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Opacity[1], Dashing[{}], CapForm[None], 
           LineBox[{{-1.949999999999999, 0.1}, {-1.0499999999999992`, 0.1}}]}, 
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Opacity[1], Dashing[{}], CapForm[None], 
           LineBox[{{-1.1750249999999989`, 
            0.12778333333333336`}, {-1.049999999999998, 
            0.09999999999999987}, {-1.1750249999999989`, 
            0.0722166666666666}}]}, 
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Opacity[1], Dashing[{}], CapForm[None], 
           LineBox[{{-1.8249749999999985`, 
            0.0722166666666666}, {-1.9499999999999984`, 
            0.09999999999999987}, {-1.8249749999999985`, 
            0.12778333333333336`}}]}, 
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Opacity[1], Dashing[{}], CapForm[None], 
           LineBox[{{-0.9499999999999991, 0.1}, {-0.049999999999999115`, 
            0.1}}]}, 
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Opacity[1], Dashing[{}], CapForm[None], 
           LineBox[{{-0.17502499999999888`, 
            0.12778333333333336`}, {-0.049999999999998934`, 
            0.09999999999999987}, {-0.17502499999999888`, 
            0.0722166666666666}}]}, 
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Opacity[1], Dashing[{}], CapForm[None], 
           LineBox[{{-0.8249749999999985, 
            0.0722166666666666}, {-0.9499999999999984, 
            0.09999999999999987}, {-0.8249749999999985, 
            0.12778333333333336`}}]}, 
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Opacity[1], Dashing[{}], CapForm[None], 
           LineBox[{{0.05000000000000089, 0.1}, {0.9500000000000008, 0.1}}]}, 
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Opacity[1], Dashing[{}], CapForm[None], 
           LineBox[{{0.8249750000000011, 0.12778333333333336`}, {
            0.9500000000000011, 0.09999999999999987}, {0.8249750000000011, 
            0.0722166666666666}}]}, 
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Opacity[1], Dashing[{}], CapForm[None], 
           LineBox[{{0.17502500000000154`, 0.0722166666666666}, {
            0.0500000000000016, 0.09999999999999987}, {0.17502500000000154`, 
            0.12778333333333336`}}]}, 
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Opacity[1], Dashing[{}], CapForm[None], 
           LineBox[{{1.050000000000001, 0.1}, {1.9500000000000008`, 0.1}}]}, 
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Opacity[1], Dashing[{}], CapForm[None], 
           LineBox[{{1.8249750000000011`, 0.12778333333333336`}, {
            1.950000000000002, 0.09999999999999987}, {1.8249750000000011`, 
            0.0722166666666666}}]}, 
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Opacity[1], Dashing[{}], CapForm[None], 
           LineBox[{{1.1750250000000015`, 0.0722166666666666}, {
            1.0500000000000016`, 0.09999999999999987}, {1.1750250000000015`, 
            0.12778333333333336`}}]}, 
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Opacity[1], Dashing[{}], CapForm[None], 
           LineBox[{{2.0500000000000007`, 0.1}, {2.950000000000001, 0.1}}]}, 
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Opacity[1], Dashing[{}], CapForm[None], 
           LineBox[{{2.824975000000003, 0.12778333333333336`}, {
            2.9500000000000037`, 0.09999999999999987}, {2.824975000000003, 
            0.0722166666666666}}]}, 
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Opacity[1], Dashing[{}], CapForm[None], 
           LineBox[{{2.1750250000000007`, 0.0722166666666666}, {
            2.0500000000000016`, 0.09999999999999987}, {2.1750250000000007`, 
            0.12778333333333336`}}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               TagBox[
                StyleBox["\<\"M\"\>",
                 FontSlant->"Italic"],
                StyleForm[#, FontSlant -> "Italic"]& ],
               DisplayForm],
              StripOnInput->False,
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {4.000000000000001, 0.}, {-1, 0}, Automatic, {1., 
            0.}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               TemplateBox[{"\"-\"",TagBox[
                  StyleBox["\"J\"", FontSlant -> "Italic"], 
                  StyleForm[#, FontSlant -> "Italic"]& ]},
                "Row",
                DisplayFunction->(RowBox[{#, "\[InvisibleSpace]", #2}]& ),
                InterpretationFunction->(RowBox[{"Row", "[", 
                   RowBox[{"{", 
                    RowBox[{#, ",", #2}], "}"}], "]"}]& )],
               DisplayForm],
              StripOnInput->False,
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {-2.999999999999999, -0.041675}, {0, 1}, 
            Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox["\<\"\[CenterEllipsis]\"\>",
               DisplayForm],
              StripOnInput->False,
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {8.881784197001252*^-16, -0.041675}, {0, 1}, 
            Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               TemplateBox[{TagBox[
                  StyleBox["\"J\"", FontSlant -> "Italic"], 
                  StyleForm[#, FontSlant -> "Italic"]& ],"\"-1\""},
                "Row",
                DisplayFunction->(RowBox[{#, "\[InvisibleSpace]", #2}]& ),
                InterpretationFunction->(RowBox[{"Row", "[", 
                   RowBox[{"{", 
                    RowBox[{#, ",", #2}], "}"}], "]"}]& )],
               DisplayForm],
              StripOnInput->False,
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {2.000000000000001, -0.041675}, {0, 1}, 
            Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               TemplateBox[{TagBox[
                  StyleBox["\"J\"", FontSlant -> "Italic"], 
                  StyleForm[#, FontSlant -> "Italic"]& ]},
                "Row",
                DisplayFunction->(#& ),
                InterpretationFunction->(RowBox[{"Row", "[", 
                   RowBox[{"{", #, "}"}], "]"}]& )],
               DisplayForm],
              StripOnInput->False,
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {3.000000000000001, -0.041675}, {0, 1}, 
            Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               SubscriptBox[
                TagBox[
                 StyleBox["\<\"J\"\>",
                  FontSlant->"Italic"],
                 
                 StyleForm[#, FontSlant -> 
                  "Italic"]& ], "\<\"\[PlusMinus]\"\>"],
               DisplayForm],
              StripOnInput->False,
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->RGBColor[0.698004, 0.133305, 0.133305],
              FontOpacity->1],
             DisplayForm], {-2.4999999999999987`, 0.09999999999999987}, {0, -1},
             Automatic, {1., 0.}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               SubscriptBox[
                TagBox[
                 StyleBox["\<\"J\"\>",
                  FontSlant->"Italic"],
                 
                 StyleForm[#, FontSlant -> 
                  "Italic"]& ], "\<\"\[PlusMinus]\"\>"],
               DisplayForm],
              StripOnInput->False,
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->RGBColor[0.698004, 0.133305, 0.133305],
              FontOpacity->1],
             DisplayForm], {-1.4999999999999991`, 0.09999999999999987}, {0, -1},
             Automatic, {1., 0.}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               SubscriptBox[
                TagBox[
                 StyleBox["\<\"J\"\>",
                  FontSlant->"Italic"],
                 
                 StyleForm[#, FontSlant -> 
                  "Italic"]& ], "\<\"\[PlusMinus]\"\>"],
               DisplayForm],
              StripOnInput->False,
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->RGBColor[0.698004, 0.133305, 0.133305],
              FontOpacity->1],
             DisplayForm], {-0.4999999999999982, 0.09999999999999987}, {0, -1},
             Automatic, {1., 0.}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               SubscriptBox[
                TagBox[
                 StyleBox["\<\"J\"\>",
                  FontSlant->"Italic"],
                 
                 StyleForm[#, FontSlant -> 
                  "Italic"]& ], "\<\"\[PlusMinus]\"\>"],
               DisplayForm],
              StripOnInput->False,
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->RGBColor[0.698004, 0.133305, 0.133305],
              FontOpacity->1],
             DisplayForm], {0.5000000000000018, 0.09999999999999987}, {0, -1},
             Automatic, {1., 0.}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               SubscriptBox[
                TagBox[
                 StyleBox["\<\"J\"\>",
                  FontSlant->"Italic"],
                 
                 StyleForm[#, FontSlant -> 
                  "Italic"]& ], "\<\"\[PlusMinus]\"\>"],
               DisplayForm],
              StripOnInput->False,
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->RGBColor[0.698004, 0.133305, 0.133305],
              FontOpacity->1],
             DisplayForm], {1.5000000000000018`, 0.09999999999999987}, {0, -1},
             Automatic, {1., 0.}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               SubscriptBox[
                TagBox[
                 StyleBox["\<\"J\"\>",
                  FontSlant->"Italic"],
                 
                 StyleForm[#, FontSlant -> 
                  "Italic"]& ], "\<\"\[PlusMinus]\"\>"],
               DisplayForm],
              StripOnInput->False,
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->RGBColor[0.698004, 0.133305, 0.133305],
              FontOpacity->1],
             DisplayForm], {2.5000000000000027`, 0.09999999999999987}, {0, -1},
             Automatic, {1., 0.}]}}}}}}}}},
  AspectRatio->NCache[
    Rational[1, 2], 0.5],
  Axes->False,
  Background->None,
  BaseStyle->{
   FontFamily -> "Times", FontSize -> 12, FontSlant -> "Plain", FontTracking -> 
    "Plain", FontWeight -> "Plain", FontColor -> GrayLevel[0], FontOpacity -> 
    1, ShowAutoStyles -> False, SingleLetterItalics -> False},
  DisplayFunction->Identity,
  Frame->False,
  FrameLabel->{None, None, None, None},
  FrameStyle->Directive[{
     GrayLevel[0], 
     Opacity[1], 
     CapForm[None], 
     AbsoluteThickness[1], 
     AbsoluteDashing[{}]}],
  FrameTicks->None,
  ImageSize->{288, 144},
  PlotRange->{{-6.0012, 6.0012}, {-1.0002, 1.0002}},
  Ticks->None]], "Output",
 CellChangeTimes->{{3.489886083796875*^9, 3.48988625875*^9}, {
   3.4898863718125*^9, 3.48988639484375*^9}, 3.492724776921875*^9, 
   3.5255278825625*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dipole-dipole interaction: Ellipses and arrows", "Section",
 CellChangeTimes->{{3.441571665177*^9, 3.44157167364575*^9}, {
  3.495659242078125*^9, 3.495659253296875*^9}, {3.495659289125*^9, 
  3.4956592956875*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Figure", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"SetOptions", "[", 
      RowBox[{"SchemeArrow", ",", 
       RowBox[{"Thickness", "\[Rule]", "1"}], ",", 
       RowBox[{"PosnC", "\[Rule]", "1"}]}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"SetOptions", "[", 
      RowBox[{"SchemeEllipse", ",", 
       RowBox[{"ShowFill", "\[Rule]", "False"}], ",", 
       RowBox[{"ShowHead", "\[Rule]", "True"}], ",", 
       RowBox[{"HeadLength", "\[Rule]", "3"}], ",", 
       RowBox[{"HeadLip", "\[Rule]", "4"}], ",", 
       RowBox[{"Thickness", "\[Rule]", "2"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"sa", "=", "0.3"}], ",", "\[IndentingNewLine]", 
     RowBox[{"rs", "=", "0.1"}], ",", "\[IndentingNewLine]", 
     RowBox[{"rl", "=", "0.2"}], ",", "\[IndentingNewLine]", 
     RowBox[{"P1", "=", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"P2", "=", 
      RowBox[{"{", 
       RowBox[{"1.5", ",", "0"}], "}"}]}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"SchemeCircle", "[", 
      RowBox[{"P1", ",", 
       RowBox[{"Point", "[", "2", "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"SchemeArrow", "[", 
      RowBox[{
       RowBox[{"P1", "+", 
        RowBox[{"Polar", "@", 
         RowBox[{"{", 
          RowBox[{"sa", ",", 
           RowBox[{
            RowBox[{"-", "Pi"}], "/", "2"}]}], "}"}]}]}], ",", 
       RowBox[{"P1", "+", 
        RowBox[{"Polar", "@", 
         RowBox[{"{", 
          RowBox[{"sa", ",", 
           RowBox[{
            RowBox[{"+", "Pi"}], "/", "2"}]}], "}"}]}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"LabC", "\[Rule]", 
        RowBox[{"SubscriptBox", "[", 
         RowBox[{
          RowBox[{"textbf", "[", "\"\<m\>\"", "]"}], ",", "\"\<1\>\""}], 
         "]"}]}], ",", 
       RowBox[{"OffsetC", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{"-", "1"}]}], "}"}]}], ",", 
       RowBox[{"OrientationC", "\[Rule]", "Horizontal"}]}], 
      "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"SchemeEllipse", "[", 
      RowBox[{"P1", ",", 
       RowBox[{"{", 
        RowBox[{"rl", ",", "rs"}], "}"}], ",", "0"}], "]"}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"SchemeCircle", "[", 
      RowBox[{"P2", ",", 
       RowBox[{"Point", "[", "2", "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"SchemeArrow", "[", 
      RowBox[{
       RowBox[{"P2", "+", 
        RowBox[{"Polar", "@", 
         RowBox[{"{", 
          RowBox[{"sa", ",", "Pi"}], "}"}]}]}], ",", 
       RowBox[{"P2", "+", 
        RowBox[{"Polar", "@", 
         RowBox[{"{", 
          RowBox[{"sa", ",", "0"}], "}"}]}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"LabC", "\[Rule]", 
        RowBox[{"SubscriptBox", "[", 
         RowBox[{
          RowBox[{"textbf", "[", "\"\<m\>\"", "]"}], ",", "\"\<2\>\""}], 
         "]"}]}], ",", 
       RowBox[{"OffsetC", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1.5"}], ",", "0"}], "}"}]}], ",", 
       RowBox[{"OrientationC", "\[Rule]", "Horizontal"}]}], 
      "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"SchemeEllipse", "[", 
      RowBox[{"P2", ",", 
       RowBox[{"{", 
        RowBox[{"rl", ",", "rs"}], "}"}], ",", 
       RowBox[{"Pi", "/", "2"}]}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"SchemeCircle", "[", 
      RowBox[{"P2", ",", "0.5", ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"Pi", "/", "2"}]}], "}"}], ",", 
       RowBox[{"ShowTail", "\[Rule]", "True"}], ",", 
       RowBox[{"LabX", "\[Rule]", "\"\<\[Theta]\>\""}], ",", 
       RowBox[{"ShowFill", "\[Rule]", "False"}], ",", 
       RowBox[{"HeadLength", "\[Rule]", "3"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"SchemeLine", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"P1", ",", "P2"}], "}"}], ",", 
       RowBox[{"Dashing", "\[Rule]", "True"}]}], "]"}]}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}]}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"ExtendRange", "\[Rule]", "0.2"}], ",", "\[IndentingNewLine]", 
   RowBox[{"ImageSize", "\[Rule]", 
    RowBox[{"72", "*", 
     RowBox[{"{", 
      RowBox[{"8", ",", "4"}], "}"}]}]}]}], "\[IndentingNewLine]", 
  "]"}]], "Input",
 CellChangeTimes->{{3.400339538875*^9, 3.400339641125*^9}, 
   3.40033967371875*^9, {3.400339770671875*^9, 3.4003400125625*^9}, {
   3.410558353359375*^9, 3.41055836778125*^9}, {3.410558452890625*^9, 
   3.410558714703125*^9}, {3.41055889328125*^9, 3.41055892746875*^9}, {
   3.4105589676875*^9, 3.410558992125*^9}, {3.41055937271875*^9, 
   3.41055937871875*^9}, {3.410559421546875*^9, 3.41055982309375*^9}, {
   3.441571567677*^9, 3.441571576677*^9}}],

Cell[BoxData[
 GraphicsBox[{
   {GrayLevel[0], Opacity[1], 
    DiskBox[{-2.220446049250313*^-16, 0.}, 0.01944833333333333, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], CircleBox[{-2.220446049250313*^-16, 0.}, 0.01944833333333333, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-2.220446049250313*^-16, -0.2999999999999998}, \
{-2.220446049250313*^-16, 0.30000000000000004`}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-0.029172500000000268`, 
     0.24165500000000018`}, {-2.220446049250313*^-16, 0.30000000000000004`}, {
     0.029172499999999824`, 0.24165500000000018`}}]}, 
   {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[CompressedData["
1:eJxdlF1IU2EYx8dYhllETPuSxI1AkCQkBMnqUZlG4EUJFuT8yEoFxYXdKMay
C6UPS4fWZh9o4NdyTt2Y2zT7k9U2M7sQTJEsupDU7Ea6ENsg3dt78xw4HF7O
Oe/7PP//7/lrSgy515UKhUK/dW8/W9q3r0lS/L+OR2jjDJcnqbvjbvNgQRNN
rL06EtsdoPy5QsVt1zOKWl5OOtXsp7lFk3p1ZxcdLvzQtzfFR9H1f1TWGitp
EtIibzreU755LHdFYyd39mxledw72jQe3ciMGKZIZ1bwwb23VK4p+azrcVBy
VWA9KgTaM7/YGhNy0le7IdQfMU6NY2c2HPtdpP6ZmFGVMkp56dO3foRc9LDj
mO3RfTcpX8fr/WMjdOV3afG4ykVL52pHVy+5SXe1Izr9pYM2p7V2/bybzv+t
e2HVD5EuTWdez/BQ2UKRwlRqo4ufMnxGi4caV/rbpjL76KBFmar87qEJdY95
KruLahu0vbMHvGRcG7LZKjpJ+2RX6kedlx6rvnj9ee2UFF8RyCzzUlPrQkJ1
0EQF36r2na330kiR8+SSsYGqLVmDphYvDVhqZnKeVlLd6Zxf7Zat9fPwGnI9
Uhz+HvL73W3h/SD3i9kRPg/yvDeiHsh6lNHheiHr9Yl+IPvpFf1C9ntD6AGp
xzWhF6Red4SekHoOCL0h9T4h/ID0Iyj8gvTrgvAT0s9Dwm9Iv/2CB0gekgUv
kLwkCp4geYoVvEHyNiN4hOSRBK+QvHYKniF5Zu/B/gfbH+x8sPrA6gfrD6x/
MH3A9APTF0x/MH/A/APzF8x/MD7A+AHjC4w/MD7B+AXjG4x/sPkAmx+w+QKb
P7D5BJtfsPkGm3+wfADLD7B8AcsfsHwCyy+wfAPLP7B8BMtPsHwFy1/wfObr
f0gD6qg=
     "]]}, 
   {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], CapForm[None]
    , LineBox[{{0.16110333333333293`, -0.029172499999999824`}, {
     0.19999999999999973`, 2.220446049250313*^-16}, {
     0.2388966666666663, -0.029172499999999824`}}], 
    {GrayLevel[0], Opacity[1], 
     DiskBox[{1.4999999999999996`, 0.}, 0.01944833333333333, 
      NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
     None], CircleBox[{1.4999999999999996`, 0.}, 0.01944833333333333, 
      NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
     None], LineBox[{{1.1999999999999997`, 2.220446049250313*^-16}, {
      1.7999999999999998`, 2.220446049250313*^-16}}]}, 
    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
     None], LineBox[{{1.7416549999999997`, 0.029172500000000268`}, {
      1.7999999999999998`, 2.220446049250313*^-16}, {
      1.7416549999999997`, -0.029172499999999824`}}]}, 
    {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], CapForm[
     None], LineBox[CompressedData["
1:eJxdlGlIlFEUhjUlCKHJlHaVRsg0yx9lu72VZVEGFSYt0kxptowoWpllplkW
KhlD02KajlSTpS3MtFnaNc1cf1g2U4RK2DbSaBZyZy5qpT+6P86Fj4/Dvd+5
533fh2/67oTNe0Y5OTlFDT8j7z9/R5YdV/JHViNY7yf9qno7FoxWeidsb0TJ
6T8uAVo7mmx3vKbebIAiMfp+tcoOD6t19tLz9Rja8eHJ4nl2KHfWlSqCXyPU
98CjvrF2+PstGXPQ+Apjn6a1FvzkYGHmuH3etbB2TDYVmDncTasHc7NfIk1Z
Y5hTzbEivuG32xBDmOfxVt09Dtu9hKGy0VUQs+Zap+s5fL8HrIgPfoZl/SE5
oTqOa8WB5Xk5T6DWbI04mcOR2BOrrnJ9BO82r+BjmRwR0cWey0uMWFeZa/mU
yqEeSL12O+oBFn0u8EhJ5jj7UeWkjS3HcUt6uyKJw9BdpmteWQrD+3M3M+M5
ujwMl5vDbqAwMj3KpOEosj0oL9foMbDhaFvufg6zq6Wifks+Jo3vzhvYy9Fy
4aNf0qAWRwxuX3ksx3y1afHXE1mYsXT9ruTh+u7VlLfhV+Nozch5Rvoxch8j
8zAyLyN6GNHLiB+M+MWIn4z4zUgejOTFSJ6M5M0ID4zwwghPjPDGCI+M8MoI
zyzE3Uf1fKFD7u9IdR40xzvk9z15hRuhd8j+f6/7ra1rdsj7K9ovrlP8csj5
etdkBsWME3J+T+W38JgAIfWld4RsewMh9T/+cSpIs0lIf1zetUzsVAnp3wu3
msOVGiH9LdTdKjtxWEj/OwO7mrLShMzHGHrI3+e0kPnVTouxnc0WMt8M/wzf
vnNC5h85M2l7mlZIPtS3M66H64Tkx9l4JvDQJSH5+tIzIdH1ipD8ZW3rnzIm
X0g+LbUPi7KH6//8khrkPEg/kPtA5gGZF0QPiF4QP0D8AvETxG+QPEDyAskT
JG8QHkB4AeEJhDcQHkF4Bf0/0/of+g4UOQ==
      "]]}, 
    {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], CapForm[
     None], LineBox[{{1.5291724999999996`, 0.16110333333333338`}, {
      1.4999999999999996`, 0.20000000000000018`}, {1.5291724999999996`, 
      0.23889666666666676`}}]}, 
    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
     None], CircleBox[{1.4999999999999996`, 0.}, 0.49999999999999994`, 
      NCache[{0, Rational[1, 2] Pi}, {0, 1.5707963267948966`}]]}, 
    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
     None], LineBox[{{2.0291724999999996`, 0.029172500000000268`}, {
      1.9999999999999996`, 2.220446049250313*^-16}, {1.9708274999999995`, 
      0.029172500000000268`}}]}, 
    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], AbsoluteDashing[{4, 2}], 
     CapForm[None], 
     LineBox[{{-2.220446049250313*^-16, 0.}, {1.4999999999999996`, 0.}}], 
     InsetBox[
      TagBox[
       StyleBox[
        TagBox[
         SubscriptBox[
          TagBox[
           StyleBox["\<\"m\"\>",
            FontWeight->"Bold"],
           StyleForm[#, FontWeight -> "Bold"]& ], "1"],
         DisplayForm],
        StripOnInput->False,
        ShowAutoStyles->False,
        SingleLetterItalics->False,
        FontFamily->"Times",
        FontSize->12,
        FontWeight->"Plain",
        FontSlant->"Plain",
        FontTracking->"Plain",
        FontColor->GrayLevel[0],
        FontOpacity->1],
       DisplayForm], {-2.220446049250313*^-16, 0.30000000000000004`}, {0, -1},
       Automatic, {1, 0}], InsetBox[
      TagBox[
       StyleBox[
        TagBox[
         SubscriptBox[
          TagBox[
           StyleBox["\<\"m\"\>",
            FontWeight->"Bold"],
           StyleForm[#, FontWeight -> "Bold"]& ], "2"],
         DisplayForm],
        StripOnInput->False,
        ShowAutoStyles->False,
        SingleLetterItalics->False,
        FontFamily->"Times",
        FontSize->12,
        FontWeight->"Plain",
        FontSlant->"Plain",
        FontTracking->"Plain",
        FontColor->GrayLevel[0],
        FontOpacity->1],
       DisplayForm], {1.7999999999999998`, 2.220446049250313*^-16}, {-1.5, 0},
       Automatic, {1, 0}], InsetBox[
      TagBox[
       StyleBox[
        TagBox["\<\"\[Theta]\"\>",
         DisplayForm],
        StripOnInput->False,
        ShowAutoStyles->False,
        SingleLetterItalics->False,
        FontFamily->"Times",
        FontSize->12,
        FontWeight->"Plain",
        FontSlant->"Plain",
        FontTracking->"Plain",
        FontColor->GrayLevel[0],
        FontOpacity->1],
       DisplayForm], {1.9023731623521294`, 0.4023731623521298}, {0, 0}, 
      Automatic, {0.7071067811865475, -0.7071067811865476}]}}},
  AspectRatio->NCache[
    Rational[1, 2], 0.5],
  Axes->False,
  Background->None,
  BaseStyle->{
   FontFamily -> "Times", FontSize -> 12, FontSlant -> "Plain", FontTracking -> 
    "Plain", FontWeight -> "Plain", FontColor -> GrayLevel[0], FontOpacity -> 
    1, ShowAutoStyles -> False, SingleLetterItalics -> False},
  DisplayFunction->Identity,
  Frame->False,
  FrameLabel->{None, None, None, None},
  FrameStyle->Directive[{
     GrayLevel[0], 
     Opacity[1], 
     CapForm[None], 
     AbsoluteThickness[1], 
     AbsoluteDashing[{}]}],
  FrameTicks->None,
  ImageSize->{576, 288},
  PlotRange->{{-1.80056, 3.80056}, {-1.40028, 1.40028}},
  Ticks->None]], "Output",
 CellChangeTimes->{3.488839177921875*^9, 3.525527882953125*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Internal reflection", "Section",
 CellChangeTimes->{{3.4818133868125*^9, 3.481813394375*^9}, 
   3.482108535609375*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LineEndpoints", "[", 
    RowBox[{"theta_", ",", "d_", ",", 
     RowBox[{"{", 
      RowBox[{"L1_", ",", "L2_"}], "}"}]}], "]"}], ":=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"d", "*", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Cos", "[", "theta", "]"}], ",", 
         RowBox[{"Sin", "[", "theta", "]"}]}], "}"}]}], "+", 
      RowBox[{"L1", "*", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Sin", "[", "theta", "]"}]}], ",", 
         RowBox[{"Cos", "[", "theta", "]"}]}], "}"}]}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"d", "*", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Cos", "[", "theta", "]"}], ",", 
         RowBox[{"Sin", "[", "theta", "]"}]}], "}"}]}], "+", 
      RowBox[{"L2", "*", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Sin", "[", "theta", "]"}]}], ",", 
         RowBox[{"Cos", "[", "theta", "]"}]}], "}"}]}]}]}], 
    "\[IndentingNewLine]", "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.481813936078125*^9, 3.48181395778125*^9}, {
  3.481814074265625*^9, 3.4818141066875*^9}, {3.481814147359375*^9, 
  3.481814186734375*^9}, {3.481814434578125*^9, 3.48181446075*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Figure", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"zm", "=", "2.5"}], ",", "\[IndentingNewLine]", 
     RowBox[{"zme", "=", 
      RowBox[{"0.4", "*", "zm"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"xm", "=", "1.5"}], ",", "\[IndentingNewLine]", 
     RowBox[{"head", "=", "0.1"}], ",", "\[IndentingNewLine]", 
     RowBox[{"lambda", "=", "0.15"}], ",", "\[IndentingNewLine]", 
     RowBox[{"side", "=", 
      RowBox[{"xm", "*", 
       RowBox[{"Cos", "[", "theta", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"infinity", "=", "999"}], ",", "\[IndentingNewLine]", 
     RowBox[{"theta", "=", 
      RowBox[{"45", "*", "Degree"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"nj", "=", "10"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"SetOptions", "[", 
      RowBox[{"SchemeArrow", ",", 
       RowBox[{"HeadLength", "\[Rule]", "4"}], ",", 
       RowBox[{"HeadLip", "\[Rule]", "2"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"SetOptions", "[", 
      RowBox[{"SchemeAxis", ",", 
       RowBox[{"HeadLength", "\[Rule]", "4"}], ",", 
       RowBox[{"HeadLip", "\[Rule]", "2"}]}], "]"}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", "axes", " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"SchemeAxis", "[", 
      RowBox[{"Bottom", ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"zm", "+", "head"}]}], "}"}], ",", "0", ",", 
       RowBox[{"LabB", "\[Rule]", 
        RowBox[{"textit", "[", "\"\<z\>\"", "]"}]}], ",", 
       RowBox[{"PosnB", "\[Rule]", "1"}]}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"SchemeAxis", "[", 
      RowBox[{"Left", ",", "0", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "xm"}], ",", 
         RowBox[{"xm", "+", "head"}]}], "}"}], ",", 
       RowBox[{"LabL", "\[Rule]", 
        RowBox[{"textit", "[", "\"\<x\>\"", "]"}]}], ",", 
       RowBox[{"PosnL", "\[Rule]", "1"}], ",", 
       RowBox[{"OrientationL", "\[Rule]", "Horizontal"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"SchemeBox", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "zm"}], ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "xm"}], ",", "xm"}], "}"}]}], "}"}], ",", 
       RowBox[{"FillColor", "\[Rule]", "LightGray"}], ",", 
       RowBox[{"ShowLine", "\[Rule]", "False"}], ",", 
       RowBox[{"Layer", "\[Rule]", 
        RowBox[{"-", "1"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"SetOptions", "[", 
      RowBox[{"SchemeArrow", ",", 
       RowBox[{"BackgroundL", "\[Rule]", "LightGray"}], ",", 
       RowBox[{"BufferL", "\[Rule]", "1.3"}], ",", 
       RowBox[{"Thickness", "\[Rule]", "2"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"SetOptions", "[", 
      RowBox[{"SchemeLine", ",", 
       RowBox[{"Thickness", "\[Rule]", "0.5"}]}], "]"}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"plane", " ", "waves"}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
      "clip", " ", "wavefronts", " ", "to", " ", "region", " ", "with", " ", 
       "SetRegion"}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"SetRegion", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "zm"}], ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "xm"}], ",", "xm"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "zm"}], ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "xm"}], ",", "xm"}], "}"}]}], "}"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Table", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"SchemeLine", "[", 
        RowBox[{"LineEndpoints", "[", 
         RowBox[{"theta", ",", 
          RowBox[{"lambda", "*", "i"}], ",", 
          RowBox[{"{", 
           RowBox[{"side", ",", 
            RowBox[{"-", "infinity"}]}], "}"}]}], "]"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"i", ",", 
         RowBox[{"-", "20"}], ",", "20"}], "}"}]}], "\[IndentingNewLine]", 
      "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Table", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"SchemeLine", "[", 
        RowBox[{"LineEndpoints", "[", 
         RowBox[{
          RowBox[{"-", "theta"}], ",", 
          RowBox[{"lambda", "*", "i"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "side"}], ",", "infinity"}], "}"}]}], "]"}], "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"i", ",", 
         RowBox[{"-", "20"}], ",", "20"}], "}"}]}], "\[IndentingNewLine]", 
      "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"SetRegion", "[", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"SchemeArrow", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Polar", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "2"}], ",", "theta"}], "}"}], "]"}], ",", 
         RowBox[{"Polar", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "side"}], ",", "theta"}], "}"}], "]"}]}], "}"}], ",", 
       RowBox[{"LabL", "\[Rule]", 
        RowBox[{"textbf", "[", "\"\<k\>\"", "]"}]}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"SchemeArrow", "[", 
      RowBox[{
       RowBox[{"Reverse", "@", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Polar", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "2"}], ",", 
             RowBox[{"-", "theta"}]}], "}"}], "]"}], ",", 
          RowBox[{"Polar", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "side"}], ",", 
             RowBox[{"-", "theta"}]}], "}"}], "]"}]}], "}"}]}], ",", 
       RowBox[{"LabL", "\[Rule]", 
        RowBox[{"SuperPrime", "[", 
         RowBox[{
          RowBox[{"textbf", "[", "\"\<k\>\"", "]"}], ",", "2"}], "]"}]}]}], 
      "]"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"evanescent", " ", "wave"}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"SetRegion", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "zm"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "xm"}], ",", "xm"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "zm"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "xm"}], ",", "xm"}], "}"}]}], "}"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Table", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"SchemeLine", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"zme", "/", "nj"}], "*", 
              RowBox[{"(", 
               RowBox[{"j", "-", "1"}], ")"}]}], ",", 
             RowBox[{
              RowBox[{"lambda", "/", 
               RowBox[{"Sin", "[", "theta", "]"}]}], "*", "i"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"zme", "/", "nj"}], "*", "j"}], ",", 
             RowBox[{
              RowBox[{"lambda", "/", 
               RowBox[{"Sin", "[", "theta", "]"}]}], "*", "i"}]}], "}"}]}], 
          "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"LineColor", "\[Rule]", 
          RowBox[{"GrayLevel", "[", 
           RowBox[{"j", "/", "nj"}], "]"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"Show", "\[Rule]", 
          RowBox[{"(", 
           RowBox[{"i", "!=", "0"}], ")"}]}]}], "\[IndentingNewLine]", "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"i", ",", 
         RowBox[{"-", "8"}], ",", "8"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", "1", ",", "nj"}], "}"}]}], "\[IndentingNewLine]", 
      "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"SetRegion", "[", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"ManualLabel", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"zme", ",", 
         RowBox[{"0.5", "*", "xm"}]}], "}"}], ",", 
       RowBox[{"SuperPrime", "[", 
        RowBox[{"OverTilde", "[", 
         RowBox[{"textbf", "[", "\"\<k\>\"", "]"}], "]"}], "]"}]}], "]"}], 
     ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"ManualLabel", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "0.85"}], "*", "zm"}], ",", 
         RowBox[{
          RowBox[{"-", "0.2"}], "*", "xm"}]}], "}"}], ",", 
       RowBox[{"Subscript", "[", 
        RowBox[{
         RowBox[{"textit", "[", "\"\<n\>\"", "]"}], ",", "\"\<1\>\""}], 
        "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"ManualLabel", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"+", "0.85"}], "*", "zm"}], ",", 
         RowBox[{
          RowBox[{"-", "0.2"}], "*", "xm"}]}], "}"}], ",", 
       RowBox[{"Subscript", "[", 
        RowBox[{
         RowBox[{"textit", "[", "\"\<n\>\"", "]"}], ",", "\"\<2\>\""}], 
        "]"}]}], "]"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"SetOptions", "[", 
      RowBox[{"SchemeArrow", ",", 
       RowBox[{"Thickness", "\[Rule]", "1"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"SchemeArrow", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"0.3", "*", "zm"}], ",", 
            RowBox[{
             RowBox[{"-", "0.5"}], "*", "xm"}]}], "}"}], "+", 
          RowBox[{"{", 
           RowBox[{"0.4", ",", 
            RowBox[{"-", "0.2"}]}], "}"}]}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"0.3", "*", "zm"}], ",", 
           RowBox[{
            RowBox[{"-", "0.5"}], "*", "xm"}]}], "}"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"LabT", "\[Rule]", 
        RowBox[{"StackText", "[", 
         RowBox[{"Center", ",", "0", ",", 
          RowBox[{"{", 
           RowBox[{"\"\<Evanescent\>\"", ",", "\"\<wave\>\""}], "}"}]}], 
         "]"}]}], ",", 
       RowBox[{"OrientationT", "\[Rule]", "Horizontal"}], ",", 
       RowBox[{"OffsetT", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1.1"}], ",", 
          RowBox[{"+", "1"}]}], "}"}]}]}], "]"}]}], "\[IndentingNewLine]", 
    "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "3"}], ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "2"}], ",", "2"}], "}"}]}], "}"}]}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"ImageSize", "\[Rule]", 
    RowBox[{"72", "*", "0.75", "*", 
     RowBox[{"{", 
      RowBox[{"6", ",", "4"}], "}"}]}]}]}], "\[IndentingNewLine]", 
  "]"}]], "Input",
 CellChangeTimes->{{3.400339538875*^9, 3.400339641125*^9}, 
   3.40033967371875*^9, {3.400339770671875*^9, 3.4003400125625*^9}, {
   3.40034057915625*^9, 3.400340757515625*^9}, {3.40034081134375*^9, 
   3.400341004390625*^9}, {3.40284428675*^9, 3.402844347046875*^9}, {
   3.40284438971875*^9, 3.402844707515625*^9}, {3.40680969346875*^9, 
   3.4068099673125*^9}, {3.406835998875*^9, 3.406836068671875*^9}, {
   3.4343079153125*^9, 3.434308117078125*^9}, {3.438374458280198*^9, 
   3.438374461327073*^9}, {3.438374765061448*^9, 3.438375054295823*^9}, 
   3.465677031109375*^9, {3.4656770730625*^9, 3.465677285875*^9}, {
   3.46567840534375*^9, 3.46567871090625*^9}, {3.4657214805625*^9, 
   3.465721495109375*^9}, {3.465723373375*^9, 3.465723432734375*^9}, {
   3.465723463859375*^9, 3.465723504140625*^9}, {3.465723536421875*^9, 
   3.4657235808125*^9}, {3.465723622546875*^9, 3.4657237045625*^9}, {
   3.465723899671875*^9, 3.465723909484375*^9}, {3.465723943609375*^9, 
   3.465724152234375*^9}, {3.46572430209375*^9, 3.4657245648125*^9}, {
   3.465724609859375*^9, 3.465724686015625*^9}, 3.4657247286875*^9, {
   3.465724810765625*^9, 3.465724940796875*^9}, 3.465724994375*^9, 
   3.4657250260625*^9, {3.46572513190625*^9, 3.465725228921875*^9}, 
   3.46572537428125*^9, {3.465725608421875*^9, 3.4657263133125*^9}, {
   3.46572662571875*^9, 3.4657269748125*^9}, {3.465729455828125*^9, 
   3.465729466046875*^9}, {3.469956861*^9, 3.469957021546875*^9}, {
   3.46995767309375*^9, 3.469957726671875*^9}, {3.46995776421875*^9, 
   3.46995777453125*^9}, {3.469957852875*^9, 3.46995797765625*^9}, {
   3.4749012973125*^9, 3.474901336515625*^9}, {3.474901370859375*^9, 
   3.474901372515625*^9}, {3.474901418640625*^9, 3.474901421078125*^9}, {
   3.474901488703125*^9, 3.474901824984375*^9}, {3.4749028675625*^9, 
   3.47490288171875*^9}, {3.475419584640625*^9, 3.4754196073125*^9}, {
   3.47541963840625*^9, 3.475419653484375*^9}, {3.4754196881875*^9, 
   3.475420094546875*^9}, {3.47542012846875*^9, 3.4754202186875*^9}, {
   3.475420261515625*^9, 3.47542035315625*^9}, {3.475420803921875*^9, 
   3.4754210959375*^9}, {3.47903126865625*^9, 3.4790314976875*^9}, {
   3.48085512759375*^9, 3.48085528175*^9}, {3.48085536146875*^9, 
   3.48085554375*^9}, {3.48085557909375*^9, 3.48085576815625*^9}, {
   3.48085581309375*^9, 3.480855864328125*^9}, {3.480855909265625*^9, 
   3.48085600040625*^9}, {3.480856053453125*^9, 3.480856057171875*^9}, {
   3.481813414953125*^9, 3.481813673515625*^9}, {3.481813752328125*^9, 
   3.481813814421875*^9}, {3.481813851890625*^9, 3.481813934109375*^9}, {
   3.481814200515625*^9, 3.481814316265625*^9}, {3.481814361578125*^9, 
   3.481814398296875*^9}, {3.481814465296875*^9, 3.481814481234375*^9}, {
   3.4818145763125*^9, 3.481814622546875*^9}, {3.481814717203125*^9, 
   3.481814720203125*^9}, {3.481814758671875*^9, 3.4818148053125*^9}, {
   3.481814883015625*^9, 3.481815109484375*^9}, {3.48181513975*^9, 
   3.481815168203125*^9}, {3.4818152449375*^9, 3.481815439078125*^9}, {
   3.48181548884375*^9, 3.48181555653125*^9}, {3.481815595625*^9, 
   3.481815632109375*^9}, {3.481815667359375*^9, 3.481815673546875*^9}, {
   3.4818157098125*^9, 3.481815761875*^9}, {3.48181579925*^9, 
   3.481815808046875*^9}, {3.481816322765625*^9, 3.481816588671875*^9}, {
   3.481816647171875*^9, 3.48181665028125*^9}, {3.4818168593125*^9, 
   3.481816861328125*^9}, {3.482107918984375*^9, 3.48210798253125*^9}, {
   3.482108015046875*^9, 3.4821081316875*^9}, {3.482108173109375*^9, 
   3.48210830775*^9}, {3.4821085515*^9, 3.482108562078125*^9}}],

Cell[BoxData[
 GraphicsBox[{
   {GrayLevel[0.85], Opacity[1], 
    PolygonBox[{{-2.4999999999999996`, -1.5}, {-2.4999999999999996`, 1.5}, {
     4.440892098500626*^-16, 1.5}, {4.440892098500626*^-16, -1.5}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{4.440892098500626*^-16, 0.}, {2.6000000000000005`, 
     0.}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{2.5259111111111117`, 0.03704444444444421}, {2.6, 0.}, {
     2.5259111111111117`, -0.037044444444444435`}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{4.440892098500626*^-16, -1.5}, {4.440892098500626*^-16, 
     1.6}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-0.03704444444444421, 1.5259111111111112`}, {
     4.440892098500626*^-16, 1.6}, {0.03704444444444466, 
     1.5259111111111112`}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-2.5, -1.3183766184073558`}, {-2.3183766184073558`, \
-1.5}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-2.5, -1.106244584051392}, {-2.106244584051392, -1.5}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-2.447056274847714, -0.9470562748477139}, \
{-1.8941125496954276`, -1.5}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-2.340990257669732, -0.840990257669732}, \
{-1.6819805153394638`, -1.5}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-2.2349242404917495`, -0.7349242404917499}, \
{-1.4698484809834995`, -1.5}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-2.1288582233137676`, -0.6288582233137677}, \
{-1.2577164466275352`, -1.5}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-2.0227922061357853`, -0.5227922061357854}, \
{-1.0455844122715705`, -1.5}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-1.9167261889578033`, -0.41672618895780345`}, \
{-0.8334523779156067, -1.5}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-1.810660171779821, -0.3106601717798213}, \
{-0.6213203435596424, -1.5}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-1.7045941546018388`, -0.20459415460183905`}, \
{-0.4091883092036779, -1.5}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-1.5985281374238567`, -0.09852813742385702}, \
{-0.19705627484771382`, -1.5}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-1.4924621202458748`, 0.00753787975412501}, {
      0, -1.4849242404917498`}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-1.3863961030678924`, 0.11360389693210726`}, {
      0, -1.2727922061357853`}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-1.2803300858899105`, 0.2196699141100893}, {
      0, -1.0606601717798212`}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-1.1742640687119283`, 0.32573593128807143`}, {
      0, -0.8485281374238569}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-1.0681980515339462`, 0.4318019484660536}, {
      0, -0.6363961030678926}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-0.9621320343559641, 0.5378679656440357}, {
      0, -0.42426406871192834`}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-0.856066017177982, 0.6439339828220177}, {
      0, -0.21213203435596428`}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-0.7499999999999999, 0.7499999999999999}, {0, 0.}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-0.6439339828220177, 0.856066017177982}, {
      0, 0.21213203435596428`}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-0.5378679656440357, 0.9621320343559641}, {
      0, 0.42426406871192834`}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-0.4318019484660536, 1.0681980515339462`}, {
      0, 0.6363961030678925}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-0.32573593128807143`, 1.1742640687119283`}, {
      0, 0.8485281374238569}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-0.2196699141100893, 1.2803300858899105`}, {
      0, 1.0606601717798212`}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-0.11360389693210726`, 1.3863961030678924`}, {
      0, 1.2727922061357853`}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-0.00753787975412501, 1.4924621202458748`}, {
      0, 1.4849242404917498`}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-2.5, 1.3183766184073558`}, {-2.3183766184073558`, 
     1.5}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-2.5, 1.106244584051392}, {-2.106244584051392, 1.5}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-2.447056274847714, 
     0.9470562748477139}, {-1.8941125496954276`, 1.5}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-2.340990257669732, 
     0.840990257669732}, {-1.6819805153394638`, 1.5}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], 
    LineBox[{{-2.2349242404917495`, 
     0.7349242404917499}, {-1.4698484809834995`, 1.5}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-2.1288582233137676`, 
     0.6288582233137677}, {-1.2577164466275352`, 1.5}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-2.0227922061357853`, 
     0.5227922061357854}, {-1.0455844122715705`, 1.5}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-1.9167261889578033`, 
     0.41672618895780345`}, {-0.8334523779156067, 1.5}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-1.810660171779821, 
     0.3106601717798213}, {-0.6213203435596424, 1.5}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-1.7045941546018388`, 
     0.20459415460183905`}, {-0.4091883092036779, 1.5}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-1.5985281374238567`, 
     0.09852813742385702}, {-0.19705627484771382`, 1.5}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-1.4924621202458748`, -0.00753787975412501}, {
      0, 1.4849242404917498`}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-1.3863961030678924`, -0.11360389693210726`}, {
      0, 1.2727922061357853`}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-1.2803300858899105`, -0.2196699141100893}, {
      0, 1.0606601717798212`}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-1.1742640687119283`, -0.32573593128807143`}, {
      0, 0.8485281374238569}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], 
    LineBox[{{-1.0681980515339462`, -0.4318019484660536}, {
      0, 0.6363961030678926}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-0.9621320343559641, -0.5378679656440357}, {
      0, 0.42426406871192834`}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-0.856066017177982, -0.6439339828220177}, {
      0, 0.21213203435596428`}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-0.7499999999999999, -0.7499999999999999}, {0, 0.}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-0.6439339828220177, -0.856066017177982}, {
      0, -0.21213203435596428`}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-0.5378679656440357, -0.9621320343559641}, {
      0, -0.42426406871192834`}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-0.4318019484660536, -1.0681980515339462`}, {
      0, -0.6363961030678925}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-0.32573593128807143`, -1.1742640687119283`}, {
      0, -0.8485281374238569}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-0.2196699141100893, -1.2803300858899105`}, {
      0, -1.0606601717798212`}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-0.11360389693210726`, -1.3863961030678924`}, {
      0, -1.2727922061357853`}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-0.00753787975412501, -1.4924621202458748`}, {
      0, -1.4849242404917498`}}]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-1.4142135623730947`, -1.4142135623730954`}, \
{-0.7499999999999996, -0.7499999999999998}}]}, 
   {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-0.8285831336158647, -0.7761943778719549}, \
{-0.7499999999999996, -0.7499999999999998}, {-0.7761943778719544, \
-0.8285831336158649}}]}, 
   {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-0.7499999999999996, 0.75}, {-1.4142135623730947`, 
     1.414213562373095}}]}, 
   {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-1.3880191845011398`, 
     1.3356304287572298`}, {-1.4142135623730947`, 
     1.414213562373095}, {-1.3356304287572296`, 1.38801918450114}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 10], 0.1]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None]}, 
   {GrayLevel[
     NCache[
      Rational[1, 5], 0.2]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None]}, 
   {GrayLevel[
     NCache[
      Rational[3, 10], 0.3]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None]}, 
   {GrayLevel[
     NCache[
      Rational[2, 5], 0.4]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None]}, 
   {GrayLevel[
     NCache[
      Rational[1, 2], 0.5]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None]}, 
   {GrayLevel[
     NCache[
      Rational[3, 5], 0.6]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None]}, 
   {GrayLevel[
     NCache[
      Rational[7, 10], 0.7]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None]}, 
   {GrayLevel[
     NCache[
      Rational[4, 5], 0.8]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None]}, 
   {GrayLevel[
     NCache[
      Rational[9, 10], 0.9]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None]}, 
   {GrayLevel[1], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[
     NCache[
      Rational[1, 10], 0.1]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0., -1.4849242404917498`}, {0.1, -1.4849242404917498`}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 5], 0.2]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.1, -1.4849242404917498`}, {0.2, -1.4849242404917498`}}]}, 
   {GrayLevel[
     NCache[
      Rational[3, 10], 0.3]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.2, -1.4849242404917498`}, {
     0.30000000000000004`, -1.4849242404917498`}}]}, 
   {GrayLevel[
     NCache[
      Rational[2, 5], 0.4]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.30000000000000004`, -1.4849242404917498`}, {
     0.4, -1.4849242404917498`}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 2], 0.5]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.4, -1.4849242404917498`}, {0.5, -1.4849242404917498`}}]}, 
   {GrayLevel[
     NCache[
      Rational[3, 5], 0.6]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.5, -1.4849242404917498`}, {
     0.6000000000000001, -1.4849242404917498`}}]}, 
   {GrayLevel[
     NCache[
      Rational[7, 10], 0.7]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.6000000000000001, -1.4849242404917498`}, {
     0.7000000000000001, -1.4849242404917498`}}]}, 
   {GrayLevel[
     NCache[
      Rational[4, 5], 0.8]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.7000000000000001, -1.4849242404917498`}, {
     0.8, -1.4849242404917498`}}]}, 
   {GrayLevel[
     NCache[
      Rational[9, 10], 0.9]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.8, -1.4849242404917498`}, {0.9, -1.4849242404917498`}}]}, 
   {GrayLevel[1], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0.9, -1.4849242404917498`}, {
     1., -1.4849242404917498`}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 10], 0.1]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0., -1.2727922061357855`}, {0.1, -1.2727922061357855`}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 5], 0.2]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.1, -1.2727922061357855`}, {0.2, -1.2727922061357855`}}]}, 
   {GrayLevel[
     NCache[
      Rational[3, 10], 0.3]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.2, -1.2727922061357855`}, {
     0.30000000000000004`, -1.2727922061357855`}}]}, 
   {GrayLevel[
     NCache[
      Rational[2, 5], 0.4]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.30000000000000004`, -1.2727922061357855`}, {
     0.4, -1.2727922061357855`}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 2], 0.5]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.4, -1.2727922061357855`}, {0.5, -1.2727922061357855`}}]}, 
   {GrayLevel[
     NCache[
      Rational[3, 5], 0.6]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.5, -1.2727922061357855`}, {
     0.6000000000000001, -1.2727922061357855`}}]}, 
   {GrayLevel[
     NCache[
      Rational[7, 10], 0.7]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.6000000000000001, -1.2727922061357855`}, {
     0.7000000000000001, -1.2727922061357855`}}]}, 
   {GrayLevel[
     NCache[
      Rational[4, 5], 0.8]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.7000000000000001, -1.2727922061357855`}, {
     0.8, -1.2727922061357855`}}]}, 
   {GrayLevel[
     NCache[
      Rational[9, 10], 0.9]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.8, -1.2727922061357855`}, {0.9, -1.2727922061357855`}}]}, 
   {GrayLevel[1], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0.9, -1.2727922061357855`}, {
     1., -1.2727922061357855`}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 10], 0.1]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0., -1.0606601717798212`}, {0.1, -1.0606601717798212`}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 5], 0.2]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.1, -1.0606601717798212`}, {0.2, -1.0606601717798212`}}]}, 
   {GrayLevel[
     NCache[
      Rational[3, 10], 0.3]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.2, -1.0606601717798212`}, {
     0.30000000000000004`, -1.0606601717798212`}}]}, 
   {GrayLevel[
     NCache[
      Rational[2, 5], 0.4]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.30000000000000004`, -1.0606601717798212`}, {
     0.4, -1.0606601717798212`}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 2], 0.5]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.4, -1.0606601717798212`}, {0.5, -1.0606601717798212`}}]}, 
   {GrayLevel[
     NCache[
      Rational[3, 5], 0.6]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.5, -1.0606601717798212`}, {
     0.6000000000000001, -1.0606601717798212`}}]}, 
   {GrayLevel[
     NCache[
      Rational[7, 10], 0.7]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.6000000000000001, -1.0606601717798212`}, {
     0.7000000000000001, -1.0606601717798212`}}]}, 
   {GrayLevel[
     NCache[
      Rational[4, 5], 0.8]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.7000000000000001, -1.0606601717798212`}, {
     0.8, -1.0606601717798212`}}]}, 
   {GrayLevel[
     NCache[
      Rational[9, 10], 0.9]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.8, -1.0606601717798212`}, {0.9, -1.0606601717798212`}}]}, 
   {GrayLevel[1], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0.9, -1.0606601717798212`}, {
     1., -1.0606601717798212`}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 10], 0.1]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0., -0.848528137423857}, {0.1, -0.848528137423857}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 5], 0.2]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.1, -0.848528137423857}, {0.2, -0.848528137423857}}]}, 
   {GrayLevel[
     NCache[
      Rational[3, 10], 0.3]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.2, -0.848528137423857}, {
     0.30000000000000004`, -0.848528137423857}}]}, 
   {GrayLevel[
     NCache[
      Rational[2, 5], 0.4]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.30000000000000004`, -0.848528137423857}, {
     0.4, -0.848528137423857}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 2], 0.5]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.4, -0.848528137423857}, {0.5, -0.848528137423857}}]}, 
   {GrayLevel[
     NCache[
      Rational[3, 5], 0.6]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.5, -0.848528137423857}, {
     0.6000000000000001, -0.848528137423857}}]}, 
   {GrayLevel[
     NCache[
      Rational[7, 10], 0.7]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.6000000000000001, -0.848528137423857}, {
     0.7000000000000001, -0.848528137423857}}]}, 
   {GrayLevel[
     NCache[
      Rational[4, 5], 0.8]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.7000000000000001, -0.848528137423857}, {
     0.8, -0.848528137423857}}]}, 
   {GrayLevel[
     NCache[
      Rational[9, 10], 0.9]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.8, -0.848528137423857}, {0.9, -0.848528137423857}}]}, 
   {GrayLevel[1], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0.9, -0.848528137423857}, {1., -0.848528137423857}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 10], 0.1]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0., -0.6363961030678927}, {0.1, -0.6363961030678927}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 5], 0.2]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.1, -0.6363961030678927}, {0.2, -0.6363961030678927}}]}, 
   {GrayLevel[
     NCache[
      Rational[3, 10], 0.3]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.2, -0.6363961030678927}, {
     0.30000000000000004`, -0.6363961030678927}}]}, 
   {GrayLevel[
     NCache[
      Rational[2, 5], 0.4]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.30000000000000004`, -0.6363961030678927}, {
     0.4, -0.6363961030678927}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 2], 0.5]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.4, -0.6363961030678927}, {0.5, -0.6363961030678927}}]}, 
   {GrayLevel[
     NCache[
      Rational[3, 5], 0.6]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.5, -0.6363961030678927}, {
     0.6000000000000001, -0.6363961030678927}}]}, 
   {GrayLevel[
     NCache[
      Rational[7, 10], 0.7]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.6000000000000001, -0.6363961030678927}, {
     0.7000000000000001, -0.6363961030678927}}]}, 
   {GrayLevel[
     NCache[
      Rational[4, 5], 0.8]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.7000000000000001, -0.6363961030678927}, {
     0.8, -0.6363961030678927}}]}, 
   {GrayLevel[
     NCache[
      Rational[9, 10], 0.9]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.8, -0.6363961030678927}, {0.9, -0.6363961030678927}}]}, 
   {GrayLevel[1], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0.9, -0.6363961030678927}, {1., -0.6363961030678927}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 10], 0.1]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0., -0.4242640687119285}, {0.1, -0.4242640687119285}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 5], 0.2]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.1, -0.4242640687119285}, {0.2, -0.4242640687119285}}]}, 
   {GrayLevel[
     NCache[
      Rational[3, 10], 0.3]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.2, -0.4242640687119285}, {
     0.30000000000000004`, -0.4242640687119285}}]}, 
   {GrayLevel[
     NCache[
      Rational[2, 5], 0.4]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.30000000000000004`, -0.4242640687119285}, {
     0.4, -0.4242640687119285}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 2], 0.5]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.4, -0.4242640687119285}, {0.5, -0.4242640687119285}}]}, 
   {GrayLevel[
     NCache[
      Rational[3, 5], 0.6]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.5, -0.4242640687119285}, {
     0.6000000000000001, -0.4242640687119285}}]}, 
   {GrayLevel[
     NCache[
      Rational[7, 10], 0.7]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.6000000000000001, -0.4242640687119285}, {
     0.7000000000000001, -0.4242640687119285}}]}, 
   {GrayLevel[
     NCache[
      Rational[4, 5], 0.8]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.7000000000000001, -0.4242640687119285}, {
     0.8, -0.4242640687119285}}]}, 
   {GrayLevel[
     NCache[
      Rational[9, 10], 0.9]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.8, -0.4242640687119285}, {0.9, -0.4242640687119285}}]}, 
   {GrayLevel[1], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0.9, -0.4242640687119285}, {1., -0.4242640687119285}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 10], 0.1]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0., -0.21213203435596426`}, {0.1, -0.21213203435596426`}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 5], 0.2]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.1, -0.21213203435596426`}, {0.2, -0.21213203435596426`}}]}, 
   {GrayLevel[
     NCache[
      Rational[3, 10], 0.3]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.2, -0.21213203435596426`}, {
     0.30000000000000004`, -0.21213203435596426`}}]}, 
   {GrayLevel[
     NCache[
      Rational[2, 5], 0.4]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.30000000000000004`, -0.21213203435596426`}, {
     0.4, -0.21213203435596426`}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 2], 0.5]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.4, -0.21213203435596426`}, {0.5, -0.21213203435596426`}}]}, 
   {GrayLevel[
     NCache[
      Rational[3, 5], 0.6]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.5, -0.21213203435596426`}, {
     0.6000000000000001, -0.21213203435596426`}}]}, 
   {GrayLevel[
     NCache[
      Rational[7, 10], 0.7]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.6000000000000001, -0.21213203435596426`}, {
     0.7000000000000001, -0.21213203435596426`}}]}, 
   {GrayLevel[
     NCache[
      Rational[4, 5], 0.8]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.7000000000000001, -0.21213203435596426`}, {
     0.8, -0.21213203435596426`}}]}, 
   {GrayLevel[
     NCache[
      Rational[9, 10], 0.9]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.8, -0.21213203435596426`}, {0.9, -0.21213203435596426`}}]}, 
   {GrayLevel[1], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0.9, -0.21213203435596426`}, {
     1., -0.21213203435596426`}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 10], 0.1]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0., 0.21213203435596426`}, {0.1, 0.21213203435596426`}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 5], 0.2]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.1, 0.21213203435596426`}, {0.2, 0.21213203435596426`}}]}, 
   {GrayLevel[
     NCache[
      Rational[3, 10], 0.3]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.2, 0.21213203435596426`}, {0.30000000000000004`, 
     0.21213203435596426`}}]}, 
   {GrayLevel[
     NCache[
      Rational[2, 5], 0.4]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.30000000000000004`, 0.21213203435596426`}, {0.4, 
     0.21213203435596426`}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 2], 0.5]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.4, 0.21213203435596426`}, {0.5, 0.21213203435596426`}}]}, 
   {GrayLevel[
     NCache[
      Rational[3, 5], 0.6]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.5, 0.21213203435596426`}, {0.6000000000000001, 
     0.21213203435596426`}}]}, 
   {GrayLevel[
     NCache[
      Rational[7, 10], 0.7]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.6000000000000001, 0.21213203435596426`}, {0.7000000000000001, 
     0.21213203435596426`}}]}, 
   {GrayLevel[
     NCache[
      Rational[4, 5], 0.8]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.7000000000000001, 0.21213203435596426`}, {0.8, 
     0.21213203435596426`}}]}, 
   {GrayLevel[
     NCache[
      Rational[9, 10], 0.9]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.8, 0.21213203435596426`}, {0.9, 0.21213203435596426`}}]}, 
   {GrayLevel[1], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0.9, 0.21213203435596426`}, {1., 
     0.21213203435596426`}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 10], 0.1]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0., 0.4242640687119285}, {0.1, 0.4242640687119285}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 5], 0.2]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.1, 0.4242640687119285}, {0.2, 0.4242640687119285}}]}, 
   {GrayLevel[
     NCache[
      Rational[3, 10], 0.3]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.2, 0.4242640687119285}, {0.30000000000000004`, 
     0.4242640687119285}}]}, 
   {GrayLevel[
     NCache[
      Rational[2, 5], 0.4]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.30000000000000004`, 0.4242640687119285}, {0.4, 
     0.4242640687119285}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 2], 0.5]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.4, 0.4242640687119285}, {0.5, 0.4242640687119285}}]}, 
   {GrayLevel[
     NCache[
      Rational[3, 5], 0.6]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.5, 0.4242640687119285}, {0.6000000000000001, 
     0.4242640687119285}}]}, 
   {GrayLevel[
     NCache[
      Rational[7, 10], 0.7]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.6000000000000001, 0.4242640687119285}, {0.7000000000000001, 
     0.4242640687119285}}]}, 
   {GrayLevel[
     NCache[
      Rational[4, 5], 0.8]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.7000000000000001, 0.4242640687119285}, {0.8, 
     0.4242640687119285}}]}, 
   {GrayLevel[
     NCache[
      Rational[9, 10], 0.9]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.8, 0.4242640687119285}, {0.9, 0.4242640687119285}}]}, 
   {GrayLevel[1], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0.9, 0.4242640687119285}, {1., 0.4242640687119285}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 10], 0.1]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0., 0.6363961030678927}, {0.1, 0.6363961030678927}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 5], 0.2]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.1, 0.6363961030678927}, {0.2, 0.6363961030678927}}]}, 
   {GrayLevel[
     NCache[
      Rational[3, 10], 0.3]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.2, 0.6363961030678927}, {0.30000000000000004`, 
     0.6363961030678927}}]}, 
   {GrayLevel[
     NCache[
      Rational[2, 5], 0.4]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.30000000000000004`, 0.6363961030678927}, {0.4, 
     0.6363961030678927}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 2], 0.5]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.4, 0.6363961030678927}, {0.5, 0.6363961030678927}}]}, 
   {GrayLevel[
     NCache[
      Rational[3, 5], 0.6]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.5, 0.6363961030678927}, {0.6000000000000001, 
     0.6363961030678927}}]}, 
   {GrayLevel[
     NCache[
      Rational[7, 10], 0.7]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.6000000000000001, 0.6363961030678927}, {0.7000000000000001, 
     0.6363961030678927}}]}, 
   {GrayLevel[
     NCache[
      Rational[4, 5], 0.8]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.7000000000000001, 0.6363961030678927}, {0.8, 
     0.6363961030678927}}]}, 
   {GrayLevel[
     NCache[
      Rational[9, 10], 0.9]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.8, 0.6363961030678927}, {0.9, 0.6363961030678927}}]}, 
   {GrayLevel[1], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0.9, 0.6363961030678927}, {1., 0.6363961030678927}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 10], 0.1]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0., 0.848528137423857}, {0.1, 0.848528137423857}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 5], 0.2]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.1, 0.848528137423857}, {0.2, 0.848528137423857}}]}, 
   {GrayLevel[
     NCache[
      Rational[3, 10], 0.3]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.2, 0.848528137423857}, {0.30000000000000004`, 
     0.848528137423857}}]}, 
   {GrayLevel[
     NCache[
      Rational[2, 5], 0.4]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.30000000000000004`, 0.848528137423857}, {0.4, 
     0.848528137423857}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 2], 0.5]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.4, 0.848528137423857}, {0.5, 0.848528137423857}}]}, 
   {GrayLevel[
     NCache[
      Rational[3, 5], 0.6]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.5, 0.848528137423857}, {0.6000000000000001, 
     0.848528137423857}}]}, 
   {GrayLevel[
     NCache[
      Rational[7, 10], 0.7]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.6000000000000001, 0.848528137423857}, {0.7000000000000001, 
     0.848528137423857}}]}, 
   {GrayLevel[
     NCache[
      Rational[4, 5], 0.8]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.7000000000000001, 0.848528137423857}, {0.8, 
     0.848528137423857}}]}, 
   {GrayLevel[
     NCache[
      Rational[9, 10], 0.9]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.8, 0.848528137423857}, {0.9, 0.848528137423857}}]}, 
   {GrayLevel[1], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0.9, 0.848528137423857}, {1., 0.848528137423857}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 10], 0.1]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0., 1.0606601717798212`}, {0.1, 1.0606601717798212`}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 5], 0.2]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.1, 1.0606601717798212`}, {0.2, 1.0606601717798212`}}]}, 
   {GrayLevel[
     NCache[
      Rational[3, 10], 0.3]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.2, 1.0606601717798212`}, {0.30000000000000004`, 
     1.0606601717798212`}}]}, 
   {GrayLevel[
     NCache[
      Rational[2, 5], 0.4]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.30000000000000004`, 1.0606601717798212`}, {0.4, 
     1.0606601717798212`}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 2], 0.5]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.4, 1.0606601717798212`}, {0.5, 1.0606601717798212`}}]}, 
   {GrayLevel[
     NCache[
      Rational[3, 5], 0.6]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.5, 1.0606601717798212`}, {0.6000000000000001, 
     1.0606601717798212`}}]}, 
   {GrayLevel[
     NCache[
      Rational[7, 10], 0.7]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.6000000000000001, 1.0606601717798212`}, {0.7000000000000001, 
     1.0606601717798212`}}]}, 
   {GrayLevel[
     NCache[
      Rational[4, 5], 0.8]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.7000000000000001, 1.0606601717798212`}, {0.8, 
     1.0606601717798212`}}]}, 
   {GrayLevel[
     NCache[
      Rational[9, 10], 0.9]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.8, 1.0606601717798212`}, {0.9, 1.0606601717798212`}}]}, 
   {GrayLevel[1], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0.9, 1.0606601717798212`}, {1., 1.0606601717798212`}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 10], 0.1]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0., 1.2727922061357855`}, {0.1, 1.2727922061357855`}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 5], 0.2]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.1, 1.2727922061357855`}, {0.2, 1.2727922061357855`}}]}, 
   {GrayLevel[
     NCache[
      Rational[3, 10], 0.3]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.2, 1.2727922061357855`}, {0.30000000000000004`, 
     1.2727922061357855`}}]}, 
   {GrayLevel[
     NCache[
      Rational[2, 5], 0.4]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.30000000000000004`, 1.2727922061357855`}, {0.4, 
     1.2727922061357855`}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 2], 0.5]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.4, 1.2727922061357855`}, {0.5, 1.2727922061357855`}}]}, 
   {GrayLevel[
     NCache[
      Rational[3, 5], 0.6]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.5, 1.2727922061357855`}, {0.6000000000000001, 
     1.2727922061357855`}}]}, 
   {GrayLevel[
     NCache[
      Rational[7, 10], 0.7]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.6000000000000001, 1.2727922061357855`}, {0.7000000000000001, 
     1.2727922061357855`}}]}, 
   {GrayLevel[
     NCache[
      Rational[4, 5], 0.8]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.7000000000000001, 1.2727922061357855`}, {0.8, 
     1.2727922061357855`}}]}, 
   {GrayLevel[
     NCache[
      Rational[9, 10], 0.9]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.8, 1.2727922061357855`}, {0.9, 1.2727922061357855`}}]}, 
   {GrayLevel[1], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0.9, 1.2727922061357855`}, {1., 1.2727922061357855`}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 10], 0.1]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0., 1.4849242404917498`}, {0.1, 1.4849242404917498`}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 5], 0.2]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.1, 1.4849242404917498`}, {0.2, 1.4849242404917498`}}]}, 
   {GrayLevel[
     NCache[
      Rational[3, 10], 0.3]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.2, 1.4849242404917498`}, {0.30000000000000004`, 
     1.4849242404917498`}}]}, 
   {GrayLevel[
     NCache[
      Rational[2, 5], 0.4]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.30000000000000004`, 1.4849242404917498`}, {0.4, 
     1.4849242404917498`}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 2], 0.5]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.4, 1.4849242404917498`}, {0.5, 1.4849242404917498`}}]}, 
   {GrayLevel[
     NCache[
      Rational[3, 5], 0.6]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.5, 1.4849242404917498`}, {0.6000000000000001, 
     1.4849242404917498`}}]}, 
   {GrayLevel[
     NCache[
      Rational[7, 10], 0.7]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.6000000000000001, 1.4849242404917498`}, {0.7000000000000001, 
     1.4849242404917498`}}]}, 
   {GrayLevel[
     NCache[
      Rational[4, 5], 0.8]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None], 
    LineBox[{{0.7000000000000001, 1.4849242404917498`}, {0.8, 
     1.4849242404917498`}}]}, 
   {GrayLevel[
     NCache[
      Rational[9, 10], 0.9]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None], 
    LineBox[{{0.8, 1.4849242404917498`}, {0.9, 1.4849242404917498`}}]}, 
   {GrayLevel[1], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0.9, 1.4849242404917498`}, {1., 1.4849242404917498`}}]}, 
   {GrayLevel[
     NCache[
      Rational[1, 10], 0.1]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None]}, 
   {GrayLevel[
     NCache[
      Rational[1, 5], 0.2]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None]}, 
   {GrayLevel[
     NCache[
      Rational[3, 10], 0.3]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None]}, 
   {GrayLevel[
     NCache[
      Rational[2, 5], 0.4]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None]}, 
   {GrayLevel[
     NCache[
      Rational[1, 2], 0.5]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None]}, 
   {GrayLevel[
     NCache[
      Rational[3, 5], 0.6]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None]}, 
   {GrayLevel[
     NCache[
      Rational[7, 10], 0.7]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None]}, 
   {GrayLevel[
     NCache[
      Rational[4, 5], 0.8]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], 
    CapForm[None]}, 
   {GrayLevel[
     NCache[
      Rational[9, 10], 0.9]], AbsoluteThickness[0.5], Opacity[1], Dashing[{}],
     CapForm[None]}, 
   {GrayLevel[1], AbsoluteThickness[0.5], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{1.15, -0.95}, {
     0.7500000000000004, -0.7500000000000002}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0.7997003375798961, -0.8162671167731939}, {
     0.7500000000000004, -0.7500000000000002}, {
     0.8328338959664925, -0.7500000000000002}}], InsetBox[
     FrameBox[
      StyleBox[
       TagBox[
        StyleBox[
         TagBox[
          TagBox[
           StyleBox["\<\"k\"\>",
            FontWeight->"Bold"],
           StyleForm[#, FontWeight -> "Bold"]& ],
          DisplayForm],
         StripOnInput->False,
         ShowAutoStyles->False,
         SingleLetterItalics->False,
         FontFamily->"Times",
         FontSize->12,
         FontWeight->"Plain",
         FontSlant->"Plain",
         FontTracking->"Plain",
         FontColor->GrayLevel[0],
         FontOpacity->1],
        DisplayForm],
       StripOnInput->False,
       ShowContents->False],
      Background->GrayLevel[0.85],
      ContentPadding->False,
      FrameMargins->None,
      FrameStyle->None,
      StripOnInput->False], {-0.9668515185499453, -1.1973620438231494`}, {0, 0},
      Automatic, {0.7071067811865474, 0.7071067811865477}], InsetBox[
     FrameBox[
      StyleBox[
       TagBox[
        StyleBox[
         TagBox[
          TemplateBox[{TagBox[
             StyleBox["\"k\"", FontWeight -> "Bold"], 
             StyleForm[#, FontWeight -> "Bold"]& ],"\"\[Prime]\[Prime]\""},
           "Superscript"],
          DisplayForm],
         StripOnInput->False,
         ShowAutoStyles->False,
         SingleLetterItalics->False,
         FontFamily->"Times",
         FontSize->12,
         FontWeight->"Plain",
         FontSlant->"Plain",
         FontTracking->"Plain",
         FontColor->GrayLevel[0],
         FontOpacity->1],
        DisplayForm],
       StripOnInput->False,
       ShowContents->False],
      Background->GrayLevel[0.85],
      ContentPadding->False,
      FrameMargins->None,
      FrameStyle->None,
      StripOnInput->False], {-0.9668515185499453, 1.1973620438231496`}, {0, 0},
      Automatic, {0.7071067811865475, -0.7071067811865476}], InsetBox[
     TagBox[
      StyleBox[
       TagBox[
        TagBox[
         StyleBox["\<\"z\"\>",
          FontSlant->"Italic"],
         StyleForm[#, FontSlant -> "Italic"]& ],
        DisplayForm],
       StripOnInput->False,
       ShowAutoStyles->False,
       SingleLetterItalics->False,
       FontFamily->"Times",
       FontSize->12,
       FontWeight->"Plain",
       FontSlant->"Plain",
       FontTracking->"Plain",
       FontColor->GrayLevel[0],
       FontOpacity->1],
      DisplayForm], {2.6, -0.13150777777777778`}, {0, 0}, Automatic, {1, 0}], 
    InsetBox[
     TagBox[
      StyleBox[
       TagBox[
        TagBox[
         StyleBox["\<\"x\"\>",
          FontSlant->"Italic"],
         StyleForm[#, FontSlant -> "Italic"]& ],
        DisplayForm],
       StripOnInput->False,
       ShowAutoStyles->False,
       SingleLetterItalics->False,
       FontFamily->"Times",
       FontSize->12,
       FontWeight->"Plain",
       FontSlant->"Plain",
       FontTracking->"Plain",
       FontColor->GrayLevel[0],
       FontOpacity->1],
      DisplayForm], {-0.13150777777777733`, 1.6}, {0, 0}, Automatic, {1, 0}], 
    InsetBox[
     TagBox[
      StyleBox[
       TagBox[
        TagBox[
         StyleBox["\<\"k\"\>",
          FontWeight->"Bold"],
         StyleForm[#, FontWeight -> "Bold"]& ],
        DisplayForm],
       StripOnInput->False,
       ShowAutoStyles->False,
       SingleLetterItalics->False,
       FontFamily->"Times",
       FontSize->12,
       FontWeight->"Plain",
       FontSlant->"Plain",
       FontTracking->"Plain",
       FontColor->GrayLevel[0],
       FontOpacity->1],
      DisplayForm], {-0.9668515185499453, -1.1973620438231494`}, {0, 0}, 
     Automatic, {0.7071067811865474, 0.7071067811865477}], InsetBox[
     TagBox[
      StyleBox[
       TagBox[
        TemplateBox[{TagBox[
           StyleBox["\"k\"", FontWeight -> "Bold"], 
           StyleForm[#, FontWeight -> "Bold"]& ],"\"\[Prime]\[Prime]\""},
         "Superscript"],
        DisplayForm],
       StripOnInput->False,
       ShowAutoStyles->False,
       SingleLetterItalics->False,
       FontFamily->"Times",
       FontSize->12,
       FontWeight->"Plain",
       FontSlant->"Plain",
       FontTracking->"Plain",
       FontColor->GrayLevel[0],
       FontOpacity->1],
      DisplayForm], {-0.9668515185499453, 1.1973620438231496`}, {0, 0}, 
     Automatic, {0.7071067811865475, -0.7071067811865476}], InsetBox[
     TagBox[
      StyleBox[
       TagBox[
        TemplateBox[{OverscriptBox[
           TagBox[
            StyleBox["\"k\"", FontWeight -> "Bold"], 
            StyleForm[#, FontWeight -> "Bold"]& ], "~"],"\"\[Prime]\""},
         "Superscript"],
        DisplayForm],
       StripOnInput->False,
       ShowAutoStyles->False,
       SingleLetterItalics->False,
       FontFamily->"Times",
       FontSize->12,
       FontWeight->"Plain",
       FontSlant->"Plain",
       FontTracking->"Plain",
       FontColor->GrayLevel[0],
       FontOpacity->1],
      DisplayForm], {1.0000000000000004`, 0.75}, {0, 0}, Automatic, {1, 0}], 
    InsetBox[
     TagBox[
      StyleBox[
       TagBox[
        SubscriptBox[
         TagBox[
          StyleBox["\<\"n\"\>",
           FontSlant->"Italic"],
          StyleForm[#, FontSlant -> "Italic"]& ], "\<\"1\"\>"],
        DisplayForm],
       StripOnInput->False,
       ShowAutoStyles->False,
       SingleLetterItalics->False,
       FontFamily->"Times",
       FontSize->12,
       FontWeight->"Plain",
       FontSlant->"Plain",
       FontTracking->"Plain",
       FontColor->GrayLevel[0],
       FontOpacity->1],
      DisplayForm], {-2.1249999999999996`, -0.30000000000000004`}, {0, 0}, 
     Automatic, {1, 0}], InsetBox[
     TagBox[
      StyleBox[
       TagBox[
        SubscriptBox[
         TagBox[
          StyleBox["\<\"n\"\>",
           FontSlant->"Italic"],
          StyleForm[#, FontSlant -> "Italic"]& ], "\<\"2\"\>"],
        DisplayForm],
       StripOnInput->False,
       ShowAutoStyles->False,
       SingleLetterItalics->False,
       FontFamily->"Times",
       FontSize->12,
       FontWeight->"Plain",
       FontSlant->"Plain",
       FontTracking->"Plain",
       FontColor->GrayLevel[0],
       FontOpacity->1],
      DisplayForm], {2.1250000000000004`, -0.30000000000000004`}, {0, 0}, 
     Automatic, {1, 0}], InsetBox[
     TagBox[
      StyleBox[
       TagBox[GridBox[{
          {"Evanescent"},
          {"wave"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        DisplayForm],
       StripOnInput->False,
       ShowAutoStyles->False,
       SingleLetterItalics->False,
       FontFamily->"Times",
       FontSize->12,
       FontWeight->"Plain",
       FontSlant->"Plain",
       FontTracking->"Plain",
       FontColor->GrayLevel[0],
       FontOpacity->1],
      DisplayForm], {1.15, -0.95}, {-1.1, 1}, Automatic, {1, 0}]}},
  AspectRatio->0.6666666666666666,
  Axes->False,
  Background->None,
  BaseStyle->{
   FontFamily -> "Times", FontSize -> 12, FontSlant -> "Plain", FontTracking -> 
    "Plain", FontWeight -> "Plain", FontColor -> GrayLevel[0], FontOpacity -> 
    1, ShowAutoStyles -> False, SingleLetterItalics -> False},
  DisplayFunction->Identity,
  Frame->False,
  FrameLabel->{None, None, None, None},
  FrameStyle->Directive[{
     GrayLevel[0], 
     Opacity[1], 
     CapForm[None], 
     AbsoluteThickness[1], 
     AbsoluteDashing[{}]}],
  FrameTicks->None,
  ImageSize->{324., 216.},
  PlotRange->{{-3.0006, 3.0006}, {-2.0004, 2.0004}},
  Ticks->None]], "Output",
 CellChangeTimes->{{3.48210822121875*^9, 3.482108312296875*^9}, 
   3.525527886921875*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Rotating inhomogeneous sphere", "Section",
 CellChangeTimes->{{3.465676987359375*^9, 3.465676993328125*^9}, {
  3.469958116140625*^9, 3.469958117625*^9}, {3.4730184600625*^9, 
  3.473018469265625*^9}, {3.501273684375*^9, 3.501273707859375*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Figure", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"SetOptions", "[", 
      RowBox[{"SchemeArrow", ",", 
       RowBox[{"Thickness", "\[Rule]", "1"}], ",", 
       RowBox[{"PosnC", "\[Rule]", "1"}]}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"SetOptions", "[", 
      RowBox[{"SchemeCircle", ",", 
       RowBox[{"FillColor", "\[Rule]", "Gray"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"SetOptions", "[", 
      RowBox[{"SchemeEllipse", ",", 
       RowBox[{"ShowFill", "\[Rule]", "False"}]}], "]"}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"set", " ", "various", " ", "radius", " ", "parameters"}], " ", 
      "*)"}], "\[IndentingNewLine]", 
     RowBox[{"ra", "=", "0.5"}], ",", "\[IndentingNewLine]", 
     RowBox[{"hb", "=", "0.2"}], ",", "\[IndentingNewLine]", 
     RowBox[{"rb", "=", "0.7"}], ",", "\[IndentingNewLine]", 
     RowBox[{"rc", "=", "0.9"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"a", "=", "0"}], ",", "\[IndentingNewLine]", 
     RowBox[{"b", "=", "rb"}], ",", "\[IndentingNewLine]", 
     RowBox[{"dr", "=", "0.01"}], ",", "\[IndentingNewLine]", 
     RowBox[{"lmin", "=", "0.05"}], ",", "\[IndentingNewLine]", 
     RowBox[{"lmax", "=", "0.85"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
       RowBox[{"make", " ", "cloud"}], "-", 
       RowBox[{
       "like", " ", "gradient", " ", "fill", " ", "out", " ", "of", " ", 
        "successively", " ", "darker", " ", 
        RowBox[{"(", 
         RowBox[{"as", " ", "we", " ", "move", " ", "inward"}], ")"}], " ", 
        "concentric", " ", "circles"}]}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"Table", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"SchemeCircle", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}], ",", 
         RowBox[{"Horizontal", "[", "r", "]"}], ",", 
         RowBox[{"FillColor", "\[Rule]", 
          RowBox[{"GrayLevel", "[", 
           RowBox[{"lmin", "+", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{"lmax", "-", "lmin"}], ")"}], "/", 
              RowBox[{"(", 
               RowBox[{"b", "-", "a"}], ")"}]}], "*", 
             RowBox[{"(", 
              RowBox[{"r", "-", "a"}], ")"}]}]}], "]"}]}], ",", 
         RowBox[{"ShowLine", "\[Rule]", "False"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"r", ",", "b", ",", 
         RowBox[{"a", "+", "dr"}], ",", 
         RowBox[{"-", "dr"}]}], "}"}]}], "\[IndentingNewLine]", "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"SchemeCircle", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], ",", "rb", ",", 
       RowBox[{"ShowFill", "\[Rule]", "False"}]}], "]"}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", "annotations", " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"SchemeCircle", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], ",", 
       RowBox[{"Horizontal", "[", "rb", "]"}], ",", 
       RowBox[{"ShowFill", "\[Rule]", "False"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"SchemeArrow", "[", 
      RowBox[{
       RowBox[{"Polar", "[", 
        RowBox[{"{", 
         RowBox[{"rc", ",", 
          RowBox[{
           RowBox[{"-", "Pi"}], "/", "2"}]}], "}"}], "]"}], ",", 
       RowBox[{"Polar", "[", 
        RowBox[{"{", 
         RowBox[{"rc", ",", 
          RowBox[{
           RowBox[{"+", "Pi"}], "/", "2"}]}], "}"}], "]"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"SchemeEllipse", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "hb"}], "}"}], ",", 
       RowBox[{"Horizontal", "[", 
        RowBox[{"{", 
         RowBox[{"ra", ",", 
          RowBox[{"0.5", "*", "ra"}]}], "}"}], "]"}], ",", 
       RowBox[{"ShowHead", "\[Rule]", "True"}], ",", 
       RowBox[{"HeadLength", "\[Rule]", "3"}], ",", 
       RowBox[{"HeadLip", "\[Rule]", "4"}], ",", 
       RowBox[{"Thickness", "\[Rule]", "2"}], ",", "\[IndentingNewLine]", 
       RowBox[{"LabX", "\[Rule]", "\"\<\[Omega]\>\""}], ",", 
       RowBox[{"PosnX", "\[Rule]", "Pi"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"SchemeEllipse", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], ",", 
       RowBox[{"Horizontal", "[", 
        RowBox[{"{", 
         RowBox[{"rb", ",", 
          RowBox[{"0.5", "*", "rb"}]}], "}"}], "]"}], ",", "0", ",", 
       RowBox[{"{", 
        RowBox[{"Pi", ",", 
         RowBox[{"2", "*", "Pi"}]}], "}"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"SchemeEllipse", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], ",", 
       RowBox[{"Horizontal", "[", 
        RowBox[{"{", 
         RowBox[{"rb", ",", 
          RowBox[{"0.5", "*", "rb"}]}], "}"}], "]"}], ",", "0", ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "Pi"}], "}"}], ",", 
       RowBox[{"Dashing", "\[Rule]", "3"}]}], "]"}], ","}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}]}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"ExtendRange", "\[Rule]", "0.2"}], ",", "\[IndentingNewLine]", 
   RowBox[{"ImageSize", "\[Rule]", 
    RowBox[{"72", "*", 
     RowBox[{"{", 
      RowBox[{"4", ",", "4"}], "}"}]}]}]}], "\[IndentingNewLine]", 
  "]"}]], "Input",
 CellChangeTimes->{{3.400339538875*^9, 3.400339641125*^9}, 
   3.40033967371875*^9, {3.400339770671875*^9, 3.4003400125625*^9}, {
   3.410558353359375*^9, 3.41055836778125*^9}, {3.410558452890625*^9, 
   3.410558714703125*^9}, {3.41055889328125*^9, 3.41055892746875*^9}, {
   3.4105589676875*^9, 3.410558992125*^9}, {3.41055937271875*^9, 
   3.41055937871875*^9}, {3.410559421546875*^9, 3.41055982309375*^9}, {
   3.441571567677*^9, 3.441571576677*^9}, {3.441571981505125*^9, 
   3.441572019817625*^9}, {3.441572050052*^9, 3.44157215070825*^9}, {
   3.44157230477075*^9, 3.441572324223875*^9}, {3.441572744536375*^9, 
   3.441572892036375*^9}, {3.4415729458645*^9, 3.44157315839575*^9}, {
   3.4730185059375*^9, 3.47301864846875*^9}, {3.47301869*^9, 
   3.473018813484375*^9}, {3.48210857434375*^9, 3.482108575703125*^9}, {
   3.50127357684375*^9, 3.501273660703125*^9}}],

Cell[BoxData[
 GraphicsBox[{
   {GrayLevel[0.85], Opacity[1], 
    DiskBox[{0., 0.}, 0.6999999999999998, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.8385714285714285], Opacity[1], 
    DiskBox[{0., 0.}, 0.69, NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.8271428571428571], Opacity[1], 
    DiskBox[{0., 0.}, 0.6799999999999998, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.8157142857142856], Opacity[1], 
    DiskBox[{0., 0.}, 0.6699999999999999, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.8042857142857142], Opacity[1], 
    DiskBox[{0., 0.}, 0.6599999999999998, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.7928571428571427], Opacity[1], 
    DiskBox[{0., 0.}, 0.6499999999999999, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.7814285714285714], Opacity[1], 
    DiskBox[{0., 0.}, 0.6399999999999999, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.77], Opacity[1], 
    DiskBox[{0., 0.}, 0.63, NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.7585714285714286], Opacity[1], 
    DiskBox[{0., 0.}, 0.62, NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.7471428571428571], Opacity[1], 
    DiskBox[{0., 0.}, 0.61, NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.7357142857142857], Opacity[1], 
    DiskBox[{0., 0.}, 0.6, NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.7242857142857143], Opacity[1], 
    DiskBox[{0., 0.}, 0.59, NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.7128571428571429], Opacity[1], 
    DiskBox[{0., 0.}, 0.58, NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.7014285714285714], Opacity[1], 
    DiskBox[{0., 0.}, 0.57, NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.69], Opacity[1], 
    DiskBox[{0., 0.}, 0.5599999999999999, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.6785714285714285], Opacity[1], 
    DiskBox[{0., 0.}, 0.5499999999999999, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.667142857142857], Opacity[1], 
    DiskBox[{0., 0.}, 0.5399999999999999, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.6557142857142856], Opacity[1], 
    DiskBox[{0., 0.}, 0.5299999999999998, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.6442857142857142], Opacity[1], 
    DiskBox[{0., 0.}, 0.5199999999999998, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.6328571428571428], Opacity[1], 
    DiskBox[{0., 0.}, 0.5099999999999998, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.6214285714285713], Opacity[1], 
    DiskBox[{0., 0.}, 0.4999999999999999, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.61], Opacity[1], 
    DiskBox[{0., 0.}, 0.4899999999999999, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.5985714285714285], Opacity[1], 
    DiskBox[{0., 0.}, 0.47999999999999987`, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.5871428571428571], Opacity[1], 
    DiskBox[{0., 0.}, 0.4699999999999999, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.5757142857142857], Opacity[1], 
    DiskBox[{0., 0.}, 0.4599999999999999, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.5642857142857143], Opacity[1], 
    DiskBox[{0., 0.}, 0.4499999999999999, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.5528571428571428], Opacity[1], 
    DiskBox[{0., 0.}, 0.4399999999999999, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.5414285714285714], Opacity[1], 
    DiskBox[{0., 0.}, 0.4299999999999999, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.5299999999999999], Opacity[1], 
    DiskBox[{0., 0.}, 0.4199999999999999, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.5185714285714286], Opacity[1], 
    DiskBox[{0., 0.}, 0.4099999999999999, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.5071428571428571], Opacity[1], 
    DiskBox[{0., 0.}, 0.3999999999999999, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.4957142857142856], Opacity[1], 
    DiskBox[{0., 0.}, 0.3899999999999999, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.4842857142857142], Opacity[1], 
    DiskBox[{0., 0.}, 0.3799999999999999, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.47285714285714275`], Opacity[1], 
    DiskBox[{0., 0.}, 0.3699999999999999, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.4614285714285713], Opacity[1], 
    DiskBox[{0., 0.}, 0.35999999999999993`, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.4499999999999999], Opacity[1], 
    DiskBox[{0., 0.}, 0.3499999999999999, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.4385714285714285], Opacity[1], 
    DiskBox[{0., 0.}, 0.3399999999999999, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.42714285714285705`], Opacity[1], 
    DiskBox[{0., 0.}, 0.3299999999999999, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.41571428571428565`], Opacity[1], 
    DiskBox[{0., 0.}, 0.31999999999999995`, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.4042857142857142], Opacity[1], 
    DiskBox[{0., 0.}, 0.3099999999999999, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.39285714285714274`], Opacity[1], 
    DiskBox[{0., 0.}, 0.2999999999999999, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.38142857142857134`], Opacity[1], 
    DiskBox[{0., 0.}, 0.28999999999999987`, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.36999999999999994`], Opacity[1], 
    DiskBox[{0., 0.}, 0.27999999999999997`, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.3585714285714285], Opacity[1], 
    DiskBox[{0., 0.}, 0.26999999999999996`, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.3471428571428571], Opacity[1], 
    DiskBox[{0., 0.}, 0.2599999999999999, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.33571428571428563`], Opacity[1], 
    DiskBox[{0., 0.}, 0.24999999999999992`, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.3242857142857142], Opacity[1], 
    DiskBox[{0., 0.}, 0.2399999999999999, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.3128571428571428], Opacity[1], 
    DiskBox[{0., 0.}, 0.22999999999999993`, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.3014285714285713], Opacity[1], 
    DiskBox[{0., 0.}, 0.21999999999999995`, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.2899999999999999], Opacity[1], 
    DiskBox[{0., 0.}, 0.20999999999999994`, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.2785714285714285], Opacity[1], 
    DiskBox[{0., 0.}, 0.19999999999999996`, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.26714285714285707`], Opacity[1], 
    DiskBox[{0., 0.}, 0.18999999999999995`, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.2557142857142856], Opacity[1], 
    DiskBox[{0., 0.}, 0.17999999999999994`, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.24428571428571422`], Opacity[1], 
    DiskBox[{0., 0.}, 0.16999999999999996`, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.23285714285714276`], Opacity[1], 
    DiskBox[{0., 0.}, 0.15999999999999995`, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.22142857142857136`], Opacity[1], 
    DiskBox[{0., 0.}, 0.14999999999999994`, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.20999999999999996`], Opacity[1], 
    DiskBox[{0., 0.}, 0.13999999999999993`, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.1985714285714285], Opacity[1], 
    DiskBox[{0., 0.}, 0.12999999999999995`, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.18714285714285706`], Opacity[1], 
    DiskBox[{0., 0.}, 0.11999999999999993`, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.17571428571428566`], Opacity[1], 
    DiskBox[{0., 0.}, 0.10999999999999995`, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.16428571428571423`], Opacity[1], 
    DiskBox[{0., 0.}, 0.09999999999999995, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.1528571428571428], Opacity[1], 
    DiskBox[{0., 0.}, 0.08999999999999993, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.14142857142857135`], Opacity[1], 
    DiskBox[{0., 0.}, 0.07999999999999993, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.12999999999999992`], Opacity[1], 
    DiskBox[{0., 0.}, 0.06999999999999994, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.11857142857142851`], Opacity[1], 
    DiskBox[{0., 0.}, 0.05999999999999994, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.10714285714285707`], Opacity[1], 
    DiskBox[{0., 0.}, 0.04999999999999994, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.09571428571428564], Opacity[1], 
    DiskBox[{0., 0.}, 0.03999999999999993, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.08428571428571421], Opacity[1], 
    DiskBox[{0., 0.}, 0.02999999999999994, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.07285714285714279], Opacity[1], 
    DiskBox[{0., 0.}, 0.01999999999999994, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0.06142857142857136], Opacity[1], 
    DiskBox[{0., 0.}, 0.009999999999999941, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], CircleBox[{0., 0.}, 0.6999999999999998, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], CircleBox[{0., 0.}, 0.6999999999999998, 
     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{2.220446049250313*^-16, -0.8999999999999998}, {
     2.220446049250313*^-16, 0.9000000000000004}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-0.029172499999999824`, 0.8416550000000003}, {
     2.220446049250313*^-16, 0.9000000000000004}, {0.029172500000000268`, 
     0.8416550000000003}}]}, 
   {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[CompressedData["
1:eJxdlHlIVFEUxqdpErE/LDI3hDIitaREArWFE6Lt+EeSThCllkFluUyUJYlW
lEu2mKSZqYk5U1YyZotiHi1NSkeymZp0ntmepsUoZqRDtnC/94cPHo8L9917
zvf9zucZE78pVqlQKLb+ff99f0/8e3rp0v/nKTWfuvHJQd9LWcN29ivtO2hc
O/tTdMcbSiq2lHt7dpLzvB1B0zU9NDfm63Coo5Eq747mhj+ykHHpluL0RyYa
sWa2OfZ2kWuc9l5swCvaX+CQofxsJp+iD9p7CWYyz4kc/z7wkm57PjPcP/Ca
+kIeHvL6bSSTJmDd2PouCjfEpi6a/4IUyhGtbayLDj6v69sZ/ZyUsw11h7O7
6URrQKT/PgOFBUfv8lFayKBLezAY+oxshep03mEh7xWtbufWtVJmTlmtXY2F
gsa6VSZNM5kTI/eqRi2U17e81L2xiY4N3rX38JVoxsdXh1PDG0ja27FksVoi
S8HZo6nqWgqMCt5cnSJRi1ePOf9kDZXtMS5py5do+skNuqDKKupvdMyKuCVR
Q2Cn/kxKBT1xqQ74VS9RSGBUZvGbQnLaqO72apXoZlT21IS36bRMI034tstr
xlrsZ+wX5zHOE/cx7hP1MOoR9TLqFf0w+hH9MvoVejD0EHox9BJ6MvQUejP0
Fn4w/BB+MfwSfjL8FH4z/BY8MHgQvDB4ETwxeBK8MXgTPDJ4FLwyeBU88ySe
WbfKd9Howhb5/7DRlP531kb5/M899YVhPnXy/W4XpnzbvvWOXJ8q7rxLycxK
uf60gaoclzVX5f50qT/rPcJy5f7nJma6mrQaWZ9Gt8KLj9XJDP389sUvUK04
w9B3bfaRdlvGRYb+fs7WlG1lRQx/0krWKHYbSxn+WZu+50R8KGP4uzH/ffKs
vHKG/065FfrykWsMPmxLV/e0zNAy+AnJ6NCfHtIy+Epbpj/+5YqOwV/c0GOr
zf06g0/ThR/TkuKuM/i1Nzj7X86T14Q1+Md+zAfOw/zgPswX6sH8oV7MJ/rB
/KJfzDf0wPxDL+QD9ER+QG/kC/xA/sAv5BP8RH7Bb+QbeED+gRfkI3hCfoI3
5Ct4RP6C18n5PHn9B0ydJbU=
     "]]}, 
   {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0.4611033333333334, 0.17082750000000013`}, {0.5, 
     0.20000000000000018`}, {0.5388966666666668, 0.17082750000000013`}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[CompressedData["
1:eJw9kl1Ik3EUxsci+pBKssKLRS4mWYKTcpFL3kNoFxFGsyKwTcO2LsLexRJj
kERBRnWRJJFi62II7cKwckXG8mmL9TELndteMNPM5ijISFFiUFDCOR348+fA
4Xw8z8/Y4K5x6XU6Xcm/t/g7Ty5GBjoONeqwGs0Z9F6/7cvGAyi9sdB/rm0a
6u+agiHlKXIHiwOHfWkY/Jvi31vDcDzq6TutfkHuzyPp9n2vUBnJC5gMU1BN
zqIeRwwZn7W+69kkLBO0fSH2HvVZbzb4YAIV47fKztuG0Xzc3XTqzxhWbmz4
7GmJY1V/uEVzjWJdemfnx7MjUK4t9b74oWF/x47qQiWBQM49raIziYvdd84c
SCcQWVMbLHSOIFCw7cRMYxJfm3PW5lcPo7ypLt82nsS3Xx2JIv87jPUdqwqW
p2D5dGhyYPQNYje9M+rlFDyNGzZ7rFGs36ufNb5MwWV7aJp7HsbbMmXuw3wK
eXctJWooBHvlitlSg4bdVV2R1cVPsCXkcNdaNXRfGoi+9vaiTb/HrBzUYJ63
ty8f8sM5bfdeqNNw9MrWXUuWXcXg46n7ra7/OUnO9ST13I+kH88jmcf7kOzD
+5Lsy/eQ3MP3ktzLepDowXqR6MV6kujJepPozX6Q+MF+kfjFfpL4yX6T+M08
kPDAvJDwwjyR8MS8kfDGPJLwyLyS8Mo8k/D8F5iGglM=
     "]]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], AbsoluteDashing[
     NCache[{3, 
       Rational[3, 2]}, {3, 1.5}]], CapForm[None], LineBox[CompressedData["
1:eJw9kl1Ik3EUxsci+pBKssKLRS4mWYKTcpFL3ofQLiKMZkVgm4ZtXYS9iyXG
IImCjOoiSSLF1sUQ2oVh5YqM5WmL9TELndteMNPM5ijISFFiUFDCOR348+fA
4Xw8z8/Y4K5x6XU6Xcm/t/g7Ty5GBjoONeqwGs0Z9F6/7cvGAyi9sdB/rm0a
6u+agiHlKXIHiwOHfWkY/Jvi31vDcDzq6TutfkHuzyPp9n2vUBnJC5gMU1BN
zqIeRwwZn7W+69kkLBPYvhB7j/qsNxt8MIGK8Vtl523DaD7ubjr1ZwwrNzZ8
9rTEsao/3KK5RrEuvbPz49kRKNeWel/80LC/Y0d1oZJAIOeeVtGZxMXuO2cO
pBOIrKkNFjpHECjYdmKmMYmvzTlr86uHUd5Ul28bT+Lbr45Ekf8dxvqOVQXL
U7B8OjQ5MPoGsZveGfVyCp7GDZs91ijW79XPGl+m4LI9NM09D+NtmTL3YT6F
vLuWEjUUgr1yxWypQcPuqq7I6uIn2BJyuGutGrovDURfe3vRpt9jVg5qMM/b
25cP+eGctnsv1Gk4emXrriXLrmLw8dT9Vtf/nCTnepJ67kfSj+eRzON9SPbh
fUn25XtI7uF7Se5lPUj0YL1I9GI9SfRkvUn0Zj9I/GC/SPxiP0n8ZL9J/GYe
SHhgXkh4YZ5IeGLeSHhjHkl4ZF5JeGWeSXj+CwfFbFM=
     "]], InsetBox[
     TagBox[
      StyleBox[
       TagBox["\<\"\[Omega]\"\>",
        DisplayForm],
       StripOnInput->False,
       ShowAutoStyles->False,
       SingleLetterItalics->False,
       FontFamily->"Times",
       FontSize->12,
       FontWeight->"Plain",
       FontSlant->"Plain",
       FontTracking->"Plain",
       FontColor->GrayLevel[0],
       FontOpacity->1],
      DisplayForm], {0.37774002639456994`, 0.4330133970016863}, {0, 0}, 
     Automatic, {0.9267806473751461, -0.375603024017253}]}},
  AspectRatio->1,
  Axes->False,
  Background->None,
  BaseStyle->{
   FontFamily -> "Times", FontSize -> 12, FontSlant -> "Plain", FontTracking -> 
    "Plain", FontWeight -> "Plain", FontColor -> GrayLevel[0], FontOpacity -> 
    1, ShowAutoStyles -> False, SingleLetterItalics -> False},
  DisplayFunction->Identity,
  Frame->False,
  FrameLabel->{None, None, None, None},
  FrameStyle->Directive[{
     GrayLevel[0], 
     Opacity[1], 
     CapForm[None], 
     AbsoluteThickness[1], 
     AbsoluteDashing[{}]}],
  FrameTicks->None,
  ImageSize->{288, 288},
  PlotRange->{{-1.40028, 1.40028}, {-1.40028, 1.40028}},
  Ticks->None]], "Output",
 CellChangeTimes->{
  3.482108582296875*^9, {3.501273652515625*^9, 3.50127366228125*^9}, 
   3.52552788834375*^9}]
}, Open  ]],

Cell[BoxData[""], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Some more (circles, arrows, arcs, ",
 StyleBox["etc.",
  FontSlant->"Italic"],
 ")"
}], "Section",
 CellChangeTimes->{{3.399735755125*^9, 3.399735761734375*^9}, {
  3.399737667796875*^9, 3.39973767721875*^9}, {3.495659279546875*^9, 
  3.495659312453125*^9}}],

Cell["\<\
Note how functions (Dipole and ForceArrow) have been defined to draw parts of \
the diagram, thereby saving retyping and allowing easy changes to the \
coordinates.  For instance, the \"dipole\" can be moved or its size changed \
just by changing the argument to Dipole, without the need to manually edit \
the coordinates for each component of the dipole.\
\>", "Text",
 CellChangeTimes->{{3.399737682484375*^9, 3.399737846890625*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Dipole", "[", 
    RowBox[{"x0_List", ",", "a_", ",", "theta_"}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "avec", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"avec", "=", 
         RowBox[{"a", "*", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Cos", "[", "theta", "]"}], ",", 
            RowBox[{"Sin", "[", "theta", "]"}]}], "}"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"SchemeCircle", "[", 
         RowBox[{
          RowBox[{"x0", "+", "avec"}], ",", 
          RowBox[{"Point", "[", "4", "]"}], ",", 
          RowBox[{"FillColor", "\[Rule]", "Red"}], ",", 
          RowBox[{"LabT", "\[Rule]", "\"\<+\>\""}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"SchemeCircle", "[", 
        RowBox[{
         RowBox[{"x0", "-", "avec"}], ",", 
         RowBox[{"Point", "[", "4", "]"}], ",", 
         RowBox[{"FillColor", "\[Rule]", "Blue"}], ",", 
         RowBox[{"LabB", "\[Rule]", "\"\<-\>\""}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"SchemeArrow", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x0", "-", "avec"}], ",", 
           RowBox[{"x0", "+", "avec"}]}], "}"}], ",", 
         RowBox[{"LabR", "\[Rule]", 
          RowBox[{"textbf", "[", "\"\<p\>\"", "]"}]}], ",", 
         RowBox[{"Thickness", "\[Rule]", "2"}], ",", 
         RowBox[{"BufferR", "\[Rule]", "1.3"}], ",", 
         RowBox[{"OrientationR", "\[Rule]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"N", "[", "theta", "]"}], "<", 
             RowBox[{"Pi", "/", "2"}]}], ",", "Automatic", ",", "Inverted"}], 
           "]"}]}]}], "]"}]}], "\[IndentingNewLine]", "}"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"ForceArrow", "[", 
    RowBox[{"x_List", ",", "l_"}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "rhat", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"rhat", "=", 
       RowBox[{"x", "/", 
        RowBox[{"Norm", "[", "x", "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"SchemeArrow", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"x", ",", 
          RowBox[{"x", "+", 
           RowBox[{"l", "*", "rhat"}]}]}], "}"}], ",", 
        RowBox[{"ArrowType", "\[Rule]", "MultilineArrow"}], ",", 
        RowBox[{"ShowFill", "\[Rule]", "False"}], ",", 
        RowBox[{"Layer", "\[Rule]", "0"}], ",", 
        RowBox[{"Width", "\[Rule]", "3"}]}], "]"}]}]}], "\[IndentingNewLine]",
     "\[IndentingNewLine]", "]"}]}], ";"}], "\n", 
 RowBox[{"Figure", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Multipanel", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"1", ",", "3"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Margin", "\[Rule]", "10"}], ",", "\[IndentingNewLine]", 
       RowBox[{"XPlotRanges", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "0.2"}], ",", "1"}], "}"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"YPlotRanges", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "0.4"}], ",", "0.8"}], "}"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"XFrameTicks", "\[Rule]", "None"}], ",", 
       RowBox[{"YFrameTicks", "\[Rule]", "None"}]}], "\[IndentingNewLine]", 
      "]"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"x0", "=", 
      RowBox[{"{", 
       RowBox[{"0.6", ",", "0"}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"a", "=", "0.13"}], ",", "\[IndentingNewLine]", 
     RowBox[{"l", "=", "0.15"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"FigurePanel", "[", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"SchemeAxis", "[", 
      RowBox[{"Bottom", ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0.9"}], "}"}], ",", "0", ",", 
       RowBox[{"LabB", "\[Rule]", 
        RowBox[{"textit", "[", "\"\<x\>\"", "]"}]}], ",", 
       RowBox[{"PosnB", "\[Rule]", "1"}]}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"SchemeAxis", "[", 
      RowBox[{"Left", ",", "0", ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0.5"}], "}"}], ",", 
       RowBox[{"LabL", "\[Rule]", 
        RowBox[{"textit", "[", "\"\<z\>\"", "]"}]}], ",", 
       RowBox[{"PosnL", "\[Rule]", "1"}]}], "]"}], ",", "\[IndentingNewLine]",
      "\[IndentingNewLine]", 
     RowBox[{"SchemeCircle", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], ",", 
       RowBox[{"Point", "[", "10", "]"}], ",", 
       RowBox[{"FillColor", "\[Rule]", "Red"}], ",", 
       RowBox[{"LabC", "\[Rule]", 
        RowBox[{"textit", "[", "\"\<Q\>\"", "]"}]}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Dipole", "[", 
      RowBox[{"x0", ",", "a", ",", 
       RowBox[{"55", "*", "Degree"}]}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"SchemeCircle", "[", 
      RowBox[{"x0", ",", "a", ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"45", "*", "Degree"}]}], "}"}], ",", 
       RowBox[{"ShowFill", "\[Rule]", "False"}], ",", 
       RowBox[{"LabX", "\[Rule]", "\"\<\[Alpha]\>\""}], ",", 
       RowBox[{"PosnX", "\[Rule]", "0.3"}], ",", 
       RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"SchemeCircle", "[", 
      RowBox[{"x0", ",", 
       RowBox[{"Point", "[", "3", "]"}], ",", 
       RowBox[{"LabB", "\[Rule]", 
        RowBox[{"Row", "[", 
         RowBox[{"{", 
          RowBox[{"\"\<(\>\"", ",", 
           RowBox[{"textit", "[", "\"\<r\>\"", "]"}], ",", "\"\<,0,0)\>\""}], 
          "}"}], "]"}]}], ",", 
       RowBox[{"OffsetB", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1"}], ",", 
          RowBox[{"+", "1"}]}], "}"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"FigurePanel", "[", 
      RowBox[{"{", 
       RowBox[{"1", ",", "2"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"SchemeCircle", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], ",", 
       RowBox[{"Point", "[", "10", "]"}], ",", 
       RowBox[{"FillColor", "\[Rule]", "Red"}], ",", 
       RowBox[{"LabC", "\[Rule]", 
        RowBox[{"textit", "[", "\"\<Q\>\"", "]"}]}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Dipole", "[", 
      RowBox[{"x0", ",", "a", ",", 
       RowBox[{"0", "*", "Degree"}]}], "]"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"FigurePanel", "[", 
      RowBox[{"{", 
       RowBox[{"1", ",", "3"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"SchemeCircle", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], ",", 
       RowBox[{"Point", "[", "10", "]"}], ",", 
       RowBox[{"FillColor", "\[Rule]", "Red"}], ",", 
       RowBox[{"LabC", "\[Rule]", 
        RowBox[{"textit", "[", "\"\<Q\>\"", "]"}]}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Dipole", "[", 
      RowBox[{"x0", ",", "a", ",", 
       RowBox[{"90", "*", "Degree"}]}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"ForceArrow", "[", 
      RowBox[{
       RowBox[{"x0", "+", 
        RowBox[{"{", 
         RowBox[{"0", ",", "a"}], "}"}]}], ",", "l"}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ForceArrow", "[", 
      RowBox[{
       RowBox[{"x0", "+", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{"-", "a"}]}], "}"}]}], ",", 
       RowBox[{"-", "l"}]}], "]"}]}], "\[IndentingNewLine]", 
    "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
   RowBox[{"ImageSize", "\[Rule]", 
    RowBox[{"72", "*", "0.8", "*", 
     RowBox[{"{", 
      RowBox[{"9", ",", "3"}], "}"}]}]}]}], "\[IndentingNewLine]", 
  "]"}]}], "Input",
 CellChangeTimes->{{3.399732547171875*^9, 3.39973266503125*^9}, {
   3.39973270928125*^9, 3.399732721875*^9}, {3.39973283740625*^9, 
   3.399732839078125*^9}, {3.399732878515625*^9, 3.399732880015625*^9}, {
   3.399732910921875*^9, 3.399732921515625*^9}, 3.399732996796875*^9, {
   3.399733394671875*^9, 3.399733401515625*^9}, {3.399733435671875*^9, 
   3.399733437703125*^9}, {3.399733496140625*^9, 3.399733567953125*^9}, {
   3.399733956796875*^9, 3.399733958578125*^9}, {3.3997343233125*^9, 
   3.39973448796875*^9}, {3.399734649140625*^9, 3.399734746*^9}, {
   3.399734901921875*^9, 3.39973491115625*^9}}],

Cell[BoxData[
 GraphicsBox[{
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], CircleBox[{0.2329411008230453, 0.3526273148148148}, {0.03471765689300413, 0.09579224537037037},
      NCache[{0, 45 Degree}, {0, 0.7853981633974483}]], InsetBox[
     TagBox[
      StyleBox[
       TagBox["\<\"\[Alpha]\"\>",
        DisplayForm],
       StripOnInput->False,
       ShowAutoStyles->False,
       SingleLetterItalics->False,
       FontFamily->"Times",
       FontSize->12,
       FontWeight->"Plain",
       FontSlant->"Plain",
       FontTracking->"Plain",
       FontColor->GrayLevel[0],
       FontOpacity->1],
      DisplayForm], {0.2781198682752133, 0.39768481228754055`}, {0, 0}, 
     Automatic, {0.2525697535070605, -0.9675786891066703}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0.874448056720046, 0.4399046861399264}, {
     0.9098140945428449, 0.46104728915958565`}}], 
    LineBox[{{0.8733168609754273, 0.4569344342304439}, {0.9086828987982261, 
     0.4780770372501032}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0.8999829261244883, 0.4905820023621452}, {
     0.913032885135095, 0.4718245546940821}, {0.9033765133583449, 
     0.4394927580905928}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0.874448056720046, 0.26534994348970325`}, {
     0.8390820188972473, 0.28649254650936246`}}], 
    LineBox[{{0.8733168609754273, 0.24832019539918573`}, {0.8379508231526285, 
     0.269462798418845}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0.8443884043371286, 0.24790826734985208`}, {
     0.8347320325603784, 0.2802400639533414}, {0.8477819915709851, 
     0.29899751162140453`}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0.01929398148148148, 0.05788194444444439}, {
     0.3397646604938272, 0.05788194444444439}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0.01929398148148148, 0.05788194444444439}, {
     0.01929398148148148, 0.9421180555555556}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0.01929398148148148, 0.9421180555555556}, {
     0.3397646604938272, 0.9421180555555556}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0.3397646604938272, 0.05788194444444439}, {
     0.3397646604938272, 0.9421180555555556}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0.07270576131687244, 0.3526273148148148}, {
     0.31305877057613174`, 0.3526273148148148}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0.3014823816872429, 0.36999189814814815`}, {
     0.3130587705761318, 0.35262731481481485`}, {0.3014823816872429, 
     0.3352627314814815}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0.07270576131687244, 0.3526273148148148}, {
     0.07270576131687244, 0.7210590277777778}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0.06691756687242799, 0.686329861111111}, {
     0.07270576131687244, 0.7210590277777778}, {0.07849395576131689, 
     0.686329861111111}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], {}, 
    {RGBColor[1, 0, 0], Opacity[1], 
     DiskBox[{0.07270576131687244, 0.3526273148148148}, {0.01929398148148148, 0.05788194444444444},
       NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
     None], CircleBox[{0.07270576131687244, 0.3526273148148148}, {0.01929398148148148, 0.05788194444444444},
       NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
     {RGBColor[1, 0, 0], Opacity[1], 
      DiskBox[{0.25285433074219293`, 0.4310957284369864}, {0.007717592592592593, 0.023152777777777776`},
        NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
     {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
      None], CircleBox[{0.25285433074219293`, 0.4310957284369864}, {0.007717592592592593, 0.023152777777777776`},
        NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
      {RGBColor[0, 0, 1], Opacity[1], 
       DiskBox[{0.2130278709038977, 0.2741589011926432}, {0.007717592592592593, 0.023152777777777776`},
         NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
      {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
       None], CircleBox[{0.2130278709038977, 0.2741589011926432}, {0.007717592592592593, 0.023152777777777776`},
         NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
      {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], CapForm[
       None], LineBox[{{0.21302787090389771`, 0.27415890119264325`}, {
        0.252854330742193, 0.4310957284369864}}]}, 
      {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], CapForm[
       None], LineBox[{{0.24123653037767329`, 0.41398186844244145`}, {
        0.252854330742193, 0.4310957284369864}, {0.2504473465220265, 
        0.39294469156541223`}}], 
       {GrayLevel[0], Opacity[1], 
        DiskBox[{0.2329411008230453, 0.3526273148148148}, {0.005788194444444445, 0.017364583333333333`},
          NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
       {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
        None], 
        CircleBox[{0.2329411008230453, 0.3526273148148148}, {0.005788194444444445, 0.017364583333333333`},
          NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
       {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
        None], LineBox[{{0.3397646604938272, 0.05788194444444439}, {
         0.6602353395061729, 0.05788194444444439}}]}, 
       {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
        None]}, 
       {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
        None], LineBox[{{0.3397646604938272, 0.05788194444444439}, {
         0.3397646604938272, 0.9421180555555556}}]}, 
       {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
        None]}, 
       {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
        None], LineBox[{{0.3397646604938272, 0.9421180555555556}, {
         0.6602353395061729, 0.9421180555555556}}]}, 
       {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
        None]}, 
       {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
        None], LineBox[{{0.6602353395061729, 0.05788194444444439}, {
         0.6602353395061729, 0.9421180555555556}}]}, 
       {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
        None], {}, 
        {RGBColor[1, 0, 0], Opacity[1], 
         DiskBox[{0.39317644032921817`, 0.3526273148148148}, {0.01929398148148148, 0.05788194444444444},
           NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
        {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
         None], CircleBox[{0.39317644032921817`, 0.3526273148148148}, {0.01929398148148148, 0.05788194444444444},
           NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
         {RGBColor[1, 0, 0], Opacity[1], 
          DiskBox[{0.5881294367283951, 0.3526273148148148}, {0.007717592592592593, 0.023152777777777776`},
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          CircleBox[{0.5881294367283951, 0.3526273148148148}, {0.007717592592592593, 0.023152777777777776`},
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
          {RGBColor[0, 0, 1], Opacity[1], 
           DiskBox[{0.5186941229423869, 0.3526273148148148}, {0.007717592592592593, 0.023152777777777776`},
             NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           CircleBox[{0.5186941229423869, 0.3526273148148148}, {0.007717592592592593, 0.023152777777777776`},
             NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.5186941229423869, 0.35262731481481485`}, {
            0.5881294367283951, 0.35262731481481485`}}]}, 
          {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.5765530478395062, 0.36999189814814815`}, {
            0.5881294367283951, 0.35262731481481485`}, {0.5765530478395062, 
            0.3352627314814815}}]}, 
          {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.6602353395061729, 0.05788194444444439}, {
            0.9807060185185186, 0.05788194444444439}}]}, 
          {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None]}, 
          {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.6602353395061729, 0.05788194444444439}, {
            0.6602353395061729, 0.9421180555555556}}]}, 
          {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None]}, 
          {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.6602353395061729, 0.9421180555555556}, {
            0.9807060185185186, 0.9421180555555556}}]}, 
          {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None]}, 
          {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.9807060185185186, 0.05788194444444439}, {
            0.9807060185185186, 0.9421180555555556}}]}, 
          {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], {}, 
           {RGBColor[1, 0, 0], Opacity[1], 
            DiskBox[{0.7136471193415638, 0.3526273148148148}, {0.01929398148148148, 0.05788194444444444},
              NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
           {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
            CapForm[None], 
            CircleBox[{0.7136471193415638, 0.3526273148148148}, {0.01929398148148148, 0.05788194444444444},
              NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
            {RGBColor[1, 0, 0], Opacity[1], 
             DiskBox[{0.8738824588477366, 0.44841956018518514`}, {0.007717592592592593, 0.023152777777777776`},
               NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
            {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
             CapForm[None], 
             CircleBox[{0.8738824588477366, 0.44841956018518514`}, {0.007717592592592593, 0.023152777777777776`},
               NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
             {RGBColor[0, 0, 1], Opacity[1], 
              DiskBox[{0.8738824588477366, 0.25683506944444445`}, {0.007717592592592593, 0.023152777777777776`},
                NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
             {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
              CapForm[None], 
              CircleBox[{0.8738824588477366, 0.25683506944444445`}, {0.007717592592592593, 0.023152777777777776`},
                NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
             {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], 
              CapForm[None], 
              LineBox[{{0.8738824588477366, 0.25683506944444445`}, {
               0.8738824588477366, 0.44841956018518514`}}]}, 
             {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], 
              CapForm[None], 
              LineBox[{{0.8680942644032922, 0.4136903935185185}, {
               0.8738824588477366, 0.44841956018518514`}, {0.8796706532921811,
                0.4136903935185185}}], InsetBox[
               TagBox[
                StyleBox[
                 TagBox["\<\"(a)\"\>",
                  DisplayForm],
                 StripOnInput->False,
                 ShowAutoStyles->False,
                 SingleLetterItalics->False,
                 FontFamily->"Times",
                 FontSize->12,
                 FontWeight->"Plain",
                 FontSlant->"Plain",
                 FontTracking->"Plain",
                 FontColor->GrayLevel[0],
                 FontOpacity->1],
                DisplayForm], {0.048234953703703703`, 0.855295138888889}, {0, 0},
                Automatic, {1, 0}], InsetBox[
               TagBox[
                StyleBox[
                 TagBox[
                  TagBox[
                   StyleBox["\<\"x\"\>",
                    FontSlant->"Italic"],
                   StyleForm[#, FontSlant -> "Italic"]& ],
                  DisplayForm],
                 StripOnInput->False,
                 ShowAutoStyles->False,
                 SingleLetterItalics->False,
                 FontFamily->"Times",
                 FontSize->12,
                 FontWeight->"Plain",
                 FontSlant->"Plain",
                 FontTracking->"Plain",
                 FontColor->GrayLevel[0],
                 FontOpacity->1],
                DisplayForm], {0.3130587705761318, 0.31153113425925927`}, {0, 0},
                Automatic, {1, 0}], InsetBox[
               TagBox[
                StyleBox[
                 TagBox[
                  TagBox[
                   StyleBox["\<\"z\"\>",
                    FontSlant->"Italic"],
                   StyleForm[#, FontSlant -> "Italic"]& ],
                  DisplayForm],
                 StripOnInput->False,
                 ShowAutoStyles->False,
                 SingleLetterItalics->False,
                 FontFamily->"Times",
                 FontSize->12,
                 FontWeight->"Plain",
                 FontSlant->"Plain",
                 FontTracking->"Plain",
                 FontColor->GrayLevel[0],
                 FontOpacity->1],
                DisplayForm], {0.05900703446502059, 0.7210590277777778}, {0, 0},
                Automatic, {0, 1}], InsetBox[
               TagBox[
                StyleBox[
                 TagBox[
                  TagBox[
                   StyleBox["\<\"Q\"\>",
                    FontSlant->"Italic"],
                   StyleForm[#, FontSlant -> "Italic"]& ],
                  DisplayForm],
                 StripOnInput->False,
                 ShowAutoStyles->False,
                 SingleLetterItalics->False,
                 FontFamily->"Times",
                 FontSize->12,
                 FontWeight->"Plain",
                 FontSlant->"Plain",
                 FontTracking->"Plain",
                 FontColor->GrayLevel[0],
                 FontOpacity->1],
                DisplayForm], {0.07270576131687244, 0.3526273148148148}, {0, 0},
                Automatic, {1, 0}], InsetBox[
               TagBox[
                StyleBox[
                 TagBox["\<\"+\"\>",
                  DisplayForm],
                 StripOnInput->False,
                 ShowAutoStyles->False,
                 SingleLetterItalics->False,
                 FontFamily->"Times",
                 FontSize->12,
                 FontWeight->"Plain",
                 FontSlant->"Plain",
                 FontTracking->"Plain",
                 FontColor->GrayLevel[0],
                 FontOpacity->1],
                DisplayForm], {0.25285433074219293`, 0.4542485062147642}, {0, -1},
                Automatic, {1, 0}], InsetBox[
               TagBox[
                StyleBox[
                 TagBox["\<\"-\"\>",
                  DisplayForm],
                 StripOnInput->False,
                 ShowAutoStyles->False,
                 SingleLetterItalics->False,
                 FontFamily->"Times",
                 FontSize->12,
                 FontWeight->"Plain",
                 FontSlant->"Plain",
                 FontTracking->"Plain",
                 FontColor->GrayLevel[0],
                 FontOpacity->1],
                DisplayForm], {0.2130278709038977, 0.2510061234148654}, {0, 1},
                Automatic, {1, 0}], InsetBox[
               TagBox[
                StyleBox[
                 TagBox[
                  TagBox[
                   StyleBox["\<\"p\"\>",
                    FontWeight->"Bold"],
                   StyleForm[#, FontWeight -> "Bold"]& ],
                  DisplayForm],
                 StripOnInput->False,
                 ShowAutoStyles->False,
                 SingleLetterItalics->False,
                 FontFamily->"Times",
                 FontSize->12,
                 FontWeight->"Plain",
                 FontSlant->"Plain",
                 FontTracking->"Plain",
                 FontColor->GrayLevel[0],
                 FontOpacity->1],
                DisplayForm], {0.21943190381132735`, 0.3834818409011244}, {0, 0},
                Automatic, {0.6057495441496134, 0.7956553837953563}], InsetBox[
               TagBox[
                StyleBox[
                 TagBox[
                  TemplateBox[{"\"(\"",TagBox[
                    StyleBox["\"r\"", FontSlant -> "Italic"], 
                    StyleForm[#, FontSlant -> "Italic"]& ],"\",0,0)\""},
                   "Row",
                   
                   DisplayFunction->(
                    RowBox[{#, "\[InvisibleSpace]", #2, 
                    "\[InvisibleSpace]", #3}]& ),
                   InterpretationFunction->(RowBox[{"Row", "[", 
                    RowBox[{"{", 
                    RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
                  DisplayForm],
                 StripOnInput->False,
                 ShowAutoStyles->False,
                 SingleLetterItalics->False,
                 FontFamily->"Times",
                 FontSize->12,
                 FontWeight->"Plain",
                 FontSlant->"Plain",
                 FontTracking->"Plain",
                 FontColor->GrayLevel[0],
                 FontOpacity->1],
                DisplayForm], {0.2329411008230453, 0.33526273148148145`}, {-1, 1},
                Automatic, {1, 0}], InsetBox[
               TagBox[
                StyleBox[
                 TagBox["\<\"(b)\"\>",
                  DisplayForm],
                 StripOnInput->False,
                 ShowAutoStyles->False,
                 SingleLetterItalics->False,
                 FontFamily->"Times",
                 FontSize->12,
                 FontWeight->"Plain",
                 FontSlant->"Plain",
                 FontTracking->"Plain",
                 FontColor->GrayLevel[0],
                 FontOpacity->1],
                DisplayForm], {0.3687056327160494, 0.855295138888889}, {0, 0},
                Automatic, {1, 0}], InsetBox[
               TagBox[
                StyleBox[
                 TagBox[
                  TagBox[
                   StyleBox["\<\"Q\"\>",
                    FontSlant->"Italic"],
                   StyleForm[#, FontSlant -> "Italic"]& ],
                  DisplayForm],
                 StripOnInput->False,
                 ShowAutoStyles->False,
                 SingleLetterItalics->False,
                 FontFamily->"Times",
                 FontSize->12,
                 FontWeight->"Plain",
                 FontSlant->"Plain",
                 FontTracking->"Plain",
                 FontColor->GrayLevel[0],
                 FontOpacity->1],
                DisplayForm], {0.39317644032921817`, 0.3526273148148148}, {0, 0},
                Automatic, {1, 0}], InsetBox[
               TagBox[
                StyleBox[
                 TagBox["\<\"+\"\>",
                  DisplayForm],
                 StripOnInput->False,
                 ShowAutoStyles->False,
                 SingleLetterItalics->False,
                 FontFamily->"Times",
                 FontSize->12,
                 FontWeight->"Plain",
                 FontSlant->"Plain",
                 FontTracking->"Plain",
                 FontColor->GrayLevel[0],
                 FontOpacity->1],
                DisplayForm], {0.5881294367283951, 0.3757800925925926}, {0, -1},
                Automatic, {1, 0}], InsetBox[
               TagBox[
                StyleBox[
                 TagBox["\<\"-\"\>",
                  DisplayForm],
                 StripOnInput->False,
                 ShowAutoStyles->False,
                 SingleLetterItalics->False,
                 FontFamily->"Times",
                 FontSize->12,
                 FontWeight->"Plain",
                 FontSlant->"Plain",
                 FontTracking->"Plain",
                 FontColor->GrayLevel[0],
                 FontOpacity->1],
                DisplayForm], {0.5186941229423869, 0.329474537037037}, {0, 1},
                Automatic, {1, 0}], InsetBox[
               TagBox[
                StyleBox[
                 TagBox[
                  TagBox[
                   StyleBox["\<\"p\"\>",
                    FontWeight->"Bold"],
                   StyleForm[#, FontWeight -> "Bold"]& ],
                  DisplayForm],
                 StripOnInput->False,
                 ShowAutoStyles->False,
                 SingleLetterItalics->False,
                 FontFamily->"Times",
                 FontSize->12,
                 FontWeight->"Plain",
                 FontSlant->"Plain",
                 FontTracking->"Plain",
                 FontColor->GrayLevel[0],
                 FontOpacity->1],
                DisplayForm], {0.553411779835391, 0.4035634259259259}, {0, 0},
                Automatic, {1., 0.}], InsetBox[
               TagBox[
                StyleBox[
                 TagBox["\<\"(c)\"\>",
                  DisplayForm],
                 StripOnInput->False,
                 ShowAutoStyles->False,
                 SingleLetterItalics->False,
                 FontFamily->"Times",
                 FontSize->12,
                 FontWeight->"Plain",
                 FontSlant->"Plain",
                 FontTracking->"Plain",
                 FontColor->GrayLevel[0],
                 FontOpacity->1],
                DisplayForm], {0.6891763117283951, 0.855295138888889}, {0, 0},
                Automatic, {1, 0}], InsetBox[
               TagBox[
                StyleBox[
                 TagBox[
                  TagBox[
                   StyleBox["\<\"Q\"\>",
                    FontSlant->"Italic"],
                   StyleForm[#, FontSlant -> "Italic"]& ],
                  DisplayForm],
                 StripOnInput->False,
                 ShowAutoStyles->False,
                 SingleLetterItalics->False,
                 FontFamily->"Times",
                 FontSize->12,
                 FontWeight->"Plain",
                 FontSlant->"Plain",
                 FontTracking->"Plain",
                 FontColor->GrayLevel[0],
                 FontOpacity->1],
                DisplayForm], {0.7136471193415638, 0.3526273148148148}, {0, 0},
                Automatic, {1, 0}], InsetBox[
               TagBox[
                StyleBox[
                 TagBox["\<\"+\"\>",
                  DisplayForm],
                 StripOnInput->False,
                 ShowAutoStyles->False,
                 SingleLetterItalics->False,
                 FontFamily->"Times",
                 FontSize->12,
                 FontWeight->"Plain",
                 FontSlant->"Plain",
                 FontTracking->"Plain",
                 FontColor->GrayLevel[0],
                 FontOpacity->1],
                DisplayForm], {0.8738824588477366, 0.47157233796296294`}, {0, -1},
                Automatic, {1, 0}], InsetBox[
               TagBox[
                StyleBox[
                 TagBox["\<\"-\"\>",
                  DisplayForm],
                 StripOnInput->False,
                 ShowAutoStyles->False,
                 SingleLetterItalics->False,
                 FontFamily->"Times",
                 FontSize->12,
                 FontWeight->"Plain",
                 FontSlant->"Plain",
                 FontTracking->"Plain",
                 FontColor->GrayLevel[0],
                 FontOpacity->1],
                DisplayForm], {0.8738824588477366, 0.23368229166666668`}, {0, 1},
                Automatic, {1, 0}], InsetBox[
               TagBox[
                StyleBox[
                 TagBox[
                  TagBox[
                   StyleBox["\<\"p\"\>",
                    FontWeight->"Bold"],
                   StyleForm[#, FontWeight -> "Bold"]& ],
                  DisplayForm],
                 StripOnInput->False,
                 ShowAutoStyles->False,
                 SingleLetterItalics->False,
                 FontFamily->"Times",
                 FontSize->12,
                 FontWeight->"Plain",
                 FontSlant->"Plain",
                 FontTracking->"Plain",
                 FontColor->GrayLevel[0],
                 FontOpacity->1],
                DisplayForm], {0.8569037551440329, 0.35262731481481485`}, {0, 0},
                Automatic, {-6.123233995736766*^-17, -1.}]}}}}}}}}}}}},
  AspectRatio->0.33333333333333337`,
  Axes->False,
  Background->None,
  BaseStyle->{
   FontFamily -> "Times", FontSize -> 12, FontSlant -> "Plain", FontTracking -> 
    "Plain", FontWeight -> "Plain", FontColor -> GrayLevel[0], FontOpacity -> 
    1, ShowAutoStyles -> False, SingleLetterItalics -> False},
  DisplayFunction->Identity,
  Frame->False,
  FrameLabel->{None, None, None, None},
  FrameStyle->Directive[{
     GrayLevel[0], 
     Opacity[1], 
     CapForm[None], 
     AbsoluteThickness[1], 
     AbsoluteDashing[{}]}],
  FrameTicks->None,
  ImageSize->{518.4, 172.8},
  PlotRange->{{-0.0001, 1.0001}, {-0.0001, 1.0001}},
  Ticks->None]], "Output",
 CellChangeTimes->{{3.3997333100625*^9, 3.39973332078125*^9}, {
   3.3997333545*^9, 3.3997334100625*^9}, {3.39973344040625*^9, 
   3.399733598609375*^9}, {3.3997336471875*^9, 3.399733669609375*^9}, {
   3.399733722078125*^9, 3.399733725609375*^9}, {3.3997338146875*^9, 
   3.3997338840625*^9}, {3.39973416515625*^9, 3.39973428484375*^9}, 
   3.3997343508125*^9, {3.3997343879375*^9, 3.3997345141875*^9}, 
   3.399734656453125*^9, {3.39973471578125*^9, 3.399734747484375*^9}, {
   3.399734895765625*^9, 3.399734912375*^9}, 3.43024801746875*^9, 
   3.52552788953125*^9},
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Diagram of recurrence relations", "Section",
 CellChangeTimes->{{3.495658481421875*^9, 3.495658485828125*^9}}],

Cell[TextData[{
 "Figure from F. Q. Luo and M. A. Caprio, Nuclear Physics A ",
 StyleBox["849",
  FontWeight->"Bold"],
 ", 35 (2011)."
}], "Text",
 CellChangeTimes->{{3.525527975296875*^9, 3.52552799284375*^9}}],

Cell["\<\
This provides an example of defining functions to draw certain elements of \
the figure which you use repeatedly within the figure (e.g., nodes of a \
network) and then of using \"Table[]\" to construct the full figure.

This also provides an example of maintaining multiple variants of a figure in \
parallel using \"conditional inclusion\", so that any changes you make \
automatically apply to both/all versions.  Two variants are needed here: 
\t1) With SchemeFlags \[Rule] {\"EqnNumber\"}, we make a version for use in \
the paper, with cross references to certain equation numbers.
\t2) With SchemeFlags \[Rule] {\"Color\"}, we make a color version for use in \
presentations.\
\>", "Text",
 CellChangeTimes->{{3.495658556640625*^9, 3.49565869053125*^9}}],

Cell[TextData[{
 "Character definition\nIncidentally, this figure also provides a simple \
example of selecting a different font to get a symbol we need.  In Times \
Roman, a lowercase italic \"",
 StyleBox["v",
  FontSlant->"Italic"],
 "\" looks very similar to a lowercase Greek \"\[Nu]\".  We are trying to \
avoid this by using a different font for \"v\", namely, ",
 "\"BookAntiqua\"",
 ".  If you do not have \"BookAntiqua\" installed as a font on your system, \
you may not get this rounded v character in the example, or you may have to \
hunt for another suitable font if you really want it!  (For instance, \
\"BookmanOldStyle\" works well.)"
}], "Text",
 CellChangeTimes->{{3.495658829859375*^9, 3.495659026703125*^9}, {
  3.495659068953125*^9, 3.49565912803125*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RoundedV", "=", 
  RowBox[{"Style", "[", 
   RowBox[{"\"\<v\>\"", ",", "Italic", ",", 
    RowBox[{"FontFamily", "\[Rule]", "\"\<BookAntiqua\>\""}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.484770186703125*^9, 3.484770200859375*^9}, {
  3.4847702585625*^9, 3.48477027103125*^9}, {3.484770819984375*^9, 
  3.484770854984375*^9}, {3.495658874984375*^9, 3.495658887015625*^9}}],

Cell[BoxData[
 StyleBox["\<\"v\"\>",
  StripOnInput->False,
  FontFamily->"BookAntiqua",
  FontSlant->Italic]], "Output",
 CellChangeTimes->{3.495658888609375*^9, 3.495659630203125*^9, 
  3.525527889640625*^9}]
}, Open  ]],

Cell["Diagram components: Nodes", "Text",
 CellChangeTimes->{{3.495658156828125*^9, 3.495658161546875*^9}, {
   3.495658205375*^9, 3.495658207953125*^9}, 3.495658252796875*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"OverlapDot", "[", 
    RowBox[{"v_", ",", "N_"}], "]"}], ":=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"SchemeCircle", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"N", ",", "v"}], "}"}], ",", "DotRadius", ",", 
       RowBox[{"ShowLine", "\[Rule]", "False"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"SchemeCircle", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"N", ",", "v"}], "}"}], ",", 
       RowBox[{"DotScale", "*", "DotRadius"}], ",", 
       RowBox[{"ShowFill", "\[Rule]", "False"}], ",", 
       RowBox[{"Show", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{"v", "\[Equal]", "0"}], ")"}]}]}], "]"}], ","}], 
    "\[IndentingNewLine]", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"OBMEDot", "[", 
    RowBox[{"v_", ",", "N_"}], "]"}], ":=", 
   RowBox[{"SchemeCircle", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"N", ",", 
       RowBox[{"v", "+", "0.5"}]}], "}"}], ",", "DotRadius", ",", 
     RowBox[{"ShowLine", "\[Rule]", "False"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"UpEllipsis", "[", 
    RowBox[{"v_", ",", "N_"}], "]"}], ":=", 
   RowBox[{"ManualLabel", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"N", ",", 
       RowBox[{"v", "+", "0.5", "+", "0.25"}]}], "}"}], ",", 
     "\"\<\[VerticalEllipsis]\>\""}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484771232625*^9, 3.484771261671875*^9}, {
   3.484771425734375*^9, 3.4847714690625*^9}, {3.484771529109375*^9, 
   3.484771539234375*^9}, {3.484772151875*^9, 3.48477217065625*^9}, {
   3.484772547640625*^9, 3.48477256515625*^9}, {3.484772597640625*^9, 
   3.48477261821875*^9}, 3.48477265509375*^9, {3.484774961234375*^9, 
   3.48477499371875*^9}, {3.48477512915625*^9, 3.484775151078125*^9}, {
   3.48477519909375*^9, 3.484775260390625*^9}, {3.48477565565625*^9, 
   3.48477566178125*^9}, 3.48477599353125*^9, {3.484776041734375*^9, 
   3.48477604490625*^9}, {3.4847761121875*^9, 3.48477621546875*^9}, {
   3.4847762741875*^9, 3.484776284796875*^9}, {3.484776994796875*^9, 
   3.48477705896875*^9}, {3.4847771034375*^9, 3.484777106078125*^9}, {
   3.48477713753125*^9, 3.484777156734375*^9}, {3.4847772154375*^9, 
   3.48477721678125*^9}, {3.4847772808125*^9, 3.4847772973125*^9}, {
   3.48477735465625*^9, 3.48477740865625*^9}, {3.4847775466875*^9, 
   3.484777585640625*^9}, {3.4848359379375*^9, 3.48483596296875*^9}, {
   3.48571588434375*^9, 3.485715906625*^9}, {3.48667959440625*^9, 
   3.486679657453125*^9}, {3.495657942875*^9, 3.495657975109375*^9}, {
   3.495658023*^9, 3.495658033546875*^9}, 3.49565816896875*^9}],

Cell["Diagram components: Arrows", "Text",
 CellChangeTimes->{{3.495658156828125*^9, 3.495658161546875*^9}, {
   3.495658205375*^9, 3.495658215328125*^9}, 3.495658252828125*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"OverlapNetwork", "[", 
    RowBox[{"v_", ",", "N_"}], "]"}], ":=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"SchemeArrow", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"N", ",", "v"}], "}"}], "+", "LL"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"N", ",", 
           RowBox[{"v", "-", "0.5"}]}], "}"}], "+", "UL"}]}], "}"}], "]"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"SchemeArrow", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"N", ",", "v"}], "}"}], "+", "LR"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"N", ",", 
           RowBox[{"v", "-", "1"}]}], "}"}], "+", "UR"}]}], "}"}], "]"}]}], 
    "\[IndentingNewLine]", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"OBMENetwork", "[", 
    RowBox[{"v_", ",", "N_"}], "]"}], ":=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"SchemeArrow", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"N", ",", 
            RowBox[{"v", "+", "0.5"}]}], "}"}], "+", "ML"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"N", "-", "1"}], ",", 
            RowBox[{"v", "+", "0.5"}]}], "}"}], "+", "MR"}]}], "}"}], ",", 
       RowBox[{"Show", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{"N", ">", "0"}], ")"}]}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"SchemeArrow", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"N", ",", 
            RowBox[{"v", "+", "0.5"}]}], "}"}], "+", "LL"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"N", "-", "1"}], ",", "v"}], "}"}], "+", "UR"}]}], "}"}], 
       ",", 
       RowBox[{"Show", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{"N", ">", "0"}], ")"}]}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"SchemeArrow", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"N", ",", 
            RowBox[{"v", "+", "0.5"}]}], "}"}], "+", "LC"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"N", ",", "v"}], "}"}], "+", "UC"}]}], "}"}], ",", 
       RowBox[{"Show", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{"v", ">", "0"}], ")"}]}]}], "]"}]}], "\[IndentingNewLine]", 
    "}"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484771232625*^9, 3.484771261671875*^9}, {
   3.484771425734375*^9, 3.4847714690625*^9}, {3.484771529109375*^9, 
   3.484771539234375*^9}, {3.484772151875*^9, 3.48477217065625*^9}, {
   3.484772547640625*^9, 3.48477256515625*^9}, {3.484772597640625*^9, 
   3.48477261821875*^9}, 3.48477265509375*^9, {3.484774961234375*^9, 
   3.48477499371875*^9}, {3.48477512915625*^9, 3.484775151078125*^9}, {
   3.48477519909375*^9, 3.484775260390625*^9}, {3.48477565565625*^9, 
   3.48477566178125*^9}, 3.48477599353125*^9, {3.484776041734375*^9, 
   3.48477604490625*^9}, {3.4847761121875*^9, 3.48477621546875*^9}, {
   3.4847762741875*^9, 3.484776284796875*^9}, {3.484776994796875*^9, 
   3.48477705896875*^9}, {3.4847771034375*^9, 3.484777106078125*^9}, {
   3.48477713753125*^9, 3.484777156734375*^9}, {3.4847772154375*^9, 
   3.48477721678125*^9}, {3.4847772808125*^9, 3.4847772973125*^9}, {
   3.48477735465625*^9, 3.48477740865625*^9}, {3.4847775466875*^9, 
   3.484777585640625*^9}, {3.4848359379375*^9, 3.48483596296875*^9}, {
   3.48571588434375*^9, 3.485715906625*^9}, {3.48667959440625*^9, 
   3.486679657453125*^9}, {3.495657942875*^9, 3.495657975109375*^9}, {
   3.495658023*^9, 3.495658033546875*^9}, 3.49565816896875*^9, 
   3.495658217890625*^9}],

Cell["Diagram components: Labels", "Text",
 CellChangeTimes->{{3.495658156828125*^9, 3.495658161546875*^9}, {
   3.495658205375*^9, 3.49565822215625*^9}, 3.495658252859375*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"OverlapLabel", "[", "v_", "]"}], ":=", 
   RowBox[{"ManualLabel", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "0.5"}], ",", "v"}], "}"}], ",", 
     RowBox[{"Subsuperscript", "[", 
      RowBox[{
       RowBox[{"textit", "[", "\"\<O\>\"", "]"}], ",", 
       RowBox[{"textit", "[", "\"\<N\>\"", "]"}], ",", 
       RowBox[{"Row", "[", 
        RowBox[{"{", 
         RowBox[{"\"\<(\>\"", ",", "v", ",", "\"\<)\>\""}], "}"}], "]"}]}], 
      "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"OBMELabel", "[", "v_", "]"}], ":=", 
   RowBox[{"ManualLabel", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "0.5"}], ",", 
       RowBox[{"v", "+", "0.5"}]}], "}"}], ",", 
     RowBox[{"Subsuperscript", "[", 
      RowBox[{
       RowBox[{"textit", "[", "\"\<T\>\"", "]"}], ",", 
       RowBox[{"textit", "[", "\"\<N\>\"", "]"}], ",", 
       RowBox[{"Row", "[", 
        RowBox[{"{", 
         RowBox[{"\"\<(\>\"", ",", "v", ",", "\"\<)\>\""}], "}"}], "]"}]}], 
      "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"OverlapRecur", "[", "v_", "]"}], ":=", 
   RowBox[{"ManualLabel", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"NMax", "+", "0.5"}], ",", 
       RowBox[{"v", "-", "0.25"}]}], "}"}], ",", 
     RowBox[{"Row", "[", 
      RowBox[{"{", 
       RowBox[{"\"\<(\>\"", ",", 
        RowBox[{"OverlapEquations", "[", 
         RowBox[{"[", 
          RowBox[{"v", "+", "1"}], "]"}], "]"}], ",", "\"\<)\>\""}], "}"}], 
      "]"}], ",", 
     RowBox[{"Show", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{"v", ">", "0"}], ")"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"OBMERecur", "[", "v_", "]"}], ":=", 
   RowBox[{"ManualLabel", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"NMax", "+", "0.5"}], ",", 
       RowBox[{"v", "+", "0.5", "-", "0.25"}]}], "}"}], ",", 
     RowBox[{"Row", "[", 
      RowBox[{"{", 
       RowBox[{"\"\<(\>\"", ",", 
        RowBox[{"OBMEEquations", "[", 
         RowBox[{"[", 
          RowBox[{"v", "+", "1"}], "]"}], "]"}], ",", "\"\<)\>\""}], "}"}], 
      "]"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"OverlapEquations", "=", 
   RowBox[{
    RowBox[{"{", "None", "}"}], "~", "Join", "~", 
    RowBox[{"Range", "[", 
     RowBox[{"54", ",", 
      RowBox[{"54", "+", "3"}]}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"OBMEEquations", "=", 
   RowBox[{"Range", "[", 
    RowBox[{"47", ",", 
     RowBox[{"47", "+", "4"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484771232625*^9, 3.484771261671875*^9}, {
   3.484771425734375*^9, 3.4847714690625*^9}, {3.484771529109375*^9, 
   3.484771539234375*^9}, {3.484772151875*^9, 3.48477217065625*^9}, {
   3.484772547640625*^9, 3.48477256515625*^9}, {3.484772597640625*^9, 
   3.48477261821875*^9}, 3.48477265509375*^9, {3.484774961234375*^9, 
   3.48477499371875*^9}, {3.48477512915625*^9, 3.484775151078125*^9}, {
   3.48477519909375*^9, 3.484775260390625*^9}, {3.48477565565625*^9, 
   3.48477566178125*^9}, 3.48477599353125*^9, {3.484776041734375*^9, 
   3.48477604490625*^9}, {3.4847761121875*^9, 3.48477621546875*^9}, {
   3.4847762741875*^9, 3.484776284796875*^9}, {3.484776994796875*^9, 
   3.48477705896875*^9}, {3.4847771034375*^9, 3.484777106078125*^9}, {
   3.48477713753125*^9, 3.484777156734375*^9}, {3.4847772154375*^9, 
   3.48477721678125*^9}, {3.4847772808125*^9, 3.4847772973125*^9}, {
   3.48477735465625*^9, 3.48477740865625*^9}, {3.4847775466875*^9, 
   3.484777585640625*^9}, {3.4848359379375*^9, 3.48483596296875*^9}, {
   3.48571588434375*^9, 3.485715906625*^9}, {3.48667959440625*^9, 
   3.486679657453125*^9}, {3.495657942875*^9, 3.495657975109375*^9}, {
   3.495658023*^9, 3.495658033546875*^9}, 3.49565816896875*^9, 
   3.495658217890625*^9}],

Cell["Draw figure", "Text",
 CellChangeTimes->{{3.4956583750625*^9, 3.495658473125*^9}, {
  3.4956586949375*^9, 3.495658695234375*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Figure", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"SetOptions", "[", 
       RowBox[{"SchemeArrow", ",", 
        RowBox[{"HeadLip", "\[Rule]", "2"}], ",", 
        RowBox[{"HeadLength", "\[Rule]", "2"}]}], "]"}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"define", " ", "network", " ", "size"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"vMax", "=", "4"}], ";", "\[IndentingNewLine]", 
       RowBox[{"NMax", "=", "4"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"define", " ", "dot", " ", "dimensions"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"DotRadius", "=", 
        RowBox[{"ConvertCoordinate", "[", 
         RowBox[{"AbsoluteCoords", ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2"}], "}"}], ",", "D"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"DotScale", "=", "1.5"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"UR", "=", 
        RowBox[{"DotScale", "*", "DotRadius", "*", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"UC", "=", 
        RowBox[{"DotScale", "*", "DotRadius", "*", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"UL", "=", 
        RowBox[{"DotScale", "*", "DotRadius", "*", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "1"}], "}"}]}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"ML", "=", 
        RowBox[{
         RowBox[{"Sqrt", "[", "2", "]"}], "*", "DotScale", "*", "DotRadius", 
         "*", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "0"}], "}"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"MR", "=", 
        RowBox[{
         RowBox[{"Sqrt", "[", "2", "]"}], "*", "DotScale", "*", "DotRadius", 
         "*", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"+", "1"}], ",", "0"}], "}"}]}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"LR", "=", 
        RowBox[{"DotScale", "*", "DotRadius", "*", 
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"LC", "=", 
        RowBox[{"DotScale", "*", "DotRadius", "*", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"LL", "=", 
        RowBox[{"DotScale", "*", "DotRadius", "*", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", 
           RowBox[{"-", "1"}]}], "}"}]}]}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", "axes", " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"SchemeAxis", "[", 
        RowBox[{"Left", ",", 
         RowBox[{"-", "1"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"vMax", "+", "0.5"}]}], "}"}], ",", 
         RowBox[{"LabL", "\[Rule]", "RoundedV"}]}], "]"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"SchemeAxis", "[", 
       RowBox[{"Bottom", ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "NMax"}], "}"}], ",", 
        RowBox[{"-", "0.3"}], ",", 
        RowBox[{"LabB", "\[Rule]", 
         RowBox[{"textit", "[", "\"\<N\>\"", "]"}]}], ",", 
        RowBox[{"Ticks", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "\"\<0\>\""}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "\"\<1\>\""}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "\"\<2\>\""}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"3", ",", "\"\<\[CenterEllipsis]\>\"", ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "0"}], "}"}]}], "}"}]}], "}"}]}], ",", 
        RowBox[{"PosnB", "\[Rule]", "1"}], ",", 
        RowBox[{"OffsetB", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "1"}], "}"}]}], ",", 
        RowBox[{"BufferB", "\[Rule]", "0"}]}], "]"}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"side", " ", "labels"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"OverlapLabel", "[", "v", "]"}], ",", 
          RowBox[{"OBMELabel", "[", "v", "]"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"v", ",", "0", ",", "vMax"}], "}"}]}], "\[IndentingNewLine]",
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"SchemeIfDef", "[", "\[IndentingNewLine]", 
       RowBox[{"\"\<EqnNumber\>\"", ",", "\[IndentingNewLine]", 
        RowBox[{"Table", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"OverlapRecur", "[", "v", "]"}], ",", 
            RowBox[{"OBMERecur", "[", "v", "]"}]}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"v", ",", "0", ",", "vMax"}], "}"}]}], 
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"top", " ", "labels"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"UpEllipsis", "[", 
         RowBox[{"vMax", ",", "N"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"N", ",", "0", ",", "NMax"}], "}"}]}], "\[IndentingNewLine]",
        "]"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{"DEBUGGING", ":", " ", 
         RowBox[{"on", " ", "network", " ", "arrows"}]}], ",", " ", 
        RowBox[{
        "use", " ", "dummy", " ", "index", " ", "names", " ", "different", 
         " ", "from", " ", 
         RowBox[{"(", 
          RowBox[{"N", ",", "v"}], ")"}]}], ",", " ", 
        RowBox[{
        "to", " ", "prevent", " ", "bizarre", " ", "errors", " ", "when", " ",
          "function", " ", "definition", " ", "dummy", " ", "index", " ", 
         "has", " ", "same", " ", "name", " ", "as", " ", "loop", " ", 
         "dummy", " ", "index"}]}], " ", "*)"}], "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"nodes", " ", "and", " ", "arrows"}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"BlockSchemeOptions", "[", "\[IndentingNewLine]", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"SetOptions", "[", 
          RowBox[{"SchemeObject", ",", 
           RowBox[{"Color", "\[Rule]", 
            RowBox[{"SchemeIfElseDef", "[", 
             RowBox[{"\"\<Color\>\"", ",", "Blue", ",", "Black"}], "]"}]}]}], 
          "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"OverlapDot", "[", 
            RowBox[{"v", ",", "N"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"N", ",", "0", ",", "NMax"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"v", ",", "0", ",", "vMax"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"OverlapNetwork", "[", 
            RowBox[{"vx", ",", "Nx"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"Nx", ",", "0", ",", "NMax"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"vx", ",", "1", ",", "vMax"}], "}"}]}], "]"}]}], 
        "\[IndentingNewLine]", "}"}], "\[IndentingNewLine]", "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"BlockSchemeOptions", "[", "\[IndentingNewLine]", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"SetOptions", "[", 
          RowBox[{"SchemeObject", ",", 
           RowBox[{"Color", "->", 
            RowBox[{"SchemeIfElseDef", "[", 
             RowBox[{"\"\<Color\>\"", ",", "Red", ",", "Gray"}], "]"}]}]}], 
          "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"OBMEDot", "[", 
            RowBox[{"v", ",", "N"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"N", ",", "0", ",", "NMax"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"v", ",", "0", ",", "vMax"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"OBMENetwork", "[", 
            RowBox[{"vx", ",", "Nx"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"Nx", ",", "0", ",", "NMax"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"vx", ",", "0", ",", "vMax"}], "}"}]}], "]"}]}], 
        "\[IndentingNewLine]", "}"}], "\[IndentingNewLine]", "]"}], ","}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "2"}], ",", "6"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "2"}], ",", "6"}], "}"}]}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"ImageSize", "\[Rule]", 
     RowBox[{"72", "*", 
      RowBox[{"{", 
       RowBox[{"6", ",", "6"}], "}"}]}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"SchemeFlags", "\[Rule]", 
     RowBox[{"{", "\"\<Color\>\"", "}"}]}]}], "\[IndentingNewLine]", "]"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "clear", " ", "some", " ", "variable", " ", "names", " ", "used", " ", 
    "in", " ", "example", " ", "below"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"DotScale", ",", "DotRadius"}], "]"}], " "}]}], "Input",
 CellChangeTimes->{{3.40243520075*^9, 3.40243524146875*^9}, {
   3.402435289734375*^9, 3.402435537453125*^9}, {3.402435570578125*^9, 
   3.402435759390625*^9}, {3.40243588296875*^9, 3.40243591275*^9}, {
   3.40829301315625*^9, 3.40829302334375*^9}, {3.484769285328125*^9, 
   3.4847692855*^9}, {3.484769903984375*^9, 3.484769938453125*^9}, {
   3.4847700048125*^9, 3.4847700455*^9}, {3.484771194703125*^9, 
   3.484771227484375*^9}, {3.4847714413125*^9, 3.484771513515625*^9}, {
   3.484771633453125*^9, 3.48477178225*^9}, {3.484771866109375*^9, 
   3.4847718805*^9}, {3.484772231546875*^9, 3.48477238303125*^9}, {
   3.484772658921875*^9, 3.484772676859375*^9}, 3.484774066359375*^9, {
   3.484774270578125*^9, 3.4847743265625*^9}, {3.484774849375*^9, 
   3.484774898921875*^9}, {3.4847750326875*^9, 3.484775081484375*^9}, {
   3.484775157390625*^9, 3.484775169921875*^9}, {3.48477527925*^9, 
   3.484775312171875*^9}, {3.48477537065625*^9, 3.484775513515625*^9}, {
   3.484775549015625*^9, 3.4847755871875*^9}, {3.48477567359375*^9, 
   3.4847756765*^9}, {3.484775718640625*^9, 3.484775744859375*^9}, {
   3.484775853640625*^9, 3.484776009796875*^9}, {3.484776078390625*^9, 
   3.4847761035625*^9}, {3.484776224828125*^9, 3.48477625071875*^9}, {
   3.48477629371875*^9, 3.48477630890625*^9}, {3.484776362375*^9, 
   3.48477650171875*^9}, {3.484776578984375*^9, 3.48477662178125*^9}, {
   3.484776668734375*^9, 3.484776762984375*^9}, 3.484776795609375*^9, {
   3.484777071578125*^9, 3.48477708240625*^9}, {3.4847773299375*^9, 
   3.48477734821875*^9}, {3.484777601546875*^9, 3.484777630703125*^9}, {
   3.484777704984375*^9, 3.4847777088125*^9}, {3.48477773884375*^9, 
   3.484777835203125*^9}, {3.484777886109375*^9, 3.484777923203125*^9}, {
   3.484778119703125*^9, 3.484778169921875*^9}, {3.484835987953125*^9, 
   3.484836023578125*^9}, {3.484836122359375*^9, 3.484836154734375*^9}, {
   3.484836191578125*^9, 3.484836257078125*^9}, 3.485715930328125*^9, {
   3.485821326265625*^9, 3.485821348671875*^9}, {3.48701129153125*^9, 
   3.487011312296875*^9}, {3.489427811796875*^9, 3.4894278501875*^9}, 
   3.4894279020625*^9, {3.49565794325*^9, 3.49565795540625*^9}, 
   3.495658083171875*^9, {3.4956581160625*^9, 3.4956581174375*^9}, {
   3.495658276609375*^9, 3.495658348703125*^9}, {3.495658721703125*^9, 
   3.49565872234375*^9}, {3.50751313375*^9, 3.507513174953125*^9}}],

Cell[BoxData[
 GraphicsBox[{
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-1., 0.}, {-1., 4.5}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-1.0555666666666665`, 4.388866666666667}, {-1., 
     4.5}, {-0.9444333333333335, 4.388866666666667}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0., -0.3}, {4., -0.3}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{3.888866666666667, -0.24443333333333328`}, {
     4., -0.2999999999999998}, {3.888866666666667, -0.3555666666666666}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], {LineBox[{{0., -0.239988}, {0., -0.3}}], 
     LineBox[{{1., -0.239988}, {1., -0.3}}], 
     LineBox[{{2., -0.239988}, {2., -0.3}}]}, 
    {RGBColor[0, 0, 1], Opacity[1], 
     DiskBox[{0., 0.}, 0.03704444444444444, 
      NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
    {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
     CapForm[None], 
     CircleBox[{0., 0.}, 0.05556666666666667, 
      NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
     {RGBColor[0, 0, 1], Opacity[1], 
      DiskBox[{0., 1.}, 0.03704444444444444, 
       NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
     {RGBColor[0, 0, 1], Opacity[1], 
      DiskBox[{0., 2.}, 0.03704444444444444, 
       NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
     {RGBColor[0, 0, 1], Opacity[1], 
      DiskBox[{0., 3.}, 0.03704444444444444, 
       NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
     {RGBColor[0, 0, 1], Opacity[1], 
      DiskBox[{0., 4.}, 0.03704444444444444, 
       NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
     {RGBColor[0, 0, 1], Opacity[1], 
      DiskBox[{1., 0.}, 0.03704444444444444, 
       NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
     {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
      CapForm[None], 
      CircleBox[{1., 0.}, 0.05556666666666667, 
       NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
      {RGBColor[0, 0, 1], Opacity[1], 
       DiskBox[{1., 1.}, 0.03704444444444444, 
        NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
      {RGBColor[0, 0, 1], Opacity[1], 
       DiskBox[{1., 2.}, 0.03704444444444444, 
        NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
      {RGBColor[0, 0, 1], Opacity[1], 
       DiskBox[{1., 3.}, 0.03704444444444444, 
        NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
      {RGBColor[0, 0, 1], Opacity[1], 
       DiskBox[{1., 4.}, 0.03704444444444444, 
        NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
      {RGBColor[0, 0, 1], Opacity[1], 
       DiskBox[{2., 0.}, 0.03704444444444444, 
        NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
      {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
       CapForm[None], 
       CircleBox[{2., 0.}, 0.05556666666666667, 
        NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
       {RGBColor[0, 0, 1], Opacity[1], 
        DiskBox[{2., 1.}, 0.03704444444444444, 
         NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
       {RGBColor[0, 0, 1], Opacity[1], 
        DiskBox[{2., 2.}, 0.03704444444444444, 
         NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
       {RGBColor[0, 0, 1], Opacity[1], 
        DiskBox[{2., 3.}, 0.03704444444444444, 
         NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
       {RGBColor[0, 0, 1], Opacity[1], 
        DiskBox[{2., 4.}, 0.03704444444444444, 
         NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
       {RGBColor[0, 0, 1], Opacity[1], 
        DiskBox[{3., 0.}, 0.03704444444444444, 
         NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
       {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
        CapForm[None], 
        CircleBox[{3., 0.}, 0.05556666666666667, 
         NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
        {RGBColor[0, 0, 1], Opacity[1], 
         DiskBox[{3., 1.}, 0.03704444444444444, 
          NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
        {RGBColor[0, 0, 1], Opacity[1], 
         DiskBox[{3., 2.}, 0.03704444444444444, 
          NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
        {RGBColor[0, 0, 1], Opacity[1], 
         DiskBox[{3., 3.}, 0.03704444444444444, 
          NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
        {RGBColor[0, 0, 1], Opacity[1], 
         DiskBox[{3., 4.}, 0.03704444444444444, 
          NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
        {RGBColor[0, 0, 1], Opacity[1], 
         DiskBox[{4., 0.}, 0.03704444444444444, 
          NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
         CapForm[None], 
         CircleBox[{4., 0.}, 0.05556666666666667, 
          NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
         {RGBColor[0, 0, 1], Opacity[1], 
          DiskBox[{4., 1.}, 0.03704444444444444, 
           NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
         {RGBColor[0, 0, 1], Opacity[1], 
          DiskBox[{4., 2.}, 0.03704444444444444, 
           NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
         {RGBColor[0, 0, 1], Opacity[1], 
          DiskBox[{4., 3.}, 0.03704444444444444, 
           NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
         {RGBColor[0, 0, 1], Opacity[1], 
          DiskBox[{4., 4.}, 0.03704444444444444, 
           NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{-0.055566666666666764`, 
           0.944433333333333}, {-0.055566666666666764`, 
           0.5555666666666665}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{-0.01852222222222233, 
           0.5926111111111108}, {-0.055566666666666764`, 
           0.5555666666666665}, {-0.0926111111111112, 0.5926111111111108}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{0.05556666666666654, 0.944433333333333}, {
           0.05556666666666654, 0.05556666666666654}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{0.0926111111111112, 0.0926111111111112}, {
           0.05556666666666654, 0.05556666666666654}, {0.01852222222222233, 
           0.0926111111111112}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{-0.055566666666666764`, 
           1.944433333333333}, {-0.055566666666666764`, 
           1.5555666666666665`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{-0.01852222222222233, 
           1.5926111111111108`}, {-0.055566666666666764`, 
           1.5555666666666665`}, {-0.0926111111111112, 
           1.5926111111111108`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{0.05556666666666654, 1.944433333333333}, {
           0.05556666666666654, 1.0555666666666665`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{0.0926111111111112, 1.0926111111111108`}, {
           0.05556666666666654, 1.0555666666666665`}, {0.01852222222222233, 
           1.0926111111111108`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{-0.055566666666666764`, 
           2.9444333333333335`}, {-0.055566666666666764`, 
           2.5555666666666665`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{-0.01852222222222233, 
           2.592611111111111}, {-0.055566666666666764`, 
           2.5555666666666665`}, {-0.0926111111111112, 2.592611111111111}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{0.05556666666666654, 2.9444333333333335`}, {
           0.05556666666666654, 2.0555666666666665`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{0.0926111111111112, 2.092611111111111}, {
           0.05556666666666654, 2.0555666666666665`}, {0.01852222222222233, 
           2.092611111111111}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{-0.055566666666666764`, 
           3.9444333333333335`}, {-0.055566666666666764`, 
           3.5555666666666665`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{-0.01852222222222233, 
           3.592611111111111}, {-0.055566666666666764`, 
           3.5555666666666665`}, {-0.0926111111111112, 3.592611111111111}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{0.05556666666666654, 3.9444333333333335`}, {
           0.05556666666666654, 3.0555666666666665`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{0.0926111111111112, 3.092611111111111}, {
           0.05556666666666654, 3.0555666666666665`}, {0.01852222222222233, 
           3.092611111111111}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{0.944433333333333, 0.944433333333333}, {0.944433333333333,
            0.5555666666666665}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{0.9814777777777777, 0.5926111111111108}, {
           0.944433333333333, 0.5555666666666665}, {0.9073888888888888, 
           0.5926111111111108}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{1.0555666666666665`, 0.944433333333333}, {
           1.0555666666666665`, 0.05556666666666654}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{1.0926111111111108`, 0.0926111111111112}, {
           1.0555666666666665`, 0.05556666666666654}, {1.0185222222222219`, 
           0.0926111111111112}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{0.944433333333333, 1.944433333333333}, {0.944433333333333,
            1.5555666666666665`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{0.9814777777777777, 1.5926111111111108`}, {
           0.944433333333333, 1.5555666666666665`}, {0.9073888888888888, 
           1.5926111111111108`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{1.0555666666666665`, 1.944433333333333}, {
           1.0555666666666665`, 1.0555666666666665`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{1.0926111111111108`, 1.0926111111111108`}, {
           1.0555666666666665`, 1.0555666666666665`}, {1.0185222222222219`, 
           1.0926111111111108`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{0.944433333333333, 2.9444333333333335`}, {
           0.944433333333333, 2.5555666666666665`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{0.9814777777777777, 2.592611111111111}, {
           0.944433333333333, 2.5555666666666665`}, {0.9073888888888888, 
           2.592611111111111}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{1.0555666666666665`, 2.9444333333333335`}, {
           1.0555666666666665`, 2.0555666666666665`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{1.0926111111111108`, 2.092611111111111}, {
           1.0555666666666665`, 2.0555666666666665`}, {1.0185222222222219`, 
           2.092611111111111}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{0.944433333333333, 3.9444333333333335`}, {
           0.944433333333333, 3.5555666666666665`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{0.9814777777777777, 3.592611111111111}, {
           0.944433333333333, 3.5555666666666665`}, {0.9073888888888888, 
           3.592611111111111}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{1.0555666666666665`, 3.9444333333333335`}, {
           1.0555666666666665`, 3.0555666666666665`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{1.0926111111111108`, 3.092611111111111}, {
           1.0555666666666665`, 3.0555666666666665`}, {1.0185222222222219`, 
           3.092611111111111}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{1.944433333333333, 0.944433333333333}, {1.944433333333333,
            0.5555666666666665}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{1.9814777777777777`, 0.5926111111111108}, {
           1.944433333333333, 0.5555666666666665}, {1.9073888888888888`, 
           0.5926111111111108}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{2.0555666666666665`, 0.944433333333333}, {
           2.0555666666666665`, 0.05556666666666654}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{2.092611111111111, 0.0926111111111112}, {
           2.0555666666666665`, 0.05556666666666654}, {2.018522222222222, 
           0.0926111111111112}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{1.944433333333333, 1.944433333333333}, {1.944433333333333,
            1.5555666666666665`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{1.9814777777777777`, 1.5926111111111108`}, {
           1.944433333333333, 1.5555666666666665`}, {1.9073888888888888`, 
           1.5926111111111108`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{2.0555666666666665`, 1.944433333333333}, {
           2.0555666666666665`, 1.0555666666666665`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{2.092611111111111, 1.0926111111111108`}, {
           2.0555666666666665`, 1.0555666666666665`}, {2.018522222222222, 
           1.0926111111111108`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{1.944433333333333, 2.9444333333333335`}, {
           1.944433333333333, 2.5555666666666665`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{1.9814777777777777`, 2.592611111111111}, {
           1.944433333333333, 2.5555666666666665`}, {1.9073888888888888`, 
           2.592611111111111}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{2.0555666666666665`, 2.9444333333333335`}, {
           2.0555666666666665`, 2.0555666666666665`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{2.092611111111111, 2.092611111111111}, {
           2.0555666666666665`, 2.0555666666666665`}, {2.018522222222222, 
           2.092611111111111}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{1.944433333333333, 3.9444333333333335`}, {
           1.944433333333333, 3.5555666666666665`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{1.9814777777777777`, 3.592611111111111}, {
           1.944433333333333, 3.5555666666666665`}, {1.9073888888888888`, 
           3.592611111111111}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{2.0555666666666665`, 3.9444333333333335`}, {
           2.0555666666666665`, 3.0555666666666665`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{2.092611111111111, 3.092611111111111}, {
           2.0555666666666665`, 3.0555666666666665`}, {2.018522222222222, 
           3.092611111111111}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{2.9444333333333335`, 0.944433333333333}, {
           2.9444333333333335`, 0.5555666666666665}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{2.981477777777778, 0.5926111111111108}, {
           2.9444333333333335`, 0.5555666666666665}, {2.907388888888889, 
           0.5926111111111108}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{3.0555666666666665`, 0.944433333333333}, {
           3.0555666666666665`, 0.05556666666666654}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{3.092611111111111, 0.0926111111111112}, {
           3.0555666666666665`, 0.05556666666666654}, {3.018522222222222, 
           0.0926111111111112}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{2.9444333333333335`, 1.944433333333333}, {
           2.9444333333333335`, 1.5555666666666665`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{2.981477777777778, 1.5926111111111108`}, {
           2.9444333333333335`, 1.5555666666666665`}, {2.907388888888889, 
           1.5926111111111108`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{3.0555666666666665`, 1.944433333333333}, {
           3.0555666666666665`, 1.0555666666666665`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{3.092611111111111, 1.0926111111111108`}, {
           3.0555666666666665`, 1.0555666666666665`}, {3.018522222222222, 
           1.0926111111111108`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{2.9444333333333335`, 2.9444333333333335`}, {
           2.9444333333333335`, 2.5555666666666665`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{2.981477777777778, 2.592611111111111}, {
           2.9444333333333335`, 2.5555666666666665`}, {2.907388888888889, 
           2.592611111111111}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{3.0555666666666665`, 2.9444333333333335`}, {
           3.0555666666666665`, 2.0555666666666665`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{3.092611111111111, 2.092611111111111}, {
           3.0555666666666665`, 2.0555666666666665`}, {3.018522222222222, 
           2.092611111111111}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{2.9444333333333335`, 3.9444333333333335`}, {
           2.9444333333333335`, 3.5555666666666665`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{2.981477777777778, 3.592611111111111}, {
           2.9444333333333335`, 3.5555666666666665`}, {2.907388888888889, 
           3.592611111111111}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{3.0555666666666665`, 3.9444333333333335`}, {
           3.0555666666666665`, 3.0555666666666665`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{3.092611111111111, 3.092611111111111}, {
           3.0555666666666665`, 3.0555666666666665`}, {3.018522222222222, 
           3.092611111111111}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{3.9444333333333335`, 0.944433333333333}, {
           3.9444333333333335`, 0.5555666666666665}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{3.981477777777778, 0.5926111111111108}, {
           3.9444333333333335`, 0.5555666666666665}, {3.907388888888889, 
           0.5926111111111108}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{4.0555666666666665`, 0.944433333333333}, {
           4.0555666666666665`, 0.05556666666666654}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{4.092611111111111, 0.0926111111111112}, {
           4.0555666666666665`, 0.05556666666666654}, {4.018522222222222, 
           0.0926111111111112}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{3.9444333333333335`, 1.944433333333333}, {
           3.9444333333333335`, 1.5555666666666665`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{3.981477777777778, 1.5926111111111108`}, {
           3.9444333333333335`, 1.5555666666666665`}, {3.907388888888889, 
           1.5926111111111108`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{4.0555666666666665`, 1.944433333333333}, {
           4.0555666666666665`, 1.0555666666666665`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{4.092611111111111, 1.0926111111111108`}, {
           4.0555666666666665`, 1.0555666666666665`}, {4.018522222222222, 
           1.0926111111111108`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{3.9444333333333335`, 2.9444333333333335`}, {
           3.9444333333333335`, 2.5555666666666665`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{3.981477777777778, 2.592611111111111}, {
           3.9444333333333335`, 2.5555666666666665`}, {3.907388888888889, 
           2.592611111111111}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{4.0555666666666665`, 2.9444333333333335`}, {
           4.0555666666666665`, 2.0555666666666665`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{4.092611111111111, 2.092611111111111}, {
           4.0555666666666665`, 2.0555666666666665`}, {4.018522222222222, 
           2.092611111111111}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{3.9444333333333335`, 3.9444333333333335`}, {
           3.9444333333333335`, 3.5555666666666665`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{3.981477777777778, 3.592611111111111}, {
           3.9444333333333335`, 3.5555666666666665`}, {3.907388888888889, 
           3.592611111111111}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{4.0555666666666665`, 3.9444333333333335`}, {
           4.0555666666666665`, 3.0555666666666665`}}]}, 
         {RGBColor[0, 0, 1], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{4.092611111111111, 3.092611111111111}, {
           4.0555666666666665`, 3.0555666666666665`}, {4.018522222222222, 
           3.092611111111111}}], 
          {RGBColor[1, 0, 0], Opacity[1], 
           DiskBox[{0., 0.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {RGBColor[1, 0, 0], Opacity[1], 
           DiskBox[{0., 1.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {RGBColor[1, 0, 0], Opacity[1], 
           DiskBox[{0., 2.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {RGBColor[1, 0, 0], Opacity[1], 
           DiskBox[{0., 3.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {RGBColor[1, 0, 0], Opacity[1], 
           DiskBox[{0., 4.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {RGBColor[1, 0, 0], Opacity[1], 
           DiskBox[{1., 0.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {RGBColor[1, 0, 0], Opacity[1], 
           DiskBox[{1., 1.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {RGBColor[1, 0, 0], Opacity[1], 
           DiskBox[{1., 2.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {RGBColor[1, 0, 0], Opacity[1], 
           DiskBox[{1., 3.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {RGBColor[1, 0, 0], Opacity[1], 
           DiskBox[{1., 4.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {RGBColor[1, 0, 0], Opacity[1], 
           DiskBox[{2., 0.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {RGBColor[1, 0, 0], Opacity[1], 
           DiskBox[{2., 1.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {RGBColor[1, 0, 0], Opacity[1], 
           DiskBox[{2., 2.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {RGBColor[1, 0, 0], Opacity[1], 
           DiskBox[{2., 3.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {RGBColor[1, 0, 0], Opacity[1], 
           DiskBox[{2., 4.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {RGBColor[1, 0, 0], Opacity[1], 
           DiskBox[{3., 0.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {RGBColor[1, 0, 0], Opacity[1], 
           DiskBox[{3., 1.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {RGBColor[1, 0, 0], Opacity[1], 
           DiskBox[{3., 2.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {RGBColor[1, 0, 0], Opacity[1], 
           DiskBox[{3., 3.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {RGBColor[1, 0, 0], Opacity[1], 
           DiskBox[{3., 4.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {RGBColor[1, 0, 0], Opacity[1], 
           DiskBox[{4., 0.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {RGBColor[1, 0, 0], Opacity[1], 
           DiskBox[{4., 1.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {RGBColor[1, 0, 0], Opacity[1], 
           DiskBox[{4., 2.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {RGBColor[1, 0, 0], Opacity[1], 
           DiskBox[{4., 3.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {RGBColor[1, 0, 0], Opacity[1], 
           DiskBox[{4., 4.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0., 1.444433333333333}, {0., 1.0555666666666665`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.03704444444444421, 1.0926111111111108`}, {0., 
            1.0555666666666665`}, {-0.037044444444444435`, 
            1.0926111111111108`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0., 2.4444333333333335`}, {0., 2.0555666666666665`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.03704444444444421, 2.092611111111111}, {0., 
            2.0555666666666665`}, {-0.037044444444444435`, 
            2.092611111111111}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0., 3.4444333333333335`}, {0., 3.0555666666666665`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.03704444444444421, 3.092611111111111}, {0., 
            3.0555666666666665`}, {-0.037044444444444435`, 
            3.092611111111111}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0., 4.4444333333333335`}, {0., 4.0555666666666665`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.03704444444444421, 4.092611111111111}, {0., 
            4.0555666666666665`}, {-0.037044444444444435`, 
            4.092611111111111}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.9214168663841353, 0.49999999999999956`}, {
            0.07858313361586511, 0.49999999999999956`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.11562757806030932`, 0.46295555555555534`}, {
            0.07858313361586511, 0.49999999999999956`}, {0.11562757806030932`,
             0.5370444444444442}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.944433333333333, 0.444433333333333}, {
            0.055566666666666986`, 0.05556666666666654}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.10435309185110819`, 0.03647566234216937}, {
            0.055566666666666986`, 0.05556666666666654}, {0.07465767099116372,
             0.10435309185110775`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.9214168663841353, 1.5}, {0.07858313361586511, 1.5}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.11562757806030932`, 1.4629555555555553`}, {
            0.07858313361586511, 1.5}, {0.11562757806030932`, 
            1.5370444444444442`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.944433333333333, 1.444433333333333}, {
            0.05556666666666654, 1.0555666666666665`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.10435309185110775`, 1.0364756623421694`}, {
            0.05556666666666654, 1.0555666666666665`}, {0.07465767099116372, 
            1.1043530918511077`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.9999999999999996, 1.444433333333333}, {
            0.9999999999999996, 1.0555666666666665`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.0370444444444442`, 1.0926111111111108`}, {
            0.9999999999999996, 1.0555666666666665`}, {0.9629555555555553, 
            1.0926111111111108`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.9214168663841353, 2.5}, {0.07858313361586511, 2.5}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.11562757806030932`, 2.4629555555555553`}, {
            0.07858313361586511, 2.5}, {0.11562757806030932`, 
            2.5370444444444447`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.944433333333333, 2.4444333333333335`}, {
            0.05556666666666654, 2.0555666666666665`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.10435309185110775`, 2.036475662342169}, {
            0.05556666666666654, 2.0555666666666665`}, {0.07465767099116372, 
            2.1043530918511077`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.9999999999999996, 2.4444333333333335`}, {
            0.9999999999999996, 2.0555666666666665`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.0370444444444442`, 2.092611111111111}, {
            0.9999999999999996, 2.0555666666666665`}, {0.9629555555555553, 
            2.092611111111111}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.9214168663841353, 3.5}, {0.07858313361586511, 3.5}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.11562757806030932`, 3.4629555555555553`}, {
            0.07858313361586511, 3.5}, {0.11562757806030932`, 
            3.5370444444444447`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.944433333333333, 3.4444333333333335`}, {
            0.05556666666666654, 3.0555666666666665`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.10435309185110775`, 3.03647566234217}, {
            0.05556666666666654, 3.0555666666666665`}, {0.07465767099116372, 
            3.1043530918511086`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.9999999999999996, 3.4444333333333335`}, {
            0.9999999999999996, 3.0555666666666665`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.0370444444444442`, 3.092611111111111}, {
            0.9999999999999996, 3.0555666666666665`}, {0.9629555555555553, 
            3.092611111111111}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.9214168663841353, 4.5}, {0.07858313361586511, 4.5}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.11562757806030932`, 4.462955555555555}, {
            0.07858313361586511, 4.5}, {0.11562757806030932`, 
            4.537044444444445}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.944433333333333, 4.4444333333333335`}, {
            0.05556666666666654, 4.0555666666666665`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.10435309185110775`, 4.03647566234217}, {
            0.05556666666666654, 4.0555666666666665`}, {0.07465767099116372, 
            4.104353091851109}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.9999999999999996, 4.4444333333333335`}, {
            0.9999999999999996, 4.0555666666666665`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.0370444444444442`, 4.092611111111111}, {
            0.9999999999999996, 4.0555666666666665`}, {0.9629555555555553, 
            4.092611111111111}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.9214168663841353`, 0.49999999999999956`}, {
            1.0785831336158647`, 0.49999999999999956`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.1156275780603093`, 0.46295555555555534`}, {
            1.0785831336158647`, 0.49999999999999956`}, {1.1156275780603093`, 
            0.5370444444444442}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.944433333333333, 0.444433333333333}, {
            1.0555666666666665`, 0.055566666666666986`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.1043530918511077`, 0.03647566234216981}, {
            1.0555666666666665`, 0.055566666666666986`}, {1.0746576709911637`,
             0.10435309185110819`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.9214168663841353`, 1.5}, {1.0785831336158647`, 1.5}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.1156275780603093`, 1.4629555555555553`}, {
            1.0785831336158647`, 1.5}, {1.1156275780603093`, 
            1.5370444444444442`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.944433333333333, 1.444433333333333}, {
            1.0555666666666665`, 1.0555666666666665`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.1043530918511077`, 1.0364756623421694`}, {
            1.0555666666666665`, 1.0555666666666665`}, {1.0746576709911637`, 
            1.1043530918511077`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2., 1.444433333333333}, {2., 1.0555666666666665`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.0370444444444447`, 1.0926111111111108`}, {2., 
            1.0555666666666665`}, {1.9629555555555553`, 
            1.0926111111111108`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.9214168663841353`, 2.5}, {1.0785831336158647`, 2.5}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.1156275780603093`, 2.4629555555555553`}, {
            1.0785831336158647`, 2.5}, {1.1156275780603093`, 
            2.5370444444444447`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.944433333333333, 2.4444333333333335`}, {
            1.0555666666666665`, 2.0555666666666665`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.1043530918511077`, 2.036475662342169}, {
            1.0555666666666665`, 2.0555666666666665`}, {1.0746576709911637`, 
            2.1043530918511077`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2., 2.4444333333333335`}, {2., 2.0555666666666665`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.0370444444444447`, 2.092611111111111}, {2., 
            2.0555666666666665`}, {1.9629555555555553`, 2.092611111111111}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.9214168663841353`, 3.5}, {1.0785831336158647`, 3.5}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.1156275780603093`, 3.4629555555555553`}, {
            1.0785831336158647`, 3.5}, {1.1156275780603093`, 
            3.5370444444444447`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.944433333333333, 3.4444333333333335`}, {
            1.0555666666666665`, 3.0555666666666665`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.1043530918511077`, 3.03647566234217}, {
            1.0555666666666665`, 3.0555666666666665`}, {1.0746576709911637`, 
            3.1043530918511086`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2., 3.4444333333333335`}, {2., 3.0555666666666665`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.0370444444444447`, 3.092611111111111}, {2., 
            3.0555666666666665`}, {1.9629555555555553`, 3.092611111111111}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.9214168663841353`, 4.5}, {1.0785831336158647`, 4.5}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.1156275780603093`, 4.462955555555555}, {
            1.0785831336158647`, 4.5}, {1.1156275780603093`, 
            4.537044444444445}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.944433333333333, 4.4444333333333335`}, {
            1.0555666666666665`, 4.0555666666666665`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.1043530918511077`, 4.03647566234217}, {
            1.0555666666666665`, 4.0555666666666665`}, {1.0746576709911637`, 
            4.104353091851109}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2., 4.4444333333333335`}, {2., 4.0555666666666665`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.0370444444444447`, 4.092611111111111}, {2., 
            4.0555666666666665`}, {1.9629555555555553`, 4.092611111111111}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.921416866384134, 0.49999999999999956`}, {
            2.078583133615865, 0.49999999999999956`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.1156275780603098`, 0.46295555555555534`}, {
            2.078583133615865, 0.49999999999999956`}, {2.1156275780603098`, 
            0.5370444444444442}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.9444333333333335`, 0.444433333333333}, {
            2.0555666666666665`, 0.055566666666666986`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.1043530918511077`, 0.03647566234216981}, {
            2.0555666666666665`, 0.055566666666666986`}, {2.074657670991164, 
            0.10435309185110819`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.921416866384134, 1.5}, {2.078583133615865, 1.5}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.1156275780603098`, 1.4629555555555553`}, {
            2.078583133615865, 1.5}, {2.1156275780603098`, 
            1.5370444444444442`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.9444333333333335`, 1.444433333333333}, {
            2.0555666666666665`, 1.0555666666666665`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.1043530918511077`, 1.0364756623421694`}, {
            2.0555666666666665`, 1.0555666666666665`}, {2.074657670991164, 
            1.1043530918511077`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3., 1.444433333333333}, {3., 1.0555666666666665`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.0370444444444447`, 1.0926111111111108`}, {3., 
            1.0555666666666665`}, {2.9629555555555553`, 
            1.0926111111111108`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.921416866384134, 2.5}, {2.078583133615865, 2.5}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.1156275780603098`, 2.4629555555555553`}, {
            2.078583133615865, 2.5}, {2.1156275780603098`, 
            2.5370444444444447`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.9444333333333335`, 2.4444333333333335`}, {
            2.0555666666666665`, 2.0555666666666665`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.1043530918511077`, 2.036475662342169}, {
            2.0555666666666665`, 2.0555666666666665`}, {2.074657670991164, 
            2.1043530918511077`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3., 2.4444333333333335`}, {3., 2.0555666666666665`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.0370444444444447`, 2.092611111111111}, {3., 
            2.0555666666666665`}, {2.9629555555555553`, 2.092611111111111}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.921416866384134, 3.5}, {2.078583133615865, 3.5}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.1156275780603098`, 3.4629555555555553`}, {
            2.078583133615865, 3.5}, {2.1156275780603098`, 
            3.5370444444444447`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.9444333333333335`, 3.4444333333333335`}, {
            2.0555666666666665`, 3.0555666666666665`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.1043530918511077`, 3.03647566234217}, {
            2.0555666666666665`, 3.0555666666666665`}, {2.074657670991164, 
            3.1043530918511086`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3., 3.4444333333333335`}, {3., 3.0555666666666665`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.0370444444444447`, 3.092611111111111}, {3., 
            3.0555666666666665`}, {2.9629555555555553`, 3.092611111111111}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.921416866384134, 4.5}, {2.078583133615865, 4.5}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.1156275780603098`, 4.462955555555555}, {
            2.078583133615865, 4.5}, {2.1156275780603098`, 
            4.537044444444445}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.9444333333333335`, 4.4444333333333335`}, {
            2.0555666666666665`, 4.0555666666666665`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.1043530918511077`, 4.03647566234217}, {
            2.0555666666666665`, 4.0555666666666665`}, {2.074657670991164, 
            4.104353091851109}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3., 4.4444333333333335`}, {3., 4.0555666666666665`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.0370444444444447`, 4.092611111111111}, {3., 
            4.0555666666666665`}, {2.9629555555555553`, 4.092611111111111}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.921416866384134, 0.49999999999999956`}, {
            3.078583133615864, 0.49999999999999956`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.115627578060309, 0.46295555555555534`}, {
            3.078583133615864, 0.49999999999999956`}, {3.115627578060309, 
            0.5370444444444442}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.9444333333333335`, 0.444433333333333}, {
            3.0555666666666665`, 0.055566666666666986`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.1043530918511086`, 0.03647566234216981}, {
            3.0555666666666665`, 0.055566666666666986`}, {3.0746576709911633`,
             0.10435309185110819`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.921416866384134, 1.5}, {3.078583133615864, 1.5}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.115627578060309, 1.4629555555555553`}, {
            3.078583133615864, 1.5}, {3.115627578060309, 
            1.5370444444444442`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.9444333333333335`, 1.444433333333333}, {
            3.0555666666666665`, 1.0555666666666665`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.1043530918511086`, 1.0364756623421694`}, {
            3.0555666666666665`, 1.0555666666666665`}, {3.0746576709911633`, 
            1.1043530918511077`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{4., 1.444433333333333}, {4., 1.0555666666666665`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{4.037044444444445, 1.0926111111111108`}, {4., 
            1.0555666666666665`}, {3.9629555555555553`, 
            1.0926111111111108`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.921416866384134, 2.5}, {3.078583133615864, 2.5}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.115627578060309, 2.4629555555555553`}, {
            3.078583133615864, 2.5}, {3.115627578060309, 
            2.5370444444444447`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.9444333333333335`, 2.4444333333333335`}, {
            3.0555666666666665`, 2.0555666666666665`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.1043530918511086`, 2.036475662342169}, {
            3.0555666666666665`, 2.0555666666666665`}, {3.0746576709911633`, 
            2.1043530918511077`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{4., 2.4444333333333335`}, {4., 2.0555666666666665`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{4.037044444444445, 2.092611111111111}, {4., 
            2.0555666666666665`}, {3.9629555555555553`, 2.092611111111111}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.921416866384134, 3.5}, {3.078583133615864, 3.5}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.115627578060309, 3.4629555555555553`}, {
            3.078583133615864, 3.5}, {3.115627578060309, 
            3.5370444444444447`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.9444333333333335`, 3.4444333333333335`}, {
            3.0555666666666665`, 3.0555666666666665`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.1043530918511086`, 3.03647566234217}, {
            3.0555666666666665`, 3.0555666666666665`}, {3.0746576709911633`, 
            3.1043530918511086`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{4., 3.4444333333333335`}, {4., 3.0555666666666665`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{4.037044444444445, 3.092611111111111}, {4., 
            3.0555666666666665`}, {3.9629555555555553`, 3.092611111111111}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.921416866384134, 4.5}, {3.078583133615864, 4.5}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.115627578060309, 4.462955555555555}, {
            3.078583133615864, 4.5}, {3.115627578060309, 
            4.537044444444445}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.9444333333333335`, 4.4444333333333335`}, {
            3.0555666666666665`, 4.0555666666666665`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.1043530918511086`, 4.03647566234217}, {
            3.0555666666666665`, 4.0555666666666665`}, {3.0746576709911633`, 
            4.104353091851109}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{4., 4.4444333333333335`}, {4., 4.0555666666666665`}}]}, 
          {RGBColor[1, 0, 0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{4.037044444444445, 4.092611111111111}, {4., 
            4.0555666666666665`}, {3.9629555555555553`, 4.092611111111111}}], 
           InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               StyleBox["\<\"v\"\>",
                StripOnInput->False,
                FontFamily->"BookAntiqua",
                FontSlant->Italic],
               DisplayForm],
              StripOnInput->False,
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {-1.1315077777777778`, 2.25}, {0, 0}, Automatic, {
            0, 1}], InsetBox[
            TagBox[
             StyleBox[
              TagBox["\<\"0\"\>",
               DisplayForm],
              StripOnInput->False,
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {0., -0.3092611111111111}, {0, 1}, Automatic, {1, 
            0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox["\<\"1\"\>",
               DisplayForm],
              StripOnInput->False,
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {1., -0.3092611111111111}, {0, 1}, Automatic, {1, 
            0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox["\<\"2\"\>",
               DisplayForm],
              StripOnInput->False,
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {2., -0.3092611111111111}, {0, 1}, Automatic, {1, 
            0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox["\<\"\[CenterEllipsis]\"\>",
               DisplayForm],
              StripOnInput->False,
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {3., -0.3092611111111111}, {0, 1}, Automatic, {1, 
            0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               TagBox[
                StyleBox["\<\"N\"\>",
                 FontSlant->"Italic"],
                StyleForm[#, FontSlant -> "Italic"]& ],
               DisplayForm],
              StripOnInput->False,
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {4., -0.309261111111111}, {-1, 1}, Automatic, {1, 
            0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               InterpretationBox[
                SubsuperscriptBox[
                 TagBox[
                  StyleBox["\<\"O\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TagBox[
                  StyleBox["\<\"N\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TemplateBox[{"\"(\"","0","\")\""},
                  "Row",
                  
                  DisplayFunction->(
                   RowBox[{#, "\[InvisibleSpace]", #2, 
                    "\[InvisibleSpace]", #3}]& ),
                  InterpretationFunction->(RowBox[{"Row", "[", 
                    RowBox[{"{", 
                    RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )]],
                Subsuperscript[
                 StyleForm["O", FontSlant -> "Italic"], 
                 StyleForm["N", FontSlant -> "Italic"], 
                 Row[{"(", 0, ")"}]],
                Editable->False],
               DisplayForm],
              StripOnInput->False,
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {-0.5, 0.}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               InterpretationBox[
                SubsuperscriptBox[
                 TagBox[
                  StyleBox["\<\"T\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TagBox[
                  StyleBox["\<\"N\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TemplateBox[{"\"(\"","0","\")\""},
                  "Row",
                  
                  DisplayFunction->(
                   RowBox[{#, "\[InvisibleSpace]", #2, 
                    "\[InvisibleSpace]", #3}]& ),
                  InterpretationFunction->(RowBox[{"Row", "[", 
                    RowBox[{"{", 
                    RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )]],
                Subsuperscript[
                 StyleForm["T", FontSlant -> "Italic"], 
                 StyleForm["N", FontSlant -> "Italic"], 
                 Row[{"(", 0, ")"}]],
                Editable->False],
               DisplayForm],
              StripOnInput->False,
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {-0.5, 0.5}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               InterpretationBox[
                SubsuperscriptBox[
                 TagBox[
                  StyleBox["\<\"O\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TagBox[
                  StyleBox["\<\"N\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TemplateBox[{"\"(\"","1","\")\""},
                  "Row",
                  
                  DisplayFunction->(
                   RowBox[{#, "\[InvisibleSpace]", #2, 
                    "\[InvisibleSpace]", #3}]& ),
                  InterpretationFunction->(RowBox[{"Row", "[", 
                    RowBox[{"{", 
                    RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )]],
                Subsuperscript[
                 StyleForm["O", FontSlant -> "Italic"], 
                 StyleForm["N", FontSlant -> "Italic"], 
                 Row[{"(", 1, ")"}]],
                Editable->False],
               DisplayForm],
              StripOnInput->False,
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {-0.5, 1.}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               InterpretationBox[
                SubsuperscriptBox[
                 TagBox[
                  StyleBox["\<\"T\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TagBox[
                  StyleBox["\<\"N\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TemplateBox[{"\"(\"","1","\")\""},
                  "Row",
                  
                  DisplayFunction->(
                   RowBox[{#, "\[InvisibleSpace]", #2, 
                    "\[InvisibleSpace]", #3}]& ),
                  InterpretationFunction->(RowBox[{"Row", "[", 
                    RowBox[{"{", 
                    RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )]],
                Subsuperscript[
                 StyleForm["T", FontSlant -> "Italic"], 
                 StyleForm["N", FontSlant -> "Italic"], 
                 Row[{"(", 1, ")"}]],
                Editable->False],
               DisplayForm],
              StripOnInput->False,
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {-0.5, 1.5}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               InterpretationBox[
                SubsuperscriptBox[
                 TagBox[
                  StyleBox["\<\"O\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TagBox[
                  StyleBox["\<\"N\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TemplateBox[{"\"(\"","2","\")\""},
                  "Row",
                  
                  DisplayFunction->(
                   RowBox[{#, "\[InvisibleSpace]", #2, 
                    "\[InvisibleSpace]", #3}]& ),
                  InterpretationFunction->(RowBox[{"Row", "[", 
                    RowBox[{"{", 
                    RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )]],
                Subsuperscript[
                 StyleForm["O", FontSlant -> "Italic"], 
                 StyleForm["N", FontSlant -> "Italic"], 
                 Row[{"(", 2, ")"}]],
                Editable->False],
               DisplayForm],
              StripOnInput->False,
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {-0.5, 2.}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               InterpretationBox[
                SubsuperscriptBox[
                 TagBox[
                  StyleBox["\<\"T\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TagBox[
                  StyleBox["\<\"N\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TemplateBox[{"\"(\"","2","\")\""},
                  "Row",
                  
                  DisplayFunction->(
                   RowBox[{#, "\[InvisibleSpace]", #2, 
                    "\[InvisibleSpace]", #3}]& ),
                  InterpretationFunction->(RowBox[{"Row", "[", 
                    RowBox[{"{", 
                    RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )]],
                Subsuperscript[
                 StyleForm["T", FontSlant -> "Italic"], 
                 StyleForm["N", FontSlant -> "Italic"], 
                 Row[{"(", 2, ")"}]],
                Editable->False],
               DisplayForm],
              StripOnInput->False,
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {-0.5, 2.5}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               InterpretationBox[
                SubsuperscriptBox[
                 TagBox[
                  StyleBox["\<\"O\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TagBox[
                  StyleBox["\<\"N\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TemplateBox[{"\"(\"","3","\")\""},
                  "Row",
                  
                  DisplayFunction->(
                   RowBox[{#, "\[InvisibleSpace]", #2, 
                    "\[InvisibleSpace]", #3}]& ),
                  InterpretationFunction->(RowBox[{"Row", "[", 
                    RowBox[{"{", 
                    RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )]],
                Subsuperscript[
                 StyleForm["O", FontSlant -> "Italic"], 
                 StyleForm["N", FontSlant -> "Italic"], 
                 Row[{"(", 3, ")"}]],
                Editable->False],
               DisplayForm],
              StripOnInput->False,
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {-0.5, 3.}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               InterpretationBox[
                SubsuperscriptBox[
                 TagBox[
                  StyleBox["\<\"T\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TagBox[
                  StyleBox["\<\"N\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TemplateBox[{"\"(\"","3","\")\""},
                  "Row",
                  
                  DisplayFunction->(
                   RowBox[{#, "\[InvisibleSpace]", #2, 
                    "\[InvisibleSpace]", #3}]& ),
                  InterpretationFunction->(RowBox[{"Row", "[", 
                    RowBox[{"{", 
                    RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )]],
                Subsuperscript[
                 StyleForm["T", FontSlant -> "Italic"], 
                 StyleForm["N", FontSlant -> "Italic"], 
                 Row[{"(", 3, ")"}]],
                Editable->False],
               DisplayForm],
              StripOnInput->False,
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {-0.5, 3.5}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               InterpretationBox[
                SubsuperscriptBox[
                 TagBox[
                  StyleBox["\<\"O\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TagBox[
                  StyleBox["\<\"N\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TemplateBox[{"\"(\"","4","\")\""},
                  "Row",
                  
                  DisplayFunction->(
                   RowBox[{#, "\[InvisibleSpace]", #2, 
                    "\[InvisibleSpace]", #3}]& ),
                  InterpretationFunction->(RowBox[{"Row", "[", 
                    RowBox[{"{", 
                    RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )]],
                Subsuperscript[
                 StyleForm["O", FontSlant -> "Italic"], 
                 StyleForm["N", FontSlant -> "Italic"], 
                 Row[{"(", 4, ")"}]],
                Editable->False],
               DisplayForm],
              StripOnInput->False,
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {-0.5, 4.}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               InterpretationBox[
                SubsuperscriptBox[
                 TagBox[
                  StyleBox["\<\"T\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TagBox[
                  StyleBox["\<\"N\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TemplateBox[{"\"(\"","4","\")\""},
                  "Row",
                  
                  DisplayFunction->(
                   RowBox[{#, "\[InvisibleSpace]", #2, 
                    "\[InvisibleSpace]", #3}]& ),
                  InterpretationFunction->(RowBox[{"Row", "[", 
                    RowBox[{"{", 
                    RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )]],
                Subsuperscript[
                 StyleForm["T", FontSlant -> "Italic"], 
                 StyleForm["N", FontSlant -> "Italic"], 
                 Row[{"(", 4, ")"}]],
                Editable->False],
               DisplayForm],
              StripOnInput->False,
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {-0.5, 4.5}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox["\<\"\[VerticalEllipsis]\"\>",
               DisplayForm],
              StripOnInput->False,
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {0., 4.75}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox["\<\"\[VerticalEllipsis]\"\>",
               DisplayForm],
              StripOnInput->False,
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {1., 4.75}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox["\<\"\[VerticalEllipsis]\"\>",
               DisplayForm],
              StripOnInput->False,
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {2., 4.75}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox["\<\"\[VerticalEllipsis]\"\>",
               DisplayForm],
              StripOnInput->False,
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {3., 4.75}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox["\<\"\[VerticalEllipsis]\"\>",
               DisplayForm],
              StripOnInput->False,
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {4., 4.75}, {0, 0}, Automatic, {1, 0}]}}}}}}}}},
  AspectRatio->1,
  Axes->False,
  Background->None,
  BaseStyle->{
   FontFamily -> "Times", FontSize -> 12, FontSlant -> "Plain", FontTracking -> 
    "Plain", FontWeight -> "Plain", FontColor -> GrayLevel[0], FontOpacity -> 
    1, ShowAutoStyles -> False, SingleLetterItalics -> False},
  DisplayFunction->Identity,
  Frame->False,
  FrameLabel->{None, None, None, None},
  FrameStyle->Directive[{
     GrayLevel[0], 
     Opacity[1], 
     CapForm[None], 
     AbsoluteThickness[1], 
     AbsoluteDashing[{}]}],
  FrameTicks->None,
  ImageSize->{432, 432},
  PlotRange->{{-2.0008, 6.0008}, {-2.0008, 6.0008}},
  Ticks->None]], "Output",
 CellChangeTimes->{3.4956587290625*^9, 3.52552789496875*^9}]
}, Open  ]],

Cell["\<\
For the paper, we instead use
\tSchemeFlags \[Rule] {\"EqnNumber\"}\
\>", "Text",
 CellChangeTimes->{{3.49565806659375*^9, 3.495658067203125*^9}, {
  3.4956581323125*^9, 3.49565813253125*^9}, {3.495658699609375*^9, 
  3.495658713265625*^9}}],

Cell[BoxData[
 GraphicsBox[{
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-1., 0.}, {-1., 4.5}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{-1.0555666666666665`, 4.388866666666667}, {-1., 
     4.5}, {-0.9444333333333335, 4.388866666666667}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0., -0.3}, {4., -0.3}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{3.888866666666667, -0.24443333333333328`}, {
     4., -0.2999999999999998}, {3.888866666666667, -0.3555666666666666}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], {LineBox[{{0., -0.239988}, {0., -0.3}}], 
     LineBox[{{1., -0.239988}, {1., -0.3}}], 
     LineBox[{{2., -0.239988}, {2., -0.3}}]}, 
    {GrayLevel[0], Opacity[1], 
     DiskBox[{0., 0.}, 0.03704444444444444, 
      NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
     None], CircleBox[{0., 0.}, 0.05556666666666667, 
      NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
     {GrayLevel[0], Opacity[1], 
      DiskBox[{0., 1.}, 0.03704444444444444, 
       NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
     {GrayLevel[0], Opacity[1], 
      DiskBox[{0., 2.}, 0.03704444444444444, 
       NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
     {GrayLevel[0], Opacity[1], 
      DiskBox[{0., 3.}, 0.03704444444444444, 
       NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
     {GrayLevel[0], Opacity[1], 
      DiskBox[{0., 4.}, 0.03704444444444444, 
       NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
     {GrayLevel[0], Opacity[1], 
      DiskBox[{1., 0.}, 0.03704444444444444, 
       NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
     {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
      None], 
      CircleBox[{1., 0.}, 0.05556666666666667, 
       NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
      {GrayLevel[0], Opacity[1], 
       DiskBox[{1., 1.}, 0.03704444444444444, 
        NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
      {GrayLevel[0], Opacity[1], 
       DiskBox[{1., 2.}, 0.03704444444444444, 
        NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
      {GrayLevel[0], Opacity[1], 
       DiskBox[{1., 3.}, 0.03704444444444444, 
        NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
      {GrayLevel[0], Opacity[1], 
       DiskBox[{1., 4.}, 0.03704444444444444, 
        NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
      {GrayLevel[0], Opacity[1], 
       DiskBox[{2., 0.}, 0.03704444444444444, 
        NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
      {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
       None], CircleBox[{2., 0.}, 0.05556666666666667, 
        NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
       {GrayLevel[0], Opacity[1], 
        DiskBox[{2., 1.}, 0.03704444444444444, 
         NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
       {GrayLevel[0], Opacity[1], 
        DiskBox[{2., 2.}, 0.03704444444444444, 
         NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
       {GrayLevel[0], Opacity[1], 
        DiskBox[{2., 3.}, 0.03704444444444444, 
         NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
       {GrayLevel[0], Opacity[1], 
        DiskBox[{2., 4.}, 0.03704444444444444, 
         NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
       {GrayLevel[0], Opacity[1], 
        DiskBox[{3., 0.}, 0.03704444444444444, 
         NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
       {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
        None], CircleBox[{3., 0.}, 0.05556666666666667, 
         NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
        {GrayLevel[0], Opacity[1], 
         DiskBox[{3., 1.}, 0.03704444444444444, 
          NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
        {GrayLevel[0], Opacity[1], 
         DiskBox[{3., 2.}, 0.03704444444444444, 
          NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
        {GrayLevel[0], Opacity[1], 
         DiskBox[{3., 3.}, 0.03704444444444444, 
          NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
        {GrayLevel[0], Opacity[1], 
         DiskBox[{3., 4.}, 0.03704444444444444, 
          NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
        {GrayLevel[0], Opacity[1], 
         DiskBox[{4., 0.}, 0.03704444444444444, 
          NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
        {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
         None], CircleBox[{4., 0.}, 0.05556666666666667, 
          NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
         {GrayLevel[0], Opacity[1], 
          DiskBox[{4., 1.}, 0.03704444444444444, 
           NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
         {GrayLevel[0], Opacity[1], 
          DiskBox[{4., 2.}, 0.03704444444444444, 
           NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
         {GrayLevel[0], Opacity[1], 
          DiskBox[{4., 3.}, 0.03704444444444444, 
           NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
         {GrayLevel[0], Opacity[1], 
          DiskBox[{4., 4.}, 0.03704444444444444, 
           NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{-0.055566666666666764`, 
           0.944433333333333}, {-0.055566666666666764`, 
           0.5555666666666665}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{-0.01852222222222233, 
           0.5926111111111108}, {-0.055566666666666764`, 
           0.5555666666666665}, {-0.0926111111111112, 0.5926111111111108}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{0.05556666666666654, 0.944433333333333}, {
           0.05556666666666654, 0.05556666666666654}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{0.0926111111111112, 0.0926111111111112}, {
           0.05556666666666654, 0.05556666666666654}, {0.01852222222222233, 
           0.0926111111111112}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{-0.055566666666666764`, 
           1.944433333333333}, {-0.055566666666666764`, 
           1.5555666666666665`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{-0.01852222222222233, 
           1.5926111111111108`}, {-0.055566666666666764`, 
           1.5555666666666665`}, {-0.0926111111111112, 
           1.5926111111111108`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{0.05556666666666654, 1.944433333333333}, {
           0.05556666666666654, 1.0555666666666665`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{0.0926111111111112, 1.0926111111111108`}, {
           0.05556666666666654, 1.0555666666666665`}, {0.01852222222222233, 
           1.0926111111111108`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{-0.055566666666666764`, 
           2.9444333333333335`}, {-0.055566666666666764`, 
           2.5555666666666665`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{-0.01852222222222233, 
           2.592611111111111}, {-0.055566666666666764`, 
           2.5555666666666665`}, {-0.0926111111111112, 2.592611111111111}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{0.05556666666666654, 2.9444333333333335`}, {
           0.05556666666666654, 2.0555666666666665`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{0.0926111111111112, 2.092611111111111}, {
           0.05556666666666654, 2.0555666666666665`}, {0.01852222222222233, 
           2.092611111111111}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{-0.055566666666666764`, 
           3.9444333333333335`}, {-0.055566666666666764`, 
           3.5555666666666665`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{-0.01852222222222233, 
           3.592611111111111}, {-0.055566666666666764`, 
           3.5555666666666665`}, {-0.0926111111111112, 3.592611111111111}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{0.05556666666666654, 3.9444333333333335`}, {
           0.05556666666666654, 3.0555666666666665`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{0.0926111111111112, 3.092611111111111}, {
           0.05556666666666654, 3.0555666666666665`}, {0.01852222222222233, 
           3.092611111111111}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{0.944433333333333, 0.944433333333333}, {0.944433333333333,
            0.5555666666666665}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{0.9814777777777777, 0.5926111111111108}, {
           0.944433333333333, 0.5555666666666665}, {0.9073888888888888, 
           0.5926111111111108}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{1.0555666666666665`, 0.944433333333333}, {
           1.0555666666666665`, 0.05556666666666654}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{1.0926111111111108`, 0.0926111111111112}, {
           1.0555666666666665`, 0.05556666666666654}, {1.0185222222222219`, 
           0.0926111111111112}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{0.944433333333333, 1.944433333333333}, {0.944433333333333,
            1.5555666666666665`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{0.9814777777777777, 1.5926111111111108`}, {
           0.944433333333333, 1.5555666666666665`}, {0.9073888888888888, 
           1.5926111111111108`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{1.0555666666666665`, 1.944433333333333}, {
           1.0555666666666665`, 1.0555666666666665`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{1.0926111111111108`, 1.0926111111111108`}, {
           1.0555666666666665`, 1.0555666666666665`}, {1.0185222222222219`, 
           1.0926111111111108`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{0.944433333333333, 2.9444333333333335`}, {
           0.944433333333333, 2.5555666666666665`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{0.9814777777777777, 2.592611111111111}, {
           0.944433333333333, 2.5555666666666665`}, {0.9073888888888888, 
           2.592611111111111}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{1.0555666666666665`, 2.9444333333333335`}, {
           1.0555666666666665`, 2.0555666666666665`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{1.0926111111111108`, 2.092611111111111}, {
           1.0555666666666665`, 2.0555666666666665`}, {1.0185222222222219`, 
           2.092611111111111}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{0.944433333333333, 3.9444333333333335`}, {
           0.944433333333333, 3.5555666666666665`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{0.9814777777777777, 3.592611111111111}, {
           0.944433333333333, 3.5555666666666665`}, {0.9073888888888888, 
           3.592611111111111}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{1.0555666666666665`, 3.9444333333333335`}, {
           1.0555666666666665`, 3.0555666666666665`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{1.0926111111111108`, 3.092611111111111}, {
           1.0555666666666665`, 3.0555666666666665`}, {1.0185222222222219`, 
           3.092611111111111}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{1.944433333333333, 0.944433333333333}, {1.944433333333333,
            0.5555666666666665}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{1.9814777777777777`, 0.5926111111111108}, {
           1.944433333333333, 0.5555666666666665}, {1.9073888888888888`, 
           0.5926111111111108}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{2.0555666666666665`, 0.944433333333333}, {
           2.0555666666666665`, 0.05556666666666654}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{2.092611111111111, 0.0926111111111112}, {
           2.0555666666666665`, 0.05556666666666654}, {2.018522222222222, 
           0.0926111111111112}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{1.944433333333333, 1.944433333333333}, {1.944433333333333,
            1.5555666666666665`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{1.9814777777777777`, 1.5926111111111108`}, {
           1.944433333333333, 1.5555666666666665`}, {1.9073888888888888`, 
           1.5926111111111108`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{2.0555666666666665`, 1.944433333333333}, {
           2.0555666666666665`, 1.0555666666666665`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{2.092611111111111, 1.0926111111111108`}, {
           2.0555666666666665`, 1.0555666666666665`}, {2.018522222222222, 
           1.0926111111111108`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{1.944433333333333, 2.9444333333333335`}, {
           1.944433333333333, 2.5555666666666665`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{1.9814777777777777`, 2.592611111111111}, {
           1.944433333333333, 2.5555666666666665`}, {1.9073888888888888`, 
           2.592611111111111}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{2.0555666666666665`, 2.9444333333333335`}, {
           2.0555666666666665`, 2.0555666666666665`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{2.092611111111111, 2.092611111111111}, {
           2.0555666666666665`, 2.0555666666666665`}, {2.018522222222222, 
           2.092611111111111}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{1.944433333333333, 3.9444333333333335`}, {
           1.944433333333333, 3.5555666666666665`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{1.9814777777777777`, 3.592611111111111}, {
           1.944433333333333, 3.5555666666666665`}, {1.9073888888888888`, 
           3.592611111111111}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{2.0555666666666665`, 3.9444333333333335`}, {
           2.0555666666666665`, 3.0555666666666665`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{2.092611111111111, 3.092611111111111}, {
           2.0555666666666665`, 3.0555666666666665`}, {2.018522222222222, 
           3.092611111111111}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{2.9444333333333335`, 0.944433333333333}, {
           2.9444333333333335`, 0.5555666666666665}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{2.981477777777778, 0.5926111111111108}, {
           2.9444333333333335`, 0.5555666666666665}, {2.907388888888889, 
           0.5926111111111108}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{3.0555666666666665`, 0.944433333333333}, {
           3.0555666666666665`, 0.05556666666666654}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{3.092611111111111, 0.0926111111111112}, {
           3.0555666666666665`, 0.05556666666666654}, {3.018522222222222, 
           0.0926111111111112}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{2.9444333333333335`, 1.944433333333333}, {
           2.9444333333333335`, 1.5555666666666665`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{2.981477777777778, 1.5926111111111108`}, {
           2.9444333333333335`, 1.5555666666666665`}, {2.907388888888889, 
           1.5926111111111108`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{3.0555666666666665`, 1.944433333333333}, {
           3.0555666666666665`, 1.0555666666666665`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{3.092611111111111, 1.0926111111111108`}, {
           3.0555666666666665`, 1.0555666666666665`}, {3.018522222222222, 
           1.0926111111111108`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{2.9444333333333335`, 2.9444333333333335`}, {
           2.9444333333333335`, 2.5555666666666665`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{2.981477777777778, 2.592611111111111}, {
           2.9444333333333335`, 2.5555666666666665`}, {2.907388888888889, 
           2.592611111111111}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{3.0555666666666665`, 2.9444333333333335`}, {
           3.0555666666666665`, 2.0555666666666665`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{3.092611111111111, 2.092611111111111}, {
           3.0555666666666665`, 2.0555666666666665`}, {3.018522222222222, 
           2.092611111111111}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{2.9444333333333335`, 3.9444333333333335`}, {
           2.9444333333333335`, 3.5555666666666665`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{2.981477777777778, 3.592611111111111}, {
           2.9444333333333335`, 3.5555666666666665`}, {2.907388888888889, 
           3.592611111111111}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{3.0555666666666665`, 3.9444333333333335`}, {
           3.0555666666666665`, 3.0555666666666665`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{3.092611111111111, 3.092611111111111}, {
           3.0555666666666665`, 3.0555666666666665`}, {3.018522222222222, 
           3.092611111111111}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{3.9444333333333335`, 0.944433333333333}, {
           3.9444333333333335`, 0.5555666666666665}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{3.981477777777778, 0.5926111111111108}, {
           3.9444333333333335`, 0.5555666666666665}, {3.907388888888889, 
           0.5926111111111108}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{4.0555666666666665`, 0.944433333333333}, {
           4.0555666666666665`, 0.05556666666666654}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{4.092611111111111, 0.0926111111111112}, {
           4.0555666666666665`, 0.05556666666666654}, {4.018522222222222, 
           0.0926111111111112}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{3.9444333333333335`, 1.944433333333333}, {
           3.9444333333333335`, 1.5555666666666665`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{3.981477777777778, 1.5926111111111108`}, {
           3.9444333333333335`, 1.5555666666666665`}, {3.907388888888889, 
           1.5926111111111108`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{4.0555666666666665`, 1.944433333333333}, {
           4.0555666666666665`, 1.0555666666666665`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{4.092611111111111, 1.0926111111111108`}, {
           4.0555666666666665`, 1.0555666666666665`}, {4.018522222222222, 
           1.0926111111111108`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{3.9444333333333335`, 2.9444333333333335`}, {
           3.9444333333333335`, 2.5555666666666665`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{3.981477777777778, 2.592611111111111}, {
           3.9444333333333335`, 2.5555666666666665`}, {3.907388888888889, 
           2.592611111111111}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{4.0555666666666665`, 2.9444333333333335`}, {
           4.0555666666666665`, 2.0555666666666665`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{4.092611111111111, 2.092611111111111}, {
           4.0555666666666665`, 2.0555666666666665`}, {4.018522222222222, 
           2.092611111111111}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{3.9444333333333335`, 3.9444333333333335`}, {
           3.9444333333333335`, 3.5555666666666665`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{3.981477777777778, 3.592611111111111}, {
           3.9444333333333335`, 3.5555666666666665`}, {3.907388888888889, 
           3.592611111111111}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{4.0555666666666665`, 3.9444333333333335`}, {
           4.0555666666666665`, 3.0555666666666665`}}]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          LineBox[{{4.092611111111111, 3.092611111111111}, {
           4.0555666666666665`, 3.0555666666666665`}, {4.018522222222222, 
           3.092611111111111}}], 
          {GrayLevel[0.5], Opacity[1], 
           DiskBox[{0., 0.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {GrayLevel[0.5], Opacity[1], 
           DiskBox[{0., 1.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {GrayLevel[0.5], Opacity[1], 
           DiskBox[{0., 2.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {GrayLevel[0.5], Opacity[1], 
           DiskBox[{0., 3.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {GrayLevel[0.5], Opacity[1], 
           DiskBox[{0., 4.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {GrayLevel[0.5], Opacity[1], 
           DiskBox[{1., 0.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {GrayLevel[0.5], Opacity[1], 
           DiskBox[{1., 1.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {GrayLevel[0.5], Opacity[1], 
           DiskBox[{1., 2.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {GrayLevel[0.5], Opacity[1], 
           DiskBox[{1., 3.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {GrayLevel[0.5], Opacity[1], 
           DiskBox[{1., 4.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {GrayLevel[0.5], Opacity[1], 
           DiskBox[{2., 0.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {GrayLevel[0.5], Opacity[1], 
           DiskBox[{2., 1.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {GrayLevel[0.5], Opacity[1], 
           DiskBox[{2., 2.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {GrayLevel[0.5], Opacity[1], 
           DiskBox[{2., 3.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {GrayLevel[0.5], Opacity[1], 
           DiskBox[{2., 4.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {GrayLevel[0.5], Opacity[1], 
           DiskBox[{3., 0.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {GrayLevel[0.5], Opacity[1], 
           DiskBox[{3., 1.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {GrayLevel[0.5], Opacity[1], 
           DiskBox[{3., 2.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {GrayLevel[0.5], Opacity[1], 
           DiskBox[{3., 3.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {GrayLevel[0.5], Opacity[1], 
           DiskBox[{3., 4.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {GrayLevel[0.5], Opacity[1], 
           DiskBox[{4., 0.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {GrayLevel[0.5], Opacity[1], 
           DiskBox[{4., 1.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {GrayLevel[0.5], Opacity[1], 
           DiskBox[{4., 2.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {GrayLevel[0.5], Opacity[1], 
           DiskBox[{4., 3.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {GrayLevel[0.5], Opacity[1], 
           DiskBox[{4., 4.5}, 0.03704444444444444, 
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0., 1.444433333333333}, {0., 1.0555666666666665`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.03704444444444421, 1.0926111111111108`}, {0., 
            1.0555666666666665`}, {-0.037044444444444435`, 
            1.0926111111111108`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0., 2.4444333333333335`}, {0., 2.0555666666666665`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.03704444444444421, 2.092611111111111}, {0., 
            2.0555666666666665`}, {-0.037044444444444435`, 
            2.092611111111111}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0., 3.4444333333333335`}, {0., 3.0555666666666665`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.03704444444444421, 3.092611111111111}, {0., 
            3.0555666666666665`}, {-0.037044444444444435`, 
            3.092611111111111}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0., 4.4444333333333335`}, {0., 4.0555666666666665`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.03704444444444421, 4.092611111111111}, {0., 
            4.0555666666666665`}, {-0.037044444444444435`, 
            4.092611111111111}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.9214168663841353, 0.49999999999999956`}, {
            0.07858313361586511, 0.49999999999999956`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.11562757806030932`, 0.46295555555555534`}, {
            0.07858313361586511, 0.49999999999999956`}, {0.11562757806030932`,
             0.5370444444444442}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.944433333333333, 0.444433333333333}, {
            0.055566666666666986`, 0.05556666666666654}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.10435309185110819`, 0.03647566234216937}, {
            0.055566666666666986`, 0.05556666666666654}, {0.07465767099116372,
             0.10435309185110775`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.9214168663841353, 1.5}, {0.07858313361586511, 1.5}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.11562757806030932`, 1.4629555555555553`}, {
            0.07858313361586511, 1.5}, {0.11562757806030932`, 
            1.5370444444444442`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.944433333333333, 1.444433333333333}, {
            0.05556666666666654, 1.0555666666666665`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.10435309185110775`, 1.0364756623421694`}, {
            0.05556666666666654, 1.0555666666666665`}, {0.07465767099116372, 
            1.1043530918511077`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.9999999999999996, 1.444433333333333}, {
            0.9999999999999996, 1.0555666666666665`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.0370444444444442`, 1.0926111111111108`}, {
            0.9999999999999996, 1.0555666666666665`}, {0.9629555555555553, 
            1.0926111111111108`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.9214168663841353, 2.5}, {0.07858313361586511, 2.5}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.11562757806030932`, 2.4629555555555553`}, {
            0.07858313361586511, 2.5}, {0.11562757806030932`, 
            2.5370444444444447`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.944433333333333, 2.4444333333333335`}, {
            0.05556666666666654, 2.0555666666666665`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.10435309185110775`, 2.036475662342169}, {
            0.05556666666666654, 2.0555666666666665`}, {0.07465767099116372, 
            2.1043530918511077`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.9999999999999996, 2.4444333333333335`}, {
            0.9999999999999996, 2.0555666666666665`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.0370444444444442`, 2.092611111111111}, {
            0.9999999999999996, 2.0555666666666665`}, {0.9629555555555553, 
            2.092611111111111}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.9214168663841353, 3.5}, {0.07858313361586511, 3.5}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.11562757806030932`, 3.4629555555555553`}, {
            0.07858313361586511, 3.5}, {0.11562757806030932`, 
            3.5370444444444447`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.944433333333333, 3.4444333333333335`}, {
            0.05556666666666654, 3.0555666666666665`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.10435309185110775`, 3.03647566234217}, {
            0.05556666666666654, 3.0555666666666665`}, {0.07465767099116372, 
            3.1043530918511086`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.9999999999999996, 3.4444333333333335`}, {
            0.9999999999999996, 3.0555666666666665`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.0370444444444442`, 3.092611111111111}, {
            0.9999999999999996, 3.0555666666666665`}, {0.9629555555555553, 
            3.092611111111111}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.9214168663841353, 4.5}, {0.07858313361586511, 4.5}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.11562757806030932`, 4.462955555555555}, {
            0.07858313361586511, 4.5}, {0.11562757806030932`, 
            4.537044444444445}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.944433333333333, 4.4444333333333335`}, {
            0.05556666666666654, 4.0555666666666665`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.10435309185110775`, 4.03647566234217}, {
            0.05556666666666654, 4.0555666666666665`}, {0.07465767099116372, 
            4.104353091851109}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{0.9999999999999996, 4.4444333333333335`}, {
            0.9999999999999996, 4.0555666666666665`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.0370444444444442`, 4.092611111111111}, {
            0.9999999999999996, 4.0555666666666665`}, {0.9629555555555553, 
            4.092611111111111}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.9214168663841353`, 0.49999999999999956`}, {
            1.0785831336158647`, 0.49999999999999956`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.1156275780603093`, 0.46295555555555534`}, {
            1.0785831336158647`, 0.49999999999999956`}, {1.1156275780603093`, 
            0.5370444444444442}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.944433333333333, 0.444433333333333}, {
            1.0555666666666665`, 0.055566666666666986`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.1043530918511077`, 0.03647566234216981}, {
            1.0555666666666665`, 0.055566666666666986`}, {1.0746576709911637`,
             0.10435309185110819`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.9214168663841353`, 1.5}, {1.0785831336158647`, 1.5}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.1156275780603093`, 1.4629555555555553`}, {
            1.0785831336158647`, 1.5}, {1.1156275780603093`, 
            1.5370444444444442`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.944433333333333, 1.444433333333333}, {
            1.0555666666666665`, 1.0555666666666665`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.1043530918511077`, 1.0364756623421694`}, {
            1.0555666666666665`, 1.0555666666666665`}, {1.0746576709911637`, 
            1.1043530918511077`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2., 1.444433333333333}, {2., 1.0555666666666665`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.0370444444444447`, 1.0926111111111108`}, {2., 
            1.0555666666666665`}, {1.9629555555555553`, 
            1.0926111111111108`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.9214168663841353`, 2.5}, {1.0785831336158647`, 2.5}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.1156275780603093`, 2.4629555555555553`}, {
            1.0785831336158647`, 2.5}, {1.1156275780603093`, 
            2.5370444444444447`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.944433333333333, 2.4444333333333335`}, {
            1.0555666666666665`, 2.0555666666666665`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.1043530918511077`, 2.036475662342169}, {
            1.0555666666666665`, 2.0555666666666665`}, {1.0746576709911637`, 
            2.1043530918511077`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2., 2.4444333333333335`}, {2., 2.0555666666666665`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.0370444444444447`, 2.092611111111111}, {2., 
            2.0555666666666665`}, {1.9629555555555553`, 2.092611111111111}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.9214168663841353`, 3.5}, {1.0785831336158647`, 3.5}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.1156275780603093`, 3.4629555555555553`}, {
            1.0785831336158647`, 3.5}, {1.1156275780603093`, 
            3.5370444444444447`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.944433333333333, 3.4444333333333335`}, {
            1.0555666666666665`, 3.0555666666666665`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.1043530918511077`, 3.03647566234217}, {
            1.0555666666666665`, 3.0555666666666665`}, {1.0746576709911637`, 
            3.1043530918511086`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2., 3.4444333333333335`}, {2., 3.0555666666666665`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.0370444444444447`, 3.092611111111111}, {2., 
            3.0555666666666665`}, {1.9629555555555553`, 3.092611111111111}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.9214168663841353`, 4.5}, {1.0785831336158647`, 4.5}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.1156275780603093`, 4.462955555555555}, {
            1.0785831336158647`, 4.5}, {1.1156275780603093`, 
            4.537044444444445}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.944433333333333, 4.4444333333333335`}, {
            1.0555666666666665`, 4.0555666666666665`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{1.1043530918511077`, 4.03647566234217}, {
            1.0555666666666665`, 4.0555666666666665`}, {1.0746576709911637`, 
            4.104353091851109}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2., 4.4444333333333335`}, {2., 4.0555666666666665`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.0370444444444447`, 4.092611111111111}, {2., 
            4.0555666666666665`}, {1.9629555555555553`, 4.092611111111111}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.921416866384134, 0.49999999999999956`}, {
            2.078583133615865, 0.49999999999999956`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.1156275780603098`, 0.46295555555555534`}, {
            2.078583133615865, 0.49999999999999956`}, {2.1156275780603098`, 
            0.5370444444444442}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.9444333333333335`, 0.444433333333333}, {
            2.0555666666666665`, 0.055566666666666986`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.1043530918511077`, 0.03647566234216981}, {
            2.0555666666666665`, 0.055566666666666986`}, {2.074657670991164, 
            0.10435309185110819`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.921416866384134, 1.5}, {2.078583133615865, 1.5}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.1156275780603098`, 1.4629555555555553`}, {
            2.078583133615865, 1.5}, {2.1156275780603098`, 
            1.5370444444444442`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.9444333333333335`, 1.444433333333333}, {
            2.0555666666666665`, 1.0555666666666665`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.1043530918511077`, 1.0364756623421694`}, {
            2.0555666666666665`, 1.0555666666666665`}, {2.074657670991164, 
            1.1043530918511077`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3., 1.444433333333333}, {3., 1.0555666666666665`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.0370444444444447`, 1.0926111111111108`}, {3., 
            1.0555666666666665`}, {2.9629555555555553`, 
            1.0926111111111108`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.921416866384134, 2.5}, {2.078583133615865, 2.5}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.1156275780603098`, 2.4629555555555553`}, {
            2.078583133615865, 2.5}, {2.1156275780603098`, 
            2.5370444444444447`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.9444333333333335`, 2.4444333333333335`}, {
            2.0555666666666665`, 2.0555666666666665`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.1043530918511077`, 2.036475662342169}, {
            2.0555666666666665`, 2.0555666666666665`}, {2.074657670991164, 
            2.1043530918511077`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3., 2.4444333333333335`}, {3., 2.0555666666666665`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.0370444444444447`, 2.092611111111111}, {3., 
            2.0555666666666665`}, {2.9629555555555553`, 2.092611111111111}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.921416866384134, 3.5}, {2.078583133615865, 3.5}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.1156275780603098`, 3.4629555555555553`}, {
            2.078583133615865, 3.5}, {2.1156275780603098`, 
            3.5370444444444447`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.9444333333333335`, 3.4444333333333335`}, {
            2.0555666666666665`, 3.0555666666666665`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.1043530918511077`, 3.03647566234217}, {
            2.0555666666666665`, 3.0555666666666665`}, {2.074657670991164, 
            3.1043530918511086`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3., 3.4444333333333335`}, {3., 3.0555666666666665`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.0370444444444447`, 3.092611111111111}, {3., 
            3.0555666666666665`}, {2.9629555555555553`, 3.092611111111111}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.921416866384134, 4.5}, {2.078583133615865, 4.5}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.1156275780603098`, 4.462955555555555}, {
            2.078583133615865, 4.5}, {2.1156275780603098`, 
            4.537044444444445}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.9444333333333335`, 4.4444333333333335`}, {
            2.0555666666666665`, 4.0555666666666665`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{2.1043530918511077`, 4.03647566234217}, {
            2.0555666666666665`, 4.0555666666666665`}, {2.074657670991164, 
            4.104353091851109}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3., 4.4444333333333335`}, {3., 4.0555666666666665`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.0370444444444447`, 4.092611111111111}, {3., 
            4.0555666666666665`}, {2.9629555555555553`, 4.092611111111111}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.921416866384134, 0.49999999999999956`}, {
            3.078583133615864, 0.49999999999999956`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.115627578060309, 0.46295555555555534`}, {
            3.078583133615864, 0.49999999999999956`}, {3.115627578060309, 
            0.5370444444444442}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.9444333333333335`, 0.444433333333333}, {
            3.0555666666666665`, 0.055566666666666986`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.1043530918511086`, 0.03647566234216981}, {
            3.0555666666666665`, 0.055566666666666986`}, {3.0746576709911633`,
             0.10435309185110819`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.921416866384134, 1.5}, {3.078583133615864, 1.5}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.115627578060309, 1.4629555555555553`}, {
            3.078583133615864, 1.5}, {3.115627578060309, 
            1.5370444444444442`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.9444333333333335`, 1.444433333333333}, {
            3.0555666666666665`, 1.0555666666666665`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.1043530918511086`, 1.0364756623421694`}, {
            3.0555666666666665`, 1.0555666666666665`}, {3.0746576709911633`, 
            1.1043530918511077`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{4., 1.444433333333333}, {4., 1.0555666666666665`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{4.037044444444445, 1.0926111111111108`}, {4., 
            1.0555666666666665`}, {3.9629555555555553`, 
            1.0926111111111108`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.921416866384134, 2.5}, {3.078583133615864, 2.5}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.115627578060309, 2.4629555555555553`}, {
            3.078583133615864, 2.5}, {3.115627578060309, 
            2.5370444444444447`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.9444333333333335`, 2.4444333333333335`}, {
            3.0555666666666665`, 2.0555666666666665`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.1043530918511086`, 2.036475662342169}, {
            3.0555666666666665`, 2.0555666666666665`}, {3.0746576709911633`, 
            2.1043530918511077`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{4., 2.4444333333333335`}, {4., 2.0555666666666665`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{4.037044444444445, 2.092611111111111}, {4., 
            2.0555666666666665`}, {3.9629555555555553`, 2.092611111111111}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.921416866384134, 3.5}, {3.078583133615864, 3.5}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.115627578060309, 3.4629555555555553`}, {
            3.078583133615864, 3.5}, {3.115627578060309, 
            3.5370444444444447`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.9444333333333335`, 3.4444333333333335`}, {
            3.0555666666666665`, 3.0555666666666665`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.1043530918511086`, 3.03647566234217}, {
            3.0555666666666665`, 3.0555666666666665`}, {3.0746576709911633`, 
            3.1043530918511086`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{4., 3.4444333333333335`}, {4., 3.0555666666666665`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{4.037044444444445, 3.092611111111111}, {4., 
            3.0555666666666665`}, {3.9629555555555553`, 3.092611111111111}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.921416866384134, 4.5}, {3.078583133615864, 4.5}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.115627578060309, 4.462955555555555}, {
            3.078583133615864, 4.5}, {3.115627578060309, 
            4.537044444444445}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.9444333333333335`, 4.4444333333333335`}, {
            3.0555666666666665`, 4.0555666666666665`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{3.1043530918511086`, 4.03647566234217}, {
            3.0555666666666665`, 4.0555666666666665`}, {3.0746576709911633`, 
            4.104353091851109}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{4., 4.4444333333333335`}, {4., 4.0555666666666665`}}]}, 
          {GrayLevel[0.5], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           LineBox[{{4.037044444444445, 4.092611111111111}, {4., 
            4.0555666666666665`}, {3.9629555555555553`, 4.092611111111111}}], 
           InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               StyleBox["\<\"v\"\>",
                StripOnInput->False,
                FontFamily->"BookAntiqua",
                FontSlant->Italic],
               DisplayForm],
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {-1.1315077777777778`, 2.25}, {0, 0}, Automatic, {
            0, 1}], InsetBox[
            TagBox[
             StyleBox[
              TagBox["\<\"0\"\>",
               DisplayForm],
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {0., -0.3092611111111111}, {0, 1}, Automatic, {1, 
            0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox["\<\"1\"\>",
               DisplayForm],
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {1., -0.3092611111111111}, {0, 1}, Automatic, {1, 
            0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox["\<\"2\"\>",
               DisplayForm],
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {2., -0.3092611111111111}, {0, 1}, Automatic, {1, 
            0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox["\<\"\[CenterEllipsis]\"\>",
               DisplayForm],
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {3., -0.3092611111111111}, {0, 1}, Automatic, {1, 
            0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               TagBox[
                StyleBox["\<\"N\"\>",
                 FontSlant->"Italic"],
                StyleForm[#, FontSlant -> "Italic"]& ],
               DisplayForm],
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {4., -0.309261111111111}, {-1, 1}, Automatic, {1, 
            0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               InterpretationBox[
                SubsuperscriptBox[
                 TagBox[
                  StyleBox["\<\"O\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TagBox[
                  StyleBox["\<\"N\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TemplateBox[{"\"(\"","0","\")\""},
                  "Row",
                  
                  DisplayFunction->(
                   RowBox[{#, "\[InvisibleSpace]", #2, 
                    "\[InvisibleSpace]", #3}]& ),
                  InterpretationFunction->(RowBox[{"Row", "[", 
                    RowBox[{"{", 
                    RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )]],
                Subsuperscript[
                 StyleForm["O", FontSlant -> "Italic"], 
                 StyleForm["N", FontSlant -> "Italic"], 
                 Row[{"(", 0, ")"}]],
                Editable->False],
               DisplayForm],
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {-0.5, 0.}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               InterpretationBox[
                SubsuperscriptBox[
                 TagBox[
                  StyleBox["\<\"T\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TagBox[
                  StyleBox["\<\"N\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TemplateBox[{"\"(\"","0","\")\""},
                  "Row",
                  
                  DisplayFunction->(
                   RowBox[{#, "\[InvisibleSpace]", #2, 
                    "\[InvisibleSpace]", #3}]& ),
                  InterpretationFunction->(RowBox[{"Row", "[", 
                    RowBox[{"{", 
                    RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )]],
                Subsuperscript[
                 StyleForm["T", FontSlant -> "Italic"], 
                 StyleForm["N", FontSlant -> "Italic"], 
                 Row[{"(", 0, ")"}]],
                Editable->False],
               DisplayForm],
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {-0.5, 0.5}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               InterpretationBox[
                SubsuperscriptBox[
                 TagBox[
                  StyleBox["\<\"O\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TagBox[
                  StyleBox["\<\"N\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TemplateBox[{"\"(\"","1","\")\""},
                  "Row",
                  
                  DisplayFunction->(
                   RowBox[{#, "\[InvisibleSpace]", #2, 
                    "\[InvisibleSpace]", #3}]& ),
                  InterpretationFunction->(RowBox[{"Row", "[", 
                    RowBox[{"{", 
                    RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )]],
                Subsuperscript[
                 StyleForm["O", FontSlant -> "Italic"], 
                 StyleForm["N", FontSlant -> "Italic"], 
                 Row[{"(", 1, ")"}]],
                Editable->False],
               DisplayForm],
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {-0.5, 1.}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               InterpretationBox[
                SubsuperscriptBox[
                 TagBox[
                  StyleBox["\<\"T\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TagBox[
                  StyleBox["\<\"N\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TemplateBox[{"\"(\"","1","\")\""},
                  "Row",
                  
                  DisplayFunction->(
                   RowBox[{#, "\[InvisibleSpace]", #2, 
                    "\[InvisibleSpace]", #3}]& ),
                  InterpretationFunction->(RowBox[{"Row", "[", 
                    RowBox[{"{", 
                    RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )]],
                Subsuperscript[
                 StyleForm["T", FontSlant -> "Italic"], 
                 StyleForm["N", FontSlant -> "Italic"], 
                 Row[{"(", 1, ")"}]],
                Editable->False],
               DisplayForm],
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {-0.5, 1.5}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               InterpretationBox[
                SubsuperscriptBox[
                 TagBox[
                  StyleBox["\<\"O\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TagBox[
                  StyleBox["\<\"N\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TemplateBox[{"\"(\"","2","\")\""},
                  "Row",
                  
                  DisplayFunction->(
                   RowBox[{#, "\[InvisibleSpace]", #2, 
                    "\[InvisibleSpace]", #3}]& ),
                  InterpretationFunction->(RowBox[{"Row", "[", 
                    RowBox[{"{", 
                    RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )]],
                Subsuperscript[
                 StyleForm["O", FontSlant -> "Italic"], 
                 StyleForm["N", FontSlant -> "Italic"], 
                 Row[{"(", 2, ")"}]],
                Editable->False],
               DisplayForm],
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {-0.5, 2.}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               InterpretationBox[
                SubsuperscriptBox[
                 TagBox[
                  StyleBox["\<\"T\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TagBox[
                  StyleBox["\<\"N\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TemplateBox[{"\"(\"","2","\")\""},
                  "Row",
                  
                  DisplayFunction->(
                   RowBox[{#, "\[InvisibleSpace]", #2, 
                    "\[InvisibleSpace]", #3}]& ),
                  InterpretationFunction->(RowBox[{"Row", "[", 
                    RowBox[{"{", 
                    RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )]],
                Subsuperscript[
                 StyleForm["T", FontSlant -> "Italic"], 
                 StyleForm["N", FontSlant -> "Italic"], 
                 Row[{"(", 2, ")"}]],
                Editable->False],
               DisplayForm],
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {-0.5, 2.5}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               InterpretationBox[
                SubsuperscriptBox[
                 TagBox[
                  StyleBox["\<\"O\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TagBox[
                  StyleBox["\<\"N\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TemplateBox[{"\"(\"","3","\")\""},
                  "Row",
                  
                  DisplayFunction->(
                   RowBox[{#, "\[InvisibleSpace]", #2, 
                    "\[InvisibleSpace]", #3}]& ),
                  InterpretationFunction->(RowBox[{"Row", "[", 
                    RowBox[{"{", 
                    RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )]],
                Subsuperscript[
                 StyleForm["O", FontSlant -> "Italic"], 
                 StyleForm["N", FontSlant -> "Italic"], 
                 Row[{"(", 3, ")"}]],
                Editable->False],
               DisplayForm],
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {-0.5, 3.}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               InterpretationBox[
                SubsuperscriptBox[
                 TagBox[
                  StyleBox["\<\"T\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TagBox[
                  StyleBox["\<\"N\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TemplateBox[{"\"(\"","3","\")\""},
                  "Row",
                  
                  DisplayFunction->(
                   RowBox[{#, "\[InvisibleSpace]", #2, 
                    "\[InvisibleSpace]", #3}]& ),
                  InterpretationFunction->(RowBox[{"Row", "[", 
                    RowBox[{"{", 
                    RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )]],
                Subsuperscript[
                 StyleForm["T", FontSlant -> "Italic"], 
                 StyleForm["N", FontSlant -> "Italic"], 
                 Row[{"(", 3, ")"}]],
                Editable->False],
               DisplayForm],
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {-0.5, 3.5}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               InterpretationBox[
                SubsuperscriptBox[
                 TagBox[
                  StyleBox["\<\"O\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TagBox[
                  StyleBox["\<\"N\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TemplateBox[{"\"(\"","4","\")\""},
                  "Row",
                  
                  DisplayFunction->(
                   RowBox[{#, "\[InvisibleSpace]", #2, 
                    "\[InvisibleSpace]", #3}]& ),
                  InterpretationFunction->(RowBox[{"Row", "[", 
                    RowBox[{"{", 
                    RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )]],
                Subsuperscript[
                 StyleForm["O", FontSlant -> "Italic"], 
                 StyleForm["N", FontSlant -> "Italic"], 
                 Row[{"(", 4, ")"}]],
                Editable->False],
               DisplayForm],
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {-0.5, 4.}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               InterpretationBox[
                SubsuperscriptBox[
                 TagBox[
                  StyleBox["\<\"T\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TagBox[
                  StyleBox["\<\"N\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], 
                 TemplateBox[{"\"(\"","4","\")\""},
                  "Row",
                  
                  DisplayFunction->(
                   RowBox[{#, "\[InvisibleSpace]", #2, 
                    "\[InvisibleSpace]", #3}]& ),
                  InterpretationFunction->(RowBox[{"Row", "[", 
                    RowBox[{"{", 
                    RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )]],
                Subsuperscript[
                 StyleForm["T", FontSlant -> "Italic"], 
                 StyleForm["N", FontSlant -> "Italic"], 
                 Row[{"(", 4, ")"}]],
                Editable->False],
               DisplayForm],
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {-0.5, 4.5}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               TemplateBox[{"\"(\"","47","\")\""},
                "Row",
                
                DisplayFunction->(
                 RowBox[{#, "\[InvisibleSpace]", #2, 
                   "\[InvisibleSpace]", #3}]& ),
                InterpretationFunction->(RowBox[{"Row", "[", 
                   RowBox[{"{", 
                    RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
               DisplayForm],
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {4.5, 0.25}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               TemplateBox[{"\"(\"","54","\")\""},
                "Row",
                
                DisplayFunction->(
                 RowBox[{#, "\[InvisibleSpace]", #2, 
                   "\[InvisibleSpace]", #3}]& ),
                InterpretationFunction->(RowBox[{"Row", "[", 
                   RowBox[{"{", 
                    RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
               DisplayForm],
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {4.5, 0.75}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               TemplateBox[{"\"(\"","48","\")\""},
                "Row",
                
                DisplayFunction->(
                 RowBox[{#, "\[InvisibleSpace]", #2, 
                   "\[InvisibleSpace]", #3}]& ),
                InterpretationFunction->(RowBox[{"Row", "[", 
                   RowBox[{"{", 
                    RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
               DisplayForm],
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {4.5, 1.25}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               TemplateBox[{"\"(\"","55","\")\""},
                "Row",
                
                DisplayFunction->(
                 RowBox[{#, "\[InvisibleSpace]", #2, 
                   "\[InvisibleSpace]", #3}]& ),
                InterpretationFunction->(RowBox[{"Row", "[", 
                   RowBox[{"{", 
                    RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
               DisplayForm],
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {4.5, 1.75}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               TemplateBox[{"\"(\"","49","\")\""},
                "Row",
                
                DisplayFunction->(
                 RowBox[{#, "\[InvisibleSpace]", #2, 
                   "\[InvisibleSpace]", #3}]& ),
                InterpretationFunction->(RowBox[{"Row", "[", 
                   RowBox[{"{", 
                    RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
               DisplayForm],
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {4.5, 2.25}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               TemplateBox[{"\"(\"","56","\")\""},
                "Row",
                
                DisplayFunction->(
                 RowBox[{#, "\[InvisibleSpace]", #2, 
                   "\[InvisibleSpace]", #3}]& ),
                InterpretationFunction->(RowBox[{"Row", "[", 
                   RowBox[{"{", 
                    RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
               DisplayForm],
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {4.5, 2.75}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               TemplateBox[{"\"(\"","50","\")\""},
                "Row",
                
                DisplayFunction->(
                 RowBox[{#, "\[InvisibleSpace]", #2, 
                   "\[InvisibleSpace]", #3}]& ),
                InterpretationFunction->(RowBox[{"Row", "[", 
                   RowBox[{"{", 
                    RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
               DisplayForm],
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {4.5, 3.25}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               TemplateBox[{"\"(\"","57","\")\""},
                "Row",
                
                DisplayFunction->(
                 RowBox[{#, "\[InvisibleSpace]", #2, 
                   "\[InvisibleSpace]", #3}]& ),
                InterpretationFunction->(RowBox[{"Row", "[", 
                   RowBox[{"{", 
                    RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
               DisplayForm],
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {4.5, 3.75}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox[
               TemplateBox[{"\"(\"","51","\")\""},
                "Row",
                
                DisplayFunction->(
                 RowBox[{#, "\[InvisibleSpace]", #2, 
                   "\[InvisibleSpace]", #3}]& ),
                InterpretationFunction->(RowBox[{"Row", "[", 
                   RowBox[{"{", 
                    RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )],
               DisplayForm],
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {4.5, 4.25}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox["\<\"\[VerticalEllipsis]\"\>",
               DisplayForm],
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {0., 4.75}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox["\<\"\[VerticalEllipsis]\"\>",
               DisplayForm],
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {1., 4.75}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox["\<\"\[VerticalEllipsis]\"\>",
               DisplayForm],
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {2., 4.75}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox["\<\"\[VerticalEllipsis]\"\>",
               DisplayForm],
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {3., 4.75}, {0, 0}, Automatic, {1, 0}], InsetBox[
            TagBox[
             StyleBox[
              TagBox["\<\"\[VerticalEllipsis]\"\>",
               DisplayForm],
              ShowAutoStyles->False,
              SingleLetterItalics->False,
              FontFamily->"Times",
              FontSize->12,
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontColor->GrayLevel[0],
              FontOpacity->1],
             DisplayForm], {4., 4.75}, {0, 0}, Automatic, {1, 0}]}}}}}}}}},
  AspectRatio->1,
  Axes->False,
  Background->None,
  BaseStyle->{
   FontFamily -> "Times", FontSize -> 12, FontSlant -> "Plain", FontTracking -> 
    "Plain", FontWeight -> "Plain", FontColor -> GrayLevel[0], FontOpacity -> 
    1, ShowAutoStyles -> False, SingleLetterItalics -> False},
  DisplayFunction->Identity,
  Frame->False,
  FrameLabel->{None, None, None, None},
  FrameStyle->Directive[{
     GrayLevel[0], 
     Opacity[1], 
     CapForm[None], 
     AbsoluteThickness[1], 
     AbsoluteDashing[{}]}],
  FrameTicks->None,
  ImageSize->{432, 432},
  PlotRange->{{-2.0008, 6.0008}, {-2.0008, 6.0008}},
  Ticks->None]], "Output",
 CellChangeTimes->{3.495658088125*^9, 3.4956581224375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Nuclear structure: A multipanel diagram", "Section",
 CellChangeTimes->{{3.488147355921875*^9, 3.488147357953125*^9}, {
  3.488366055109375*^9, 3.488366057859375*^9}, {3.491258720046875*^9, 
  3.491258744515625*^9}, {3.4956593404375*^9, 3.49565936984375*^9}}],

Cell["\<\
This provides plenty of examples of defining functions to draw different \
diagram elements, and also an example of PDF import.\
\>", "Text",
 CellChangeTimes->{{3.495659372296875*^9, 3.495659403046875*^9}}],

Cell["import PDF graphics", "Text",
 CellChangeTimes->{{3.488837807625*^9, 3.488837812*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"EllipsoidGraphics", "=", 
   RowBox[{
   "Import", "[", 
    "\"\<LevelScheme/ExampleData/nuclpict_modes_redblue_Y22C.pdf\>\"", 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.4881504998125*^9, 3.488150503515625*^9}, {
   3.488151365*^9, 3.488151434515625*^9}, {3.488281363875*^9, 
   3.488281364125*^9}, {3.48828319428125*^9, 3.488283206625*^9}, {
   3.48883605475*^9, 3.488836058734375*^9}, {3.48883632528125*^9, 
   3.488836343359375*^9}, {3.488837665890625*^9, 3.4888376971875*^9}, {
   3.4888377524375*^9, 3.488837773359375*^9}, 3.492125327390625*^9, 
   3.492125423609375*^9, {3.495659420765625*^9, 3.495659433921875*^9}, {
   3.501273983125*^9, 3.50127398465625*^9}}],

Cell["generate points for plot", "Text",
 CellChangeTimes->{{3.488837814328125*^9, 3.48883781725*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ParamFcn", "[", 
    RowBox[{"eta0_", ",", "xi_", ",", "x0_", ",", "x_"}], "]"}], ":=", 
   RowBox[{"eta0", "*", 
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{"Tanh", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"x", "-", "x0"}], ")"}], "/", "xi"}], "]"}]}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ParamPlot", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"ParamFcn", "[", 
      RowBox[{"0.5", ",", "2", ",", "3", ",", "x"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", "5"}], "}"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"BCSPoints", "=", 
   RowBox[{"Reverse", "/@", 
    RowBox[{"GrabPoints", "[", "ParamPlot", "]"}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.488287030796875*^9, 3.488287140765625*^9}, {
   3.488287203453125*^9, 3.48828723346875*^9}, {3.4883661865625*^9, 
   3.488366191640625*^9}, 3.48883780009375*^9, 3.488838298734375*^9}],

Cell["\<\
define simple (or maybe not-so-simple) functions to draw particles in pairing \
diagram\
\>", "Text",
 CellChangeTimes->{{3.48883782228125*^9, 3.488837886296875*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "ShellPoint", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"N", "\[Rule]", "6"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ShellPoint", "[", 
    RowBox[{"y_Integer", ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"k_", "?", "NumericQ"}], ")"}], "?", "Positive"}], ",", 
     RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"k", "/", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"OptionValue", "[", "N", "]"}], "+", "1"}], ")"}]}], ",", 
     "y"}], "}"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.4882873059375*^9, 3.488287365390625*^9}, {
  3.4882879288125*^9, 3.488287930125*^9}, {3.488288016734375*^9, 
  3.48828802465625*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "ShellDot", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"DotRadius", "\[Rule]", 
      RowBox[{"Point", "[", "2", "]"}]}], ",", 
     RowBox[{"DotOptions", "\[Rule]", 
      RowBox[{"{", "}"}]}], ",", 
     RowBox[{"Occupied", "\[Rule]", "True"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ShellDot", "[", 
    RowBox[{"y_Integer", ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"k_", "?", "NumericQ"}], ")"}], "?", "Positive"}], ",", 
     RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"SchemeCircle", "[", 
       RowBox[{
        RowBox[{"ShellPoint", "[", 
         RowBox[{"y", ",", "k"}], "]"}], ",", 
        RowBox[{"OptionValue", "[", "DotRadius", "]"}], ",", 
        RowBox[{"OptionValue", "[", "DotOptions", "]"}], ",", 
        RowBox[{"ShowFill", "\[Rule]", 
         RowBox[{"OptionValue", "[", "Occupied", "]"}]}]}], "]"}], 
      "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.4881972606875*^9, 3.48819726125*^9}, {
   3.48819761890625*^9, 3.488197640078125*^9}, {3.488197678703125*^9, 
   3.488197890359375*^9}, {3.48819821825*^9, 3.488198263234375*^9}, {
   3.488198308421875*^9, 3.488198312375*^9}, {3.488198395109375*^9, 
   3.488198438765625*^9}, {3.4881985739375*^9, 3.48819859771875*^9}, 
   3.488198711578125*^9, {3.488198764453125*^9, 3.48819877359375*^9}, {
   3.488286746453125*^9, 3.48828680965625*^9}, 3.488287302984375*^9, {
   3.48828737040625*^9, 3.4882873770625*^9}, 3.488287934296875*^9, {
   3.488288019296875*^9, 3.488288020203125*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "ShellPair", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ExtraRadius", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}]}], ",", 
     RowBox[{"NucleonShift", "\[Rule]", "0"}], ",", 
     RowBox[{"PairOptions", "\[Rule]", 
      RowBox[{"{", "}"}]}], ",", 
     RowBox[{"NucleonOptions", "\[Rule]", 
      RowBox[{"{", "}"}]}], ",", 
     RowBox[{"ArrowOptions", "\[Rule]", 
      RowBox[{"{", "}"}]}], ",", 
     RowBox[{"ArrowVector", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0.2"}], "}"}]}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ShellPair", "[", 
   RowBox[{"y_Integer", ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"k_", "?", "NumericQ"}], ")"}], "?", "Positive"}], ",", 
    RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{"P1", ",", "P2"}], "\[IndentingNewLine]", "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"P1", "=", 
        RowBox[{"ShellPoint", "[", 
         RowBox[{"y", ",", 
          RowBox[{"k", "+", 
           RowBox[{"OptionValue", "[", "NucleonShift", "]"}]}]}], "]"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"P2", "=", 
        RowBox[{"ShellPoint", "[", 
         RowBox[{"y", ",", 
          RowBox[{"k", "+", "1", "-", 
           RowBox[{"OptionValue", "[", "NucleonShift", "]"}]}]}], "]"}]}], 
       ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"SchemeCircle", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Mean", "[", 
          RowBox[{"{", 
           RowBox[{"P1", ",", "P2"}], "}"}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"1", "/", "2"}], "*", 
           RowBox[{"(", 
            RowBox[{"P2", "-", "P1"}], ")"}]}], "+", 
          RowBox[{"OptionValue", "[", "ExtraRadius", "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"OptionValue", "[", "PairOptions", "]"}]}], 
        "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"ShellDot", "[", 
       RowBox[{"y", ",", 
        RowBox[{"k", "+", 
         RowBox[{"OptionValue", "[", "NucleonShift", "]"}]}], ",", 
        RowBox[{"OptionValue", "[", "NucleonOptions", "]"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"ShellDot", "[", 
       RowBox[{"y", ",", 
        RowBox[{"k", "+", "1", "-", 
         RowBox[{"OptionValue", "[", "NucleonShift", "]"}]}], ",", 
        RowBox[{"OptionValue", "[", "NucleonOptions", "]"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"SchemeArrow", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"P1", "-", 
           RowBox[{"OptionValue", "[", "ArrowVector", "]"}]}], ",", 
          RowBox[{"P1", "+", 
           RowBox[{"OptionValue", "[", "ArrowVector", "]"}]}]}], "}"}], ",", 
        RowBox[{"OptionValue", "[", "ArrowOptions", "]"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"SchemeArrow", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"P2", "+", 
           RowBox[{"OptionValue", "[", "ArrowVector", "]"}]}], ",", 
          RowBox[{"P2", "-", 
           RowBox[{"OptionValue", "[", "ArrowVector", "]"}]}]}], "}"}], ",", 
        RowBox[{"OptionValue", "[", "ArrowOptions", "]"}]}], "]"}]}], 
     "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", "]"}]}]}], "Input",
 CellChangeTimes->{{3.48828741490625*^9, 3.4882875993125*^9}, {
   3.4882876493125*^9, 3.48828771003125*^9}, {3.4882877415625*^9, 
   3.488287771453125*^9}, {3.488287850625*^9, 3.488287867625*^9}, {
   3.48828789825*^9, 3.48828790909375*^9}, 3.488287941359375*^9, 
   3.48828801390625*^9, {3.4882880929375*^9, 3.488288126125*^9}, {
   3.4882881620625*^9, 3.488288302796875*^9}, {3.48828833475*^9, 
   3.48828836340625*^9}, {3.488836183375*^9, 3.488836185234375*^9}, {
   3.48883629878125*^9, 3.488836299453125*^9}}],

Cell["\<\
define functions to draw particles in a circle for shell model schematic\
\>", "Text",
 CellChangeTimes->{{3.488837914125*^9, 3.488837928015625*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DrawParticle", "[", 
    RowBox[{"R_", ",", "theta_", ",", "r_", ",", 
     RowBox[{"Opts___", "?", "OptionQ"}]}], "]"}], ":=", 
   RowBox[{"SchemeCircle", "[", 
    RowBox[{
     RowBox[{"ConvertCoordinate", "[", 
      RowBox[{"AbsoluteCoords", ",", "UserCoords", ",", "D", ",", 
       RowBox[{"R", "*", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Cos", "[", "theta", "]"}], ",", 
          RowBox[{"Sin", "[", "theta", "]"}]}], "}"}]}]}], "]"}], ",", 
     RowBox[{"Point", "[", "r", "]"}], ",", "Opts"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"NaturalDistance", "[", 
    RowBox[{"dtheta_", ",", "r_"}], "]"}], ":=", 
   RowBox[{"r", "*", 
    RowBox[{"Sec", "[", 
     RowBox[{
      RowBox[{"1", "/", "2"}], "*", 
      RowBox[{"(", 
       RowBox[{"Pi", "-", "dtheta"}], ")"}]}], "]"}]}]}], ";"}]}], "Input",
 CellChangeTimes->{3.405207762953125*^9}],

Cell["put it all together", "Text",
 CellChangeTimes->{{3.488837934859375*^9, 3.488837937234375*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Figure", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Multipanel", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"2", ",", "3"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"XPlotRanges", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "1"}], "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"YPlotRanges", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "1"}], "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"ExtendRange", "\[Rule]", "0.25"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Frame", "\[Rule]", "False"}], ",", "\[IndentingNewLine]", 
       RowBox[{"ShowPanelLetter", "\[Rule]", "False"}]}], 
      "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"SetOptions", "[", 
      RowBox[{"ScaledLabel", ",", 
       RowBox[{"FontSize", "\[Rule]", "15"}]}], "]"}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", "nucleus", " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"FigurePanel", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}], ",", 
       RowBox[{"PanelLetter", "\[Rule]", "None"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ScaledLabel", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0.5", ",", "1"}], "}"}], ",", "\"\<Nucleon interactions\>\"",
        ",", 
       RowBox[{"Offset", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{"+", "1"}]}], "}"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"BlockSchemeOptions", "[", "\[IndentingNewLine]", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"SeedRandom", "[", "3", "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"RNucl", "=", "1"}], ";", "\[IndentingNewLine]", 
         RowBox[{"SchemeCircle", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "0"}], "}"}], ",", "RNucl", ",", 
           RowBox[{"FillColor", "\[Rule]", "Gray"}], ",", 
           RowBox[{"ShowLine", "\[Rule]", "False"}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Table", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"SchemeCircle", "[", 
           RowBox[{
            RowBox[{"Polar", "[", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"0.7", "*", "RNucl", "*", 
                RowBox[{"Random", "[", "]"}]}], ",", 
               RowBox[{"2", "*", "Pi", "*", 
                RowBox[{"Random", "[", "]"}]}]}], "}"}], "]"}], ",", 
            RowBox[{"Point", "[", "14", "]"}], ",", 
            RowBox[{"FillColor", "\[Rule]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Random", "[", "Integer", "]"}], "\[Equal]", "1"}], 
               ",", "Red", ",", "DimGray"}], "]"}]}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"n", ",", "1", ",", "100"}], "}"}]}], 
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "}"}], 
      "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"shell", " ", "structure"}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"FigurePanel", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "2"}], "}"}], ",", 
       RowBox[{"PanelLetter", "\[Rule]", "\"\<(a)\>\""}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ScaledLabel", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0.5", ",", "1"}], "}"}], ",", "\"\<Shell structure\>\"", ",", 
       RowBox[{"Offset", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{"+", "1"}]}], "}"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"BlockSchemeOptions", "[", "\[IndentingNewLine]", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"RN", "=", "8"}], ",", "\[IndentingNewLine]", 
        RowBox[{"R1", "=", 
         RowBox[{"1.2", "*", 
          RowBox[{"Sqrt", "[", "2", "]"}], "*", "RN"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"R2", "=", 
         RowBox[{"1.7", "*", "2.61", "*", "RN"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"SetOptions", "[", 
         RowBox[{"SchemeCircle", ",", 
          RowBox[{"FillColor", "\[Rule]", "Automatic"}], ",", 
          RowBox[{"LabC", "\[Rule]", "None"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForEach", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"DrawParticle", "[", 
           RowBox[{"R1", ",", "theta", ",", "RN", ",", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"OddQ", "[", "i", "]"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"FillColor", "\[Rule]", "Red"}], ",", 
                RowBox[{"LabC", "\[Rule]", 
                 RowBox[{"textit", "@", "\"\<p\>\""}]}], ",", 
                RowBox[{"NudgeC", "\[Rule]", "1"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"FillColor", "\[Rule]", "DimGray"}], ",", 
                RowBox[{"LabC", "\[Rule]", 
                 RowBox[{"textit", "@", "\"\<n\>\""}]}]}], "}"}]}], "]"}]}], 
           "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"theta", ",", "i", ",", 
            RowBox[{"Range", "[", 
             RowBox[{"0", ",", 
              RowBox[{"2", "*", "Pi"}], ",", 
              RowBox[{"2", "*", 
               RowBox[{"Pi", "/", "4"}]}]}], "]"}]}], "}"}]}], 
         "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"TableForEach", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"DrawParticle", "[", 
           RowBox[{"R2", ",", "theta", ",", "RN", ",", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"OddQ", "[", "i", "]"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"FillColor", "\[Rule]", "Red"}], ",", 
                RowBox[{"LabC", "\[Rule]", 
                 RowBox[{"textit", "@", "\"\<p\>\""}]}], ",", 
                RowBox[{"NudgeC", "\[Rule]", "1"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"FillColor", "\[Rule]", "DimGray"}], ",", 
                RowBox[{"LabC", "\[Rule]", 
                 RowBox[{"textit", "@", "\"\<n\>\""}]}]}], "}"}]}], "]"}]}], 
           "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"theta", ",", "i", ",", 
            RowBox[{"Range", "[", 
             RowBox[{"0", ",", 
              RowBox[{"2", "*", "Pi"}], ",", 
              RowBox[{"2", "*", 
               RowBox[{"Pi", "/", "12"}]}]}], "]"}]}], "}"}]}], 
         "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"SetOptions", "[", 
         RowBox[{"SchemeCircle", ",", 
          RowBox[{"ShowFill", "\[Rule]", "False"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"SchemeCircle", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", 
          RowBox[{"Point", "[", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"R1", "+", "R2"}], ")"}], "/", "2"}], "]"}]}], "]"}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"SchemeCircle", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", 
          RowBox[{"Point", "[", 
           RowBox[{"2", "*", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"R1", "+", "R2"}], ")"}], "/", "2"}]}], "]"}]}], 
         "]"}]}], "\[IndentingNewLine]", "}"}], "\[IndentingNewLine]", "]"}], 
     ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", "deformation", " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"FigurePanel", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "3"}], "}"}], ",", 
       RowBox[{"ExtendRange", "\[Rule]", "0.15"}], ",", 
       RowBox[{"PanelLetter", "\[Rule]", "\"\<(b)\>\""}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ScaledLabel", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0.5", ",", "1"}], "}"}], ",", 
       "\"\<Collective deformation\>\"", ",", 
       RowBox[{"Offset", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{"+", "1"}]}], "}"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"FigGraphics", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}], ",", 
       "EllipsoidGraphics"}], "]"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"alpha", " ", "cluster"}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"FigurePanel", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"2", ",", "2"}], "}"}], ",", 
       RowBox[{"PanelLetter", "\[Rule]", "\"\<(c)\>\""}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ScaledLabel", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0.5", ",", "0"}], "}"}], ",", "\"\<Cluster correlations\>\"",
        ",", 
       RowBox[{"Offset", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{"-", "1"}]}], "}"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"BlockSchemeOptions", "[", "\[IndentingNewLine]", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Ralpha", "=", "20"}], ",", "\[IndentingNewLine]", 
        RowBox[{"SetOptions", "[", 
         RowBox[{"SchemeCircle", ",", 
          RowBox[{"FillColor", "\[Rule]", "Gold"}], ",", 
          RowBox[{"LabC", "->", "\"\<\[Alpha]\>\""}], ",", 
          RowBox[{"FontSize", "\[Rule]", "16"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Table", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"DrawParticle", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"2", "/", 
              RowBox[{"Sqrt", "[", "3", "]"}]}], "*", "Ralpha"}], ",", 
            "theta", ",", "Ralpha"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"theta", ",", "0", ",", 
            RowBox[{"2", "*", "Pi"}], ",", 
            RowBox[{"2", "*", 
             RowBox[{"Pi", "/", "3"}]}]}], "}"}]}], "\[IndentingNewLine]", 
         "]"}]}], "\[IndentingNewLine]", "}"}], "\[IndentingNewLine]", "]"}], 
     ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", "pairing", " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"FigurePanel", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"2", ",", "3"}], "}"}], ",", 
       RowBox[{"PlotRange", "->", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "0.25"}], ",", "1.25"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1.5"}], ",", "5.5"}], "}"}]}], "}"}]}], ",", 
       RowBox[{"ExtendRange", "\[Rule]", "0.05"}], ",", 
       RowBox[{"PanelLetter", "\[Rule]", "\"\<(d)\>\""}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ScaledLabel", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0.5", ",", "0"}], "}"}], ",", "\"\<Pair condensation\>\"", 
       ",", 
       RowBox[{"Offset", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{"-", "1"}]}], "}"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"BlockSchemeOptions", "[", "\[IndentingNewLine]", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"SetOptions", "[", 
         RowBox[{"SchemeAxis", ",", 
          RowBox[{"HeadLength", "\[Rule]", "5"}], ",", 
          RowBox[{"HeadLip", "\[Rule]", "3"}], ",", 
          RowBox[{"Color", "\[Rule]", "DimGray"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"SchemeAxis", "[", 
         RowBox[{"Left", ",", 
          RowBox[{"-", "0.1"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "0.5"}], ",", "5.5"}], "}"}], ",", 
          RowBox[{"LabL", "\[Rule]", 
           RowBox[{"textit", "[", "\"\<E\>\"", "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"SetOptions", "[", 
         RowBox[{"Lev", ",", 
          RowBox[{"Margin", "\[Rule]", "0"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"SetOptions", "[", 
         RowBox[{"ShellPair", ",", 
          RowBox[{"NucleonShift", "\[Rule]", "0.15"}], ",", 
          RowBox[{"ExtraRadius", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"0.05", ",", "0.3"}], "}"}]}], ",", 
          RowBox[{"PairOptions", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"FillColor", "\[Rule]", "Moccasin"}], "}"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"ArrowOptions", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"HeadLength", "\[Rule]", "2"}], ",", 
             RowBox[{"HeadLip", "\[Rule]", "2"}]}], "}"}]}], ",", 
          RowBox[{"ArrowVector", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"0.025", ",", "0.2"}], "}"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Table", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Lev", "[", 
           RowBox[{"0", ",", "1", ",", "i"}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"i", ",", "0", ",", "5"}], "}"}]}], "\[IndentingNewLine]", 
         "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"ShellPair", "[", 
         RowBox[{"0", ",", "1"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"ShellPair", "[", 
         RowBox[{"0", ",", "3"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"ShellPair", "[", 
         RowBox[{"0", ",", "5"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"ShellPair", "[", 
         RowBox[{"1", ",", "1"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"ShellPair", "[", 
         RowBox[{"1", ",", "3"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"ShellPair", "[", 
         RowBox[{"2", ",", "1"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"ShellPair", "[", 
         RowBox[{"2", ",", "3"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"ShellPair", "[", 
         RowBox[{"3", ",", "1"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"ShellDot", "[", 
             RowBox[{"0", ",", "k"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"k", ",", "1", ",", "6"}], "}"}]}], "]"}], ","}], "*)"}],
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"SchemeLine", "[", 
         RowBox[{"BCSPoints", ",", 
          RowBox[{"Thickness", "\[Rule]", "2"}], ",", 
          RowBox[{"Color", "\[Rule]", "Gray"}], ",", 
          RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}]}], "\[IndentingNewLine]",
        "}"}], "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"interpanel", " ", "arrows"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"Px", "=", "0.1"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Do", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"FigurePanel", "[", 
          RowBox[{"{", 
           RowBox[{"i", ",", "j"}], "}"}], "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"SavePoint", "[", 
          RowBox[{
           RowBox[{"PL", "[", 
            RowBox[{"i", ",", "j"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"Px", ",", "0.5"}], "}"}], ",", "ScaledCoords"}], "]"}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{"SavePoint", "[", 
          RowBox[{
           RowBox[{"PR", "[", 
            RowBox[{"i", ",", "j"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"1", "-", "Px"}], ",", "0.5"}], "}"}], ",", 
           "ScaledCoords"}], "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"SavePoint", "[", 
          RowBox[{
           RowBox[{"PT", "[", 
            RowBox[{"i", ",", "j"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"0.5", ",", 
             RowBox[{"1", "-", "Px"}]}], "}"}], ",", "ScaledCoords"}], "]"}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{"SavePoint", "[", 
          RowBox[{
           RowBox[{"PB", "[", 
            RowBox[{"i", ",", "j"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"0.5", ",", "Px"}], "}"}], ",", "ScaledCoords"}], "]"}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{"SavePoint", "[", 
          RowBox[{
           RowBox[{"PTL", "[", 
            RowBox[{"i", ",", "j"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Px", "/", 
              RowBox[{"Sqrt", "[", "2", "]"}]}], ",", 
             RowBox[{"1", "-", 
              RowBox[{"Px", "/", 
               RowBox[{"Sqrt", "[", "2", "]"}]}]}]}], "}"}], ",", 
           "ScaledCoords"}], "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"SavePoint", "[", 
          RowBox[{
           RowBox[{"PBR", "[", 
            RowBox[{"i", ",", "j"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"1", "-", 
              RowBox[{"Px", "/", 
               RowBox[{"Sqrt", "[", "2", "]"}]}]}], ",", 
             RowBox[{"Px", "/", 
              RowBox[{"Sqrt", "[", "2", "]"}]}]}], "}"}], ",", 
           "ScaledCoords"}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", "2"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "1", ",", "3"}], "}"}]}], "\[IndentingNewLine]", 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"SetRegion", "[", "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"SetOptions", "[", 
      RowBox[{"SchemeArrow", ",", 
       RowBox[{"ArrowType", "\[Rule]", "MultilineArrow"}], ",", 
       RowBox[{"ShowFill", "\[Rule]", "False"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"SchemeArrow", "[", 
      RowBox[{
       RowBox[{"GetPoint", "[", 
        RowBox[{"PR", "[", 
         RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
       RowBox[{"GetPoint", "[", 
        RowBox[{"PL", "[", 
         RowBox[{"1", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"SchemeArrow", "[", 
      RowBox[{
       RowBox[{"GetPoint", "[", 
        RowBox[{"PR", "[", 
         RowBox[{"1", ",", "2"}], "]"}], "]"}], ",", 
       RowBox[{"GetPoint", "[", 
        RowBox[{"PL", "[", 
         RowBox[{"1", ",", "3"}], "]"}], "]"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"SchemeArrow", "[", 
      RowBox[{
       RowBox[{"GetPoint", "[", 
        RowBox[{"PB", "[", 
         RowBox[{"1", ",", "2"}], "]"}], "]"}], ",", 
       RowBox[{"GetPoint", "[", 
        RowBox[{"PT", "[", 
         RowBox[{"2", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"SchemeArrow", "[", 
      RowBox[{
       RowBox[{"GetPoint", "[", 
        RowBox[{"PBR", "[", 
         RowBox[{"1", ",", "2"}], "]"}], "]"}], ",", 
       RowBox[{"GetPoint", "[", 
        RowBox[{"PTL", "[", 
         RowBox[{"2", ",", "3"}], "]"}], "]"}]}], "]"}], ","}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
   RowBox[{"ImageSize", "\[Rule]", 
    RowBox[{"72", "*", "0.7", "*", 
     RowBox[{"{", 
      RowBox[{"9", ",", "6"}], "}"}]}]}], ",", "\[IndentingNewLine]", 
   RowBox[{"Frame", "\[Rule]", "False"}]}], "\[IndentingNewLine]", 
  "]"}]], "Input",
 CellChangeTimes->{{3.4052021644375*^9, 3.40520220715625*^9}, {
   3.405202238578125*^9, 3.40520223878125*^9}, {3.405202292609375*^9, 
   3.405202309484375*^9}, {3.405202468546875*^9, 3.405202475*^9}, {
   3.4052025325*^9, 3.405202631546875*^9}, {3.405202731875*^9, 
   3.405203287703125*^9}, {3.405203325578125*^9, 3.40520335125*^9}, {
   3.40520343996875*^9, 3.40520350828125*^9}, {3.405204675671875*^9, 
   3.405204740328125*^9}, {3.40520477325*^9, 3.405204832828125*^9}, 
   3.48828153896875*^9, {3.488281624859375*^9, 3.488281694890625*^9}, {
   3.488282148296875*^9, 3.48828228190625*^9}, {3.488283226109375*^9, 
   3.488283247671875*^9}, {3.488284071875*^9, 3.488284109640625*^9}, {
   3.488284168796875*^9, 3.48828417221875*^9}, {3.4882842058125*^9, 
   3.488284228625*^9}, {3.48828430809375*^9, 3.488284327875*^9}, {
   3.488284477984375*^9, 3.488284618828125*^9}, {3.48828465840625*^9, 
   3.48828473565625*^9}, {3.488284768390625*^9, 3.488284768515625*^9}, {
   3.48828486096875*^9, 3.48828487484375*^9}, {3.488285554125*^9, 
   3.48828555965625*^9}, {3.488285643921875*^9, 3.488285679796875*^9}, {
   3.48828572040625*^9, 3.488285809015625*^9}, {3.48828585146875*^9, 
   3.488285871390625*^9}, {3.488285908734375*^9, 3.488285993140625*^9}, {
   3.48828603015625*^9, 3.4882860306875*^9}, {3.4882863721875*^9, 
   3.4882863745*^9}, {3.488286417671875*^9, 3.488286417984375*^9}, {
   3.488286548703125*^9, 3.48828660359375*^9}, {3.488288503765625*^9, 
   3.4882886588125*^9}, {3.48828869615625*^9, 3.4882887044375*^9}, {
   3.48828874446875*^9, 3.48828880053125*^9}, {3.48828883409375*^9, 
   3.488288835765625*^9}, {3.48828887921875*^9, 3.48828893128125*^9}, {
   3.4882889638125*^9, 3.488289012578125*^9}, {3.48828904384375*^9, 
   3.48828904496875*^9}, {3.488289172609375*^9, 3.488289173109375*^9}, {
   3.48883601928125*^9, 3.488836033484375*^9}, {3.488836390515625*^9, 
   3.488836414484375*^9}}],

Cell[BoxData[
 GraphicsBox[
  {GrayLevel[0.5], AbsoluteThickness[2], Opacity[1], Dashing[{}], CapForm[
   None], LineBox[CompressedData["
1:eJwV02s0lAkcBvDJaROtmghJF7c4IWrDlpYndFnXVrLIKAZRycollzK02pKo
pjY6qYidRJu0q5FyaZLbjEYYE3qlVfLOzPtuK20qyb774X+e8zvPp+fD35j7
07ZINRaL5c3c/6kXGbCvrICGafQ/L2UPGhCe5v91DuO+M+FHg1sbsO/H4ZIY
xqdq5WbDjxtgtrKwajXjj5r1kW8GGsC9Y+1zP5+G9OaJUY1/G5DePnqq4zyN
1HETlfOKRrgHcOaNnqPRyfN/e53fCHta6jN5mka9R0im8+oHaCk5IRg8RsNS
qb29VEcEzaEa9sl0GlzfiET1URGaTJK45xNoCB/kaWwWPkScy/t2cRQNyV31
CN2CJrCmbRZKgmncSFky51X0IxzS++NdsTcNL1FWsptXM3o93RXJzjQ0tR8G
plu1QPqt3wcTWxrnLC8dE0624MKMQRfTJTQGJS2pmYOtGKyw3PFJk8Zbu7xa
96o2LB2pceyboGByzSqW5rWDt431LPsvCrrFi0jjXWIszs3KdZBQ6A4TVPqv
kkBcb8ryv03hh98zHRfpdMCUL7xhm09B+WXN+tqxDqzz1gvzPsT0BlnZAaLH
uJV37lMsh8LBOpPCYyVSzJiRs3+2M4Voi52fqhM7IXbYLtptSCFPK2meo/UT
2PX2BIkmVEicY0HMuvQE2Ubh8Yt7VXChzbf6zexCWX3dmuWVKsTqdJpFJ3VB
OsJW8bNVOLKkufjz8y4I2qpLG7kqlFhZBPA2d+NCAVHdvlYFU97quDZhNwwy
Lq94w1Yhp/qE7dllPWhedmnWNyNK+Nrm+Jrxe7CxiYr/u1YJi8r3N0tZMnR1
iw5n8JUYZt+uKomWYff7vCJxpBJfanT09vbLUBBPhvo7KTHt+sj4tmsv/KVm
njZ6SsztfhE1Ut4LrcukbjKlAE8gYA8byNFYEeMa16KAjHN3186f5RBnF42G
XFEgJzBhfum4HBGfzWys0xQwX3t4T1TIU0wZ3O96G6BAp+HY5MLmp5BzlJYB
dgoMuM0dO2vfh7g/X728uEAB8dbU3NwrfTiZIEohx0ksKs7N8WH3IyGi3vB0
L4nUd3OapjL60dIxwZLdI1Fn3X/VmuyH4waae6aIRGi5z0vToAGMSwUr7xwn
odTQllx8OABxfgrVfoBEVqwL/WXFM4RVqF0rDCZxSN8g3uriMziUGUs535MI
+s358lM1AtUHr3/QYDw0eWS6YiaBqpSvnGu2kAj3aw7jzSIwu3OlgTbj/Wpe
5ss1CWSllLPbN5HIDA26FT+fgL6XbHq9G4myxYkiLSMC1q/l9+ydSbz7tXzE
zYlAQeAqh9dOzB6K2qIPAsdj70nyGU+5rapQbiDQxvXc9OE7Eurjwlj+RgL5
5h0H6taTMPR9NPHck0A5efWG+zoSLlpDGmk7CKTuzm6dXEuiOcIkxptDYNrH
Y+omY4+6SKnRTgKFzz2E2oz99lFnW8OYPUuvhww6kIhq/2iou4dg/rdnyxnG
lJETj9xLwHVvpacb4wMpmS/uxxBQ6oYWl9uTSLNQF3DjCIwVWY1xGLMyPNQd
4gksr+UHsxkfleft0UgkYDmWO9RkR2K2TZeESCIQKNdPT2Z86pcFNlXJBP4D
t35yJQ==
    "]], 
   {GrayLevel[0.5], Opacity[1], 
    DiskBox[{0.16666666666666666`, 0.75}, {0.1111111111111111, 0.16666666666666666`},
      NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {RGBColor[1, 0, 0], Opacity[1], 
    DiskBox[{0.10962826255724775`, 0.7488375202932471}, {0.030870370370370374`, 0.04630555555555556},
      NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], CircleBox[{0.10962826255724775`, 0.7488375202932471}, {0.030870370370370374`, 0.04630555555555556},
      NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
     DiskBox[{0.17641079289046807`, 0.7016526711723247}, {0.030870370370370374`, 0.04630555555555556},
       NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
     None], CircleBox[{0.17641079289046807`, 0.7016526711723247}, {0.030870370370370374`, 0.04630555555555556},
       NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
     {RGBColor[1, 0, 0], Opacity[1], 
      DiskBox[{0.17845126483458307`, 0.7494819470500875}, {0.030870370370370374`, 0.04630555555555556},
        NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
     {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
      None], CircleBox[{0.17845126483458307`, 0.7494819470500875}, {0.030870370370370374`, 0.04630555555555556},
        NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
      {RGBColor[1, 0, 0], Opacity[1], 
       DiskBox[{0.22162370568793519`, 0.6818114185612199}, {0.030870370370370374`, 0.04630555555555556},
         NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
      {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
       None], CircleBox[{0.22162370568793519`, 0.6818114185612199}, {0.030870370370370374`, 0.04630555555555556},
         NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
       {RGBColor[1, 0, 0], Opacity[1], 
        DiskBox[{0.1778700421125725, 0.7072079858120044}, {0.030870370370370374`, 0.04630555555555556},
          NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
       {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
        None], CircleBox[{0.1778700421125725, 0.7072079858120044}, {0.030870370370370374`, 0.04630555555555556},
          NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
        {RGBColor[1, 0, 0], Opacity[1], 
         DiskBox[{0.18564627969188913`, 0.7428108284297903}, {0.030870370370370374`, 0.04630555555555556},
           NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
        {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
         None], CircleBox[{0.18564627969188913`, 0.7428108284297903}, {0.030870370370370374`, 0.04630555555555556},
           NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
         {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
          DiskBox[{0.1719203867040178, 0.7950273004752003}, {0.030870370370370374`, 0.04630555555555556},
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
         {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
          CapForm[None], 
          CircleBox[{0.1719203867040178, 0.7950273004752003}, {0.030870370370370374`, 0.04630555555555556},
            NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
          {RGBColor[1, 0, 0], Opacity[1], 
           DiskBox[{0.18823336403286456`, 0.7365505422825905}, {0.030870370370370374`, 0.04630555555555556},
             NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
          {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
           CapForm[None], 
           CircleBox[{0.18823336403286456`, 0.7365505422825905}, {0.030870370370370374`, 0.04630555555555556},
             NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
           {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
            DiskBox[{0.206244245350506, 0.7342173409871459}, {0.030870370370370374`, 0.04630555555555556},
              NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
           {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
            CapForm[None], 
            CircleBox[{0.206244245350506, 0.7342173409871459}, 
             {0.030870370370370374`, 0.04630555555555556}, 
             NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
            {RGBColor[1, 0, 0], Opacity[1], 
             DiskBox[{0.13677768210356106`, 0.8065723207924073}, {0.030870370370370374`, 0.04630555555555556},
               NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
            {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
             CapForm[None], 
             CircleBox[{0.13677768210356106`, 0.8065723207924073}, {0.030870370370370374`, 0.04630555555555556},
               NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
             {RGBColor[1, 0, 0], Opacity[1], 
              DiskBox[{0.19387260019426125`, 0.8067223351833027}, {0.030870370370370374`, 0.04630555555555556},
                NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
             {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
              CapForm[None], 
              CircleBox[{0.19387260019426125`, 0.8067223351833027}, {0.030870370370370374`, 0.04630555555555556},
                NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
              {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
               DiskBox[{0.13270786651127311`, 0.7046282783339405}, {0.030870370370370374`, 0.04630555555555556},
                 NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
              {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
               CapForm[None], 
               CircleBox[{0.13270786651127311`, 0.7046282783339405}, {0.030870370370370374`, 0.04630555555555556},
                 NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
               {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                DiskBox[{0.1266130095668783, 0.66884017722208}, {0.030870370370370374`, 0.04630555555555556},
                  NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
               {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
                CapForm[None], 
                CircleBox[{0.1266130095668783, 0.66884017722208}, {0.030870370370370374`, 0.04630555555555556},
                  NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                 DiskBox[{0.17163137689035368`, 0.7339355297918034}, {0.030870370370370374`, 0.04630555555555556},
                   NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
                 CapForm[None], 
                 CircleBox[{0.17163137689035368`, 0.7339355297918034}, {0.030870370370370374`, 0.04630555555555556},
                   NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                 {RGBColor[1, 0, 0], Opacity[1], 
                  DiskBox[{0.13494928311717408`, 0.6816308030078513}, {0.030870370370370374`, 0.04630555555555556},
                    NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                 {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}],
                   CapForm[None], 
                  CircleBox[{0.13494928311717408`, 0.6816308030078513}, {0.030870370370370374`, 0.04630555555555556},
                    NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                  {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                   DiskBox[{0.18314382766484683`, 0.7381941824828057}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                  {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                   Dashing[{}], CapForm[None], 
                   CircleBox[{0.18314382766484683`, 0.7381941824828057}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                   {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.18048077516422373`, 0.7189609457513234}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.18048077516422373`, 0.7189609457513234}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.24163147395483275`, 0.7274084956530797}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.24163147395483275`, 0.7274084956530797}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.11444014977697356`, 0.6752580155706648}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.11444014977697356`, 0.6752580155706648}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.21875901871998993`, 0.765493188866323}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.21875901871998993`, 0.765493188866323}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.1503677751376467, 0.7100390281227604}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.1503677751376467, 0.7100390281227604}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.16438986556142346`, 0.7433495155030547}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.16438986556142346`, 0.7433495155030547}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.10441613593677268`, 0.7430206333135643}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.10441613593677268`, 0.7430206333135643}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.20144585898487516`, 0.7701576360239594}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.20144585898487516`, 0.7701576360239594}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.2142767607396895, 0.66722444818024}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.2142767607396895, 0.66722444818024}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.16833098083124926`, 0.7881394634274697}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.16833098083124926`, 0.7881394634274697}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.17097685784119743`, 0.7752155126286593}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.17097685784119743`, 0.7752155126286593}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.1639867834485963, 0.760056850167667}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.1639867834485963, 0.760056850167667}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.11975689539613273`, 0.8284428731472119}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.11975689539613273`, 0.8284428731472119}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.16199964595695196`, 0.7607195541176355}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.16199964595695196`, 0.7607195541176355}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.16433589781993904`, 0.6362843606416446}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.16433589781993904`, 0.6362843606416446}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.15426381655259672`, 0.7962050996350336}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.15426381655259672`, 0.7962050996350336}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.20542179202163038`, 0.7831549811218212}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.20542179202163038`, 0.7831549811218212}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.1481933079363576, 0.7179952308779909}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.1481933079363576, 0.7179952308779909}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.11250502044917561`, 0.71138341871372}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.11250502044917561`, 0.71138341871372}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.10598775323031576`, 0.7016301327471045}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.10598775323031576`, 0.7016301327471045}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.14948187933426488`, 0.6561817405447755}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.14948187933426488`, 0.6561817405447755}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.14392731277386364`, 0.8051571431592377}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.14392731277386364`, 0.8051571431592377}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.11916439173757104`, 0.751221809806875}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.11916439173757104`, 0.751221809806875}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.20213958481917105`, 0.7593300195540715}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.20213958481917105`, 0.7593300195540715}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.20411271899163033`, 0.8104979399029238}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.20411271899163033`, 0.8104979399029238}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.1558409246083144, 0.7121153472344672}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.1558409246083144, 0.7121153472344672}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.12374781182208597`, 0.8061885845399849}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.12374781182208597`, 0.8061885845399849}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.11583853421128631`, 0.8265984016751078}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.11583853421128631`, 0.8265984016751078}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.162607020485542, 0.7674979732857237}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.162607020485542, 0.7674979732857237}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.16342081942362538`, 0.684439429312888}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.16342081942362538`, 0.684439429312888}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.16339129468800115`, 0.7050268080550433}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.16339129468800115`, 0.7050268080550433}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.19487761263689982`, 0.8171071532715722}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.19487761263689982`, 0.8171071532715722}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.20919599934724553`, 0.7602510083117288}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.20919599934724553`, 0.7602510083117288}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.17090436288770278`, 0.7369860425971643}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.17090436288770278`, 0.7369860425971643}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.09446233314179885, 0.7306859208749301}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.09446233314179885, 0.7306859208749301}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.1809150405162427, 0.6758914361266499}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.1809150405162427, 0.6758914361266499}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.15204772332268188`, 0.7665325270243578}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.15204772332268188`, 0.7665325270243578}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.18519570193587787`, 0.7727397561063772}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.18519570193587787`, 0.7727397561063772}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.20568580417259685`, 0.7541956603255492}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.20568580417259685`, 0.7541956603255492}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.16378309951738373`, 0.7057082526161692}, 
                    {0.030870370370370374`, 0.04630555555555556}, 
                    NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.16378309951738373`, 0.7057082526161692}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.1596988995002085, 0.7112325640635403}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.1596988995002085, 0.7112325640635403}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.2302681856629148, 0.7477843988715976}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.2302681856629148, 0.7477843988715976}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.24016535634064068`, 0.7328270049006061}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.24016535634064068`, 0.7328270049006061}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.17217695910819933`, 0.7361918210451561}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.17217695910819933`, 0.7361918210451561}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.19644730787189976`, 0.7355006814132998}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.19644730787189976`, 0.7355006814132998}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.16773583178646434`, 0.7501366878449977}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.16773583178646434`, 0.7501366878449977}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.13513363935468475`, 0.775248779257651}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.13513363935468475`, 0.775248779257651}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.17200221498999976`, 0.7903614960065755}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.17200221498999976`, 0.7903614960065755}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.1838920028702114, 0.7540554708123601}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.1838920028702114, 0.7540554708123601}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.16936066138432418`, 0.753330587855946}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.16936066138432418`, 0.753330587855946}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.2225630323184003, 0.7570700493038968}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.2225630323184003, 0.7570700493038968}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.13013312156254264`, 0.8046609475546139}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.13013312156254264`, 0.8046609475546139}, 
                    {0.030870370370370374`, 0.04630555555555556}, NCache[{0, 
                    2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.15668045151566012`, 0.7913616288171724}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.15668045151566012`, 0.7913616288171724}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.11904271144630928`, 0.8180195881657848}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.11904271144630928`, 0.8180195881657848}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.15092294182993451`, 0.7930246101199494}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.15092294182993451`, 0.7930246101199494}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.11363682020325194`, 0.727941753579797}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.11363682020325194`, 0.727941753579797}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.16563999862777173`, 0.7514489850888507}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.16563999862777173`, 0.7514489850888507}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.11363419658833476`, 0.7350734078023837}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.11363419658833476`, 0.7350734078023837}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.20859737498645073`, 0.7329559847653601}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.20859737498645073`, 0.7329559847653601}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.15679702754284772`, 0.7869329923528072}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.15679702754284772`, 0.7869329923528072}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.19040978765011685`, 0.7340818351511996}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.19040978765011685`, 0.7340818351511996}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.173651849458961, 0.7829260987342007}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.173651849458961, 0.7829260987342007}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.2084164214209503, 0.715425826262482}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.2084164214209503, 0.715425826262482}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.18921881389006154`, 0.6843884845259185}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.18921881389006154`, 0.6843884845259185}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.1528479748091814, 0.7318607331301731}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.1528479748091814, 0.7318607331301731}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.10881679133522346`, 0.7800967308739549}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.10881679133522346`, 0.7800967308739549}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.153018058461559, 0.8429021627565985}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.153018058461559, 0.8429021627565985}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.17176809108017047`, 0.7447157293184402}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.17176809108017047`, 0.7447157293184402}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.2178839129886952, 0.6975605443744385}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.2178839129886952, 0.6975605443744385}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.14553442099168207`, 0.7819816935852252}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.14553442099168207`, 0.7819816935852252}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.18420685610002963`, 0.740861356359363}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.18420685610002963`, 0.740861356359363}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.16988424809493943`, 0.7520389256272987}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.16988424809493943`, 0.7520389256272987}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.23674576309621398`, 0.7590641223550431}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.23674576309621398`, 0.7590641223550431}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.2045292437322936, 0.6836297773641676}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.2045292437322936, 0.6836297773641676}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.18548113251903478`, 0.7689147240543597}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.18548113251903478`, 0.7689147240543597}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.17544821238597566`, 0.7531087424766851}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.17544821238597566`, 0.7531087424766851}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.16241547287868302`, 0.7508235235024672}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.16241547287868302`, 0.7508235235024672}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.14507907979860377`, 0.7294441306352335}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.14507907979860377`, 0.7294441306352335}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.1729777301207578, 0.7763141554659955}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.1729777301207578, 0.7763141554659955}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.15910898658279568`, 0.7232473330393165}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.15910898658279568`, 0.7232473330393165}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.15803354545121057`, 0.7999642530382449}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.15803354545121057`, 0.7999642530382449}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.14120511861793705`, 0.8431689309614905}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.14120511861793705`, 0.8431689309614905}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.15788045359041422`, 0.7697732473659346}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.15788045359041422`, 0.7697732473659346}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.16734626364915337`, 0.8454482919415076}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.16734626364915337`, 0.8454482919415076}, {0.030870370370370374`, 0.04630555555555556},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.5299364318536629, 0.75}, {0.017640211640211644`, 0.026460317460317462`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.5299364318536629, 0.75}, {0.017640211640211644`, 0.026460317460317462`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.5, 0.7949046477804943}, {0.017640211640211644`, 0.026460317460317462`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.5, 0.7949046477804943}, {0.017640211640211644`, 0.026460317460317462`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.47006356814633715`, 0.75}, {0.017640211640211644`, 0.026460317460317462`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.47006356814633715`, 0.75}, {0.017640211640211644`, 0.026460317460317462`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.5, 0.7050953522195057}, {0.017640211640211644`, 0.026460317460317462`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.5, 0.7050953522195057}, {0.017640211640211644`, 0.026460317460317462`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.5299364318536629, 0.75}, {0.017640211640211644`, 0.026460317460317462`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.5299364318536629, 0.75}, {0.017640211640211644`, 0.026460317460317462`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.5782696190476191, 0.75}, {0.017640211640211644`, 0.026460317460317462`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.5782696190476191, 0.75}, {0.017640211640211644`, 0.026460317460317462`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.5677834784397685, 0.8087022142857143}, {0.017640211640211644`, 0.026460317460317462`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.5677834784397685, 0.8087022142857143}, {0.017640211640211644`, 0.026460317460317462`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.5391348095238095, 0.8516752176596527}, {0.017640211640211644`, 0.026460317460317462`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.5391348095238095, 0.8516752176596527}, {0.017640211640211644`, 0.026460317460317462`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.5, 0.8674044285714285}, {0.017640211640211644`, 0.026460317460317462`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.5, 0.8674044285714285}, {0.017640211640211644`, 0.026460317460317462`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.46086519047619046`, 0.8516752176596527}, {0.017640211640211644`, 0.026460317460317462`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.46086519047619046`, 0.8516752176596527}, {0.017640211640211644`, 0.026460317460317462`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.4322165215602315, 0.8087022142857143}, {0.017640211640211644`, 0.026460317460317462`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.4322165215602315, 0.8087022142857143}, {0.017640211640211644`, 0.026460317460317462`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.42173038095238097`, 0.75}, {0.017640211640211644`, 0.026460317460317462`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.42173038095238097`, 0.75}, {0.017640211640211644`, 0.026460317460317462`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.4322165215602315, 0.6912977857142857}, {0.017640211640211644`, 0.026460317460317462`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.4322165215602315, 0.6912977857142857}, {0.017640211640211644`, 0.026460317460317462`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.46086519047619046`, 0.6483247823403473}, {0.017640211640211644`, 0.026460317460317462`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.46086519047619046`, 0.6483247823403473}, {0.017640211640211644`, 0.026460317460317462`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.5, 0.6325955714285715}, {0.017640211640211644`, 0.026460317460317462`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.5, 0.6325955714285715}, {0.017640211640211644`, 0.026460317460317462`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.5391348095238095, 0.6483247823403473}, {0.017640211640211644`, 0.026460317460317462`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.5391348095238095, 0.6483247823403473}, {0.017640211640211644`, 0.026460317460317462`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[0.333333, 0.333333, 0.333333], Opacity[1], 
                    DiskBox[{0.5677834784397685, 0.6912977857142857}, {0.017640211640211644`, 0.026460317460317462`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.5677834784397685, 0.6912977857142857}, {0.017640211640211644`, 0.026460317460317462`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1, 0, 0], Opacity[1], 
                    DiskBox[{0.5782696190476191, 0.75}, {0.017640211640211644`, 0.026460317460317462`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.5782696190476191, 0.75}, {0.017640211640211644`, 0.026460317460317462`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.5, 0.75}, {0.054103025450640954`, 0.08115453817596142},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.5, 0.75}, {0.10820605090128191`, 0.16230907635192285`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], InsetBox[
                    GraphicsBox[
                    {Thickness[0.006024096385542169], 
                    {FaceForm[{RGBColor[0.64314, 0., 0.35686], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{3.16, 
                    64.6}, {1.12, 67.72}, {1.9600000000000002`, 
                    60.279999999999994`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{3.16, 
                    64.6}, {1.12, 67.72}, {1.9600000000000002`, 
                    60.279999999999994`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.64314, 0., 0.35686], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{1.12, 
                    67.72}, {3.16, 64.6}, {3.52, 74.67999999999999}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{1.12, 67.72}, {3.16, 64.6}, {3.52, 
                    74.67999999999999}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.64314, 0., 0.35686], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{3.52, 
                    74.67999999999999}, {1.3599999999999999`, 
                    75.63999999999999}, {1.12, 67.72}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{3.52, 74.67999999999999}, {1.3599999999999999`, 
                    75.63999999999999}, {1.12, 67.72}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.61961, 0., 0.38039], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{1.36, 
                    75.64}, {3.5200000000000005`, 74.68}, {5.08, 84.64}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{1.36, 75.64}, {3.5200000000000005`, 
                    74.68}, {5.08, 84.64}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.61961, 0., 0.38039], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{5.08, 
                    84.64}, {2.56, 83.44}, {1.3599999999999999`, 75.64}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{5.08, 84.64}, {2.56, 
                    83.44}, {1.3599999999999999`, 75.64}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.61961, 0., 0.38039], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{4.24, 
                    55.120000000000005`}, {1.96, 
                    60.28}, {3.7600000000000002`, 53.56}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{4.24, 55.120000000000005`}, {1.96, 
                    60.28}, {3.7600000000000002`, 53.56}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.64314, 0., 0.35686], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{1.96, 
                    60.28}, {4.24, 55.120000000000005`}, {3.16, 64.6}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{1.96, 60.28}, {4.24, 
                    55.120000000000005`}, {3.16, 64.6}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.57255, 0., 0.42745000000000005`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{2.56, 83.44000000000001}, {5.08, 
                    84.64000000000001}, {7.84, 94.12}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{2.56, 83.44000000000001}, {5.08, 
                    84.64000000000001}, {7.84, 94.12}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.57255, 0., 0.42745000000000005`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{7.84, 94.11999999999999}, {4.72, 
                    90.88}, {2.5599999999999996`, 83.44}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{7.84, 
                    94.11999999999999}, {4.72, 90.88}, {2.5599999999999996`, 
                    83.44}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.7215699999999999, 0., 0.27843], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{7.84, 61.720000000000006`}, {3.16, 
                    64.60000000000001}, {4.24, 55.120000000000005`}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{7.84, 61.720000000000006`}, {3.16, 
                    64.60000000000001}, {4.24, 55.120000000000005`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.7215699999999999, 0., 0.27843], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{3.16, 64.6}, {7.84, 61.71999999999999}, {8.32, 
                    73.47999999999999}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{3.16, 
                    64.6}, {7.84, 61.71999999999999}, {8.32, 
                    73.47999999999999}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.7215699999999999, 0., 0.27843], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{8.32, 73.48}, {3.5200000000000005`, 
                    74.68}, {3.160000000000001, 64.60000000000001}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{8.32, 73.48}, {3.5200000000000005`, 
                    74.68}, {3.160000000000001, 64.60000000000001}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.6823499999999999, 0., 0.31765], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{3.52, 74.67999999999999}, {8.32, 
                    73.47999999999999}, {10.12, 85.24}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{3.52, 74.67999999999999}, {8.32, 
                    73.47999999999999}, {10.12, 85.24}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.6823499999999999, 0., 0.31765], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{10.12, 85.24000000000001}, {5.079999999999999, 
                    84.64000000000001}, {3.5199999999999996`, 74.68}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{10.12, 
                    85.24000000000001}, {5.079999999999999, 
                    84.64000000000001}, {3.5199999999999996`, 74.68}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.61961, 0., 0.38039], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{3.7600000000000002`, 
                    53.56}, {6.5200000000000005`, 46.72}, {4.24, 
                    55.120000000000005`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{3.7600000000000002`, 
                    53.56}, {6.5200000000000005`, 46.72}, {4.24, 
                    55.120000000000005`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.6823499999999999, 0., 0.31765], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{9.04, 50.68}, {4.239999999999999, 55.12}, {6.52, 
                    46.72}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{9.04, 
                    50.68}, {4.239999999999999, 55.12}, {6.52, 46.72}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.7215699999999999, 0., 0.27843], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{4.24, 55.120000000000005`}, {9.04, 
                    50.68000000000001}, {7.84, 61.720000000000006`}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{4.24, 55.120000000000005`}, {9.04, 
                    50.68000000000001}, {7.84, 61.720000000000006`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.51765, 0., 0.48235000000000006`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{11.68, 102.52}, {7.84, 97.6}, {4.72, 90.88}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{11.68, 102.52}, {7.84, 97.6}, {4.72, 90.88}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.51765, 0., 0.48235000000000006`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{4.72, 90.88}, {7.84, 94.11999999999999}, {11.68, 
                    102.52}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{4.72, 
                    90.88}, {7.84, 94.11999999999999}, {11.68, 102.52}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.61176, 0., 0.38824], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{5.08, 
                    84.64}, {10.120000000000001`, 85.24}, {13.36, 96.28}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{5.08, 84.64}, {10.120000000000001`, 
                    85.24}, {13.36, 96.28}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.61176, 0., 0.38824], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{13.360000000000001`, 96.28}, {7.840000000000002, 
                    94.12}, {5.080000000000002, 84.64}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{13.360000000000001`, 96.28}, {7.840000000000002, 
                    94.12}, {5.080000000000002, 84.64}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.61176, 0., 0.38824], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{11.56, 
                    40.839999999999996`}, {6.5200000000000005`, 
                    46.72}, {9.76, 39.63999999999999}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{11.56, 
                    40.839999999999996`}, {6.5200000000000005`, 
                    46.72}, {9.76, 39.63999999999999}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.6823499999999999, 0., 0.31765], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{6.52, 
                    46.720000000000006`}, {11.559999999999999`, 
                    40.84}, {9.04, 50.68000000000001}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{6.52, 
                    46.720000000000006`}, {11.559999999999999`, 
                    40.84}, {9.04, 50.68000000000001}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.4549, 0., 0.5451], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{16.36, 
                    109.48}, {11.559999999999999`, 103.12}, {7.84, 
                    97.60000000000001}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{16.36, 
                    109.48}, {11.559999999999999`, 103.12}, {7.84, 
                    97.60000000000001}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.4549, 0., 0.5451], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{7.84, 
                    97.6}, {11.68, 102.52}, {16.36, 109.47999999999999`}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{7.84, 97.6}, {11.68, 102.52}, {16.36, 
                    109.47999999999999`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{17.8, 
                    106.11999999999999`}, {11.680000000000001`, 
                    102.52}, {7.84, 94.11999999999999}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{17.8, 
                    106.11999999999999`}, {11.680000000000001`, 
                    102.52}, {7.84, 94.11999999999999}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{7.84, 
                    94.11999999999999}, {13.36, 96.27999999999999}, {17.8, 
                    106.11999999999999`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{7.84, 
                    94.11999999999999}, {13.36, 96.27999999999999}, {17.8, 
                    106.11999999999999`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.8, 0., 0.2], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{14.56, 
                    59.08}, {7.840000000000001, 61.72}, {9.040000000000001, 
                    50.68}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{14.56, 
                    59.08}, {7.840000000000001, 61.72}, {9.040000000000001, 
                    50.68}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.8, 0., 0.2], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{7.84, 
                    61.720000000000006`}, {14.559999999999999`, 
                    59.080000000000005`}, {15.04, 72.16000000000001}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{7.84, 
                    61.720000000000006`}, {14.559999999999999`, 
                    59.080000000000005`}, {15.04, 72.16000000000001}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.8, 0., 0.2], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{15.04, 
                    72.16}, {8.32, 73.47999999999999}, {7.839999999999999, 
                    61.72}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{15.04, 
                    72.16}, {8.32, 73.47999999999999}, {7.839999999999999, 
                    61.72}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.7451, 0., 0.2549], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{8.32, 
                    73.48}, {15.04, 72.16000000000001}, {17.08, 85.12}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{8.32, 73.48}, {15.04, 
                    72.16000000000001}, {17.08, 85.12}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.7451, 0., 0.2549], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{17.08, 
                    85.11999999999999}, {10.119999999999997`, 
                    85.24}, {8.319999999999999, 73.47999999999999}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{17.08, 
                    85.11999999999999}, {10.119999999999997`, 
                    85.24}, {8.319999999999999, 73.47999999999999}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.7451, 0., 0.2549], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{15.76, 
                    46.96}, {9.04, 50.68}, {11.559999999999999`, 40.84}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{15.76, 46.96}, {9.04, 
                    50.68}, {11.559999999999999`, 40.84}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.8, 0., 0.2], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{9.04, 
                    50.68}, {15.759999999999998`, 
                    46.96}, {14.559999999999999`, 59.08}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{9.04, 50.68}, {15.759999999999998`, 
                    46.96}, {14.559999999999999`, 59.08}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.61176, 0., 0.38824], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{9.76, 
                    39.64}, {15.28, 32.8}, {11.56, 40.84}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{9.76, 39.64}, {15.28, 32.8}, {11.56, 40.84}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{15.28, 
                    32.8}, {9.76, 39.64}, {13.84, 34.48}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{15.28, 32.8}, {9.76, 39.64}, {13.84, 34.48}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.65098, 0., 0.34902], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{10.12, 
                    85.24000000000001}, {17.08, 85.12}, {20.56, 97.48}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{10.12, 85.24000000000001}, {17.08, 
                    85.12}, {20.56, 97.48}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.65098, 0., 0.34902], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{20.56, 
                    97.48}, {13.36, 96.28}, {10.12, 85.24000000000001}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{20.56, 97.48}, {13.36, 96.28}, {10.12, 
                    85.24000000000001}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.65098, 0., 0.34902], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{18.52, 
                    36.04}, {11.559999999999999`, 
                    40.839999999999996`}, {15.28, 32.8}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{18.52, 36.04}, {11.559999999999999`, 
                    40.839999999999996`}, {15.28, 32.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.7451, 0., 0.2549], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{11.56, 
                    40.839999999999996`}, {18.52, 
                    36.04}, {15.760000000000002`, 46.959999999999994`}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{11.56, 40.839999999999996`}, {18.52, 
                    36.04}, {15.760000000000002`, 46.959999999999994`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[
                    0.4313700000000001, 0., 0.5686300000000001], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{23.08, 114.28}, {16.36, 
                    109.48}, {11.679999999999998`, 102.52}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{23.08, 114.28}, {16.36, 
                    109.48}, {11.679999999999998`, 102.52}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[
                    0.4313700000000001, 0., 0.5686300000000001], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{11.68, 102.52}, {17.799999999999997`, 
                    106.11999999999999`}, {23.08, 114.28}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{11.68, 102.52}, {17.799999999999997`, 
                    106.11999999999999`}, {23.08, 114.28}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.53333, 0., 0.46667000000000003`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{25.36, 108.28}, {17.8, 106.12}, {13.36, 
                    96.28}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{25.36, 
                    108.28}, {17.8, 106.12}, {13.36, 96.28}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.53333, 0., 0.46667000000000003`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{13.360000000000001`, 
                    96.28}, {20.560000000000002`, 97.48}, {25.36, 108.28}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{13.360000000000001`, 
                    96.28}, {20.560000000000002`, 97.48}, {25.36, 108.28}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{13.84, 
                    34.48}, {20.08, 26.799999999999997`}, {15.28, 32.8}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{13.84, 34.48}, {20.08, 
                    26.799999999999997`}, {15.28, 32.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[
                    0.8705900000000001, 0., 0.12941000000000003`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{22.72, 56.92}, {14.559999999999999`, 
                    59.08}, {15.759999999999998`, 46.96}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{22.72, 56.92}, {14.559999999999999`, 
                    59.08}, {15.759999999999998`, 46.96}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[
                    0.8705900000000001, 0., 0.12941000000000003`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{14.56, 59.08}, {22.72, 56.92}, {23.2, 70.84}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{14.56, 59.08}, {22.72, 56.92}, {23.2, 70.84}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[
                    0.8705900000000001, 0., 0.12941000000000003`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{23.2, 70.84}, {15.04, 72.16}, {14.56, 
                    59.080000000000005`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{23.2, 
                    70.84}, {15.04, 72.16}, {14.56, 59.080000000000005`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.8078400000000001, 0., 0.19216], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{15.04, 72.16}, {23.2, 70.84}, {25.24, 84.64}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{15.04, 72.16}, {23.2, 70.84}, {25.24, 84.64}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.8078400000000001, 0., 0.19216], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{25.24, 84.64}, {17.08, 85.12}, {15.04, 
                    72.16}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{25.24, 
                    84.64}, {17.08, 85.12}, {15.04, 72.16}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.53333, 0., 0.46667000000000003`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{22.6, 27.16}, {15.280000000000001`, 
                    32.8}, {20.080000000000002`, 26.8}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{22.6, 27.16}, {15.280000000000001`, 
                    32.8}, {20.080000000000002`, 26.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.65098, 0., 0.34902], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{15.28, 
                    32.8}, {22.599999999999998`, 
                    27.159999999999997`}, {18.52, 36.04}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{15.28, 32.8}, {22.599999999999998`, 
                    27.159999999999997`}, {18.52, 36.04}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.8078400000000001, 0., 0.19216], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{23.8, 
                    43.839999999999996`}, {15.760000000000002`, 
                    46.959999999999994`}, {18.52, 36.04}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{23.8, 
                    43.839999999999996`}, {15.760000000000002`, 
                    46.959999999999994`}, {18.52, 36.04}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[
                    0.8705900000000001, 0., 0.12941000000000003`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{15.76, 46.96}, {23.799999999999997`, 
                    43.84}, {22.72, 56.92}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{15.76, 
                    46.96}, {23.799999999999997`, 43.84}, {22.72, 56.92}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.34902, 0., 0.65098], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{16.36, 
                    109.48}, {23.08, 114.28}, {29.08, 120.16}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{16.36, 109.48}, {23.08, 114.28}, {29.08, 
                    120.16}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.34902, 0., 0.65098], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{29.08, 
                    120.16}, {21.52, 114.75999999999999`}, {16.36, 
                    109.47999999999999`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{29.08, 
                    120.16}, {21.52, 114.75999999999999`}, {16.36, 
                    109.47999999999999`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.6901999999999999, 0., 0.3098], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{17.08, 85.11999999999999}, {25.24, 
                    84.63999999999999}, {29.08, 97.71999999999998}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{17.08, 85.11999999999999}, {25.24, 
                    84.63999999999999}, {29.08, 97.71999999999998}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.6901999999999999, 0., 0.3098], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{29.08, 97.72}, {20.56, 97.48}, {17.08, 
                    85.12}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{29.08, 
                    97.72}, {20.56, 97.48}, {17.08, 85.12}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[
                    0.40392000000000006`, 0., 0.5960799999999999], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{31.24, 117.28}, {23.08, 
                    114.28}, {17.799999999999997`, 106.12}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{31.24, 117.28}, {23.08, 
                    114.28}, {17.799999999999997`, 106.12}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[
                    0.40392000000000006`, 0., 0.5960799999999999], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{17.8, 106.11999999999999`}, {25.36, 
                    108.27999999999999`}, {31.240000000000002`, 
                    117.27999999999999`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{17.8, 
                    106.11999999999999`}, {25.36, 
                    108.27999999999999`}, {31.240000000000002`, 
                    117.27999999999999`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.6901999999999999, 0., 0.3098], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{26.68, 32.32}, {18.52, 36.04}, {22.6, 27.16}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{26.68, 32.32}, {18.52, 36.04}, {22.6, 27.16}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.8078400000000001, 0., 0.19216], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{18.52, 36.04}, {26.68, 32.32}, {23.8, 
                    43.839999999999996`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{18.52, 
                    36.04}, {26.68, 32.32}, {23.8, 43.839999999999996`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.53333, 0., 0.46667000000000003`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{20.08, 26.8}, {27.639999999999997`, 
                    20.68}, {22.599999999999998`, 27.16}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{20.08, 26.8}, {27.639999999999997`, 
                    20.68}, {22.599999999999998`, 27.16}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.53725, 0., 0.46275], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{20.56, 
                    97.48}, {29.08, 97.72}, {34.12, 109.48}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{20.56, 
                    97.48}, {29.08, 97.72}, {34.12, 109.48}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.53725, 0., 0.46275], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{34.120000000000005`, 
                    109.48}, {25.360000000000007`, 
                    108.28}, {20.560000000000002`, 97.48}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{34.120000000000005`, 
                    109.48}, {25.360000000000007`, 
                    108.28}, {20.560000000000002`, 97.48}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.53725, 0., 0.46275], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{30.88, 
                    22.959999999999997`}, {22.6, 
                    27.159999999999997`}, {27.64, 20.679999999999996`}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{30.88, 22.959999999999997`}, {22.6, 
                    27.159999999999997`}, {27.64, 20.679999999999996`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.6901999999999999, 0., 0.3098], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{22.6, 27.16}, {30.880000000000003`, 
                    22.96}, {26.68, 32.32}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{22.6, 
                    27.16}, {30.880000000000003`, 22.96}, {26.68, 32.32}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.92549, 0., 0.07451], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{31.6, 
                    55.}, {22.72, 56.92}, {23.8, 43.84}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{31.6, 55.}, {22.72, 56.92}, {23.8, 43.84}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.92549, 0., 0.07451], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{22.72, 
                    56.92}, {31.6, 55.}, {32.2, 69.4}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{22.72, 56.92}, {31.6, 55.}, {32.2, 69.4}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.92549, 0., 0.07451], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{32.2, 
                    69.4}, {23.200000000000003`, 
                    70.84}, {22.720000000000002`, 56.92}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{32.2, 69.4}, {23.200000000000003`, 
                    70.84}, {22.720000000000002`, 56.92}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.29804, 0., 0.7019599999999999], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{23.08, 114.28}, {31.24, 
                    117.28}, {37.599999999999994`, 123.88}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{23.08, 114.28}, {31.24, 
                    117.28}, {37.599999999999994`, 123.88}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.29804, 0., 0.7019599999999999], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{37.6, 123.88}, {29.080000000000002`, 
                    120.16}, {23.080000000000002`, 114.28}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{37.6, 123.88}, {29.080000000000002`, 
                    120.16}, {23.080000000000002`, 114.28}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.8549000000000001, 0., 0.1451], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{23.2, 70.84}, {32.2, 69.4}, {34.36, 83.92}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{23.2, 70.84}, {32.2, 69.4}, {34.36, 83.92}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.8549000000000001, 0., 0.1451], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{34.36, 83.92}, {25.240000000000002`, 
                    84.64}, {23.2, 70.84}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{34.36, 
                    83.92}, {25.240000000000002`, 84.64}, {23.2, 70.84}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.8549000000000001, 0., 0.1451], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{32.8, 41.44}, {23.799999999999997`, 
                    43.839999999999996`}, {26.68, 32.32}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{32.8, 41.44}, {23.799999999999997`, 
                    43.839999999999996`}, {26.68, 32.32}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.92549, 0., 0.07451], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{23.8, 
                    43.839999999999996`}, {32.8, 41.44}, {31.6, 55.}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{23.8, 43.839999999999996`}, {32.8, 
                    41.44}, {31.6, 55.}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.71765, 0., 0.28235000000000005`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{25.24, 84.64}, {34.36, 83.92}, {38.2, 97.48}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{25.24, 84.64}, {34.36, 83.92}, {38.2, 97.48}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.71765, 0., 0.28235000000000005`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{38.2, 97.48}, {29.080000000000005`, 
                    97.72}, {25.240000000000002`, 84.64}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{38.2, 97.48}, {29.080000000000005`, 
                    97.72}, {25.240000000000002`, 84.64}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[
                    0.38431000000000004`, 0., 0.6156900000000001], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{25.36, 108.28}, {34.12, 109.48}, {40.12, 
                    118.96000000000001`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{25.36, 
                    108.28}, {34.12, 109.48}, {40.12, 118.96000000000001`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[
                    0.38431000000000004`, 0., 0.6156900000000001], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{40.120000000000005`, 
                    118.96000000000001`}, {31.240000000000002`, 
                    117.28}, {25.360000000000007`, 108.28}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{40.120000000000005`, 
                    118.96000000000001`}, {31.240000000000002`, 
                    117.28}, {25.360000000000007`, 108.28}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.71765, 0., 0.28235000000000005`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{35.56, 29.439999999999998`}, {26.68, 
                    32.32}, {30.880000000000003`, 22.959999999999997`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}]
                    , JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{35.56, 
                    29.439999999999998`}, {26.68, 
                    32.32}, {30.880000000000003`, 22.959999999999997`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.8549000000000001, 0., 0.1451], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{26.68, 32.32}, {35.56, 29.44}, {32.8, 41.44}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{26.68, 32.32}, {35.56, 29.44}, {32.8, 41.44}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.53725, 0., 0.46275], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{27.64, 
                    20.68}, {36.16, 16.12}, {30.880000000000003`, 22.96}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{27.64, 20.68}, {36.16, 
                    16.12}, {30.880000000000003`, 22.96}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[
                    0.38431000000000004`, 0., 0.6156900000000001], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{36.160000000000004`, 
                    16.12}, {27.640000000000004`, 20.68}, {33.52, 
                    16.720000000000002`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{36.160000000000004`, 
                    16.12}, {27.640000000000004`, 20.68}, {33.52, 
                    16.720000000000002`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.22353, 0., 0.77647], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{29.08, 
                    120.16}, {37.599999999999994`, 
                    123.88}, {44.31999999999999, 127.84}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{29.08, 120.16}, {37.599999999999994`, 
                    123.88}, {44.31999999999999, 127.84}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.22353, 0., 0.77647], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{44.32, 
                    127.84}, {35.2, 
                    123.88000000000001`}, {29.080000000000002`, 120.16}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{44.32, 127.84}, {35.2, 
                    123.88000000000001`}, {29.080000000000002`, 120.16}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.5451, 0., 0.4549], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{29.08, 
                    97.72}, {38.199999999999996`, 97.48}, {43.36, 109.6}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{29.08, 97.72}, {38.199999999999996`, 
                    97.48}, {43.36, 109.6}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.5451, 0., 0.4549], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{43.36, 
                    109.6}, {34.120000000000005`, 
                    109.47999999999999`}, {29.08, 97.72}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{43.36, 109.6}, {34.120000000000005`, 
                    109.47999999999999`}, {29.08, 97.72}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.5451, 0., 0.4549], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{39.760000000000005`, 
                    19.84}, {30.880000000000003`, 
                    22.96}, {36.160000000000004`, 16.12}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{39.760000000000005`, 
                    19.84}, {30.880000000000003`, 
                    22.96}, {36.160000000000004`, 16.12}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.71765, 0., 0.28235000000000005`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{30.88, 22.959999999999997`}, {39.76, 
                    19.839999999999996`}, {35.56, 29.439999999999998`}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{30.88, 22.959999999999997`}, {39.76, 
                    19.839999999999996`}, {35.56, 29.439999999999998`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.24706000000000003`, 0., 0.75294], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{46.839999999999996`, 
                    125.92}, {37.599999999999994`, 
                    123.88}, {31.239999999999995`, 117.28}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{46.839999999999996`, 
                    125.92}, {37.599999999999994`, 
                    123.88}, {31.239999999999995`, 117.28}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.24706000000000003`, 0., 0.75294], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{31.24, 117.28}, {40.12, 
                    118.96000000000001`}, {46.839999999999996`, 125.92}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{31.24, 117.28}, {40.12, 
                    118.96000000000001`}, {46.839999999999996`, 125.92}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.96471, 0., 0.03529399999999999], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{41.08, 53.2}, {31.599999999999998`, 55.}, {32.8, 
                    41.440000000000005`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{41.08, 
                    53.2}, {31.599999999999998`, 55.}, {32.8, 
                    41.440000000000005`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.96471, 0., 0.03529399999999999], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{31.6, 55.}, {41.08, 53.2}, {41.68, 
                    67.96000000000001}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{31.6, 
                    55.}, {41.08, 53.2}, {41.68, 67.96000000000001}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.96471, 0., 0.03529399999999999], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{41.68, 67.96000000000001}, {32.2, 69.4}, {31.6, 
                    55.00000000000001}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{41.68, 
                    67.96000000000001}, {32.2, 69.4}, {31.6, 
                    55.00000000000001}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.88235, 0., 0.11765], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{32.2, 
                    69.4}, {41.68000000000001, 67.96000000000001}, {43.96, 
                    82.84}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{32.2, 
                    69.4}, {41.68000000000001, 67.96000000000001}, {43.96, 
                    82.84}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.88235, 0., 0.11765], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{43.96, 
                    82.84}, {34.36, 83.92}, {32.2, 69.4}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{43.96, 82.84}, {34.36, 83.92}, {32.2, 69.4}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.88235, 0., 0.11765], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{42.160000000000004`, 
                    39.4}, {32.800000000000004`, 41.44}, {35.56, 
                    29.439999999999998`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}]
                    , JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{42.160000000000004`, 
                    39.4}, {32.800000000000004`, 41.44}, {35.56, 
                    29.439999999999998`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.96471, 0., 0.03529399999999999], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{32.8, 41.44}, {42.16, 39.4}, {41.08, 
                    53.199999999999996`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{32.8, 
                    41.44}, {42.16, 39.4}, {41.08, 53.199999999999996`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[
                    0.38431000000000004`, 0., 0.6156900000000001], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{33.52, 16.72}, {42.160000000000004`, 
                    11.919999999999998`}, {36.160000000000004`, 
                    16.119999999999997`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{33.52, 
                    16.72}, {42.160000000000004`, 
                    11.919999999999998`}, {36.160000000000004`, 
                    16.119999999999997`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{49.6, 
                    119.44000000000001`}, {40.120000000000005`, 
                    118.96000000000001`}, {34.120000000000005`, 
                    109.48000000000002`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{49.6, 
                    119.44000000000001`}, {40.120000000000005`, 
                    118.96000000000001`}, {34.120000000000005`, 
                    109.48000000000002`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{34.120000000000005`, 109.48}, {43.36, 
                    109.60000000000001`}, {49.60000000000001, 119.44}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{34.120000000000005`, 109.48}, {43.36, 
                    109.60000000000001`}, {49.60000000000001, 119.44}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.73725, 0., 0.26275], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{34.36, 
                    83.92}, {43.96, 82.84}, {47.8, 96.76}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{34.36, 83.92}, {43.96, 82.84}, {47.8, 96.76}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.73725, 0., 0.26275], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{47.8, 
                    96.76}, {38.199999999999996`, 97.48}, {34.36, 83.92}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{47.8, 96.76}, {38.199999999999996`, 
                    97.48}, {34.36, 83.92}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.73725, 0., 0.26275], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{44.92, 
                    27.16}, {35.56, 29.44}, {39.760000000000005`, 19.84}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{44.92, 27.16}, {35.56, 
                    29.44}, {39.760000000000005`, 19.84}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.88235, 0., 0.11765], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{35.56, 
                    29.439999999999998`}, {44.92, 
                    27.159999999999997`}, {42.160000000000004`, 39.4}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{35.56, 29.439999999999998`}, {44.92, 
                    27.159999999999997`}, {42.160000000000004`, 39.4}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{45.04, 
                    12.639999999999999`}, {36.16, 
                    16.119999999999997`}, {42.16, 11.919999999999998`}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{45.04, 12.639999999999999`}, {36.16, 
                    16.119999999999997`}, {42.16, 11.919999999999998`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.5451, 0., 0.4549], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{36.160000000000004`, 
                    16.12}, {45.040000000000006`, 
                    12.64}, {39.760000000000005`, 19.84}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{36.160000000000004`, 
                    16.12}, {45.040000000000006`, 
                    12.64}, {39.760000000000005`, 19.84}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.15294000000000005`, 0., 0.84706], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{53.8, 130.12}, {44.31999999999999, 
                    127.84}, {37.599999999999994`, 123.88000000000001`}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{53.8, 130.12}, {44.31999999999999, 
                    127.84}, {37.599999999999994`, 123.88000000000001`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.15294000000000005`, 0., 0.84706], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{37.6, 123.88}, {46.84, 125.92}, {53.8, 
                    130.12}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{37.6, 
                    123.88}, {46.84, 125.92}, {53.8, 130.12}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.5529400000000001, 0., 0.44706], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{38.2, 97.48}, {47.800000000000004`, 
                    96.76}, {52.96, 109.24000000000001`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{38.2, 97.48}, {47.800000000000004`, 
                    96.76}, {52.96, 109.24000000000001`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.5529400000000001, 0., 0.44706], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{52.96, 109.24000000000001`}, {43.36, 
                    109.60000000000001`}, {38.2, 97.48}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{52.96, 109.24000000000001`}, {43.36, 
                    109.60000000000001`}, {38.2, 97.48}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.5529400000000001, 0., 0.44706], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{49., 17.32}, {39.760000000000005`, 
                    19.84}, {45.04, 12.64}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{49., 
                    17.32}, {39.760000000000005`, 19.84}, {45.04, 12.64}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.73725, 0., 0.26275], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{39.760000000000005`, 19.84}, {49., 
                    17.32}, {44.92, 27.16}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{39.760000000000005`, 19.84}, {49., 
                    17.32}, {44.92, 27.16}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[
                    0.20784000000000002`, 0., 0.7921599999999999], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{56.32, 126.76}, {46.84, 
                    125.92}, {40.120000000000005`, 118.96000000000001`}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{56.32, 126.76}, {46.84, 
                    125.92}, {40.120000000000005`, 118.96000000000001`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[
                    0.20784000000000002`, 0., 0.7921599999999999], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{40.120000000000005`, 
                    118.96000000000001`}, {49.60000000000001, 
                    119.44000000000001`}, {56.32000000000001, 126.76}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{40.120000000000005`, 
                    118.96000000000001`}, {49.60000000000001, 
                    119.44000000000001`}, {56.32000000000001, 126.76}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.97647, 0., 0.023528999999999998`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{51.04, 51.64}, {41.08, 53.2}, {42.16, 
                    39.400000000000006`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{51.04, 
                    51.64}, {41.08, 53.2}, {42.16, 39.400000000000006`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.97647, 0., 0.023528999999999998`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{41.08, 53.2}, {51.04, 51.64}, {51.76, 66.64}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{41.08, 53.2}, {51.04, 51.64}, {51.76, 66.64}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.97647, 0., 0.023528999999999998`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{51.760000000000005`, 66.64}, {41.68000000000001, 
                    67.96}, {41.080000000000005`, 53.2}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{51.760000000000005`, 66.64}, {41.68000000000001, 
                    67.96}, {41.080000000000005`, 53.2}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.89412, 0., 0.10588], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{41.68, 
                    67.96000000000001}, {51.76, 66.64000000000001}, {54.04, 
                    81.52000000000001}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{41.68, 
                    67.96000000000001}, {51.76, 66.64000000000001}, {54.04, 
                    81.52000000000001}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.89412, 0., 0.10588], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{54.04, 
                    81.52}, {43.96, 82.83999999999999}, {41.68, 67.96}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{54.04, 81.52}, {43.96, 
                    82.83999999999999}, {41.68, 67.96}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{42.160000000000004`, 
                    11.92}, {51.040000000000006`, 
                    8.44}, {45.040000000000006`, 12.64}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{42.160000000000004`, 
                    11.92}, {51.040000000000006`, 
                    8.44}, {45.040000000000006`, 12.64}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.89412, 0., 0.10588], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{52.120000000000005`, 
                    37.720000000000006`}, {42.160000000000004`, 
                    39.400000000000006`}, {44.92, 27.160000000000004`}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{52.120000000000005`, 
                    37.720000000000006`}, {42.160000000000004`, 
                    39.400000000000006`}, {44.92, 27.160000000000004`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.97647, 0., 0.023528999999999998`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{42.160000000000004`, 
                    39.4}, {52.120000000000005`, 
                    37.72}, {51.040000000000006`, 51.64}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{42.160000000000004`, 
                    39.4}, {52.120000000000005`, 
                    37.72}, {51.040000000000006`, 51.64}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.35294, 0., 0.64706], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{43.36, 
                    109.6}, {52.96, 109.24}, {59.2, 119.32}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{43.36, 109.6}, {52.96, 109.24}, {59.2, 119.32}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.35294, 0., 0.64706], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{59.2, 
                    119.32}, {49.6, 119.44}, {43.36, 109.6}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{59.2, 119.32}, {49.6, 119.44}, {43.36, 109.6}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.7451, 0., 0.2549], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{43.96, 
                    82.84}, {54.04, 81.52000000000001}, {57.88, 95.68}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{43.96, 
                    82.84}, {54.04, 81.52000000000001}, {57.88, 95.68}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.7451, 0., 0.2549], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{57.879999999999995`, 95.67999999999999}, {47.8, 
                    96.75999999999999}, {43.959999999999994`, 
                    82.83999999999999}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{57.879999999999995`, 95.67999999999999}, {47.8, 
                    96.75999999999999}, {43.959999999999994`, 
                    82.83999999999999}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.7451, 0., 0.2549], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{54.760000000000005`, 25.36}, {44.92, 
                    27.16}, {49.00000000000001, 17.32}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{54.760000000000005`, 25.36}, {44.92, 
                    27.16}, {49.00000000000001, 17.32}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.89412, 0., 0.10588], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{44.92, 
                    27.16}, {54.760000000000005`, 
                    25.36}, {52.120000000000005`, 37.72}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{44.92, 27.16}, {54.760000000000005`, 
                    25.36}, {52.120000000000005`, 37.72}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.35294, 0., 0.64706], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{54.28, 
                    10.12}, {45.040000000000006`, 
                    12.639999999999999`}, {51.04, 8.44}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{54.28, 10.12}, {45.040000000000006`, 
                    12.639999999999999`}, {51.04, 8.44}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.5529400000000001, 0., 0.44706], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{45.04, 12.639999999999999`}, {54.28, 
                    10.12}, {49., 17.32}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{45.04, 
                    12.639999999999999`}, {54.28, 10.12}, {49., 17.32}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[
                    0.10196000000000001`, 0., 0.8980400000000001], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{46.839999999999996`, 
                    125.92}, {56.31999999999999, 
                    126.76}, {63.279999999999994`, 131.08}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{46.839999999999996`, 
                    125.92}, {56.31999999999999, 
                    126.76}, {63.279999999999994`, 131.08}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[
                    0.10196000000000001`, 0., 0.8980400000000001], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{63.28, 131.08}, {53.8, 130.12}, {46.84, 
                    125.92000000000002`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{63.28, 
                    131.08}, {53.8, 130.12}, {46.84, 125.92000000000002`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.55686, 0., 0.44314], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{47.8, 
                    96.76}, {57.879999999999995`, 95.68}, {63.03999999999999, 
                    108.28}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{47.8, 
                    96.76}, {57.879999999999995`, 95.68}, {63.03999999999999, 
                    108.28}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.55686, 0., 0.44314], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{63.04, 
                    108.28}, {52.96, 109.24}, {47.8, 96.76}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{63.04, 108.28}, {52.96, 109.24}, {47.8, 96.76}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.55686, 0., 0.44314], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{58.720000000000006`, 15.52}, {49.00000000000001, 
                    17.32}, {54.28000000000001, 10.12}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{58.720000000000006`, 15.52}, {49.00000000000001, 
                    17.32}, {54.28000000000001, 10.12}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.7451, 0., 0.2549], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{49., 
                    17.32}, {58.72, 15.52}, {54.76, 25.36}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{49., 17.32}, {58.72, 15.52}, {54.76, 25.36}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.18431, 0., 0.8156900000000001], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{49.6, 119.44000000000001`}, {59.2, 
                    119.32000000000001`}, {65.92, 126.76}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{49.6, 119.44000000000001`}, {59.2, 
                    119.32000000000001`}, {65.92, 126.76}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.18431, 0., 0.8156900000000001], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{65.92, 126.76}, {56.32, 126.76}, {49.6, 
                    119.44000000000001`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{65.92, 
                    126.76}, {56.32, 126.76}, {49.6, 119.44000000000001`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.96471, 0., 0.03529399999999999], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{61.839999999999996`, 50.32}, {51.03999999999999, 
                    51.64}, {52.12, 37.72}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{61.839999999999996`, 50.32}, {51.03999999999999, 
                    51.64}, {52.12, 37.72}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.96471, 0., 0.03529399999999999], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{51.04, 51.64}, {61.84, 50.32}, {62.56, 65.2}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{51.04, 51.64}, {61.84, 50.32}, {62.56, 65.2}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.96471, 0., 0.03529399999999999], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{62.56, 65.2}, {51.760000000000005`, 
                    66.64}, {51.040000000000006`, 51.64}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{62.56, 65.2}, {51.760000000000005`, 
                    66.64}, {51.040000000000006`, 51.64}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.35294, 0., 0.64706], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{51.04, 
                    8.44}, {60.28, 5.92}, {54.28, 10.12}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{51.04, 
                    8.44}, {60.28, 5.92}, {54.28, 10.12}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.88235, 0., 0.11765], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{51.760000000000005`, 66.64}, {62.56, 
                    65.2}, {64.84, 80.08}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{51.760000000000005`, 66.64}, {62.56, 
                    65.2}, {64.84, 80.08}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.88235, 0., 0.11765], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{64.84, 
                    80.08}, {54.040000000000006`, 
                    81.52}, {51.760000000000005`, 66.64}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{64.84, 80.08}, {54.040000000000006`, 
                    81.52}, {51.760000000000005`, 66.64}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.88235, 0., 0.11765], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{62.8, 
                    36.28}, {52.12, 37.72}, {54.76, 25.36}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{62.8, 36.28}, {52.12, 37.72}, {54.76, 25.36}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.96471, 0., 0.03529399999999999], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{52.120000000000005`, 
                    37.720000000000006`}, {62.800000000000004`, 
                    36.28000000000001}, {61.84, 50.32000000000001}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{52.120000000000005`, 
                    37.720000000000006`}, {62.800000000000004`, 
                    36.28000000000001}, {61.84, 50.32000000000001}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.34902, 0., 0.65098], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{52.96, 
                    109.24000000000001`}, {63.04, 
                    108.28000000000002`}, {69.03999999999999, 118.48}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{52.96, 109.24000000000001`}, {63.04, 
                    108.28000000000002`}, {69.03999999999999, 118.48}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.34902, 0., 0.65098], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{69.04, 
                    118.48}, {59.2, 119.32000000000001`}, {52.96000000000001, 
                    109.24000000000001`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{69.04, 
                    118.48}, {59.2, 119.32000000000001`}, {52.96000000000001, 
                    109.24000000000001`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.06274500000000001, 0., 0.93725], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{70.24000000000001, 132.52}, {60.64000000000001, 
                    131.56}, {53.80000000000001, 130.12}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{70.24000000000001, 132.52}, {60.64000000000001, 
                    131.56}, {53.80000000000001, 130.12}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.06274500000000001, 0., 0.93725], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{53.8, 130.12}, {63.28, 131.08}, {70.24, 
                    132.52}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{53.8, 
                    130.12}, {63.28, 131.08}, {70.24, 132.52}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.73725, 0., 0.26275], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{54.04, 
                    81.52}, {64.84, 80.08}, {68.56, 94.24}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{54.04, 81.52}, {64.84, 80.08}, {68.56, 94.24}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.73725, 0., 0.26275], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{68.56, 
                    94.24000000000001}, {57.88, 95.68}, {54.040000000000006`, 
                    81.52000000000001}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{68.56, 
                    94.24000000000001}, {57.88, 95.68}, {54.040000000000006`, 
                    81.52000000000001}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.34902, 0., 0.65098], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{63.760000000000005`, 8.2}, {54.28, 
                    10.12}, {60.28000000000001, 5.919999999999999}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{63.760000000000005`, 8.2}, {54.28, 
                    10.12}, {60.28000000000001, 5.919999999999999}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.55686, 0., 0.44314], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{54.28, 
                    10.12}, {63.760000000000005`, 8.2}, {58.72, 15.52}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{54.28, 10.12}, {63.760000000000005`, 
                    8.2}, {58.72, 15.52}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.73725, 0., 0.26275], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{65.2, 
                    24.04}, {54.760000000000005`, 25.36}, {58.72, 15.52}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{65.2, 24.04}, {54.760000000000005`, 
                    25.36}, {58.72, 15.52}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.88235, 0., 0.11765], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{54.760000000000005`, 25.36}, {65.2, 
                    24.04}, {62.800000000000004`, 36.28}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{54.760000000000005`, 25.36}, {65.2, 
                    24.04}, {62.800000000000004`, 36.28}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.066667, 0., 0.93333], Opacity[1.]}],
                     FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{56.32, 
                    126.76}, {65.92, 126.76}, {72.88, 131.08}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{56.32, 126.76}, {65.92, 126.76}, {72.88, 
                    131.08}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.066667, 0., 0.93333], Opacity[1.]}],
                     FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{72.88, 
                    131.08}, {63.279999999999994`, 
                    131.08}, {56.31999999999999, 126.76000000000002`}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{72.88, 131.08}, {63.279999999999994`, 
                    131.08}, {56.31999999999999, 126.76000000000002`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.5529400000000001, 0., 0.44706], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{57.879999999999995`, 95.67999999999999}, {68.56, 
                    94.24}, {73.6, 106.72}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{57.879999999999995`, 95.67999999999999}, {68.56, 
                    94.24}, {73.6, 106.72}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.5529400000000001, 0., 0.44706], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{73.6, 106.72}, {63.03999999999999, 
                    108.28}, {57.879999999999995`, 95.68}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{73.6, 106.72}, {63.03999999999999, 
                    108.28}, {57.879999999999995`, 95.68}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.5529400000000001, 0., 0.44706], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{69.04, 14.2}, {58.720000000000006`, 
                    15.52}, {63.760000000000005`, 8.2}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{69.04, 14.2}, {58.720000000000006`, 
                    15.52}, {63.760000000000005`, 8.2}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.73725, 0., 0.26275], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{58.720000000000006`, 15.52}, {69.04, 
                    14.2}, {65.2, 24.04}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{58.720000000000006`, 15.52}, {69.04, 
                    14.2}, {65.2, 24.04}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.17255, 0., 0.82745], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{59.2, 
                    119.32}, {69.04, 118.47999999999999`}, {75.76, 
                    125.91999999999999`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{59.2, 
                    119.32}, {69.04, 118.47999999999999`}, {75.76, 
                    125.91999999999999`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.17255, 0., 0.82745], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{75.76, 
                    125.92}, {65.92, 126.76}, {59.2, 119.32000000000001`}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{75.76, 125.92}, {65.92, 126.76}, {59.2, 
                    119.32000000000001`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.34902, 0., 0.65098], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{60.28, 
                    5.92}, {69.64, 4.}, {63.76, 8.2}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{60.28, 
                    5.92}, {69.64, 4.}, {63.76, 8.2}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.17255, 0., 0.82745], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{69.64, 
                    4.}, {60.28, 5.92}, {66.76, 4.48}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{69.64, 4.}, {60.28, 5.92}, {66.76, 4.48}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.92549, 0., 0.07451], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{73.72, 
                    49.}, {61.839999999999996`, 50.32}, {62.8, 36.28}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{73.72, 49.}, {61.839999999999996`, 
                    50.32}, {62.8, 36.28}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.92549, 0., 0.07451], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{61.839999999999996`, 50.32}, {73.72, 
                    49.}, {74.44, 63.64}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{61.839999999999996`, 50.32}, {73.72, 
                    49.}, {74.44, 63.64}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.92549, 0., 0.07451], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{74.44000000000001, 63.64}, {62.56000000000001, 
                    65.2}, {61.84000000000001, 50.32}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{74.44000000000001, 63.64}, {62.56000000000001, 
                    65.2}, {61.84000000000001, 50.32}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.8549000000000001, 0., 0.1451], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{62.56, 65.2}, {74.44, 63.64}, {76.6, 78.28}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{62.56, 65.2}, {74.44, 63.64}, {76.6, 78.28}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.8549000000000001, 0., 0.1451], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{76.6, 78.28}, {64.83999999999999, 
                    80.08}, {62.559999999999995`, 65.2}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{76.6, 78.28}, {64.83999999999999, 
                    80.08}, {62.559999999999995`, 65.2}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.8549000000000001, 0., 0.1451], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{74.44000000000001, 35.32}, {62.80000000000001, 
                    36.28}, {65.20000000000002, 24.04}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{74.44000000000001, 35.32}, {62.80000000000001, 
                    36.28}, {65.20000000000002, 24.04}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.92549, 0., 0.07451], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{62.8, 
                    36.28}, {74.44, 35.32}, {73.72, 49.}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{62.8, 36.28}, {74.44, 35.32}, {73.72, 49.}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.35294, 0., 0.64706], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{63.04, 
                    108.28}, {73.6, 106.72}, {79.47999999999999, 117.04}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{63.04, 108.28}, {73.6, 
                    106.72}, {79.47999999999999, 117.04}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.35294, 0., 0.64706], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{79.48, 
                    117.04}, {69.04, 118.48}, {63.040000000000006`, 
                    108.28}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{79.48, 
                    117.04}, {69.04, 118.48}, {63.040000000000006`, 108.28}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.023528999999999998`, 0., 0.97647], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{63.28, 131.08}, {72.88, 131.08}, {79.72, 
                    132.52}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{63.28, 
                    131.08}, {72.88, 131.08}, {79.72, 132.52}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.023528999999999998`, 0., 0.97647], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{79.72, 132.52}, {70.24, 132.52}, {63.28, 
                    131.08}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{79.72, 
                    132.52}, {70.24, 132.52}, {63.28, 131.08}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.35294, 0., 0.64706], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{73.96000000000001, 7.}, {63.760000000000005`, 
                    8.2}, {69.64000000000001, 4.}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{73.96000000000001, 7.}, {63.760000000000005`, 
                    8.2}, {69.64000000000001, 4.}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.5529400000000001, 0., 0.44706], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{63.760000000000005`, 8.2}, {73.96000000000001, 
                    6.999999999999999}, {69.04, 14.2}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{63.760000000000005`, 8.2}, {73.96000000000001, 
                    6.999999999999999}, {69.04, 14.2}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.71765, 0., 0.28235000000000005`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{64.84, 80.08}, {76.60000000000001, 
                    78.28}, {80.32000000000001, 92.2}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{64.84, 80.08}, {76.60000000000001, 
                    78.28}, {80.32000000000001, 92.2}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.71765, 0., 0.28235000000000005`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{80.32, 92.2}, {68.55999999999999, 
                    94.24000000000001}, {64.83999999999999, 80.08}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{80.32, 92.2}, {68.55999999999999, 
                    94.24000000000001}, {64.83999999999999, 80.08}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.71765, 0., 0.28235000000000005`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{76.84, 23.32}, {65.2, 24.04}, {69.04, 
                    14.200000000000001`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{76.84, 
                    23.32}, {65.2, 24.04}, {69.04, 14.200000000000001`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.8549000000000001, 0., 0.1451], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{65.2, 24.04}, {76.84, 23.32}, {74.44, 35.32}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{65.2, 24.04}, {76.84, 23.32}, {74.44, 35.32}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.054902000000000006`, 0., 0.9451], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{65.92, 126.76}, {75.76, 125.92}, {82.48, 
                    130.48000000000002`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{65.92, 
                    126.76}, {75.76, 125.92}, {82.48, 130.48000000000002`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.054902000000000006`, 0., 0.9451], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{82.48, 130.48000000000002`}, {72.88000000000001, 
                    131.08}, {65.92, 126.76000000000002`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{82.48, 130.48000000000002`}, {72.88000000000001, 
                    131.08}, {65.92, 126.76000000000002`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.17255, 0., 0.82745], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{66.76, 
                    4.48}, {76., 2.6800000000000006`}, {69.64, 4.}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{66.76, 4.48}, {76., 
                    2.6800000000000006`}, {69.64, 4.}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.5451, 0., 0.4549], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{68.56, 
                    94.24000000000001}, {80.32000000000001, 92.2}, {85.12, 
                    104.56}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{68.56, 
                    94.24000000000001}, {80.32000000000001, 92.2}, {85.12, 
                    104.56}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.5451, 0., 0.4549], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{85.11999999999999, 104.56}, {73.6, 
                    106.72}, {68.55999999999999, 94.24000000000001}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{85.11999999999999, 104.56}, {73.6, 
                    106.72}, {68.55999999999999, 94.24000000000001}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.18431, 0., 0.8156900000000001], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{69.04, 118.48}, {79.48, 
                    117.04}, {85.96000000000001, 124.48}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{69.04, 118.48}, {79.48, 
                    117.04}, {85.96000000000001, 124.48}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.18431, 0., 0.8156900000000001], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{85.96000000000001, 124.48}, {75.76, 
                    125.92}, {69.04, 118.48}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{85.96000000000001, 124.48}, {75.76, 
                    125.92}, {69.04, 118.48}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.5451, 0., 0.4549], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{80.32, 
                    13.6}, {69.03999999999999, 14.2}, {73.96, 7.}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{80.32, 13.6}, {69.03999999999999, 
                    14.2}, {73.96, 7.}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.71765, 0., 0.28235000000000005`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{69.04, 14.2}, {80.32000000000001, 13.6}, {76.84, 
                    23.32}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{69.04, 
                    14.2}, {80.32000000000001, 13.6}, {76.84, 23.32}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.35294, 0., 0.64706], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{69.64, 
                    4.}, {79.6, 2.6799999999999997`}, {73.96, 7.}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{69.64, 4.}, {79.6, 
                    2.6799999999999997`}, {73.96, 7.}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.18431, 0., 0.8156900000000001], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{79.6, 2.68}, {69.63999999999999, 4.}, {76., 
                    2.68}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{79.6, 
                    2.68}, {69.63999999999999, 4.}, {76., 2.68}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.011764999999999998`, 0., 0.98824], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{72.88, 131.08}, {82.47999999999999, 
                    130.48000000000002`}, {89.19999999999999, 
                    131.92000000000002`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{72.88, 
                    131.08}, {82.47999999999999, 
                    130.48000000000002`}, {89.19999999999999, 
                    131.92000000000002`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.011764999999999998`, 0., 0.98824], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{89.2, 131.92000000000002`}, {79.72, 
                    132.52}, {72.88, 131.08}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{89.2, 
                    131.92000000000002`}, {79.72, 132.52}, {72.88, 131.08}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{73.6, 
                    106.72}, {85.11999999999999, 104.56}, {90.63999999999999, 
                    114.64}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{73.6, 
                    106.72}, {85.11999999999999, 104.56}, {90.63999999999999, 
                    114.64}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{90.64, 
                    114.64}, {79.48, 117.04}, {73.6, 106.72}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{90.64, 114.64}, {79.48, 117.04}, {73.6, 106.72}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[
                    0.8705900000000001, 0., 0.12941000000000003`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{86.67999999999999, 48.04}, {73.72, 49.}, {74.44, 
                    35.32}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{86.67999999999999, 48.04}, {73.72, 49.}, {74.44, 
                    35.32}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.8705900000000001, 0., 
                    0.12941000000000003`], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{73.72, 
                    49.}, {86.68, 48.04}, {87.4, 62.08}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{73.72, 49.}, {86.68, 48.04}, {87.4, 62.08}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[
                    0.8705900000000001, 0., 0.12941000000000003`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{87.4, 62.08}, {74.44, 63.64}, {73.72, 49.}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{87.4, 62.08}, {74.44, 63.64}, {73.72, 49.}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{84.88, 
                    6.52}, {73.96, 7.}, {79.6, 2.6799999999999997`}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{84.88, 6.52}, {73.96, 7.}, {79.6, 
                    2.6799999999999997`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.5451, 0., 0.4549], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{73.96000000000001, 7.}, {84.88000000000001, 
                    6.52}, {80.32000000000001, 13.6}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{73.96000000000001, 7.}, {84.88000000000001, 
                    6.52}, {80.32000000000001, 13.6}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.8078400000000001, 0., 0.19216], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{74.44000000000001, 63.64}, {87.4, 
                    62.08}, {89.68, 76.12}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{74.44000000000001, 63.64}, {87.4, 
                    62.08}, {89.68, 76.12}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.8078400000000001, 0., 0.19216], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{89.67999999999999, 76.11999999999999}, {76.6, 
                    78.27999999999999}, {74.44, 63.639999999999986`}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{89.67999999999999, 76.11999999999999}, {76.6, 
                    78.27999999999999}, {74.44, 63.639999999999986`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.8078400000000001, 0., 0.19216], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{87.4, 34.96}, {74.44, 35.32}, {76.84, 23.32}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{87.4, 34.96}, {74.44, 35.32}, {76.84, 23.32}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[
                    0.8705900000000001, 0., 0.12941000000000003`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{74.44000000000001, 35.32}, {87.4, 
                    34.96}, {86.68, 48.04}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{74.44000000000001, 35.32}, {87.4, 
                    34.96}, {86.68, 48.04}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.066667, 0., 0.93333], Opacity[1.]}],
                     FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{75.76, 
                    125.92}, {85.96000000000001, 124.48}, {92.56, 129.04}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{75.76, 125.92}, {85.96000000000001, 
                    124.48}, {92.56, 129.04}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.066667, 0., 0.93333], Opacity[1.]}],
                     FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{92.56, 
                    129.04}, {82.48, 130.48}, {75.76, 
                    125.91999999999999`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{92.56, 
                    129.04}, {82.48, 130.48}, {75.76, 125.91999999999999`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.18431, 0., 0.8156900000000001], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{76., 2.68}, {85.6, 1.36}, {79.6, 2.68}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{76., 2.68}, {85.6, 1.36}, {79.6, 2.68}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.6901999999999999, 0., 0.3098], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{76.6, 78.28}, {89.67999999999999, 
                    76.12}, {93.03999999999999, 89.44}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{76.6, 78.28}, {89.67999999999999, 
                    76.12}, {93.03999999999999, 89.44}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.6901999999999999, 0., 0.3098], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{93.04, 89.44000000000001}, {80.32000000000001, 
                    92.20000000000002}, {76.60000000000001, 
                    78.28000000000002}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{93.04, 
                    89.44000000000001}, {80.32000000000001, 
                    92.20000000000002}, {76.60000000000001, 
                    78.28000000000002}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.6901999999999999, 0., 0.3098], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{89.32, 23.56}, {76.83999999999999, 
                    23.32}, {80.32, 13.599999999999998`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{89.32, 23.56}, {76.83999999999999, 
                    23.32}, {80.32, 13.599999999999998`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.8078400000000001, 0., 0.19216], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{76.84, 23.32}, {89.32000000000001, 
                    23.56}, {87.4, 34.96}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{76.84, 
                    23.32}, {89.32000000000001, 23.56}, {87.4, 34.96}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[
                    0.20784000000000002`, 0., 0.7921599999999999], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{79.48, 117.04}, {90.64, 114.64}, {96.76, 
                    122.08000000000001`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{79.48, 
                    117.04}, {90.64, 114.64}, {96.76, 122.08000000000001`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.20784000000000002`, 0., 
                    0.7921599999999999], Opacity[1.]}], FilledCurveBox[{{{0, 
                    2, 0}, {0, 1, 0}}}, {{{96.76, 
                    122.08}, {85.96000000000001, 124.48}, {79.48, 
                    117.03999999999999`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{96.76, 
                    122.08}, {85.96000000000001, 124.48}, {79.48, 
                    117.03999999999999`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{79.6, 
                    2.68}, {90.16, 2.44}, {84.88, 6.52}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{79.6, 2.68}, {90.16, 2.44}, {84.88, 6.52}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[
                    0.20784000000000002`, 0., 0.7921599999999999], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{90.16, 2.44}, {79.6, 2.68}, {85.6, 
                    1.3599999999999999`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{90.16, 
                    2.44}, {79.6, 2.68}, {85.6, 1.3599999999999999`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.53725, 0., 0.46275], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{80.32, 
                    92.2}, {93.03999999999999, 89.44}, {97.47999999999999, 
                    101.32000000000001`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{80.32, 
                    92.2}, {93.03999999999999, 89.44}, {97.47999999999999, 
                    101.32000000000001`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.53725, 0., 0.46275], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{97.48, 
                    101.32}, {85.12, 
                    104.55999999999999`}, {80.32000000000001, 
                    92.19999999999999}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{97.48, 
                    101.32}, {85.12, 
                    104.55999999999999`}, {80.32000000000001, 
                    92.19999999999999}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.53725, 0., 0.46275], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{92.56, 
                    14.2}, {80.32000000000001, 13.6}, {84.88, 6.52}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{92.56, 14.2}, {80.32000000000001, 
                    13.6}, {84.88, 6.52}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.6901999999999999, 0., 0.3098], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{80.32, 13.6}, {92.55999999999999, 14.2}, {89.32, 
                    23.560000000000002`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{80.32, 
                    13.6}, {92.55999999999999, 14.2}, {89.32, 
                    23.560000000000002`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.023528999999999998`, 0., 0.97647], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{82.48, 130.48000000000002`}, {92.56, 
                    129.04000000000002`}, {99.04, 130.60000000000002`}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{82.48, 130.48000000000002`}, {92.56, 
                    129.04000000000002`}, {99.04, 130.60000000000002`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.023528999999999998`, 0., 0.97647], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{99.04, 130.6}, {89.2, 131.92}, {82.48, 
                    130.48}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{99.04, 
                    130.6}, {89.2, 131.92}, {82.48, 130.48}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[
                    0.38431000000000004`, 0., 0.6156900000000001], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{96.76, 7.359999999999999}, {84.88000000000001, 
                    6.52}, {90.16000000000001, 2.4399999999999995`}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{96.76, 
                    7.359999999999999}, {84.88000000000001, 
                    6.52}, {90.16000000000001, 2.4399999999999995`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.53725, 0., 0.46275], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{84.88, 
                    6.52}, {96.75999999999999, 7.359999999999999}, {92.56, 
                    14.2}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{84.88, 
                    6.52}, {96.75999999999999, 7.359999999999999}, {92.56, 
                    14.2}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.38431000000000004`, 0., 
                    0.6156900000000001], Opacity[1.]}], FilledCurveBox[{{{0, 
                    2, 0}, {0, 1, 0}}}, {{{85.11999999999999, 
                    104.56}, {97.47999999999999, 
                    101.32000000000001`}, {102.63999999999999`, 111.04}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{85.11999999999999, 
                    104.56}, {97.47999999999999, 
                    101.32000000000001`}, {102.63999999999999`, 111.04}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[
                    0.38431000000000004`, 0., 0.6156900000000001], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{102.64, 111.04}, {90.64, 114.64}, {85.12, 
                    104.56}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{102.64, 111.04}, {90.64, 114.64}, {85.12, 
                    104.56}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.20784000000000002`, 0., 
                    0.7921599999999999], Opacity[1.]}], FilledCurveBox[{{{0, 
                    2, 0}, {0, 1, 0}}}, {{{85.6, 1.36}, {95.91999999999999, 
                    1.12}, {90.16, 2.4400000000000004`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{85.6, 1.36}, {95.91999999999999, 1.12}, {90.16, 
                    2.4400000000000004`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[
                    0.10196000000000001`, 0., 0.8980400000000001], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{85.96000000000001, 124.48}, {96.76, 
                    122.08}, {103.12, 126.52000000000001`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{85.96000000000001, 124.48}, {96.76, 
                    122.08}, {103.12, 126.52000000000001`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[
                    0.10196000000000001`, 0., 0.8980400000000001], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{103.11999999999999`, 
                    126.52}, {92.55999999999999, 129.04}, {85.96, 
                    124.47999999999999`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{103.11999999999999`, 
                    126.52}, {92.55999999999999, 129.04}, {85.96, 
                    124.47999999999999`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.8, 0., 0.2], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{100.84, 
                    47.68}, {86.68, 48.04}, {87.4, 34.96}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{100.84, 47.68}, {86.68, 48.04}, {87.4, 34.96}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.8, 0., 0.2], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{86.67999999999999, 48.04}, {100.83999999999999`, 
                    47.68}, {101.55999999999999`, 60.519999999999996`}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{86.67999999999999, 
                    48.04}, {100.83999999999999`, 
                    47.68}, {101.55999999999999`, 60.519999999999996`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.8, 0., 0.2], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{101.56, 
                    60.52}, {87.4, 62.080000000000005`}, {86.68, 
                    48.040000000000006`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{101.56, 60.52}, {87.4, 
                    62.080000000000005`}, {86.68, 48.040000000000006`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.7451, 0., 0.2549], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{101.32, 
                    35.56}, {87.39999999999999, 34.96}, {89.32, 
                    23.560000000000002`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{101.32, 35.56}, {87.39999999999999, 
                    34.96}, {89.32, 23.560000000000002`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.8, 0., 0.2], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{87.4, 
                    34.96}, {101.32000000000001`, 35.56}, {100.84, 47.68}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{87.4, 34.96}, {101.32000000000001`, 
                    35.56}, {100.84, 47.68}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.7451, 0., 0.2549], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{87.4, 
                    62.08}, {101.56, 
                    60.519999999999996`}, {103.60000000000001`, 73.48}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{87.4, 62.08}, {101.56, 
                    60.519999999999996`}, {103.60000000000001`, 73.48}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.7451, 0., 0.2549], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{103.6, 
                    73.48}, {89.67999999999999, 76.12}, {87.39999999999999, 
                    62.080000000000005`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{103.6, 
                    73.48}, {89.67999999999999, 76.12}, {87.39999999999999, 
                    62.080000000000005`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.65098, 0., 0.34902], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{103., 
                    25.}, {89.32, 23.56}, {92.56, 14.2}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{103., 25.}, {89.32, 23.56}, {92.56, 14.2}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.7451, 0., 0.2549], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{89.32, 
                    23.56}, {103., 25.}, {101.32, 35.56}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{89.32, 23.56}, {103., 25.}, {101.32, 35.56}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.65098, 0., 0.34902], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{89.67999999999999, 76.11999999999999}, {103.6, 
                    73.47999999999999}, {106.6, 85.83999999999999}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{89.67999999999999, 
                    76.11999999999999}, {103.6, 73.47999999999999}, {106.6, 
                    85.83999999999999}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.65098, 0., 0.34902], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{106.6, 
                    85.84}, {93.03999999999999, 89.44}, {89.67999999999999, 
                    76.12}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{106.6, 
                    85.84}, {93.03999999999999, 89.44}, {89.67999999999999, 
                    76.12}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.38431000000000004`, 0., 
                    0.6156900000000001], Opacity[1.]}], FilledCurveBox[{{{0, 
                    2, 0}, {0, 1, 0}}}, {{{90.16, 2.44}, {101.56, 
                    3.2800000000000002`}, {96.75999999999999, 
                    7.359999999999999}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{90.16, 
                    2.44}, {101.56, 3.2800000000000002`}, {96.75999999999999, 
                    7.359999999999999}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.24706000000000003`, 0., 0.75294], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{101.56, 3.2800000000000002`}, {90.16, 
                    2.4400000000000004`}, {95.92, 1.12}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{101.56, 3.2800000000000002`}, {90.16, 
                    2.4400000000000004`}, {95.92, 1.12}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.24706000000000003`, 0., 0.75294], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{90.64, 114.64}, {102.64, 111.04}, {108.28, 
                    118.24}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{90.64, 
                    114.64}, {102.64, 111.04}, {108.28, 118.24}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.24706000000000003`, 0., 0.75294], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{108.28, 118.24000000000001`}, {96.76, 
                    122.08000000000001`}, {90.64, 114.64000000000001`}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{108.28, 118.24000000000001`}, {96.76, 
                    122.08000000000001`}, {90.64, 114.64000000000001`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.06274500000000001, 0., 0.93725], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{92.56, 129.04}, {103.12, 
                    126.52}, {109.24000000000001`, 128.07999999999998`}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{92.56, 129.04}, {103.12, 
                    126.52}, {109.24000000000001`, 128.07999999999998`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.06274500000000001, 0., 0.93725], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{109.24000000000001`, 128.08}, {99.04, 
                    130.60000000000002`}, {92.56, 129.04000000000002`}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{109.24000000000001`, 128.08}, {99.04, 
                    130.60000000000002`}, {92.56, 129.04000000000002`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.53333, 0., 0.46667000000000003`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{105.76, 16.24}, {92.56, 14.2}, {96.76, 
                    7.359999999999998}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{105.76, 16.24}, {92.56, 14.2}, {96.76, 
                    7.359999999999998}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.65098, 0., 0.34902], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{92.56, 
                    14.2}, {105.76, 16.24}, {103., 25.}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{92.56, 14.2}, {105.76, 16.24}, {103., 25.}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.53333, 0., 0.46667000000000003`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{93.04, 89.44000000000001}, {106.60000000000001`, 
                    85.84000000000002}, {110.56, 96.76}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{93.04, 89.44000000000001}, {106.60000000000001`, 
                    85.84000000000002}, {110.56, 96.76}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.53333, 0., 0.46667000000000003`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{110.56, 96.76}, {97.48, 
                    101.32000000000001`}, {93.04, 89.44000000000001}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{110.56, 96.76}, {97.48, 
                    101.32000000000001`}, {93.04, 89.44000000000001}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.24706000000000003`, 0., 0.75294], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{95.92, 1.12}, {106.84, 2.08}, {101.56, 
                    3.2800000000000002`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{95.92, 
                    1.12}, {106.84, 2.08}, {101.56, 3.2800000000000002`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[
                    0.40392000000000006`, 0., 0.5960799999999999], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{109.36, 10.}, {96.76, 
                    7.359999999999999}, {101.56, 3.2800000000000002`}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{109.36, 10.}, {96.76, 
                    7.359999999999999}, {101.56, 3.2800000000000002`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.53333, 0., 0.46667000000000003`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{96.76, 7.359999999999999}, {109.36, 
                    10.}, {105.76, 16.240000000000002`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{96.76, 7.359999999999999}, {109.36, 
                    10.}, {105.76, 16.240000000000002`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.15294000000000005`, 0., 0.84706], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{96.76, 122.08}, {108.28, 118.24}, {114.16, 
                    122.67999999999999`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{96.76, 
                    122.08}, {108.28, 118.24}, {114.16, 122.67999999999999`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.15294000000000005`, 0., 0.84706], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{114.16, 122.67999999999999`}, {103.12, 
                    126.52}, {96.75999999999999, 122.08}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{114.16, 122.67999999999999`}, {103.12, 
                    126.52}, {96.75999999999999, 122.08}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[
                    0.40392000000000006`, 0., 0.5960799999999999], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{97.48, 101.32}, {110.56, 
                    96.75999999999999}, {115.24000000000001`, 
                    105.75999999999999`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{97.48, 
                    101.32}, {110.56, 
                    96.75999999999999}, {115.24000000000001`, 
                    105.75999999999999`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[
                    0.40392000000000006`, 0., 0.5960799999999999], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{115.24000000000001`, 
                    105.76}, {102.64000000000001`, 
                    111.04}, {97.48000000000002, 101.32000000000001`}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{115.24000000000001`, 
                    105.76}, {102.64000000000001`, 
                    111.04}, {97.48000000000002, 101.32000000000001`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[
                    0.10196000000000001`, 0., 0.8980400000000001], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{99.04, 130.6}, {109.24000000000001`, 
                    128.07999999999998`}, {114.88000000000001`, 126.88}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{99.04, 130.6}, {109.24000000000001`, 
                    128.07999999999998`}, {114.88000000000001`, 126.88}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[
                    0.10196000000000001`, 0., 0.8980400000000001], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{114.88, 126.88}, {105.03999999999999`, 
                    129.16}, {99.03999999999999, 130.6}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{114.88, 126.88}, {105.03999999999999`, 
                    129.16}, {99.03999999999999, 130.6}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.7215699999999999, 0., 0.27843], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{115.6, 47.92}, {100.83999999999999`, 
                    47.68}, {101.32, 35.56}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{115.6, 
                    47.92}, {100.83999999999999`, 47.68}, {101.32, 35.56}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.7215699999999999, 0., 0.27843], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{116.32, 59.08}, {101.55999999999999`, 
                    60.519999999999996`}, {100.83999999999999`, 47.68}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{116.32, 59.08}, {101.55999999999999`, 
                    60.519999999999996`}, {100.83999999999999`, 47.68}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.7215699999999999, 0., 0.27843], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{100.84, 47.68}, {115.60000000000001`, 
                    47.92}, {116.32000000000001`, 59.08}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{100.84, 47.68}, {115.60000000000001`, 
                    47.92}, {116.32000000000001`, 59.08}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.6823499999999999, 0., 0.31765], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{115.96000000000001`, 
                    37.36}, {101.32000000000001`, 35.56}, {103., 25.}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{115.96000000000001`, 
                    37.36}, {101.32000000000001`, 35.56}, {103., 25.}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.7215699999999999, 0., 0.27843], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{101.32, 35.56}, {115.96, 37.36}, {115.6, 
                    47.92}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{101.32, 35.56}, {115.96, 37.36}, {115.6, 47.92}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.29804, 0., 0.7019599999999999], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{113.67999999999999`, 
                    6.159999999999999}, {101.55999999999999`, 
                    3.2799999999999994`}, {106.83999999999999`, 
                    2.079999999999999}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{113.67999999999999`, 
                    6.159999999999999}, {101.55999999999999`, 
                    3.2799999999999994`}, {106.83999999999999`, 
                    2.079999999999999}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[
                    0.40392000000000006`, 0., 0.5960799999999999], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{101.56, 3.2800000000000002`}, {113.68, 
                    6.16}, {109.36, 10.}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{101.56, 3.2800000000000002`}, {113.68, 
                    6.16}, {109.36, 10.}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.6823499999999999, 0., 0.31765], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{101.56, 60.52}, {116.32000000000001`, 
                    59.080000000000005`}, {118., 70.36}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{101.56, 60.52}, {116.32000000000001`, 
                    59.080000000000005`}, {118., 70.36}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.6823499999999999, 0., 0.31765], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{118., 70.36}, {103.6, 73.48}, {101.56, 
                    60.519999999999996`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{118., 
                    70.36}, {103.6, 73.48}, {101.56, 60.519999999999996`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.29804, 0., 0.7019599999999999], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{102.64, 111.04}, {115.24, 105.76}, {120.28, 
                    112.60000000000001`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{102.64, 111.04}, {115.24, 105.76}, {120.28, 
                    112.60000000000001`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.29804, 0., 0.7019599999999999], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{120.28, 112.6}, {108.28, 118.24}, {102.64, 
                    111.03999999999999`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{120.28, 112.6}, {108.28, 118.24}, {102.64, 
                    111.03999999999999`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.61176, 0., 0.38824], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{117.28, 
                    28.12}, {103., 25.}, {105.76, 16.240000000000002`}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{117.28, 28.12}, {103., 25.}, {105.76, 
                    16.240000000000002`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.6823499999999999, 0., 0.31765], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{103., 25.}, {117.28, 
                    28.12}, {115.96000000000001`, 37.36}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{103., 25.}, {117.28, 
                    28.12}, {115.96000000000001`, 37.36}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.12157000000000001`, 0., 0.87843], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{103.11999999999999`, 126.52}, {114.16, 
                    122.67999999999999`}, {119.79999999999998`, 124.24}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{103.11999999999999`, 126.52}, {114.16, 
                    122.67999999999999`}, {119.79999999999998`, 124.24}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.12157000000000001`, 0., 0.87843], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{119.8, 124.24000000000001`}, {109.24, 
                    128.08}, {103.12, 126.52000000000001`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{119.8, 124.24000000000001`}, {109.24, 
                    128.08}, {103.12, 126.52000000000001`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.61176, 0., 0.38824], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{103.6, 
                    73.48}, {118., 70.36}, {120.63999999999999`, 81.16}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{103.6, 73.48}, {118., 
                    70.36}, {120.63999999999999`, 81.16}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.61176, 0., 0.38824], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{120.64, 
                    81.16}, {106.6, 85.84}, {103.6, 73.47999999999999}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{120.64, 81.16}, {106.6, 85.84}, {103.6, 
                    73.47999999999999}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{119.44000000000001`, 
                    20.439999999999998`}, {105.76000000000002`, 
                    16.24}, {109.36000000000001`, 9.999999999999998}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{119.44000000000001`, 
                    20.439999999999998`}, {105.76000000000002`, 
                    16.24}, {109.36000000000001`, 9.999999999999998}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.61176, 0., 0.38824], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{105.76, 
                    16.24}, {119.44, 20.439999999999998`}, {117.28, 
                    28.119999999999997`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{105.76, 16.24}, {119.44, 
                    20.439999999999998`}, {117.28, 28.119999999999997`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{106.6, 
                    85.84}, {120.63999999999999`, 81.16}, {124., 90.76}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{106.6, 85.84}, {120.63999999999999`, 
                    81.16}, {124., 90.76}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{124., 
                    90.76}, {110.56, 96.76}, {106.6, 85.84}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{124., 90.76}, {110.56, 96.76}, {106.6, 85.84}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.29804, 0., 0.7019599999999999], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{106.84, 2.08}, {118.36, 4.96}, {113.68, 
                    6.16}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{106.84, 2.08}, {118.36, 4.96}, {113.68, 6.16}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.22353, 0., 0.77647], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{108.28, 
                    118.24000000000001`}, {120.28, 
                    112.60000000000001`}, {125.44, 116.68}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{108.28, 118.24000000000001`}, {120.28, 
                    112.60000000000001`}, {125.44, 116.68}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.22353, 0., 0.77647], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{125.44000000000001`, 
                    116.67999999999999`}, {114.16000000000001`, 
                    122.67999999999999`}, {108.28000000000002`, 118.24}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{125.44000000000001`, 
                    116.67999999999999`}, {114.16000000000001`, 
                    122.67999999999999`}, {108.28000000000002`, 118.24}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.15294000000000005`, 0., 0.84706], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{125.08, 123.04}, {114.88, 
                    126.88000000000001`}, {109.24, 128.08}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{125.08, 123.04}, {114.88, 
                    126.88000000000001`}, {109.24, 128.08}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.15294000000000005`, 0., 0.84706], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{109.24000000000001`, 
                    128.08}, {119.80000000000001`, 
                    124.24000000000001`}, {125.08000000000001`, 123.04}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{109.24000000000001`, 
                    128.08}, {119.80000000000001`, 
                    124.24000000000001`}, {125.08000000000001`, 123.04}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[
                    0.4313700000000001, 0., 0.5686300000000001], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{122.44000000000001`, 
                    14.8}, {109.36000000000001`, 10.}, {113.68, 
                    6.160000000000002}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{122.44000000000001`, 
                    14.8}, {109.36000000000001`, 10.}, {113.68, 
                    6.160000000000002}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{109.36, 
                    10.}, {122.44, 14.8}, {119.44, 20.439999999999998`}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{109.36, 10.}, {122.44, 14.8}, {119.44, 
                    20.439999999999998`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[
                    0.4313700000000001, 0., 0.5686300000000001], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{110.56, 96.76}, {124., 
                    90.76}, {127.96000000000001`, 98.68}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{110.56, 96.76}, {124., 
                    90.76}, {127.96000000000001`, 98.68}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[
                    0.4313700000000001, 0., 0.5686300000000001], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{127.96000000000001`, 
                    98.67999999999999}, {115.24000000000001`, 
                    105.75999999999999`}, {110.56, 96.75999999999999}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{127.96000000000001`, 
                    98.67999999999999}, {115.24000000000001`, 
                    105.75999999999999`}, {110.56, 96.75999999999999}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.34902, 0., 0.65098], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{125.92, 
                    11.44}, {113.68, 6.159999999999999}, {118.36, 
                    4.959999999999999}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{125.92, 11.44}, {113.68, 
                    6.159999999999999}, {118.36, 4.959999999999999}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[
                    0.4313700000000001, 0., 0.5686300000000001], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{113.67999999999999`, 
                    6.159999999999999}, {125.91999999999999`, 
                    11.44}, {122.44, 14.799999999999997`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{113.67999999999999`, 
                    6.159999999999999}, {125.91999999999999`, 
                    11.44}, {122.44, 14.799999999999997`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.19608, 0., 0.8039200000000001], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{114.16, 122.67999999999999`}, {125.44, 
                    116.67999999999999`}, {130.48, 118.24}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{114.16, 122.67999999999999`}, {125.44, 
                    116.67999999999999`}, {130.48, 118.24}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.19608, 0., 0.8039200000000001], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{130.48000000000002`, 
                    118.24000000000001`}, {119.80000000000001`, 
                    124.24000000000001`}, {114.16000000000003`, 122.68}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{130.48000000000002`, 
                    118.24000000000001`}, {119.80000000000001`, 
                    124.24000000000001`}, {114.16000000000003`, 122.68}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.34902, 0., 0.65098], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{115.24000000000001`, 
                    105.76}, {127.96000000000001`, 98.68}, {132.16, 
                    104.68}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{115.24000000000001`, 
                    105.76}, {127.96000000000001`, 98.68}, {132.16, 104.68}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.34902, 0., 0.65098], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{132.16, 
                    104.67999999999999`}, {120.28, 112.6}, {115.24, 
                    105.75999999999999`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{132.16, 104.67999999999999`}, {120.28, 
                    112.6}, {115.24, 105.75999999999999`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.64314, 0., 0.35686], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{130.12, 
                    49.}, {115.60000000000001`, 47.92}, {115.96000000000001`, 
                    37.36}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{130.12, 49.}, {115.60000000000001`, 
                    47.92}, {115.96000000000001`, 37.36}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.64314, 0., 0.35686], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{115.6, 
                    47.92}, {130.12, 49.}, {130.72, 57.88}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{115.6, 47.92}, {130.12, 49.}, {130.72, 57.88}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.64314, 0., 0.35686], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{130.72, 
                    57.879999999999995`}, {116.32, 59.08}, {115.6, 
                    47.919999999999995`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{130.72, 57.879999999999995`}, {116.32, 
                    59.08}, {115.6, 47.919999999999995`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.61961, 0., 0.38039], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{130.36, 
                    40.48}, {115.96000000000001`, 
                    37.36}, {117.28000000000002`, 28.119999999999997`}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{130.36, 40.48}, {115.96000000000001`, 
                    37.36}, {117.28000000000002`, 28.119999999999997`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.64314, 0., 0.35686], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{115.96000000000001`, 37.36}, {130.36, 
                    40.48}, {130.12, 49.}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{115.96000000000001`, 37.36}, {130.36, 
                    40.48}, {130.12, 49.}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.61961, 0., 0.38039], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{116.32, 
                    59.08}, {130.72, 57.879999999999995`}, {132.04, 67.}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{116.32, 59.08}, {130.72, 
                    57.879999999999995`}, {132.04, 67.}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.61961, 0., 0.38039], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{132.04, 
                    67.}, {118., 70.36}, {116.32, 59.08}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{132.04, 67.}, {118., 70.36}, {116.32, 59.08}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.57255, 0., 0.42745000000000005`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{131.32000000000002`, 
                    33.04}, {117.28000000000003`, 
                    28.119999999999997`}, {119.44000000000003`, 
                    20.439999999999998`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{131.32000000000002`, 
                    33.04}, {117.28000000000003`, 
                    28.119999999999997`}, {119.44000000000003`, 
                    20.439999999999998`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.61961, 0., 0.38039], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{117.28, 
                    28.12}, {131.32, 33.04}, {130.36, 
                    40.480000000000004`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{117.28, 28.12}, {131.32, 33.04}, {130.36, 
                    40.480000000000004`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.57255, 0., 0.42745000000000005`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{118., 70.36}, {132.04, 67.}, {134.2, 75.64}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{118., 70.36}, {132.04, 67.}, {134.2, 75.64}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.57255, 0., 0.42745000000000005`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{134.2, 75.64}, {120.63999999999999`, 
                    81.16}, {117.99999999999999`, 70.36}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{134.2, 75.64}, {120.63999999999999`, 
                    81.16}, {117.99999999999999`, 70.36}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.29412000000000005`, 0., 0.70588], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{129.88000000000002`, 
                    10.239999999999998`}, {118.36000000000003`, 
                    4.959999999999998}, {123.16000000000003`, 
                    6.2799999999999985`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{129.88000000000002`, 
                    10.239999999999998`}, {118.36000000000003`, 
                    4.959999999999998}, {123.16000000000003`, 
                    6.2799999999999985`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.34902, 0., 0.65098], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{118.36, 
                    4.96}, {129.88, 10.24}, {125.92, 11.440000000000001`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{118.36, 4.96}, {129.88, 10.24}, {125.92, 
                    11.440000000000001`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.51765, 0., 0.48235000000000006`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{132.88000000000002`, 
                    26.8}, {119.44000000000003`, 
                    20.44}, {122.44000000000003`, 14.8}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{132.88000000000002`, 
                    26.8}, {119.44000000000003`, 
                    20.44}, {122.44000000000003`, 14.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.57255, 0., 0.42745000000000005`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{119.44000000000001`, 
                    20.439999999999998`}, {132.88000000000002`, 
                    26.799999999999997`}, {131.32000000000002`, 33.04}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{119.44000000000001`, 
                    20.439999999999998`}, {132.88000000000002`, 
                    26.799999999999997`}, {131.32000000000002`, 33.04}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.22353, 0., 0.77647], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{135.16, 
                    117.4}, {125.08, 123.04}, {119.8, 
                    124.24000000000001`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{135.16, 117.4}, {125.08, 123.04}, {119.8, 
                    124.24000000000001`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.22353, 0., 0.77647], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{119.8, 
                    124.24000000000001`}, {130.48, 
                    118.24000000000001`}, {135.16, 117.4}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{119.8, 
                    124.24000000000001`}, {130.48, 
                    118.24000000000001`}, {135.16, 117.4}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.29412000000000005`, 0., 0.70588], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{120.28, 112.6}, {132.16, 
                    104.67999999999999`}, {136.48, 108.52}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{120.28, 112.6}, {132.16, 
                    104.67999999999999`}, {136.48, 108.52}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.29412000000000005`, 0., 0.70588], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{136.48000000000002`, 
                    108.52}, {125.44000000000003`, 
                    116.67999999999999`}, {120.28000000000002`, 112.6}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{136.48000000000002`, 
                    108.52}, {125.44000000000003`, 
                    116.67999999999999`}, {120.28000000000002`, 112.6}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.51765, 0., 0.48235000000000006`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{120.64, 81.16}, {134.2, 75.64}, {136.72, 
                    83.32}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{120.64, 81.16}, {134.2, 75.64}, {136.72, 83.32}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.51765, 0., 0.48235000000000006`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{136.72, 83.32}, {124., 
                    90.75999999999999}, {120.64, 81.16}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{136.72, 83.32}, {124., 
                    90.75999999999999}, {120.64, 81.16}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.4549, 0., 0.5451], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{135.16, 
                    22.24}, {122.44, 14.799999999999997`}, {125.92, 
                    11.439999999999998`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{135.16, 22.24}, {122.44, 
                    14.799999999999997`}, {125.92, 11.439999999999998`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.51765, 0., 0.48235000000000006`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{122.44000000000001`, 
                    14.8}, {135.16000000000003`, 
                    22.240000000000002`}, {132.88000000000002`, 26.8}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{122.44000000000001`, 
                    14.8}, {135.16000000000003`, 
                    22.240000000000002`}, {132.88000000000002`, 26.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.29412000000000005`, 0., 0.70588], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{123.16, 6.28}, {133.96, 11.32}, {129.88, 
                    10.24}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{123.16, 6.28}, {133.96, 11.32}, {129.88, 10.24}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.4549, 0., 0.5451], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{124., 
                    90.76}, {136.72, 83.32000000000001}, {139.72, 
                    89.80000000000001}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{124., 
                    90.76}, {136.72, 83.32000000000001}, {139.72, 
                    89.80000000000001}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.4549, 0., 0.5451], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{139.72, 
                    89.8}, {127.96, 98.67999999999999}, {124., 
                    90.75999999999999}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{139.72, 89.8}, {127.96, 
                    98.67999999999999}, {124., 90.75999999999999}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.27451000000000003`, 0., 0.72549], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{125.44000000000001`, 
                    116.67999999999999`}, {136.48000000000002`, 
                    108.52}, {140.68, 110.08}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{125.44000000000001`, 
                    116.67999999999999`}, {136.48000000000002`, 
                    108.52}, {140.68, 110.08}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.27451000000000003`, 0., 0.72549], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{140.68, 110.08}, {130.48000000000002`, 
                    118.24}, {125.44000000000001`, 116.67999999999999`}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{140.68, 110.08}, {130.48000000000002`, 
                    118.24}, {125.44000000000001`, 116.67999999999999`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.39608000000000004`, 0., 0.60392], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{137.8, 19.36}, {125.92000000000002`, 
                    11.44}, {129.88000000000002`, 10.24}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{137.8, 19.36}, {125.92000000000002`, 
                    11.44}, {129.88000000000002`, 10.24}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.4549, 0., 0.5451], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{125.92, 
                    11.44}, {137.8, 19.36}, {135.16, 22.240000000000002`}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{125.92, 11.44}, {137.8, 19.36}, {135.16, 
                    22.240000000000002`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.39608000000000004`, 0., 0.60392], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{127.96000000000001`, 
                    98.67999999999999}, {139.72, 89.8}, {142.96, 94.72}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{127.96000000000001`, 
                    98.67999999999999}, {139.72, 89.8}, {142.96, 94.72}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.39608000000000004`, 0., 0.60392], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{142.96, 94.72}, {132.16, 
                    104.68}, {127.96000000000001`, 98.67999999999999}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{142.96, 94.72}, {132.16, 
                    104.68}, {127.96000000000001`, 98.67999999999999}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{140.8, 
                    18.279999999999998`}, {129.88000000000002`, 
                    10.239999999999998`}, {133.96, 11.319999999999997`}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{140.8, 
                    18.279999999999998`}, {129.88000000000002`, 
                    10.239999999999998`}, {133.96, 11.319999999999997`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.39608000000000004`, 0., 0.60392], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{129.88000000000002`, 
                    10.239999999999998`}, {140.8, 
                    18.279999999999998`}, {137.8, 19.36}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{129.88000000000002`, 
                    10.239999999999998`}, {140.8, 
                    18.279999999999998`}, {137.8, 19.36}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.58039, 0., 0.41961000000000004`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{143.32000000000002`, 
                    50.8}, {130.12000000000003`, 49.}, {130.36, 40.48}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{143.32000000000002`, 
                    50.8}, {130.12000000000003`, 49.}, {130.36, 40.48}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.58039, 0., 0.41961000000000004`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{130.12, 49.}, {143.32, 50.8}, {143.8, 57.04}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{130.12, 49.}, {143.32, 50.8}, {143.8, 57.04}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.58039, 0., 0.41961000000000004`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{143.8, 57.04}, {130.72, 57.88}, {130.12, 
                    49.}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{143.8, 
                    57.04}, {130.72, 57.88}, {130.12, 49.}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.56471, 0., 0.43529], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{143.32000000000002`, 44.92}, {130.36, 
                    40.480000000000004`}, {131.32000000000002`, 33.04}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{143.32000000000002`, 44.92}, {130.36, 
                    40.480000000000004`}, {131.32000000000002`, 33.04}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.58039, 0., 0.41961000000000004`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{130.36, 40.48}, {143.32000000000002`, 
                    44.919999999999995`}, {143.32000000000002`, 50.8}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{130.36, 40.48}, {143.32000000000002`, 
                    44.919999999999995`}, {143.32000000000002`, 50.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.29412000000000005`, 0., 0.70588], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{144.64, 109.36}, {135.16, 117.4}, {130.48, 
                    118.24}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{144.64, 109.36}, {135.16, 117.4}, {130.48, 
                    118.24}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.29412000000000005`, 0., 0.70588], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{130.48000000000002`, 
                    118.24000000000001`}, {140.68, 
                    110.08000000000001`}, {144.64000000000001`, 
                    109.36000000000001`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{130.48000000000002`, 
                    118.24000000000001`}, {140.68, 
                    110.08000000000001`}, {144.64000000000001`, 
                    109.36000000000001`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.56471, 0., 0.43529], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{130.72, 
                    57.879999999999995`}, {143.8, 
                    57.03999999999999}, {144.64, 63.39999999999999}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{130.72, 57.879999999999995`}, {143.8, 
                    57.03999999999999}, {144.64, 63.39999999999999}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.56471, 0., 0.43529], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{144.64, 
                    63.4}, {132.04, 67.}, {130.72, 57.879999999999995`}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{144.64, 63.4}, {132.04, 67.}, {130.72, 
                    57.879999999999995`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.54118, 0., 0.45882000000000006`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{143.92000000000002`, 
                    39.760000000000005`}, {131.32000000000002`, 
                    33.040000000000006`}, {132.88000000000002`, 
                    26.800000000000004`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{143.92000000000002`, 
                    39.760000000000005`}, {131.32000000000002`, 
                    33.040000000000006`}, {132.88000000000002`, 
                    26.800000000000004`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.56471, 0., 0.43529], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{131.32000000000002`, 
                    33.04}, {143.92000000000002`, 
                    39.76}, {143.32000000000002`, 44.92}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{131.32000000000002`, 
                    33.04}, {143.92000000000002`, 
                    39.76}, {143.32000000000002`, 44.92}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.54118, 0., 0.45882000000000006`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{132.04, 67.}, {144.64, 
                    63.4}, {145.95999999999998`, 69.4}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{132.04, 67.}, {144.64, 
                    63.4}, {145.95999999999998`, 69.4}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.54118, 0., 0.45882000000000006`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{145.96, 69.4}, {134.20000000000002`, 
                    75.64}, {132.04000000000002`, 67.}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{145.96, 69.4}, {134.20000000000002`, 
                    75.64}, {132.04000000000002`, 67.}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{132.16, 
                    104.67999999999999`}, {142.96, 94.72}, {146.32, 
                    97.96}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{132.16, 104.67999999999999`}, {142.96, 
                    94.72}, {146.32, 97.96}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{146.32000000000002`, 
                    97.96000000000001}, {136.48000000000002`, 
                    108.52000000000001`}, {132.16000000000003`, 104.68}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{146.32000000000002`, 
                    97.96000000000001}, {136.48000000000002`, 
                    108.52000000000001`}, {132.16000000000003`, 104.68}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.51373, 0., 0.48627000000000004`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{145., 35.32}, {132.88, 26.8}, {135.16, 
                    22.240000000000002`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{145., 
                    35.32}, {132.88, 26.8}, {135.16, 22.240000000000002`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.54118, 0., 0.45882000000000006`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{132.88000000000002`, 
                    26.8}, {145.00000000000003`, 
                    35.32}, {143.92000000000002`, 39.760000000000005`}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{132.88000000000002`, 
                    26.8}, {145.00000000000003`, 
                    35.32}, {143.92000000000002`, 39.760000000000005`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.35294, 0., 0.64706], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{144.04, 
                    19.}, {133.95999999999998`, 11.32}, {138.04, 14.32}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{144.04, 19.}, {133.95999999999998`, 
                    11.32}, {138.04, 14.32}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{133.96, 
                    11.32}, {144.04000000000002`, 19.}, {140.8, 18.28}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{133.96, 11.32}, {144.04000000000002`, 
                    19.}, {140.8, 18.28}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.51373, 0., 0.48627000000000004`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{134.2, 75.64}, {145.95999999999998`, 
                    69.4}, {147.76, 74.68}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{134.2, 
                    75.64}, {145.95999999999998`, 69.4}, {147.76, 74.68}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.51373, 0., 0.48627000000000004`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{147.76, 74.67999999999999}, {136.72, 
                    83.32}, {134.2, 75.63999999999999}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{147.76, 74.67999999999999}, {136.72, 
                    83.32}, {134.2, 75.63999999999999}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.47451000000000004`, 0., 0.52549], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{146.44, 32.08}, {135.16, 22.24}, {137.8, 
                    19.36}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{146.44, 32.08}, {135.16, 22.24}, {137.8, 19.36}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.51373, 0., 0.48627000000000004`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{135.16, 22.24}, {146.44, 32.08}, {145., 
                    35.32}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{135.16, 22.24}, {146.44, 32.08}, {145., 35.32}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.34902, 0., 0.65098], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{148.12, 
                    106.48}, {139.24, 114.04}, {135.16, 117.4}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{148.12, 106.48}, {139.24, 114.04}, {135.16, 
                    117.4}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.34902, 0., 0.65098], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{135.16, 
                    117.4}, {144.64, 109.36000000000001`}, {148.12, 
                    106.48}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{135.16, 117.4}, {144.64, 
                    109.36000000000001`}, {148.12, 106.48}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.35294, 0., 0.64706], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{136.48000000000002`, 
                    108.52}, {146.32000000000002`, 97.96}, {149.68, 
                    99.28}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{136.48000000000002`, 
                    108.52}, {146.32000000000002`, 97.96}, {149.68, 99.28}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.35294, 0., 0.64706], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{149.68, 
                    99.28}, {140.68, 110.08}, {136.48000000000002`, 
                    108.52}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{149.68, 99.28}, {140.68, 
                    110.08}, {136.48000000000002`, 108.52}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.47451000000000004`, 0., 0.52549], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{136.72, 83.32}, {147.76, 
                    74.67999999999999}, {149.8, 79.36}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{136.72, 83.32}, {147.76, 
                    74.67999999999999}, {149.8, 79.36}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.47451000000000004`, 0., 0.52549], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{149.8, 79.36}, {139.72, 89.8}, {136.72, 
                    83.32}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{149.8, 
                    79.36}, {139.72, 89.8}, {136.72, 83.32}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.44314, 0., 0.55686], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{148.23999999999998`, 
                    29.919999999999998`}, {137.79999999999998`, 
                    19.36}, {140.79999999999998`, 18.28}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{148.23999999999998`, 
                    29.919999999999998`}, {137.79999999999998`, 
                    19.36}, {140.79999999999998`, 18.28}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.47451000000000004`, 0., 0.52549], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{137.8, 19.36}, {148.24, 29.92}, {146.44, 
                    32.08}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{137.8, 
                    19.36}, {148.24, 29.92}, {146.44, 32.08}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.35294, 0., 0.64706], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{138.04, 
                    14.32}, {147.28, 21.4}, {144.04, 19.}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{138.04, 14.32}, {147.28, 21.4}, {144.04, 19.}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.44314, 0., 0.55686], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{139.72, 
                    89.8}, {149.8, 79.36}, {152.08, 82.84}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{139.72, 89.8}, {149.8, 79.36}, {152.08, 82.84}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.44314, 0., 0.55686], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{152.08, 
                    82.84}, {142.96, 94.72}, {139.72, 89.8}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{152.08, 82.84}, {142.96, 94.72}, {139.72, 89.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{152.68, 
                    98.8}, {144.64000000000001`, 109.36}, {140.68, 
                    110.08}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{152.68, 98.8}, {144.64000000000001`, 
                    109.36}, {140.68, 110.08}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{140.68, 
                    110.08}, {149.68, 99.28}, {152.68, 98.8}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{140.68, 110.08}, {149.68, 99.28}, {152.68, 
                    98.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.42745000000000005`, 0., 0.57255], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{150.28, 29.08}, {140.8, 
                    18.279999999999998`}, {144.04, 19.}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{150.28, 29.08}, {140.8, 
                    18.279999999999998`}, {144.04, 19.}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.44314, 0., 0.55686], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{140.8, 
                    18.279999999999998`}, {150.28, 29.08}, {148.24, 
                    29.919999999999995`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{140.8, 
                    18.279999999999998`}, {150.28, 29.08}, {148.24, 
                    29.919999999999995`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.42745000000000005`, 0., 0.57255], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{142.96, 94.72}, {152.08, 82.84}, {154.24, 
                    85.24}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{142.96, 94.72}, {152.08, 82.84}, {154.24, 
                    85.24}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.42745000000000005`, 0., 0.57255], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{154.23999999999998`, 
                    85.24000000000001}, {146.32, 
                    97.96000000000001}, {142.95999999999998`, 
                    94.72000000000001}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{154.23999999999998`, 
                    85.24000000000001}, {146.32, 
                    97.96000000000001}, {142.95999999999998`, 
                    94.72000000000001}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.53333, 0., 0.46667000000000003`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{153.88000000000002`, 
                    53.56}, {143.32000000000002`, 
                    50.800000000000004`}, {143.32000000000002`, 44.92}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{153.88000000000002`, 
                    53.56}, {143.32000000000002`, 
                    50.800000000000004`}, {143.32000000000002`, 44.92}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.53333, 0., 0.46667000000000003`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{154.12, 56.68}, {143.8, 57.04}, {143.32, 
                    50.8}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{154.12, 56.68}, {143.8, 57.04}, {143.32, 50.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.53333, 0., 0.46667000000000003`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{143.32000000000002`, 
                    50.8}, {153.88000000000002`, 
                    53.559999999999995`}, {154.12000000000003`, 56.68}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{143.32000000000002`, 
                    50.8}, {153.88000000000002`, 
                    53.559999999999995`}, {154.12000000000003`, 56.68}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.52549, 0., 0.47451000000000004`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{153.88000000000002`, 
                    50.56}, {143.32000000000002`, 
                    44.92}, {143.92000000000002`, 39.760000000000005`}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{153.88000000000002`, 
                    50.56}, {143.32000000000002`, 
                    44.92}, {143.92000000000002`, 39.760000000000005`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.53333, 0., 0.46667000000000003`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{143.32000000000002`, 
                    44.92}, {153.88000000000002`, 
                    50.56}, {153.88000000000002`, 53.56}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{143.32000000000002`, 
                    44.92}, {153.88000000000002`, 
                    50.56}, {153.88000000000002`, 53.56}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.52549, 0., 0.47451000000000004`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{143.8, 57.04}, {154.12, 
                    56.68}, {154.60000000000002`, 59.92}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{143.8, 57.04}, {154.12, 
                    56.68}, {154.60000000000002`, 59.92}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.52549, 0., 0.47451000000000004`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{154.6, 59.92}, {144.64, 
                    63.4}, {143.79999999999998`, 57.04}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{154.6, 59.92}, {144.64, 
                    63.4}, {143.79999999999998`, 57.04}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{154.12, 
                    47.8}, {143.92000000000002`, 39.76}, {145., 
                    35.31999999999999}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{154.12, 47.8}, {143.92000000000002`, 
                    39.76}, {145., 35.31999999999999}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.52549, 0., 0.47451000000000004`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{143.92000000000002`, 
                    39.760000000000005`}, {154.12, 
                    47.800000000000004`}, {153.88000000000002`, 50.56}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{143.92000000000002`, 
                    39.760000000000005`}, {154.12, 
                    47.800000000000004`}, {153.88000000000002`, 50.56}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.42745000000000005`, 0., 0.57255], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{144.04, 19.}, {152.44, 
                    29.560000000000002`}, {150.28, 29.08}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{144.04, 19.}, {152.44, 
                    29.560000000000002`}, {150.28, 29.08}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.41961000000000004`, 0., 0.58039], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{152.44, 29.56}, {144.04, 19.}, {147.28, 
                    21.4}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{152.44, 29.56}, {144.04, 19.}, {147.28, 21.4}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.39608000000000004`, 0., 0.60392], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{155.44, 96.76}, {148.12, 106.48}, {144.64, 
                    109.36}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{155.44, 96.76}, {148.12, 106.48}, {144.64, 
                    109.36}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.39608000000000004`, 0., 0.60392], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{144.64, 109.36}, {152.67999999999998`, 
                    98.8}, {155.44, 96.76}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{144.64, 109.36}, {152.67999999999998`, 
                    98.8}, {155.44, 96.76}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{144.64, 
                    63.4}, {154.6, 59.92}, {155.32, 62.92}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{144.64, 63.4}, {154.6, 59.92}, {155.32, 62.92}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{155.32000000000002`, 62.92}, {145.96, 
                    69.4}, {144.64000000000001`, 63.4}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{155.32000000000002`, 62.92}, {145.96, 
                    69.4}, {144.64000000000001`, 63.4}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{154.6, 
                    45.64}, {145., 35.32}, {146.44, 32.08}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{154.6, 45.64}, {145., 35.32}, {146.44, 32.08}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{145., 
                    35.32}, {154.6, 45.64}, {154.12, 47.8}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{145., 35.32}, {154.6, 45.64}, {154.12, 47.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{145.96, 
                    69.4}, {155.32000000000002`, 62.92}, {156.16, 65.68}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{145.96, 69.4}, {155.32000000000002`, 
                    62.92}, {156.16, 65.68}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{156.16, 
                    65.67999999999999}, {147.76, 74.67999999999999}, {145.96, 
                    69.39999999999999}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{156.16, 65.67999999999999}, {147.76, 
                    74.67999999999999}, {145.96, 69.39999999999999}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.41961000000000004`, 0., 0.58039], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{146.32000000000002`, 
                    97.96000000000001}, {154.24, 85.24000000000001}, {156.52, 
                    86.32000000000001}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{146.32000000000002`, 
                    97.96000000000001}, {154.24, 85.24000000000001}, {156.52, 
                    86.32000000000001}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.41961000000000004`, 0., 0.58039], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{156.52, 86.32}, {149.68, 
                    99.28}, {146.32000000000002`, 97.96}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{156.52, 86.32}, {149.68, 
                    99.28}, {146.32000000000002`, 97.96}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.48627000000000004`, 0., 0.51373], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{155.44, 43.839999999999996`}, {146.44, 
                    32.08}, {148.24, 29.919999999999995`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{155.44, 43.839999999999996`}, {146.44, 
                    32.08}, {148.24, 29.919999999999995`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{146.44, 
                    32.08}, {155.44, 43.839999999999996`}, {154.6, 45.64}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{146.44, 32.08}, {155.44, 
                    43.839999999999996`}, {154.6, 45.64}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.41961000000000004`, 0., 0.58039], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{147.28, 21.4}, {154.6, 
                    31.119999999999997`}, {152.44, 29.56}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{147.28, 21.4}, {154.6, 
                    31.119999999999997`}, {152.44, 29.56}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.42745000000000005`, 0., 0.57255], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{154.6, 31.12}, {147.28, 
                    21.400000000000002`}, {150.28, 25.36}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{154.6, 31.12}, {147.28, 
                    21.400000000000002`}, {150.28, 25.36}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.48627000000000004`, 0., 0.51373], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{147.76, 74.67999999999999}, {156.16, 
                    65.67999999999999}, {157.12, 68.08}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{147.76, 74.67999999999999}, {156.16, 
                    65.67999999999999}, {157.12, 68.08}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.48627000000000004`, 0., 0.51373], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{157.12, 68.08}, {149.8, 79.36}, {147.76, 
                    74.67999999999999}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{157.12, 68.08}, {149.8, 79.36}, {147.76, 
                    74.67999999999999}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.47843, 0., 0.52157], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{156.28, 
                    42.64}, {148.24, 29.92}, {150.28, 29.08}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{156.28, 42.64}, {148.24, 29.92}, {150.28, 
                    29.08}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.48627000000000004`, 0., 0.51373], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{148.23999999999998`, 
                    29.919999999999998`}, {156.27999999999997`, 
                    42.64}, {155.43999999999997`, 43.839999999999996`}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{148.23999999999998`, 
                    29.919999999999998`}, {156.27999999999997`, 
                    42.64}, {155.43999999999997`, 43.839999999999996`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.42745000000000005`, 0., 0.57255], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{158.68, 86.08}, {152.68, 98.8}, {149.68, 
                    99.28}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{158.68, 86.08}, {152.68, 98.8}, {149.68, 99.28}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.42745000000000005`, 0., 0.57255], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{149.68, 99.28}, {156.52, 86.32}, {158.68, 
                    86.08}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{149.68, 99.28}, {156.52, 86.32}, {158.68, 
                    86.08}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.47843, 0., 0.52157], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{149.8, 
                    79.36}, {157.12, 68.08}, {158.32000000000002`, 69.88}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{149.8, 79.36}, {157.12, 
                    68.08}, {158.32000000000002`, 69.88}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.47843, 0., 0.52157], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{158.32000000000002`, 69.88}, {152.08, 
                    82.84}, {149.8, 79.36}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{158.32000000000002`, 69.88}, {152.08, 
                    82.84}, {149.8, 79.36}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.47843, 0., 0.52157], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{150.28, 
                    29.08}, {157.24, 42.16}, {156.28, 42.64}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{150.28, 29.08}, {157.24, 42.16}, {156.28, 
                    42.64}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.47059, 0., 0.5294099999999999], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{157.23999999999998`, 
                    42.160000000000004`}, {150.27999999999997`, 
                    29.080000000000005`}, {152.43999999999997`, 
                    29.560000000000002`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{157.23999999999998`, 
                    42.160000000000004`}, {150.27999999999997`, 
                    29.080000000000005`}, {152.43999999999997`, 
                    29.560000000000002`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.42745000000000005`, 0., 0.57255], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{150.28, 25.36}, {156.76, 33.76}, {154.6, 
                    31.119999999999997`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{150.28, 25.36}, {156.76, 33.76}, {154.6, 
                    31.119999999999997`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.47059, 0., 0.5294099999999999], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{152.08, 82.84}, {158.32000000000002`, 
                    69.88}, {159.4, 71.2}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{152.08, 82.84}, {158.32000000000002`, 
                    69.88}, {159.4, 71.2}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.47059, 0., 0.5294099999999999], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{159.4, 71.2}, {154.24, 
                    85.24000000000001}, {152.08, 82.84}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{159.4, 71.2}, {154.24, 
                    85.24000000000001}, {152.08, 82.84}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.47059, 0., 0.5294099999999999], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{152.44, 29.56}, {158.32, 42.28}, {157.24, 
                    42.16}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{152.44, 29.56}, {158.32, 42.28}, {157.24, 
                    42.16}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.46667000000000003`, 0., 0.53333], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{158.32000000000002`, 
                    42.28}, {152.44000000000003`, 
                    29.560000000000002`}, {154.60000000000002`, 31.12}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{158.32000000000002`, 
                    42.28}, {152.44000000000003`, 
                    29.560000000000002`}, {154.60000000000002`, 31.12}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.44314, 0., 0.55686], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{160.6, 
                    84.76}, {155.44, 96.76}, {152.68, 98.80000000000001}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{160.6, 84.76}, {155.44, 96.76}, {152.68, 
                    98.80000000000001}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.44314, 0., 0.55686], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{152.68, 
                    98.8}, {158.68, 86.08}, {160.6, 84.75999999999999}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{152.68, 98.8}, {158.68, 86.08}, {160.6, 
                    84.75999999999999}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.5098, 0., 0.49019999999999997`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{161.2, 56.8}, {153.88, 
                    53.559999999999995`}, {153.88, 50.559999999999995`}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {153.88, 
                    53.559999999999995`}, {153.88, 
                    50.559999999999995`}, {161.2, 56.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.5098, 0., 0.49019999999999997`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{161.2, 56.8}, {154.11999999999998`, 
                    56.68}, {153.88, 53.559999999999995`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}, {0, 1, 0}}}, {{{161.2, 56.8}, {154.11999999999998`, 
                    56.68}, {153.88, 53.559999999999995`}, {161.2, 56.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.5098, 0., 0.49019999999999997`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{161.2, 56.8}, {153.88, 
                    50.559999999999995`}, {154.11999999999998`, 47.8}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {153.88, 
                    50.559999999999995`}, {154.11999999999998`, 
                    47.8}, {161.2, 56.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.5098, 0., 0.49019999999999997`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{161.2, 56.8}, {154.6, 
                    59.919999999999995`}, {154.11999999999998`, 56.68}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {154.6, 
                    59.919999999999995`}, {154.11999999999998`, 
                    56.68}, {161.2, 56.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 
                    56.8}, {154.11999999999998`, 47.8}, {154.6, 45.64}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}, {0, 1, 0}}}, {{{161.2, 
                    56.8}, {154.11999999999998`, 47.8}, {154.6, 
                    45.64}, {161.2, 56.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.46667000000000003`, 0., 0.53333], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{154.23999999999998`, 
                    85.24000000000001}, {159.39999999999998`, 
                    71.20000000000002}, {160.48, 71.80000000000001}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{154.23999999999998`, 
                    85.24000000000001}, {159.39999999999998`, 
                    71.20000000000002}, {160.48, 71.80000000000001}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.46667000000000003`, 0., 0.53333], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{160.48000000000002`, 71.8}, {156.52, 
                    86.32}, {154.24, 85.24}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{160.48000000000002`, 71.8}, {156.52, 
                    86.32}, {154.24, 85.24}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 
                    56.8}, {155.32, 62.919999999999995`}, {154.6, 
                    59.919999999999995`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}}, {{{161.2, 56.8}, {155.32, 
                    62.919999999999995`}, {154.6, 
                    59.919999999999995`}, {161.2, 56.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.46667000000000003`, 0., 0.53333], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{154.6, 31.12}, {159.4, 
                    43.120000000000005`}, {158.32, 42.28}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{154.6, 31.12}, {159.4, 
                    43.120000000000005`}, {158.32, 42.28}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.47059, 0., 0.5294099999999999], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{159.4, 43.120000000000005`}, {154.6, 
                    31.120000000000005`}, {156.76000000000002`, 
                    33.760000000000005`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{159.4, 
                    43.120000000000005`}, {154.6, 
                    31.120000000000005`}, {156.76000000000002`, 
                    33.760000000000005`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 
                    56.8}, {154.6, 45.64}, {155.44, 43.839999999999996`}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {154.6, 
                    45.64}, {155.44, 43.839999999999996`}, {161.2, 56.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 
                    56.8}, {156.16, 65.67999999999999}, {155.32, 
                    62.919999999999995`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}}, {{{161.2, 56.8}, {156.16, 
                    65.67999999999999}, {155.32, 
                    62.919999999999995`}, {161.2, 56.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.49412, 0., 0.50196], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 
                    56.8}, {155.44, 43.839999999999996`}, {156.28, 42.64}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {155.44, 
                    43.839999999999996`}, {156.28, 42.64}, {161.2, 56.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.47451000000000004`, 0., 0.52549], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{155.44, 96.76}, {160.6, 84.76}, {162.16, 
                    82.24000000000001}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{155.44, 96.76}, {160.6, 84.76}, {162.16, 
                    82.24000000000001}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.47451000000000004`, 0., 0.52549], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{162.16, 82.24000000000001}, {157.72, 
                    92.92000000000002}, {155.44, 96.76}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{162.16, 82.24000000000001}, {157.72, 
                    92.92000000000002}, {155.44, 96.76}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.49412, 0., 0.50196], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 
                    56.8}, {157.11999999999998`, 68.08}, {156.16, 
                    65.67999999999999}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}}, {{{161.2, 56.8}, {157.11999999999998`, 
                    68.08}, {156.16, 65.67999999999999}, {161.2, 56.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.49019999999999997`, 0., 0.5098], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{161.2, 56.8}, {156.28, 
                    42.64}, {157.23999999999998`, 42.16}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}, {0, 1, 0}}}, {{{161.2, 56.8}, {156.28, 
                    42.64}, {157.23999999999998`, 42.16}, {161.2, 56.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.47059, 0., 0.5294099999999999], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{156.52, 86.32}, {160.48000000000002`, 
                    71.8}, {161.68, 71.8}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{156.52, 86.32}, {160.48000000000002`, 
                    71.8}, {161.68, 71.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.47059, 0., 0.5294099999999999], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{161.68, 71.8}, {158.68, 86.08}, {156.52, 
                    86.32}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{161.68, 71.8}, {158.68, 86.08}, {156.52, 86.32}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.47843, 0., 0.52157], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{160.6, 
                    44.44}, {156.76, 33.76}, {158.79999999999998`, 37.48}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{160.6, 44.44}, {156.76, 
                    33.76}, {158.79999999999998`, 37.48}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.47059, 0., 0.5294099999999999], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{156.76, 33.760000000000005`}, {160.6, 
                    44.440000000000005`}, {159.39999999999998`, 
                    43.120000000000005`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{156.76, 33.760000000000005`}, {160.6, 
                    44.440000000000005`}, {159.39999999999998`, 
                    43.120000000000005`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.49019999999999997`, 0., 0.5098], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{161.2, 56.8}, {158.32, 
                    69.88}, {157.11999999999998`, 68.08}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}}, {{{161.2, 56.8}, {158.32, 
                    69.88}, {157.11999999999998`, 68.08}, {161.2, 56.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.49019999999999997`, 0., 0.5098], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{161.2, 56.8}, {157.23999999999998`, 
                    42.16}, {158.32, 42.28}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}}, {{{161.2, 56.8}, {157.23999999999998`, 
                    42.16}, {158.32, 42.28}, {161.2, 56.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.49019999999999997`, 0., 0.5098], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{161.2, 56.8}, {159.39999999999998`, 
                    71.2}, {158.32, 69.88}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}}, {{{161.2, 56.8}, {159.39999999999998`, 
                    71.2}, {158.32, 69.88}, {161.2, 56.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.49019999999999997`, 0., 0.5098], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{161.2, 56.8}, {158.32, 
                    42.28}, {159.39999999999998`, 43.12}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}, {0, 1, 0}}}, {{{161.2, 56.8}, {158.32, 
                    42.28}, {159.39999999999998`, 43.12}, {161.2, 56.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.47843, 0., 0.52157], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{162.52, 
                    71.2}, {160.60000000000002`, 84.76}, {158.68, 86.08}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{162.52, 71.2}, {160.60000000000002`, 
                    84.76}, {158.68, 86.08}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.47843, 0., 0.52157], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{158.68, 
                    86.08}, {161.68, 71.8}, {162.52, 71.2}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{158.68, 86.08}, {161.68, 71.8}, {162.52, 71.2}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.47843, 0., 0.52157], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{158.8, 
                    37.48}, {161.68, 46.36}, {160.60000000000002`, 44.44}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{158.8, 37.48}, {161.68, 
                    46.36}, {160.60000000000002`, 44.44}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.48627000000000004`, 0., 0.51373], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{161.68, 46.36}, {158.8, 37.48}, {160.6, 
                    41.92}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{161.68, 46.36}, {158.8, 37.48}, {160.6, 41.92}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.49019999999999997`, 0., 0.5098], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{161.2, 56.8}, {160.48, 
                    71.8}, {159.39999999999998`, 71.2}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}, {0, 1, 0}}}, {{{161.2, 56.8}, {160.48, 
                    71.8}, {159.39999999999998`, 71.2}, {161.2, 56.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.49019999999999997`, 0., 0.5098], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{161.2, 56.8}, {159.39999999999998`, 
                    43.12}, {160.6, 44.44}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}}, {{{161.2, 56.8}, {159.39999999999998`, 
                    43.12}, {160.6, 44.44}, {161.2, 56.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.49019999999999997`, 0., 0.5098], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{161.2, 56.8}, {161.67999999999998`, 
                    71.8}, {160.48, 71.8}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}}, {{{161.2, 56.8}, {161.67999999999998`, 
                    71.8}, {160.48, 71.8}, {161.2, 56.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.48627000000000004`, 0., 0.51373], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{160.6, 84.76}, {162.51999999999998`, 
                    71.2}, {163.48, 69.88000000000001}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{160.6, 84.76}, {162.51999999999998`, 
                    71.2}, {163.48, 69.88000000000001}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.48627000000000004`, 0., 0.51373], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{163.48000000000002`, 
                    69.88}, {162.16000000000003`, 
                    82.24}, {160.60000000000002`, 84.75999999999999}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{163.48000000000002`, 
                    69.88}, {162.16000000000003`, 
                    82.24}, {160.60000000000002`, 84.75999999999999}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.49019999999999997`, 0., 0.5098], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{161.2, 56.8}, {160.6, 
                    44.44}, {161.67999999999998`, 46.36}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}, {0, 1, 0}}}, {{{161.2, 56.8}, {160.6, 
                    44.44}, {161.67999999999998`, 46.36}, {161.2, 56.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{162.52, 
                    48.760000000000005`}, {160.60000000000002`, 
                    41.92}, {162.16, 47.080000000000005`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{162.52, 
                    48.760000000000005`}, {160.60000000000002`, 
                    41.92}, {162.16, 47.080000000000005`}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.48627000000000004`, 0., 0.51373], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{160.6, 41.92}, {162.51999999999998`, 
                    48.760000000000005`}, {161.68, 46.36}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{160.6, 41.92}, {162.51999999999998`, 
                    48.760000000000005`}, {161.68, 46.36}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.49412, 0., 0.50196], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 
                    56.8}, {161.67999999999998`, 
                    46.36}, {162.51999999999998`, 48.76}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}, {0, 1, 0}}}, {{{161.2, 56.8}, {161.67999999999998`, 
                    46.36}, {162.51999999999998`, 48.76}, {161.2, 56.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 
                    56.8}, {162.51999999999998`, 
                    48.76}, {163.35999999999999`, 51.28}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}, {0, 1, 0}}}, {{{161.2, 56.8}, {162.51999999999998`, 
                    48.76}, {163.35999999999999`, 51.28}, {161.2, 56.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 
                    56.8}, {163.35999999999999`, 
                    51.28}, {164.07999999999998`, 54.279999999999994`}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}, {0, 1, 0}}}, {{{161.2, 
                    56.8}, {163.35999999999999`, 
                    51.28}, {164.07999999999998`, 
                    54.279999999999994`}, {161.2, 56.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.5098, 0., 0.49019999999999997`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{161.2, 56.8}, {164.07999999999998`, 
                    54.279999999999994`}, {164.56, 57.279999999999994`}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}, {0, 1, 0}}}, {{{161.2, 
                    56.8}, {164.07999999999998`, 
                    54.279999999999994`}, {164.56, 
                    57.279999999999994`}, {161.2, 56.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.49019999999999997`, 0., 0.5098], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{161.2, 56.8}, {162.51999999999998`, 
                    71.2}, {161.67999999999998`, 71.8}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}, {0, 1, 0}}}, {{{161.2, 56.8}, {162.51999999999998`, 
                    71.2}, {161.67999999999998`, 71.8}, {161.2, 56.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.49412, 0., 0.50196], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 
                    56.8}, {163.48, 69.88}, {162.51999999999998`, 71.2}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {163.48, 
                    69.88}, {162.51999999999998`, 71.2}, {161.2, 56.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 
                    56.8}, {164.07999999999998`, 68.08}, {163.48, 69.88}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}, {0, 1, 0}}}, {{{161.2, 
                    56.8}, {164.07999999999998`, 68.08}, {163.48, 
                    69.88}, {161.2, 56.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 
                    56.8}, {164.56, 65.8}, {164.07999999999998`, 68.08}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {164.56, 
                    65.8}, {164.07999999999998`, 68.08}, {161.2, 56.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.5098, 0., 0.49019999999999997`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{161.2, 56.8}, {164.79999999999998`, 
                    63.16}, {164.56, 65.8}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}}, {{{161.2, 56.8}, {164.79999999999998`, 
                    63.16}, {164.56, 65.8}, {161.2, 56.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.5098, 0., 0.49019999999999997`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{161.2, 56.8}, {164.79999999999998`, 
                    60.279999999999994`}, {164.79999999999998`, 63.16}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}, {0, 1, 0}}}, {{{161.2, 
                    56.8}, {164.79999999999998`, 
                    60.279999999999994`}, {164.79999999999998`, 
                    63.16}, {161.2, 56.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.5098, 0., 0.49019999999999997`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{161.2, 56.8}, {164.56, 
                    57.279999999999994`}, {164.79999999999998`, 
                    60.279999999999994`}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}}, {{{161.2, 56.8}, {164.56, 
                    57.279999999999994`}, {164.79999999999998`, 
                    60.279999999999994`}, {161.2, 56.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{164.08, 
                    68.08}, {163.36, 78.64}, {162.16000000000003`, 82.24}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{164.08, 68.08}, {163.36, 
                    78.64}, {162.16000000000003`, 82.24}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{162.16, 
                    82.24000000000001}, {163.48, 
                    69.88000000000001}, {164.07999999999998`, 
                    68.08000000000001}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{162.16, 82.24000000000001}, {163.48, 
                    69.88000000000001}, {164.07999999999998`, 
                    68.08000000000001}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{162.16, 
                    47.08}, {163.35999999999999`, 51.28}, {162.52, 48.76}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{162.16, 47.08}, {163.35999999999999`, 
                    51.28}, {162.52, 48.76}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{164.56, 
                    65.8}, {164.2, 74.32}, {163.36, 78.64}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{164.56, 65.8}, {164.2, 74.32}, {163.36, 78.64}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
                    FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{163.36, 
                    78.64}, {164.08, 68.08}, {164.56, 65.8}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{
                    "Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{163.36, 78.64}, {164.08, 68.08}, {164.56, 65.8}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.52549, 0., 0.47451000000000004`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{164.8, 63.160000000000004`}, {164.68, 
                    69.28}, {164.20000000000002`, 74.32000000000001}}}]}, 
                    {Thickness[0.002168674698795181], 
                    JoinForm[{"Miter", 10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 
                    1, 0}}}, {{{164.8, 63.160000000000004`}, {164.68, 
                    69.28}, {164.20000000000002`, 74.32000000000001}}},
                    CurveClosed->{0}]}, 
                    {FaceForm[{RGBColor[0.52549, 0., 0.47451000000000004`], 
                    Opacity[1.]}], FilledCurveBox[{{{0, 2, 0}, {0, 1, 
                    0}}}, {{{164.2, 74.32}, {164.56, 
                    65.8}, {164.79999999999998`, 63.16}}}]}, 
                    {Thickness[0.002168674698795181], JoinForm[{"Miter", 
                    10.}], JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{164.2, 
                    74.32}, {164.56, 65.8}, {164.79999999999998`, 63.16}}},
                    CurveClosed->{0}]}},
                    AspectRatio->Automatic,
                    ImageSize->{166., 135.},
                    PlotRange->{{0., 166.}, {0., 135.}}], {0.8333333333333333, 0.75},
                     Center, {0.2564102564102564, 0.3846153846153846}], 
                    {RGBColor[1., 0.843104, 0.], Opacity[1], 
                    DiskBox[{0.5509229046951908, 0.25}, {0.04410052910052911, 0.06615079365079365},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.5509229046951908, 0.25}, {0.04410052910052911, 0.06615079365079365},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1., 0.843104, 0.], Opacity[1], 
                    DiskBox[{0.4745385476524046, 0.3161507936507937}, {0.04410052910052911, 0.06615079365079365},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.4745385476524046, 0.3161507936507937}, {0.04410052910052911, 0.06615079365079365},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1., 0.843104, 0.], Opacity[1], 
                    DiskBox[{0.4745385476524046, 0.18384920634920635`}, {0.04410052910052911, 0.06615079365079365},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.4745385476524046, 0.18384920634920635`}, {0.04410052910052911, 0.06615079365079365},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {RGBColor[1., 0.843104, 0.], Opacity[1], 
                    DiskBox[{0.5509229046951908, 0.25}, {0.04410052910052911, 0.06615079365079365},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.5509229046951908, 0.25}, {0.04410052910052911, 0.06615079365079365},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {RGBColor[0.333333, 0.333333, 0.333333], 
                    AbsoluteThickness[1], Opacity[1], Dashing[{}], 
                    CapForm[None], LineBox[{{0.712121212121212, 
                    0.08766233766233769}, {0.712121212121212, 
                    0.47727272727272735`}}]}, 
                    {RGBColor[0.333333, 0.333333, 0.333333], 
                    AbsoluteThickness[1], Opacity[1], Dashing[{}], 
                    CapForm[None], LineBox[{{0.7055061327561327, 
                    0.46073502886002893`}, {0.712121212121212, 
                    0.47727272727272735`}, {0.7187362914862915, 
                    0.46073502886002893`}}]}, 
                    {RGBColor[0.333333, 0.333333, 0.333333], 
                    AbsoluteThickness[1], Opacity[1], Dashing[{}], 
                    CapForm[None]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.7323232323232323, 
                    0.12012987012987016`}, {0.9343434343434343, 
                    0.12012987012987016`}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.7323232323232323, 
                    0.1850649350649351}, {0.9343434343434343, 
                    0.1850649350649351}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.7323232323232323, 
                    0.25000000000000006`}, {0.9343434343434343, 
                    0.25000000000000006`}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.7323232323232323, 
                    0.31493506493506496`}, {0.9343434343434343, 
                    0.31493506493506496`}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.7323232323232323, 
                    0.3798701298701299}, {0.9343434343434343, 
                    0.3798701298701299}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.7323232323232323, 
                    0.44480519480519487`}, {0.9343434343434343, 
                    0.44480519480519487`}}], 
                    {RGBColor[1., 0.894101, 0.709799], Opacity[1], 
                    DiskBox[{0.7756132756132755, 0.12012987012987016`}, {0.020202020202020207`, 0.019480519480519484`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.7756132756132755, 0.12012987012987016`}, {0.020202020202020207`, 0.019480519480519484`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {GrayLevel[0], Opacity[1], 
                    DiskBox[{0.7655122655122655, 0.12012987012987016`}, {0.004410052910052911, 0.0066150793650793654`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.7655122655122655, 0.12012987012987016`}, {0.004410052910052911, 0.0066150793650793654`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {GrayLevel[0], Opacity[1], 
                    DiskBox[{0.7857142857142857, 0.12012987012987016`}, {0.004410052910052911, 0.0066150793650793654`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.7857142857142857, 0.12012987012987016`}, {0.004410052910052911, 0.0066150793650793654`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.7604617604617604, 
                    0.10714285714285719`}, {0.7705627705627704, 
                    0.13311688311688316`}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.7645313620248172, 
                    0.13073606395716475`}, {0.7705627705627704, 
                    0.13311688311688316`}, {0.7721499833359161, 
                    0.12406977030995323`}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.7907647907647908, 
                    0.13311688311688316`}, {0.7806637806637807, 
                    0.10714285714285719`}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.786695189201734, 
                    0.1095236763025756}, {0.7806637806637807, 
                    0.10714285714285719`}, {0.7790765678906351, 
                    0.1161899699497871}}], 
                    {RGBColor[1., 0.894101, 0.709799], Opacity[1], 
                    DiskBox[{0.8333333333333333, 0.12012987012987016`}, {0.020202020202020204`, 0.019480519480519484`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.8333333333333333, 0.12012987012987016`}, {0.020202020202020204`, 0.019480519480519484`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {GrayLevel[0], Opacity[1], 
                    DiskBox[{0.8232323232323232, 0.12012987012987016`}, {0.004410052910052911, 0.0066150793650793654`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.8232323232323232, 0.12012987012987016`}, {0.004410052910052911, 0.0066150793650793654`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {GrayLevel[0], Opacity[1], 
                    DiskBox[{0.8434343434343434, 0.12012987012987016`}, {0.004410052910052911, 0.0066150793650793654`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.8434343434343434, 0.12012987012987016`}, {0.004410052910052911, 0.0066150793650793654`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.8181818181818182, 
                    0.10714285714285719`}, {0.8282828282828284, 
                    0.13311688311688316`}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.8222514197448751, 
                    0.1307360639571648}, {0.8282828282828284, 
                    0.13311688311688316`}, {0.8298700410559741, 
                    0.12406977030995323`}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.8484848484848484, 
                    0.13311688311688316`}, {0.8383838383838383, 
                    0.10714285714285719`}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.8444152469217917, 
                    0.1095236763025756}, {0.8383838383838383, 
                    0.10714285714285719`}, {0.8367966256106928, 
                    0.1161899699497871}}], 
                    {RGBColor[1., 0.894101, 0.709799], Opacity[1], 
                    DiskBox[{0.891053391053391, 0.12012987012987016`}, {0.02020202020202019, 0.019480519480519484`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.891053391053391, 0.12012987012987016`}, {0.02020202020202019, 0.019480519480519484`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {GrayLevel[0], Opacity[1], 
                    DiskBox[{0.8809523809523809, 0.12012987012987016`}, {0.004410052910052911, 0.0066150793650793654`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.8809523809523809, 0.12012987012987016`}, {0.004410052910052911, 0.0066150793650793654`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {GrayLevel[0], Opacity[1], 
                    DiskBox[{0.901154401154401, 0.12012987012987016`}, {0.004410052910052911, 0.0066150793650793654`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.901154401154401, 0.12012987012987016`}, {0.004410052910052911, 0.0066150793650793654`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.875901875901876, 
                    0.10714285714285719`}, {0.8860028860028861, 
                    0.13311688311688316`}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.8799714774649328, 
                    0.1307360639571648}, {0.8860028860028861, 
                    0.13311688311688316`}, {0.8875900987760317, 
                    0.12406977030995323`}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.9062049062049062, 
                    0.13311688311688316`}, {0.8961038961038962, 
                    0.10714285714285719`}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.9021353046418495, 
                    0.1095236763025756}, {0.8961038961038962, 
                    0.10714285714285719`}, {0.8945166833307506, 
                    0.1161899699497871}}], 
                    {RGBColor[1., 0.894101, 0.709799], Opacity[1], 
                    DiskBox[{0.7756132756132755, 0.1850649350649351}, {0.020202020202020207`, 0.019480519480519484`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.7756132756132755, 0.1850649350649351}, {0.020202020202020207`, 0.019480519480519484`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {GrayLevel[0], Opacity[1], 
                    DiskBox[{0.7655122655122655, 0.1850649350649351}, {0.004410052910052911, 0.0066150793650793654`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.7655122655122655, 0.1850649350649351}, {0.004410052910052911, 0.0066150793650793654`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {GrayLevel[0], Opacity[1], 
                    DiskBox[{0.7857142857142857, 0.1850649350649351}, {0.004410052910052911, 0.0066150793650793654`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.7857142857142857, 0.1850649350649351}, {0.004410052910052911, 0.0066150793650793654`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.7604617604617604, 
                    0.17207792207792214`}, {0.7705627705627704, 
                    0.19805194805194812`}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.7645313620248172, 
                    0.19567112889222968`}, {0.7705627705627704, 
                    0.19805194805194812`}, {0.7721499833359161, 
                    0.18900483524501818`}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.7907647907647908, 
                    0.19805194805194812`}, {0.7806637806637807, 
                    0.17207792207792214`}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.786695189201734, 
                    0.17445874123764055`}, {0.7806637806637807, 
                    0.17207792207792214`}, {0.7790765678906351, 
                    0.18112503488485204`}}], 
                    {RGBColor[1., 0.894101, 0.709799], Opacity[1], 
                    DiskBox[{0.8333333333333333, 0.1850649350649351}, {0.020202020202020204`, 0.019480519480519484`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.8333333333333333, 0.1850649350649351}, {0.020202020202020204`, 0.019480519480519484`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {GrayLevel[0], Opacity[1], 
                    DiskBox[{0.8232323232323232, 0.1850649350649351}, {0.004410052910052911, 0.0066150793650793654`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.8232323232323232, 0.1850649350649351}, {0.004410052910052911, 0.0066150793650793654`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {GrayLevel[0], Opacity[1], 
                    DiskBox[{0.8434343434343434, 0.1850649350649351}, {0.004410052910052911, 0.0066150793650793654`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.8434343434343434, 0.1850649350649351}, {0.004410052910052911, 0.0066150793650793654`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.8181818181818182, 
                    0.17207792207792214`}, {0.8282828282828284, 
                    0.19805194805194812`}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.8222514197448751, 
                    0.19567112889222973`}, {0.8282828282828284, 
                    0.19805194805194812`}, {0.8298700410559741, 
                    0.18900483524501818`}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.8484848484848484, 
                    0.19805194805194812`}, {0.8383838383838383, 
                    0.17207792207792214`}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.8444152469217917, 
                    0.17445874123764055`}, {0.8383838383838383, 
                    0.17207792207792214`}, {0.8367966256106928, 
                    0.18112503488485204`}}], 
                    {RGBColor[1., 0.894101, 0.709799], Opacity[1], DiskBox[{0.7756132756132755, 0.25000000000000006`},\
 {0.020202020202020207`, 0.019480519480519484`}, NCache[{0, 2 Pi}, {0, 
                    6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.7756132756132755, 0.25000000000000006`}, {0.020202020202020207`, 0.019480519480519484`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {GrayLevel[0], Opacity[1], 
                    DiskBox[{0.7655122655122655, 0.25000000000000006`}, {0.004410052910052911, 0.0066150793650793654`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.7655122655122655, 0.25000000000000006`}, {0.004410052910052911, 0.0066150793650793654`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {GrayLevel[0], Opacity[1], 
                    DiskBox[{0.7857142857142857, 0.25000000000000006`}, {0.004410052910052911, 0.0066150793650793654`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.7857142857142857, 0.25000000000000006`}, {0.004410052910052911, 0.0066150793650793654`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.7604617604617604, 
                    0.23701298701298706`}, {0.7705627705627704, 
                    0.2629870129870131}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.7645313620248172, 
                    0.26060619382729466`}, {0.7705627705627704, 
                    0.2629870129870131}, {0.7721499833359161, 
                    0.25393990018008317`}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.7907647907647908, 
                    0.2629870129870131}, {0.7806637806637807, 
                    0.23701298701298706`}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.786695189201734, 
                    0.23939380617270548`}, {0.7806637806637807, 
                    0.23701298701298706`}, {0.7790765678906351, 
                    0.24606009981991697`}}], 
                    {RGBColor[1., 0.894101, 0.709799], Opacity[1], 
                    DiskBox[{0.8333333333333333, 0.25000000000000006`}, {0.020202020202020204`, 0.019480519480519484`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.8333333333333333, 0.25000000000000006`}, {0.020202020202020204`, 0.019480519480519484`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {GrayLevel[0], Opacity[1], 
                    DiskBox[{0.8232323232323232, 0.25000000000000006`}, {0.004410052910052911, 0.0066150793650793654`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.8232323232323232, 0.25000000000000006`}, {0.004410052910052911, 0.0066150793650793654`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {GrayLevel[0], Opacity[1], 
                    DiskBox[{0.8434343434343434, 0.25000000000000006`}, {0.004410052910052911, 0.0066150793650793654`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.8434343434343434, 0.25000000000000006`}, {0.004410052910052911, 0.0066150793650793654`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.8181818181818182, 
                    0.23701298701298706`}, {0.8282828282828284, 
                    0.2629870129870131}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.8222514197448751, 
                    0.2606061938272947}, {0.8282828282828284, 
                    0.2629870129870131}, {0.8298700410559741, 
                    0.25393990018008317`}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.8484848484848484, 
                    0.2629870129870131}, {0.8383838383838383, 
                    0.23701298701298706`}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.8444152469217917, 
                    0.23939380617270548`}, {0.8383838383838383, 
                    0.23701298701298706`}, {0.8367966256106928, 
                    0.24606009981991697`}}], 
                    {RGBColor[1., 0.894101, 0.709799], Opacity[1], 
                    DiskBox[{0.7756132756132755, 0.31493506493506496`}, {0.020202020202020207`, 0.019480519480519484`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.7756132756132755, 0.31493506493506496`}, {0.020202020202020207`, 0.019480519480519484`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {GrayLevel[0], Opacity[1], 
                    DiskBox[{0.7655122655122655, 0.31493506493506496`}, {0.004410052910052911, 0.0066150793650793654`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.7655122655122655, 0.31493506493506496`}, {0.004410052910052911, 0.0066150793650793654`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]], 
                    {GrayLevel[0], Opacity[1], 
                    DiskBox[{0.7857142857142857, 0.31493506493506496`}, {0.004410052910052911, 0.0066150793650793654`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    CircleBox[{0.7857142857142857, 0.31493506493506496`}, {0.004410052910052911, 0.0066150793650793654`},
                     NCache[{0, 2 Pi}, {0, 6.283185307179586}]]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.7604617604617604, 
                    0.301948051948052}, {0.7705627705627704, 
                    0.32792207792207806`}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.7645313620248172, 
                    0.3255412587623596}, {0.7705627705627704, 
                    0.32792207792207806`}, {0.7721499833359161, 
                    0.3188749651151482}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.7907647907647908, 
                    0.32792207792207806`}, {0.7806637806637807, 
                    0.301948051948052}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.786695189201734, 
                    0.30432887110777046`}, {0.7806637806637807, 
                    0.301948051948052}, {0.7790765678906351, 
                    0.3109951647549819}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    LineBox[{{0.30000000000000004`, 
                    0.7417311507936508}, {0.36065295815295817`, 
                    0.7417311507936508}}], LineBox[{{0.30000000000000004`, 
                    0.7582688492063492}, {0.36065295815295817`, 
                    0.7582688492063492}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    LineBox[{{0.35343650793650794`, 
                    0.7681914682539682}, {0.3666666666666667, 
                    0.75}, {0.35343650793650794`, 0.7318085317460318}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.6333333333333334, 
                    0.7417311507936508}, {0.6939862914862914, 
                    0.7417311507936508}}], LineBox[{{0.6333333333333334, 
                    0.7582688492063492}, {0.6939862914862914, 
                    0.7582688492063492}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.6867698412698413, 
                    0.7681914682539682}, {0.7000000000000001, 
                    0.75}, {0.6867698412698413, 0.7318085317460318}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], 
                    LineBox[{{0.49448743386243393`, 
                    0.55}, {0.49448743386243393`, 0.4590205627705628}}], 
                    LineBox[{{0.5055125661375662, 0.55}, {0.5055125661375662, 
                    0.4590205627705628}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.5121276455026456, 
                    0.46984523809523815`}, {0.5000000000000001, 
                    0.45}, {0.48787235449735455`, 0.46984523809523815`}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.6391984677295028, 
                    0.529508379712909}, {0.6820865857384834, 
                    0.465176202699438}}], LineBox[{{0.6469944135247276, 
                    0.5412022984057459}, {0.6898825315337082, 
                    0.476870121392275}}]}, 
                    {GrayLevel[0], AbsoluteThickness[1], Opacity[1], 
                    Dashing[{}], CapForm[None], LineBox[{{0.6894572981266959, 
                    0.4915406739341979}, {0.6902368927062184, 
                    0.4646446609406727}, {0.6723062173772015, 
                    0.4658140528099564}}], InsetBox[
                    TagBox[
                    StyleBox[
                    TagBox["\<\"Nucleon interactions\"\>",
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    FontFamily->"Times",
                    FontSize->15,
                    FontWeight->"Plain",
                    FontSlant->"Plain",
                    FontTracking->"Plain",
                    FontColor->GrayLevel[0],
                    FontOpacity->1],
                    DisplayForm], {0.16666666666666666`, 1.}, {0, 1}, 
                    Automatic, {1, 0}], InsetBox[
                    TagBox[
                    StyleBox[
                    TagBox["\<\"Shell structure\"\>",
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    FontFamily->"Times",
                    FontSize->15,
                    FontWeight->"Plain",
                    FontSlant->"Plain",
                    FontTracking->"Plain",
                    FontColor->GrayLevel[0],
                    FontOpacity->1],
                    DisplayForm], {0.5, 1.}, {0, 1}, Automatic, {1, 0}], 
                    InsetBox[
                    TagBox[
                    StyleBox[
                    TagBox[
                    TagBox[
                    StyleBox["\<\"p\"\>",
                    FontSlant->"Italic"],
                    StyleForm[#, FontSlant -> "Italic"]& ],
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    FontFamily->"Times",
                    FontSize->12,
                    FontWeight->"Plain",
                    FontSlant->"Plain",
                    FontTracking->"Plain",
                    FontColor->GrayLevel[0],
                    FontOpacity->1],
                    DisplayForm], {0.5299364318536629, 0.7533075396825397}, {0, 0},
                     Automatic, {1, 0}], InsetBox[
                    TagBox[
                    StyleBox[
                    TagBox[
                    TagBox[
                    StyleBox["\<\"n\"\>",
                    FontSlant->"Italic"],
                    StyleForm[#, FontSlant -> "Italic"]& ],
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    FontFamily->"Times",
                    FontSize->12,
                    FontWeight->"Plain",
                    FontSlant->"Plain",
                    FontTracking->"Plain",
                    FontColor->GrayLevel[0],
                    FontOpacity->1],
                    DisplayForm], {0.5, 0.7949046477804943}, {0, 0}, 
                    Automatic, {1, 0}], InsetBox[
                    TagBox[
                    StyleBox[
                    TagBox[
                    TagBox[
                    StyleBox["\<\"p\"\>",
                    FontSlant->"Italic"],
                    StyleForm[#, FontSlant -> "Italic"]& ],
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    FontFamily->"Times",
                    FontSize->12,
                    FontWeight->"Plain",
                    FontSlant->"Plain",
                    FontTracking->"Plain",
                    FontColor->GrayLevel[0],
                    FontOpacity->1],
                    
                    DisplayForm], {0.47006356814633715`, 0.7533075396825397}, \
{0, 0}, Automatic, {1, 0}], InsetBox[
                    TagBox[
                    StyleBox[
                    TagBox[
                    TagBox[
                    StyleBox["\<\"n\"\>",
                    FontSlant->"Italic"],
                    StyleForm[#, FontSlant -> "Italic"]& ],
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    FontFamily->"Times",
                    FontSize->12,
                    FontWeight->"Plain",
                    FontSlant->"Plain",
                    FontTracking->"Plain",
                    FontColor->GrayLevel[0],
                    FontOpacity->1],
                    DisplayForm], {0.5, 0.7050953522195057}, {0, 0}, 
                    Automatic, {1, 0}], InsetBox[
                    TagBox[
                    StyleBox[
                    TagBox[
                    TagBox[
                    StyleBox["\<\"p\"\>",
                    FontSlant->"Italic"],
                    StyleForm[#, FontSlant -> "Italic"]& ],
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    FontFamily->"Times",
                    FontSize->12,
                    FontWeight->"Plain",
                    FontSlant->"Plain",
                    FontTracking->"Plain",
                    FontColor->GrayLevel[0],
                    FontOpacity->1],
                    DisplayForm], {0.5299364318536629, 0.7533075396825397}, {0, 0},
                     Automatic, {1, 0}], InsetBox[
                    TagBox[
                    StyleBox[
                    TagBox[
                    TagBox[
                    StyleBox["\<\"p\"\>",
                    FontSlant->"Italic"],
                    StyleForm[#, FontSlant -> "Italic"]& ],
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    FontFamily->"Times",
                    FontSize->12,
                    FontWeight->"Plain",
                    FontSlant->"Plain",
                    FontTracking->"Plain",
                    FontColor->GrayLevel[0],
                    FontOpacity->1],
                    DisplayForm], {0.5782696190476191, 0.7533075396825397}, {0, 0},
                     Automatic, {1, 0}], InsetBox[
                    TagBox[
                    StyleBox[
                    TagBox[
                    TagBox[
                    StyleBox["\<\"n\"\>",
                    FontSlant->"Italic"],
                    StyleForm[#, FontSlant -> "Italic"]& ],
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    FontFamily->"Times",
                    FontSize->12,
                    FontWeight->"Plain",
                    FontSlant->"Plain",
                    FontTracking->"Plain",
                    FontColor->GrayLevel[0],
                    FontOpacity->1],
                    DisplayForm], {0.5677834784397685, 0.8087022142857143}, {0, 0},
                     Automatic, {1, 0}], InsetBox[
                    TagBox[
                    StyleBox[
                    TagBox[
                    TagBox[
                    StyleBox["\<\"p\"\>",
                    FontSlant->"Italic"],
                    StyleForm[#, FontSlant -> "Italic"]& ],
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    FontFamily->"Times",
                    FontSize->12,
                    FontWeight->"Plain",
                    FontSlant->"Plain",
                    FontTracking->"Plain",
                    FontColor->GrayLevel[0],
                    FontOpacity->1],
                    DisplayForm], {0.5391348095238095, 0.8549827573421924}, {0, 0},
                     Automatic, {1, 0}], InsetBox[
                    TagBox[
                    StyleBox[
                    TagBox[
                    TagBox[
                    StyleBox["\<\"n\"\>",
                    FontSlant->"Italic"],
                    StyleForm[#, FontSlant -> "Italic"]& ],
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    FontFamily->"Times",
                    FontSize->12,
                    FontWeight->"Plain",
                    FontSlant->"Plain",
                    FontTracking->"Plain",
                    FontColor->GrayLevel[0],
                    FontOpacity->1],
                    DisplayForm], {0.5, 0.8674044285714285}, {0, 0}, 
                    Automatic, {1, 0}], InsetBox[
                    TagBox[
                    StyleBox[
                    TagBox[
                    TagBox[
                    StyleBox["\<\"p\"\>",
                    FontSlant->"Italic"],
                    StyleForm[#, FontSlant -> "Italic"]& ],
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    FontFamily->"Times",
                    FontSize->12,
                    FontWeight->"Plain",
                    FontSlant->"Plain",
                    FontTracking->"Plain",
                    FontColor->GrayLevel[0],
                    FontOpacity->1],
                    
                    DisplayForm], {0.46086519047619046`, 0.8549827573421924}, \
{0, 0}, Automatic, {1, 0}], InsetBox[
                    TagBox[
                    StyleBox[
                    TagBox[
                    TagBox[
                    StyleBox["\<\"n\"\>",
                    FontSlant->"Italic"],
                    StyleForm[#, FontSlant -> "Italic"]& ],
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    FontFamily->"Times",
                    FontSize->12,
                    FontWeight->"Plain",
                    FontSlant->"Plain",
                    FontTracking->"Plain",
                    FontColor->GrayLevel[0],
                    FontOpacity->1],
                    DisplayForm], {0.4322165215602315, 0.8087022142857143}, {0, 0},
                     Automatic, {1, 0}], InsetBox[
                    TagBox[
                    StyleBox[
                    TagBox[
                    TagBox[
                    StyleBox["\<\"p\"\>",
                    FontSlant->"Italic"],
                    StyleForm[#, FontSlant -> "Italic"]& ],
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    FontFamily->"Times",
                    FontSize->12,
                    FontWeight->"Plain",
                    FontSlant->"Plain",
                    FontTracking->"Plain",
                    FontColor->GrayLevel[0],
                    FontOpacity->1],
                    
                    DisplayForm], {0.42173038095238097`, 0.7533075396825397}, \
{0, 0}, Automatic, {1, 0}], InsetBox[
                    TagBox[
                    StyleBox[
                    TagBox[
                    TagBox[
                    StyleBox["\<\"n\"\>",
                    FontSlant->"Italic"],
                    StyleForm[#, FontSlant -> "Italic"]& ],
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    FontFamily->"Times",
                    FontSize->12,
                    FontWeight->"Plain",
                    FontSlant->"Plain",
                    FontTracking->"Plain",
                    FontColor->GrayLevel[0],
                    FontOpacity->1],
                    DisplayForm], {0.4322165215602315, 0.6912977857142857}, {0, 0},
                     Automatic, {1, 0}], InsetBox[
                    TagBox[
                    StyleBox[
                    TagBox[
                    TagBox[
                    StyleBox["\<\"p\"\>",
                    FontSlant->"Italic"],
                    StyleForm[#, FontSlant -> "Italic"]& ],
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    FontFamily->"Times",
                    FontSize->12,
                    FontWeight->"Plain",
                    FontSlant->"Plain",
                    FontTracking->"Plain",
                    FontColor->GrayLevel[0],
                    FontOpacity->1],
                    DisplayForm], {0.46086519047619046`, 0.651632322022887}, {0, 0},
                     Automatic, {1, 0}], InsetBox[
                    TagBox[
                    StyleBox[
                    TagBox[
                    TagBox[
                    StyleBox["\<\"n\"\>",
                    FontSlant->"Italic"],
                    StyleForm[#, FontSlant -> "Italic"]& ],
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    FontFamily->"Times",
                    FontSize->12,
                    FontWeight->"Plain",
                    FontSlant->"Plain",
                    FontTracking->"Plain",
                    FontColor->GrayLevel[0],
                    FontOpacity->1],
                    DisplayForm], {0.5, 0.6325955714285715}, {0, 0}, 
                    Automatic, {1, 0}], InsetBox[
                    TagBox[
                    StyleBox[
                    TagBox[
                    TagBox[
                    StyleBox["\<\"p\"\>",
                    FontSlant->"Italic"],
                    StyleForm[#, FontSlant -> "Italic"]& ],
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    FontFamily->"Times",
                    FontSize->12,
                    FontWeight->"Plain",
                    FontSlant->"Plain",
                    FontTracking->"Plain",
                    FontColor->GrayLevel[0],
                    FontOpacity->1],
                    DisplayForm], {0.5391348095238095, 0.651632322022887}, {0, 0},
                     Automatic, {1, 0}], InsetBox[
                    TagBox[
                    StyleBox[
                    TagBox[
                    TagBox[
                    StyleBox["\<\"n\"\>",
                    FontSlant->"Italic"],
                    StyleForm[#, FontSlant -> "Italic"]& ],
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    FontFamily->"Times",
                    FontSize->12,
                    FontWeight->"Plain",
                    FontSlant->"Plain",
                    FontTracking->"Plain",
                    FontColor->GrayLevel[0],
                    FontOpacity->1],
                    DisplayForm], {0.5677834784397685, 0.6912977857142857}, {0, 0},
                     Automatic, {1, 0}], InsetBox[
                    TagBox[
                    StyleBox[
                    TagBox[
                    TagBox[
                    StyleBox["\<\"p\"\>",
                    FontSlant->"Italic"],
                    StyleForm[#, FontSlant -> "Italic"]& ],
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    FontFamily->"Times",
                    FontSize->12,
                    FontWeight->"Plain",
                    FontSlant->"Plain",
                    FontTracking->"Plain",
                    FontColor->GrayLevel[0],
                    FontOpacity->1],
                    DisplayForm], {0.5782696190476191, 0.7533075396825397}, {0, 0},
                     Automatic, {1, 0}], InsetBox[
                    TagBox[
                    StyleBox[
                    TagBox["\<\"Collective deformation\"\>",
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    FontFamily->"Times",
                    FontSize->15,
                    FontWeight->"Plain",
                    FontSlant->"Plain",
                    FontTracking->"Plain",
                    FontColor->GrayLevel[0],
                    FontOpacity->1],
                    DisplayForm], {0.8333333333333333, 1.}, {0, 1}, 
                    Automatic, {1, 0}], InsetBox[
                    TagBox[
                    StyleBox[
                    TagBox["\<\"Cluster correlations\"\>",
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    FontFamily->"Times",
                    FontSize->15,
                    FontWeight->"Plain",
                    FontSlant->"Plain",
                    FontTracking->"Plain",
                    FontColor->GrayLevel[0],
                    FontOpacity->1],
                    DisplayForm], {0.5, 0.}, {0, -1}, Automatic, {1, 0}], 
                    InsetBox[
                    TagBox[
                    StyleBox[
                    TagBox["\<\"\[Alpha]\"\>",
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    FontFamily->"Times",
                    FontSize->16,
                    FontWeight->"Plain",
                    FontSlant->"Plain",
                    FontTracking->"Plain",
                    FontColor->GrayLevel[0],
                    FontOpacity->1],
                    DisplayForm], {0.5509229046951908, 0.25}, {0, 0}, 
                    Automatic, {1, 0}], InsetBox[
                    TagBox[
                    StyleBox[
                    TagBox["\<\"\[Alpha]\"\>",
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    FontFamily->"Times",
                    FontSize->16,
                    FontWeight->"Plain",
                    FontSlant->"Plain",
                    FontTracking->"Plain",
                    FontColor->GrayLevel[0],
                    FontOpacity->1],
                    DisplayForm], {0.4745385476524046, 0.3161507936507937}, {0, 0},
                     Automatic, {1, 0}], InsetBox[
                    TagBox[
                    StyleBox[
                    TagBox["\<\"\[Alpha]\"\>",
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    FontFamily->"Times",
                    FontSize->16,
                    FontWeight->"Plain",
                    FontSlant->"Plain",
                    FontTracking->"Plain",
                    FontColor->GrayLevel[0],
                    FontOpacity->1],
                    
                    DisplayForm], {0.4745385476524046, 0.18384920634920635`}, \
{0, 0}, Automatic, {1, 0}], InsetBox[
                    TagBox[
                    StyleBox[
                    TagBox["\<\"\[Alpha]\"\>",
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    FontFamily->"Times",
                    FontSize->16,
                    FontWeight->"Plain",
                    FontSlant->"Plain",
                    FontTracking->"Plain",
                    FontColor->GrayLevel[0],
                    FontOpacity->1],
                    DisplayForm], {0.5509229046951908, 0.25}, {0, 0}, 
                    Automatic, {1, 0}], InsetBox[
                    TagBox[
                    StyleBox[
                    TagBox["\<\"Pair condensation\"\>",
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    FontFamily->"Times",
                    FontSize->15,
                    FontWeight->"Plain",
                    FontSlant->"Plain",
                    FontTracking->"Plain",
                    FontColor->GrayLevel[0],
                    FontOpacity->1],
                    DisplayForm], {0.8333333333333333, 0.}, {0, -1}, 
                    Automatic, {1, 0}], InsetBox[
                    TagBox[
                    StyleBox[
                    TagBox[
                    TagBox[
                    StyleBox["\<\"E\"\>",
                    FontSlant->"Italic"],
                    StyleForm[#, FontSlant -> "Italic"]& ],
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    FontFamily->"Times",
                    FontSize->12,
                    FontWeight->"Plain",
                    FontSlant->"Plain",
                    FontTracking->"Plain",
                    FontColor->RGBColor[0.333333, 0.333333, 0.333333],
                    FontOpacity->1],
                    
                    DisplayForm], {0.6964655242905242, 0.28246753246753253`}, \
{0, 0}, Automatic, {0, 
                    1}]}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}\
}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}\
}}}}}}}}}}}}}},
AspectRatio->0.6666666666666667,
Axes->False,
Background->None,
BaseStyle->{
 FontFamily -> "Times", FontSize -> 12, FontSlant -> "Plain", FontTracking -> 
  "Plain", FontWeight -> "Plain", FontColor -> GrayLevel[0], FontOpacity -> 1,
   ShowAutoStyles -> False, SingleLetterItalics -> False},
DisplayFunction->Identity,
Frame->False,
FrameLabel->{None, None, None, None},
FrameStyle->Directive[{
   GrayLevel[0], 
   Opacity[1], 
   CapForm[None], 
   AbsoluteThickness[1], 
   AbsoluteDashing[{}]}],
FrameTicks->None,
ImageSize->{453.59999999999997`, 302.4},
PlotRange->{{-0.0001, 1.0001}, {-0.0001, 1.0001}},
Ticks->None]], "Output",
 CellChangeTimes->{3.488836538515625*^9, 3.48883794671875*^9, 
  3.4956594663125*^9, 3.495659704109375*^9, 3.525527904375*^9},
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Simple example of image or vector graphics import", "Section",
 CellChangeTimes->{{3.488838544484375*^9, 3.488838555671875*^9}}],

Cell[TextData[{
 "Import bitmap image from standard Wolfram example data (this is a ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " Image object)"
}], "Text",
 CellChangeTimes->{{3.488838441875*^9, 3.488838450328125*^9}, {
  3.48883848328125*^9, 3.488838484453125*^9}, {3.492724853375*^9, 
  3.49272486109375*^9}, {3.501273888984375*^9, 3.50127390671875*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"MapImage", "=", 
   RowBox[{"Import", "[", "\"\<ExampleData/cea.tif\>\"", "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.485821451328125*^9, 3.485821451921875*^9}, {
   3.485821551484375*^9, 3.485821563546875*^9}, {3.48883113828125*^9, 
   3.4888311386875*^9}, {3.48883125190625*^9, 3.488831275296875*^9}, {
   3.488837116125*^9, 3.488837126171875*^9}, {3.488837619625*^9, 
   3.488837619859375*^9}, 3.488838440359375*^9, 3.495659667828125*^9}],

Cell[TextData[{
 "Import vector graphics from a PDF file (this is a ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " Graphics object)"
}], "Text",
 CellChangeTimes->{{3.48883845809375*^9, 3.488838480234375*^9}, {
  3.501273911375*^9, 3.501273918890625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"EllipsoidGraphics", "=", 
   RowBox[{
   "Import", "[", 
    "\"\<LevelScheme/ExampleData/nuclpict_modes_redblue_Y22C.pdf\>\"", 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.4881504998125*^9, 3.488150503515625*^9}, {
   3.488151365*^9, 3.488151434515625*^9}, {3.488281363875*^9, 
   3.488281364125*^9}, {3.48828319428125*^9, 3.488283206625*^9}, {
   3.48883605475*^9, 3.488836058734375*^9}, {3.48883632528125*^9, 
   3.488836343359375*^9}, {3.488837665890625*^9, 3.4888376971875*^9}, {
   3.4888377524375*^9, 3.488837773359375*^9}, 3.492125327390625*^9, 
   3.492125423609375*^9, {3.495659420765625*^9, 3.495659433921875*^9}, {
   3.501273932671875*^9, 3.501273933984375*^9}, 3.50127399434375*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Figure", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Multipanel", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"2", ",", "2"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"XPlotRanges", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"YPlotRanges", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
       RowBox[{"XGapSizes", "\[Rule]", "0.05"}], ",", "\[IndentingNewLine]", 
       RowBox[{"YGapSizes", "\[Rule]", "0.05"}], ",", "\[IndentingNewLine]", 
       RowBox[{"ShowTicks", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"False", ",", "False", ",", "False", ",", "False"}], 
         "}"}]}]}], "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"Table", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Switch", "[", 
        RowBox[{
         RowBox[{"Mod", "[", 
          RowBox[{
           RowBox[{"r", "+", "s"}], ",", "2"}], "]"}], ",", 
         "\[IndentingNewLine]", "0", ",", "\[IndentingNewLine]", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"FigurePanel", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"r", ",", "s"}], "}"}], ",", 
             RowBox[{"PanelLetterBackground", "\[Rule]", "LightGray"}]}], 
            "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"FigGraphics", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"0", ",", "1"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", "MapImage"}], 
            "]"}], ","}], "\[IndentingNewLine]", "}"}], ",", 
         "\[IndentingNewLine]", "1", ",", "\[IndentingNewLine]", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"FigurePanel", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"r", ",", "s"}], "}"}], ",", 
             RowBox[{"ExtendRange", "\[Rule]", "0.05"}], ",", 
             RowBox[{"Background", "\[Rule]", "Moccasin"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"FigGraphics", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"0", ",", "1"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
             "EllipsoidGraphics"}], "]"}], ","}], "\[IndentingNewLine]", 
          "}"}]}], "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"r", ",", "1", ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"s", ",", "1", ",", "2"}], "}"}]}], "\[IndentingNewLine]", 
      "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
   RowBox[{"ExtendRange", "\[Rule]", "0.1"}], ",", "\[IndentingNewLine]", 
   RowBox[{"ImageSize", "\[Rule]", 
    RowBox[{"72", "*", 
     RowBox[{"{", 
      RowBox[{"4", ",", "4"}], "}"}]}]}], ",", "\[IndentingNewLine]", 
   RowBox[{"Frame", "\[Rule]", "False"}]}], "\[IndentingNewLine]", 
  "]"}]], "Input",
 CellChangeTimes->{{3.4052021644375*^9, 3.40520220715625*^9}, {
   3.405202238578125*^9, 3.40520223878125*^9}, {3.405202292609375*^9, 
   3.405202309484375*^9}, {3.405202468546875*^9, 3.405202475*^9}, {
   3.4052025325*^9, 3.405202631546875*^9}, {3.405202731875*^9, 
   3.405203287703125*^9}, {3.405203325578125*^9, 3.40520335125*^9}, {
   3.40520343996875*^9, 3.40520350828125*^9}, {3.405204675671875*^9, 
   3.405204740328125*^9}, {3.40520477325*^9, 3.405204832828125*^9}, 
   3.48828153896875*^9, {3.488281624859375*^9, 3.488281694890625*^9}, {
   3.488282148296875*^9, 3.48828228190625*^9}, {3.488283226109375*^9, 
   3.488283247671875*^9}, {3.488284071875*^9, 3.488284109640625*^9}, {
   3.488284168796875*^9, 3.48828417221875*^9}, {3.4882842058125*^9, 
   3.488284228625*^9}, {3.48828430809375*^9, 3.488284327875*^9}, {
   3.488284477984375*^9, 3.488284618828125*^9}, {3.48828465840625*^9, 
   3.48828473565625*^9}, {3.488284768390625*^9, 3.488284768515625*^9}, {
   3.48828486096875*^9, 3.48828487484375*^9}, {3.488284916890625*^9, 
   3.488284939359375*^9}, {3.488284994625*^9, 3.48828503721875*^9}, {
   3.488285076765625*^9, 3.48828507703125*^9}, {3.48828549625*^9, 
   3.488285532375*^9}, {3.488833143078125*^9, 3.48883318528125*^9}, {
   3.48883326521875*^9, 3.488833284421875*^9}, {3.488833330984375*^9, 
   3.48883347028125*^9}, {3.48883386234375*^9, 3.488833895203125*^9}, {
   3.4888339380625*^9, 3.488833958796875*^9}, {3.48883399415625*^9, 
   3.488834068015625*^9}, {3.488837154109375*^9, 3.488837236796875*^9}, {
   3.488837297359375*^9, 3.48883753421875*^9}, {3.495659668546875*^9, 
   3.49565968328125*^9}}],

Cell[BoxData[
 GraphicsBox[{
   {RGBColor[1., 0.894101, 0.709799], Opacity[1], 
    RectangleBox[{0.5121951219512195, 0.5121951219512195}, {1., 1.}]}, 
   {RGBColor[1., 0.894101, 0.709799], Opacity[1], 
    RectangleBox[{0., -5.551115123125783*^-17}, \
{0.48780487804878053`, 0.4878048780487805}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0., 0.5121951219512195}, {0.48780487804878053`, 
     0.5121951219512195}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0., 0.5121951219512195}, {0., 1.}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0., 1.}, {0.48780487804878053`, 1.}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0.48780487804878053`, 0.5121951219512195}, {
     0.48780487804878053`, 1.}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], {}, InsetBox[
     FormBox[
      GraphicsBox[
       TagBox[RasterBox[CompressedData["
1:eJzsvSuw5TobprdrEnDgphsuuOCiZjE0dJjZjGuGGKRqnKrUlKigoKCooKCg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         "], {{0, 515}, {514, 0}}, {0, 255},
         ColorFunction->GrayLevel],
        BoxForm`ImageTag[
        "Byte", ColorSpace -> "Grayscale", Interleaving -> None],
        Selectable->False],
       BaseStyle->"ImageGraphics",
       ImageSizeRaw->{514, 515},
       PlotRange->{{0, 514}, {0, 515}}],
      TraditionalForm], {0.24390243902439027`, 0.7560975609756098}, 
     Center, {0.48780487804878053`, 0.4878048780487805}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0.5121951219512195, 0.5121951219512195}, {1., 
     0.5121951219512195}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0.5121951219512195, 0.5121951219512195}, {
     0.5121951219512195, 1.}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0.5121951219512195, 1.}, {1., 1.}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{1., 0.5121951219512195}, {1., 1.}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], {}, InsetBox[
     GraphicsBox[
      {Thickness[0.006024096385542169], 
       {FaceForm[{RGBColor[0.64314, 0., 0.35686], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{3.16, 64.6}, {1.12, 
         67.72}, {1.9600000000000002`, 60.279999999999994`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{3.16, 64.6}, {1.12, 
         67.72}, {1.9600000000000002`, 60.279999999999994`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.64314, 0., 0.35686], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{1.12, 67.72}, {3.16, 
         64.6}, {3.52, 74.67999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{1.12, 67.72}, {3.16, 
         64.6}, {3.52, 74.67999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.64314, 0., 0.35686], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{3.52, 
         74.67999999999999}, {1.3599999999999999`, 75.63999999999999}, {1.12, 
         67.72}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{3.52, 
         74.67999999999999}, {1.3599999999999999`, 75.63999999999999}, {1.12, 
         67.72}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.61961, 0., 0.38039], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{1.36, 75.64}, {
         3.5200000000000005`, 74.68}, {5.08, 84.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{1.36, 75.64}, {
         3.5200000000000005`, 74.68}, {5.08, 84.64}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.61961, 0., 0.38039], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{5.08, 84.64}, {2.56, 
         83.44}, {1.3599999999999999`, 75.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{5.08, 84.64}, {2.56, 
         83.44}, {1.3599999999999999`, 75.64}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.61961, 0., 0.38039], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{4.24, 
         55.120000000000005`}, {1.96, 60.28}, {3.7600000000000002`, 
         53.56}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{4.24, 
         55.120000000000005`}, {1.96, 60.28}, {3.7600000000000002`, 53.56}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.64314, 0., 0.35686], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{1.96, 60.28}, {4.24, 
         55.120000000000005`}, {3.16, 64.6}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{1.96, 60.28}, {4.24, 
         55.120000000000005`}, {3.16, 64.6}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.57255, 0., 0.42745000000000005`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{2.56, 
         83.44000000000001}, {5.08, 84.64000000000001}, {7.84, 94.12}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{2.56, 
         83.44000000000001}, {5.08, 84.64000000000001}, {7.84, 94.12}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.57255, 0., 0.42745000000000005`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{7.84, 
         94.11999999999999}, {4.72, 90.88}, {2.5599999999999996`, 83.44}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{7.84, 
         94.11999999999999}, {4.72, 90.88}, {2.5599999999999996`, 83.44}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7215699999999999, 0., 0.27843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{7.84, 
         61.720000000000006`}, {3.16, 64.60000000000001}, {4.24, 
         55.120000000000005`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{7.84, 
         61.720000000000006`}, {3.16, 64.60000000000001}, {4.24, 
         55.120000000000005`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7215699999999999, 0., 0.27843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{3.16, 64.6}, {7.84, 
         61.71999999999999}, {8.32, 73.47999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{3.16, 64.6}, {7.84, 
         61.71999999999999}, {8.32, 73.47999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7215699999999999, 0., 0.27843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{8.32, 73.48}, {
         3.5200000000000005`, 74.68}, {3.160000000000001, 
         64.60000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{8.32, 73.48}, {
         3.5200000000000005`, 74.68}, {3.160000000000001, 64.60000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.6823499999999999, 0., 0.31765], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{3.52, 
         74.67999999999999}, {8.32, 73.47999999999999}, {10.12, 85.24}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{3.52, 
         74.67999999999999}, {8.32, 73.47999999999999}, {10.12, 85.24}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.6823499999999999, 0., 0.31765], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{10.12, 
         85.24000000000001}, {5.079999999999999, 84.64000000000001}, {
         3.5199999999999996`, 74.68}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{10.12, 
         85.24000000000001}, {5.079999999999999, 84.64000000000001}, {
         3.5199999999999996`, 74.68}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.61961, 0., 0.38039], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{3.7600000000000002`, 
         53.56}, {6.5200000000000005`, 46.72}, {4.24, 
         55.120000000000005`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{3.7600000000000002`, 
         53.56}, {6.5200000000000005`, 46.72}, {4.24, 55.120000000000005`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.6823499999999999, 0., 0.31765], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{9.04, 50.68}, {
         4.239999999999999, 55.12}, {6.52, 46.72}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{9.04, 50.68}, {
         4.239999999999999, 55.12}, {6.52, 46.72}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7215699999999999, 0., 0.27843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{4.24, 
         55.120000000000005`}, {9.04, 50.68000000000001}, {7.84, 
         61.720000000000006`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{4.24, 
         55.120000000000005`}, {9.04, 50.68000000000001}, {7.84, 
         61.720000000000006`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.51765, 0., 0.48235000000000006`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{11.68, 102.52}, {7.84, 
         97.6}, {4.72, 90.88}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{11.68, 102.52}, {7.84, 
         97.6}, {4.72, 90.88}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.51765, 0., 0.48235000000000006`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{4.72, 90.88}, {7.84, 
         94.11999999999999}, {11.68, 102.52}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{4.72, 90.88}, {7.84, 
         94.11999999999999}, {11.68, 102.52}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.61176, 0., 0.38824], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{5.08, 84.64}, {
         10.120000000000001`, 85.24}, {13.36, 96.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{5.08, 84.64}, {
         10.120000000000001`, 85.24}, {13.36, 96.28}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.61176, 0., 0.38824], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{13.360000000000001`, 
         96.28}, {7.840000000000002, 94.12}, {5.080000000000002, 84.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{13.360000000000001`, 
         96.28}, {7.840000000000002, 94.12}, {5.080000000000002, 84.64}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.61176, 0., 0.38824], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{11.56, 
         40.839999999999996`}, {6.5200000000000005`, 46.72}, {9.76, 
         39.63999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{11.56, 
         40.839999999999996`}, {6.5200000000000005`, 46.72}, {9.76, 
         39.63999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.6823499999999999, 0., 0.31765], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{6.52, 
         46.720000000000006`}, {11.559999999999999`, 40.84}, {9.04, 
         50.68000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{6.52, 
         46.720000000000006`}, {11.559999999999999`, 40.84}, {9.04, 
         50.68000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.4549, 0., 0.5451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{16.36, 109.48}, {
         11.559999999999999`, 103.12}, {7.84, 97.60000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{16.36, 109.48}, {
         11.559999999999999`, 103.12}, {7.84, 97.60000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.4549, 0., 0.5451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{7.84, 97.6}, {11.68, 
         102.52}, {16.36, 109.47999999999999`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{7.84, 97.6}, {11.68, 
         102.52}, {16.36, 109.47999999999999`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{17.8, 
         106.11999999999999`}, {11.680000000000001`, 102.52}, {7.84, 
         94.11999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{17.8, 
         106.11999999999999`}, {11.680000000000001`, 102.52}, {7.84, 
         94.11999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{7.84, 
         94.11999999999999}, {13.36, 96.27999999999999}, {17.8, 
         106.11999999999999`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{7.84, 
         94.11999999999999}, {13.36, 96.27999999999999}, {17.8, 
         106.11999999999999`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8, 0., 0.2], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{14.56, 59.08}, {
         7.840000000000001, 61.72}, {9.040000000000001, 50.68}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{14.56, 59.08}, {
         7.840000000000001, 61.72}, {9.040000000000001, 50.68}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8, 0., 0.2], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{7.84, 
         61.720000000000006`}, {14.559999999999999`, 59.080000000000005`}, {
         15.04, 72.16000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{7.84, 
         61.720000000000006`}, {14.559999999999999`, 59.080000000000005`}, {
         15.04, 72.16000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8, 0., 0.2], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{15.04, 72.16}, {8.32, 
         73.47999999999999}, {7.839999999999999, 61.72}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{15.04, 72.16}, {8.32, 
         73.47999999999999}, {7.839999999999999, 61.72}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7451, 0., 0.2549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{8.32, 73.48}, {15.04, 
         72.16000000000001}, {17.08, 85.12}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{8.32, 73.48}, {15.04, 
         72.16000000000001}, {17.08, 85.12}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7451, 0., 0.2549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{17.08, 
         85.11999999999999}, {10.119999999999997`, 85.24}, {8.319999999999999,
          73.47999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{17.08, 
         85.11999999999999}, {10.119999999999997`, 85.24}, {8.319999999999999,
          73.47999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7451, 0., 0.2549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{15.76, 46.96}, {9.04, 
         50.68}, {11.559999999999999`, 40.84}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{15.76, 46.96}, {9.04, 
         50.68}, {11.559999999999999`, 40.84}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8, 0., 0.2], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{9.04, 50.68}, {
         15.759999999999998`, 46.96}, {14.559999999999999`, 59.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{9.04, 50.68}, {
         15.759999999999998`, 46.96}, {14.559999999999999`, 59.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.61176, 0., 0.38824], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{9.76, 39.64}, {15.28, 
         32.8}, {11.56, 40.84}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{9.76, 39.64}, {15.28, 
         32.8}, {11.56, 40.84}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{15.28, 32.8}, {9.76, 
         39.64}, {13.84, 34.48}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{15.28, 32.8}, {9.76, 
         39.64}, {13.84, 34.48}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.65098, 0., 0.34902], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{10.12, 
         85.24000000000001}, {17.08, 85.12}, {20.56, 97.48}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{10.12, 
         85.24000000000001}, {17.08, 85.12}, {20.56, 97.48}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.65098, 0., 0.34902], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{20.56, 97.48}, {13.36, 
         96.28}, {10.12, 85.24000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{20.56, 97.48}, {13.36, 
         96.28}, {10.12, 85.24000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.65098, 0., 0.34902], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{18.52, 36.04}, {
         11.559999999999999`, 40.839999999999996`}, {15.28, 32.8}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{18.52, 36.04}, {
         11.559999999999999`, 40.839999999999996`}, {15.28, 32.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7451, 0., 0.2549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{11.56, 
         40.839999999999996`}, {18.52, 36.04}, {15.760000000000002`, 
         46.959999999999994`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{11.56, 
         40.839999999999996`}, {18.52, 36.04}, {15.760000000000002`, 
         46.959999999999994`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.4313700000000001, 0., 0.5686300000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{23.08, 114.28}, {16.36, 
         109.48}, {11.679999999999998`, 102.52}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{23.08, 114.28}, {16.36, 
         109.48}, {11.679999999999998`, 102.52}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.4313700000000001, 0., 0.5686300000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{11.68, 102.52}, {
         17.799999999999997`, 106.11999999999999`}, {23.08, 114.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{11.68, 102.52}, {
         17.799999999999997`, 106.11999999999999`}, {23.08, 114.28}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53333, 0., 0.46667000000000003`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{25.36, 108.28}, {17.8, 
         106.12}, {13.36, 96.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{25.36, 108.28}, {17.8, 
         106.12}, {13.36, 96.28}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53333, 0., 0.46667000000000003`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{13.360000000000001`, 
         96.28}, {20.560000000000002`, 97.48}, {25.36, 108.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{13.360000000000001`, 
         96.28}, {20.560000000000002`, 97.48}, {25.36, 108.28}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{13.84, 34.48}, {20.08, 
         26.799999999999997`}, {15.28, 32.8}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{13.84, 34.48}, {20.08, 
         26.799999999999997`}, {15.28, 32.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8705900000000001, 0., 0.12941000000000003`], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{22.72, 56.92}, {
         14.559999999999999`, 59.08}, {15.759999999999998`, 46.96}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{22.72, 56.92}, {
         14.559999999999999`, 59.08}, {15.759999999999998`, 46.96}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8705900000000001, 0., 0.12941000000000003`], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{14.56, 59.08}, {22.72, 
         56.92}, {23.2, 70.84}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{14.56, 59.08}, {22.72, 
         56.92}, {23.2, 70.84}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8705900000000001, 0., 0.12941000000000003`], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{23.2, 70.84}, {15.04, 
         72.16}, {14.56, 59.080000000000005`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{23.2, 70.84}, {15.04, 
         72.16}, {14.56, 59.080000000000005`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8078400000000001, 0., 0.19216], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{15.04, 72.16}, {23.2, 
         70.84}, {25.24, 84.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{15.04, 72.16}, {23.2, 
         70.84}, {25.24, 84.64}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8078400000000001, 0., 0.19216], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{25.24, 84.64}, {17.08, 
         85.12}, {15.04, 72.16}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{25.24, 84.64}, {17.08, 
         85.12}, {15.04, 72.16}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53333, 0., 0.46667000000000003`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{22.6, 27.16}, {
         15.280000000000001`, 32.8}, {20.080000000000002`, 26.8}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{22.6, 27.16}, {
         15.280000000000001`, 32.8}, {20.080000000000002`, 26.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.65098, 0., 0.34902], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{15.28, 32.8}, {
         22.599999999999998`, 27.159999999999997`}, {18.52, 36.04}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{15.28, 32.8}, {
         22.599999999999998`, 27.159999999999997`}, {18.52, 36.04}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8078400000000001, 0., 0.19216], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{23.8, 
         43.839999999999996`}, {15.760000000000002`, 46.959999999999994`}, {
         18.52, 36.04}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{23.8, 
         43.839999999999996`}, {15.760000000000002`, 46.959999999999994`}, {
         18.52, 36.04}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8705900000000001, 0., 0.12941000000000003`], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{15.76, 46.96}, {
         23.799999999999997`, 43.84}, {22.72, 56.92}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{15.76, 46.96}, {
         23.799999999999997`, 43.84}, {22.72, 56.92}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.34902, 0., 0.65098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{16.36, 109.48}, {23.08, 
         114.28}, {29.08, 120.16}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{16.36, 109.48}, {23.08, 
         114.28}, {29.08, 120.16}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.34902, 0., 0.65098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{29.08, 120.16}, {21.52, 
         114.75999999999999`}, {16.36, 109.47999999999999`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{29.08, 120.16}, {21.52, 
         114.75999999999999`}, {16.36, 109.47999999999999`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.6901999999999999, 0., 0.3098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{17.08, 
         85.11999999999999}, {25.24, 84.63999999999999}, {29.08, 
         97.71999999999998}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{17.08, 
         85.11999999999999}, {25.24, 84.63999999999999}, {29.08, 
         97.71999999999998}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.6901999999999999, 0., 0.3098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{29.08, 97.72}, {20.56, 
         97.48}, {17.08, 85.12}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{29.08, 97.72}, {20.56, 
         97.48}, {17.08, 85.12}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.40392000000000006`, 0., 0.5960799999999999], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{31.24, 117.28}, {23.08, 
         114.28}, {17.799999999999997`, 106.12}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{31.24, 117.28}, {23.08, 
         114.28}, {17.799999999999997`, 106.12}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.40392000000000006`, 0., 0.5960799999999999], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{17.8, 
         106.11999999999999`}, {25.36, 108.27999999999999`}, {
         31.240000000000002`, 117.27999999999999`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{17.8, 
         106.11999999999999`}, {25.36, 108.27999999999999`}, {
         31.240000000000002`, 117.27999999999999`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.6901999999999999, 0., 0.3098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{26.68, 32.32}, {18.52, 
         36.04}, {22.6, 27.16}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{26.68, 32.32}, {18.52, 
         36.04}, {22.6, 27.16}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8078400000000001, 0., 0.19216], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{18.52, 36.04}, {26.68, 
         32.32}, {23.8, 43.839999999999996`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{18.52, 36.04}, {26.68, 
         32.32}, {23.8, 43.839999999999996`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53333, 0., 0.46667000000000003`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{20.08, 26.8}, {
         27.639999999999997`, 20.68}, {22.599999999999998`, 27.16}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{20.08, 26.8}, {
         27.639999999999997`, 20.68}, {22.599999999999998`, 27.16}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53725, 0., 0.46275], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{20.56, 97.48}, {29.08, 
         97.72}, {34.12, 109.48}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{20.56, 97.48}, {29.08, 
         97.72}, {34.12, 109.48}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53725, 0., 0.46275], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{34.120000000000005`, 
         109.48}, {25.360000000000007`, 108.28}, {20.560000000000002`, 
         97.48}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{34.120000000000005`, 
         109.48}, {25.360000000000007`, 108.28}, {20.560000000000002`, 
         97.48}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53725, 0., 0.46275], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{30.88, 
         22.959999999999997`}, {22.6, 27.159999999999997`}, {27.64, 
         20.679999999999996`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{30.88, 
         22.959999999999997`}, {22.6, 27.159999999999997`}, {27.64, 
         20.679999999999996`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.6901999999999999, 0., 0.3098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{22.6, 27.16}, {
         30.880000000000003`, 22.96}, {26.68, 32.32}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{22.6, 27.16}, {
         30.880000000000003`, 22.96}, {26.68, 32.32}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.92549, 0., 0.07451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{31.6, 55.}, {22.72, 
         56.92}, {23.8, 43.84}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{31.6, 55.}, {22.72, 
         56.92}, {23.8, 43.84}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.92549, 0., 0.07451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{22.72, 56.92}, {31.6, 
         55.}, {32.2, 69.4}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{22.72, 56.92}, {31.6, 
         55.}, {32.2, 69.4}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.92549, 0., 0.07451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{32.2, 69.4}, {
         23.200000000000003`, 70.84}, {22.720000000000002`, 56.92}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{32.2, 69.4}, {
         23.200000000000003`, 70.84}, {22.720000000000002`, 56.92}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.29804, 0., 0.7019599999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{23.08, 114.28}, {31.24, 
         117.28}, {37.599999999999994`, 123.88}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{23.08, 114.28}, {31.24, 
         117.28}, {37.599999999999994`, 123.88}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.29804, 0., 0.7019599999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{37.6, 123.88}, {
         29.080000000000002`, 120.16}, {23.080000000000002`, 114.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{37.6, 123.88}, {
         29.080000000000002`, 120.16}, {23.080000000000002`, 114.28}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8549000000000001, 0., 0.1451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{23.2, 70.84}, {32.2, 
         69.4}, {34.36, 83.92}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{23.2, 70.84}, {32.2, 
         69.4}, {34.36, 83.92}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8549000000000001, 0., 0.1451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{34.36, 83.92}, {
         25.240000000000002`, 84.64}, {23.2, 70.84}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{34.36, 83.92}, {
         25.240000000000002`, 84.64}, {23.2, 70.84}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8549000000000001, 0., 0.1451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{32.8, 41.44}, {
         23.799999999999997`, 43.839999999999996`}, {26.68, 32.32}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{32.8, 41.44}, {
         23.799999999999997`, 43.839999999999996`}, {26.68, 32.32}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.92549, 0., 0.07451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{23.8, 
         43.839999999999996`}, {32.8, 41.44}, {31.6, 55.}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{23.8, 
         43.839999999999996`}, {32.8, 41.44}, {31.6, 55.}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.71765, 0., 0.28235000000000005`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{25.24, 84.64}, {34.36, 
         83.92}, {38.2, 97.48}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{25.24, 84.64}, {34.36, 
         83.92}, {38.2, 97.48}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.71765, 0., 0.28235000000000005`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{38.2, 97.48}, {
         29.080000000000005`, 97.72}, {25.240000000000002`, 84.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{38.2, 97.48}, {
         29.080000000000005`, 97.72}, {25.240000000000002`, 84.64}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.38431000000000004`, 0., 0.6156900000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{25.36, 108.28}, {34.12, 
         109.48}, {40.12, 118.96000000000001`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{25.36, 108.28}, {34.12, 
         109.48}, {40.12, 118.96000000000001`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.38431000000000004`, 0., 0.6156900000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{40.120000000000005`, 
         118.96000000000001`}, {31.240000000000002`, 117.28}, {
         25.360000000000007`, 108.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{40.120000000000005`, 
         118.96000000000001`}, {31.240000000000002`, 117.28}, {
         25.360000000000007`, 108.28}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.71765, 0., 0.28235000000000005`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{35.56, 
         29.439999999999998`}, {26.68, 32.32}, {30.880000000000003`, 
         22.959999999999997`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{35.56, 
         29.439999999999998`}, {26.68, 32.32}, {30.880000000000003`, 
         22.959999999999997`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8549000000000001, 0., 0.1451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{26.68, 32.32}, {35.56, 
         29.44}, {32.8, 41.44}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{26.68, 32.32}, {35.56, 
         29.44}, {32.8, 41.44}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53725, 0., 0.46275], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{27.64, 20.68}, {36.16, 
         16.12}, {30.880000000000003`, 22.96}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{27.64, 20.68}, {36.16, 
         16.12}, {30.880000000000003`, 22.96}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.38431000000000004`, 0., 0.6156900000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{36.160000000000004`, 
         16.12}, {27.640000000000004`, 20.68}, {33.52, 
         16.720000000000002`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{36.160000000000004`, 
         16.12}, {27.640000000000004`, 20.68}, {33.52, 16.720000000000002`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.22353, 0., 0.77647], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{29.08, 120.16}, {
         37.599999999999994`, 123.88}, {44.31999999999999, 127.84}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{29.08, 120.16}, {
         37.599999999999994`, 123.88}, {44.31999999999999, 127.84}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.22353, 0., 0.77647], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{44.32, 127.84}, {35.2, 
         123.88000000000001`}, {29.080000000000002`, 120.16}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{44.32, 127.84}, {35.2, 
         123.88000000000001`}, {29.080000000000002`, 120.16}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5451, 0., 0.4549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{29.08, 97.72}, {
         38.199999999999996`, 97.48}, {43.36, 109.6}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{29.08, 97.72}, {
         38.199999999999996`, 97.48}, {43.36, 109.6}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5451, 0., 0.4549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{43.36, 109.6}, {
         34.120000000000005`, 109.47999999999999`}, {29.08, 97.72}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{43.36, 109.6}, {
         34.120000000000005`, 109.47999999999999`}, {29.08, 97.72}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5451, 0., 0.4549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{39.760000000000005`, 
         19.84}, {30.880000000000003`, 22.96}, {36.160000000000004`, 
         16.12}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{39.760000000000005`, 
         19.84}, {30.880000000000003`, 22.96}, {36.160000000000004`, 16.12}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.71765, 0., 0.28235000000000005`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{30.88, 
         22.959999999999997`}, {39.76, 19.839999999999996`}, {35.56, 
         29.439999999999998`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{30.88, 
         22.959999999999997`}, {39.76, 19.839999999999996`}, {35.56, 
         29.439999999999998`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.24706000000000003`, 0., 0.75294], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{46.839999999999996`, 
         125.92}, {37.599999999999994`, 123.88}, {31.239999999999995`, 
         117.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{46.839999999999996`, 
         125.92}, {37.599999999999994`, 123.88}, {31.239999999999995`, 
         117.28}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.24706000000000003`, 0., 0.75294], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{31.24, 117.28}, {40.12, 
         118.96000000000001`}, {46.839999999999996`, 125.92}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{31.24, 117.28}, {40.12, 
         118.96000000000001`}, {46.839999999999996`, 125.92}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.96471, 0., 0.03529399999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{41.08, 53.2}, {
         31.599999999999998`, 55.}, {32.8, 41.440000000000005`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{41.08, 53.2}, {
         31.599999999999998`, 55.}, {32.8, 41.440000000000005`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.96471, 0., 0.03529399999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{31.6, 55.}, {41.08, 
         53.2}, {41.68, 67.96000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{31.6, 55.}, {41.08, 
         53.2}, {41.68, 67.96000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.96471, 0., 0.03529399999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{41.68, 
         67.96000000000001}, {32.2, 69.4}, {31.6, 55.00000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{41.68, 
         67.96000000000001}, {32.2, 69.4}, {31.6, 55.00000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.88235, 0., 0.11765], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{32.2, 69.4}, {
         41.68000000000001, 67.96000000000001}, {43.96, 82.84}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{32.2, 69.4}, {
         41.68000000000001, 67.96000000000001}, {43.96, 82.84}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.88235, 0., 0.11765], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{43.96, 82.84}, {34.36, 
         83.92}, {32.2, 69.4}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{43.96, 82.84}, {34.36, 
         83.92}, {32.2, 69.4}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.88235, 0., 0.11765], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{42.160000000000004`, 
         39.4}, {32.800000000000004`, 41.44}, {35.56, 
         29.439999999999998`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{42.160000000000004`, 
         39.4}, {32.800000000000004`, 41.44}, {35.56, 29.439999999999998`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.96471, 0., 0.03529399999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{32.8, 41.44}, {42.16, 
         39.4}, {41.08, 53.199999999999996`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{32.8, 41.44}, {42.16, 
         39.4}, {41.08, 53.199999999999996`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.38431000000000004`, 0., 0.6156900000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{33.52, 16.72}, {
         42.160000000000004`, 11.919999999999998`}, {36.160000000000004`, 
         16.119999999999997`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{33.52, 16.72}, {
         42.160000000000004`, 11.919999999999998`}, {36.160000000000004`, 
         16.119999999999997`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{49.6, 
         119.44000000000001`}, {40.120000000000005`, 118.96000000000001`}, {
         34.120000000000005`, 109.48000000000002`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{49.6, 
         119.44000000000001`}, {40.120000000000005`, 118.96000000000001`}, {
         34.120000000000005`, 109.48000000000002`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{34.120000000000005`, 
         109.48}, {43.36, 109.60000000000001`}, {49.60000000000001, 
         119.44}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{34.120000000000005`, 
         109.48}, {43.36, 109.60000000000001`}, {49.60000000000001, 119.44}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.73725, 0., 0.26275], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{34.36, 83.92}, {43.96, 
         82.84}, {47.8, 96.76}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{34.36, 83.92}, {43.96, 
         82.84}, {47.8, 96.76}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.73725, 0., 0.26275], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{47.8, 96.76}, {
         38.199999999999996`, 97.48}, {34.36, 83.92}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{47.8, 96.76}, {
         38.199999999999996`, 97.48}, {34.36, 83.92}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.73725, 0., 0.26275], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{44.92, 27.16}, {35.56, 
         29.44}, {39.760000000000005`, 19.84}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{44.92, 27.16}, {35.56, 
         29.44}, {39.760000000000005`, 19.84}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.88235, 0., 0.11765], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{35.56, 
         29.439999999999998`}, {44.92, 27.159999999999997`}, {
         42.160000000000004`, 39.4}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{35.56, 
         29.439999999999998`}, {44.92, 27.159999999999997`}, {
         42.160000000000004`, 39.4}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{45.04, 
         12.639999999999999`}, {36.16, 16.119999999999997`}, {42.16, 
         11.919999999999998`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{45.04, 
         12.639999999999999`}, {36.16, 16.119999999999997`}, {42.16, 
         11.919999999999998`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5451, 0., 0.4549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{36.160000000000004`, 
         16.12}, {45.040000000000006`, 12.64}, {39.760000000000005`, 
         19.84}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{36.160000000000004`, 
         16.12}, {45.040000000000006`, 12.64}, {39.760000000000005`, 19.84}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.15294000000000005`, 0., 0.84706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{53.8, 130.12}, {
         44.31999999999999, 127.84}, {37.599999999999994`, 
         123.88000000000001`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{53.8, 130.12}, {
         44.31999999999999, 127.84}, {37.599999999999994`, 
         123.88000000000001`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.15294000000000005`, 0., 0.84706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{37.6, 123.88}, {46.84, 
         125.92}, {53.8, 130.12}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{37.6, 123.88}, {46.84, 
         125.92}, {53.8, 130.12}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5529400000000001, 0., 0.44706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{38.2, 97.48}, {
         47.800000000000004`, 96.76}, {52.96, 109.24000000000001`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{38.2, 97.48}, {
         47.800000000000004`, 96.76}, {52.96, 109.24000000000001`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5529400000000001, 0., 0.44706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{52.96, 
         109.24000000000001`}, {43.36, 109.60000000000001`}, {38.2, 
         97.48}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{52.96, 
         109.24000000000001`}, {43.36, 109.60000000000001`}, {38.2, 97.48}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5529400000000001, 0., 0.44706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{49., 17.32}, {
         39.760000000000005`, 19.84}, {45.04, 12.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{49., 17.32}, {
         39.760000000000005`, 19.84}, {45.04, 12.64}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.73725, 0., 0.26275], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{39.760000000000005`, 
         19.84}, {49., 17.32}, {44.92, 27.16}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{39.760000000000005`, 
         19.84}, {49., 17.32}, {44.92, 27.16}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.20784000000000002`, 0., 0.7921599999999999], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{56.32, 126.76}, {46.84, 
         125.92}, {40.120000000000005`, 118.96000000000001`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{56.32, 126.76}, {46.84, 
         125.92}, {40.120000000000005`, 118.96000000000001`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.20784000000000002`, 0., 0.7921599999999999], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{40.120000000000005`, 
         118.96000000000001`}, {49.60000000000001, 119.44000000000001`}, {
         56.32000000000001, 126.76}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{40.120000000000005`, 
         118.96000000000001`}, {49.60000000000001, 119.44000000000001`}, {
         56.32000000000001, 126.76}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.97647, 0., 0.023528999999999998`], Opacity[1.]}],
         FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{51.04, 51.64}, {41.08, 
         53.2}, {42.16, 39.400000000000006`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{51.04, 51.64}, {41.08, 
         53.2}, {42.16, 39.400000000000006`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.97647, 0., 0.023528999999999998`], Opacity[1.]}],
         FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{41.08, 53.2}, {51.04, 
         51.64}, {51.76, 66.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{41.08, 53.2}, {51.04, 
         51.64}, {51.76, 66.64}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.97647, 0., 0.023528999999999998`], Opacity[1.]}],
         FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{51.760000000000005`, 
         66.64}, {41.68000000000001, 67.96}, {41.080000000000005`, 53.2}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{51.760000000000005`, 
         66.64}, {41.68000000000001, 67.96}, {41.080000000000005`, 53.2}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.89412, 0., 0.10588], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{41.68, 
         67.96000000000001}, {51.76, 66.64000000000001}, {54.04, 
         81.52000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{41.68, 
         67.96000000000001}, {51.76, 66.64000000000001}, {54.04, 
         81.52000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.89412, 0., 0.10588], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{54.04, 81.52}, {43.96, 
         82.83999999999999}, {41.68, 67.96}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{54.04, 81.52}, {43.96, 
         82.83999999999999}, {41.68, 67.96}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{42.160000000000004`, 
         11.92}, {51.040000000000006`, 8.44}, {45.040000000000006`, 
         12.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{42.160000000000004`, 
         11.92}, {51.040000000000006`, 8.44}, {45.040000000000006`, 12.64}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.89412, 0., 0.10588], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{52.120000000000005`, 
         37.720000000000006`}, {42.160000000000004`, 39.400000000000006`}, {
         44.92, 27.160000000000004`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{52.120000000000005`, 
         37.720000000000006`}, {42.160000000000004`, 39.400000000000006`}, {
         44.92, 27.160000000000004`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.97647, 0., 0.023528999999999998`], Opacity[1.]}],
         FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{42.160000000000004`, 
         39.4}, {52.120000000000005`, 37.72}, {51.040000000000006`, 
         51.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{42.160000000000004`, 
         39.4}, {52.120000000000005`, 37.72}, {51.040000000000006`, 51.64}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.35294, 0., 0.64706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{43.36, 109.6}, {52.96, 
         109.24}, {59.2, 119.32}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{43.36, 109.6}, {52.96, 
         109.24}, {59.2, 119.32}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.35294, 0., 0.64706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{59.2, 119.32}, {49.6, 
         119.44}, {43.36, 109.6}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{59.2, 119.32}, {49.6, 
         119.44}, {43.36, 109.6}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7451, 0., 0.2549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{43.96, 82.84}, {54.04, 
         81.52000000000001}, {57.88, 95.68}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{43.96, 82.84}, {54.04, 
         81.52000000000001}, {57.88, 95.68}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7451, 0., 0.2549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{57.879999999999995`, 
         95.67999999999999}, {47.8, 96.75999999999999}, {43.959999999999994`, 
         82.83999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{57.879999999999995`, 
         95.67999999999999}, {47.8, 96.75999999999999}, {43.959999999999994`, 
         82.83999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7451, 0., 0.2549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{54.760000000000005`, 
         25.36}, {44.92, 27.16}, {49.00000000000001, 17.32}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{54.760000000000005`, 
         25.36}, {44.92, 27.16}, {49.00000000000001, 17.32}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.89412, 0., 0.10588], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{44.92, 27.16}, {
         54.760000000000005`, 25.36}, {52.120000000000005`, 37.72}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{44.92, 27.16}, {
         54.760000000000005`, 25.36}, {52.120000000000005`, 37.72}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.35294, 0., 0.64706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{54.28, 10.12}, {
         45.040000000000006`, 12.639999999999999`}, {51.04, 8.44}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{54.28, 10.12}, {
         45.040000000000006`, 12.639999999999999`}, {51.04, 8.44}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5529400000000001, 0., 0.44706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{45.04, 
         12.639999999999999`}, {54.28, 10.12}, {49., 17.32}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{45.04, 
         12.639999999999999`}, {54.28, 10.12}, {49., 17.32}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.10196000000000001`, 0., 0.8980400000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{46.839999999999996`, 
         125.92}, {56.31999999999999, 126.76}, {63.279999999999994`, 
         131.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{46.839999999999996`, 
         125.92}, {56.31999999999999, 126.76}, {63.279999999999994`, 131.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.10196000000000001`, 0., 0.8980400000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{63.28, 131.08}, {53.8, 
         130.12}, {46.84, 125.92000000000002`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{63.28, 131.08}, {53.8, 
         130.12}, {46.84, 125.92000000000002`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.55686, 0., 0.44314], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{47.8, 96.76}, {
         57.879999999999995`, 95.68}, {63.03999999999999, 108.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{47.8, 96.76}, {
         57.879999999999995`, 95.68}, {63.03999999999999, 108.28}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.55686, 0., 0.44314], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{63.04, 108.28}, {52.96, 
         109.24}, {47.8, 96.76}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{63.04, 108.28}, {52.96, 
         109.24}, {47.8, 96.76}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.55686, 0., 0.44314], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{58.720000000000006`, 
         15.52}, {49.00000000000001, 17.32}, {54.28000000000001, 10.12}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{58.720000000000006`, 
         15.52}, {49.00000000000001, 17.32}, {54.28000000000001, 10.12}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7451, 0., 0.2549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{49., 17.32}, {58.72, 
         15.52}, {54.76, 25.36}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{49., 17.32}, {58.72, 
         15.52}, {54.76, 25.36}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.18431, 0., 0.8156900000000001], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{49.6, 
         119.44000000000001`}, {59.2, 119.32000000000001`}, {65.92, 
         126.76}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{49.6, 
         119.44000000000001`}, {59.2, 119.32000000000001`}, {65.92, 126.76}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.18431, 0., 0.8156900000000001], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{65.92, 126.76}, {56.32, 
         126.76}, {49.6, 119.44000000000001`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{65.92, 126.76}, {56.32, 
         126.76}, {49.6, 119.44000000000001`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.96471, 0., 0.03529399999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{61.839999999999996`, 
         50.32}, {51.03999999999999, 51.64}, {52.12, 37.72}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{61.839999999999996`, 
         50.32}, {51.03999999999999, 51.64}, {52.12, 37.72}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.96471, 0., 0.03529399999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{51.04, 51.64}, {61.84, 
         50.32}, {62.56, 65.2}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{51.04, 51.64}, {61.84, 
         50.32}, {62.56, 65.2}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.96471, 0., 0.03529399999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{62.56, 65.2}, {
         51.760000000000005`, 66.64}, {51.040000000000006`, 51.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{62.56, 65.2}, {
         51.760000000000005`, 66.64}, {51.040000000000006`, 51.64}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.35294, 0., 0.64706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{51.04, 8.44}, {60.28, 
         5.92}, {54.28, 10.12}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{51.04, 8.44}, {60.28, 
         5.92}, {54.28, 10.12}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.88235, 0., 0.11765], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{51.760000000000005`, 
         66.64}, {62.56, 65.2}, {64.84, 80.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{51.760000000000005`, 
         66.64}, {62.56, 65.2}, {64.84, 80.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.88235, 0., 0.11765], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{64.84, 80.08}, {
         54.040000000000006`, 81.52}, {51.760000000000005`, 66.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{64.84, 80.08}, {
         54.040000000000006`, 81.52}, {51.760000000000005`, 66.64}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.88235, 0., 0.11765], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{62.8, 36.28}, {52.12, 
         37.72}, {54.76, 25.36}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{62.8, 36.28}, {52.12, 
         37.72}, {54.76, 25.36}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.96471, 0., 0.03529399999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{52.120000000000005`, 
         37.720000000000006`}, {62.800000000000004`, 36.28000000000001}, {
         61.84, 50.32000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{52.120000000000005`, 
         37.720000000000006`}, {62.800000000000004`, 36.28000000000001}, {
         61.84, 50.32000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.34902, 0., 0.65098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{52.96, 
         109.24000000000001`}, {63.04, 108.28000000000002`}, {
         69.03999999999999, 118.48}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{52.96, 
         109.24000000000001`}, {63.04, 108.28000000000002`}, {
         69.03999999999999, 118.48}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.34902, 0., 0.65098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{69.04, 118.48}, {59.2, 
         119.32000000000001`}, {52.96000000000001, 109.24000000000001`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{69.04, 118.48}, {59.2, 
         119.32000000000001`}, {52.96000000000001, 109.24000000000001`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.06274500000000001, 0., 0.93725], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{70.24000000000001, 
         132.52}, {60.64000000000001, 131.56}, {53.80000000000001, 
         130.12}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{70.24000000000001, 
         132.52}, {60.64000000000001, 131.56}, {53.80000000000001, 130.12}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.06274500000000001, 0., 0.93725], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{53.8, 130.12}, {63.28, 
         131.08}, {70.24, 132.52}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{53.8, 130.12}, {63.28, 
         131.08}, {70.24, 132.52}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.73725, 0., 0.26275], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{54.04, 81.52}, {64.84, 
         80.08}, {68.56, 94.24}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{54.04, 81.52}, {64.84, 
         80.08}, {68.56, 94.24}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.73725, 0., 0.26275], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{68.56, 
         94.24000000000001}, {57.88, 95.68}, {54.040000000000006`, 
         81.52000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{68.56, 
         94.24000000000001}, {57.88, 95.68}, {54.040000000000006`, 
         81.52000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.34902, 0., 0.65098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{63.760000000000005`, 
         8.2}, {54.28, 10.12}, {60.28000000000001, 5.919999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{63.760000000000005`, 
         8.2}, {54.28, 10.12}, {60.28000000000001, 5.919999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.55686, 0., 0.44314], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{54.28, 10.12}, {
         63.760000000000005`, 8.2}, {58.72, 15.52}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{54.28, 10.12}, {
         63.760000000000005`, 8.2}, {58.72, 15.52}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.73725, 0., 0.26275], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{65.2, 24.04}, {
         54.760000000000005`, 25.36}, {58.72, 15.52}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{65.2, 24.04}, {
         54.760000000000005`, 25.36}, {58.72, 15.52}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.88235, 0., 0.11765], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{54.760000000000005`, 
         25.36}, {65.2, 24.04}, {62.800000000000004`, 36.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{54.760000000000005`, 
         25.36}, {65.2, 24.04}, {62.800000000000004`, 36.28}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.066667, 0., 0.93333], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{56.32, 126.76}, {65.92, 
         126.76}, {72.88, 131.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{56.32, 126.76}, {65.92, 
         126.76}, {72.88, 131.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.066667, 0., 0.93333], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{72.88, 131.08}, {
         63.279999999999994`, 131.08}, {56.31999999999999, 
         126.76000000000002`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{72.88, 131.08}, {
         63.279999999999994`, 131.08}, {56.31999999999999, 
         126.76000000000002`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5529400000000001, 0., 0.44706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{57.879999999999995`, 
         95.67999999999999}, {68.56, 94.24}, {73.6, 106.72}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{57.879999999999995`, 
         95.67999999999999}, {68.56, 94.24}, {73.6, 106.72}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5529400000000001, 0., 0.44706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{73.6, 106.72}, {
         63.03999999999999, 108.28}, {57.879999999999995`, 95.68}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{73.6, 106.72}, {
         63.03999999999999, 108.28}, {57.879999999999995`, 95.68}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5529400000000001, 0., 0.44706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{69.04, 14.2}, {
         58.720000000000006`, 15.52}, {63.760000000000005`, 8.2}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{69.04, 14.2}, {
         58.720000000000006`, 15.52}, {63.760000000000005`, 8.2}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.73725, 0., 0.26275], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{58.720000000000006`, 
         15.52}, {69.04, 14.2}, {65.2, 24.04}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{58.720000000000006`, 
         15.52}, {69.04, 14.2}, {65.2, 24.04}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.17255, 0., 0.82745], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{59.2, 119.32}, {69.04, 
         118.47999999999999`}, {75.76, 125.91999999999999`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{59.2, 119.32}, {69.04, 
         118.47999999999999`}, {75.76, 125.91999999999999`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.17255, 0., 0.82745], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{75.76, 125.92}, {65.92, 
         126.76}, {59.2, 119.32000000000001`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{75.76, 125.92}, {65.92, 
         126.76}, {59.2, 119.32000000000001`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.34902, 0., 0.65098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{60.28, 5.92}, {69.64, 
         4.}, {63.76, 8.2}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{60.28, 5.92}, {69.64, 
         4.}, {63.76, 8.2}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.17255, 0., 0.82745], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{69.64, 4.}, {60.28, 
         5.92}, {66.76, 4.48}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{69.64, 4.}, {60.28, 
         5.92}, {66.76, 4.48}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.92549, 0., 0.07451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{73.72, 49.}, {
         61.839999999999996`, 50.32}, {62.8, 36.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{73.72, 49.}, {
         61.839999999999996`, 50.32}, {62.8, 36.28}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.92549, 0., 0.07451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{61.839999999999996`, 
         50.32}, {73.72, 49.}, {74.44, 63.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{61.839999999999996`, 
         50.32}, {73.72, 49.}, {74.44, 63.64}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.92549, 0., 0.07451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{74.44000000000001, 
         63.64}, {62.56000000000001, 65.2}, {61.84000000000001, 50.32}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{74.44000000000001, 
         63.64}, {62.56000000000001, 65.2}, {61.84000000000001, 50.32}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8549000000000001, 0., 0.1451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{62.56, 65.2}, {74.44, 
         63.64}, {76.6, 78.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{62.56, 65.2}, {74.44, 
         63.64}, {76.6, 78.28}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8549000000000001, 0., 0.1451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{76.6, 78.28}, {
         64.83999999999999, 80.08}, {62.559999999999995`, 65.2}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{76.6, 78.28}, {
         64.83999999999999, 80.08}, {62.559999999999995`, 65.2}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8549000000000001, 0., 0.1451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{74.44000000000001, 
         35.32}, {62.80000000000001, 36.28}, {65.20000000000002, 24.04}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{74.44000000000001, 
         35.32}, {62.80000000000001, 36.28}, {65.20000000000002, 24.04}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.92549, 0., 0.07451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{62.8, 36.28}, {74.44, 
         35.32}, {73.72, 49.}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{62.8, 36.28}, {74.44, 
         35.32}, {73.72, 49.}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.35294, 0., 0.64706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{63.04, 108.28}, {73.6, 
         106.72}, {79.47999999999999, 117.04}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{63.04, 108.28}, {73.6, 
         106.72}, {79.47999999999999, 117.04}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.35294, 0., 0.64706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{79.48, 117.04}, {69.04, 
         118.48}, {63.040000000000006`, 108.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{79.48, 117.04}, {69.04, 
         118.48}, {63.040000000000006`, 108.28}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.023528999999999998`, 0., 0.97647], Opacity[1.]}],
         FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{63.28, 131.08}, {72.88, 
         131.08}, {79.72, 132.52}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{63.28, 131.08}, {72.88, 
         131.08}, {79.72, 132.52}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.023528999999999998`, 0., 0.97647], Opacity[1.]}],
         FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{79.72, 132.52}, {70.24, 
         132.52}, {63.28, 131.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{79.72, 132.52}, {70.24, 
         132.52}, {63.28, 131.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.35294, 0., 0.64706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{73.96000000000001, 7.}, {
         63.760000000000005`, 8.2}, {69.64000000000001, 4.}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{73.96000000000001, 7.}, {
         63.760000000000005`, 8.2}, {69.64000000000001, 4.}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5529400000000001, 0., 0.44706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{63.760000000000005`, 
         8.2}, {73.96000000000001, 6.999999999999999}, {69.04, 14.2}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{63.760000000000005`, 
         8.2}, {73.96000000000001, 6.999999999999999}, {69.04, 14.2}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.71765, 0., 0.28235000000000005`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{64.84, 80.08}, {
         76.60000000000001, 78.28}, {80.32000000000001, 92.2}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{64.84, 80.08}, {
         76.60000000000001, 78.28}, {80.32000000000001, 92.2}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.71765, 0., 0.28235000000000005`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{80.32, 92.2}, {
         68.55999999999999, 94.24000000000001}, {64.83999999999999, 
         80.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{80.32, 92.2}, {
         68.55999999999999, 94.24000000000001}, {64.83999999999999, 80.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.71765, 0., 0.28235000000000005`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{76.84, 23.32}, {65.2, 
         24.04}, {69.04, 14.200000000000001`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{76.84, 23.32}, {65.2, 
         24.04}, {69.04, 14.200000000000001`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8549000000000001, 0., 0.1451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{65.2, 24.04}, {76.84, 
         23.32}, {74.44, 35.32}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{65.2, 24.04}, {76.84, 
         23.32}, {74.44, 35.32}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.054902000000000006`, 0., 0.9451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{65.92, 126.76}, {75.76, 
         125.92}, {82.48, 130.48000000000002`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{65.92, 126.76}, {75.76, 
         125.92}, {82.48, 130.48000000000002`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.054902000000000006`, 0., 0.9451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{82.48, 
         130.48000000000002`}, {72.88000000000001, 131.08}, {65.92, 
         126.76000000000002`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{82.48, 
         130.48000000000002`}, {72.88000000000001, 131.08}, {65.92, 
         126.76000000000002`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.17255, 0., 0.82745], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{66.76, 4.48}, {76., 
         2.6800000000000006`}, {69.64, 4.}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{66.76, 4.48}, {76., 
         2.6800000000000006`}, {69.64, 4.}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5451, 0., 0.4549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{68.56, 
         94.24000000000001}, {80.32000000000001, 92.2}, {85.12, 104.56}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{68.56, 
         94.24000000000001}, {80.32000000000001, 92.2}, {85.12, 104.56}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5451, 0., 0.4549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{85.11999999999999, 
         104.56}, {73.6, 106.72}, {68.55999999999999, 94.24000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{85.11999999999999, 
         104.56}, {73.6, 106.72}, {68.55999999999999, 94.24000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.18431, 0., 0.8156900000000001], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{69.04, 118.48}, {79.48, 
         117.04}, {85.96000000000001, 124.48}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{69.04, 118.48}, {79.48, 
         117.04}, {85.96000000000001, 124.48}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.18431, 0., 0.8156900000000001], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{85.96000000000001, 
         124.48}, {75.76, 125.92}, {69.04, 118.48}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{85.96000000000001, 
         124.48}, {75.76, 125.92}, {69.04, 118.48}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5451, 0., 0.4549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{80.32, 13.6}, {
         69.03999999999999, 14.2}, {73.96, 7.}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{80.32, 13.6}, {
         69.03999999999999, 14.2}, {73.96, 7.}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.71765, 0., 0.28235000000000005`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{69.04, 14.2}, {
         80.32000000000001, 13.6}, {76.84, 23.32}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{69.04, 14.2}, {
         80.32000000000001, 13.6}, {76.84, 23.32}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.35294, 0., 0.64706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{69.64, 4.}, {79.6, 
         2.6799999999999997`}, {73.96, 7.}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{69.64, 4.}, {79.6, 
         2.6799999999999997`}, {73.96, 7.}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.18431, 0., 0.8156900000000001], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{79.6, 2.68}, {
         69.63999999999999, 4.}, {76., 2.68}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{79.6, 2.68}, {
         69.63999999999999, 4.}, {76., 2.68}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.011764999999999998`, 0., 0.98824], Opacity[1.]}],
         FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{72.88, 131.08}, {
         82.47999999999999, 130.48000000000002`}, {89.19999999999999, 
         131.92000000000002`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{72.88, 131.08}, {
         82.47999999999999, 130.48000000000002`}, {89.19999999999999, 
         131.92000000000002`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.011764999999999998`, 0., 0.98824], Opacity[1.]}],
         FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{89.2, 
         131.92000000000002`}, {79.72, 132.52}, {72.88, 131.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{89.2, 
         131.92000000000002`}, {79.72, 132.52}, {72.88, 131.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{73.6, 106.72}, {
         85.11999999999999, 104.56}, {90.63999999999999, 114.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{73.6, 106.72}, {
         85.11999999999999, 104.56}, {90.63999999999999, 114.64}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{90.64, 114.64}, {79.48, 
         117.04}, {73.6, 106.72}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{90.64, 114.64}, {79.48, 
         117.04}, {73.6, 106.72}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8705900000000001, 0., 0.12941000000000003`], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{86.67999999999999, 
         48.04}, {73.72, 49.}, {74.44, 35.32}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{86.67999999999999, 
         48.04}, {73.72, 49.}, {74.44, 35.32}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8705900000000001, 0., 0.12941000000000003`], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{73.72, 49.}, {86.68, 
         48.04}, {87.4, 62.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{73.72, 49.}, {86.68, 
         48.04}, {87.4, 62.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8705900000000001, 0., 0.12941000000000003`], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{87.4, 62.08}, {74.44, 
         63.64}, {73.72, 49.}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{87.4, 62.08}, {74.44, 
         63.64}, {73.72, 49.}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{84.88, 6.52}, {73.96, 
         7.}, {79.6, 2.6799999999999997`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{84.88, 6.52}, {73.96, 
         7.}, {79.6, 2.6799999999999997`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5451, 0., 0.4549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{73.96000000000001, 7.}, {
         84.88000000000001, 6.52}, {80.32000000000001, 13.6}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{73.96000000000001, 7.}, {
         84.88000000000001, 6.52}, {80.32000000000001, 13.6}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8078400000000001, 0., 0.19216], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{74.44000000000001, 
         63.64}, {87.4, 62.08}, {89.68, 76.12}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{74.44000000000001, 
         63.64}, {87.4, 62.08}, {89.68, 76.12}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8078400000000001, 0., 0.19216], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{89.67999999999999, 
         76.11999999999999}, {76.6, 78.27999999999999}, {74.44, 
         63.639999999999986`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{89.67999999999999, 
         76.11999999999999}, {76.6, 78.27999999999999}, {74.44, 
         63.639999999999986`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8078400000000001, 0., 0.19216], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{87.4, 34.96}, {74.44, 
         35.32}, {76.84, 23.32}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{87.4, 34.96}, {74.44, 
         35.32}, {76.84, 23.32}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8705900000000001, 0., 0.12941000000000003`], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{74.44000000000001, 
         35.32}, {87.4, 34.96}, {86.68, 48.04}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{74.44000000000001, 
         35.32}, {87.4, 34.96}, {86.68, 48.04}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.066667, 0., 0.93333], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{75.76, 125.92}, {
         85.96000000000001, 124.48}, {92.56, 129.04}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{75.76, 125.92}, {
         85.96000000000001, 124.48}, {92.56, 129.04}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.066667, 0., 0.93333], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{92.56, 129.04}, {82.48, 
         130.48}, {75.76, 125.91999999999999`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{92.56, 129.04}, {82.48, 
         130.48}, {75.76, 125.91999999999999`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.18431, 0., 0.8156900000000001], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{76., 2.68}, {85.6, 
         1.36}, {79.6, 2.68}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{76., 2.68}, {85.6, 
         1.36}, {79.6, 2.68}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.6901999999999999, 0., 0.3098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{76.6, 78.28}, {
         89.67999999999999, 76.12}, {93.03999999999999, 89.44}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{76.6, 78.28}, {
         89.67999999999999, 76.12}, {93.03999999999999, 89.44}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.6901999999999999, 0., 0.3098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{93.04, 
         89.44000000000001}, {80.32000000000001, 92.20000000000002}, {
         76.60000000000001, 78.28000000000002}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{93.04, 
         89.44000000000001}, {80.32000000000001, 92.20000000000002}, {
         76.60000000000001, 78.28000000000002}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.6901999999999999, 0., 0.3098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{89.32, 23.56}, {
         76.83999999999999, 23.32}, {80.32, 13.599999999999998`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{89.32, 23.56}, {
         76.83999999999999, 23.32}, {80.32, 13.599999999999998`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8078400000000001, 0., 0.19216], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{76.84, 23.32}, {
         89.32000000000001, 23.56}, {87.4, 34.96}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{76.84, 23.32}, {
         89.32000000000001, 23.56}, {87.4, 34.96}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.20784000000000002`, 0., 0.7921599999999999], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{79.48, 117.04}, {90.64, 
         114.64}, {96.76, 122.08000000000001`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{79.48, 117.04}, {90.64, 
         114.64}, {96.76, 122.08000000000001`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.20784000000000002`, 0., 0.7921599999999999], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{96.76, 122.08}, {
         85.96000000000001, 124.48}, {79.48, 117.03999999999999`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{96.76, 122.08}, {
         85.96000000000001, 124.48}, {79.48, 117.03999999999999`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{79.6, 2.68}, {90.16, 
         2.44}, {84.88, 6.52}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{79.6, 2.68}, {90.16, 
         2.44}, {84.88, 6.52}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.20784000000000002`, 0., 0.7921599999999999], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{90.16, 2.44}, {79.6, 
         2.68}, {85.6, 1.3599999999999999`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{90.16, 2.44}, {79.6, 
         2.68}, {85.6, 1.3599999999999999`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53725, 0., 0.46275], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{80.32, 92.2}, {
         93.03999999999999, 89.44}, {97.47999999999999, 
         101.32000000000001`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{80.32, 92.2}, {
         93.03999999999999, 89.44}, {97.47999999999999, 101.32000000000001`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53725, 0., 0.46275], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{97.48, 101.32}, {85.12, 
         104.55999999999999`}, {80.32000000000001, 92.19999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{97.48, 101.32}, {85.12, 
         104.55999999999999`}, {80.32000000000001, 92.19999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53725, 0., 0.46275], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{92.56, 14.2}, {
         80.32000000000001, 13.6}, {84.88, 6.52}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{92.56, 14.2}, {
         80.32000000000001, 13.6}, {84.88, 6.52}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.6901999999999999, 0., 0.3098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{80.32, 13.6}, {
         92.55999999999999, 14.2}, {89.32, 23.560000000000002`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{80.32, 13.6}, {
         92.55999999999999, 14.2}, {89.32, 23.560000000000002`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.023528999999999998`, 0., 0.97647], Opacity[1.]}],
         FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{82.48, 
         130.48000000000002`}, {92.56, 129.04000000000002`}, {99.04, 
         130.60000000000002`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{82.48, 
         130.48000000000002`}, {92.56, 129.04000000000002`}, {99.04, 
         130.60000000000002`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.023528999999999998`, 0., 0.97647], Opacity[1.]}],
         FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{99.04, 130.6}, {89.2, 
         131.92}, {82.48, 130.48}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{99.04, 130.6}, {89.2, 
         131.92}, {82.48, 130.48}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.38431000000000004`, 0., 0.6156900000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{96.76, 
         7.359999999999999}, {84.88000000000001, 6.52}, {90.16000000000001, 
         2.4399999999999995`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{96.76, 
         7.359999999999999}, {84.88000000000001, 6.52}, {90.16000000000001, 
         2.4399999999999995`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53725, 0., 0.46275], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{84.88, 6.52}, {
         96.75999999999999, 7.359999999999999}, {92.56, 14.2}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{84.88, 6.52}, {
         96.75999999999999, 7.359999999999999}, {92.56, 14.2}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.38431000000000004`, 0., 0.6156900000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{85.11999999999999, 
         104.56}, {97.47999999999999, 101.32000000000001`}, {
         102.63999999999999`, 111.04}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{85.11999999999999, 
         104.56}, {97.47999999999999, 101.32000000000001`}, {
         102.63999999999999`, 111.04}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.38431000000000004`, 0., 0.6156900000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{102.64, 111.04}, {90.64, 
         114.64}, {85.12, 104.56}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{102.64, 111.04}, {90.64, 
         114.64}, {85.12, 104.56}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.20784000000000002`, 0., 0.7921599999999999], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{85.6, 1.36}, {
         95.91999999999999, 1.12}, {90.16, 2.4400000000000004`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{85.6, 1.36}, {
         95.91999999999999, 1.12}, {90.16, 2.4400000000000004`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.10196000000000001`, 0., 0.8980400000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{85.96000000000001, 
         124.48}, {96.76, 122.08}, {103.12, 126.52000000000001`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{85.96000000000001, 
         124.48}, {96.76, 122.08}, {103.12, 126.52000000000001`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.10196000000000001`, 0., 0.8980400000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{103.11999999999999`, 
         126.52}, {92.55999999999999, 129.04}, {85.96, 
         124.47999999999999`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{103.11999999999999`, 
         126.52}, {92.55999999999999, 129.04}, {85.96, 124.47999999999999`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8, 0., 0.2], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{100.84, 47.68}, {86.68, 
         48.04}, {87.4, 34.96}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{100.84, 47.68}, {86.68, 
         48.04}, {87.4, 34.96}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8, 0., 0.2], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{86.67999999999999, 
         48.04}, {100.83999999999999`, 47.68}, {101.55999999999999`, 
         60.519999999999996`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{86.67999999999999, 
         48.04}, {100.83999999999999`, 47.68}, {101.55999999999999`, 
         60.519999999999996`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8, 0., 0.2], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{101.56, 60.52}, {87.4, 
         62.080000000000005`}, {86.68, 48.040000000000006`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{101.56, 60.52}, {87.4, 
         62.080000000000005`}, {86.68, 48.040000000000006`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7451, 0., 0.2549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{101.32, 35.56}, {
         87.39999999999999, 34.96}, {89.32, 23.560000000000002`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{101.32, 35.56}, {
         87.39999999999999, 34.96}, {89.32, 23.560000000000002`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8, 0., 0.2], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{87.4, 34.96}, {
         101.32000000000001`, 35.56}, {100.84, 47.68}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{87.4, 34.96}, {
         101.32000000000001`, 35.56}, {100.84, 47.68}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7451, 0., 0.2549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{87.4, 62.08}, {101.56, 
         60.519999999999996`}, {103.60000000000001`, 73.48}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{87.4, 62.08}, {101.56, 
         60.519999999999996`}, {103.60000000000001`, 73.48}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7451, 0., 0.2549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{103.6, 73.48}, {
         89.67999999999999, 76.12}, {87.39999999999999, 
         62.080000000000005`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{103.6, 73.48}, {
         89.67999999999999, 76.12}, {87.39999999999999, 62.080000000000005`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.65098, 0., 0.34902], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{103., 25.}, {89.32, 
         23.56}, {92.56, 14.2}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{103., 25.}, {89.32, 
         23.56}, {92.56, 14.2}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7451, 0., 0.2549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{89.32, 23.56}, {103., 
         25.}, {101.32, 35.56}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{89.32, 23.56}, {103., 
         25.}, {101.32, 35.56}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.65098, 0., 0.34902], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{89.67999999999999, 
         76.11999999999999}, {103.6, 73.47999999999999}, {106.6, 
         85.83999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{89.67999999999999, 
         76.11999999999999}, {103.6, 73.47999999999999}, {106.6, 
         85.83999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.65098, 0., 0.34902], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{106.6, 85.84}, {
         93.03999999999999, 89.44}, {89.67999999999999, 76.12}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{106.6, 85.84}, {
         93.03999999999999, 89.44}, {89.67999999999999, 76.12}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.38431000000000004`, 0., 0.6156900000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{90.16, 2.44}, {101.56, 
         3.2800000000000002`}, {96.75999999999999, 7.359999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{90.16, 2.44}, {101.56, 
         3.2800000000000002`}, {96.75999999999999, 7.359999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.24706000000000003`, 0., 0.75294], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{101.56, 
         3.2800000000000002`}, {90.16, 2.4400000000000004`}, {95.92, 
         1.12}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{101.56, 
         3.2800000000000002`}, {90.16, 2.4400000000000004`}, {95.92, 1.12}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.24706000000000003`, 0., 0.75294], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{90.64, 114.64}, {102.64, 
         111.04}, {108.28, 118.24}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{90.64, 114.64}, {102.64, 
         111.04}, {108.28, 118.24}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.24706000000000003`, 0., 0.75294], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{108.28, 
         118.24000000000001`}, {96.76, 122.08000000000001`}, {90.64, 
         114.64000000000001`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{108.28, 
         118.24000000000001`}, {96.76, 122.08000000000001`}, {90.64, 
         114.64000000000001`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.06274500000000001, 0., 0.93725], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{92.56, 129.04}, {103.12, 
         126.52}, {109.24000000000001`, 128.07999999999998`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{92.56, 129.04}, {103.12, 
         126.52}, {109.24000000000001`, 128.07999999999998`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.06274500000000001, 0., 0.93725], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{109.24000000000001`, 
         128.08}, {99.04, 130.60000000000002`}, {92.56, 
         129.04000000000002`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{109.24000000000001`, 
         128.08}, {99.04, 130.60000000000002`}, {92.56, 129.04000000000002`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53333, 0., 0.46667000000000003`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{105.76, 16.24}, {92.56, 
         14.2}, {96.76, 7.359999999999998}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{105.76, 16.24}, {92.56, 
         14.2}, {96.76, 7.359999999999998}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.65098, 0., 0.34902], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{92.56, 14.2}, {105.76, 
         16.24}, {103., 25.}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{92.56, 14.2}, {105.76, 
         16.24}, {103., 25.}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53333, 0., 0.46667000000000003`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{93.04, 
         89.44000000000001}, {106.60000000000001`, 85.84000000000002}, {
         110.56, 96.76}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{93.04, 
         89.44000000000001}, {106.60000000000001`, 85.84000000000002}, {
         110.56, 96.76}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53333, 0., 0.46667000000000003`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{110.56, 96.76}, {97.48, 
         101.32000000000001`}, {93.04, 89.44000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{110.56, 96.76}, {97.48, 
         101.32000000000001`}, {93.04, 89.44000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.24706000000000003`, 0., 0.75294], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{95.92, 1.12}, {106.84, 
         2.08}, {101.56, 3.2800000000000002`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{95.92, 1.12}, {106.84, 
         2.08}, {101.56, 3.2800000000000002`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.40392000000000006`, 0., 0.5960799999999999], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{109.36, 10.}, {96.76, 
         7.359999999999999}, {101.56, 3.2800000000000002`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{109.36, 10.}, {96.76, 
         7.359999999999999}, {101.56, 3.2800000000000002`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53333, 0., 0.46667000000000003`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{96.76, 
         7.359999999999999}, {109.36, 10.}, {105.76, 16.240000000000002`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{96.76, 
         7.359999999999999}, {109.36, 10.}, {105.76, 16.240000000000002`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.15294000000000005`, 0., 0.84706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{96.76, 122.08}, {108.28, 
         118.24}, {114.16, 122.67999999999999`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{96.76, 122.08}, {108.28, 
         118.24}, {114.16, 122.67999999999999`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.15294000000000005`, 0., 0.84706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{114.16, 
         122.67999999999999`}, {103.12, 126.52}, {96.75999999999999, 
         122.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{114.16, 
         122.67999999999999`}, {103.12, 126.52}, {96.75999999999999, 122.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.40392000000000006`, 0., 0.5960799999999999], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{97.48, 101.32}, {110.56, 
         96.75999999999999}, {115.24000000000001`, 105.75999999999999`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{97.48, 101.32}, {110.56, 
         96.75999999999999}, {115.24000000000001`, 105.75999999999999`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.40392000000000006`, 0., 0.5960799999999999], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{115.24000000000001`, 
         105.76}, {102.64000000000001`, 111.04}, {97.48000000000002, 
         101.32000000000001`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{115.24000000000001`, 
         105.76}, {102.64000000000001`, 111.04}, {97.48000000000002, 
         101.32000000000001`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.10196000000000001`, 0., 0.8980400000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{99.04, 130.6}, {
         109.24000000000001`, 128.07999999999998`}, {114.88000000000001`, 
         126.88}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{99.04, 130.6}, {
         109.24000000000001`, 128.07999999999998`}, {114.88000000000001`, 
         126.88}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.10196000000000001`, 0., 0.8980400000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{114.88, 126.88}, {
         105.03999999999999`, 129.16}, {99.03999999999999, 130.6}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{114.88, 126.88}, {
         105.03999999999999`, 129.16}, {99.03999999999999, 130.6}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7215699999999999, 0., 0.27843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{115.6, 47.92}, {
         100.83999999999999`, 47.68}, {101.32, 35.56}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{115.6, 47.92}, {
         100.83999999999999`, 47.68}, {101.32, 35.56}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7215699999999999, 0., 0.27843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{116.32, 59.08}, {
         101.55999999999999`, 60.519999999999996`}, {100.83999999999999`, 
         47.68}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{116.32, 59.08}, {
         101.55999999999999`, 60.519999999999996`}, {100.83999999999999`, 
         47.68}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7215699999999999, 0., 0.27843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{100.84, 47.68}, {
         115.60000000000001`, 47.92}, {116.32000000000001`, 59.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{100.84, 47.68}, {
         115.60000000000001`, 47.92}, {116.32000000000001`, 59.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.6823499999999999, 0., 0.31765], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{115.96000000000001`, 
         37.36}, {101.32000000000001`, 35.56}, {103., 25.}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{115.96000000000001`, 
         37.36}, {101.32000000000001`, 35.56}, {103., 25.}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7215699999999999, 0., 0.27843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{101.32, 35.56}, {115.96, 
         37.36}, {115.6, 47.92}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{101.32, 35.56}, {115.96, 
         37.36}, {115.6, 47.92}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.29804, 0., 0.7019599999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{113.67999999999999`, 
         6.159999999999999}, {101.55999999999999`, 3.2799999999999994`}, {
         106.83999999999999`, 2.079999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{113.67999999999999`, 
         6.159999999999999}, {101.55999999999999`, 3.2799999999999994`}, {
         106.83999999999999`, 2.079999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.40392000000000006`, 0., 0.5960799999999999], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{101.56, 
         3.2800000000000002`}, {113.68, 6.16}, {109.36, 10.}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{101.56, 
         3.2800000000000002`}, {113.68, 6.16}, {109.36, 10.}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.6823499999999999, 0., 0.31765], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{101.56, 60.52}, {
         116.32000000000001`, 59.080000000000005`}, {118., 70.36}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{101.56, 60.52}, {
         116.32000000000001`, 59.080000000000005`}, {118., 70.36}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.6823499999999999, 0., 0.31765], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{118., 70.36}, {103.6, 
         73.48}, {101.56, 60.519999999999996`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{118., 70.36}, {103.6, 
         73.48}, {101.56, 60.519999999999996`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.29804, 0., 0.7019599999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{102.64, 111.04}, {115.24, 
         105.76}, {120.28, 112.60000000000001`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{102.64, 111.04}, {115.24, 
         105.76}, {120.28, 112.60000000000001`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.29804, 0., 0.7019599999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{120.28, 112.6}, {108.28, 
         118.24}, {102.64, 111.03999999999999`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{120.28, 112.6}, {108.28, 
         118.24}, {102.64, 111.03999999999999`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.61176, 0., 0.38824], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{117.28, 28.12}, {103., 
         25.}, {105.76, 16.240000000000002`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{117.28, 28.12}, {103., 
         25.}, {105.76, 16.240000000000002`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.6823499999999999, 0., 0.31765], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{103., 25.}, {117.28, 
         28.12}, {115.96000000000001`, 37.36}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{103., 25.}, {117.28, 
         28.12}, {115.96000000000001`, 37.36}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.12157000000000001`, 0., 0.87843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{103.11999999999999`, 
         126.52}, {114.16, 122.67999999999999`}, {119.79999999999998`, 
         124.24}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{103.11999999999999`, 
         126.52}, {114.16, 122.67999999999999`}, {119.79999999999998`, 
         124.24}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.12157000000000001`, 0., 0.87843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{119.8, 
         124.24000000000001`}, {109.24, 128.08}, {103.12, 
         126.52000000000001`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{119.8, 
         124.24000000000001`}, {109.24, 128.08}, {103.12, 
         126.52000000000001`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.61176, 0., 0.38824], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{103.6, 73.48}, {118., 
         70.36}, {120.63999999999999`, 81.16}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{103.6, 73.48}, {118., 
         70.36}, {120.63999999999999`, 81.16}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.61176, 0., 0.38824], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{120.64, 81.16}, {106.6, 
         85.84}, {103.6, 73.47999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{120.64, 81.16}, {106.6, 
         85.84}, {103.6, 73.47999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{119.44000000000001`, 
         20.439999999999998`}, {105.76000000000002`, 16.24}, {
         109.36000000000001`, 9.999999999999998}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{119.44000000000001`, 
         20.439999999999998`}, {105.76000000000002`, 16.24}, {
         109.36000000000001`, 9.999999999999998}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.61176, 0., 0.38824], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{105.76, 16.24}, {119.44, 
         20.439999999999998`}, {117.28, 28.119999999999997`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{105.76, 16.24}, {119.44, 
         20.439999999999998`}, {117.28, 28.119999999999997`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{106.6, 85.84}, {
         120.63999999999999`, 81.16}, {124., 90.76}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{106.6, 85.84}, {
         120.63999999999999`, 81.16}, {124., 90.76}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{124., 90.76}, {110.56, 
         96.76}, {106.6, 85.84}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{124., 90.76}, {110.56, 
         96.76}, {106.6, 85.84}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.29804, 0., 0.7019599999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{106.84, 2.08}, {118.36, 
         4.96}, {113.68, 6.16}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{106.84, 2.08}, {118.36, 
         4.96}, {113.68, 6.16}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.22353, 0., 0.77647], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{108.28, 
         118.24000000000001`}, {120.28, 112.60000000000001`}, {125.44, 
         116.68}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{108.28, 
         118.24000000000001`}, {120.28, 112.60000000000001`}, {125.44, 
         116.68}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.22353, 0., 0.77647], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{125.44000000000001`, 
         116.67999999999999`}, {114.16000000000001`, 122.67999999999999`}, {
         108.28000000000002`, 118.24}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{125.44000000000001`, 
         116.67999999999999`}, {114.16000000000001`, 122.67999999999999`}, {
         108.28000000000002`, 118.24}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.15294000000000005`, 0., 0.84706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{125.08, 123.04}, {114.88, 
         126.88000000000001`}, {109.24, 128.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{125.08, 123.04}, {114.88, 
         126.88000000000001`}, {109.24, 128.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.15294000000000005`, 0., 0.84706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{109.24000000000001`, 
         128.08}, {119.80000000000001`, 124.24000000000001`}, {
         125.08000000000001`, 123.04}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{109.24000000000001`, 
         128.08}, {119.80000000000001`, 124.24000000000001`}, {
         125.08000000000001`, 123.04}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.4313700000000001, 0., 0.5686300000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{122.44000000000001`, 
         14.8}, {109.36000000000001`, 10.}, {113.68, 6.160000000000002}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{122.44000000000001`, 
         14.8}, {109.36000000000001`, 10.}, {113.68, 6.160000000000002}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{109.36, 10.}, {122.44, 
         14.8}, {119.44, 20.439999999999998`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{109.36, 10.}, {122.44, 
         14.8}, {119.44, 20.439999999999998`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.4313700000000001, 0., 0.5686300000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{110.56, 96.76}, {124., 
         90.76}, {127.96000000000001`, 98.68}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{110.56, 96.76}, {124., 
         90.76}, {127.96000000000001`, 98.68}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.4313700000000001, 0., 0.5686300000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{127.96000000000001`, 
         98.67999999999999}, {115.24000000000001`, 105.75999999999999`}, {
         110.56, 96.75999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{127.96000000000001`, 
         98.67999999999999}, {115.24000000000001`, 105.75999999999999`}, {
         110.56, 96.75999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.34902, 0., 0.65098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{125.92, 11.44}, {113.68, 
         6.159999999999999}, {118.36, 4.959999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{125.92, 11.44}, {113.68, 
         6.159999999999999}, {118.36, 4.959999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.4313700000000001, 0., 0.5686300000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{113.67999999999999`, 
         6.159999999999999}, {125.91999999999999`, 11.44}, {122.44, 
         14.799999999999997`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{113.67999999999999`, 
         6.159999999999999}, {125.91999999999999`, 11.44}, {122.44, 
         14.799999999999997`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.19608, 0., 0.8039200000000001], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{114.16, 
         122.67999999999999`}, {125.44, 116.67999999999999`}, {130.48, 
         118.24}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{114.16, 
         122.67999999999999`}, {125.44, 116.67999999999999`}, {130.48, 
         118.24}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.19608, 0., 0.8039200000000001], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{130.48000000000002`, 
         118.24000000000001`}, {119.80000000000001`, 124.24000000000001`}, {
         114.16000000000003`, 122.68}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{130.48000000000002`, 
         118.24000000000001`}, {119.80000000000001`, 124.24000000000001`}, {
         114.16000000000003`, 122.68}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.34902, 0., 0.65098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{115.24000000000001`, 
         105.76}, {127.96000000000001`, 98.68}, {132.16, 104.68}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{115.24000000000001`, 
         105.76}, {127.96000000000001`, 98.68}, {132.16, 104.68}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.34902, 0., 0.65098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{132.16, 
         104.67999999999999`}, {120.28, 112.6}, {115.24, 
         105.75999999999999`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{132.16, 
         104.67999999999999`}, {120.28, 112.6}, {115.24, 
         105.75999999999999`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.64314, 0., 0.35686], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{130.12, 49.}, {
         115.60000000000001`, 47.92}, {115.96000000000001`, 37.36}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{130.12, 49.}, {
         115.60000000000001`, 47.92}, {115.96000000000001`, 37.36}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.64314, 0., 0.35686], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{115.6, 47.92}, {130.12, 
         49.}, {130.72, 57.88}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{115.6, 47.92}, {130.12, 
         49.}, {130.72, 57.88}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.64314, 0., 0.35686], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{130.72, 
         57.879999999999995`}, {116.32, 59.08}, {115.6, 
         47.919999999999995`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{130.72, 
         57.879999999999995`}, {116.32, 59.08}, {115.6, 47.919999999999995`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.61961, 0., 0.38039], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{130.36, 40.48}, {
         115.96000000000001`, 37.36}, {117.28000000000002`, 
         28.119999999999997`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{130.36, 40.48}, {
         115.96000000000001`, 37.36}, {117.28000000000002`, 
         28.119999999999997`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.64314, 0., 0.35686], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{115.96000000000001`, 
         37.36}, {130.36, 40.48}, {130.12, 49.}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{115.96000000000001`, 
         37.36}, {130.36, 40.48}, {130.12, 49.}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.61961, 0., 0.38039], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{116.32, 59.08}, {130.72, 
         57.879999999999995`}, {132.04, 67.}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{116.32, 59.08}, {130.72, 
         57.879999999999995`}, {132.04, 67.}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.61961, 0., 0.38039], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{132.04, 67.}, {118., 
         70.36}, {116.32, 59.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{132.04, 67.}, {118., 
         70.36}, {116.32, 59.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.57255, 0., 0.42745000000000005`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{131.32000000000002`, 
         33.04}, {117.28000000000003`, 28.119999999999997`}, {
         119.44000000000003`, 20.439999999999998`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{131.32000000000002`, 
         33.04}, {117.28000000000003`, 28.119999999999997`}, {
         119.44000000000003`, 20.439999999999998`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.61961, 0., 0.38039], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{117.28, 28.12}, {131.32, 
         33.04}, {130.36, 40.480000000000004`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{117.28, 28.12}, {131.32, 
         33.04}, {130.36, 40.480000000000004`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.57255, 0., 0.42745000000000005`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{118., 70.36}, {132.04, 
         67.}, {134.2, 75.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{118., 70.36}, {132.04, 
         67.}, {134.2, 75.64}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.57255, 0., 0.42745000000000005`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{134.2, 75.64}, {
         120.63999999999999`, 81.16}, {117.99999999999999`, 70.36}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{134.2, 75.64}, {
         120.63999999999999`, 81.16}, {117.99999999999999`, 70.36}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.29412000000000005`, 0., 0.70588], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{129.88000000000002`, 
         10.239999999999998`}, {118.36000000000003`, 4.959999999999998}, {
         123.16000000000003`, 6.2799999999999985`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{129.88000000000002`, 
         10.239999999999998`}, {118.36000000000003`, 4.959999999999998}, {
         123.16000000000003`, 6.2799999999999985`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.34902, 0., 0.65098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{118.36, 4.96}, {129.88, 
         10.24}, {125.92, 11.440000000000001`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{118.36, 4.96}, {129.88, 
         10.24}, {125.92, 11.440000000000001`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.51765, 0., 0.48235000000000006`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{132.88000000000002`, 
         26.8}, {119.44000000000003`, 20.44}, {122.44000000000003`, 14.8}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{132.88000000000002`, 
         26.8}, {119.44000000000003`, 20.44}, {122.44000000000003`, 14.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.57255, 0., 0.42745000000000005`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{119.44000000000001`, 
         20.439999999999998`}, {132.88000000000002`, 26.799999999999997`}, {
         131.32000000000002`, 33.04}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{119.44000000000001`, 
         20.439999999999998`}, {132.88000000000002`, 26.799999999999997`}, {
         131.32000000000002`, 33.04}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.22353, 0., 0.77647], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{135.16, 117.4}, {125.08, 
         123.04}, {119.8, 124.24000000000001`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{135.16, 117.4}, {125.08, 
         123.04}, {119.8, 124.24000000000001`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.22353, 0., 0.77647], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{119.8, 
         124.24000000000001`}, {130.48, 118.24000000000001`}, {135.16, 
         117.4}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{119.8, 
         124.24000000000001`}, {130.48, 118.24000000000001`}, {135.16, 
         117.4}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.29412000000000005`, 0., 0.70588], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{120.28, 112.6}, {132.16, 
         104.67999999999999`}, {136.48, 108.52}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{120.28, 112.6}, {132.16, 
         104.67999999999999`}, {136.48, 108.52}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.29412000000000005`, 0., 0.70588], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{136.48000000000002`, 
         108.52}, {125.44000000000003`, 116.67999999999999`}, {
         120.28000000000002`, 112.6}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{136.48000000000002`, 
         108.52}, {125.44000000000003`, 116.67999999999999`}, {
         120.28000000000002`, 112.6}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.51765, 0., 0.48235000000000006`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{120.64, 81.16}, {134.2, 
         75.64}, {136.72, 83.32}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{120.64, 81.16}, {134.2, 
         75.64}, {136.72, 83.32}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.51765, 0., 0.48235000000000006`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{136.72, 83.32}, {124., 
         90.75999999999999}, {120.64, 81.16}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{136.72, 83.32}, {124., 
         90.75999999999999}, {120.64, 81.16}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.4549, 0., 0.5451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{135.16, 22.24}, {122.44, 
         14.799999999999997`}, {125.92, 11.439999999999998`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{135.16, 22.24}, {122.44, 
         14.799999999999997`}, {125.92, 11.439999999999998`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.51765, 0., 0.48235000000000006`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{122.44000000000001`, 
         14.8}, {135.16000000000003`, 22.240000000000002`}, {
         132.88000000000002`, 26.8}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{122.44000000000001`, 
         14.8}, {135.16000000000003`, 22.240000000000002`}, {
         132.88000000000002`, 26.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.29412000000000005`, 0., 0.70588], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{123.16, 6.28}, {133.96, 
         11.32}, {129.88, 10.24}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{123.16, 6.28}, {133.96, 
         11.32}, {129.88, 10.24}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.4549, 0., 0.5451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{124., 90.76}, {136.72, 
         83.32000000000001}, {139.72, 89.80000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{124., 90.76}, {136.72, 
         83.32000000000001}, {139.72, 89.80000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.4549, 0., 0.5451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{139.72, 89.8}, {127.96, 
         98.67999999999999}, {124., 90.75999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{139.72, 89.8}, {127.96, 
         98.67999999999999}, {124., 90.75999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.27451000000000003`, 0., 0.72549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{125.44000000000001`, 
         116.67999999999999`}, {136.48000000000002`, 108.52}, {140.68, 
         110.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{125.44000000000001`, 
         116.67999999999999`}, {136.48000000000002`, 108.52}, {140.68, 
         110.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.27451000000000003`, 0., 0.72549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{140.68, 110.08}, {
         130.48000000000002`, 118.24}, {125.44000000000001`, 
         116.67999999999999`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{140.68, 110.08}, {
         130.48000000000002`, 118.24}, {125.44000000000001`, 
         116.67999999999999`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.39608000000000004`, 0., 0.60392], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{137.8, 19.36}, {
         125.92000000000002`, 11.44}, {129.88000000000002`, 10.24}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{137.8, 19.36}, {
         125.92000000000002`, 11.44}, {129.88000000000002`, 10.24}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.4549, 0., 0.5451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{125.92, 11.44}, {137.8, 
         19.36}, {135.16, 22.240000000000002`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{125.92, 11.44}, {137.8, 
         19.36}, {135.16, 22.240000000000002`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.39608000000000004`, 0., 0.60392], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{127.96000000000001`, 
         98.67999999999999}, {139.72, 89.8}, {142.96, 94.72}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{127.96000000000001`, 
         98.67999999999999}, {139.72, 89.8}, {142.96, 94.72}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.39608000000000004`, 0., 0.60392], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{142.96, 94.72}, {132.16, 
         104.68}, {127.96000000000001`, 98.67999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{142.96, 94.72}, {132.16, 
         104.68}, {127.96000000000001`, 98.67999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{140.8, 
         18.279999999999998`}, {129.88000000000002`, 10.239999999999998`}, {
         133.96, 11.319999999999997`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{140.8, 
         18.279999999999998`}, {129.88000000000002`, 10.239999999999998`}, {
         133.96, 11.319999999999997`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.39608000000000004`, 0., 0.60392], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{129.88000000000002`, 
         10.239999999999998`}, {140.8, 18.279999999999998`}, {137.8, 
         19.36}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{129.88000000000002`, 
         10.239999999999998`}, {140.8, 18.279999999999998`}, {137.8, 19.36}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.58039, 0., 0.41961000000000004`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{143.32000000000002`, 
         50.8}, {130.12000000000003`, 49.}, {130.36, 40.48}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{143.32000000000002`, 
         50.8}, {130.12000000000003`, 49.}, {130.36, 40.48}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.58039, 0., 0.41961000000000004`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{130.12, 49.}, {143.32, 
         50.8}, {143.8, 57.04}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{130.12, 49.}, {143.32, 
         50.8}, {143.8, 57.04}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.58039, 0., 0.41961000000000004`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{143.8, 57.04}, {130.72, 
         57.88}, {130.12, 49.}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{143.8, 57.04}, {130.72, 
         57.88}, {130.12, 49.}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.56471, 0., 0.43529], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{143.32000000000002`, 
         44.92}, {130.36, 40.480000000000004`}, {131.32000000000002`, 
         33.04}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{143.32000000000002`, 
         44.92}, {130.36, 40.480000000000004`}, {131.32000000000002`, 33.04}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.58039, 0., 0.41961000000000004`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{130.36, 40.48}, {
         143.32000000000002`, 44.919999999999995`}, {143.32000000000002`, 
         50.8}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{130.36, 40.48}, {
         143.32000000000002`, 44.919999999999995`}, {143.32000000000002`, 
         50.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.29412000000000005`, 0., 0.70588], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{144.64, 109.36}, {135.16, 
         117.4}, {130.48, 118.24}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{144.64, 109.36}, {135.16, 
         117.4}, {130.48, 118.24}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.29412000000000005`, 0., 0.70588], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{130.48000000000002`, 
         118.24000000000001`}, {140.68, 110.08000000000001`}, {
         144.64000000000001`, 109.36000000000001`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{130.48000000000002`, 
         118.24000000000001`}, {140.68, 110.08000000000001`}, {
         144.64000000000001`, 109.36000000000001`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.56471, 0., 0.43529], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{130.72, 
         57.879999999999995`}, {143.8, 57.03999999999999}, {144.64, 
         63.39999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{130.72, 
         57.879999999999995`}, {143.8, 57.03999999999999}, {144.64, 
         63.39999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.56471, 0., 0.43529], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{144.64, 63.4}, {132.04, 
         67.}, {130.72, 57.879999999999995`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{144.64, 63.4}, {132.04, 
         67.}, {130.72, 57.879999999999995`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.54118, 0., 0.45882000000000006`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{143.92000000000002`, 
         39.760000000000005`}, {131.32000000000002`, 33.040000000000006`}, {
         132.88000000000002`, 26.800000000000004`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{143.92000000000002`, 
         39.760000000000005`}, {131.32000000000002`, 33.040000000000006`}, {
         132.88000000000002`, 26.800000000000004`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.56471, 0., 0.43529], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{131.32000000000002`, 
         33.04}, {143.92000000000002`, 39.76}, {143.32000000000002`, 
         44.92}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{131.32000000000002`, 
         33.04}, {143.92000000000002`, 39.76}, {143.32000000000002`, 44.92}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.54118, 0., 0.45882000000000006`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{132.04, 67.}, {144.64, 
         63.4}, {145.95999999999998`, 69.4}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{132.04, 67.}, {144.64, 
         63.4}, {145.95999999999998`, 69.4}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.54118, 0., 0.45882000000000006`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{145.96, 69.4}, {
         134.20000000000002`, 75.64}, {132.04000000000002`, 67.}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{145.96, 69.4}, {
         134.20000000000002`, 75.64}, {132.04000000000002`, 67.}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{132.16, 
         104.67999999999999`}, {142.96, 94.72}, {146.32, 97.96}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{132.16, 
         104.67999999999999`}, {142.96, 94.72}, {146.32, 97.96}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{146.32000000000002`, 
         97.96000000000001}, {136.48000000000002`, 108.52000000000001`}, {
         132.16000000000003`, 104.68}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{146.32000000000002`, 
         97.96000000000001}, {136.48000000000002`, 108.52000000000001`}, {
         132.16000000000003`, 104.68}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.51373, 0., 0.48627000000000004`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{145., 35.32}, {132.88, 
         26.8}, {135.16, 22.240000000000002`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{145., 35.32}, {132.88, 
         26.8}, {135.16, 22.240000000000002`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.54118, 0., 0.45882000000000006`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{132.88000000000002`, 
         26.8}, {145.00000000000003`, 35.32}, {143.92000000000002`, 
         39.760000000000005`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{132.88000000000002`, 
         26.8}, {145.00000000000003`, 35.32}, {143.92000000000002`, 
         39.760000000000005`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.35294, 0., 0.64706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{144.04, 19.}, {
         133.95999999999998`, 11.32}, {138.04, 14.32}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{144.04, 19.}, {
         133.95999999999998`, 11.32}, {138.04, 14.32}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{133.96, 11.32}, {
         144.04000000000002`, 19.}, {140.8, 18.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{133.96, 11.32}, {
         144.04000000000002`, 19.}, {140.8, 18.28}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.51373, 0., 0.48627000000000004`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{134.2, 75.64}, {
         145.95999999999998`, 69.4}, {147.76, 74.68}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{134.2, 75.64}, {
         145.95999999999998`, 69.4}, {147.76, 74.68}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.51373, 0., 0.48627000000000004`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{147.76, 
         74.67999999999999}, {136.72, 83.32}, {134.2, 75.63999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{147.76, 
         74.67999999999999}, {136.72, 83.32}, {134.2, 75.63999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47451000000000004`, 0., 0.52549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{146.44, 32.08}, {135.16, 
         22.24}, {137.8, 19.36}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{146.44, 32.08}, {135.16, 
         22.24}, {137.8, 19.36}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.51373, 0., 0.48627000000000004`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{135.16, 22.24}, {146.44, 
         32.08}, {145., 35.32}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{135.16, 22.24}, {146.44, 
         32.08}, {145., 35.32}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.34902, 0., 0.65098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{148.12, 106.48}, {139.24, 
         114.04}, {135.16, 117.4}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{148.12, 106.48}, {139.24, 
         114.04}, {135.16, 117.4}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.34902, 0., 0.65098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{135.16, 117.4}, {144.64, 
         109.36000000000001`}, {148.12, 106.48}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{135.16, 117.4}, {144.64, 
         109.36000000000001`}, {148.12, 106.48}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.35294, 0., 0.64706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{136.48000000000002`, 
         108.52}, {146.32000000000002`, 97.96}, {149.68, 99.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{136.48000000000002`, 
         108.52}, {146.32000000000002`, 97.96}, {149.68, 99.28}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.35294, 0., 0.64706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{149.68, 99.28}, {140.68, 
         110.08}, {136.48000000000002`, 108.52}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{149.68, 99.28}, {140.68, 
         110.08}, {136.48000000000002`, 108.52}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47451000000000004`, 0., 0.52549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{136.72, 83.32}, {147.76, 
         74.67999999999999}, {149.8, 79.36}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{136.72, 83.32}, {147.76, 
         74.67999999999999}, {149.8, 79.36}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47451000000000004`, 0., 0.52549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{149.8, 79.36}, {139.72, 
         89.8}, {136.72, 83.32}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{149.8, 79.36}, {139.72, 
         89.8}, {136.72, 83.32}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.44314, 0., 0.55686], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{148.23999999999998`, 
         29.919999999999998`}, {137.79999999999998`, 19.36}, {
         140.79999999999998`, 18.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{148.23999999999998`, 
         29.919999999999998`}, {137.79999999999998`, 19.36}, {
         140.79999999999998`, 18.28}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47451000000000004`, 0., 0.52549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{137.8, 19.36}, {148.24, 
         29.92}, {146.44, 32.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{137.8, 19.36}, {148.24, 
         29.92}, {146.44, 32.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.35294, 0., 0.64706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{138.04, 14.32}, {147.28, 
         21.4}, {144.04, 19.}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{138.04, 14.32}, {147.28, 
         21.4}, {144.04, 19.}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.44314, 0., 0.55686], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{139.72, 89.8}, {149.8, 
         79.36}, {152.08, 82.84}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{139.72, 89.8}, {149.8, 
         79.36}, {152.08, 82.84}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.44314, 0., 0.55686], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{152.08, 82.84}, {142.96, 
         94.72}, {139.72, 89.8}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{152.08, 82.84}, {142.96, 
         94.72}, {139.72, 89.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{152.68, 98.8}, {
         144.64000000000001`, 109.36}, {140.68, 110.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{152.68, 98.8}, {
         144.64000000000001`, 109.36}, {140.68, 110.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{140.68, 110.08}, {149.68, 
         99.28}, {152.68, 98.8}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{140.68, 110.08}, {149.68, 
         99.28}, {152.68, 98.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.42745000000000005`, 0., 0.57255], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{150.28, 29.08}, {140.8, 
         18.279999999999998`}, {144.04, 19.}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{150.28, 29.08}, {140.8, 
         18.279999999999998`}, {144.04, 19.}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.44314, 0., 0.55686], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{140.8, 
         18.279999999999998`}, {150.28, 29.08}, {148.24, 
         29.919999999999995`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{140.8, 
         18.279999999999998`}, {150.28, 29.08}, {148.24, 
         29.919999999999995`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.42745000000000005`, 0., 0.57255], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{142.96, 94.72}, {152.08, 
         82.84}, {154.24, 85.24}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{142.96, 94.72}, {152.08, 
         82.84}, {154.24, 85.24}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.42745000000000005`, 0., 0.57255], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{154.23999999999998`, 
         85.24000000000001}, {146.32, 97.96000000000001}, {
         142.95999999999998`, 94.72000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{154.23999999999998`, 
         85.24000000000001}, {146.32, 97.96000000000001}, {
         142.95999999999998`, 94.72000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53333, 0., 0.46667000000000003`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{153.88000000000002`, 
         53.56}, {143.32000000000002`, 50.800000000000004`}, {
         143.32000000000002`, 44.92}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{153.88000000000002`, 
         53.56}, {143.32000000000002`, 50.800000000000004`}, {
         143.32000000000002`, 44.92}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53333, 0., 0.46667000000000003`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{154.12, 56.68}, {143.8, 
         57.04}, {143.32, 50.8}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{154.12, 56.68}, {143.8, 
         57.04}, {143.32, 50.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53333, 0., 0.46667000000000003`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{143.32000000000002`, 
         50.8}, {153.88000000000002`, 53.559999999999995`}, {
         154.12000000000003`, 56.68}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{143.32000000000002`, 
         50.8}, {153.88000000000002`, 53.559999999999995`}, {
         154.12000000000003`, 56.68}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52549, 0., 0.47451000000000004`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{153.88000000000002`, 
         50.56}, {143.32000000000002`, 44.92}, {143.92000000000002`, 
         39.760000000000005`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{153.88000000000002`, 
         50.56}, {143.32000000000002`, 44.92}, {143.92000000000002`, 
         39.760000000000005`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53333, 0., 0.46667000000000003`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{143.32000000000002`, 
         44.92}, {153.88000000000002`, 50.56}, {153.88000000000002`, 
         53.56}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{143.32000000000002`, 
         44.92}, {153.88000000000002`, 50.56}, {153.88000000000002`, 53.56}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52549, 0., 0.47451000000000004`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{143.8, 57.04}, {154.12, 
         56.68}, {154.60000000000002`, 59.92}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{143.8, 57.04}, {154.12, 
         56.68}, {154.60000000000002`, 59.92}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52549, 0., 0.47451000000000004`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{154.6, 59.92}, {144.64, 
         63.4}, {143.79999999999998`, 57.04}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{154.6, 59.92}, {144.64, 
         63.4}, {143.79999999999998`, 57.04}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{154.12, 47.8}, {
         143.92000000000002`, 39.76}, {145., 35.31999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{154.12, 47.8}, {
         143.92000000000002`, 39.76}, {145., 35.31999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52549, 0., 0.47451000000000004`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{143.92000000000002`, 
         39.760000000000005`}, {154.12, 47.800000000000004`}, {
         153.88000000000002`, 50.56}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{143.92000000000002`, 
         39.760000000000005`}, {154.12, 47.800000000000004`}, {
         153.88000000000002`, 50.56}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.42745000000000005`, 0., 0.57255], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{144.04, 19.}, {152.44, 
         29.560000000000002`}, {150.28, 29.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{144.04, 19.}, {152.44, 
         29.560000000000002`}, {150.28, 29.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.41961000000000004`, 0., 0.58039], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{152.44, 29.56}, {144.04, 
         19.}, {147.28, 21.4}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{152.44, 29.56}, {144.04, 
         19.}, {147.28, 21.4}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.39608000000000004`, 0., 0.60392], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{155.44, 96.76}, {148.12, 
         106.48}, {144.64, 109.36}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{155.44, 96.76}, {148.12, 
         106.48}, {144.64, 109.36}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.39608000000000004`, 0., 0.60392], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{144.64, 109.36}, {
         152.67999999999998`, 98.8}, {155.44, 96.76}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{144.64, 109.36}, {
         152.67999999999998`, 98.8}, {155.44, 96.76}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{144.64, 63.4}, {154.6, 
         59.92}, {155.32, 62.92}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{144.64, 63.4}, {154.6, 
         59.92}, {155.32, 62.92}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{155.32000000000002`, 
         62.92}, {145.96, 69.4}, {144.64000000000001`, 63.4}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{155.32000000000002`, 
         62.92}, {145.96, 69.4}, {144.64000000000001`, 63.4}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{154.6, 45.64}, {145., 
         35.32}, {146.44, 32.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{154.6, 45.64}, {145., 
         35.32}, {146.44, 32.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{145., 35.32}, {154.6, 
         45.64}, {154.12, 47.8}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{145., 35.32}, {154.6, 
         45.64}, {154.12, 47.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{145.96, 69.4}, {
         155.32000000000002`, 62.92}, {156.16, 65.68}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{145.96, 69.4}, {
         155.32000000000002`, 62.92}, {156.16, 65.68}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{156.16, 
         65.67999999999999}, {147.76, 74.67999999999999}, {145.96, 
         69.39999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{156.16, 
         65.67999999999999}, {147.76, 74.67999999999999}, {145.96, 
         69.39999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.41961000000000004`, 0., 0.58039], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{146.32000000000002`, 
         97.96000000000001}, {154.24, 85.24000000000001}, {156.52, 
         86.32000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{146.32000000000002`, 
         97.96000000000001}, {154.24, 85.24000000000001}, {156.52, 
         86.32000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.41961000000000004`, 0., 0.58039], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{156.52, 86.32}, {149.68, 
         99.28}, {146.32000000000002`, 97.96}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{156.52, 86.32}, {149.68, 
         99.28}, {146.32000000000002`, 97.96}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.48627000000000004`, 0., 0.51373], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{155.44, 
         43.839999999999996`}, {146.44, 32.08}, {148.24, 
         29.919999999999995`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{155.44, 
         43.839999999999996`}, {146.44, 32.08}, {148.24, 
         29.919999999999995`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{146.44, 32.08}, {155.44, 
         43.839999999999996`}, {154.6, 45.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{146.44, 32.08}, {155.44, 
         43.839999999999996`}, {154.6, 45.64}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.41961000000000004`, 0., 0.58039], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{147.28, 21.4}, {154.6, 
         31.119999999999997`}, {152.44, 29.56}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{147.28, 21.4}, {154.6, 
         31.119999999999997`}, {152.44, 29.56}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.42745000000000005`, 0., 0.57255], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{154.6, 31.12}, {147.28, 
         21.400000000000002`}, {150.28, 25.36}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{154.6, 31.12}, {147.28, 
         21.400000000000002`}, {150.28, 25.36}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.48627000000000004`, 0., 0.51373], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{147.76, 
         74.67999999999999}, {156.16, 65.67999999999999}, {157.12, 68.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{147.76, 
         74.67999999999999}, {156.16, 65.67999999999999}, {157.12, 68.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.48627000000000004`, 0., 0.51373], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{157.12, 68.08}, {149.8, 
         79.36}, {147.76, 74.67999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{157.12, 68.08}, {149.8, 
         79.36}, {147.76, 74.67999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47843, 0., 0.52157], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{156.28, 42.64}, {148.24, 
         29.92}, {150.28, 29.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{156.28, 42.64}, {148.24, 
         29.92}, {150.28, 29.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.48627000000000004`, 0., 0.51373], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{148.23999999999998`, 
         29.919999999999998`}, {156.27999999999997`, 42.64}, {
         155.43999999999997`, 43.839999999999996`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{148.23999999999998`, 
         29.919999999999998`}, {156.27999999999997`, 42.64}, {
         155.43999999999997`, 43.839999999999996`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.42745000000000005`, 0., 0.57255], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{158.68, 86.08}, {152.68, 
         98.8}, {149.68, 99.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{158.68, 86.08}, {152.68, 
         98.8}, {149.68, 99.28}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.42745000000000005`, 0., 0.57255], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{149.68, 99.28}, {156.52, 
         86.32}, {158.68, 86.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{149.68, 99.28}, {156.52, 
         86.32}, {158.68, 86.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47843, 0., 0.52157], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{149.8, 79.36}, {157.12, 
         68.08}, {158.32000000000002`, 69.88}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{149.8, 79.36}, {157.12, 
         68.08}, {158.32000000000002`, 69.88}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47843, 0., 0.52157], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{158.32000000000002`, 
         69.88}, {152.08, 82.84}, {149.8, 79.36}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{158.32000000000002`, 
         69.88}, {152.08, 82.84}, {149.8, 79.36}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47843, 0., 0.52157], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{150.28, 29.08}, {157.24, 
         42.16}, {156.28, 42.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{150.28, 29.08}, {157.24, 
         42.16}, {156.28, 42.64}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47059, 0., 0.5294099999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{157.23999999999998`, 
         42.160000000000004`}, {150.27999999999997`, 29.080000000000005`}, {
         152.43999999999997`, 29.560000000000002`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{157.23999999999998`, 
         42.160000000000004`}, {150.27999999999997`, 29.080000000000005`}, {
         152.43999999999997`, 29.560000000000002`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.42745000000000005`, 0., 0.57255], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{150.28, 25.36}, {156.76, 
         33.76}, {154.6, 31.119999999999997`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{150.28, 25.36}, {156.76, 
         33.76}, {154.6, 31.119999999999997`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47059, 0., 0.5294099999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{152.08, 82.84}, {
         158.32000000000002`, 69.88}, {159.4, 71.2}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{152.08, 82.84}, {
         158.32000000000002`, 69.88}, {159.4, 71.2}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47059, 0., 0.5294099999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{159.4, 71.2}, {154.24, 
         85.24000000000001}, {152.08, 82.84}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{159.4, 71.2}, {154.24, 
         85.24000000000001}, {152.08, 82.84}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47059, 0., 0.5294099999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{152.44, 29.56}, {158.32, 
         42.28}, {157.24, 42.16}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{152.44, 29.56}, {158.32, 
         42.28}, {157.24, 42.16}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.46667000000000003`, 0., 0.53333], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{158.32000000000002`, 
         42.28}, {152.44000000000003`, 29.560000000000002`}, {
         154.60000000000002`, 31.12}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{158.32000000000002`, 
         42.28}, {152.44000000000003`, 29.560000000000002`}, {
         154.60000000000002`, 31.12}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.44314, 0., 0.55686], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{160.6, 84.76}, {155.44, 
         96.76}, {152.68, 98.80000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{160.6, 84.76}, {155.44, 
         96.76}, {152.68, 98.80000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.44314, 0., 0.55686], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{152.68, 98.8}, {158.68, 
         86.08}, {160.6, 84.75999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{152.68, 98.8}, {158.68, 
         86.08}, {160.6, 84.75999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5098, 0., 0.49019999999999997`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {153.88, 
         53.559999999999995`}, {153.88, 50.559999999999995`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         153.88, 53.559999999999995`}, {153.88, 50.559999999999995`}, {161.2, 
         56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5098, 0., 0.49019999999999997`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         154.11999999999998`, 56.68}, {153.88, 53.559999999999995`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         154.11999999999998`, 56.68}, {153.88, 53.559999999999995`}, {161.2, 
         56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5098, 0., 0.49019999999999997`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {153.88, 
         50.559999999999995`}, {154.11999999999998`, 47.8}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         153.88, 50.559999999999995`}, {154.11999999999998`, 47.8}, {161.2, 
         56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5098, 0., 0.49019999999999997`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {154.6, 
         59.919999999999995`}, {154.11999999999998`, 56.68}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         154.6, 59.919999999999995`}, {154.11999999999998`, 56.68}, {161.2, 
         56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         154.11999999999998`, 47.8}, {154.6, 45.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         154.11999999999998`, 47.8}, {154.6, 45.64}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.46667000000000003`, 0., 0.53333], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{154.23999999999998`, 
         85.24000000000001}, {159.39999999999998`, 71.20000000000002}, {
         160.48, 71.80000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{154.23999999999998`, 
         85.24000000000001}, {159.39999999999998`, 71.20000000000002}, {
         160.48, 71.80000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.46667000000000003`, 0., 0.53333], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{160.48000000000002`, 
         71.8}, {156.52, 86.32}, {154.24, 85.24}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{160.48000000000002`, 
         71.8}, {156.52, 86.32}, {154.24, 85.24}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {155.32, 
         62.919999999999995`}, {154.6, 59.919999999999995`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         155.32, 62.919999999999995`}, {154.6, 59.919999999999995`}, {161.2, 
         56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.46667000000000003`, 0., 0.53333], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{154.6, 31.12}, {159.4, 
         43.120000000000005`}, {158.32, 42.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{154.6, 31.12}, {159.4, 
         43.120000000000005`}, {158.32, 42.28}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47059, 0., 0.5294099999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{159.4, 
         43.120000000000005`}, {154.6, 31.120000000000005`}, {
         156.76000000000002`, 33.760000000000005`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{159.4, 
         43.120000000000005`}, {154.6, 31.120000000000005`}, {
         156.76000000000002`, 33.760000000000005`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {154.6, 
         45.64}, {155.44, 43.839999999999996`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         154.6, 45.64}, {155.44, 43.839999999999996`}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {156.16, 
         65.67999999999999}, {155.32, 62.919999999999995`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         156.16, 65.67999999999999}, {155.32, 62.919999999999995`}, {161.2, 
         56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.49412, 0., 0.50196], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {155.44, 
         43.839999999999996`}, {156.28, 42.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         155.44, 43.839999999999996`}, {156.28, 42.64}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47451000000000004`, 0., 0.52549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{155.44, 96.76}, {160.6, 
         84.76}, {162.16, 82.24000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{155.44, 96.76}, {160.6, 
         84.76}, {162.16, 82.24000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47451000000000004`, 0., 0.52549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{162.16, 
         82.24000000000001}, {157.72, 92.92000000000002}, {155.44, 96.76}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{162.16, 
         82.24000000000001}, {157.72, 92.92000000000002}, {155.44, 96.76}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.49412, 0., 0.50196], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         157.11999999999998`, 68.08}, {156.16, 65.67999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         157.11999999999998`, 68.08}, {156.16, 65.67999999999999}, {161.2, 
         56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.49019999999999997`, 0., 0.5098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {156.28, 
         42.64}, {157.23999999999998`, 42.16}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         156.28, 42.64}, {157.23999999999998`, 42.16}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47059, 0., 0.5294099999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{156.52, 86.32}, {
         160.48000000000002`, 71.8}, {161.68, 71.8}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{156.52, 86.32}, {
         160.48000000000002`, 71.8}, {161.68, 71.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47059, 0., 0.5294099999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.68, 71.8}, {158.68, 
         86.08}, {156.52, 86.32}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.68, 71.8}, {158.68, 
         86.08}, {156.52, 86.32}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47843, 0., 0.52157], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{160.6, 44.44}, {156.76, 
         33.76}, {158.79999999999998`, 37.48}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{160.6, 44.44}, {156.76, 
         33.76}, {158.79999999999998`, 37.48}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47059, 0., 0.5294099999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{156.76, 
         33.760000000000005`}, {160.6, 44.440000000000005`}, {
         159.39999999999998`, 43.120000000000005`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{156.76, 
         33.760000000000005`}, {160.6, 44.440000000000005`}, {
         159.39999999999998`, 43.120000000000005`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.49019999999999997`, 0., 0.5098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {158.32, 
         69.88}, {157.11999999999998`, 68.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         158.32, 69.88}, {157.11999999999998`, 68.08}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.49019999999999997`, 0., 0.5098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         157.23999999999998`, 42.16}, {158.32, 42.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         157.23999999999998`, 42.16}, {158.32, 42.28}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.49019999999999997`, 0., 0.5098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         159.39999999999998`, 71.2}, {158.32, 69.88}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         159.39999999999998`, 71.2}, {158.32, 69.88}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.49019999999999997`, 0., 0.5098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {158.32, 
         42.28}, {159.39999999999998`, 43.12}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         158.32, 42.28}, {159.39999999999998`, 43.12}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47843, 0., 0.52157], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{162.52, 71.2}, {
         160.60000000000002`, 84.76}, {158.68, 86.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{162.52, 71.2}, {
         160.60000000000002`, 84.76}, {158.68, 86.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47843, 0., 0.52157], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{158.68, 86.08}, {161.68, 
         71.8}, {162.52, 71.2}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{158.68, 86.08}, {161.68, 
         71.8}, {162.52, 71.2}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47843, 0., 0.52157], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{158.8, 37.48}, {161.68, 
         46.36}, {160.60000000000002`, 44.44}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{158.8, 37.48}, {161.68, 
         46.36}, {160.60000000000002`, 44.44}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.48627000000000004`, 0., 0.51373], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.68, 46.36}, {158.8, 
         37.48}, {160.6, 41.92}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.68, 46.36}, {158.8, 
         37.48}, {160.6, 41.92}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.49019999999999997`, 0., 0.5098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {160.48, 
         71.8}, {159.39999999999998`, 71.2}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         160.48, 71.8}, {159.39999999999998`, 71.2}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.49019999999999997`, 0., 0.5098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         159.39999999999998`, 43.12}, {160.6, 44.44}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         159.39999999999998`, 43.12}, {160.6, 44.44}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.49019999999999997`, 0., 0.5098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         161.67999999999998`, 71.8}, {160.48, 71.8}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         161.67999999999998`, 71.8}, {160.48, 71.8}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.48627000000000004`, 0., 0.51373], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{160.6, 84.76}, {
         162.51999999999998`, 71.2}, {163.48, 69.88000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{160.6, 84.76}, {
         162.51999999999998`, 71.2}, {163.48, 69.88000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.48627000000000004`, 0., 0.51373], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{163.48000000000002`, 
         69.88}, {162.16000000000003`, 82.24}, {160.60000000000002`, 
         84.75999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{163.48000000000002`, 
         69.88}, {162.16000000000003`, 82.24}, {160.60000000000002`, 
         84.75999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.49019999999999997`, 0., 0.5098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {160.6, 
         44.44}, {161.67999999999998`, 46.36}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         160.6, 44.44}, {161.67999999999998`, 46.36}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{162.52, 
         48.760000000000005`}, {160.60000000000002`, 41.92}, {162.16, 
         47.080000000000005`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{162.52, 
         48.760000000000005`}, {160.60000000000002`, 41.92}, {162.16, 
         47.080000000000005`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.48627000000000004`, 0., 0.51373], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{160.6, 41.92}, {
         162.51999999999998`, 48.760000000000005`}, {161.68, 46.36}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{160.6, 41.92}, {
         162.51999999999998`, 48.760000000000005`}, {161.68, 46.36}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.49412, 0., 0.50196], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         161.67999999999998`, 46.36}, {162.51999999999998`, 48.76}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         161.67999999999998`, 46.36}, {162.51999999999998`, 48.76}, {161.2, 
         56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         162.51999999999998`, 48.76}, {163.35999999999999`, 51.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         162.51999999999998`, 48.76}, {163.35999999999999`, 51.28}, {161.2, 
         56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         163.35999999999999`, 51.28}, {164.07999999999998`, 
         54.279999999999994`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         163.35999999999999`, 51.28}, {164.07999999999998`, 
         54.279999999999994`}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5098, 0., 0.49019999999999997`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         164.07999999999998`, 54.279999999999994`}, {164.56, 
         57.279999999999994`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         164.07999999999998`, 54.279999999999994`}, {164.56, 
         57.279999999999994`}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.49019999999999997`, 0., 0.5098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         162.51999999999998`, 71.2}, {161.67999999999998`, 71.8}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         162.51999999999998`, 71.2}, {161.67999999999998`, 71.8}, {161.2, 
         56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.49412, 0., 0.50196], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {163.48, 
         69.88}, {162.51999999999998`, 71.2}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         163.48, 69.88}, {162.51999999999998`, 71.2}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         164.07999999999998`, 68.08}, {163.48, 69.88}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         164.07999999999998`, 68.08}, {163.48, 69.88}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {164.56, 
         65.8}, {164.07999999999998`, 68.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         164.56, 65.8}, {164.07999999999998`, 68.08}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5098, 0., 0.49019999999999997`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         164.79999999999998`, 63.16}, {164.56, 65.8}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         164.79999999999998`, 63.16}, {164.56, 65.8}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5098, 0., 0.49019999999999997`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         164.79999999999998`, 60.279999999999994`}, {164.79999999999998`, 
         63.16}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         164.79999999999998`, 60.279999999999994`}, {164.79999999999998`, 
         63.16}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5098, 0., 0.49019999999999997`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {164.56, 
         57.279999999999994`}, {164.79999999999998`, 60.279999999999994`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         164.56, 57.279999999999994`}, {164.79999999999998`, 
         60.279999999999994`}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{164.08, 68.08}, {163.36, 
         78.64}, {162.16000000000003`, 82.24}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{164.08, 68.08}, {163.36, 
         78.64}, {162.16000000000003`, 82.24}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{162.16, 
         82.24000000000001}, {163.48, 69.88000000000001}, {
         164.07999999999998`, 68.08000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{162.16, 
         82.24000000000001}, {163.48, 69.88000000000001}, {
         164.07999999999998`, 68.08000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{162.16, 47.08}, {
         163.35999999999999`, 51.28}, {162.52, 48.76}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{162.16, 47.08}, {
         163.35999999999999`, 51.28}, {162.52, 48.76}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{164.56, 65.8}, {164.2, 
         74.32}, {163.36, 78.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{164.56, 65.8}, {164.2, 
         74.32}, {163.36, 78.64}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{163.36, 78.64}, {164.08, 
         68.08}, {164.56, 65.8}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{163.36, 78.64}, {164.08, 
         68.08}, {164.56, 65.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52549, 0., 0.47451000000000004`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{164.8, 
         63.160000000000004`}, {164.68, 69.28}, {164.20000000000002`, 
         74.32000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{164.8, 
         63.160000000000004`}, {164.68, 69.28}, {164.20000000000002`, 
         74.32000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52549, 0., 0.47451000000000004`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{164.2, 74.32}, {164.56, 
         65.8}, {164.79999999999998`, 63.16}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{164.2, 74.32}, {164.56, 
         65.8}, {164.79999999999998`, 63.16}}},
         CurveClosed->{0}]}},
      AspectRatio->Automatic,
      ImageSize->{166., 135.},
      PlotRange->{{0., 166.}, {0., 135.}}], {0.7560975609756098, 0.7560975609756098},
      Center, {0.4434589800443458, 0.4434589800443458}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0., -5.551115123125783*^-17}, {
     0.48780487804878053`, -5.551115123125783*^-17}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0., -5.551115123125783*^-17}, {0., 
     0.4878048780487805}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0., 0.4878048780487805}, {0.48780487804878053`, 
     0.4878048780487805}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0.48780487804878053`, -5.551115123125783*^-17}, {
     0.48780487804878053`, 0.4878048780487805}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], {}, InsetBox[
     GraphicsBox[
      {Thickness[0.006024096385542169], 
       {FaceForm[{RGBColor[0.64314, 0., 0.35686], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{3.16, 64.6}, {1.12, 
         67.72}, {1.9600000000000002`, 60.279999999999994`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{3.16, 64.6}, {1.12, 
         67.72}, {1.9600000000000002`, 60.279999999999994`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.64314, 0., 0.35686], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{1.12, 67.72}, {3.16, 
         64.6}, {3.52, 74.67999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{1.12, 67.72}, {3.16, 
         64.6}, {3.52, 74.67999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.64314, 0., 0.35686], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{3.52, 
         74.67999999999999}, {1.3599999999999999`, 75.63999999999999}, {1.12, 
         67.72}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{3.52, 
         74.67999999999999}, {1.3599999999999999`, 75.63999999999999}, {1.12, 
         67.72}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.61961, 0., 0.38039], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{1.36, 75.64}, {
         3.5200000000000005`, 74.68}, {5.08, 84.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{1.36, 75.64}, {
         3.5200000000000005`, 74.68}, {5.08, 84.64}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.61961, 0., 0.38039], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{5.08, 84.64}, {2.56, 
         83.44}, {1.3599999999999999`, 75.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{5.08, 84.64}, {2.56, 
         83.44}, {1.3599999999999999`, 75.64}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.61961, 0., 0.38039], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{4.24, 
         55.120000000000005`}, {1.96, 60.28}, {3.7600000000000002`, 
         53.56}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{4.24, 
         55.120000000000005`}, {1.96, 60.28}, {3.7600000000000002`, 53.56}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.64314, 0., 0.35686], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{1.96, 60.28}, {4.24, 
         55.120000000000005`}, {3.16, 64.6}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{1.96, 60.28}, {4.24, 
         55.120000000000005`}, {3.16, 64.6}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.57255, 0., 0.42745000000000005`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{2.56, 
         83.44000000000001}, {5.08, 84.64000000000001}, {7.84, 94.12}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{2.56, 
         83.44000000000001}, {5.08, 84.64000000000001}, {7.84, 94.12}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.57255, 0., 0.42745000000000005`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{7.84, 
         94.11999999999999}, {4.72, 90.88}, {2.5599999999999996`, 83.44}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{7.84, 
         94.11999999999999}, {4.72, 90.88}, {2.5599999999999996`, 83.44}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7215699999999999, 0., 0.27843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{7.84, 
         61.720000000000006`}, {3.16, 64.60000000000001}, {4.24, 
         55.120000000000005`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{7.84, 
         61.720000000000006`}, {3.16, 64.60000000000001}, {4.24, 
         55.120000000000005`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7215699999999999, 0., 0.27843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{3.16, 64.6}, {7.84, 
         61.71999999999999}, {8.32, 73.47999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{3.16, 64.6}, {7.84, 
         61.71999999999999}, {8.32, 73.47999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7215699999999999, 0., 0.27843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{8.32, 73.48}, {
         3.5200000000000005`, 74.68}, {3.160000000000001, 
         64.60000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{8.32, 73.48}, {
         3.5200000000000005`, 74.68}, {3.160000000000001, 64.60000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.6823499999999999, 0., 0.31765], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{3.52, 
         74.67999999999999}, {8.32, 73.47999999999999}, {10.12, 85.24}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{3.52, 
         74.67999999999999}, {8.32, 73.47999999999999}, {10.12, 85.24}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.6823499999999999, 0., 0.31765], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{10.12, 
         85.24000000000001}, {5.079999999999999, 84.64000000000001}, {
         3.5199999999999996`, 74.68}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{10.12, 
         85.24000000000001}, {5.079999999999999, 84.64000000000001}, {
         3.5199999999999996`, 74.68}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.61961, 0., 0.38039], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{3.7600000000000002`, 
         53.56}, {6.5200000000000005`, 46.72}, {4.24, 
         55.120000000000005`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{3.7600000000000002`, 
         53.56}, {6.5200000000000005`, 46.72}, {4.24, 55.120000000000005`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.6823499999999999, 0., 0.31765], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{9.04, 50.68}, {
         4.239999999999999, 55.12}, {6.52, 46.72}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{9.04, 50.68}, {
         4.239999999999999, 55.12}, {6.52, 46.72}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7215699999999999, 0., 0.27843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{4.24, 
         55.120000000000005`}, {9.04, 50.68000000000001}, {7.84, 
         61.720000000000006`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{4.24, 
         55.120000000000005`}, {9.04, 50.68000000000001}, {7.84, 
         61.720000000000006`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.51765, 0., 0.48235000000000006`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{11.68, 102.52}, {7.84, 
         97.6}, {4.72, 90.88}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{11.68, 102.52}, {7.84, 
         97.6}, {4.72, 90.88}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.51765, 0., 0.48235000000000006`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{4.72, 90.88}, {7.84, 
         94.11999999999999}, {11.68, 102.52}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{4.72, 90.88}, {7.84, 
         94.11999999999999}, {11.68, 102.52}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.61176, 0., 0.38824], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{5.08, 84.64}, {
         10.120000000000001`, 85.24}, {13.36, 96.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{5.08, 84.64}, {
         10.120000000000001`, 85.24}, {13.36, 96.28}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.61176, 0., 0.38824], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{13.360000000000001`, 
         96.28}, {7.840000000000002, 94.12}, {5.080000000000002, 84.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{13.360000000000001`, 
         96.28}, {7.840000000000002, 94.12}, {5.080000000000002, 84.64}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.61176, 0., 0.38824], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{11.56, 
         40.839999999999996`}, {6.5200000000000005`, 46.72}, {9.76, 
         39.63999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{11.56, 
         40.839999999999996`}, {6.5200000000000005`, 46.72}, {9.76, 
         39.63999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.6823499999999999, 0., 0.31765], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{6.52, 
         46.720000000000006`}, {11.559999999999999`, 40.84}, {9.04, 
         50.68000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{6.52, 
         46.720000000000006`}, {11.559999999999999`, 40.84}, {9.04, 
         50.68000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.4549, 0., 0.5451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{16.36, 109.48}, {
         11.559999999999999`, 103.12}, {7.84, 97.60000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{16.36, 109.48}, {
         11.559999999999999`, 103.12}, {7.84, 97.60000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.4549, 0., 0.5451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{7.84, 97.6}, {11.68, 
         102.52}, {16.36, 109.47999999999999`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{7.84, 97.6}, {11.68, 
         102.52}, {16.36, 109.47999999999999`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{17.8, 
         106.11999999999999`}, {11.680000000000001`, 102.52}, {7.84, 
         94.11999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{17.8, 
         106.11999999999999`}, {11.680000000000001`, 102.52}, {7.84, 
         94.11999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{7.84, 
         94.11999999999999}, {13.36, 96.27999999999999}, {17.8, 
         106.11999999999999`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{7.84, 
         94.11999999999999}, {13.36, 96.27999999999999}, {17.8, 
         106.11999999999999`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8, 0., 0.2], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{14.56, 59.08}, {
         7.840000000000001, 61.72}, {9.040000000000001, 50.68}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{14.56, 59.08}, {
         7.840000000000001, 61.72}, {9.040000000000001, 50.68}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8, 0., 0.2], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{7.84, 
         61.720000000000006`}, {14.559999999999999`, 59.080000000000005`}, {
         15.04, 72.16000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{7.84, 
         61.720000000000006`}, {14.559999999999999`, 59.080000000000005`}, {
         15.04, 72.16000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8, 0., 0.2], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{15.04, 72.16}, {8.32, 
         73.47999999999999}, {7.839999999999999, 61.72}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{15.04, 72.16}, {8.32, 
         73.47999999999999}, {7.839999999999999, 61.72}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7451, 0., 0.2549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{8.32, 73.48}, {15.04, 
         72.16000000000001}, {17.08, 85.12}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{8.32, 73.48}, {15.04, 
         72.16000000000001}, {17.08, 85.12}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7451, 0., 0.2549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{17.08, 
         85.11999999999999}, {10.119999999999997`, 85.24}, {8.319999999999999,
          73.47999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{17.08, 
         85.11999999999999}, {10.119999999999997`, 85.24}, {8.319999999999999,
          73.47999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7451, 0., 0.2549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{15.76, 46.96}, {9.04, 
         50.68}, {11.559999999999999`, 40.84}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{15.76, 46.96}, {9.04, 
         50.68}, {11.559999999999999`, 40.84}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8, 0., 0.2], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{9.04, 50.68}, {
         15.759999999999998`, 46.96}, {14.559999999999999`, 59.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{9.04, 50.68}, {
         15.759999999999998`, 46.96}, {14.559999999999999`, 59.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.61176, 0., 0.38824], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{9.76, 39.64}, {15.28, 
         32.8}, {11.56, 40.84}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{9.76, 39.64}, {15.28, 
         32.8}, {11.56, 40.84}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{15.28, 32.8}, {9.76, 
         39.64}, {13.84, 34.48}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{15.28, 32.8}, {9.76, 
         39.64}, {13.84, 34.48}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.65098, 0., 0.34902], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{10.12, 
         85.24000000000001}, {17.08, 85.12}, {20.56, 97.48}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{10.12, 
         85.24000000000001}, {17.08, 85.12}, {20.56, 97.48}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.65098, 0., 0.34902], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{20.56, 97.48}, {13.36, 
         96.28}, {10.12, 85.24000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{20.56, 97.48}, {13.36, 
         96.28}, {10.12, 85.24000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.65098, 0., 0.34902], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{18.52, 36.04}, {
         11.559999999999999`, 40.839999999999996`}, {15.28, 32.8}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{18.52, 36.04}, {
         11.559999999999999`, 40.839999999999996`}, {15.28, 32.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7451, 0., 0.2549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{11.56, 
         40.839999999999996`}, {18.52, 36.04}, {15.760000000000002`, 
         46.959999999999994`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{11.56, 
         40.839999999999996`}, {18.52, 36.04}, {15.760000000000002`, 
         46.959999999999994`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.4313700000000001, 0., 0.5686300000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{23.08, 114.28}, {16.36, 
         109.48}, {11.679999999999998`, 102.52}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{23.08, 114.28}, {16.36, 
         109.48}, {11.679999999999998`, 102.52}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.4313700000000001, 0., 0.5686300000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{11.68, 102.52}, {
         17.799999999999997`, 106.11999999999999`}, {23.08, 114.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{11.68, 102.52}, {
         17.799999999999997`, 106.11999999999999`}, {23.08, 114.28}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53333, 0., 0.46667000000000003`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{25.36, 108.28}, {17.8, 
         106.12}, {13.36, 96.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{25.36, 108.28}, {17.8, 
         106.12}, {13.36, 96.28}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53333, 0., 0.46667000000000003`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{13.360000000000001`, 
         96.28}, {20.560000000000002`, 97.48}, {25.36, 108.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{13.360000000000001`, 
         96.28}, {20.560000000000002`, 97.48}, {25.36, 108.28}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{13.84, 34.48}, {20.08, 
         26.799999999999997`}, {15.28, 32.8}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{13.84, 34.48}, {20.08, 
         26.799999999999997`}, {15.28, 32.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8705900000000001, 0., 0.12941000000000003`], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{22.72, 56.92}, {
         14.559999999999999`, 59.08}, {15.759999999999998`, 46.96}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{22.72, 56.92}, {
         14.559999999999999`, 59.08}, {15.759999999999998`, 46.96}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8705900000000001, 0., 0.12941000000000003`], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{14.56, 59.08}, {22.72, 
         56.92}, {23.2, 70.84}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{14.56, 59.08}, {22.72, 
         56.92}, {23.2, 70.84}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8705900000000001, 0., 0.12941000000000003`], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{23.2, 70.84}, {15.04, 
         72.16}, {14.56, 59.080000000000005`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{23.2, 70.84}, {15.04, 
         72.16}, {14.56, 59.080000000000005`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8078400000000001, 0., 0.19216], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{15.04, 72.16}, {23.2, 
         70.84}, {25.24, 84.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{15.04, 72.16}, {23.2, 
         70.84}, {25.24, 84.64}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8078400000000001, 0., 0.19216], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{25.24, 84.64}, {17.08, 
         85.12}, {15.04, 72.16}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{25.24, 84.64}, {17.08, 
         85.12}, {15.04, 72.16}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53333, 0., 0.46667000000000003`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{22.6, 27.16}, {
         15.280000000000001`, 32.8}, {20.080000000000002`, 26.8}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{22.6, 27.16}, {
         15.280000000000001`, 32.8}, {20.080000000000002`, 26.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.65098, 0., 0.34902], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{15.28, 32.8}, {
         22.599999999999998`, 27.159999999999997`}, {18.52, 36.04}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{15.28, 32.8}, {
         22.599999999999998`, 27.159999999999997`}, {18.52, 36.04}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8078400000000001, 0., 0.19216], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{23.8, 
         43.839999999999996`}, {15.760000000000002`, 46.959999999999994`}, {
         18.52, 36.04}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{23.8, 
         43.839999999999996`}, {15.760000000000002`, 46.959999999999994`}, {
         18.52, 36.04}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8705900000000001, 0., 0.12941000000000003`], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{15.76, 46.96}, {
         23.799999999999997`, 43.84}, {22.72, 56.92}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{15.76, 46.96}, {
         23.799999999999997`, 43.84}, {22.72, 56.92}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.34902, 0., 0.65098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{16.36, 109.48}, {23.08, 
         114.28}, {29.08, 120.16}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{16.36, 109.48}, {23.08, 
         114.28}, {29.08, 120.16}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.34902, 0., 0.65098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{29.08, 120.16}, {21.52, 
         114.75999999999999`}, {16.36, 109.47999999999999`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{29.08, 120.16}, {21.52, 
         114.75999999999999`}, {16.36, 109.47999999999999`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.6901999999999999, 0., 0.3098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{17.08, 
         85.11999999999999}, {25.24, 84.63999999999999}, {29.08, 
         97.71999999999998}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{17.08, 
         85.11999999999999}, {25.24, 84.63999999999999}, {29.08, 
         97.71999999999998}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.6901999999999999, 0., 0.3098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{29.08, 97.72}, {20.56, 
         97.48}, {17.08, 85.12}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{29.08, 97.72}, {20.56, 
         97.48}, {17.08, 85.12}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.40392000000000006`, 0., 0.5960799999999999], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{31.24, 117.28}, {23.08, 
         114.28}, {17.799999999999997`, 106.12}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{31.24, 117.28}, {23.08, 
         114.28}, {17.799999999999997`, 106.12}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.40392000000000006`, 0., 0.5960799999999999], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{17.8, 
         106.11999999999999`}, {25.36, 108.27999999999999`}, {
         31.240000000000002`, 117.27999999999999`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{17.8, 
         106.11999999999999`}, {25.36, 108.27999999999999`}, {
         31.240000000000002`, 117.27999999999999`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.6901999999999999, 0., 0.3098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{26.68, 32.32}, {18.52, 
         36.04}, {22.6, 27.16}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{26.68, 32.32}, {18.52, 
         36.04}, {22.6, 27.16}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8078400000000001, 0., 0.19216], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{18.52, 36.04}, {26.68, 
         32.32}, {23.8, 43.839999999999996`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{18.52, 36.04}, {26.68, 
         32.32}, {23.8, 43.839999999999996`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53333, 0., 0.46667000000000003`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{20.08, 26.8}, {
         27.639999999999997`, 20.68}, {22.599999999999998`, 27.16}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{20.08, 26.8}, {
         27.639999999999997`, 20.68}, {22.599999999999998`, 27.16}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53725, 0., 0.46275], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{20.56, 97.48}, {29.08, 
         97.72}, {34.12, 109.48}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{20.56, 97.48}, {29.08, 
         97.72}, {34.12, 109.48}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53725, 0., 0.46275], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{34.120000000000005`, 
         109.48}, {25.360000000000007`, 108.28}, {20.560000000000002`, 
         97.48}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{34.120000000000005`, 
         109.48}, {25.360000000000007`, 108.28}, {20.560000000000002`, 
         97.48}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53725, 0., 0.46275], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{30.88, 
         22.959999999999997`}, {22.6, 27.159999999999997`}, {27.64, 
         20.679999999999996`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{30.88, 
         22.959999999999997`}, {22.6, 27.159999999999997`}, {27.64, 
         20.679999999999996`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.6901999999999999, 0., 0.3098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{22.6, 27.16}, {
         30.880000000000003`, 22.96}, {26.68, 32.32}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{22.6, 27.16}, {
         30.880000000000003`, 22.96}, {26.68, 32.32}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.92549, 0., 0.07451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{31.6, 55.}, {22.72, 
         56.92}, {23.8, 43.84}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{31.6, 55.}, {22.72, 
         56.92}, {23.8, 43.84}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.92549, 0., 0.07451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{22.72, 56.92}, {31.6, 
         55.}, {32.2, 69.4}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{22.72, 56.92}, {31.6, 
         55.}, {32.2, 69.4}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.92549, 0., 0.07451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{32.2, 69.4}, {
         23.200000000000003`, 70.84}, {22.720000000000002`, 56.92}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{32.2, 69.4}, {
         23.200000000000003`, 70.84}, {22.720000000000002`, 56.92}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.29804, 0., 0.7019599999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{23.08, 114.28}, {31.24, 
         117.28}, {37.599999999999994`, 123.88}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{23.08, 114.28}, {31.24, 
         117.28}, {37.599999999999994`, 123.88}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.29804, 0., 0.7019599999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{37.6, 123.88}, {
         29.080000000000002`, 120.16}, {23.080000000000002`, 114.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{37.6, 123.88}, {
         29.080000000000002`, 120.16}, {23.080000000000002`, 114.28}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8549000000000001, 0., 0.1451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{23.2, 70.84}, {32.2, 
         69.4}, {34.36, 83.92}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{23.2, 70.84}, {32.2, 
         69.4}, {34.36, 83.92}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8549000000000001, 0., 0.1451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{34.36, 83.92}, {
         25.240000000000002`, 84.64}, {23.2, 70.84}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{34.36, 83.92}, {
         25.240000000000002`, 84.64}, {23.2, 70.84}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8549000000000001, 0., 0.1451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{32.8, 41.44}, {
         23.799999999999997`, 43.839999999999996`}, {26.68, 32.32}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{32.8, 41.44}, {
         23.799999999999997`, 43.839999999999996`}, {26.68, 32.32}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.92549, 0., 0.07451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{23.8, 
         43.839999999999996`}, {32.8, 41.44}, {31.6, 55.}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{23.8, 
         43.839999999999996`}, {32.8, 41.44}, {31.6, 55.}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.71765, 0., 0.28235000000000005`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{25.24, 84.64}, {34.36, 
         83.92}, {38.2, 97.48}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{25.24, 84.64}, {34.36, 
         83.92}, {38.2, 97.48}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.71765, 0., 0.28235000000000005`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{38.2, 97.48}, {
         29.080000000000005`, 97.72}, {25.240000000000002`, 84.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{38.2, 97.48}, {
         29.080000000000005`, 97.72}, {25.240000000000002`, 84.64}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.38431000000000004`, 0., 0.6156900000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{25.36, 108.28}, {34.12, 
         109.48}, {40.12, 118.96000000000001`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{25.36, 108.28}, {34.12, 
         109.48}, {40.12, 118.96000000000001`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.38431000000000004`, 0., 0.6156900000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{40.120000000000005`, 
         118.96000000000001`}, {31.240000000000002`, 117.28}, {
         25.360000000000007`, 108.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{40.120000000000005`, 
         118.96000000000001`}, {31.240000000000002`, 117.28}, {
         25.360000000000007`, 108.28}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.71765, 0., 0.28235000000000005`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{35.56, 
         29.439999999999998`}, {26.68, 32.32}, {30.880000000000003`, 
         22.959999999999997`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{35.56, 
         29.439999999999998`}, {26.68, 32.32}, {30.880000000000003`, 
         22.959999999999997`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8549000000000001, 0., 0.1451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{26.68, 32.32}, {35.56, 
         29.44}, {32.8, 41.44}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{26.68, 32.32}, {35.56, 
         29.44}, {32.8, 41.44}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53725, 0., 0.46275], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{27.64, 20.68}, {36.16, 
         16.12}, {30.880000000000003`, 22.96}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{27.64, 20.68}, {36.16, 
         16.12}, {30.880000000000003`, 22.96}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.38431000000000004`, 0., 0.6156900000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{36.160000000000004`, 
         16.12}, {27.640000000000004`, 20.68}, {33.52, 
         16.720000000000002`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{36.160000000000004`, 
         16.12}, {27.640000000000004`, 20.68}, {33.52, 16.720000000000002`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.22353, 0., 0.77647], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{29.08, 120.16}, {
         37.599999999999994`, 123.88}, {44.31999999999999, 127.84}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{29.08, 120.16}, {
         37.599999999999994`, 123.88}, {44.31999999999999, 127.84}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.22353, 0., 0.77647], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{44.32, 127.84}, {35.2, 
         123.88000000000001`}, {29.080000000000002`, 120.16}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{44.32, 127.84}, {35.2, 
         123.88000000000001`}, {29.080000000000002`, 120.16}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5451, 0., 0.4549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{29.08, 97.72}, {
         38.199999999999996`, 97.48}, {43.36, 109.6}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{29.08, 97.72}, {
         38.199999999999996`, 97.48}, {43.36, 109.6}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5451, 0., 0.4549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{43.36, 109.6}, {
         34.120000000000005`, 109.47999999999999`}, {29.08, 97.72}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{43.36, 109.6}, {
         34.120000000000005`, 109.47999999999999`}, {29.08, 97.72}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5451, 0., 0.4549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{39.760000000000005`, 
         19.84}, {30.880000000000003`, 22.96}, {36.160000000000004`, 
         16.12}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{39.760000000000005`, 
         19.84}, {30.880000000000003`, 22.96}, {36.160000000000004`, 16.12}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.71765, 0., 0.28235000000000005`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{30.88, 
         22.959999999999997`}, {39.76, 19.839999999999996`}, {35.56, 
         29.439999999999998`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{30.88, 
         22.959999999999997`}, {39.76, 19.839999999999996`}, {35.56, 
         29.439999999999998`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.24706000000000003`, 0., 0.75294], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{46.839999999999996`, 
         125.92}, {37.599999999999994`, 123.88}, {31.239999999999995`, 
         117.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{46.839999999999996`, 
         125.92}, {37.599999999999994`, 123.88}, {31.239999999999995`, 
         117.28}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.24706000000000003`, 0., 0.75294], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{31.24, 117.28}, {40.12, 
         118.96000000000001`}, {46.839999999999996`, 125.92}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{31.24, 117.28}, {40.12, 
         118.96000000000001`}, {46.839999999999996`, 125.92}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.96471, 0., 0.03529399999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{41.08, 53.2}, {
         31.599999999999998`, 55.}, {32.8, 41.440000000000005`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{41.08, 53.2}, {
         31.599999999999998`, 55.}, {32.8, 41.440000000000005`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.96471, 0., 0.03529399999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{31.6, 55.}, {41.08, 
         53.2}, {41.68, 67.96000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{31.6, 55.}, {41.08, 
         53.2}, {41.68, 67.96000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.96471, 0., 0.03529399999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{41.68, 
         67.96000000000001}, {32.2, 69.4}, {31.6, 55.00000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{41.68, 
         67.96000000000001}, {32.2, 69.4}, {31.6, 55.00000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.88235, 0., 0.11765], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{32.2, 69.4}, {
         41.68000000000001, 67.96000000000001}, {43.96, 82.84}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{32.2, 69.4}, {
         41.68000000000001, 67.96000000000001}, {43.96, 82.84}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.88235, 0., 0.11765], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{43.96, 82.84}, {34.36, 
         83.92}, {32.2, 69.4}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{43.96, 82.84}, {34.36, 
         83.92}, {32.2, 69.4}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.88235, 0., 0.11765], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{42.160000000000004`, 
         39.4}, {32.800000000000004`, 41.44}, {35.56, 
         29.439999999999998`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{42.160000000000004`, 
         39.4}, {32.800000000000004`, 41.44}, {35.56, 29.439999999999998`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.96471, 0., 0.03529399999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{32.8, 41.44}, {42.16, 
         39.4}, {41.08, 53.199999999999996`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{32.8, 41.44}, {42.16, 
         39.4}, {41.08, 53.199999999999996`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.38431000000000004`, 0., 0.6156900000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{33.52, 16.72}, {
         42.160000000000004`, 11.919999999999998`}, {36.160000000000004`, 
         16.119999999999997`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{33.52, 16.72}, {
         42.160000000000004`, 11.919999999999998`}, {36.160000000000004`, 
         16.119999999999997`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{49.6, 
         119.44000000000001`}, {40.120000000000005`, 118.96000000000001`}, {
         34.120000000000005`, 109.48000000000002`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{49.6, 
         119.44000000000001`}, {40.120000000000005`, 118.96000000000001`}, {
         34.120000000000005`, 109.48000000000002`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{34.120000000000005`, 
         109.48}, {43.36, 109.60000000000001`}, {49.60000000000001, 
         119.44}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{34.120000000000005`, 
         109.48}, {43.36, 109.60000000000001`}, {49.60000000000001, 119.44}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.73725, 0., 0.26275], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{34.36, 83.92}, {43.96, 
         82.84}, {47.8, 96.76}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{34.36, 83.92}, {43.96, 
         82.84}, {47.8, 96.76}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.73725, 0., 0.26275], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{47.8, 96.76}, {
         38.199999999999996`, 97.48}, {34.36, 83.92}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{47.8, 96.76}, {
         38.199999999999996`, 97.48}, {34.36, 83.92}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.73725, 0., 0.26275], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{44.92, 27.16}, {35.56, 
         29.44}, {39.760000000000005`, 19.84}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{44.92, 27.16}, {35.56, 
         29.44}, {39.760000000000005`, 19.84}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.88235, 0., 0.11765], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{35.56, 
         29.439999999999998`}, {44.92, 27.159999999999997`}, {
         42.160000000000004`, 39.4}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{35.56, 
         29.439999999999998`}, {44.92, 27.159999999999997`}, {
         42.160000000000004`, 39.4}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{45.04, 
         12.639999999999999`}, {36.16, 16.119999999999997`}, {42.16, 
         11.919999999999998`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{45.04, 
         12.639999999999999`}, {36.16, 16.119999999999997`}, {42.16, 
         11.919999999999998`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5451, 0., 0.4549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{36.160000000000004`, 
         16.12}, {45.040000000000006`, 12.64}, {39.760000000000005`, 
         19.84}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{36.160000000000004`, 
         16.12}, {45.040000000000006`, 12.64}, {39.760000000000005`, 19.84}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.15294000000000005`, 0., 0.84706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{53.8, 130.12}, {
         44.31999999999999, 127.84}, {37.599999999999994`, 
         123.88000000000001`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{53.8, 130.12}, {
         44.31999999999999, 127.84}, {37.599999999999994`, 
         123.88000000000001`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.15294000000000005`, 0., 0.84706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{37.6, 123.88}, {46.84, 
         125.92}, {53.8, 130.12}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{37.6, 123.88}, {46.84, 
         125.92}, {53.8, 130.12}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5529400000000001, 0., 0.44706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{38.2, 97.48}, {
         47.800000000000004`, 96.76}, {52.96, 109.24000000000001`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{38.2, 97.48}, {
         47.800000000000004`, 96.76}, {52.96, 109.24000000000001`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5529400000000001, 0., 0.44706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{52.96, 
         109.24000000000001`}, {43.36, 109.60000000000001`}, {38.2, 
         97.48}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{52.96, 
         109.24000000000001`}, {43.36, 109.60000000000001`}, {38.2, 97.48}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5529400000000001, 0., 0.44706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{49., 17.32}, {
         39.760000000000005`, 19.84}, {45.04, 12.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{49., 17.32}, {
         39.760000000000005`, 19.84}, {45.04, 12.64}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.73725, 0., 0.26275], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{39.760000000000005`, 
         19.84}, {49., 17.32}, {44.92, 27.16}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{39.760000000000005`, 
         19.84}, {49., 17.32}, {44.92, 27.16}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.20784000000000002`, 0., 0.7921599999999999], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{56.32, 126.76}, {46.84, 
         125.92}, {40.120000000000005`, 118.96000000000001`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{56.32, 126.76}, {46.84, 
         125.92}, {40.120000000000005`, 118.96000000000001`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.20784000000000002`, 0., 0.7921599999999999], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{40.120000000000005`, 
         118.96000000000001`}, {49.60000000000001, 119.44000000000001`}, {
         56.32000000000001, 126.76}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{40.120000000000005`, 
         118.96000000000001`}, {49.60000000000001, 119.44000000000001`}, {
         56.32000000000001, 126.76}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.97647, 0., 0.023528999999999998`], Opacity[1.]}],
         FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{51.04, 51.64}, {41.08, 
         53.2}, {42.16, 39.400000000000006`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{51.04, 51.64}, {41.08, 
         53.2}, {42.16, 39.400000000000006`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.97647, 0., 0.023528999999999998`], Opacity[1.]}],
         FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{41.08, 53.2}, {51.04, 
         51.64}, {51.76, 66.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{41.08, 53.2}, {51.04, 
         51.64}, {51.76, 66.64}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.97647, 0., 0.023528999999999998`], Opacity[1.]}],
         FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{51.760000000000005`, 
         66.64}, {41.68000000000001, 67.96}, {41.080000000000005`, 53.2}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{51.760000000000005`, 
         66.64}, {41.68000000000001, 67.96}, {41.080000000000005`, 53.2}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.89412, 0., 0.10588], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{41.68, 
         67.96000000000001}, {51.76, 66.64000000000001}, {54.04, 
         81.52000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{41.68, 
         67.96000000000001}, {51.76, 66.64000000000001}, {54.04, 
         81.52000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.89412, 0., 0.10588], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{54.04, 81.52}, {43.96, 
         82.83999999999999}, {41.68, 67.96}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{54.04, 81.52}, {43.96, 
         82.83999999999999}, {41.68, 67.96}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{42.160000000000004`, 
         11.92}, {51.040000000000006`, 8.44}, {45.040000000000006`, 
         12.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{42.160000000000004`, 
         11.92}, {51.040000000000006`, 8.44}, {45.040000000000006`, 12.64}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.89412, 0., 0.10588], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{52.120000000000005`, 
         37.720000000000006`}, {42.160000000000004`, 39.400000000000006`}, {
         44.92, 27.160000000000004`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{52.120000000000005`, 
         37.720000000000006`}, {42.160000000000004`, 39.400000000000006`}, {
         44.92, 27.160000000000004`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.97647, 0., 0.023528999999999998`], Opacity[1.]}],
         FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{42.160000000000004`, 
         39.4}, {52.120000000000005`, 37.72}, {51.040000000000006`, 
         51.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{42.160000000000004`, 
         39.4}, {52.120000000000005`, 37.72}, {51.040000000000006`, 51.64}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.35294, 0., 0.64706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{43.36, 109.6}, {52.96, 
         109.24}, {59.2, 119.32}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{43.36, 109.6}, {52.96, 
         109.24}, {59.2, 119.32}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.35294, 0., 0.64706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{59.2, 119.32}, {49.6, 
         119.44}, {43.36, 109.6}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{59.2, 119.32}, {49.6, 
         119.44}, {43.36, 109.6}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7451, 0., 0.2549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{43.96, 82.84}, {54.04, 
         81.52000000000001}, {57.88, 95.68}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{43.96, 82.84}, {54.04, 
         81.52000000000001}, {57.88, 95.68}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7451, 0., 0.2549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{57.879999999999995`, 
         95.67999999999999}, {47.8, 96.75999999999999}, {43.959999999999994`, 
         82.83999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{57.879999999999995`, 
         95.67999999999999}, {47.8, 96.75999999999999}, {43.959999999999994`, 
         82.83999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7451, 0., 0.2549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{54.760000000000005`, 
         25.36}, {44.92, 27.16}, {49.00000000000001, 17.32}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{54.760000000000005`, 
         25.36}, {44.92, 27.16}, {49.00000000000001, 17.32}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.89412, 0., 0.10588], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{44.92, 27.16}, {
         54.760000000000005`, 25.36}, {52.120000000000005`, 37.72}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{44.92, 27.16}, {
         54.760000000000005`, 25.36}, {52.120000000000005`, 37.72}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.35294, 0., 0.64706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{54.28, 10.12}, {
         45.040000000000006`, 12.639999999999999`}, {51.04, 8.44}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{54.28, 10.12}, {
         45.040000000000006`, 12.639999999999999`}, {51.04, 8.44}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5529400000000001, 0., 0.44706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{45.04, 
         12.639999999999999`}, {54.28, 10.12}, {49., 17.32}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{45.04, 
         12.639999999999999`}, {54.28, 10.12}, {49., 17.32}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.10196000000000001`, 0., 0.8980400000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{46.839999999999996`, 
         125.92}, {56.31999999999999, 126.76}, {63.279999999999994`, 
         131.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{46.839999999999996`, 
         125.92}, {56.31999999999999, 126.76}, {63.279999999999994`, 131.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.10196000000000001`, 0., 0.8980400000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{63.28, 131.08}, {53.8, 
         130.12}, {46.84, 125.92000000000002`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{63.28, 131.08}, {53.8, 
         130.12}, {46.84, 125.92000000000002`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.55686, 0., 0.44314], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{47.8, 96.76}, {
         57.879999999999995`, 95.68}, {63.03999999999999, 108.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{47.8, 96.76}, {
         57.879999999999995`, 95.68}, {63.03999999999999, 108.28}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.55686, 0., 0.44314], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{63.04, 108.28}, {52.96, 
         109.24}, {47.8, 96.76}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{63.04, 108.28}, {52.96, 
         109.24}, {47.8, 96.76}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.55686, 0., 0.44314], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{58.720000000000006`, 
         15.52}, {49.00000000000001, 17.32}, {54.28000000000001, 10.12}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{58.720000000000006`, 
         15.52}, {49.00000000000001, 17.32}, {54.28000000000001, 10.12}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7451, 0., 0.2549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{49., 17.32}, {58.72, 
         15.52}, {54.76, 25.36}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{49., 17.32}, {58.72, 
         15.52}, {54.76, 25.36}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.18431, 0., 0.8156900000000001], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{49.6, 
         119.44000000000001`}, {59.2, 119.32000000000001`}, {65.92, 
         126.76}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{49.6, 
         119.44000000000001`}, {59.2, 119.32000000000001`}, {65.92, 126.76}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.18431, 0., 0.8156900000000001], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{65.92, 126.76}, {56.32, 
         126.76}, {49.6, 119.44000000000001`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{65.92, 126.76}, {56.32, 
         126.76}, {49.6, 119.44000000000001`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.96471, 0., 0.03529399999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{61.839999999999996`, 
         50.32}, {51.03999999999999, 51.64}, {52.12, 37.72}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{61.839999999999996`, 
         50.32}, {51.03999999999999, 51.64}, {52.12, 37.72}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.96471, 0., 0.03529399999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{51.04, 51.64}, {61.84, 
         50.32}, {62.56, 65.2}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{51.04, 51.64}, {61.84, 
         50.32}, {62.56, 65.2}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.96471, 0., 0.03529399999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{62.56, 65.2}, {
         51.760000000000005`, 66.64}, {51.040000000000006`, 51.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{62.56, 65.2}, {
         51.760000000000005`, 66.64}, {51.040000000000006`, 51.64}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.35294, 0., 0.64706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{51.04, 8.44}, {60.28, 
         5.92}, {54.28, 10.12}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{51.04, 8.44}, {60.28, 
         5.92}, {54.28, 10.12}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.88235, 0., 0.11765], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{51.760000000000005`, 
         66.64}, {62.56, 65.2}, {64.84, 80.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{51.760000000000005`, 
         66.64}, {62.56, 65.2}, {64.84, 80.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.88235, 0., 0.11765], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{64.84, 80.08}, {
         54.040000000000006`, 81.52}, {51.760000000000005`, 66.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{64.84, 80.08}, {
         54.040000000000006`, 81.52}, {51.760000000000005`, 66.64}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.88235, 0., 0.11765], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{62.8, 36.28}, {52.12, 
         37.72}, {54.76, 25.36}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{62.8, 36.28}, {52.12, 
         37.72}, {54.76, 25.36}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.96471, 0., 0.03529399999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{52.120000000000005`, 
         37.720000000000006`}, {62.800000000000004`, 36.28000000000001}, {
         61.84, 50.32000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{52.120000000000005`, 
         37.720000000000006`}, {62.800000000000004`, 36.28000000000001}, {
         61.84, 50.32000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.34902, 0., 0.65098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{52.96, 
         109.24000000000001`}, {63.04, 108.28000000000002`}, {
         69.03999999999999, 118.48}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{52.96, 
         109.24000000000001`}, {63.04, 108.28000000000002`}, {
         69.03999999999999, 118.48}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.34902, 0., 0.65098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{69.04, 118.48}, {59.2, 
         119.32000000000001`}, {52.96000000000001, 109.24000000000001`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{69.04, 118.48}, {59.2, 
         119.32000000000001`}, {52.96000000000001, 109.24000000000001`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.06274500000000001, 0., 0.93725], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{70.24000000000001, 
         132.52}, {60.64000000000001, 131.56}, {53.80000000000001, 
         130.12}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{70.24000000000001, 
         132.52}, {60.64000000000001, 131.56}, {53.80000000000001, 130.12}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.06274500000000001, 0., 0.93725], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{53.8, 130.12}, {63.28, 
         131.08}, {70.24, 132.52}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{53.8, 130.12}, {63.28, 
         131.08}, {70.24, 132.52}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.73725, 0., 0.26275], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{54.04, 81.52}, {64.84, 
         80.08}, {68.56, 94.24}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{54.04, 81.52}, {64.84, 
         80.08}, {68.56, 94.24}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.73725, 0., 0.26275], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{68.56, 
         94.24000000000001}, {57.88, 95.68}, {54.040000000000006`, 
         81.52000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{68.56, 
         94.24000000000001}, {57.88, 95.68}, {54.040000000000006`, 
         81.52000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.34902, 0., 0.65098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{63.760000000000005`, 
         8.2}, {54.28, 10.12}, {60.28000000000001, 5.919999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{63.760000000000005`, 
         8.2}, {54.28, 10.12}, {60.28000000000001, 5.919999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.55686, 0., 0.44314], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{54.28, 10.12}, {
         63.760000000000005`, 8.2}, {58.72, 15.52}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{54.28, 10.12}, {
         63.760000000000005`, 8.2}, {58.72, 15.52}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.73725, 0., 0.26275], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{65.2, 24.04}, {
         54.760000000000005`, 25.36}, {58.72, 15.52}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{65.2, 24.04}, {
         54.760000000000005`, 25.36}, {58.72, 15.52}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.88235, 0., 0.11765], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{54.760000000000005`, 
         25.36}, {65.2, 24.04}, {62.800000000000004`, 36.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{54.760000000000005`, 
         25.36}, {65.2, 24.04}, {62.800000000000004`, 36.28}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.066667, 0., 0.93333], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{56.32, 126.76}, {65.92, 
         126.76}, {72.88, 131.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{56.32, 126.76}, {65.92, 
         126.76}, {72.88, 131.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.066667, 0., 0.93333], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{72.88, 131.08}, {
         63.279999999999994`, 131.08}, {56.31999999999999, 
         126.76000000000002`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{72.88, 131.08}, {
         63.279999999999994`, 131.08}, {56.31999999999999, 
         126.76000000000002`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5529400000000001, 0., 0.44706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{57.879999999999995`, 
         95.67999999999999}, {68.56, 94.24}, {73.6, 106.72}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{57.879999999999995`, 
         95.67999999999999}, {68.56, 94.24}, {73.6, 106.72}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5529400000000001, 0., 0.44706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{73.6, 106.72}, {
         63.03999999999999, 108.28}, {57.879999999999995`, 95.68}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{73.6, 106.72}, {
         63.03999999999999, 108.28}, {57.879999999999995`, 95.68}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5529400000000001, 0., 0.44706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{69.04, 14.2}, {
         58.720000000000006`, 15.52}, {63.760000000000005`, 8.2}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{69.04, 14.2}, {
         58.720000000000006`, 15.52}, {63.760000000000005`, 8.2}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.73725, 0., 0.26275], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{58.720000000000006`, 
         15.52}, {69.04, 14.2}, {65.2, 24.04}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{58.720000000000006`, 
         15.52}, {69.04, 14.2}, {65.2, 24.04}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.17255, 0., 0.82745], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{59.2, 119.32}, {69.04, 
         118.47999999999999`}, {75.76, 125.91999999999999`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{59.2, 119.32}, {69.04, 
         118.47999999999999`}, {75.76, 125.91999999999999`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.17255, 0., 0.82745], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{75.76, 125.92}, {65.92, 
         126.76}, {59.2, 119.32000000000001`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{75.76, 125.92}, {65.92, 
         126.76}, {59.2, 119.32000000000001`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.34902, 0., 0.65098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{60.28, 5.92}, {69.64, 
         4.}, {63.76, 8.2}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{60.28, 5.92}, {69.64, 
         4.}, {63.76, 8.2}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.17255, 0., 0.82745], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{69.64, 4.}, {60.28, 
         5.92}, {66.76, 4.48}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{69.64, 4.}, {60.28, 
         5.92}, {66.76, 4.48}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.92549, 0., 0.07451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{73.72, 49.}, {
         61.839999999999996`, 50.32}, {62.8, 36.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{73.72, 49.}, {
         61.839999999999996`, 50.32}, {62.8, 36.28}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.92549, 0., 0.07451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{61.839999999999996`, 
         50.32}, {73.72, 49.}, {74.44, 63.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{61.839999999999996`, 
         50.32}, {73.72, 49.}, {74.44, 63.64}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.92549, 0., 0.07451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{74.44000000000001, 
         63.64}, {62.56000000000001, 65.2}, {61.84000000000001, 50.32}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{74.44000000000001, 
         63.64}, {62.56000000000001, 65.2}, {61.84000000000001, 50.32}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8549000000000001, 0., 0.1451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{62.56, 65.2}, {74.44, 
         63.64}, {76.6, 78.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{62.56, 65.2}, {74.44, 
         63.64}, {76.6, 78.28}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8549000000000001, 0., 0.1451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{76.6, 78.28}, {
         64.83999999999999, 80.08}, {62.559999999999995`, 65.2}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{76.6, 78.28}, {
         64.83999999999999, 80.08}, {62.559999999999995`, 65.2}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8549000000000001, 0., 0.1451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{74.44000000000001, 
         35.32}, {62.80000000000001, 36.28}, {65.20000000000002, 24.04}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{74.44000000000001, 
         35.32}, {62.80000000000001, 36.28}, {65.20000000000002, 24.04}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.92549, 0., 0.07451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{62.8, 36.28}, {74.44, 
         35.32}, {73.72, 49.}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{62.8, 36.28}, {74.44, 
         35.32}, {73.72, 49.}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.35294, 0., 0.64706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{63.04, 108.28}, {73.6, 
         106.72}, {79.47999999999999, 117.04}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{63.04, 108.28}, {73.6, 
         106.72}, {79.47999999999999, 117.04}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.35294, 0., 0.64706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{79.48, 117.04}, {69.04, 
         118.48}, {63.040000000000006`, 108.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{79.48, 117.04}, {69.04, 
         118.48}, {63.040000000000006`, 108.28}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.023528999999999998`, 0., 0.97647], Opacity[1.]}],
         FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{63.28, 131.08}, {72.88, 
         131.08}, {79.72, 132.52}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{63.28, 131.08}, {72.88, 
         131.08}, {79.72, 132.52}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.023528999999999998`, 0., 0.97647], Opacity[1.]}],
         FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{79.72, 132.52}, {70.24, 
         132.52}, {63.28, 131.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{79.72, 132.52}, {70.24, 
         132.52}, {63.28, 131.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.35294, 0., 0.64706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{73.96000000000001, 7.}, {
         63.760000000000005`, 8.2}, {69.64000000000001, 4.}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{73.96000000000001, 7.}, {
         63.760000000000005`, 8.2}, {69.64000000000001, 4.}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5529400000000001, 0., 0.44706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{63.760000000000005`, 
         8.2}, {73.96000000000001, 6.999999999999999}, {69.04, 14.2}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{63.760000000000005`, 
         8.2}, {73.96000000000001, 6.999999999999999}, {69.04, 14.2}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.71765, 0., 0.28235000000000005`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{64.84, 80.08}, {
         76.60000000000001, 78.28}, {80.32000000000001, 92.2}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{64.84, 80.08}, {
         76.60000000000001, 78.28}, {80.32000000000001, 92.2}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.71765, 0., 0.28235000000000005`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{80.32, 92.2}, {
         68.55999999999999, 94.24000000000001}, {64.83999999999999, 
         80.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{80.32, 92.2}, {
         68.55999999999999, 94.24000000000001}, {64.83999999999999, 80.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.71765, 0., 0.28235000000000005`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{76.84, 23.32}, {65.2, 
         24.04}, {69.04, 14.200000000000001`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{76.84, 23.32}, {65.2, 
         24.04}, {69.04, 14.200000000000001`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8549000000000001, 0., 0.1451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{65.2, 24.04}, {76.84, 
         23.32}, {74.44, 35.32}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{65.2, 24.04}, {76.84, 
         23.32}, {74.44, 35.32}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.054902000000000006`, 0., 0.9451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{65.92, 126.76}, {75.76, 
         125.92}, {82.48, 130.48000000000002`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{65.92, 126.76}, {75.76, 
         125.92}, {82.48, 130.48000000000002`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.054902000000000006`, 0., 0.9451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{82.48, 
         130.48000000000002`}, {72.88000000000001, 131.08}, {65.92, 
         126.76000000000002`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{82.48, 
         130.48000000000002`}, {72.88000000000001, 131.08}, {65.92, 
         126.76000000000002`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.17255, 0., 0.82745], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{66.76, 4.48}, {76., 
         2.6800000000000006`}, {69.64, 4.}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{66.76, 4.48}, {76., 
         2.6800000000000006`}, {69.64, 4.}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5451, 0., 0.4549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{68.56, 
         94.24000000000001}, {80.32000000000001, 92.2}, {85.12, 104.56}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{68.56, 
         94.24000000000001}, {80.32000000000001, 92.2}, {85.12, 104.56}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5451, 0., 0.4549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{85.11999999999999, 
         104.56}, {73.6, 106.72}, {68.55999999999999, 94.24000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{85.11999999999999, 
         104.56}, {73.6, 106.72}, {68.55999999999999, 94.24000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.18431, 0., 0.8156900000000001], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{69.04, 118.48}, {79.48, 
         117.04}, {85.96000000000001, 124.48}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{69.04, 118.48}, {79.48, 
         117.04}, {85.96000000000001, 124.48}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.18431, 0., 0.8156900000000001], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{85.96000000000001, 
         124.48}, {75.76, 125.92}, {69.04, 118.48}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{85.96000000000001, 
         124.48}, {75.76, 125.92}, {69.04, 118.48}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5451, 0., 0.4549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{80.32, 13.6}, {
         69.03999999999999, 14.2}, {73.96, 7.}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{80.32, 13.6}, {
         69.03999999999999, 14.2}, {73.96, 7.}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.71765, 0., 0.28235000000000005`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{69.04, 14.2}, {
         80.32000000000001, 13.6}, {76.84, 23.32}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{69.04, 14.2}, {
         80.32000000000001, 13.6}, {76.84, 23.32}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.35294, 0., 0.64706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{69.64, 4.}, {79.6, 
         2.6799999999999997`}, {73.96, 7.}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{69.64, 4.}, {79.6, 
         2.6799999999999997`}, {73.96, 7.}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.18431, 0., 0.8156900000000001], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{79.6, 2.68}, {
         69.63999999999999, 4.}, {76., 2.68}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{79.6, 2.68}, {
         69.63999999999999, 4.}, {76., 2.68}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.011764999999999998`, 0., 0.98824], Opacity[1.]}],
         FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{72.88, 131.08}, {
         82.47999999999999, 130.48000000000002`}, {89.19999999999999, 
         131.92000000000002`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{72.88, 131.08}, {
         82.47999999999999, 130.48000000000002`}, {89.19999999999999, 
         131.92000000000002`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.011764999999999998`, 0., 0.98824], Opacity[1.]}],
         FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{89.2, 
         131.92000000000002`}, {79.72, 132.52}, {72.88, 131.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{89.2, 
         131.92000000000002`}, {79.72, 132.52}, {72.88, 131.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{73.6, 106.72}, {
         85.11999999999999, 104.56}, {90.63999999999999, 114.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{73.6, 106.72}, {
         85.11999999999999, 104.56}, {90.63999999999999, 114.64}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{90.64, 114.64}, {79.48, 
         117.04}, {73.6, 106.72}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{90.64, 114.64}, {79.48, 
         117.04}, {73.6, 106.72}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8705900000000001, 0., 0.12941000000000003`], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{86.67999999999999, 
         48.04}, {73.72, 49.}, {74.44, 35.32}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{86.67999999999999, 
         48.04}, {73.72, 49.}, {74.44, 35.32}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8705900000000001, 0., 0.12941000000000003`], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{73.72, 49.}, {86.68, 
         48.04}, {87.4, 62.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{73.72, 49.}, {86.68, 
         48.04}, {87.4, 62.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8705900000000001, 0., 0.12941000000000003`], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{87.4, 62.08}, {74.44, 
         63.64}, {73.72, 49.}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{87.4, 62.08}, {74.44, 
         63.64}, {73.72, 49.}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{84.88, 6.52}, {73.96, 
         7.}, {79.6, 2.6799999999999997`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{84.88, 6.52}, {73.96, 
         7.}, {79.6, 2.6799999999999997`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5451, 0., 0.4549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{73.96000000000001, 7.}, {
         84.88000000000001, 6.52}, {80.32000000000001, 13.6}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{73.96000000000001, 7.}, {
         84.88000000000001, 6.52}, {80.32000000000001, 13.6}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8078400000000001, 0., 0.19216], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{74.44000000000001, 
         63.64}, {87.4, 62.08}, {89.68, 76.12}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{74.44000000000001, 
         63.64}, {87.4, 62.08}, {89.68, 76.12}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8078400000000001, 0., 0.19216], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{89.67999999999999, 
         76.11999999999999}, {76.6, 78.27999999999999}, {74.44, 
         63.639999999999986`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{89.67999999999999, 
         76.11999999999999}, {76.6, 78.27999999999999}, {74.44, 
         63.639999999999986`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8078400000000001, 0., 0.19216], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{87.4, 34.96}, {74.44, 
         35.32}, {76.84, 23.32}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{87.4, 34.96}, {74.44, 
         35.32}, {76.84, 23.32}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8705900000000001, 0., 0.12941000000000003`], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{74.44000000000001, 
         35.32}, {87.4, 34.96}, {86.68, 48.04}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{74.44000000000001, 
         35.32}, {87.4, 34.96}, {86.68, 48.04}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.066667, 0., 0.93333], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{75.76, 125.92}, {
         85.96000000000001, 124.48}, {92.56, 129.04}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{75.76, 125.92}, {
         85.96000000000001, 124.48}, {92.56, 129.04}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.066667, 0., 0.93333], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{92.56, 129.04}, {82.48, 
         130.48}, {75.76, 125.91999999999999`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{92.56, 129.04}, {82.48, 
         130.48}, {75.76, 125.91999999999999`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.18431, 0., 0.8156900000000001], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{76., 2.68}, {85.6, 
         1.36}, {79.6, 2.68}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{76., 2.68}, {85.6, 
         1.36}, {79.6, 2.68}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.6901999999999999, 0., 0.3098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{76.6, 78.28}, {
         89.67999999999999, 76.12}, {93.03999999999999, 89.44}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{76.6, 78.28}, {
         89.67999999999999, 76.12}, {93.03999999999999, 89.44}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.6901999999999999, 0., 0.3098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{93.04, 
         89.44000000000001}, {80.32000000000001, 92.20000000000002}, {
         76.60000000000001, 78.28000000000002}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{93.04, 
         89.44000000000001}, {80.32000000000001, 92.20000000000002}, {
         76.60000000000001, 78.28000000000002}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.6901999999999999, 0., 0.3098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{89.32, 23.56}, {
         76.83999999999999, 23.32}, {80.32, 13.599999999999998`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{89.32, 23.56}, {
         76.83999999999999, 23.32}, {80.32, 13.599999999999998`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8078400000000001, 0., 0.19216], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{76.84, 23.32}, {
         89.32000000000001, 23.56}, {87.4, 34.96}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{76.84, 23.32}, {
         89.32000000000001, 23.56}, {87.4, 34.96}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.20784000000000002`, 0., 0.7921599999999999], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{79.48, 117.04}, {90.64, 
         114.64}, {96.76, 122.08000000000001`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{79.48, 117.04}, {90.64, 
         114.64}, {96.76, 122.08000000000001`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.20784000000000002`, 0., 0.7921599999999999], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{96.76, 122.08}, {
         85.96000000000001, 124.48}, {79.48, 117.03999999999999`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{96.76, 122.08}, {
         85.96000000000001, 124.48}, {79.48, 117.03999999999999`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{79.6, 2.68}, {90.16, 
         2.44}, {84.88, 6.52}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{79.6, 2.68}, {90.16, 
         2.44}, {84.88, 6.52}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.20784000000000002`, 0., 0.7921599999999999], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{90.16, 2.44}, {79.6, 
         2.68}, {85.6, 1.3599999999999999`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{90.16, 2.44}, {79.6, 
         2.68}, {85.6, 1.3599999999999999`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53725, 0., 0.46275], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{80.32, 92.2}, {
         93.03999999999999, 89.44}, {97.47999999999999, 
         101.32000000000001`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{80.32, 92.2}, {
         93.03999999999999, 89.44}, {97.47999999999999, 101.32000000000001`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53725, 0., 0.46275], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{97.48, 101.32}, {85.12, 
         104.55999999999999`}, {80.32000000000001, 92.19999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{97.48, 101.32}, {85.12, 
         104.55999999999999`}, {80.32000000000001, 92.19999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53725, 0., 0.46275], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{92.56, 14.2}, {
         80.32000000000001, 13.6}, {84.88, 6.52}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{92.56, 14.2}, {
         80.32000000000001, 13.6}, {84.88, 6.52}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.6901999999999999, 0., 0.3098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{80.32, 13.6}, {
         92.55999999999999, 14.2}, {89.32, 23.560000000000002`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{80.32, 13.6}, {
         92.55999999999999, 14.2}, {89.32, 23.560000000000002`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.023528999999999998`, 0., 0.97647], Opacity[1.]}],
         FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{82.48, 
         130.48000000000002`}, {92.56, 129.04000000000002`}, {99.04, 
         130.60000000000002`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{82.48, 
         130.48000000000002`}, {92.56, 129.04000000000002`}, {99.04, 
         130.60000000000002`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.023528999999999998`, 0., 0.97647], Opacity[1.]}],
         FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{99.04, 130.6}, {89.2, 
         131.92}, {82.48, 130.48}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{99.04, 130.6}, {89.2, 
         131.92}, {82.48, 130.48}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.38431000000000004`, 0., 0.6156900000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{96.76, 
         7.359999999999999}, {84.88000000000001, 6.52}, {90.16000000000001, 
         2.4399999999999995`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{96.76, 
         7.359999999999999}, {84.88000000000001, 6.52}, {90.16000000000001, 
         2.4399999999999995`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53725, 0., 0.46275], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{84.88, 6.52}, {
         96.75999999999999, 7.359999999999999}, {92.56, 14.2}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{84.88, 6.52}, {
         96.75999999999999, 7.359999999999999}, {92.56, 14.2}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.38431000000000004`, 0., 0.6156900000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{85.11999999999999, 
         104.56}, {97.47999999999999, 101.32000000000001`}, {
         102.63999999999999`, 111.04}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{85.11999999999999, 
         104.56}, {97.47999999999999, 101.32000000000001`}, {
         102.63999999999999`, 111.04}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.38431000000000004`, 0., 0.6156900000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{102.64, 111.04}, {90.64, 
         114.64}, {85.12, 104.56}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{102.64, 111.04}, {90.64, 
         114.64}, {85.12, 104.56}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.20784000000000002`, 0., 0.7921599999999999], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{85.6, 1.36}, {
         95.91999999999999, 1.12}, {90.16, 2.4400000000000004`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{85.6, 1.36}, {
         95.91999999999999, 1.12}, {90.16, 2.4400000000000004`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.10196000000000001`, 0., 0.8980400000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{85.96000000000001, 
         124.48}, {96.76, 122.08}, {103.12, 126.52000000000001`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{85.96000000000001, 
         124.48}, {96.76, 122.08}, {103.12, 126.52000000000001`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.10196000000000001`, 0., 0.8980400000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{103.11999999999999`, 
         126.52}, {92.55999999999999, 129.04}, {85.96, 
         124.47999999999999`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{103.11999999999999`, 
         126.52}, {92.55999999999999, 129.04}, {85.96, 124.47999999999999`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8, 0., 0.2], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{100.84, 47.68}, {86.68, 
         48.04}, {87.4, 34.96}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{100.84, 47.68}, {86.68, 
         48.04}, {87.4, 34.96}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8, 0., 0.2], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{86.67999999999999, 
         48.04}, {100.83999999999999`, 47.68}, {101.55999999999999`, 
         60.519999999999996`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{86.67999999999999, 
         48.04}, {100.83999999999999`, 47.68}, {101.55999999999999`, 
         60.519999999999996`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8, 0., 0.2], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{101.56, 60.52}, {87.4, 
         62.080000000000005`}, {86.68, 48.040000000000006`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{101.56, 60.52}, {87.4, 
         62.080000000000005`}, {86.68, 48.040000000000006`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7451, 0., 0.2549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{101.32, 35.56}, {
         87.39999999999999, 34.96}, {89.32, 23.560000000000002`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{101.32, 35.56}, {
         87.39999999999999, 34.96}, {89.32, 23.560000000000002`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.8, 0., 0.2], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{87.4, 34.96}, {
         101.32000000000001`, 35.56}, {100.84, 47.68}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{87.4, 34.96}, {
         101.32000000000001`, 35.56}, {100.84, 47.68}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7451, 0., 0.2549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{87.4, 62.08}, {101.56, 
         60.519999999999996`}, {103.60000000000001`, 73.48}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{87.4, 62.08}, {101.56, 
         60.519999999999996`}, {103.60000000000001`, 73.48}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7451, 0., 0.2549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{103.6, 73.48}, {
         89.67999999999999, 76.12}, {87.39999999999999, 
         62.080000000000005`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{103.6, 73.48}, {
         89.67999999999999, 76.12}, {87.39999999999999, 62.080000000000005`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.65098, 0., 0.34902], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{103., 25.}, {89.32, 
         23.56}, {92.56, 14.2}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{103., 25.}, {89.32, 
         23.56}, {92.56, 14.2}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7451, 0., 0.2549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{89.32, 23.56}, {103., 
         25.}, {101.32, 35.56}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{89.32, 23.56}, {103., 
         25.}, {101.32, 35.56}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.65098, 0., 0.34902], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{89.67999999999999, 
         76.11999999999999}, {103.6, 73.47999999999999}, {106.6, 
         85.83999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{89.67999999999999, 
         76.11999999999999}, {103.6, 73.47999999999999}, {106.6, 
         85.83999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.65098, 0., 0.34902], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{106.6, 85.84}, {
         93.03999999999999, 89.44}, {89.67999999999999, 76.12}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{106.6, 85.84}, {
         93.03999999999999, 89.44}, {89.67999999999999, 76.12}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.38431000000000004`, 0., 0.6156900000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{90.16, 2.44}, {101.56, 
         3.2800000000000002`}, {96.75999999999999, 7.359999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{90.16, 2.44}, {101.56, 
         3.2800000000000002`}, {96.75999999999999, 7.359999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.24706000000000003`, 0., 0.75294], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{101.56, 
         3.2800000000000002`}, {90.16, 2.4400000000000004`}, {95.92, 
         1.12}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{101.56, 
         3.2800000000000002`}, {90.16, 2.4400000000000004`}, {95.92, 1.12}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.24706000000000003`, 0., 0.75294], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{90.64, 114.64}, {102.64, 
         111.04}, {108.28, 118.24}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{90.64, 114.64}, {102.64, 
         111.04}, {108.28, 118.24}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.24706000000000003`, 0., 0.75294], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{108.28, 
         118.24000000000001`}, {96.76, 122.08000000000001`}, {90.64, 
         114.64000000000001`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{108.28, 
         118.24000000000001`}, {96.76, 122.08000000000001`}, {90.64, 
         114.64000000000001`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.06274500000000001, 0., 0.93725], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{92.56, 129.04}, {103.12, 
         126.52}, {109.24000000000001`, 128.07999999999998`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{92.56, 129.04}, {103.12, 
         126.52}, {109.24000000000001`, 128.07999999999998`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.06274500000000001, 0., 0.93725], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{109.24000000000001`, 
         128.08}, {99.04, 130.60000000000002`}, {92.56, 
         129.04000000000002`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{109.24000000000001`, 
         128.08}, {99.04, 130.60000000000002`}, {92.56, 129.04000000000002`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53333, 0., 0.46667000000000003`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{105.76, 16.24}, {92.56, 
         14.2}, {96.76, 7.359999999999998}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{105.76, 16.24}, {92.56, 
         14.2}, {96.76, 7.359999999999998}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.65098, 0., 0.34902], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{92.56, 14.2}, {105.76, 
         16.24}, {103., 25.}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{92.56, 14.2}, {105.76, 
         16.24}, {103., 25.}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53333, 0., 0.46667000000000003`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{93.04, 
         89.44000000000001}, {106.60000000000001`, 85.84000000000002}, {
         110.56, 96.76}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{93.04, 
         89.44000000000001}, {106.60000000000001`, 85.84000000000002}, {
         110.56, 96.76}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53333, 0., 0.46667000000000003`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{110.56, 96.76}, {97.48, 
         101.32000000000001`}, {93.04, 89.44000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{110.56, 96.76}, {97.48, 
         101.32000000000001`}, {93.04, 89.44000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.24706000000000003`, 0., 0.75294], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{95.92, 1.12}, {106.84, 
         2.08}, {101.56, 3.2800000000000002`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{95.92, 1.12}, {106.84, 
         2.08}, {101.56, 3.2800000000000002`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.40392000000000006`, 0., 0.5960799999999999], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{109.36, 10.}, {96.76, 
         7.359999999999999}, {101.56, 3.2800000000000002`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{109.36, 10.}, {96.76, 
         7.359999999999999}, {101.56, 3.2800000000000002`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53333, 0., 0.46667000000000003`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{96.76, 
         7.359999999999999}, {109.36, 10.}, {105.76, 16.240000000000002`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{96.76, 
         7.359999999999999}, {109.36, 10.}, {105.76, 16.240000000000002`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.15294000000000005`, 0., 0.84706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{96.76, 122.08}, {108.28, 
         118.24}, {114.16, 122.67999999999999`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{96.76, 122.08}, {108.28, 
         118.24}, {114.16, 122.67999999999999`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.15294000000000005`, 0., 0.84706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{114.16, 
         122.67999999999999`}, {103.12, 126.52}, {96.75999999999999, 
         122.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{114.16, 
         122.67999999999999`}, {103.12, 126.52}, {96.75999999999999, 122.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.40392000000000006`, 0., 0.5960799999999999], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{97.48, 101.32}, {110.56, 
         96.75999999999999}, {115.24000000000001`, 105.75999999999999`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{97.48, 101.32}, {110.56, 
         96.75999999999999}, {115.24000000000001`, 105.75999999999999`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.40392000000000006`, 0., 0.5960799999999999], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{115.24000000000001`, 
         105.76}, {102.64000000000001`, 111.04}, {97.48000000000002, 
         101.32000000000001`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{115.24000000000001`, 
         105.76}, {102.64000000000001`, 111.04}, {97.48000000000002, 
         101.32000000000001`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.10196000000000001`, 0., 0.8980400000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{99.04, 130.6}, {
         109.24000000000001`, 128.07999999999998`}, {114.88000000000001`, 
         126.88}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{99.04, 130.6}, {
         109.24000000000001`, 128.07999999999998`}, {114.88000000000001`, 
         126.88}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.10196000000000001`, 0., 0.8980400000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{114.88, 126.88}, {
         105.03999999999999`, 129.16}, {99.03999999999999, 130.6}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{114.88, 126.88}, {
         105.03999999999999`, 129.16}, {99.03999999999999, 130.6}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7215699999999999, 0., 0.27843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{115.6, 47.92}, {
         100.83999999999999`, 47.68}, {101.32, 35.56}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{115.6, 47.92}, {
         100.83999999999999`, 47.68}, {101.32, 35.56}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7215699999999999, 0., 0.27843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{116.32, 59.08}, {
         101.55999999999999`, 60.519999999999996`}, {100.83999999999999`, 
         47.68}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{116.32, 59.08}, {
         101.55999999999999`, 60.519999999999996`}, {100.83999999999999`, 
         47.68}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7215699999999999, 0., 0.27843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{100.84, 47.68}, {
         115.60000000000001`, 47.92}, {116.32000000000001`, 59.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{100.84, 47.68}, {
         115.60000000000001`, 47.92}, {116.32000000000001`, 59.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.6823499999999999, 0., 0.31765], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{115.96000000000001`, 
         37.36}, {101.32000000000001`, 35.56}, {103., 25.}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{115.96000000000001`, 
         37.36}, {101.32000000000001`, 35.56}, {103., 25.}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.7215699999999999, 0., 0.27843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{101.32, 35.56}, {115.96, 
         37.36}, {115.6, 47.92}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{101.32, 35.56}, {115.96, 
         37.36}, {115.6, 47.92}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.29804, 0., 0.7019599999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{113.67999999999999`, 
         6.159999999999999}, {101.55999999999999`, 3.2799999999999994`}, {
         106.83999999999999`, 2.079999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{113.67999999999999`, 
         6.159999999999999}, {101.55999999999999`, 3.2799999999999994`}, {
         106.83999999999999`, 2.079999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.40392000000000006`, 0., 0.5960799999999999], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{101.56, 
         3.2800000000000002`}, {113.68, 6.16}, {109.36, 10.}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{101.56, 
         3.2800000000000002`}, {113.68, 6.16}, {109.36, 10.}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.6823499999999999, 0., 0.31765], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{101.56, 60.52}, {
         116.32000000000001`, 59.080000000000005`}, {118., 70.36}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{101.56, 60.52}, {
         116.32000000000001`, 59.080000000000005`}, {118., 70.36}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.6823499999999999, 0., 0.31765], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{118., 70.36}, {103.6, 
         73.48}, {101.56, 60.519999999999996`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{118., 70.36}, {103.6, 
         73.48}, {101.56, 60.519999999999996`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.29804, 0., 0.7019599999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{102.64, 111.04}, {115.24, 
         105.76}, {120.28, 112.60000000000001`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{102.64, 111.04}, {115.24, 
         105.76}, {120.28, 112.60000000000001`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.29804, 0., 0.7019599999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{120.28, 112.6}, {108.28, 
         118.24}, {102.64, 111.03999999999999`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{120.28, 112.6}, {108.28, 
         118.24}, {102.64, 111.03999999999999`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.61176, 0., 0.38824], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{117.28, 28.12}, {103., 
         25.}, {105.76, 16.240000000000002`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{117.28, 28.12}, {103., 
         25.}, {105.76, 16.240000000000002`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.6823499999999999, 0., 0.31765], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{103., 25.}, {117.28, 
         28.12}, {115.96000000000001`, 37.36}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{103., 25.}, {117.28, 
         28.12}, {115.96000000000001`, 37.36}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.12157000000000001`, 0., 0.87843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{103.11999999999999`, 
         126.52}, {114.16, 122.67999999999999`}, {119.79999999999998`, 
         124.24}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{103.11999999999999`, 
         126.52}, {114.16, 122.67999999999999`}, {119.79999999999998`, 
         124.24}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.12157000000000001`, 0., 0.87843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{119.8, 
         124.24000000000001`}, {109.24, 128.08}, {103.12, 
         126.52000000000001`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{119.8, 
         124.24000000000001`}, {109.24, 128.08}, {103.12, 
         126.52000000000001`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.61176, 0., 0.38824], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{103.6, 73.48}, {118., 
         70.36}, {120.63999999999999`, 81.16}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{103.6, 73.48}, {118., 
         70.36}, {120.63999999999999`, 81.16}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.61176, 0., 0.38824], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{120.64, 81.16}, {106.6, 
         85.84}, {103.6, 73.47999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{120.64, 81.16}, {106.6, 
         85.84}, {103.6, 73.47999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{119.44000000000001`, 
         20.439999999999998`}, {105.76000000000002`, 16.24}, {
         109.36000000000001`, 9.999999999999998}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{119.44000000000001`, 
         20.439999999999998`}, {105.76000000000002`, 16.24}, {
         109.36000000000001`, 9.999999999999998}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.61176, 0., 0.38824], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{105.76, 16.24}, {119.44, 
         20.439999999999998`}, {117.28, 28.119999999999997`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{105.76, 16.24}, {119.44, 
         20.439999999999998`}, {117.28, 28.119999999999997`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{106.6, 85.84}, {
         120.63999999999999`, 81.16}, {124., 90.76}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{106.6, 85.84}, {
         120.63999999999999`, 81.16}, {124., 90.76}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{124., 90.76}, {110.56, 
         96.76}, {106.6, 85.84}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{124., 90.76}, {110.56, 
         96.76}, {106.6, 85.84}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.29804, 0., 0.7019599999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{106.84, 2.08}, {118.36, 
         4.96}, {113.68, 6.16}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{106.84, 2.08}, {118.36, 
         4.96}, {113.68, 6.16}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.22353, 0., 0.77647], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{108.28, 
         118.24000000000001`}, {120.28, 112.60000000000001`}, {125.44, 
         116.68}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{108.28, 
         118.24000000000001`}, {120.28, 112.60000000000001`}, {125.44, 
         116.68}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.22353, 0., 0.77647], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{125.44000000000001`, 
         116.67999999999999`}, {114.16000000000001`, 122.67999999999999`}, {
         108.28000000000002`, 118.24}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{125.44000000000001`, 
         116.67999999999999`}, {114.16000000000001`, 122.67999999999999`}, {
         108.28000000000002`, 118.24}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.15294000000000005`, 0., 0.84706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{125.08, 123.04}, {114.88, 
         126.88000000000001`}, {109.24, 128.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{125.08, 123.04}, {114.88, 
         126.88000000000001`}, {109.24, 128.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.15294000000000005`, 0., 0.84706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{109.24000000000001`, 
         128.08}, {119.80000000000001`, 124.24000000000001`}, {
         125.08000000000001`, 123.04}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{109.24000000000001`, 
         128.08}, {119.80000000000001`, 124.24000000000001`}, {
         125.08000000000001`, 123.04}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.4313700000000001, 0., 0.5686300000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{122.44000000000001`, 
         14.8}, {109.36000000000001`, 10.}, {113.68, 6.160000000000002}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{122.44000000000001`, 
         14.8}, {109.36000000000001`, 10.}, {113.68, 6.160000000000002}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{109.36, 10.}, {122.44, 
         14.8}, {119.44, 20.439999999999998`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{109.36, 10.}, {122.44, 
         14.8}, {119.44, 20.439999999999998`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.4313700000000001, 0., 0.5686300000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{110.56, 96.76}, {124., 
         90.76}, {127.96000000000001`, 98.68}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{110.56, 96.76}, {124., 
         90.76}, {127.96000000000001`, 98.68}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.4313700000000001, 0., 0.5686300000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{127.96000000000001`, 
         98.67999999999999}, {115.24000000000001`, 105.75999999999999`}, {
         110.56, 96.75999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{127.96000000000001`, 
         98.67999999999999}, {115.24000000000001`, 105.75999999999999`}, {
         110.56, 96.75999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.34902, 0., 0.65098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{125.92, 11.44}, {113.68, 
         6.159999999999999}, {118.36, 4.959999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{125.92, 11.44}, {113.68, 
         6.159999999999999}, {118.36, 4.959999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.4313700000000001, 0., 0.5686300000000001], 
        Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{113.67999999999999`, 
         6.159999999999999}, {125.91999999999999`, 11.44}, {122.44, 
         14.799999999999997`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{113.67999999999999`, 
         6.159999999999999}, {125.91999999999999`, 11.44}, {122.44, 
         14.799999999999997`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.19608, 0., 0.8039200000000001], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{114.16, 
         122.67999999999999`}, {125.44, 116.67999999999999`}, {130.48, 
         118.24}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{114.16, 
         122.67999999999999`}, {125.44, 116.67999999999999`}, {130.48, 
         118.24}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.19608, 0., 0.8039200000000001], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{130.48000000000002`, 
         118.24000000000001`}, {119.80000000000001`, 124.24000000000001`}, {
         114.16000000000003`, 122.68}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{130.48000000000002`, 
         118.24000000000001`}, {119.80000000000001`, 124.24000000000001`}, {
         114.16000000000003`, 122.68}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.34902, 0., 0.65098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{115.24000000000001`, 
         105.76}, {127.96000000000001`, 98.68}, {132.16, 104.68}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{115.24000000000001`, 
         105.76}, {127.96000000000001`, 98.68}, {132.16, 104.68}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.34902, 0., 0.65098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{132.16, 
         104.67999999999999`}, {120.28, 112.6}, {115.24, 
         105.75999999999999`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{132.16, 
         104.67999999999999`}, {120.28, 112.6}, {115.24, 
         105.75999999999999`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.64314, 0., 0.35686], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{130.12, 49.}, {
         115.60000000000001`, 47.92}, {115.96000000000001`, 37.36}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{130.12, 49.}, {
         115.60000000000001`, 47.92}, {115.96000000000001`, 37.36}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.64314, 0., 0.35686], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{115.6, 47.92}, {130.12, 
         49.}, {130.72, 57.88}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{115.6, 47.92}, {130.12, 
         49.}, {130.72, 57.88}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.64314, 0., 0.35686], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{130.72, 
         57.879999999999995`}, {116.32, 59.08}, {115.6, 
         47.919999999999995`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{130.72, 
         57.879999999999995`}, {116.32, 59.08}, {115.6, 47.919999999999995`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.61961, 0., 0.38039], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{130.36, 40.48}, {
         115.96000000000001`, 37.36}, {117.28000000000002`, 
         28.119999999999997`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{130.36, 40.48}, {
         115.96000000000001`, 37.36}, {117.28000000000002`, 
         28.119999999999997`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.64314, 0., 0.35686], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{115.96000000000001`, 
         37.36}, {130.36, 40.48}, {130.12, 49.}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{115.96000000000001`, 
         37.36}, {130.36, 40.48}, {130.12, 49.}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.61961, 0., 0.38039], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{116.32, 59.08}, {130.72, 
         57.879999999999995`}, {132.04, 67.}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{116.32, 59.08}, {130.72, 
         57.879999999999995`}, {132.04, 67.}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.61961, 0., 0.38039], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{132.04, 67.}, {118., 
         70.36}, {116.32, 59.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{132.04, 67.}, {118., 
         70.36}, {116.32, 59.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.57255, 0., 0.42745000000000005`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{131.32000000000002`, 
         33.04}, {117.28000000000003`, 28.119999999999997`}, {
         119.44000000000003`, 20.439999999999998`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{131.32000000000002`, 
         33.04}, {117.28000000000003`, 28.119999999999997`}, {
         119.44000000000003`, 20.439999999999998`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.61961, 0., 0.38039], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{117.28, 28.12}, {131.32, 
         33.04}, {130.36, 40.480000000000004`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{117.28, 28.12}, {131.32, 
         33.04}, {130.36, 40.480000000000004`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.57255, 0., 0.42745000000000005`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{118., 70.36}, {132.04, 
         67.}, {134.2, 75.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{118., 70.36}, {132.04, 
         67.}, {134.2, 75.64}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.57255, 0., 0.42745000000000005`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{134.2, 75.64}, {
         120.63999999999999`, 81.16}, {117.99999999999999`, 70.36}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{134.2, 75.64}, {
         120.63999999999999`, 81.16}, {117.99999999999999`, 70.36}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.29412000000000005`, 0., 0.70588], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{129.88000000000002`, 
         10.239999999999998`}, {118.36000000000003`, 4.959999999999998}, {
         123.16000000000003`, 6.2799999999999985`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{129.88000000000002`, 
         10.239999999999998`}, {118.36000000000003`, 4.959999999999998}, {
         123.16000000000003`, 6.2799999999999985`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.34902, 0., 0.65098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{118.36, 4.96}, {129.88, 
         10.24}, {125.92, 11.440000000000001`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{118.36, 4.96}, {129.88, 
         10.24}, {125.92, 11.440000000000001`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.51765, 0., 0.48235000000000006`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{132.88000000000002`, 
         26.8}, {119.44000000000003`, 20.44}, {122.44000000000003`, 14.8}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{132.88000000000002`, 
         26.8}, {119.44000000000003`, 20.44}, {122.44000000000003`, 14.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.57255, 0., 0.42745000000000005`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{119.44000000000001`, 
         20.439999999999998`}, {132.88000000000002`, 26.799999999999997`}, {
         131.32000000000002`, 33.04}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{119.44000000000001`, 
         20.439999999999998`}, {132.88000000000002`, 26.799999999999997`}, {
         131.32000000000002`, 33.04}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.22353, 0., 0.77647], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{135.16, 117.4}, {125.08, 
         123.04}, {119.8, 124.24000000000001`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{135.16, 117.4}, {125.08, 
         123.04}, {119.8, 124.24000000000001`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.22353, 0., 0.77647], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{119.8, 
         124.24000000000001`}, {130.48, 118.24000000000001`}, {135.16, 
         117.4}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{119.8, 
         124.24000000000001`}, {130.48, 118.24000000000001`}, {135.16, 
         117.4}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.29412000000000005`, 0., 0.70588], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{120.28, 112.6}, {132.16, 
         104.67999999999999`}, {136.48, 108.52}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{120.28, 112.6}, {132.16, 
         104.67999999999999`}, {136.48, 108.52}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.29412000000000005`, 0., 0.70588], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{136.48000000000002`, 
         108.52}, {125.44000000000003`, 116.67999999999999`}, {
         120.28000000000002`, 112.6}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{136.48000000000002`, 
         108.52}, {125.44000000000003`, 116.67999999999999`}, {
         120.28000000000002`, 112.6}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.51765, 0., 0.48235000000000006`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{120.64, 81.16}, {134.2, 
         75.64}, {136.72, 83.32}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{120.64, 81.16}, {134.2, 
         75.64}, {136.72, 83.32}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.51765, 0., 0.48235000000000006`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{136.72, 83.32}, {124., 
         90.75999999999999}, {120.64, 81.16}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{136.72, 83.32}, {124., 
         90.75999999999999}, {120.64, 81.16}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.4549, 0., 0.5451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{135.16, 22.24}, {122.44, 
         14.799999999999997`}, {125.92, 11.439999999999998`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{135.16, 22.24}, {122.44, 
         14.799999999999997`}, {125.92, 11.439999999999998`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.51765, 0., 0.48235000000000006`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{122.44000000000001`, 
         14.8}, {135.16000000000003`, 22.240000000000002`}, {
         132.88000000000002`, 26.8}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{122.44000000000001`, 
         14.8}, {135.16000000000003`, 22.240000000000002`}, {
         132.88000000000002`, 26.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.29412000000000005`, 0., 0.70588], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{123.16, 6.28}, {133.96, 
         11.32}, {129.88, 10.24}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{123.16, 6.28}, {133.96, 
         11.32}, {129.88, 10.24}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.4549, 0., 0.5451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{124., 90.76}, {136.72, 
         83.32000000000001}, {139.72, 89.80000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{124., 90.76}, {136.72, 
         83.32000000000001}, {139.72, 89.80000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.4549, 0., 0.5451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{139.72, 89.8}, {127.96, 
         98.67999999999999}, {124., 90.75999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{139.72, 89.8}, {127.96, 
         98.67999999999999}, {124., 90.75999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.27451000000000003`, 0., 0.72549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{125.44000000000001`, 
         116.67999999999999`}, {136.48000000000002`, 108.52}, {140.68, 
         110.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{125.44000000000001`, 
         116.67999999999999`}, {136.48000000000002`, 108.52}, {140.68, 
         110.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.27451000000000003`, 0., 0.72549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{140.68, 110.08}, {
         130.48000000000002`, 118.24}, {125.44000000000001`, 
         116.67999999999999`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{140.68, 110.08}, {
         130.48000000000002`, 118.24}, {125.44000000000001`, 
         116.67999999999999`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.39608000000000004`, 0., 0.60392], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{137.8, 19.36}, {
         125.92000000000002`, 11.44}, {129.88000000000002`, 10.24}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{137.8, 19.36}, {
         125.92000000000002`, 11.44}, {129.88000000000002`, 10.24}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.4549, 0., 0.5451], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{125.92, 11.44}, {137.8, 
         19.36}, {135.16, 22.240000000000002`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{125.92, 11.44}, {137.8, 
         19.36}, {135.16, 22.240000000000002`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.39608000000000004`, 0., 0.60392], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{127.96000000000001`, 
         98.67999999999999}, {139.72, 89.8}, {142.96, 94.72}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{127.96000000000001`, 
         98.67999999999999}, {139.72, 89.8}, {142.96, 94.72}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.39608000000000004`, 0., 0.60392], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{142.96, 94.72}, {132.16, 
         104.68}, {127.96000000000001`, 98.67999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{142.96, 94.72}, {132.16, 
         104.68}, {127.96000000000001`, 98.67999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{140.8, 
         18.279999999999998`}, {129.88000000000002`, 10.239999999999998`}, {
         133.96, 11.319999999999997`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{140.8, 
         18.279999999999998`}, {129.88000000000002`, 10.239999999999998`}, {
         133.96, 11.319999999999997`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.39608000000000004`, 0., 0.60392], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{129.88000000000002`, 
         10.239999999999998`}, {140.8, 18.279999999999998`}, {137.8, 
         19.36}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{129.88000000000002`, 
         10.239999999999998`}, {140.8, 18.279999999999998`}, {137.8, 19.36}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.58039, 0., 0.41961000000000004`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{143.32000000000002`, 
         50.8}, {130.12000000000003`, 49.}, {130.36, 40.48}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{143.32000000000002`, 
         50.8}, {130.12000000000003`, 49.}, {130.36, 40.48}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.58039, 0., 0.41961000000000004`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{130.12, 49.}, {143.32, 
         50.8}, {143.8, 57.04}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{130.12, 49.}, {143.32, 
         50.8}, {143.8, 57.04}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.58039, 0., 0.41961000000000004`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{143.8, 57.04}, {130.72, 
         57.88}, {130.12, 49.}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{143.8, 57.04}, {130.72, 
         57.88}, {130.12, 49.}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.56471, 0., 0.43529], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{143.32000000000002`, 
         44.92}, {130.36, 40.480000000000004`}, {131.32000000000002`, 
         33.04}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{143.32000000000002`, 
         44.92}, {130.36, 40.480000000000004`}, {131.32000000000002`, 33.04}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.58039, 0., 0.41961000000000004`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{130.36, 40.48}, {
         143.32000000000002`, 44.919999999999995`}, {143.32000000000002`, 
         50.8}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{130.36, 40.48}, {
         143.32000000000002`, 44.919999999999995`}, {143.32000000000002`, 
         50.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.29412000000000005`, 0., 0.70588], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{144.64, 109.36}, {135.16, 
         117.4}, {130.48, 118.24}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{144.64, 109.36}, {135.16, 
         117.4}, {130.48, 118.24}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.29412000000000005`, 0., 0.70588], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{130.48000000000002`, 
         118.24000000000001`}, {140.68, 110.08000000000001`}, {
         144.64000000000001`, 109.36000000000001`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{130.48000000000002`, 
         118.24000000000001`}, {140.68, 110.08000000000001`}, {
         144.64000000000001`, 109.36000000000001`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.56471, 0., 0.43529], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{130.72, 
         57.879999999999995`}, {143.8, 57.03999999999999}, {144.64, 
         63.39999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{130.72, 
         57.879999999999995`}, {143.8, 57.03999999999999}, {144.64, 
         63.39999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.56471, 0., 0.43529], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{144.64, 63.4}, {132.04, 
         67.}, {130.72, 57.879999999999995`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{144.64, 63.4}, {132.04, 
         67.}, {130.72, 57.879999999999995`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.54118, 0., 0.45882000000000006`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{143.92000000000002`, 
         39.760000000000005`}, {131.32000000000002`, 33.040000000000006`}, {
         132.88000000000002`, 26.800000000000004`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{143.92000000000002`, 
         39.760000000000005`}, {131.32000000000002`, 33.040000000000006`}, {
         132.88000000000002`, 26.800000000000004`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.56471, 0., 0.43529], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{131.32000000000002`, 
         33.04}, {143.92000000000002`, 39.76}, {143.32000000000002`, 
         44.92}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{131.32000000000002`, 
         33.04}, {143.92000000000002`, 39.76}, {143.32000000000002`, 44.92}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.54118, 0., 0.45882000000000006`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{132.04, 67.}, {144.64, 
         63.4}, {145.95999999999998`, 69.4}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{132.04, 67.}, {144.64, 
         63.4}, {145.95999999999998`, 69.4}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.54118, 0., 0.45882000000000006`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{145.96, 69.4}, {
         134.20000000000002`, 75.64}, {132.04000000000002`, 67.}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{145.96, 69.4}, {
         134.20000000000002`, 75.64}, {132.04000000000002`, 67.}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{132.16, 
         104.67999999999999`}, {142.96, 94.72}, {146.32, 97.96}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{132.16, 
         104.67999999999999`}, {142.96, 94.72}, {146.32, 97.96}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{146.32000000000002`, 
         97.96000000000001}, {136.48000000000002`, 108.52000000000001`}, {
         132.16000000000003`, 104.68}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{146.32000000000002`, 
         97.96000000000001}, {136.48000000000002`, 108.52000000000001`}, {
         132.16000000000003`, 104.68}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.51373, 0., 0.48627000000000004`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{145., 35.32}, {132.88, 
         26.8}, {135.16, 22.240000000000002`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{145., 35.32}, {132.88, 
         26.8}, {135.16, 22.240000000000002`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.54118, 0., 0.45882000000000006`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{132.88000000000002`, 
         26.8}, {145.00000000000003`, 35.32}, {143.92000000000002`, 
         39.760000000000005`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{132.88000000000002`, 
         26.8}, {145.00000000000003`, 35.32}, {143.92000000000002`, 
         39.760000000000005`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.35294, 0., 0.64706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{144.04, 19.}, {
         133.95999999999998`, 11.32}, {138.04, 14.32}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{144.04, 19.}, {
         133.95999999999998`, 11.32}, {138.04, 14.32}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{133.96, 11.32}, {
         144.04000000000002`, 19.}, {140.8, 18.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{133.96, 11.32}, {
         144.04000000000002`, 19.}, {140.8, 18.28}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.51373, 0., 0.48627000000000004`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{134.2, 75.64}, {
         145.95999999999998`, 69.4}, {147.76, 74.68}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{134.2, 75.64}, {
         145.95999999999998`, 69.4}, {147.76, 74.68}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.51373, 0., 0.48627000000000004`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{147.76, 
         74.67999999999999}, {136.72, 83.32}, {134.2, 75.63999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{147.76, 
         74.67999999999999}, {136.72, 83.32}, {134.2, 75.63999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47451000000000004`, 0., 0.52549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{146.44, 32.08}, {135.16, 
         22.24}, {137.8, 19.36}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{146.44, 32.08}, {135.16, 
         22.24}, {137.8, 19.36}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.51373, 0., 0.48627000000000004`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{135.16, 22.24}, {146.44, 
         32.08}, {145., 35.32}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{135.16, 22.24}, {146.44, 
         32.08}, {145., 35.32}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.34902, 0., 0.65098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{148.12, 106.48}, {139.24, 
         114.04}, {135.16, 117.4}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{148.12, 106.48}, {139.24, 
         114.04}, {135.16, 117.4}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.34902, 0., 0.65098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{135.16, 117.4}, {144.64, 
         109.36000000000001`}, {148.12, 106.48}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{135.16, 117.4}, {144.64, 
         109.36000000000001`}, {148.12, 106.48}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.35294, 0., 0.64706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{136.48000000000002`, 
         108.52}, {146.32000000000002`, 97.96}, {149.68, 99.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{136.48000000000002`, 
         108.52}, {146.32000000000002`, 97.96}, {149.68, 99.28}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.35294, 0., 0.64706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{149.68, 99.28}, {140.68, 
         110.08}, {136.48000000000002`, 108.52}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{149.68, 99.28}, {140.68, 
         110.08}, {136.48000000000002`, 108.52}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47451000000000004`, 0., 0.52549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{136.72, 83.32}, {147.76, 
         74.67999999999999}, {149.8, 79.36}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{136.72, 83.32}, {147.76, 
         74.67999999999999}, {149.8, 79.36}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47451000000000004`, 0., 0.52549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{149.8, 79.36}, {139.72, 
         89.8}, {136.72, 83.32}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{149.8, 79.36}, {139.72, 
         89.8}, {136.72, 83.32}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.44314, 0., 0.55686], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{148.23999999999998`, 
         29.919999999999998`}, {137.79999999999998`, 19.36}, {
         140.79999999999998`, 18.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{148.23999999999998`, 
         29.919999999999998`}, {137.79999999999998`, 19.36}, {
         140.79999999999998`, 18.28}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47451000000000004`, 0., 0.52549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{137.8, 19.36}, {148.24, 
         29.92}, {146.44, 32.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{137.8, 19.36}, {148.24, 
         29.92}, {146.44, 32.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.35294, 0., 0.64706], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{138.04, 14.32}, {147.28, 
         21.4}, {144.04, 19.}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{138.04, 14.32}, {147.28, 
         21.4}, {144.04, 19.}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.44314, 0., 0.55686], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{139.72, 89.8}, {149.8, 
         79.36}, {152.08, 82.84}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{139.72, 89.8}, {149.8, 
         79.36}, {152.08, 82.84}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.44314, 0., 0.55686], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{152.08, 82.84}, {142.96, 
         94.72}, {139.72, 89.8}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{152.08, 82.84}, {142.96, 
         94.72}, {139.72, 89.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{152.68, 98.8}, {
         144.64000000000001`, 109.36}, {140.68, 110.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{152.68, 98.8}, {
         144.64000000000001`, 109.36}, {140.68, 110.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.36471, 0., 0.63529], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{140.68, 110.08}, {149.68, 
         99.28}, {152.68, 98.8}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{140.68, 110.08}, {149.68, 
         99.28}, {152.68, 98.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.42745000000000005`, 0., 0.57255], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{150.28, 29.08}, {140.8, 
         18.279999999999998`}, {144.04, 19.}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{150.28, 29.08}, {140.8, 
         18.279999999999998`}, {144.04, 19.}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.44314, 0., 0.55686], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{140.8, 
         18.279999999999998`}, {150.28, 29.08}, {148.24, 
         29.919999999999995`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{140.8, 
         18.279999999999998`}, {150.28, 29.08}, {148.24, 
         29.919999999999995`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.42745000000000005`, 0., 0.57255], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{142.96, 94.72}, {152.08, 
         82.84}, {154.24, 85.24}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{142.96, 94.72}, {152.08, 
         82.84}, {154.24, 85.24}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.42745000000000005`, 0., 0.57255], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{154.23999999999998`, 
         85.24000000000001}, {146.32, 97.96000000000001}, {
         142.95999999999998`, 94.72000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{154.23999999999998`, 
         85.24000000000001}, {146.32, 97.96000000000001}, {
         142.95999999999998`, 94.72000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53333, 0., 0.46667000000000003`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{153.88000000000002`, 
         53.56}, {143.32000000000002`, 50.800000000000004`}, {
         143.32000000000002`, 44.92}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{153.88000000000002`, 
         53.56}, {143.32000000000002`, 50.800000000000004`}, {
         143.32000000000002`, 44.92}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53333, 0., 0.46667000000000003`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{154.12, 56.68}, {143.8, 
         57.04}, {143.32, 50.8}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{154.12, 56.68}, {143.8, 
         57.04}, {143.32, 50.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53333, 0., 0.46667000000000003`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{143.32000000000002`, 
         50.8}, {153.88000000000002`, 53.559999999999995`}, {
         154.12000000000003`, 56.68}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{143.32000000000002`, 
         50.8}, {153.88000000000002`, 53.559999999999995`}, {
         154.12000000000003`, 56.68}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52549, 0., 0.47451000000000004`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{153.88000000000002`, 
         50.56}, {143.32000000000002`, 44.92}, {143.92000000000002`, 
         39.760000000000005`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{153.88000000000002`, 
         50.56}, {143.32000000000002`, 44.92}, {143.92000000000002`, 
         39.760000000000005`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.53333, 0., 0.46667000000000003`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{143.32000000000002`, 
         44.92}, {153.88000000000002`, 50.56}, {153.88000000000002`, 
         53.56}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{143.32000000000002`, 
         44.92}, {153.88000000000002`, 50.56}, {153.88000000000002`, 53.56}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52549, 0., 0.47451000000000004`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{143.8, 57.04}, {154.12, 
         56.68}, {154.60000000000002`, 59.92}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{143.8, 57.04}, {154.12, 
         56.68}, {154.60000000000002`, 59.92}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52549, 0., 0.47451000000000004`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{154.6, 59.92}, {144.64, 
         63.4}, {143.79999999999998`, 57.04}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{154.6, 59.92}, {144.64, 
         63.4}, {143.79999999999998`, 57.04}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{154.12, 47.8}, {
         143.92000000000002`, 39.76}, {145., 35.31999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{154.12, 47.8}, {
         143.92000000000002`, 39.76}, {145., 35.31999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52549, 0., 0.47451000000000004`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{143.92000000000002`, 
         39.760000000000005`}, {154.12, 47.800000000000004`}, {
         153.88000000000002`, 50.56}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{143.92000000000002`, 
         39.760000000000005`}, {154.12, 47.800000000000004`}, {
         153.88000000000002`, 50.56}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.42745000000000005`, 0., 0.57255], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{144.04, 19.}, {152.44, 
         29.560000000000002`}, {150.28, 29.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{144.04, 19.}, {152.44, 
         29.560000000000002`}, {150.28, 29.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.41961000000000004`, 0., 0.58039], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{152.44, 29.56}, {144.04, 
         19.}, {147.28, 21.4}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{152.44, 29.56}, {144.04, 
         19.}, {147.28, 21.4}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.39608000000000004`, 0., 0.60392], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{155.44, 96.76}, {148.12, 
         106.48}, {144.64, 109.36}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{155.44, 96.76}, {148.12, 
         106.48}, {144.64, 109.36}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.39608000000000004`, 0., 0.60392], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{144.64, 109.36}, {
         152.67999999999998`, 98.8}, {155.44, 96.76}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{144.64, 109.36}, {
         152.67999999999998`, 98.8}, {155.44, 96.76}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{144.64, 63.4}, {154.6, 
         59.92}, {155.32, 62.92}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{144.64, 63.4}, {154.6, 
         59.92}, {155.32, 62.92}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{155.32000000000002`, 
         62.92}, {145.96, 69.4}, {144.64000000000001`, 63.4}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{155.32000000000002`, 
         62.92}, {145.96, 69.4}, {144.64000000000001`, 63.4}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{154.6, 45.64}, {145., 
         35.32}, {146.44, 32.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{154.6, 45.64}, {145., 
         35.32}, {146.44, 32.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{145., 35.32}, {154.6, 
         45.64}, {154.12, 47.8}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{145., 35.32}, {154.6, 
         45.64}, {154.12, 47.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{145.96, 69.4}, {
         155.32000000000002`, 62.92}, {156.16, 65.68}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{145.96, 69.4}, {
         155.32000000000002`, 62.92}, {156.16, 65.68}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{156.16, 
         65.67999999999999}, {147.76, 74.67999999999999}, {145.96, 
         69.39999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{156.16, 
         65.67999999999999}, {147.76, 74.67999999999999}, {145.96, 
         69.39999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.41961000000000004`, 0., 0.58039], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{146.32000000000002`, 
         97.96000000000001}, {154.24, 85.24000000000001}, {156.52, 
         86.32000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{146.32000000000002`, 
         97.96000000000001}, {154.24, 85.24000000000001}, {156.52, 
         86.32000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.41961000000000004`, 0., 0.58039], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{156.52, 86.32}, {149.68, 
         99.28}, {146.32000000000002`, 97.96}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{156.52, 86.32}, {149.68, 
         99.28}, {146.32000000000002`, 97.96}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.48627000000000004`, 0., 0.51373], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{155.44, 
         43.839999999999996`}, {146.44, 32.08}, {148.24, 
         29.919999999999995`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{155.44, 
         43.839999999999996`}, {146.44, 32.08}, {148.24, 
         29.919999999999995`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{146.44, 32.08}, {155.44, 
         43.839999999999996`}, {154.6, 45.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{146.44, 32.08}, {155.44, 
         43.839999999999996`}, {154.6, 45.64}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.41961000000000004`, 0., 0.58039], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{147.28, 21.4}, {154.6, 
         31.119999999999997`}, {152.44, 29.56}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{147.28, 21.4}, {154.6, 
         31.119999999999997`}, {152.44, 29.56}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.42745000000000005`, 0., 0.57255], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{154.6, 31.12}, {147.28, 
         21.400000000000002`}, {150.28, 25.36}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{154.6, 31.12}, {147.28, 
         21.400000000000002`}, {150.28, 25.36}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.48627000000000004`, 0., 0.51373], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{147.76, 
         74.67999999999999}, {156.16, 65.67999999999999}, {157.12, 68.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{147.76, 
         74.67999999999999}, {156.16, 65.67999999999999}, {157.12, 68.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.48627000000000004`, 0., 0.51373], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{157.12, 68.08}, {149.8, 
         79.36}, {147.76, 74.67999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{157.12, 68.08}, {149.8, 
         79.36}, {147.76, 74.67999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47843, 0., 0.52157], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{156.28, 42.64}, {148.24, 
         29.92}, {150.28, 29.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{156.28, 42.64}, {148.24, 
         29.92}, {150.28, 29.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.48627000000000004`, 0., 0.51373], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{148.23999999999998`, 
         29.919999999999998`}, {156.27999999999997`, 42.64}, {
         155.43999999999997`, 43.839999999999996`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{148.23999999999998`, 
         29.919999999999998`}, {156.27999999999997`, 42.64}, {
         155.43999999999997`, 43.839999999999996`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.42745000000000005`, 0., 0.57255], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{158.68, 86.08}, {152.68, 
         98.8}, {149.68, 99.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{158.68, 86.08}, {152.68, 
         98.8}, {149.68, 99.28}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.42745000000000005`, 0., 0.57255], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{149.68, 99.28}, {156.52, 
         86.32}, {158.68, 86.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{149.68, 99.28}, {156.52, 
         86.32}, {158.68, 86.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47843, 0., 0.52157], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{149.8, 79.36}, {157.12, 
         68.08}, {158.32000000000002`, 69.88}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{149.8, 79.36}, {157.12, 
         68.08}, {158.32000000000002`, 69.88}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47843, 0., 0.52157], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{158.32000000000002`, 
         69.88}, {152.08, 82.84}, {149.8, 79.36}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{158.32000000000002`, 
         69.88}, {152.08, 82.84}, {149.8, 79.36}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47843, 0., 0.52157], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{150.28, 29.08}, {157.24, 
         42.16}, {156.28, 42.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{150.28, 29.08}, {157.24, 
         42.16}, {156.28, 42.64}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47059, 0., 0.5294099999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{157.23999999999998`, 
         42.160000000000004`}, {150.27999999999997`, 29.080000000000005`}, {
         152.43999999999997`, 29.560000000000002`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{157.23999999999998`, 
         42.160000000000004`}, {150.27999999999997`, 29.080000000000005`}, {
         152.43999999999997`, 29.560000000000002`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.42745000000000005`, 0., 0.57255], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{150.28, 25.36}, {156.76, 
         33.76}, {154.6, 31.119999999999997`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{150.28, 25.36}, {156.76, 
         33.76}, {154.6, 31.119999999999997`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47059, 0., 0.5294099999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{152.08, 82.84}, {
         158.32000000000002`, 69.88}, {159.4, 71.2}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{152.08, 82.84}, {
         158.32000000000002`, 69.88}, {159.4, 71.2}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47059, 0., 0.5294099999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{159.4, 71.2}, {154.24, 
         85.24000000000001}, {152.08, 82.84}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{159.4, 71.2}, {154.24, 
         85.24000000000001}, {152.08, 82.84}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47059, 0., 0.5294099999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{152.44, 29.56}, {158.32, 
         42.28}, {157.24, 42.16}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{152.44, 29.56}, {158.32, 
         42.28}, {157.24, 42.16}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.46667000000000003`, 0., 0.53333], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{158.32000000000002`, 
         42.28}, {152.44000000000003`, 29.560000000000002`}, {
         154.60000000000002`, 31.12}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{158.32000000000002`, 
         42.28}, {152.44000000000003`, 29.560000000000002`}, {
         154.60000000000002`, 31.12}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.44314, 0., 0.55686], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{160.6, 84.76}, {155.44, 
         96.76}, {152.68, 98.80000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{160.6, 84.76}, {155.44, 
         96.76}, {152.68, 98.80000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.44314, 0., 0.55686], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{152.68, 98.8}, {158.68, 
         86.08}, {160.6, 84.75999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{152.68, 98.8}, {158.68, 
         86.08}, {160.6, 84.75999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5098, 0., 0.49019999999999997`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {153.88, 
         53.559999999999995`}, {153.88, 50.559999999999995`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         153.88, 53.559999999999995`}, {153.88, 50.559999999999995`}, {161.2, 
         56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5098, 0., 0.49019999999999997`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         154.11999999999998`, 56.68}, {153.88, 53.559999999999995`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         154.11999999999998`, 56.68}, {153.88, 53.559999999999995`}, {161.2, 
         56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5098, 0., 0.49019999999999997`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {153.88, 
         50.559999999999995`}, {154.11999999999998`, 47.8}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         153.88, 50.559999999999995`}, {154.11999999999998`, 47.8}, {161.2, 
         56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5098, 0., 0.49019999999999997`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {154.6, 
         59.919999999999995`}, {154.11999999999998`, 56.68}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         154.6, 59.919999999999995`}, {154.11999999999998`, 56.68}, {161.2, 
         56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         154.11999999999998`, 47.8}, {154.6, 45.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         154.11999999999998`, 47.8}, {154.6, 45.64}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.46667000000000003`, 0., 0.53333], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{154.23999999999998`, 
         85.24000000000001}, {159.39999999999998`, 71.20000000000002}, {
         160.48, 71.80000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{154.23999999999998`, 
         85.24000000000001}, {159.39999999999998`, 71.20000000000002}, {
         160.48, 71.80000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.46667000000000003`, 0., 0.53333], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{160.48000000000002`, 
         71.8}, {156.52, 86.32}, {154.24, 85.24}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{160.48000000000002`, 
         71.8}, {156.52, 86.32}, {154.24, 85.24}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {155.32, 
         62.919999999999995`}, {154.6, 59.919999999999995`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         155.32, 62.919999999999995`}, {154.6, 59.919999999999995`}, {161.2, 
         56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.46667000000000003`, 0., 0.53333], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{154.6, 31.12}, {159.4, 
         43.120000000000005`}, {158.32, 42.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{154.6, 31.12}, {159.4, 
         43.120000000000005`}, {158.32, 42.28}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47059, 0., 0.5294099999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{159.4, 
         43.120000000000005`}, {154.6, 31.120000000000005`}, {
         156.76000000000002`, 33.760000000000005`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{159.4, 
         43.120000000000005`}, {154.6, 31.120000000000005`}, {
         156.76000000000002`, 33.760000000000005`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {154.6, 
         45.64}, {155.44, 43.839999999999996`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         154.6, 45.64}, {155.44, 43.839999999999996`}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {156.16, 
         65.67999999999999}, {155.32, 62.919999999999995`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         156.16, 65.67999999999999}, {155.32, 62.919999999999995`}, {161.2, 
         56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.49412, 0., 0.50196], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {155.44, 
         43.839999999999996`}, {156.28, 42.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         155.44, 43.839999999999996`}, {156.28, 42.64}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47451000000000004`, 0., 0.52549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{155.44, 96.76}, {160.6, 
         84.76}, {162.16, 82.24000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{155.44, 96.76}, {160.6, 
         84.76}, {162.16, 82.24000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47451000000000004`, 0., 0.52549], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{162.16, 
         82.24000000000001}, {157.72, 92.92000000000002}, {155.44, 96.76}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{162.16, 
         82.24000000000001}, {157.72, 92.92000000000002}, {155.44, 96.76}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.49412, 0., 0.50196], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         157.11999999999998`, 68.08}, {156.16, 65.67999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         157.11999999999998`, 68.08}, {156.16, 65.67999999999999}, {161.2, 
         56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.49019999999999997`, 0., 0.5098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {156.28, 
         42.64}, {157.23999999999998`, 42.16}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         156.28, 42.64}, {157.23999999999998`, 42.16}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47059, 0., 0.5294099999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{156.52, 86.32}, {
         160.48000000000002`, 71.8}, {161.68, 71.8}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{156.52, 86.32}, {
         160.48000000000002`, 71.8}, {161.68, 71.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47059, 0., 0.5294099999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.68, 71.8}, {158.68, 
         86.08}, {156.52, 86.32}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.68, 71.8}, {158.68, 
         86.08}, {156.52, 86.32}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47843, 0., 0.52157], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{160.6, 44.44}, {156.76, 
         33.76}, {158.79999999999998`, 37.48}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{160.6, 44.44}, {156.76, 
         33.76}, {158.79999999999998`, 37.48}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47059, 0., 0.5294099999999999], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{156.76, 
         33.760000000000005`}, {160.6, 44.440000000000005`}, {
         159.39999999999998`, 43.120000000000005`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{156.76, 
         33.760000000000005`}, {160.6, 44.440000000000005`}, {
         159.39999999999998`, 43.120000000000005`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.49019999999999997`, 0., 0.5098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {158.32, 
         69.88}, {157.11999999999998`, 68.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         158.32, 69.88}, {157.11999999999998`, 68.08}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.49019999999999997`, 0., 0.5098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         157.23999999999998`, 42.16}, {158.32, 42.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         157.23999999999998`, 42.16}, {158.32, 42.28}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.49019999999999997`, 0., 0.5098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         159.39999999999998`, 71.2}, {158.32, 69.88}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         159.39999999999998`, 71.2}, {158.32, 69.88}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.49019999999999997`, 0., 0.5098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {158.32, 
         42.28}, {159.39999999999998`, 43.12}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         158.32, 42.28}, {159.39999999999998`, 43.12}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47843, 0., 0.52157], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{162.52, 71.2}, {
         160.60000000000002`, 84.76}, {158.68, 86.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{162.52, 71.2}, {
         160.60000000000002`, 84.76}, {158.68, 86.08}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47843, 0., 0.52157], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{158.68, 86.08}, {161.68, 
         71.8}, {162.52, 71.2}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{158.68, 86.08}, {161.68, 
         71.8}, {162.52, 71.2}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.47843, 0., 0.52157], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{158.8, 37.48}, {161.68, 
         46.36}, {160.60000000000002`, 44.44}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{158.8, 37.48}, {161.68, 
         46.36}, {160.60000000000002`, 44.44}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.48627000000000004`, 0., 0.51373], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.68, 46.36}, {158.8, 
         37.48}, {160.6, 41.92}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.68, 46.36}, {158.8, 
         37.48}, {160.6, 41.92}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.49019999999999997`, 0., 0.5098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {160.48, 
         71.8}, {159.39999999999998`, 71.2}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         160.48, 71.8}, {159.39999999999998`, 71.2}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.49019999999999997`, 0., 0.5098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         159.39999999999998`, 43.12}, {160.6, 44.44}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         159.39999999999998`, 43.12}, {160.6, 44.44}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.49019999999999997`, 0., 0.5098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         161.67999999999998`, 71.8}, {160.48, 71.8}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         161.67999999999998`, 71.8}, {160.48, 71.8}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.48627000000000004`, 0., 0.51373], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{160.6, 84.76}, {
         162.51999999999998`, 71.2}, {163.48, 69.88000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{160.6, 84.76}, {
         162.51999999999998`, 71.2}, {163.48, 69.88000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.48627000000000004`, 0., 0.51373], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{163.48000000000002`, 
         69.88}, {162.16000000000003`, 82.24}, {160.60000000000002`, 
         84.75999999999999}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{163.48000000000002`, 
         69.88}, {162.16000000000003`, 82.24}, {160.60000000000002`, 
         84.75999999999999}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.49019999999999997`, 0., 0.5098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {160.6, 
         44.44}, {161.67999999999998`, 46.36}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         160.6, 44.44}, {161.67999999999998`, 46.36}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{162.52, 
         48.760000000000005`}, {160.60000000000002`, 41.92}, {162.16, 
         47.080000000000005`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{162.52, 
         48.760000000000005`}, {160.60000000000002`, 41.92}, {162.16, 
         47.080000000000005`}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.48627000000000004`, 0., 0.51373], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{160.6, 41.92}, {
         162.51999999999998`, 48.760000000000005`}, {161.68, 46.36}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{160.6, 41.92}, {
         162.51999999999998`, 48.760000000000005`}, {161.68, 46.36}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.49412, 0., 0.50196], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         161.67999999999998`, 46.36}, {162.51999999999998`, 48.76}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         161.67999999999998`, 46.36}, {162.51999999999998`, 48.76}, {161.2, 
         56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         162.51999999999998`, 48.76}, {163.35999999999999`, 51.28}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         162.51999999999998`, 48.76}, {163.35999999999999`, 51.28}, {161.2, 
         56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         163.35999999999999`, 51.28}, {164.07999999999998`, 
         54.279999999999994`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         163.35999999999999`, 51.28}, {164.07999999999998`, 
         54.279999999999994`}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5098, 0., 0.49019999999999997`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         164.07999999999998`, 54.279999999999994`}, {164.56, 
         57.279999999999994`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         164.07999999999998`, 54.279999999999994`}, {164.56, 
         57.279999999999994`}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.49019999999999997`, 0., 0.5098], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         162.51999999999998`, 71.2}, {161.67999999999998`, 71.8}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         162.51999999999998`, 71.2}, {161.67999999999998`, 71.8}, {161.2, 
         56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.49412, 0., 0.50196], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {163.48, 
         69.88}, {162.51999999999998`, 71.2}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         163.48, 69.88}, {162.51999999999998`, 71.2}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         164.07999999999998`, 68.08}, {163.48, 69.88}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         164.07999999999998`, 68.08}, {163.48, 69.88}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {164.56, 
         65.8}, {164.07999999999998`, 68.08}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         164.56, 65.8}, {164.07999999999998`, 68.08}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5098, 0., 0.49019999999999997`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         164.79999999999998`, 63.16}, {164.56, 65.8}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         164.79999999999998`, 63.16}, {164.56, 65.8}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5098, 0., 0.49019999999999997`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         164.79999999999998`, 60.279999999999994`}, {164.79999999999998`, 
         63.16}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         164.79999999999998`, 60.279999999999994`}, {164.79999999999998`, 
         63.16}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.5098, 0., 0.49019999999999997`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {164.56, 
         57.279999999999994`}, {164.79999999999998`, 60.279999999999994`}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{161.2, 56.8}, {
         164.56, 57.279999999999994`}, {164.79999999999998`, 
         60.279999999999994`}, {161.2, 56.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{164.08, 68.08}, {163.36, 
         78.64}, {162.16000000000003`, 82.24}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{164.08, 68.08}, {163.36, 
         78.64}, {162.16000000000003`, 82.24}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{162.16, 
         82.24000000000001}, {163.48, 69.88000000000001}, {
         164.07999999999998`, 68.08000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{162.16, 
         82.24000000000001}, {163.48, 69.88000000000001}, {
         164.07999999999998`, 68.08000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.50196, 0., 0.49412], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{162.16, 47.08}, {
         163.35999999999999`, 51.28}, {162.52, 48.76}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{162.16, 47.08}, {
         163.35999999999999`, 51.28}, {162.52, 48.76}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{164.56, 65.8}, {164.2, 
         74.32}, {163.36, 78.64}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{164.56, 65.8}, {164.2, 
         74.32}, {163.36, 78.64}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52157, 0., 0.47843], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{163.36, 78.64}, {164.08, 
         68.08}, {164.56, 65.8}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{163.36, 78.64}, {164.08, 
         68.08}, {164.56, 65.8}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52549, 0., 0.47451000000000004`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{164.8, 
         63.160000000000004`}, {164.68, 69.28}, {164.20000000000002`, 
         74.32000000000001}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{164.8, 
         63.160000000000004`}, {164.68, 69.28}, {164.20000000000002`, 
         74.32000000000001}}},
         CurveClosed->{0}]}, 
       {FaceForm[{RGBColor[0.52549, 0., 0.47451000000000004`], Opacity[1.]}], 
        FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{164.2, 74.32}, {164.56, 
         65.8}, {164.79999999999998`, 63.16}}}]}, 
       {Thickness[0.002168674698795181], JoinForm[{"Miter", 10.}], 
        JoinedCurveBox[{{{0, 2, 0}, {0, 1, 0}}}, {{{164.2, 74.32}, {164.56, 
         65.8}, {164.79999999999998`, 63.16}}},
         CurveClosed->{0}]}},
      AspectRatio->Automatic,
      ImageSize->{166., 135.},
      PlotRange->{{0., 166.}, {0., 135.}}], {0.24390243902439024`, 0.24390243902439018`},
      Center, {0.4434589800443459, 0.4434589800443459}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0.5121951219512195, -5.551115123125783*^-17}, {
     1., -5.551115123125783*^-17}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0.5121951219512195, -5.551115123125783*^-17}, {
     0.5121951219512195, 0.4878048780487805}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{0.5121951219512195, 0.4878048780487805}, {1., 
     0.4878048780487805}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], LineBox[{{1., -5.551115123125783*^-17}, {1., 
     0.4878048780487805}}]}, 
   {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], CapForm[
    None], {}, InsetBox[
     FormBox[
      GraphicsBox[
       TagBox[RasterBox[CompressedData["
1:eJzsvSuw5TobprdrEnDgphsuuOCiZjE0dJjZjGuGGKRqnKrUlKigoKCooKCg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         "], {{0, 515}, {514, 0}}, {0, 255},
         ColorFunction->GrayLevel],
        BoxForm`ImageTag[
        "Byte", ColorSpace -> "Grayscale", Interleaving -> None],
        Selectable->False],
       BaseStyle->"ImageGraphics",
       ImageSizeRaw->{514, 515},
       PlotRange->{{0, 514}, {0, 515}}],
      TraditionalForm], {0.7560975609756098, 0.2439024390243902}, 
     Center, {0.4878048780487805, 0.48780487804878053`}], InsetBox[
     FrameBox[
      StyleBox[
       TagBox[
        StyleBox[
         TagBox["\<\"(a)\"\>",
          DisplayForm],
         StripOnInput->False,
         ShowAutoStyles->False,
         SingleLetterItalics->False,
         FontFamily->"Times",
         FontSize->12,
         FontWeight->"Plain",
         FontSlant->"Plain",
         FontTracking->"Plain",
         FontColor->GrayLevel[0],
         FontOpacity->1],
        DisplayForm],
       StripOnInput->False,
       ShowContents->False],
      Background->GrayLevel[0.85],
      ContentPadding->False,
      FrameMargins->None,
      FrameStyle->None,
      StripOnInput->False], {0.06251249999999998, 0.9374875}, {0, 0}, 
     Automatic, {1, 0}], InsetBox[
     FrameBox[
      StyleBox[
       TagBox[
        StyleBox[
         TagBox["\<\"(d)\"\>",
          DisplayForm],
         StripOnInput->False,
         ShowAutoStyles->False,
         SingleLetterItalics->False,
         FontFamily->"Times",
         FontSize->12,
         FontWeight->"Plain",
         FontSlant->"Plain",
         FontTracking->"Plain",
         FontColor->GrayLevel[0],
         FontOpacity->1],
        DisplayForm],
       StripOnInput->False,
       ShowContents->False],
      Background->GrayLevel[0.85],
      ContentPadding->False,
      FrameMargins->None,
      FrameStyle->None,
      StripOnInput->False], {0.5747076219512195, 0.4252923780487805}, {0, 0}, 
     Automatic, {1, 0}], InsetBox[
     TagBox[
      StyleBox[
       TagBox["\<\"(a)\"\>",
        DisplayForm],
       StripOnInput->False,
       ShowAutoStyles->False,
       SingleLetterItalics->False,
       FontFamily->"Times",
       FontSize->12,
       FontWeight->"Plain",
       FontSlant->"Plain",
       FontTracking->"Plain",
       FontColor->GrayLevel[0],
       FontOpacity->1],
      DisplayForm], {0.06251249999999998, 0.9374875}, {0, 0}, Automatic, {1, 
     0}], InsetBox[
     TagBox[
      StyleBox[
       TagBox["\<\"(b)\"\>",
        DisplayForm],
       StripOnInput->False,
       ShowAutoStyles->False,
       SingleLetterItalics->False,
       FontFamily->"Times",
       FontSize->12,
       FontWeight->"Plain",
       FontSlant->"Plain",
       FontTracking->"Plain",
       FontColor->GrayLevel[0],
       FontOpacity->1],
      DisplayForm], {0.5747076219512195, 0.9374875}, {0, 0}, Automatic, {1, 
     0}], InsetBox[
     TagBox[
      StyleBox[
       TagBox["\<\"(c)\"\>",
        DisplayForm],
       StripOnInput->False,
       ShowAutoStyles->False,
       SingleLetterItalics->False,
       FontFamily->"Times",
       FontSize->12,
       FontWeight->"Plain",
       FontSlant->"Plain",
       FontTracking->"Plain",
       FontColor->GrayLevel[0],
       FontOpacity->1],
      DisplayForm], {0.06251249999999998, 0.4252923780487805}, {0, 0}, 
     Automatic, {1, 0}], InsetBox[
     TagBox[
      StyleBox[
       TagBox["\<\"(d)\"\>",
        DisplayForm],
       StripOnInput->False,
       ShowAutoStyles->False,
       SingleLetterItalics->False,
       FontFamily->"Times",
       FontSize->12,
       FontWeight->"Plain",
       FontSlant->"Plain",
       FontTracking->"Plain",
       FontColor->GrayLevel[0],
       FontOpacity->1],
      DisplayForm], {0.5747076219512195, 0.4252923780487805}, {0, 0}, 
     Automatic, {1, 0}]}},
  AspectRatio->1,
  Axes->False,
  Background->None,
  BaseStyle->{
   FontFamily -> "Times", FontSize -> 12, FontSlant -> "Plain", FontTracking -> 
    "Plain", FontWeight -> "Plain", FontColor -> GrayLevel[0], FontOpacity -> 
    1, ShowAutoStyles -> False, SingleLetterItalics -> False},
  DisplayFunction->Identity,
  Frame->False,
  FrameLabel->{None, None, None, None},
  FrameStyle->Directive[{
     GrayLevel[0], 
     Opacity[1], 
     CapForm[None], 
     AbsoluteThickness[1], 
     AbsoluteDashing[{}]}],
  FrameTicks->None,
  ImageSize->{288, 288},
  PlotRange->{{-0.10012, 1.10012}, {-0.10012, 1.10012}},
  Ticks->None]], "Output",
 CellChangeTimes->{
  3.488837196671875*^9, 3.488837241640625*^9, {3.488837307515625*^9, 
   3.488837312203125*^9}, {3.488837391390625*^9, 3.488837456875*^9}, {
   3.488837487734375*^9, 3.48883753815625*^9}, 3.488838525671875*^9, 
   3.495659539203125*^9, 3.495659687328125*^9, 3.50127399990625*^9, 
   3.52552791134375*^9},
 ImageCache->GraphicsData["CompressedBitmap", "\<\
eJzsvXmUXWWZ7/+evfc5p+YxSaUqqcpQSSpJJZU5qSIhgSQQppAQIEBIAmEm
hHmGMM+jiKAMKqMiSts429qt4qxti912O+CsOPa11V7ditprPff5vHt/D4X3
JnFxf3/+WFTOOXt4x+f7fYZ3Wr/jkrNOP3fHJWefumPyuot2XHDW2adePPng
8y/yS2kphNJZ/E0OfLcQ9I/5/3Y2/3Dl///+/+X3vviR/mrs2LGmBn9D/Df9
c5Zl5zzwwAPxiSx/bv9Pf/rTfyqXy/GJ+/Ln/lBXVxfv8jfhNcna5N4u+8EX
3m728oc8Wf5N7eTNa09+7LHHRiW74oBPfvKT/93e3m4/+tGPjP++/vWv21vf
+lb727/9W3vLW95iV111lT300EPx+7vf/W77l3/5F/v85z9vb3zjG+2MM86w
LVu22FlnnWU7duywk08+2Xbt2mUXXnihnXvuuXbFFVfY9ddfb7fddpu97W1v
s0cffdQef/xx+9rXvmbvfOc77fLLL7err77azj///Pge6fD7ySefjO8fccQR
dsstt9hpp51mxxxzjB1//PExP/Ll/lFHHRU/V61aZSMjI7Z582Y78sgjbdGi
RXbIIYfYunXr7JJLLqmV78ADD0xs3rx5YcDWrl1ra9asiY/y+saNG2OyW7du
tcMPP9zmzJljU6ZMiff3228/W7p0qS1evDg+O3fuXFKJn8uWLYvZLFiwwGbP
nm39/f3x+8EHHxzTP+CAA2z16tXx+WnTpsX0uEYxDzvssPj+8PBwLO706dNt
8uTJIbHu7u4w1yZNmsRv6+vri5/cJ33yXbFihc2YMcOampps3LhxtWcoI59T
p061oaEhW758ufX29sYy7L///rEePM/7PNPa2hrTXbhwoSGJLS0tNnPmzNic
lI+yUjaa8LzzzrPTTz/d3v72t9vFF19s9913X3yGutAVyGTv65HCKUjh78aP
H2+f+cxn7N///d/tH//xH+3uu++2e+65J0ofvXjmmWfaM888E39/7GMfi5L4
8Y9/3O69994oNRTxlFNOidKHZCEZvHPttdfaDTfcENN6wxveYA8++KB99KMf
tU996lMxLaTTJdWbfefOnQlSEMbbm9/8ZrvmmmvshBNOsFNPPTW+jPghRogj
ok5GtANywz3aFxFElujTQw89NLbdXXfdZTfddJNdcMEF8Tlv38Q6OztDX+xi
upNupdmR9hNPPDGKEPcQF77TPYgliDjppJNisx900EGxe7gOOhC3+fPnx0/E
jS6kaEcffXQs2qZNm6IYuGgn/AiNMSkkntqQLRJDMUie0tMlFG1gYMCbxwsa
ZsZnKPKSJUti7agpRUXKBgcHYxH8+Vh00uWZ5ubmWtEBMFJJlSgOn0gv33mW
/Elz5cqVds4559jZZ59tN954o73nPe+JLXnnnXfaZz/7WXvuuefsQx/6kD37
7LP2rne9K3bn6xXAsVEAOzo6omD95je/sW984xv24osvRvq67rrrIj1RGmSf
nBEavr/00kv2/ve/32699VbbvXt3FMQ77riD+7lAhWvsyiuvjLLkeUZqo7TI
F+k9/PDD9vTTT0fhRa4QWHoEGULmuL9hw4bYatAkacNd/D722GPjs+DPqS12
MHxC63KNTuc+aZMesrxt27ZI6eRNK3d1ddnEiRMjB8AF4J9eBM8IUdH7MFL8
jlDRk0gHeVAW+JHvlIneh5fWr18f71Ee3qFnkRqeo5z0Ls9QLj4RWup53HHH
Re4kDaQK4UXQ4apZs2ZF6aC8cClSQ7nFVeQF902YMCG+S5uQNmmSL7xXX18f
eRrggGXKyD3yR6JpO8pE/SCO+++/326//faovlCL9N0jjzwS8YxMQD70JdLH
PdTm6+bBg6MY0iXPP/+8ffWrX42iAVch6IgDVES2UDGC/8QTT9jNN99sH/nI
R+IziCWiyCeiAljQwogVfMizH/zgB+P7cCJVghOhcqqBaPA8/MkzNMVFF12E
IMemlBa+9NJLI52hThALuoam5zsqki6k+SUivAMEoEfSQvwQSz5JB7HhfQjH
mdHa2tosTdOYlueZRL1YickjCTyKJNDL3msJ4hVaY+chjHQwufObEpML11F6
CAn3uE5p6HivpYPV4eJZIKgIOMIMuQMizzaBZv027EcpkE/sA367/OVvv1p3
2g0IkTqlQYwhMSCOOCL+1JnUgTE8DVnSxqQBVKES+pi+RazoK/oInYVuBC6Y
Hogi/YpupK/I43WL4IQoghiEH/jAB2KSfMJwfL7jHe+IWYAMuo8iw8uoVBlu
3KM4sCaMiChy77LLLotqHDYEKS6m3uiOn7AwihNsCpp4j/cRS9JC5FHrdCKd
w2+Qu3379pgW5UCvFKotNitiCSOICaUqEUFgRFmUFnBCJOkWehQGbGhosGq1
Gq0rRJE0aRMYDHaEfRBTxBVmRPyjHHrfhTXRCIOY6EkRIclDKkgHskeR9Jvn
6UlUISREVZAgepjmpog8wz0kCYnhXarIe0CB/CgeAsl75It0IYFIW09PTywy
CgFJRIpoXuScclI+0E+XoXIhPWx0RADCk01OVyIO+AI0P3lB6DAMaZAv0ksX
vW4pbI5SOGbMmCj4FAPdSbboXqSQoiBZFI1P140uTS5DYYq55xQJjZ6GBJEm
qkq1IRsRGpz+3ve+N7oySDDp8BxGGM9CkFgcpEOz8A5VowuQfKSOruR5qo9t
TLVd6rws2Ew9UTLQn+gouorfSB1l4F3sC/LCiENSaXokkzwQB3UbupluhMZg
PSQSYilIM0G5hYPj49xCOqTSEFhUPazGNdgPM4AqIGWARMxIFnITeBepg7uR
Gqou1YxpAKCQYtKl+Pymqqhl3qMakDVAAlhINZyImdXY2BhBhEnzpje9KZrS
NC/ApLn5TRfS7XAg3U4XcZ1mo6nhPSSWfEACTYb0IY1IIgZtwYX/D1SIU4SQ
oYkpEcJCCREyhIsSIqRf+MIXotYkZ67D1jIaKDnUhoAhjDyHwFB6NLRrbhcY
TzW0RMFAA4M/qFA+Ms+RJ/cQIGoLBdI7XtMEUnAVSAfTWTAmnQq06WCogU6h
E7DM6WgaCvjTqC4MXgTvzjAhyiEUQxFhfYpMWlAM8kuHY4PBfDQP37H+dQ2Z
JD86g/x4l7yRZzksdI5X1fP03MJIvMY73Cd9yocQQ50IHeVBOBBcys11hArq
k88NNhAEBBgcISQ8Q3mw+7Isi7Yh7UM7UVby5HnKSneAZQSSpqfJwT9hC2iQ
5kdIEXrqpU/amPKLsikf5UT45De/bios1xQyVIUUejG92Vw9hqNrrgRUhV33
1FNPxWaimBQBaUVCcSOQQKRKERlJIhhE6qgyLA/Nco9i8xx0i4gghdAgTQTz
Uz3oDlqj2eELmhNaoruhPPBON9I9iAHdyneaH01FGaFyxJBm43lole+kidJH
fCkPqKOsCnEgFnAY3Yfih/vgH3hFLgL8w3OIC6JFGeA2ykgZeB972e95m3rp
Qkd8Rv41f6QPN3KdbqZ8iCMijIiRHqLHM9QJfvRrCRgM3TFbKJjmQFopJgzO
NQxQ2RQkSxKgk2ahm+gebCYMUbqB77wj6i2aPuQGcH1ELpLMJ2nQfHSjzP/X
LYXjoxSiiOgFojRygpE8YoNIIh4IPQXnwc5IIvcBIxaruBDTTlYrEunPJDEE
s6LmWHCbzsYwxvyBgkkCPNEavMZvLDoEW/E2lAP8gbBSa1qd1lVHInx0GJil
Q1FkUCkCLtwiFACCzkaQwDXfKRdFplrQPIoM65B0yR+hoffoRa4hZAgh+cGb
En7xlPuWuVsxNv6ESsAKGCA52B1dTda8SjIKV3KfT7nhegb6oVqeTchVwvSY
BjYBTaD05EojLDQPGINGaWqanTRFu3QFzY8eptl5R9Ulf9LjO81EE/IuXcAn
daD3SRM6hY9etxDeUrMKKQZB6Jdfftm+9KUvRS+dIsoLBzsIGteRe4UPUZZc
QzErqI1SR4JkKUJvKFkFppEoqoDkkSauOfkQHcI1lzWHpII1zCToGm1Jb4NV
ug3Ng5YE/0gdUkIX0i3QFlim+ekipJHv0Av50+R0LxxBXgCJ+3xHEuETtBnS
SDfSLUgZFMU7IEMmIeJBd9NtiBTSTNuAJLoM7QhvIIY8BwdRf96X6FFWyqko
OnnR5XQ/pibXEQesEOoAZdM+9AMiJSsA7gNh1I+yIkakBWrpK4kU91E59Dtt
TNkKB6qwIMo1MxAIUA//9HteKvfaQTjqisGHf/u3f7OvfOUrr9ssHKyZhe97
3/vsc5/7nPlv+9d//dcokShp7AUFYJAmBWLgLaSI3kXhQY1IH/YG91HA2CA8
hwQDPBQuv+EkWo+ewB9C2dMaSDDlQBJoGaSRnsJQ8FbzFnC5C8sM1Ch+R6vT
e0gn9hEKCynjHsRA79Ni5E2+oEBxOHnf8KS8b8pJWehpDA8kBumH+1DMSL/i
hkgcCJH/RLnpMXnnpEHZlB8SiMZD2qk/koD0IXXFGIrX0akzIYswMVYeS4TM
FUjFWkB3kQmwpqERN+7xLCJI4wAlKk8FKSzPYB2g84AIheUd0qEQXpgsEnhT
lDxeQQqRTpEg5cVuROIkI69X8i6PkgfOf/3rX9s//dM/RSnAQidqDZ9JCpAm
JJBPvEtaltaTsqb1iyh1bAxZy/QefEml6VHSg/PADD2NVKLk+SQNeJJn6Ul4
hJ5DWuFYepzeozxoddky8I9sIfgKLYrqowOI0HJP0W151LwDahTOVHhSDhad
RifT+nQU+cJDuKJIH54H2pjOljriHfEL0kx+SB38BkKQVNqCjobPeA7hkotJ
mUhXEW2+8y69TzmwAKgP6CI9yiK7jjLK9YYbvd1cir3EoTGWAYmn3rAL9RN3
Uw6Zpjn3ufQlEehNNeKjAFRGoXUKQ6N98YtfjFSBL/B6RXA4iiDV+vnPfx4H
ShAnCA8xgZgIoEC1NJ0CK4pA0+SIAKKFiCBeiCZNIvDT9VQd8kG0EFk8ku9+
97sxHQiTkCPkw32ai+4kP0SZ9yE2QEc+qFl+o7pQoaRN82IRoZJxDAmuoJpd
HBPCFeEAY6SdIAU9RzHhOCQQBwlLnKqSBc4XviE9q7EEkAJP0lMYV0g5n0gI
fIu2p5OQLI3JUF2aSP6oAigKrow2/JA23sPZoArQEdf4zXPS9uQpK4S8YQ4i
lrJXFbzhE0ONbijGOhMg64oT95cWVtYk66/kItdWM/NGm3xoEsSPGvJdHjFi
9w//8A/RPiPW+3pFcCSKIJT9iU98Igr13/zN30SxQzSwzhByMQQiiKuCZQfy
uYYI0JcwI5Yf4spv2BAxpA1gN8RRlhHWpcbq4PDvfe970dn+9Kc/Hf0C8of5
UC+oHYBH4/EO7Ec/wUD0CUyFuGG1wQ70CyyITUF/+acj24XS1RlyWKlU4jsa
j4M5EW3qRTmoA/WS6qKeXKNcyCByhB5GBZIXTjH5yxZQnMh7KnckZ0RRRmxA
Dx2JePAJwfMooou2pNMRVapF8fQdcdPUBhllkDzvMxiMduY3MoXyIC3kDEgp
xkB30qSIPyLtJUtJLImmXSYjT2o2eVUw6yL3gXbYCScBQx1FCeu8XsFbWBud
Y0SGlFG/CJxicwgHfIUqhBjwcxE8AI5qxQSmU8SBcCPcxTWcWc1igMN4B0Hi
OnzHjAj++9nPfhZVAqSDwGKbAFzypPMBMwYlwsl1Oh8hQ/3Q8S6ECV0U2qM8
0BnQHx2CPCKDPIaXgsxyj9lJjIQgi4yMKHLhGHM5ZRynIaoAbDQ6Db6kCrL3
eB5h8nQTEg6DkQbljkNbyIviKMiI3GVoDijBOxripm+xzJAT0S5yxPNQK2mR
NhqB58he45aaroNjwn05OxoYguY1UkNLYtzlDkY1loMq8ScTrxiFcXnxdk7i
17paoPub3/xm1OCEh/EL8D5er/CdUwsDooFgPPmjMBPCRHMgWIpeypZTHIjv
MAPXYTyeR5D4DfvBYEUkODYbTY2QMxPi+9//vv3P//yP/fM//3PkbnqaPFDC
CDyCzXdogqYnT2BNWnQHrIZ0wV50B01IVxQznqIkwoBIG58IK5KJ5kQLU2/u
IZHcRyL5pIzUC9sX8CDsXMPOQ1zoHt7BzlLIUcyr0AXGjMaTEUF5LDAllEaa
dDViJx8TEaLO1APtS11AEOLnIlz4nc01X5syQFWIG9qF9qfdYWn6C4317W9/
GxYvYnlZzdYrvIpcuDpi1hRD4398ck3qV78pFgrihRdeiPwBH9HFfL5eIVxc
C8Cg1lC9FB4WgulQuXxHFdEZ5AbOYCWEAZaj0ggXWNQoIYLMe9xDgORpIcwI
GUKK4cB8CBrp7/7u7yJWqQksRxlgOvCJ4QETa8SV9HCpEWSEm4anHAUgEhSM
Q5usKA5FQ7Z5nT5zufP+cO4L5Zpcwo7IsLOhNxLBrJnRiOQ+8o3Kg9b4pO81
NYLfYIF3oT+ucw2rAJlDdYIdjdQge4ob8z7vUEWaR3OuZJZBfQp3U2UsD4QE
+YuqkXHpumjQKIhKzyAXyAeGlPdskmtXHIu0Fl5GGHNx7ohJahaaQs36Lm+D
LOkNqIKRB9LGTqeJkYrXK3uzaxFoUsUhRRYwwwE64IbQ0ILUDPmB7OhvVBWf
mHvIGL+xNehwESIl1NAvz2r+hgJHeB7IG/cRED6pJSSgyQd0rqed0MxhQ+wn
DUUCCcQP0UOc4UqSp5h0BiIqY0FqjfcBM3JFtYEdWhnZ4JpG2uBJ5ixwn9+a
rYqsIiPID7KMbGo6Idcom2aX8g6yCmlIFfOda8ggvAm3kQdpyK7nPcrDc6SL
TCPLyC7yqiFZPok3YDkDX5oa7sMcoxkRDMqD0OURHYTw1Zge7VD43iEpFC7p
cg8VncZ/s1hm2pOpoZ5PPqaa1cYiaOL/9ykJ9D8KB+uPWRA0Bo1CRyvYgsnv
BfHCejeGntjBVBSziOc0dQ/ZQ7aQIzqcRkEZAGAEAVlGFlHwKGE4FkHCaiQ9
ykKlwUCUPU887B/1LnoGHkP2KCJFor/kpUiBIINAgSSRO4rDNSBBFiSP1QfH
JUkSZUA8CFchQ/Q9TaAZ0cgPMgCBAA24CdmAHJAn9DNNQP4Yp4qTK47CfXiR
dySLwJbvcB/pQjq8i2wybp3P7J4Yg3maAa2gHuoKy5Q6oRSZNodVhi1DnRXP
LuSppkTVRlxDFgv5HO2Z59ZhUxRHbiPamrlHb6KN0G5kT6/Cv3uXwdXx36r9
/MWn7ZPvud0eu/dCO+lYN15mTrcxrd2WJfUhXwaQWeLPZaHRSjiM9eOTeLlq
XR1dtnhwKP5detaxdvk5x9iJmw60jz9zS1i8RxFPa5FtnP8k2vcbY8GxXpEn
1DaiiJijQrkmhwZRRhyhVMXvkEPZpah6ZBERRhbxGEgLBcE1+EQRYc2ihXpp
Z9pcM/A11Zm+hIbJCz5FhkmHPOEg4ERZ0OmkxTOQgEYONVUOvqDcyJO8dPJD
WSLL8B79ja6Fs/lEPnkGWUTu5cpKlrlfyG5CYR2SwAHK1igfkAAKmKPAFEpG
jUvHkg1F0RAJpjImqpqD7HgHSNHE+KQwBxxHNWEhqgWkSJMmG2078qmIDt+l
y6Xf6Q6qq0/N5MTcxxpjCjYODSFY4EWgBWsMuUc89jHKt38h5E/ed5EdvGqh
9XZPtErW4k+XLCkh2PV+l0Tc5wz9lrr5UqyScWFPPbXWdMBhN7v+TFvUeK01
lqZYpdTkYGjwZ6vWkvZZT+tUK2cV23/hIrvtypPtC++/Z/4ehf+KmvDTmigm
aor9ib0BYYBeakwAHCGjpQAA3A158jyCDaFoVQxki6AhhAggLTN6CAUBxQqD
IQAXREfv8ixpwv0iQISRe/QqRh5CrMkBpE+ZYB96VMPm9Bz30BmUT6twIHkt
ZdBMJJQ4ZUZZ41QBGqQPUGBgyMhFapFihByp1BIXPpFUQEpZibCKwKUcAAxS
BzETSeFZpLyuri4CjXdAigYQaWPyAVhaGKBp2txDQWH/Y9/TTzjESCZhOaQa
UoeVPc8E8XdVzGsSfHG7DFgZszQBgs89PnmWpgZg+N9wIsPhhJVoTpoVvUK2
XN+77A/HfzP70JPX25EHL7NxnWOsVEpy8q6zasnbOumycWGWdYVBq3OxHsrW
2ynVp+ymJc9kti086Sl2l6fZ5Gy+nRQegqv7Hg9jbGt4ky0Lx9f+JoY58fXm
0hjrSMfnkZzU7Um/PhC22tFtT9um/uttID3GJrbM/Eu0zNkjWi6rWeMa2ddE
eTwzUIOkaw0Z0k2TooqRSlCCNGLdaGCTpuY3kk2a8BfI4VnNxeYekksTwzmK
rdFF0D9cRxfSldAw5eM672rWkEwR3H4kD55ForlGkAsJV+BLk0XIg7qBCNQd
ZdAsSaGWcipqqhkX8DNlIHCGxGN+KfhOnTVjSBNDZGpr9iWIwIwmDbqO8lNm
yglTUVZmyYNCEEa6mvHJc5SHNqNdUMeEiogboiY1NweR5j9+uy4pfMAYcMDp
S2s4cSoJeXi1s6YkoBdN/4AC6BBsfIQBWkMpYOZCL1AoCgLaAj/FGMDegLIo
/ttof/je37oJc6ytGplrzY2NUUmkriQqSYMTfsWmJCN2WvM77YYlz3oRt4R3
eDrLw7nWmLTbmnCJ/wIyZbtp6TvtjOanbFO415odBiPZZr93Snhb6LYzq2+3
25c9xa/4B5TGlftsQWWtnRkesl3Vh+3ORY/Z+nCRLQpHWE863ZVU6khttlkN
622Dp7s4XGUtYYqVg5vKWGel1GZOmWr333QWdQoz9zGoQT8jR3IFNVtPU9bl
gdKsyCFsDVZ4h+cxmzCTYX9NmwcLaC6tDtBQL8+ADZ7RRAU0H2zKc3QvtoXW
U2BSYauAC+QS8xoM4Q5oMQ7fCdmhLbiGvcPgBVohy7IiXJIzN2KAOYimwfaA
3bFPwDqfYEILLqkTeSL3pE2+miqHjFNWlVPL0DQ5GlyBOZ4VzmlntBnPgi+e
JX9wSj5oF7QQ5ST9IqwXsUVZEWn4Scse0NZ8IvaMVTLQD+flw7qOyjCh5lag
lWTjybWV/aXrmlaD/8AwP5E2oh2/+93v4jgAQ2i0He+QL31PGVBD+4BUbgCN
gd0jyy+ePegQQuk0Wm/9bFsYttmR4X6bm260hlKbw2c3gLJjwqPx3qYJl1p3
Mjs6HO2hzxXUTOsqTccca3WEjUsnW8UR2Vhq4IqNL03zAowPA34PhbSl92I7
qnqVtWZjbE15u2PEsRXa7Z6RxyPK9HdMuNr2C8e64mp1cy5zRFVtanADPLzZ
Dilfb9OblsZig8AZk6bYR56+MczYI7raI7qQTFoN4sF5ABWa1Q2K6DGUOS0q
5HGdlmUqZ4IcOvkprgjCkEyeBZGgkbiAZmzznGJKsD0SA7L5TV7uyIR8KGZx
RBOMjubhEzSBICRUc1r55DfSq2FDhnORYJCBJpBm4DplZKgaRIMyBYQ0RI3t
h+ZE0rHFQC/oQFOhWUgDtIMazedFM9GOpANq+CQ4AFpBYTHpI4E63NYCgBST
ImL+kQ3F04xwqo2woyy5r7lfKFiaUgNbkB3EhR5RiATwoX/i6iswVolJYe3x
KcuvFtLsqM2cADakgsv04Q9/OE5nxWhkVh/hUL7j8QJzVCrGM5YeQce9oys3
mMbaL158h+0+/3jbsHqlNdY1Wl/LdBuXzHCUNdv8bLOdEN5pa8N1dkzPlY6y
dqs6PJpdkTSU6qOiT1ww+txea/Tf7W4Orq0MMzs/7OeK5TD3nc4Kx9X+Wty+
W5vtZ7s6tzh0jrdDw0ov1drgndCbdnurgEcSbEoabWzWbdPCElsZtiUReh12
97LHXgO9/vI8m1leYOeEu+2gceutPRnrr7bajLAulvvShY/Y/OQ497YarCFt
s4ljJxCimLZH9J1fW1yLJwIKMAU0WA+60G+ERbmu6YigCH0EspBedBa6THsA
oLdID9EAiUgyIoLtiT7E3sTWJPaHniMNDZWBPuxT+FIT7NAThFfRVVpQryEr
kME17iPtfCLWhF55HkSCXFBAuRAw7vGbuqAXyE+2KSyE/uU++pGFCaQDwkEc
w13oOfIB0egmYMN9vpM2eaLTNESG3Th64wHCaGAApgBm6G8+qRdw5D6wA4bA
UauGsAnpF+DnzFGsNGiseYvYEUx9hTmJbdGueGWaku7YK3TeuJrpqL0YeIY+
w4NmlT/A+/KXvxyHGLXEkL0hGDgFcJSFPsRs5B0Ye+8AnB3/bUcf2GGrht06
c0ukaZGtazs3qrAJ2RzLShVjakW7W4AVB16TC3JdqWoTknF2QrLOdrreuTyw
HOaecJHf3x1Os9akya4Kp9tD3bvtwc4rXSPd5XZl2YaTebYgm2V3hMvsvuYr
7dH+6/2q/wottjAZtCXZkD3Yfa1d0naqHRsOs6XpPBuf5Bt+oB+700l22Jht
tqvhLdZVdt+5ckBq54U3hma7f+QR2xwutGnpkKu/ihdvvl0891E7sfqEq9Kz
vNjjvQr91trQbnfvPgMj2U3PPYFwZc3ARDXxR+MCRjoUNYdBxjxCQto4dBq/
AFiAktAH4OI3DhECoVABgKRjuY7aI45Hx+F0YNBoViiqR2PNqETF5kifPDE8
FSLQ+LGMIzkycD56AiCgTwAIYEQ1ATCNjVFXB1LuVbdF2cROQu411VC45XFw
SK+Ab02lBodFuDtBBYdX3UZcLiCLkuS71hYBLxQqNQfe2uVALhpQo+RAFejJ
hAWqPAdVQYW4t1AVxgqDXFAVFAJdYf6xTYuWg/3iF7+IvYdJDPDydVzp6Ch1
yKMfHfF5RmAwKZk5j3nJHAV0H7MK0KxEMTAccDd4Bh1JcEVrIfcOwYH4b0cM
X9986Uk2vmOcm3AV129jbf9wvg24HhmfTXWdV291btb1pxNtXRi2M8JRdkM4
w121wx0inQ6i8+wdC27IIgpd/Mvj7LjkEHAX/97Wf63d33xFEoGY2kXhpKgJ
rw+sAwWAqQAZf+XXMrsg7IjPXRcusNvD5QnoTPnmJTkjnGBHhDU2J51hRBir
rDgPc+1Ev5ujsiWi0r/ZaeEmW5yudgKps+l1+9n2hqejdiRgU3X04v5V0jo7
5tCV9sMvPTZpj8B8oKYdkU7sT4CHfQZI6C6AisYqxpSixlRgG0bmtyazAhiN
t6NlAKTGOzFn0J785nk0FeJBt8qb5H1Et5jeE3+TB6KGFtM4liYHI7oAF3Hl
vqaga0sFQKnZR9QRzaVlMwAXdBH7Q+uBPK7zG1gBE72DJtRkCqDEc1yTl0de
kANGpPZNIQ3uyeMjL2xk7it4T5owA+mgATV4r/VeimVqTb9iwMARWGq/BNoA
+KC9gCztyz0IFbORZ6ADWaiafkm56RvaD03IfjakQ9QM+GERAUWtuAaef//3
f28//OEPa9uGQKhoa4h079CcHv9tsodv32UrFy2w1vo2N/eWWZ1rN7ysZv8s
++fcdLp1uue1Iptn7x65MbV7w4We1K1hp7W4ETlaOT47fCPf4t+qdJHNyabV
lGMB0QjXsWm7bQ9H+T1wWBmNzfjX7Q7hlvTItAbKLIKywY4OhzodjLPzx59s
I+VFkTLaPbFBp4yzwu0RjA7KJOKzMbdawxa3pFtilTqTCbYquJ9bXh8joSh/
nMZd2ze497onUGY1hxGz0xs6iaO5c2qTqOgTcIlS0hRerV9GmaKwsHaQGbAE
1sAk2NTUOG0BxW8+wRkyQz+CU02cB4NgkfQV6ydt+h05QfbApHbbQoaJbsR9
M1wvhEURvhRbyyoxJFF4QA0lp/kEwBRDEqiwbFtuoeCJ+6kdohBlnuce2o80
eB7jEk1I0EXDHApEURUMXy1PpZk0M1muKfaDpv0pyMon9/L5UQy49sQm5Fnc
aS0Fp3mwO6AnYEq9gRO0ilGLUQlsgAt2D89CKaSPgar5+TgKxULFhC+hNfoh
WnoAM6OISYJZAMzJJPxPVIFnMG1gQSRhH/GY/vhva/y9aPZM97Q6bLC61ubW
r4k6aHwyxg4PK1y6T4gYk3a8M5wLKu1di25gF42Iz+lZrx2WrYjITOO/mT27
7Ea7JGxznddoN4Zzy4W6vHbCGQ6JOe6UdjgYc9UoSK4Pq/Ecy3+hHxujA7kr
nGq3hKvsof6b7O7ma+wk9zjnp4NRV47LxruG3wQcQ47HJqeQI2xyNs0OaDrI
Gp1eZif72+nhETtl7I2OeTfD/G9s3QSb0z/dfvONd0/cx9wzhJVOonO1CAVc
0fF4DwSd4V4EAlwxWKzp3HzXXAqwq5m2Gr8DHOhIrsnTBCwyPsEduhEzTPPb
hHl6HN2DbkIo0YWMUmAwIxGEG9AleGrod9fZuUW2MCaNGtB8QlQVeIJ9UJ1U
WTNwwRf44zpxErCHY4iKwtpD5fEsz8k+Ji2wDsZ4B9VDEbSbBdXDRscCpdpa
b0hZtCscVaNZ4BBtJ4ZzpzlzXoeEfnD/C1zQA4of4y7wCtkBK6BI6zCGTDwT
SIIdrqHxgB3vw3xcY7iNYAyRM5oI/AF1DF5tBwbNkD49i7FKrBTokwZ5EgGD
Jkh/36tfcieqHnG0M44/wqruH8ZIf6nOmh1Gzf77gmyLPTFwTaEGU4fEOVE1
XhFOKuCY2RurF9uTA7ttQziAYE5SGLIgmEszw2S3Lidak19rLVUT60wbs3xf
R/ftyvF6X9IS8mv1xmxDfyT+9bgCZBJIVxhjS8JQtFqxfF9Vn/lX90Hn2OJs
XizhVe6RC7ZA+Bqnk6PDEY71nuj/HtG81RalqyJcLwi3OW3cZddNv8lmledZ
m/vKm8J1dt3AY7asvMGh3GqzWoatudpqzz927YQ9wnZVze9Ek9JxdJrUGJ4O
qpSOEm9r7yBtCYIwACngynP8BqoICp4Qsowu4jp5aFqVpnFzH8HhXVSrhr7l
86JmwQqYAr6YZQgZwofZzbPoS20LQN7FloExX96B+DHDUcuEajFNSyVi5PTd
0bW9hDA/yYv0tHoHPKNX0W8a9OAegw3aGw8TVr415gSDImBQc0nBNmloHjP1
hqowZeEAME2bQ4VgGx9aSy74hB6lj7XrI5ygnW6gU82ZYXzvP/7jP6JJSv/x
GzrWBDvMVE0zAGxQIyDVAgdcDUgCYNInPIMMYDrjXcKH1FELuugL+pln9qFM
JxXKlPHCu3efbpXMTRwGNxxKy9IhuzScYlPLE2xDtioq07d0XmEPd18Vv+Nf
npAcXKC32Z/dGmE6rdxrzQ619qTOnb3YoTYhabCBtNWOL012+HXaOGeGOzr3
j07m0sw+Eg7xgm0OU21B2mUvLDjdMfx82BDa7R3hMLs5LI9/qxz7fUmbHVk3
aMtT54LU3RNPApx3pE0Oy3E2NfTaiS3r7ea28yP9XOEYzyKUU3tk4Ga7o7o7
/kriv2WH7Dk2M5lmmT/Vl012j5Z7DmQ3pN+0+AGH+2nOLc1RC9+64HGv4BVO
W522oOWgOKC69ajVPXuEcleEMioH8QNWdB8wALqIASYW37XnAyoDLYrK0RQ+
fiN+iCIanN/55k1MN7u6NvdJu/xoahjXtTuIdqIjhgwtyOqmPKSH7kFsgZJm
BvMb6BKcwaQE1og1sFU8WQtg0OzEHNEZ5MM7mnVCmsAU6AIt1CZ1oVzADxVL
WrQBZSHmSn6aYgjNaLyROJQ2oICitK8X9ZW1Ap0BUW1WiGXPu9zX7GZNAddK
K8VblQbtoY0gqZMWmhP4IfZKvwEvbFnWWTLGqNUw0CDWCzCmXprlD5xpV+7h
pUIHeLsMqmD5jN7MkrIjF/zW5z6g3Fco4UfuPM/aGtusI+m2dof2ceEQuy1c
EH3KtemwzcwmFbZuk729f7cNV+ZGZTa11G1j0oYI2UZHA3DtKdXb/lmX3ZMt
djyuyuzvwxq/Nc1v7QqD9snuY/grR/xmjr9muzjw5Ab77LKzKhHCmU1MW+zc
sJ+9p3m7Pd99amLvDCd4Od/qLL/btfApYYmjbE5Ec7mURjRPdBZYGfarIfft
Q7f+H8ht82S3BWf29mWO0EZbGFYUyG20N4+82bO80WZn86MivmroDW5332e9
2SxbVnes17fZJo4bFyPA4/cI36YIX7SJ9uxFPBADTKXf//73cdoq3QaUvKvz
mYv5ElEeVSwJtKGcNYqhuVpa1g/Bg1BiMJA5KNaEXS3M5h0QxT2yE8GTPQpY
TqLWGPKcJpNr4blm1CKZIBjkaLQEZuEe0s57oBIp1MgS5Qe11IVyS1I1IlJM
eIlKFgOcsC+KvogbFcszV9VGaUYvzqYcmsWgLaIoN9dAKkY6BjnoJ33NkdPy
XdKhS1CMWqREG9AmeJyjtyTFmWVeODOtCAmzzQDMRR/AJtSNNtWWd9Qd/0Xb
14JcYghYzVjkDH/i6dI+iAYMgPLWbBRto7cP9E4sZhmgiI8+6ICoNMuOyo5S
a0TvO5fcHBF8jnuPHUmL68Nzope6zJEzMetwhZ1aW6i6Xhzn3uJUV8kL7P1h
/8Q+EQ70Wy1uHj8Whu0rwyeFHMWgc5WbxJk95yB0ANun+0+wv6sekRba+Am/
3eA4e3dgBQFQTu0zI2dHdPMrKeD9DrfOK/H5zSA7AeOViPEWx2XVLm053LbW
L7c56cQ4qNrleFwc5jk+T49G9Shsg3mbkfYnXr2rQ5vdMeMyG0wH4kDvunBM
tK/ftOjB+CnFvGXcJdE9Xlk+wfqTEW80tzrSqn32+bu69ojsnohsxEkuqSbE
ARNESQ4SYs41lLN2KNMeLYg/4sZzKEqe005FxRZhCXgJO2pbWsEK2mgYvcZ1
0AjqpfOQUiQTNPIMZjQI5hOdyfPaHJhi4e9hTmv7F55Bl/I8SAQt6C8kFynV
NjUgTAu8yR9Tn9+gANdA+pb3uYYuZEwUfY8ex1TWcBWoxaXGdeae9pXVhikg
mHdHTY2rbRyF7YLO186u2CQ0H02MeUzUmPCT2EDzE2luUMlAizauZE9BfGOi
Gryn6ab5xnleSxcHuhR0OopDHu5ri4jFrkE/0/4M8qCTQTnhMMoBQ8IeRJRB
vHzvvQM7d/Qq9sEnr7fWhharuHwuDfM1PpqPxjREfDcl9Y535p5WogZenXa7
UT3bFru9uTHrta8u25ZFPJdtZ5geFbQjOf59ecGJni+4Tu3Q0GMHphMijJP4
b8U+N7Q9Ylx/65xwVqa9uZVdsc8sOVO4jn+HO4MsSXvTGqCzCOhWuy6sdS5B
eZ9q7+reZc/431vCyW42H2jD6TQnjIq1uVc/O8ywq6ecHYFNEOyccFrIUd1u
t1evsbf032xn+nvEqSdkE+y08iV27+CbIrKluDvcIKl6a7UmHTGwR0SBuYs7
t693v3xP0N4RoY29iIxoxEZhUmDKEC7xDXCCvGuTIeRKQ6bICFjV8lhkVRoW
OdGWSsKbMKVDDnR4APkqzIohgTVAbAa3TksdeR8tpu1kyBfcgSewri3geUd7
WZKvZhvxLHjhWW3DRV14h3KCT8pFXdFylAUcop01EwkbEywWyzSjttXuf5RN
deM62ptya4Y54W5GnOAFns2XozGEuiDWRW6xbG5ZFdzTDofCtna3ps/Q2uAN
zsJ2BnfYylzHkkFro/FxpcE+WhaLCGxSF/DKyA8uN5qYPmcQlzRJD07B2kGL
8x59o2WEOqxgH1o7d/2abXJPV/QGFyRz4tjMONfIJ6cbo8Y+JKxwDd0ZPdU+
R/fZDg1XxQVcs6iaHw/L7FPVg+zzfUelEeEV63OH9mpX7kL4p5oPtc92b0wK
kI9N63GdC13Nv2X70vCpNYBjybvP7FdBeNleGDqthu5xnvTl4YCQ1eAdge6Z
zk967BB3+4H3KIin/PDbV4X1tiYdjCTFHBCGhXeHi9MI7A67t/N6u7/7Rn7Z
huQQ57Emm1Odbzd33xeBvSTd38aWxlm7t87OcKsd2XiitaRtNhyOiJbBQhcm
t3/G7MMgJxQETpAjhXfAKLJDfyLfhZ+XAIqwsXbUivZCBcraU0bb7NDdfAey
RJEQb+3DAHShFFQsalqDq1pAy3XcW7JFJZEXsIQ+iMrIqCeCp42DUXuacoWR
qUEuLBEMWyJURL+gE0Sc8kFTpIO6QuVqlzneJR0cBVQo+VF24I0axlLBeaDc
2kwYdQxNaaIiUGZ0i3pr/2XaYeLEiQlc444dVaT6stuxVrQ7PGxH9rymYwRA
OD2lcTmameYCxXi/IJUZTSASLS67mWfRrGhfplbgdaONdSQIyP3Wt74VtfQv
f/nLOLsKFJMe72tjL5iQ9wmcwfowh3ZI2juwc6ewJUa0+8f3RIf0wVlXR3DP
Kc+wSQ6U3nSs1fl7c9JOuyjMjd+fbz3IkXpYju0G2+F6dChtB9Lx70sDx0ac
8/2t7ve2uqb/cDhQVPCFgePsE9V1dqubx2NL9ZUC3V8aPs3eHJa7TVAOlQLP
H6husk8M7LBH3d0kru3Wt/+bo/iD/Wfac+5s+6/41+l4vzQclqM4tWf7zrUn
m8+Kv7L4bzk+MqXcHadVTk+nOFx31fQ1uvqu5msjrB3ttjIbdr3dbUvKK2xK
1u9J32hHjdtgY7OuHNbdm6wzG2uLm1fEAeVKVg57xvR9NX0NSJEYJISek+el
nkSotVkc0gWwkAZABXCQGq1EB+g8q33cARP6TtvVY6NKUnmO9wBSqVSqmfQA
CoAg4ehV8oIM0HPaqk2zEXge6Yc8tFEqek+zL7S7gubXAzZ0NkSh5cbYmACV
YSzKyzO6J3cE6Ub/K22FqyEb3tNmgTxPu9BWCnnjqWubBW2sBbloGxF+c1/r
HSFK7CfZR1rKC3mCINAKIkEdaGZTR4gKpDIrg75DPzMPEY8ZnYueBtkgFA8c
5NK23McuIhSOP/PKK69EWx69TDtpLQfuGv2MVw/648ZbLhzMXbovP+MLoZq4
Z2R3FRHvb37qYRvf1sG4bUT1DeE8m16e5GBKrScO2w46eA6MypTA9OJ0TNTD
/7h4a83SnpAyRDw3auzc087sqyPbI7yHkzG2OZ1cLh79yrKTbK57vicnA4W+
rkRMnxlm1v5mVNptZqmzaqeGOf7QOdWFtqza4y79FHfsgXZWg/b94Uh3urNy
Aen39F9Qg3QS/230R7bFqSn3hJ326IILXa8vtUY3pye5uY3vDZzfNnQb5ngB
9dS2hKPj5OeZ2aBfuzLcGupsW9+WGrQP7lhvPeU+m9zk4uYNsmLRnM59rNDB
UtSCeaSFXqTHkSy8Ug2m8BtVJc9Qg1BaWAgakUCkmKgzKhkUou5kyWMJ8Czq
GGQz3RD0Ks6GRYuq5DnyRZ8hXZQH5CHxpM8nUobOIF1Ur+JVlEERYpdGbybH
mWsKLF9UJwhn8ArdqN31qBumAhYubISXTF2d4RKUUmiKQWGaSQ40RQSoOtYF
jU0WXPdiJHGlTL7RJy0lm5WawhOatabhNrUYvQHXFoewxNbVjBpaRAcpwDM6
OQVegmvpPfCLr01sQlteElcQNnmOViOurU1ZwbDsdexveAFNzARKnYzD+4qX
k08xlzo2C2XZhx2eu4N19txDV1trXZN1Jm2uwk6zeckMl3mGtDK7s2dVPtBU
57fr7E1uz8i2/qcl2+PnG/xaW6lSLkzwfxw8zt/O7GlvaG5fHGbheCc2L7Qx
0SStOlsQLE+KdVoVa/Zvc9301h9huSlJfZ0Npk1ehgb/q88fJs6eYMYnNiuM
c7W7zv2CbWGh3TH+SFtTno477QnmhvcofMe/491fmJR2ufCEc50b/mbkOuew
M+yoZH+3y+udl7rs9LDdnlx6ewHtFuvLJtqhyUE2p2nA+hzCDm67pnq7bes4
KcL7qvFuoFdX2YzqkHWUx1rVa/eG68/o2MfeqliR2qtUh6NoSyLNedYmskAV
4dMUFOANTLTbLQ4m0ELRkoY+ESrSJi0UMlDlnjYG0CIJYCpHHSAUO6jV9oQm
HZx3FBZjpygnhJuADxQAdWjXXYQXS16b8KAAtb8GMNb2JZpeitJCaFH+7PmB
kQEVQCUoSt7hXRQvRgY0QF2hlSRfyBxpA2ACQLhA4XQNUAFmLUPiN+ChHbWv
BNcol6Zmiu54BlLgPgYCbUZ9CUygSAlwUUaFu/NzhpxwXWzoR8BJm+Fcofgx
1QEx4OcaSh9lTTvSdp5ugjXgSGOcDN2OD86rOhCRT+/ChHQK8CBT/O3lVM6x
8d8Gu+G8bTa3Zbq1py3WH/rcD63a4W6Jbgj9jrpOotj2mYEtSWE/X+nmNAPQ
aOKkMLULd9pmZ212djI919719kwYibG1Je7OdjlLOLbdhi3F7hlIvHvSOr9y
QWj1ZC8LbW6lZ/aJvkWOwZfCdL/G4NlnG5fY17sP8GtfDQs8K/yCD4w92D7X
fWQekr83LEjspDDZ22dFOs5mpq2eTp0r68QaSmXrzdptqdfkpLBC5vlo/M9w
g2V9sp8nCvi77L0Ofv8W9fxmNzyYbNPt5vetMy+Jep6FhdeFK+ymsNsOaTvA
wd5pF4Zr7b6Be21jenwE/wMjD9n0bNBWdx7hHnmnpUlqn33+bjf+94T+tTWz
HUnF5AMFKGkkAInEREX6UaD4mKATidfMQZgDCcUvRdNp32yQDLJBF0hGkYNc
zEZQBII0ARQFjnpjJgdpkwfSDgvoPD4QCYJRgaAN8UMVyRRFNcFgpIfZTh00
RYqyIuFIOmnzGwNABwHpZAl/P98YbVoEqyaVUA2NrlMMHZFKVB7Fjm2i1elE
3VD0jJvpwEhAjJWvjZZJCw8DciNNmoMiaO9inR0CIRZHIOanc+bzW2gVaoEx
rePVGOvQJjvwoU6IAKza9o3nUeQE1gmmw78oZziBEVC+k45OfYQLCbzjemvj
YdKiFzU9Hl4h32LC5150e25gtsUVgkPeeOtaVrja7Ig6fWXaa4+4B0xUq8dd
2GvDgmiwMzANCfC9Nw+k5aNejfbopLURpTNCs2vwiqvkxJMq2by0znaWWqzH
kz2x2uZ47nXg/ciLlNnJ/uxa55rvdy+x73cuLBdgfzT0WJdbF8A8AfLl+DW1
D8UlDWnhFzjuq/FrS4zsX9K+n+0qL/YEp9ikJN8rdIw7EtNLXXaoM9X1YZM9
P3SJPVY9w5qTers8HJ9FqLt5s+TaCHX9nRjWWnupOUJ8VbI8AePYkp032Lam
Y601aXEyu8weGbnf1pePtu5yj9045V6bmE2xtW0b3dQZi8jtGeTHRpCjQuky
xELWMxKIdGv8BnECeDrvDHWLFAMYrdGGKFDnSLBUFmkjXqQPKQBK+e6K74EU
TGKmiUEW2IciEp7TWYWUD+CCKtCHCDM6i70K6BFPnidNnkMHQU6avoVKRAWC
OOCi3WMoD2pXw3yIMiPBoI70qBdqlEWwjMpDGNjGOo5Ch0aRh6t6lwivUeiO
01YJuOGl6HQdntFpP5rTou1UNELONc2ipw90GAvtCtHCDJQ5n/rN5po9tdMR
gSYQx+xB/StihnkF/Im4MW6medn45Cx+Yn2h6qTYOfAF3swi5l3nvyQetVSJ
VhPdqjOoilD6PlFetkUzXPmmc63DleIkR4yjuzb6fImb57jmrw5sNdsXl+6I
fnQRSYsmPANg/RnjaGlU3rO8RBf5s+8JY+zFMN5TetmtjNS607I9677DL4fX
FlAvRxq4yg0NR7j9cGClfac62wkAvFdsu7PQgQ4XB3n8+0b/QfbPzSNZoeev
dUtkStKkYF8EfrkYr3O9H4vy3nCUfaz/ZPtA83FeBf/lqL7R7211xliQjo8D
7tgAQ26hZ/7EFWFLOYI/HQ3+kBTXmKZX78bPfumyIPQ/Mniro/50a0mabUv5
FLun/56I/jl1C/z6Le43TLc52Yi/12S9XV1te0R/aw39IFXWm1CpzRg1yqbz
OAvj2IvDCVH10WjVuiDtiMF3DE0UiX/3Zz2HkI9coZRIG0bQZEv8ag3Q84zO
wCIKiE5EJaPqQTUqHaTgXRJbRrJhCu1ZSVnJF7bSxmWkzXOUHzRqzyaMZS1n
J8KFgYtIgzTahHooPI9HS9qkhbJEIersbBgKxIJsRu2IIArxOtdUO4YQydNO
Z7CaDlzQaCLtDwNpUamGLzBhdOYs9aR9tUGkdg3RbiWUCRZV+SgrI2VE7YAr
DMbsRBQ4bcjaKdqTtqdflBe/dWgQnjoygDyg8Mmfcmkf273Dv6MYJd+6YY1r
5THWkTRGZXllWMpUMjFAf9oWA3OvMkBjnKfSnTW4Nssi4jv9b0PabHc7p3zO
mQBE35C02c/75ju4QH7muCnZ18NE+3G1337atzArwN/t9sBTfhnw8/eTpesK
8Kdu+Tc4AU0olH2u578xcIh9rbrkNdcOcaP5sHTCqzHByANZER28xgvf7RwB
D/if16F7aznyQNUeCutsoRv0Y1yj13tbdHllR8Js9+zPLADfZQ9Wz7d3DV1d
swAuCEfHkbjrGnfarMpU6yl32cV+HWP/yZE7/fsuN5Y6bUvnlujtQwRH1J9g
i8Mab4Q6t3zymfo7jl0XWvfIBIdEJkCn6iB3eh/J1XZ+oFTHxyLV2ASj92fC
aAfV6DfGiglnaRUjbrEGtngPgx+0YJhrjx3NT9FpnKBQG0+gi2AGkIXlC2rI
U3MtiSkj9Ug2CCYejXmK7kOSQTefWtaE1CLVsBY6mjFvGAGXXnF57BDqjcWe
ZVk+a709FgGTQItnqCb+CaBGJ6I6yQqTBNMD4BOW08x19uPMJxHmQwY61V1b
CkKImthHPhQZ0oGANNxBlSEFSJAmo3qYD5oepE34dHYrn/ICMGvw9vmu4XN8
JVx49/C9bN5wrgUhaW3aQtNTJk3A43nIhfppmjHPEgKAHPZOBO0FHTx4y04r
O6K73YY9JsyNoMHK17jXfa5kW5wg3hcOjvr/ADeoelIEOrEW5oiWx4L+rLDg
UfWo/1/0L7SfVifnFkDFnnSO6C7Fh+KfcwGckMa38OZL9hX3xGGApDACXh4+
tMYP/E1Iq/ZA6M+NgIp9a+iImn3A33zXsqeHqVmNCdJiRt5RzjPLnCfAfvIX
XDDZFjjWDysN2d/0O3NXXBDS/jgxttvNj1VhKGJ/NBfAEwvTWXZnuNTe0r3b
jqse4uZ/s20MR0QueGTwNneCLrFJWa+d0X16jP41u7fDgGJvaZKTZz7Hpt41
9vseu7Zlj1SwOlIBsoryQWHpvF7MZe2EzCfwQTmizIC9zurFaMCYwPzUOaAo
ZNLSIZTgQefBkC556fQlnU6HUgGKOMxggP9QVtwnX7CIsiR9nG4tbUImkW+2
nGIqN8oLUxfPlucpJ89QNsoCfsCOVpqgvJ0WkmKrTQL2WOH48DBbfX19sYhl
fIQ2VQK6QBn2YDY6rCgbhioRgCNr6IDAIEXXJxAX05Ie9lOxNUK+a0FLbF0I
EZLDmNexhbQwKrk4liGSI0SLieCfCWXwTqYExdmSxd4lPZEbaRiIihmycKhO
EOZ5HflHg+oEEjqEhsMHggQIE0ImCjlAKKRBMAVC2DsRtBUWwZc/+IYYwp+b
dscp48wmvzgszi2CBvto5/E2vdJh40r1bjSUYwD+WAfJW11VfzJMia79z4dW
SMOj9Ln0Pa+jU4D9amR1zR04wY0JDAeeTIrnf7H0wBo5PO5uwfhSOeTuf9l+
PLSmxgJEFF4IQyGPAJTt20s31ihgolsON4a5oVzjAM3KHSy1RcsfzKfFv04C
0UN49VqLTUk73PkYsbeHHZERnm4+wx4O2+3McICjflJkhgmZa/nqGnuq/wrr
ycbY5nBoAh04+T0xeINdXT7TOXSs+0WTEgIEXleCgrOzAZvufzOzmdaSuSi5
DdLgtte0dMDrVHUKLsdJ8s17JIS6SAgADIWDotKZ5igdJ4IkHq15XuQETAJt
2Ss3VsPZiAafCDpqXhPfwSBmAkE1QCK3F8yj67QyGd1FmhrKRtcy0RtVDl/g
RJAWBimIQb8inhj2pIF+4js6bfSEe8SX0AE6FeCSPiYG30dvOobJoZM2dIYp
gT5AjJmgeTfkTTlBIk2FGcEUOjgQhMJ31B8zBN6BX4lz0n6kAbfRfjxHO4hj
KbO2wiQdrRoElnAaaTFEDwfDCJSDtgTCmuCuk95kdvn1BLy6WmaODhQMExDs
h8J14hgj+d/5zndqx3sxU49RP83go3uef/75kA92ViOrwDA6cpbfxTlDe6OE
1mK2HZFAKGFzOi/Ob7k9HBqHAN4d1kcbgTgB0+daXfa3Ju1uI6DMAS2b57Xb
SgckgP7FktXS9A+6ITA5yd2DJP5btl8OLIkcwd981/LXhvYge8JfjUkUkcFy
kfp3m+faD/qG7RmnmY5SWSMAL41sikxQTPWr1IggjxHGhTMXhSWhXKD+A83H
1TggjxJU4iLWy7yicAB/z3bvtHd170z44bcfCCfaqWGFU8VYV+aNcT3bKWFT
Gimgzd6x9OZoGxya7W8tbkpd0XdWtAt2hdPdD6g6Dwza1vJ2q0/qbXnd/p7M
NKsr1Uf7YKB30p7hf2iEP4pLU2QIwynSzCf4Rt6RS2Rcs+iRfU0JRRYVIQZX
2sAE7GiPoL80v7EvNF0UQcKu0Gmw3NdQNQKJya9gOzygs73gE7kQ2NSag0d+
4E3ONSFPrRalPNochTTBGGli41MmruMy6GAv/10sfmmLQX7Spu5SiWAdDINz
8SMcpbEJVC721aRJztxObN5bFAeI85oOp6Ao+QGHXhG3ELW7L39AnyyZMwct
YI+AN6qm1YCaUQ8FcJ0m1SZTchHoUmIEuBu4BNrVnJNLmIeHOQXeFTnkWSKK
GCZ0AZ8a3dceHPAI3bTvmfStxV4s9ZWq9TmsPzq0K8J/hmu7U5K5toXNptwF
6E3q3GXotElJxX6y7JCsUNdDaT0QjrD9SfOAvdw5WKj51NYxV89BOBr+v+ib
h6sQ4T8uYaZ8Vw3+xA1e7h5StLBSxAiA/lmVcTaStrpvnccDvrJkfYz8ofGr
o4HfmjgRhtUR3uUC5KOAH/+qntcbwvFpBHkqzBe/+Lds1zjpsSdbo9d6htsC
V8ZoQY76Z0Zuiajf5eTAlIjTx55gU0uTbUVpP2vLWu2IsNHmNM22adn0uNXE
xGqvG1GdcTLuMYetaNrHFkyYtgqia0mYNr0D0WhNxAhUaUN80Imm0kb+MAAq
BFsVhmCUjk80HKyCZtMZWKALDQe6QBJIBJE64Y/fvINXizVPIBuDBPRgdsMm
MAiDCVo2Rjk1ARCLArHFe2csHk0OE2Ha8y55U3by4VngoK2SdEIgZQdieC7a
I0ZbMsFglFXj99qKlDRgBWl5GID2kIcFvHXmFhYSbIrm1/Fv1EHnneoML1iM
vsAvAFrsSiYPXXMr6Df8A42a8htLSWeB40tgHWBlYTlg1GuzFha+Am3grvPB
qTdqnTzIT+OCus536oVM8J089n24Vkvx7yHLF0U83BYOsWerW+25OWe4oJas
zdX2wpSRgulRyR7oRLHNDebvVGfb97sXpwX8FeyXNe9OQQ3+01y7Pxg6Cj8g
DxH++/CBEfpg96XQq6HAnw0M18KEt4SuBPizj6rz0lL3nfnr99Qa/K2OUsok
IdbGaQpBvldF4Ti+ei3fraSUsT9FynSBNZXuWLdZodMLuSMM5QThJFQ9xj45
dLo97X59GrzmORXgEOAY8Cu3CMbbWe4cjHXQ39J4uq1tXBznBQwlM9jTJpLC
Uwtuip+3hgttUXlOBP0l4SI7vXxKXLJzZtjlpkKLLWpc6AbKpGgOVNzKqmZV
XILGPZLD9EgOAFfj05gAWkCniTboLq2B1XkIih7yng49R5AxKQA1BMN97S4N
cHRkK9cQfoBIZBFQyifPR93yg15w3xF+BJv0EHwA5kD1ZxxiIT+4hy5BrWOy
UHbcCwDBOANlcqJJ4mlnR8UBSrIjGfiLIlFNrQwAszq+gftatA7OKTpeAfim
SeRIkZY2HsVqgfv4Tdq8q3MCtUiHd/mt7XhoHkVk4DosIh17xDPM2GAwEOzC
lXSNNjeXGYAXwOQ+nlPkRJMM6UJ4hGfgWeqEmYAVxvNwBo4+aeNdMHcAdwHc
cx/c8ww6gokTCazj8g83UAb0CnnuwyVoLib+3X75KZaUSo69zppLUOfW9uJS
sxvjM9PCEO9zff3m0K3RvaTQ28T46nKch/QvLPzmUmJfCONz16DJHp44PToK
3MJpuM7VLAfFLXZk9KSZtfvjDQWyZyXlxD0HJtSe5i7HZc4N/D3qyfR4Ejub
ulh30+1ZfjNMtu+HKfx5S/Bvars99dnuxXx7+Gi/9pWwyK+9P8x1x38Gf/4r
/3eDP8fo5+a6aUxrSNuipDO1kMHEmaVOGwxjbFs2185pX2pdSYsXB4aYOJo1
4t9hbjbOcqTfF863tzRfbPf27rKV2bw4pXB5WGj3Vi+3tw9cH1mDLa9aSi02
vjzWrg/X2qbuQ22MG2LbJh4Xt2mN5kTdBGtOWmJg8foLTtwzY2yJjKH1pKhY
RAwrVNupoDYI4GkKmw4GRoWiXkG9tpEB/aQF9BBjbXfDO5pOB1vwnFaUA1/e
1bFwfGIC4Lhrj1NGy7TXv6YfamdFzBGm9fEszjXWOV6wVuRDAcCFuBdlJX3t
l4qJQHmBB3tJ/PGPf4xz24EGcNUO4tSdsqOyyVdbuOrMISxpBRaKLaZqYy7A
3+kmobJhOCarQUyqoZ3mdIIdWcEg3NOSC7Q/4wGwg07doykgULKji5gq8J//
+Z+1LTGornbGIT2aBsYhLVmOOjiI7qVZsQq0cB7SJS6jbamxIrAWiRXBKtoJ
l/fo5mINwF4Io6nYJeMz773TNVnZxjjCLgr725pkmits1tuX7YGmWQzrhZw1
6kYPA8S/l0fyIQDX/0wKzAorAqfi71v7GX4onIhW+4aTzfX+udGzXOLJt0R6
yBX+1CR1wyWzixy8NzpUP+ra6cXi0KbfDS/3X//L1X9qM7OKQ26s/WzpGr8G
Ofg77sgscKPHacG+NXJMNfIDswUHmMBsH6sebp8f2pZ6mutwBpZ49jucN7bG
CZId1ui1LHmtWJ/fm3XYcJiKvVBzKp6onmbvH7oossJCZ7qV6XyvkvOCFwNm
eKL/Kveldrj/M80R3mBHN6yNww7TSn22urTCRloX2ORyb2SGRY3zbDCbY0P1
c21R0yK3iHri0EN7qcMpO2GJlavcPVHDKbWhR+JSWNVAFjlCy0EPyBCWLuKO
ZY2s8RvHF80HzLU7XGEMxN9oU+DD8zoOVla1NvTHItdOizo8QBuu4oXIS8AT
wgImfohsonW1WyR5kh/0AM1oeY8se+oAPckBx6jBAOETKtKOkuAS2WcwHkwQ
34RedHIlaYFjTXigDIRhwSmUCuahB7DMe7SnTjbWMicNv2pIV8sD4omonL4w
O7IPNh1Jo6jJjrkCxAWJC8CSDMPAfjo3AdpguIWj1zE8WB2Ao6VoMc2PUUI8
QcsltQsSRdaEQxwL8oNq+MSYAPraER9DhPy9CxLqXRxkib9CLfbODI3F5GKi
i1Wn84Nd17aW6qwva7HV2fg4hacI89tLy47SeP/trrqJNLw6RphF14NYAF7B
yWlLThCNcQBhqNJgTY68CQ78Rv/MXHoW+feT/e9mT26eX7uqvtF19O8Dm3N8
mZPZ/JpTgf12aHElckI+nummQzQanBcqkRbKttkNokPSMZEW+Pv2yNGeEtxQ
rnGDU0L8+9KyHZ62f8O3ckdneTrF7p252c4II3aA43p80hJlu7OYm4h1cEt5
U+SFKek4OyqsTCMljKlRAobDpWGL+1MTbFY2JY5AnhZOjFt7DLfOt5mVaXbX
lOviKOS2ruOdBpqtM3NIpO1x2RFjK6cef/Ce2WB1Le4AyuhXUI5m0WEG2KOI
nBbxacKhtmfG18XuBn2KL4A2HXDDp6J8oA62AP2K5HMfP19HrqFYsd9hCx2E
ANK5BqNok6x4Cp9f5/5oo4JyyHAgfxCHxqSMiD6o1loCWKPY6jn3ZsZE5Yei
ZSdkXG7m40F+vAaIUdC43xAmxdAeIlRDO+jgOhQ77yZYAWG/qPPhDJ3IrP3b
aTGSorW1JBEAos+ZBggQ4SWiBdoYBwRyuiyDAEwj5PRKhhQJHP7gBz+Izh12
iOwB7BCChXAcraejm+AnbceFjYBngs7nXTwJbA/S4jt5EWDUVpZ4ITp1E+LA
2/lr2KDO1h+41A7uGHJPutk4rmd3OieG7JnI05vUJYVj8a3Bw0YHH/KYY1Oc
QTgprdpNocN9a1a6514CqJ/guq/ekX2M//44McVQzuyPgXDBvJQZv2V7ZXix
/wsRsIywamP8FYjg19Xx9pv+Qb8KG5RfwwaREUYO9qu5GzGKEmpuxLeXHiWK
iN7PouhuTHLHpjkSQhL/Te3Lw6eILryA/FuuUcXTjusPD51r725ma2v/5Y11
dVhrx4X5NuQqnp1ACNcwPXHA074u7MjpovM1dMHfrnB0HK8YzGZEqmDTkMWN
QzYnm213DF0R5zEf1bLR5pbn2fRklrV5azIw0VzXuBfLYULkCrCKJgVLSADS
BTjQgkgXjgY4RqJxPlBraFE4Q9vjYu1qUTJaFW0OvuEHMOx4ZhfCctmbnvww
8MErAATH2qCPvFBpihUykqhQA1YCYCWsThm0JkiOBZ9YDlgmOniB/DU1AN5A
qp2PQjxxOCyLZYTH4Aw4BKcHDmRkApQwdx9VjLrGHycdHYZGe6EzdaAfHEvd
SUOnNFAXLHeFdGRBaMcEGAOC0QZ9tDdk9Ktf/SoiHBVPXjh6MASsQL6kx5Ai
z/34xz+Oe2cyvAjLkAZzjPPJCxMisvES4HX+yJ+8YBPyYqgBViD+gPkA+eE1
aJt4mISJCjCDtiCgTtoMSBur7CMO0VBMX+YIh+7mdleOi2ysI/a5sLxYGVxn
K5yvj3fFqXkBX+8+IM4eLIISufHQHGctMEo5O623ZucHOGI/B/jVEYJV+w+3
5Z0S3GpI7Z6kbH/qY6ECxJG5988+XNF2sFcGZ2eFEfFmf2BWEtmCP7e5u6dn
hXdBfOPTofc1oQfnj/8jHLHMa3CGc8xozhjNI+KWi8NEghAFg+T/fnHBSdEl
efVa5kzZbQe6mQGP+F9iz/edWY48MsEeDJuswU2VvjI7LFTcZeiwlc4rt4Wz
a8EJEYjzSrQbBhqm2PhsbNyj9/7uG9zQmmX7Nyy30xq327xsvk1N+21c0uUm
ULuNK3VH9+f5t13jDbUnApn9mu3/FJscvTWIdmvGCNGaYFxhwKgDjgGa5h1r
WjxgItoAAQBSwA5IIQPikzruhPzIA2Nj9E4F5K2TN/39pNjvmGLBb5jA8AhY
hSewN8jKOca7yTNO4la7J9YmDlFeCA8CAYAEHSkTCWCwQHIYNzotk0QhIp22
h0vCSj9ULeBiBhCuOISrTbIxxMiP9tOKftpLC0XJn/rpTFvISHOkdRIgqp5B
B0wLgohESLD7GYx46aWXYt5cg7DxDSA4xiUhBtLQGm4IgfnMDF5AQuRLO0Dw
kAZl10mF2nAXIiHASWhCM1Nx+XhOJMh1zYtQABgi+SvJ457dp9ncSl/cBZNd
Q746sj1oqhCTiO5xL/3VqcYNeCExNnGBw3phqT6OUsIWBzqh3O0WTJ130ysD
M8oFC8x2tfWofzph2B+rjTI2JqRp5BUeSuwPnePT+JWZA2Wil5EnkoItftM/
J1ofo6+NZpA0/lsZzSDxr2CPciSJin1jaL19tbqs5qcUpFEuGOKz/cfbJzo3
vsYWGXJK3OQuGQyR2xupPdt8sn3EbRB+ZfHfnrgR8Plhoz028yI7pXKw12Bq
3AYBDlkbFte444ywwbmgxW4NV9pRXWvjSR7bw3GsmXb3ptd29p5sq8r726b6
fEuEfMl2JQYzuzrb9kwbDZE20P/amESze3Fz+V5E31KMf7eMuIVkopaRfqlh
7caPypZXjKTCCCTNd+2LK5dGbgvsEEvspgJZ8j6so9hmYRYUoyL5ZAskmpmI
qGxtny+GggVlRhD0IIyYgOuQn+yIlIOkYsJDZDHy5pN8aQYYTW4QbheMAWJR
3zgFIAeHApbEJMBcosl4H+SjrlHPMLHiutqnBIbUGai0B22kDVtxWEgL1sBH
wolgv3vOU/vzn/9sv/nNbyKLYQLxHHnBGLAV0Qm+Y2awaxFlxPGhjNpXHzMR
FiBKgaagPYiGaNgTExJGgJJ15insRH1IW9t28yzpwzAwxz5Yo77gDnYM7Wxs
dmGus4luwJ8TpmkvsRizaPD3XghDSTFBmVVKPe6SVLwnQPc1TKIMrUkRWPhg
YDGy80DfJPt9tUUWxCQniQ+ESBn2p6Xzcu4ou1eU2Bdz7oh/fxycFUQfbDS6
yW2YnCT4t0IEQ0ZI/GNc9JthcrkIX/xs+FXWYLrGRV5/hS9GU8bJYbybP4y7
wg0V+1T30fZC3+ZaaKPginJBEx8bvlBmRkEdTXEnlGvCFnsgnGNPdF9sT/df
Zm8IZ9mOcLBbXn1xSuXUco+tq1vqpkNfAk/QejPPtnFpp1Pscntk4Y02LZts
1465lCWkrEfN8rMH4qcbGHsmiWWRJBT510nUGgMlfIchiwHNfSQciYY4kHKt
F9LphNpvS+uaYA70ok4axwXHucDxgQ34VIhQ46k4JCCcaIB2DwdBPKuz62EJ
qgcjYDOAJGwQnUPFd0ZQ8xWODTUnRYfaaPm0djoELc42CVQRJscYC9WFiAC0
CIyqoYa5pmNniTIQMZWvAiFi8wMi5i8AKswO3lOkgOfUhBSFvOTvuVmVgMYw
I3IZr+MW/fd//3fcowjMgmmil1g5Wg2HZUegAneG5+ExrAt6gvsUBZ7gGuli
MWkFGlYKFgg8wbNYDDxDj8GLDHpoYMPzT+Km7+WYNQYJxgat8FfRRJs9cue5
HJpht4dV1pZU7JGwpLYl2a5sgA1K7NngzJm0OpWkNiOp2qHehyuzqv26uTcr
+OG+wIk0ae5hLFuUFdGJ8Qk2QHRDco5YwA5GuYHRUgLkdYWBkT//yvCiGmkU
RFFEMzL77fB+NYKIQ/b5kMfPlqyNxDAjq3ejf7KGPP5t4FB7sXm5bXDv6sC0
p1qEKf6heb19bnDraDrwYoF9J43F59sz1e3iBKt3V+OGsD2BDLw8b6meZ88t
2h2pgb+7wmm2NayJlIH2XxVGQs4HTfbAwt1eoKk2WJlhd/Zc4QQ8oUYC+Smy
eagPb+N9b7umbo+E0BIJAcAr+A24IAUkVsYrYok4AEgM1rgTEIuGTqxNBwZf
cId25uU1cEZITKORaDmeAf/aQ1u7ocE/4F6bh+ALwA3aJQjDBr5AMrWiWiu6
0P6UAysB4GJB8D73+A1H4E/Ae5RVB2aSH44Ln2h08sNpwaGBk+A67HbKjP9D
JBMOpH7a1pHvaFMQBBmQrg7sAV00J8/BhaAQRFIn6k66pA8hQCg6RUHnXOt0
KojHLQfvfQdgGIjjFayRxBfhzDr+Y2MZ5kMyFqExCS13gbBAO+gudkCJ6ZIn
pEd7kB+WEaRF+2rXVnE4deQZGESrMGgDreAuTnzdNyVk1u5IujwdtocdI9WQ
psUeKH2VJmt3BsBZPN3dkI+7cQ7wTgotdqhr5d8uXhayIvJ4pTPE8rRcw/Ir
Q3MKA6AScf/SKE74Y3Ob/am7OyloAVgUrxWvZPbKgqF4DePyslBfKYyH3w0v
txcdxHWh5DxSxCicDqa6o3Or/6orYg//2r/ONpa74AG/lscZiDt8ackOm5y1
MrRRjRxQtg8OnGPPdZ4yGv/+MAQw1t47fE0N/PyxuGpGOtkmVrusKWmww8Pa
6DY8teQ2W11eboNOn30JIc96a/T7gF0uA5Ore7vHhj0jP61tappvUu1C4L6b
Ius6m0fnuwA3Tavinv/2d9wZDzfWDtjAAEb80XeMWWgJMaodMdfBwsCVd3Dt
gT0UwDukz3PkwTtAXiOXhAV4HlpBkWHUYhyj6IAU9KPtTTQeojlRo80HntNG
xsAPPawDObSoFB2NSQEscSC0bRzP4UBgggAZnRyrowqAP3ABYgrNaO0TUMNE
AuLko5ANdYZCtMEBEMNYJ+bIyAL0yTAnI7yMYmD04xDgVLCYFNgzvZo4pp4H
+poTxScKH8hSd2hRoQjRMv2LI8ImaRgWxHGgKq3ixDDAWdIKT+rILAjSIH2u
7x35dYXP8Ohd5zl42u191WNcM86wJemYaAy8MSyMkQZmMF1dHZcVqvdI13Qn
5qa8/W7JSFoo6q0u28emFaE4Bg+SAs+McPwuB35IiujknwamRSL4pf9lISgu
8YfmTvtD90QbLrE+ukHTHj7aPxDXcr8ahKy3D4cJcV6U/lb6NUIL9e6xTCcm
Gpr8V1fK5itN/i67qI9NWdTIv2mc99DuZjk7rsV911KvBAGJ28JhkQqe6zzV
qWGnKKEcGWGMvWvwSnu0+fwaGyxIZ8fDwi6ddnLcQJKzSI4PG+3tQ7fEAc8G
b+MOTqkvVSMTjDYJ0lK6ZzKYWTuYAEFFZyComAQYsrLzNT8S3tfZqOhTwAtw
tHM/QMTbBog8jzfOb+x1dDPABHwY1lzDVtfAhA7NIz3t4O9kkZB42BmTRjXz
GsViPAXZxv7WnmiaRwgHkCwcQJIkzbsUge9wCmM0OrhHyxlwQ+Apxh/ALJ/w
DvfBEmE/DHPwiykzenUzmNMqJgx2sAzeMC/IA3cKJ1uHLmkjcoUZUcGEMcE2
A6xMX/j1r38dw4wMtmLoa8aGDlpnzAJVD0YZbwC/OP9wiEYiwS0OA9MjwDPc
SRoEPOhy+Ae8aydp6odqB+twHxxBPuQHJ2g/NvgX9U+acALc99dwQaPNmz7F
Dk+n2adHdsb9FU5yT2wwIwpQsbtDf9wk6bn2afaD6owivFeOmGMqYxyMbJ7I
eEItHLjcZZ2xilfN/Vf1On9x8nNuAvx5ZIF9EoiWSsWEh9T+4HI7OyvbmxzK
eZJ10em4JZ5sW43Jz03ZHaEc52ymoaT4NwYLYQP9nVlqs/Pd9WEd2GnViQQg
PbF81uSK0Bq3dL1rIpuUMEMqtXGuuzdXF9i2OrYkcY+BDSfGhIY4lqlp2vm4
Zjme3zCd7SXCVC/XCjs7HJE7EFktnlAwRRIPA22xtw7caGdXt9iYpD2OVNzX
f5XVJ3XWnrRZnfsWkAQjGfgYdcU8sF+8+HR1j2RxfW0HRh1gjTSDPiwHtCdI
0cl4oINPnVyJtEMKEIBWY0AUoBILAZToVFuNJBJwkFYn8KB1ULyLRsYR4HnY
gVFSiAjjXfdgC5BK2hjwoA6px8DWRqygEQeBd0ifvDRLQ6OZ5AEzoDkVTEDz
gxoYRqshdMQCBAdxovFhGW1Io8EJ0AdjwAh8gjbaEesBFtL20lgG0upaWYE1
gOYHpaAdzY9GxrXHOgKJOAo8A1pBP6ECrX3FQYG4QT1pUA8QDfuQjw4uhslo
J5gPhHsZ89NLmmJRISOKpx1YMSDI/qc//Wk8NRRSKs5ET5ATNizy3HiUFtw7
V1SLuZMMbzY5L1wehuNShHpX2Zy3eWHSa58PC2Jwjj1YGA742bKDRBcsk7rZ
qUZe/W8HF9ToYkFaiSMNr7oBqb2yZGGc75DzAlzRaA9NGF8LPPD3bb9/ZzzA
L4vuApOo6l23tZc0178ujnkS48R2ga4YFLnd8Yx3890pS+RKFG6EfWvZpsKV
KCucEOMHTINwN6KYLZXVhiKIIXx85MLcpWi2R8KxcbTy6o4TbHPdSjsgHWKT
Vs8tj8VjU3SkzTY967HBcp91l8aG/KDgZs4ftUf7b7BtYZMbPe1xY6fZyay4
/pr6iBswIHAvztp2WNgzMVxZm/oAMEZvXIigAwDtXabFlxCFhie0eYMIBBBz
DyCgQpEwgKVlC1gGfGIlYGEATvKGmLR8izTw6HEBcHUgBYiE77wPiXAPFQ/J
0F6kCVGgRnVeIL+xTjSZEhKBELQIm7xJj7TJX2YBlhJ1UMSTtCkT71NHrun8
IfKRu8V3wKmzcPHodZYM5KHziIgUYI6g1lHZRAOIG+qcIMZVAD5mAfF96gQZ
YA4wxeHll1+OaUAamBpaNEtfUX7MF2KPzKTE5Xj88cddKrwUoTvCWGcVov4x
M7SxC2SiI8QhDViCUUsIibGQn/zkJ5FsYA6IjE+UCPkjK5gj+4gmVIuNGu64
Ykc8B+zZcKQtqLix6Hc+GeanRZyuCPXHSMJPh1ZpWsFAVkXVjxpQzOx3I8sj
TUxPOdegkokbqq32VFun9SdJEVtssX9yTNztvziFdLLLF47L2GLqDEOhzK9e
U0yegC16/d6lzZ3VUaMd+Bhu29jLQ6uqBV8VIcZIZ98YPNxebN6vGIeojJ7f
EP8Yq3yhb7OGIvYL42xdOrMWW8SZeL7vzEoRdhg97ECY4ZFmzvHMww7ub8SR
S6yJznh4WkMxAbPNZnirnRA22N3VK+3JBbdE5wM+YCblROcTwgziBzkb4zs7
9sIR02rDlOAabhBH6IwxFBLftT+idjCVt4FS1WJscKxDUsAiXEC6/NbsAXhA
sxtIC8yBP/DqxkG+uLkuUgCPoLe1XbnmXXd1deU7n+e7RsECIJ6UtR0RJgQo
xtygFWALmEJTGPPl2P52ODqWGtbBJOJPqAZ5pAETiQ01sUinSdEyIIuWwk/D
9MCYB6EgR4cG8x7P45zDAjAD21JoYpk2XUVfYwJhujHHgXQIMqCceZcRS2KN
IBg24js6HQVO3TU/GnTjsOC4gGR6FQdJC3ExR2Ag0oXNSFvrwJU2JgxODjFI
GIs0yY/JYoyCKJaJSUI7/JUM0dPe4ZjusBnlDobv4t6p3x45OikY4gPxDJWS
RgAT+1HnUO5xWI9D+H2hJSjyUEyA1NyFnCGaos2wsZHBvZINpPnUhigDnir2
wcVurhzs3wfcjvhiuVEuR+Fu2G9HVgQxA6+Rc8EMlWJeA5Oyrgx9tYkLX+9b
a1/vPrD8f5n8pIkLjEQQgHx1EmU6ehJlbTJDYU2MmsxQqU1mUCSSGMR7l12T
ByqbI1MQfoANdvYeb6uyZdG7gAG60k47Y8zmWJFDw8HRy2hMGnNbIqQ1L6Oh
XLcXlnigtrsLzif4gCE0so51gRygAbX7KOgHL6AbjOLgaxxTzABedXKwZh+D
UbCqRdQ6fghWAaNYCFrlxX3iEtzjHdImb+2tiKuAG6BAJyyjbVLQ/Jj1GigE
b+RDvrgtxTZsMZBK+honoS5YP9SVwCMulyaKMkMBZoRDsKrgEE0QZ8yBtkOj
ki/34CiChGAQfNKuYBhLgWnRnP6IltfJZTqJAQvjRz/6UcQi1gLlJ+CI5mbt
BZxFgBIXBS4gTTgGN0UzLXRSBNxA+nARvASr4wbiluACUWY4AwsASwLLAhcI
7MNz/IYL+E4ABH6ibKRFmXGhGL+A1ygD1tTeaaJSBCQ++MT1ce1mq1/ZVZ4T
j0ZhISSj///SvTrijsUMrriLgERmP11wYIRrVwLEWvPhiSb7Td/MuCLzJleN
DDMOl3JSqDoomOXQ7X+9ThZPhTgHW1OisCiwHF5ZtrC2EGNRXKCR+zC/WzpS
KQZAxBPiCi9Iber16CmTmh7JUCUmxehplG8M0+IG8KMZ4ktLd9SmTIpJTgrT
baY7FK8yRCr74jVMMtadjJ1hfSSJNP5bifGIdw5cUWOSLWE1+0HlsYlWu6/5
KnvnyG12Y+UCtzOOtKXpvMgiHU5mc8LseJS6Zj/xCWe01TXbt154uOi3Pe8N
BXJ0EjGI1NmIjpgEByTMiMDRHnE6Xw2wEgfARNHmsZgREAcEwj2ew1YA+AAO
cAI4nsdeIGt8fq2jIk3ukQdExOgCaWjlNjELzULwYua2xhgdahBlmsc1r1OH
TsCJcA5J6NwZngNP1BaOwgoiWa9mAhmFI2IpgDDJySCiYbRYFBqlNtpqFThj
IuBkoLKJKUITmBJaBILzAaxxAIA9zxB/xEwh6oDBj2lB/JDxC+AKfKEGVD+0
oe1rMUNYpgXtMPZB9YmQQAeYDqQD/fBdtEi5MTegO75jcmg3IBwQvkO90BX3
oFHSoWxEPEgLytDulOS5783iRB3XnncCp6TZBdncaJyjZ7UeqkBd1NFDKZAG
pR3EKeIUxq+6Vw+4P+1wOJ+tHNw6Ya0GJslkdxsY6dAyzZ/n0xmiSwEx/GnB
HE3Bftr/+jVBYmSxlm8UI5q1EIhTSDHhIY270X4tTHrtFOyla/6qKdiQYjEN
u8Yxo1Z6hXLhl7zQd+xrpkhBqv3pGE2JkPGhaREsCt0a1lSKiCbTId7WeaFd
GDbhlmRF1OL+zt321KLcG+EI+fXhMJuS9sXveCRELvBKWCieOfU+8+Dle2GL
MbU5UdrAEMjrOEIgTygTPGlWoFwDIEtoUOMUUIJDPZ7CEvaL8OMRPoEoDos2
iQWqOhxOTMN9kuAZzAmyJ+DBd6250J4tMArF1NHhFA/YUzQdKc7UB7AMBsEG
szsInuC6MM5BFSm29r2hTJRXJg/mB+YL+Pqv//qvaHLBZpRBx1G5q5HEHd9X
R0se6GDpEwFkWQVQZtc2PA2KBKz4rcVUUAQ0gPWB9QDk/zdj7x1lV3Wl+66z
9z7nVM6qoFAqqSSVpJJKKqlKVSWEkBBCCEQUQQYkRBTJgIkig5DI2AYbbILB
ZLCx3W5z2+a2UxsnHNpte3S3u8ft1213uL73jXdf//X8ut8f883f2vs7FFwr
aAzVSXuvvfba6/tmWHPNye1wHt+jfWAJAFX5NNA0sBTwLQBXoq2V/Q1q4VpY
JdAXfVLUNXSF9oHWo8R0aBmqwYcg0IZcNCQoDX+J8kzSdzQP+sE16D+vtMF9
c60joYuKLZkzO9Zp+Oac7REUq53rLyj1Cke/mTjDdrg9vzltLtiiwV4sz/Jp
HRw75biZu6WItyaM0i2UGPTw6/djrkUQ/1FtJO5acZPFosf7YROjI0FujmlM
UXOS/vvoGjHHocOu32eN+J+F29PSGYqh/LvJ7TXLBWvL7z0oYCrGSUxEM8Ue
C2v8RrAOclUDBYOAiQG3KXaEY/JVUYI/dkQT5JzqetvZvwnHpPdhvo98oy2v
WxhpoDf02IBzW3eYEXUlKAEHZmOp0eaX5tl9N+08BCUM1pZDebjIFFRq5r2K
Cis7AQ4w8AOWldtpuvzkXOQNeFFySsx5VX1FS1DaVfBYpITJHSn+fR7w7MgM
10aHI2uWCsNE9MtkQevgeMwJ+oUMZDJjJisrMqow4KJtJjnylomN7Gf1RXur
lNiCe+FamEhwjTLs0mc4hX+o93ynQpOo7zgxUcHRB5SLi1AlZPa//du/RUAp
fhKgYVJwLDIYvQLHJOAiJoFjARmkQZo3tlWgOyC3iX0A+JAJIOcarP/SJ4gA
4uB3QIssFxnwTOkrx3EM/ZPbhOepelf0Eb1HhUTUF+kphFsxpugu9BuyEDnQ
JnyJTnEYN0W5cFZQ87UhrsOV4s4lELEwbcHuL0RsYxS7x9bNsF2uHxOUwC7L
RVldrCbTV8rNgmfTVpSKoJ1WUMPflJsIrQ6KmyxWOfKYSZ9u/9HcVvg2K/8b
Sfw/1RZWR/9YfLU4Ab9IEWNd+45gziKEq2Cx8ge2ZxQbRIMCKv929NRaoHVc
Vi32cI1dYJ9sOCryQlbwwp3heOIn4v+pMJBXssvi/pXmUr21ux3SmjSmxWpM
vV+C9RD9x5a4qOls+0jTKbYlPSazTWGdsyhVo5e4BrMxrLd5YaBmdhBTgVLR
kbTZlrVjByeNxtqyKHYsEwm7lcmJNETRZTIUFaRDXrKkpRadCzCZpHjnAS9S
lGMBFMdIOeW7uGMaV+JRUeaDV7gAKwK3B/o8OgJ6A69wBjIdzkAX4RW5jp6h
UEeOU4wXt4DeoUwR6Mq0y+RCT8EGUNF2uEGlI3jlfGW/5jqKowBfYIN/2pKl
Gk8IY3QJBDK4hwvANphCCJPVxXHqQ+bodb0KpQAXJYoACoR4QyUmWLAAg3Jv
sBTJPk6OwWWBosBjUaFfjoUnWJzAbgHHKBiKb4AX6Juye6ikM48F/lKZT8V4
0S78CDdoOxZ9RamBN3BrIkPgCMw7FaiFi3nsfHdklPHEvqhyULQ50sUPR3ba
7LSR+ImCMhqiVt5UymJJOSIVTnFKIa3Le6E/4rBI+6IoaG2tIDLqD82d6R8h
jEgaI0tqgdZFXNW0yItKfnpn74eDrbNiQ0YkjOHRmllS7CSvKOa64AlCPzek
HXUFRRBn+eu+jZEh/zRszn0W9VFtUC1b1kFYJx2tdsdVIbJINJWqxdIsVe/r
bX46I/5fnw4ldmpY6V/P8wEZT5bYI3Mvt9s7d1XjjvGOGHX50XBRjLrk/9OD
++yVqQfthZED8fNAabbrHQPW5QpKZ9JhraXWyBkYH6gxA26UbFi14uCc8ekP
eCpQEgCh/JxolQggJqBSQisjFROLCYbwRpGQ4II/VI2VSaWdTXzP5IQUFCip
5BP4CLBhUFx4r+RwrHOgVKhytWrNAmz6g1+BNrCZeI8BAehQLjBC6DftMsU4
nu+4H8CEIsRv2E8QB8YOKz4QCGQBgbCWgOMA7uN8lCoAp9pzHI/PD5Cyqoh/
EvJQbRnywLKqCfDY9URwFWQCjwJyFAzllcWKIMBJxMEaBEoHv2E58JnxZCwZ
ewhI1Ty4Fq/wPMeh6NCWtkvwzDgX3yXna4cGz4xnB6FozyfHoODQP9Wl14Zy
fuf+uRYkQhuQEO1DQEdCGk020NNtS0s9tdVEVhK7EqpJLIzhBz1p1dpdl+hw
XOyo75RXUb6K98Ows+l7OLElpCJMI4siCLNs/9/UqvcjsvO4ppo28v/682eV
lWYIEDkxravlmPi/mufE3Z/TWKLYmpHvFy/S1RXrpHX2RlgaXS1XuHY0lrXG
dJc9DuMZaYOL8HrFbLElhTUh/hOFdo5zx/mxfF5mD/ScZY/3nu+NkZWqqqq3
tbwRbON8a+IetnTGnSnXRt9nu5+/PW7PSOPfql0WdtpgaW6sJ9LoytuOcLYN
VRbGPVuU99RSCOloFsycfQh75PYaTWBPAAXkMJ9lvzONgAXfI7OBmipZAjl0
duDDe6aQlg55D81AE6qryrmchx4BHTH9kH3KMaPNnugdymiPPwEqAvrKYqVw
TnQD4I3fQdvYaQubBFpCbkNt0A66iDKuoD/TR3wXnMM9QFHQBzIVaNI3dAUg
p2I+tKvsb6hP0Cp2CDIbSAMt5D60ANzxq7CcQGwlMdBAjeVSnBKMC8ewWZOx
+8EPfhDpgAwyUAoUDBQ5RnGVtE+/gDXXZVzpq7Zs814pqjiP76AmzstVQ8qS
lePzZFxUFM/pwn9zwIe22D52DdeGWmgLPyafua5iv6EIZT5XIb0joYlmW7No
oW3MFtSikah3hXxnXye+TfJBoquvdkr5aKnd/mXoqKDAbXFFXC/tX5wWWJ5O
F4WfshZ7hYz4jw8Ebpdxb9b4AgXjf0XfxgdDO4vd4kpQJbookteJKd4Nc+yc
NmKiqHZLuHaTs0l9zNtdV1ydoG1q4rIFnmBUOOXatkm7v7qR3Wt1Rcbs6Qnx
vzZ6A5ksi8yWqe0Lp0VzI+eE/O+nq9fbF8bvtleGbi9y2TU5m/TVdnNcQ71w
Zx7S4zeVGmMeu+3h5OipWFpebMPlJQnuixjLkkZThLQvY0OLDs4XK2pVcnn2
8AB4wO+IH1L1oZkTymOFyFUaBuYc8wk8gxNEFphT7mZwAN8ghtB1mZuqmoPP
AT5h3qNusL5AO7StqlJglGPpl6pCKDqUmh0Jv4aLY7/gDeXeJpAL3whtMI/h
APylyoSHDQFPgXlUD6XJ4DiwB/ZREVgyJNklWAaLqCLK6IcYpV/4bDheej73
gx8FfDEW3CdiH5sCfgL7tEubcCe+COwHztH2KLhBS7LgHvzShuK4UQfwt3Bt
jtW52CtgnP7hIOX5oCJgszDW2rjN86QN+TcYY1RBniHtqywGqoZS4qNe0E9s
D6mb2GeMA7/R3yP0X8ymemHDzJjs8VQ3LtpKeZ36N5tHg6KxIAtCo3/bN2r/
1LxEgZrT10FYO3XeqPkRimisD8R1/8fwkulx3XJvFt7OyBfF7s9ahOd/TI2J
K4pgiw77X53zbEWlzi50MwM9ApcEix1EWxB+3lrKAzIQ1/1JnTNCZheng5Ed
HgwrKKhNpp1yUWRvgZPHnrDS/kvnR+y7Y3vqiqoa06roFEmyUxFH/JQV3+Gi
fCRcHSmiHP/W2Qv9t0ZVY2W20Mez1Q2NjrgGOp6utMvDBSl5q3wM2GlC1irs
EAhCYZu84sfoam09hHbREdkCCcvTltdSVeCR9KCQmcTMR9rjHVBdCqQ13zmC
8swM3bWal0xYhDhCkgnKd5AIgKF51ZnWPm05BnjPBESRQFByvCs9CWwVNkS+
oKfgFhzCHXAC8hJuwa8Al6Abkb+q6F3ElfaeKTQDTuISdA0bHd8jey0UDkFo
wR/+8Ifoe+R3dZNb5DrghpAKXDh8x+/oOLTPratoMJhUHWvOAVvoH+gccBRc
KnMALlYlDkwF5Lh8jXG/uP/gwpcuo6JBB1geSnvPe6AP5KElRhwa0SZengS3
gAVFN+imagYryS7WEMu63BLuFDJoQiOoGKg/dI1bgS4YfijlSC2QPHVpT7kp
po9em/ba6/5QcVF8fejYGlOc4Pg82wEV88qNbhRT4FX8kRNIbT1zfKrGFEuy
sj39IabQJq8P7AApctE0t4kl8nM67FtDgzarFNWVuPGTzR+XOQzRbJa5WYQB
ouq+s5ze2Lx+gmNuT+i128KcWAvgy2FJWuTo5LBvdWy1n47s8EYgiYqN+2VO
Ly2qldr49vAl9k7/rkpBFirAN50YppOFCITst6S8hCZyG6TqtLTVFoe5cYsI
ZNLtxtw9XR+z54bvDzlTVOyjRYVeSnfPD/N92OOxcb20iLFgmSRNkkMQxsxa
dJZyxGC1I4YQj3INqkwGngOOZYlD27e0K5vfIB7EOMeyjMl8LUyChAkZ1tSQ
pbSREALTlanL5eQEwWOJ1qMgKbQZ1fvBEsF6wSqBdFTxQmiFJWAWLBfaU70s
mEa1BGlTO8ToIl7C3//+9zHkmkgFVjfY9MBypYpRaQUIuCFpyVEJRF0zT1Cz
fO6DJByZHI5CAgI5HEWCzxgk+Ck4HWICmShlkAuUrEInnAMidUklHuTJ0D6E
Q3tKvU27QrMqmMIE+BlQJmQw8p6+QLYMsxQE+lDcSiQqlQ2S3wNSwx+jZLgw
FUoIxonS/B6aMbLiLxtAmiv48lNnhfmKTII0yE3/d2tOL/yd+Q4KfJy1pJQT
m2uRDEU85wejvtdMRbwX7FGzL4YWRZ9EsZtcW8cwSQoXacEx7THN3cNFrAWb
Sbv9KsrFj+qw3NWJ49Jmx16H3evikRoe33EVYpurG6eUZ9hvRk8uyvaUrX1a
ioy/nNxFRp1QKXJxfcSxTbHu6WX72D1H9Z7p37Gzdnk6u6jQxd/W6RxiPU6r
F4dttTR2pLijdB8qFGGcG0sTsXTPrWFPpIUsckeTrUlG4yrJJeEiO9b7RyHf
fu+TNoqkhRITg7WS8sH5Y7yWdAJgM3OZeZgKfEaGMUOYzdq2qQ1fcAZLFZAA
QMebCc8AatwL8AnmNG0wk0GStA7EK7IKxUVlalBqELUQATMaDyft0hdFTSJL
CfJSgS08pnCV8jRBRI7CkFce31lL4ysCwoWCqgInytQBnaCB/oFsRU8i5vmM
7AZFLGOCPlBDSBSEgykAiSCLQRXIxsvJ0iiR0qAcMwSCwsxAPeE6jIHKbhB9
CUnJY8kreoH26eAGYhw5H/RyDyAfU0WV+BSFKvbCfQFjqOAw6Ec2wCC0qz0h
jL22nULgvFfmDJgF9wVmDveCzsErOgjH0T7PSrWYGcfDmCeikF+886no3WOJ
9bru1TmFVKMHAFcGAZJ/1bk+ujQKCilooxwDLH/XP3bwkHA3WSZKZcK0ZG6w
laygjsKd0RoXVgnxPMe/WR9jEdg08n6VnqGkaiPenev82Ftcx6FsEN//duRY
72ie4jvm3HMuIZHn30+eXi2yaw2kDW7BDEfa4D9JuN4bOqtcMMcDYcS6XOLn
xXxyliislGnF/lK7PsRKHZEz6oq/MEdPuTVuDUGzKMeNsAsp9Gl3hiuzWPOr
PZbuudqNdhLp3hSuihGcI9ky2xtuts8OP2RLWxdE06TRCaSh2GECaVQLfTAr
ZYfQOE6rVerAMYEc0hYNHJ7MTJXxk/ahknaoBDgNtL9coZewCDMOZZtgB4wH
UKIMSLSD2oBRjDxUvDTHMUtBMuiGGVBLYAPYikVYNBzUCtrgWqypqAgYjgq0
HTR32mMWo07QT/oIUyh7HEwBO8EUqCFF0ZpawnEWPkEvi5agHCciagjIxtAH
PdyTozFB2LukBMx0n0vzk9ZF8SUoCRQApEmtXSLCASDLHYAcYlJlDCWt4xGg
RqAKAFQehXa5QiR0D58Ix6vaBt2EFBAAfM91pb7QDwjCbzvkpQXL8RrYQviu
uQcyliTQr08h+oVaBIlyLyJ8J5sifiaNw466dESE0WyfffBqa0vqrT9rs+uT
5XGdBEeoGGN6cKfCtRQX/rv+8cgaBVsoFAOiWOdGz+1xKwRM0RIXS9AeNoc0
ZuYnlBwrJ27BKpGUu2ofidVCmq3HtYuPNfVSMKhSVP/g0G+UB+13YygKea3w
ogxoLePv360+1X5RHS8XZslav+qO0tzIDcrzSea+v5zaVXgy8u/gJXbVvV8p
sBzNFVUKLIqBhbwaWGOsBXp6WBWz9rODJG5bdytpoDTLHp53XSwLSE3gT3fe
FjUmaGNW2uN0e4IdF46J3s9Lmy+wF6YesY/37Y/ez7WVo6zXdZ4Gbz8tHLVK
2R8Lh6fVw8ZxQQcIJeYisFLySsELJUCVQRFoSgSJlaBKHEopBcw5H6VEqXSx
HFAmoAslkGT+sUTI8cxvF1SFX3N7nNfMcVkZyl2tDaao58xTaIRlWNZ7lH8C
2oMuoCTakNrOPWrbh7aIQVVcA2EMhhHIKBbgEPxBJ1rfgAP4DlrBl4EpQsiK
lk21lUNFfuRP0ZY1+gJ/wBu0r8qoKBaYGCgjKAmKeWB88IPAF2BZS7v8Bpbh
D54PfYDmMGEUCs93KAg5N4DwmbW4CZ6D+IcxknsJnuGanMu9aMc/48p3KBmY
LMo/zjyAzhETuKG4xyOhjTr7zhcftJVd/ZE2bgjLYkzGNNp4P8hz+4dCwvPc
UtQEfDY0BW0lIQfFwkrVZjkY5zmbkGxX1ICycHkp30p6R0uPfTf0lItighuc
Vfjp92twOuSlxagIoCpk/7xmi9gixpuFFTW2+NuhLfarznVZwRYXhh4bTzs/
wAwk7/t+50kfYJDpdUWr8W+rfW8yt07Ygv5wOCuuj1DPgzoezU6tLGRQtOPk
sNatozPsifBRuyfsRscIuWJRH6t/wRqvTx7w//vj+2XJQmt2PtxUPsYeG7jX
W7kn3EV+kPKYLSsvc1XoPuuuzEC5qEV+KDMWFkpT1nBw0hipJcZisjMZ0BMw
+wEfr0wOJo8Sv2g3tvQQJhGgRaZDGpAHRKLgKiXHZlIycQEsgGeyilS4vtpA
d8AFAVC4pjwlCDh0oWKXe8KKh3My8V44WpjbyrKBiqM0ffACnKSQM16Vq4vb
wxsCZsAu7gJtw0Ke8ztDAi8gr8EcPMJ6BO+1zRMdAWNFMZhSzcARwwrHYlSg
OjEsipflGHALd8IlXAeegJvhaPQDvgezeFh4D7+gHtEuw8h7jBL0EjhPAekY
U3zm/uGvYq0kVyG6Y5foBk9WpUV5mkRyYO9APVAlFEk3pY3RHJelOZ6SSsOi
yR05ZayaMdeGSjNiuSzoggjQ/rSRBBHJtD0Xd7QvnkYZTXFhc66b2kRjsXNE
Hkqm2KKkzlpLiS1zGfxMmEElYdUMIzPG3Umb/X5wVSgXlUcv8uaO9yvGEuVr
NuaVRyllWOdE1VWrQvbPU1tDuShgyALJl8OSadnBU/t15zr7m6ETPvAdxYpm
JQ2RKcqFI/R7zSfYz9ecXzNZimLk+apJXTRFjqnOdQWiHLNbsKy6NJ1rZ4Sj
3TjaUYEr8AB5q9eFCyJX5DpFFv0WC9MBP7UeBkgjOTTZ5myTU+Bce6z/ITup
6wR/P2BdSVeNFGSJ4P9sa2w6XNAWURdIKpCkwlSgDfOWWY6U1HRiOvCbgpeY
Krg/mIVMHdCK60KGCtoA0odjkVQgDpBDDBCEsuJxLG2DWAwh3uMagTx45Tzt
1IAouA4swKoHLKEFFjQL2kWTUEQ5ZKSU3/SDNkAW32P0YITgWgGZaBUYSnKH
4KqABbQAxHtcEiAUywFNgeML46S2OopLA02B32EXJadkbBkH2gHBnAsrqKIv
6OazAmdhEG08pX1Yjn7BcLRDH2A0nh8whikgbTQfGEVOT85hfNC4FKHKswP+
tME10XbQHGAqrCTInOvDoFg+XEepd7kXnivCAKrAQD1yiljRMttGK7PjAisU
QfrpwXILKSPSIkvEbR2LrS8pxwR1WsWMmarqYgDBerffwXLhgVQd0qKgoP33
0WOCCg6f6go3Zse/NS+w3/cty4rq5E+Fjlod0oIogkhlt0vk49KWaSXJUthC
zFH7jsIjqimQFg4MCpL83dipNSXke64leMfrCrXj56vPd8LYotWT3NPZaJ9w
fQNv5+JSV4zLAMb4L9ani60r0tmYvTV+l31h9E4fw5wxBtyaoIooXJHGvzNi
beLlyVBkjI3p0W6f3Whtaavf0a5YSxDqmJ/Nt8+setj2Vu+MNYmvLH8svjb5
mOZbU+tqG8/6e7sPYZWcGvkDvCFZmXtIQnDJ/FSiB16VHEK7seASYREMwxlK
5CruQErDNcwv5hoRH5yrNV1VBufcIrletGg4hs+KuMBRgfWAEqLIDfrIeVyD
CC6cHXCIVmARfWAV3gFP6idtwy3wGtwBfsAt9wJWlIIe/OPAAJdwgzwCODlY
+HBM+wi7UHbdEp7gd3EPYyC+AfsqpkHEN3ykCA7ip/KU26tqEWOybJTBD+xj
RRSu3XgftA2/8FzgUsYS/lHFYdoA56gOYB4O497QruTkQdPhGcIdtKMSBWg+
Op6x4fraU8xnRbRwHOPMM6Mv3POReT/FH8e2DMEfufez1ZbXtdvG0BbjMoiH
qotrgGncT7K79P6ipuwDMqDsqHbaP3RSfSx3SVI4iM2qv6sOUqZcbEDdsTWO
dHgjgULSwjShNilRmb+N+1r4W6Eqeo1S+P+Q49zVl6wwUf55fEtN/+D/SNrg
7c+qFIsmfz95Ro04Wlxf+HyYKNZbG+1dN1Ou6l5u/UlrXFyd5bDGHCGf3rJ0
tm0PY3ZTONE+E6gn9ly42M9UwCfmCP+frF5nX1x9l31x7E5/f21WMMnmsNoW
p/MihySF7rHGeYtN61PZGCxCCoA7fCBGwrCtTkftTDf/+7N+e3z4wWikzMpm
2dbkFNvQtd6G0qVW9VNJ3kmB0vhKpNeKhQfnkqbIJSxNIF/4z/wAs2BYkV18
jwYeC1Q6MYSVtRroTDFoB4phWgEBoID6oJR3Wq3V9nbogmmJhstqiLReLouv
U2oJxjMURPfkP1VsO1McKOC0oJscq8Sc0CF9UoYw6IbPTHfacJUkryh8UtQa
QJyWO9EE8BegsMMwaCgwC3cPgom3gE1Q9pWyWxV90TZgDVDIpfBNcD52DUul
kuYqIUTXYIfCF1nzX3AcQ6iqqLSjHMF8pn8Ms1KH84TQ0viN6/O7FqdUKw6t
hetwrExP3nM+feU7nrxSp8p9rFKnzhxFXGk19o22YDiVRWBsjsgv2hI/9zW2
2Qn1S2zI+WAobYvGf8KG9VJjLTrqrXBUVOzxL/zVypOyomThlQ7/MZfV/zR4
FAVLxSJsRv+1qyVUM/7X/lVpQQzvhF4KG0Md8f/vB1ejkuRcUok89TP/WrwB
BzmXJAUH/TDMjCuw+SX4W45cQqFUeIQV2NPiHrS8b383eor9snky5iLeF5bn
7o4Gez1MebcX2gpHMmYKqQjzTF9lO6M6ZpcFIkTPqUb6SJ0ddkbPBiyRc0XT
hylkuqcj1jXf6JTDvtUV6TI3b67LCt64Olwa7ZJlyXLb335/5Ixt4bRYUezp
8U+SWcc2th1r3a7UwBdpXBTPXa/rJ5YdnDfOrkWIMoMBJbMHfV95LQAhM0vL
bNpVxjHMTmaVCnawDKvodI7XZhDa4XvOAeiyW0AP/IQuQbvoCPwmr4WSZikv
KLIPvV45N1UVEdkPkuk/18I+UnwIqIGgOBfyUHo97g/yYqVAdb1BKKsbRHAq
VR1eC1BB++gZeBuwJxTVBYHRNmxBP0C9s0SCMuDTiuaVAJjLAjaaUxEQhg9Q
QxhcwofNp4x32CWu9gBxCQCuDaVcBnUI4DNMDD+qlRzCdBM+57aVtZBrwq8M
L+fRFx4TQ0jbDBNu6TyrX0s0STkPjmZqTF+DYli19qRFn2IF9rC8UR8/V0pZ
hEa3S+aLwvLoMDzaUb+5flYMdUjlTPTjvlJeZn8zuLkwETL7FEmBS9H1YL8b
PU54xiH6Jy7Ygf+/9I3Yv3QOB7FH6jD4B+cAscf/GJ60f60OJIUmMsetoxdD
9wc0kYJBaowCw/wgzC8XHPK7kU2RPYp12Dxso93+ut+N6roO2+R0RZgGTNHj
JFeNjkfy+Xa6prHMPhrW2qMutl4LH4m/PRbOta+O3mRfGb7e9Y6cPnCM3hJ2
ROKoxr8Ve3P0TntrzV1OEZVopCxKB+3OzhtSe2b4/tRemnrYr3fe3FMiV+wM
F0WeuDHc7m012/7Fd9va4KIhW2yzqq7s1y13Lag/5v4lyBwd489fP3Bwrpiq
raLAEUgMFAEwjZ6Pg1KpOpm4TCD5D5h4qnPOsUw+7AsUDXgCUCjjPz4Mvgcc
TDxV9sRWUWYMlAPl48GBiqRDt0FRQOngM23AAQBENYOl7DDxVcSbCayCiP7q
g+Bn+PBxjtJA8B9pDO7dNgl5AY7G6EmEIwAdPgAAoUVjjtUqBUcn6CE+rir4
55qIf+d37oIFUCsdJ2PAWDEutAnH8uq2UIKh6OYKpgk0CO1gSijhDUOtdWO4
BAGPUsPwwiE0iZkCzXEcv6MQqYAReGdYuFVMR4ZcdZ/APt3j9sA6XeRW4Bke
qYrOIgIYch6/NsTyHiWL21Tp9yMzV/7pvRes4sA+2TXVeVm74hOudAV/nk/p
v5zcVVBFVqtQSFnTX3WuE1ukUZ9YENniXya3poUlwWb5Rx27gve/DY4DeSkM
nUnqKkd3YbTkLo//ObK2RiDDadUOhI7C5VH+AFvMdjZ5LmoluZvjd8Mb7AsN
81mJDbny02ifC4viqg/21mDWRHmAPOesf16R9kWOuCVssKf8diuwRKxC2mJX
heNgh/j/S0Mfsz8du6lS0AVrKThFc6Lgb9n2Oq0MJwMxogu/xHGljaEaVYp2
W5gN2syULqy1BemCSBUD2Tw7t/1cN/cORJVi74KbjTD5WXWzrL8y1zrSjpo5
8od/+MohfBu5bxShBHZ4ZRLBB3AHuGKCgTEmMRoxeMfQAP8KmQIL+BrAs0K9
wAMTGb0BvURJNJmEXIv2EHC0hw8TfpD+IcOCc5mUcBlGDfoHE5jjOY82tHOd
7+EfAANIVARH1QEAHdfmGMDIigfWCJzAhNduOlZPwbhS27IqgjXB/RBKxQqL
infCGwqtRjkAfBwHAJVOGF0GLR/eVPFSRZTDa9pgKsHNWKkwLMBlnLlfxlI7
zLi+MoRwDe4XvYh2uX/Az3eKY1W5QEhCoXmMJVzMPXKvvJfBxnU4X1lS6AfX
UrphpYSmz1hxWg0+knDyepvR3GJ7yyfGyK7vTV4RYxOK2kLRAPnZ6LnFKmXZ
lpXaXAjPrC10/qI6XqxSlKPS8Q0X3rWVjokTaj7Lox28rKe+ryqUHfhH13iE
ZdsnIzHkiyn/5/gxkTBOcPTtTlvkVS18JLY0rSMUNI/qarUX+pZGwvowLeS7
VNttRxiya7zH+92keiCsIxmG/dnQFfb24B5vH5pIbcxpZVM6XLBC/vf1vqvt
7Ylb7IXqZbXvtrppxkLK+9ZJ1U4KkzFxJ1tL1qeTzh/X2mmupvQm3X6f8AY5
Rj9q7d6XdeUN7EIM97uSW19qsGPD8bY8Wxm5AzVjtDJm4+lRNlaZiu6MnkqP
tSVtkTuSUnKIpJ+n1BZelfxW2bIQMOj2zFvmlCoTqXCv7BWtvTB/8DMqIxZ4
RRDyHTjgfHGTdk6pSDI4QN9gPuPjRLDhQ8VuUag6i7roIXzPq/ykmsN8VmIw
nCOqocbcVgFC+IO5D7bAjAQkGINrwBceDEI1Ed6cz0qnMlSwk61YB8kTYyyL
hyDboQKgS9NQEfIYOmNotMhKF5RUD0qmK3yWi1F1pKEOZV7mHK07Q4PQkjb/
4aiQqsXt4Iih+yrQBNVDNYoOjT4cv7ALW4Wda28yzSoZNLeBakLTsB3syvdY
Ydwm3ec3LE6VnoMZj2yP66oF8+2xpecZMZqvVk6x/9J5bmQPtqBSw5Q1yh/0
nRJZ5HTH18a0vcYWVEGW07EopV6wRTlaCL8dOTayCDXV16cNhcqQ2f+Y2BQZ
Y9KRcH1oVsDG/5w61m52+2tNWl8EbLRGX8j2xk7b6eL3Z2793BZm2Fkc46SH
t5Z6inn6j7pIdmdVF4smvPE/Cad6V1g/fTycEi2Ob05ca1/uvLDQLFI/dm1c
LoEYyvFvxV5qvtzentprr3ReGbWNh8I5PhxZUmgW+CzQLPBVkHLv7BhRuj/c
7s3x3Q3h6sgXScEaZ4czrMUvcU7Y7Z9y1hhKhq3XOfj28oGaxnHPzPucXTrs
vM5d1lOaGb/rLuXxrx2tzYdgjXJtNQWkMc0d9X591zl8biHt+J45Bvr5jPah
NBWgkOnPtEb6I+34DsZBc+A4rZyixTC33PpJ4mbss2p1kUEPUxMUQBCK+EQ4
QiBcQpGjiptm2oI0LqdK4JxPW3QX8gEK2pKPANV2e2UWUiZhiACBrXq+/GPb
GmEZWAJo4Sr/AxpBLNACiRAN5wEzQrQgG2UZgVGkvHD7wAzHDENCP7l3LYzA
FKrXwHuGEuWNoUUhgdSU/QOSU0VIhWzRBr6TJFYZyOL9cI/031kmrx5Sqek0
ivIqdqwm0cXZVqvDzihoeVfJvBALSjKErYO6yFX5nd4cGWlccuYW29NzrLW7
nU5V0++OxiBq60jq7NNhda26KSGVN4TFtiBpqPkw/n4yJ41laSNoTguvwn9r
HrF/7J+0Zx0VfaWsXFgjv5/aFBdVt6SNfuPwRLt9Z3h1jPeS4vFW6LG7/b5Z
r4VS5jkvtCTlyAeoFGT52JjOsvPcFrovjLmSgqn79XCCX3ZFqdPOKS22H0xd
YV+rnpFTRtXmZm12eZiIlMH/t5p32TenrrM3q+eHckEd5cLPmZMGf+vRMuzt
8ZvtDdc6cGJs8sFgX0m10CqcG/xYuMIti7TXTglbYYn4f1U2YjOSbrfwbiq0
i1bb3/mwPT3xuPXW97pmUu9G0I1Rwzi2usUudg1ldskx6gbiCXUnx1By9qLg
AP3Kc3ccgi+2Rb4ApGgTgE8pqJHkaPNIawDIREYzQINAknOMSnbyqtArjkUr
R7PlXCY0kx7NRQXWAbaWNQAsUw6QKCU2yyUAXuczNQEbfeN4PKRcCw6jPa7J
b1p7gBz4HdMdhEAIgFj7VeE6gKQcvRCC0seQ9+rf//3f4yZPxVCzpsJGEgd/
wgcfdinmgA7uQPJrjwhiW9VCeVUQCBvjFDelRVm0AO031WI3PKJtvXRfaRQZ
ChCL9iB+VaFa+JLvMaa0x4dbZmgVec9w0mftbdFSiWqpcB36wKOmXaVDQWsq
ovzzlaZKbTOdfMKHd3yWi9iNB27dbdvSFba4ri/uD4cs2HlBadCbwxIFULLd
i5WGPFQjD474zfBWNyHa7ay0rVjASO3/6BuzXzQPs4ZaaApd9ur8ZTEsQ34K
1ljvcQiRrX+qqB+AUtNY7GgnTe9Q2mpbnRl2hXl2u2uPD3nXOOa7q3dVI0GU
Y0Yt7A/nBfvz/p327SGUB1iC1c+5dlQ6UPBB/vdP+i62d0Y/+oHvprkvQrXg
iz1OkfgtcAUvLQ3ZRW3n2OPz7qmL5NBrJ4bNNjudGcMw+sq9trK82m4K++zj
g4/ZM1NP2GP+6hThv7mBVT7HNnj3ZqWznWxm297KflucLLPzGi+2TjdpNjlZ
8LrQeY5V1T/8w1cOzg13RW5g4oE/cM9TZuKAfUp7YG0w+RBcTFhVE4M3lHtH
ljncAm+whEpcN/ygVRPaBr+0wTl8p0grud6ZaQCF7xC6XBvOggPgKrAurwrf
wxf0E30HpQMLhnaZ1KxbAg76yDXhDIELkKiCG68AFtUdRYEtp3g68UgoBwUg
hEsQocrfyXYThLxWS1AqACbXRPBDFEp/CODgPsCIskE7iGuuxWeAB0+q2rRy
e6s2La98J6tNkVqK/dRaLPcupQbyoE8gGE8xK1kQDffs3+dLo13xclrS5TFi
1PFoeeVxMsRKFaKwWaYIl5NhCqVinhwZObiwslVNA3Zi64ravnC2Zo1nfWzS
0ILIz0bPjZtf/zwsC9pe/svmKbujZSH7S4uIzE77p6H1cUvIt50ApqsHV7rZ
gHow5jo6QR5dhemAikDSGyK8WbilEH27H3N3z4Qf/c2wKcRKpk4Oa+y9iYvs
neq2ciSH1L7ooGZt4wvhZIdxTgqFJlF8yv/KYQEdlAuf5teHr8J5UVMxVnh3
t5ZWlAuWED9gUXQlHTFXznEugvBHpJEkmu2R5rvs2eH77fOrH2IBxF5a82D8
/PHOezgirqx2+LkXzNhtT48/bgc6Hy4skBabV1lg68pb/W4/Hv83J622rrTJ
9oYHrNO1kL3lB222j8aiMGyzszm2wB9MfbV68PqpudsTIDILcC2g+QNEbGUM
C5YsME4hBmYZM0c74yEC7UXTjlNIAIBCGoAW0NC2AgvkooAUaBuCQEmAHDBc
tKOW7+SKwM0KMdA3DBxApU1aEJMSXHIsBAVwkfIoCujSzG76D2GAEIgJdKDY
ADz0bsIhcWniplC9H4VWaQkGhKAFQBQQC/o4wNTmD4iG81T7BaBCYCBSy0cY
eow3xyDdIQbaB40qRanCprTFdSEL7AGeiZaSMR+4HiSH0gMBcQ7kA2kpQSjH
KJRL904b3AcECLnxG/cAQ/AMISC+4x60e1WODkhKmhS/ad2Vfh4Zc/zqm09G
AdqRNNlsN7E/kW++sI/NXEdhZTEHPow5GbuzBgvmKMd47Kta5sXFTZwKRwey
g64J9TFnZUPcq9JACFJIP6AueLMJ+gKrlKWy3d25alpId2qTSZed7SrBzyd3
O8Yhj7KNljrs3NICOMO+N/gR+07fmUEMwgrpXa7xwBNiEFcxXNU4/wMMMs2H
UfguMvvm5HX2RTdMdoZVThUzkg9pFtOZ48ZwVZ7+4n0XRW6E8Dfzn6+2+dmA
E0bFNpVOLBfWx8LKkE1VNtU44s7F+63Vx6Aj7bKpdIMdXzrNLZxtdlK23RnS
pW3ojWstf/byvYeouj43EoUyVcm5hmaBfxHJDNCZPJpkTFakPWBHBMnnr8rj
AJb3TG5MbtqFcAA+x0MggN2ti5BXJji9Vh8VFVnrH6o6AJkgISEJtAlcDlrn
UJw57crcp22uqx0kTG7txpCjkImvgAX6jDTGEmHNBMBo7UP1UEU0EAQ7RzEl
sEZISwNQIQL6zPXkpgD4fEYLUXYd3B9KpsG4yAygDwBXBKCdrhAG485n2tXW
Du0gQ1Mpqk37WPonxxHjznmQGoQHUWlbuxwOnEvwBn1RkTYIXlnH6Q8mB+BX
gAXHSb3gvrSXQG4insmRlBuo2mBvn00lw9FmV0nhhhLlhLGau1LcE9VSEoMy
iQHLd0yVrY9Sw679YxQQ5HVWab6/Oy8s8LP2hhVRJxgqtdm2xrk52lNXRdrt
4mzQfjZ2XsEKZbvThSibP/wI++lqNyKqlBvi+EqMqsJDATvw/5vNp9oPhs/P
CoIgm++2dPADZPC16nb7/tTlHyCNaR4Lv1/+1kWvxdfGrrSsWCP9ECNUCkYY
LA3YsaWjIxdUir+TYTzuU1+fneC3e60PViP2R/pHmGF//6fs4yNPWWdGTy+x
3eGeGA2+obTV+kvz7IbyXVaJY121xjJ5ug7GDFlkBpBUrH7m7vHW6EZAuuNL
k4edya/QPi14yo0JQGkm96X5NAsbonrNRGPBAmBrIYXvABqTicUNwAzIaQft
gInJRAX8LN4hfSEs2efyAapwIm5SbWxQai4mNVoGbdIeEpUJjsQE9EhRJjck
ACEAXH6XDxKi4DvSfJIng/sGUGTypa4H4ZyQglwXtKuVDRZM/uIv/iKP22iO
2ETAU5qEHa+8ZxjogvaNYMlw+UKJ8CEkYmNZjStQIDhWu+h55TZoi5gxcIxC
o+1jDAXXpTvwghK7wwvwjGI9GG5wTR9oU3wldwlDqdURHi8Kk8rTwhncB5YQ
s+dIeKHObrp0u50/d5O1JPV2YOY50d2/P2yPSv3NjRtTuyNiep2T3PJKN3p9
yArA4bq4rmM15kDICm/irU4J4Pwno+eB8aywHq6M1cNao1v052vOFytUIniP
iazw46Gz7bvNW0NasAjf04mvhuP9L61X7L2pi2sswX+u5gRVKZY5pqkN8kwU
qkLVbvbm1vp3fWl7kRGvbNsaNtn9/Tc6HnMa2BXOsdZSS6ES5H/PcUlJANWi
dNiuCHclThuPuI04O5trxyUnRQ8E/0UHtzZ/0j49+dlIC4uzlbaifLR9NDxh
F/XcYPXOJjOjjlGett+szj736LUHZ4TcqFAWR8UwoeBjhgIvXoE/0EJvYF4w
dzgOWAJv5gmveBeZQyi1wI33wFbKNLRAm8wx5pE2pQI3zTFZ2pLv6CHyOqBP
EGeBnGdeM/eZ7+gA6CBQCFign8qlpZrnKNjgQE57ZKkKAAJptmCCA/rAObTL
UgYeBqWwAwtQC7ShnatQA+l0+Azm0BO4H17xcCDPwSrXox/sUVOycHAIVlUn
Hixqb4Z0N8aaseB7xWDIKFARQu2qRzegP8h16Bzdhn5zHG0rbqOosV7jFyiW
4+iH9EF0AHQCaBhOUuFEnhPjBkfwfHjO9PXwvspKEUvBPpHlHfNsSTrHtlVH
7aXmPZEXKMy1p2UtKrdP3VwFf8JVcmIu3lm2G3LIBXTmAnZ+zOr3w5Fd8IPo
AdfjK+Eo+8nIudBDWtgHOdbZj3JMnvRqalexzbxi/WlT9EzCEfz/Qb+L/r7T
RBPyS+S6Qk4TPxrdbX/uSoRoAtPhmbC5UvRNykPhk8jvpNXtoa22JSyKd4me
0FZqjqUIKUl4d7jO2WO1DadDMbnNo8132ourH4z+hif67g25IlEXE+BcFS6J
vgf+Y1bMyma6edblSsTVWcEe230wW0qtkTlGslW2srLGPj312cgeMMdmJ6Ke
dLbT5mP2yMjT1pZ12snhSlvX4qp2uthW1E86A7ktn1XxZR6cPW6v6RM8fVCH
RQDqtcOT33AjgE5FaDLjmJmKeOIzSFVtI5QLrAR8j7yXL5LdpERcgX7Qzfe0
x6ykHfk5aYd+aFcqyo0Saqk0q8ISFe2k0gawFP1XkWiEO8hG6oI0fQ9rqeaR
/Jf0AUZCceBYfIJoASAWxHEN7YdXOWMUD6Q61wBVuAdgI9AI0rg30Me1tJuU
HaDseYfJ6A9joN2raAa4UmACxh3WxNUC0nGD8JxgU54PY6Tystw7CtT08rb8
pvzO3mcHkPck9ESmgRVR6mAopetTRBbjybirfpXcM8oVrn0q2k3H/cGYh9kb
IvrwGWmdjS122ZyTsMrjciD0QdDRChKJj1xdWxhwwyMGNL27+rJCuS/bs2Fz
dDoA3YI/CmiXbV7W4lr40sgEBYkEsUivt8WeE20mfz9ANLUTw0zblPbFI5PC
7vhu84n2w8Eza8xyVJhhp6YD5eJS3+0/Jzor6MaAX/aaMOoIp4t19tzAaW4t
uU2RdMYsnMRMLUsX2VnhRLslXJ7XKGTP+bXRBXlvuLlIoJfak/377OXJh+z5
kfcTci5OFsTFUShjWbI4hlRtTs6oRrrI4tLFQDJoR9dvsXv7nkjgiNBk54eb
XG1zWyvst8cnn7FV6QYbzJbb3s7PWIOrLGc1XOXU1xSZZvf24xsOEz2hWD1U
e0dYyDeJXRDllGIjtR+cY0AyM1R6B7NUwULMdqX9xGRgpqqSEKaBqiEqU7Xs
W7EDOgLv0U24Bm2CelUNoE8gByRgjsjUUPUxUAcjYPuDXGaxHH4KRkIHUuF2
XkmnB1PAPFpeRJ7DFNgDRRx2bFupH9AzOB/dAd0C+16xXUq1p5AMJchU3lLY
BWYBdegaMBDX1DKCj0vIN5K011aRuAf6ia7E+DIefI+vBibgOSnhiAq1MIb9
/UQssr2kLz4rWA7dBget9rbSNuPHvYH26X4o3usZwRjat8+YaLMgOg2Mc0QF
2evt5PUTtrtpSy2I4O01N8dXdP4Xw9n49mpKxmgy005PF0bF/t3xPSKKabK/
RhRJoQOcGvX/nhq4f+RAd/MiKdQGsH66qzfvJ68p21+O76xxx+NhFQ7PwkdR
hmfcpjk/NnWHayMzE6IxcqXGL2s/GtvtysNsR/GcrFAzLvbDRkO3zUzb0CfY
fg+rTZVX2q1deyJD1BU80ZfNcJ1gW8EG/G2wh6p32AujD9hLEw/a9Z2XRoOl
MWmy1RlpcvZBDba/75OpfXz4U37SkxNP2lNTT9mj449alxtqraHTD3s4Lbii
xTtxZnatPT7xbHRPNLhyc2n5ATu67YSoUSxtXmkL65Za2VWl//6LVw7OFXmh
VHRPVb1iPoAZJa9j4QMdlTnDHAWfcAZ+RsweXAtaavfvE04Md9WKoWodQnXM
VQtdewu4JG5KprdSAXNJpp4WM1HtgRxUgJDV1nm6AnXQNtOc45m6TGPgCpR5
jyoOtBHwKEhs44AyaAPhTjgmKr3WD3iFQjiepDVAHiFKH3jlfKAO5XC8qpYC
I87lGghxrTVowyd9ELUQoEGCKkLJ2aYGrXGv2tqrWu/QJrCHchHwUCBtKWSV
R1TUqI3HKMhNv0HLPF5lCleBFq4FDfN8oAToWJVTtRmV6ymCQ8UnUZRUaAaq
QERw/wVVHJYpmu2q3dusLqnakro5dmFYH0OMCC+i1Dj7JGJU4+S18ZVoxr6k
qXAKlu37E9FJGP+PJb12Zjq/oIiyKCPSB4VNqrEYT473gi5qeJ+VNBQWSTku
wxLXBU8UBk0sjoaj42cTF8RzsGbeCpvyGIo2+/LIWUYDeCUoBdDmdgJY6HeV
ZENpws4Nrh2GPc5mN/v7U2IGXgobPz98n708dqBa8MQ2b3mOa1C5scHfzMZc
42mMKTkrtr1hV13UGcq2I1xlra43rM3OdO1lqU2WjwtSHOZli+2o6lZ7aPjp
6JzozfptY3K23bvscddm2mzP3OtjVovWUrutGFzQeFAy6I9koMUAZhSzgtms
zRNayURYI7hZfWT2gV7S8jPrFMTNbCRektkLSkG+NoQoZIJUeC0tLQlsEvI8
N9JH6AITTpublKBai4JMSiYql+QS8BWX4XhApA1TaLvy0QFgwIv8R15ju+Mb
YCLTbeQwgPfjQh6b2FWLbJA/gbaKCIPYNsCCaNAj6BMkBJAUuiT/ACB0ACYc
GKbiaTSBEaOgDIwUeEgBGfAEl1YRU7lpOAe8oY6wNsttK1AWToNHCT6Dg+ED
+JbveVW1ALpLm9ySNrfTPtfiCWvNlVvDEKK/3JbULB4Fw8yT5ng+q1ADj+0w
akOd1jHaZvscbXRld6C2EWoqoULRgpq64AZGJIPC7k8Kgfzu1BWRB24MY8jv
9I/QABrFY2HVH6UBoP5amCpowKE+8pGYjga/5hVhkVY/fj6522alTXZXTH3F
JRrs0TBhu8JCWx46Yu4JAiPzJJZlGysP2+nheLsqnF8F/36P5LO6JlwYGYD/
lDp/deoBXuO6LVRQiTu8ri1IgL/VmHJ3KFkYqWBxuto+4mxyQtht7Qm723PX
wzq/yxa3Wk4Ne+3S8IxdENhA3uKve20i3WxLKuN2Z99TkReO9THsctXrExPP
2YJkpa2sHuW/r7LBusWxrPrXX9l3cG44o7YJDGmtiupwBdgHtKxV4BCEM5iB
8AEagPJ9g38ZHswYXlV6nBnMYim8AoCZ3RgigFubQdAYlK4ThABmFHj4BPDC
J8xGhUcyk+mv3BzMSqQp56N5aPMW6GOGY2CQrAblHXOb9nFH4B4AlSAN8OMI
hAxAESSCG2B6uJI0EZADgoQ20OOvef2DtBau7YpEyMutd8dT4CyaUm4qdHSG
lG4qkTGXxxdabPSu7Y9RljyUEe258+FLYAGnV+6eQ3hqjL5SlkG7PAlYmWZw
ozIKigCleZ4IXaFZzqNpRaDjcmVkGAlGDX2AGcLTENuLRtGpjpAbHrvjEju+
eX1MQnFaWB354YllF8ayweKGN6vnx6AjMnO6RZ9+iBsaY+aYY9JCtRc3ECS9
szQ/WgMJ7kfvwfysmcjND+TE/PHgdttVmW9jaVehErTFtY8Lw3ybEUs0V2pZ
cZvcyB90E2SzqyznufL/sbDLHgk3us2wxNakI/bS6H57dvCenBTSmJpqbbY6
wl/+hZdXH3AVYV/8lBTfzfcmj082REpI4t+yA32X3/AcJ40679qxdkm4L+78
eNz/Espwmpv5uauBv6kfy/bQhZCDf3KaCC223ttodbVkKFllNzZ9KhLEnvBQ
VBhuXHTAj3okKg03DN5jVX+dkfZaT0tn00EJoj4ShHZjoXZqtxarECgQeUoC
p4YwK04HyAHwy0eICEPdhCRYwcBTAFBVa1DHMa0AMW0wzSAF2kIR4XssE6Y3
05UQwHzfyKLoVeB3hWsxhXkvEgNlKC3AhPdMdaxipjhqN2JPKxUQBjBBfccv
yEImBAHYlSUOE4Hj2Fmuelzy+kv9dhGfRNdAc1RQIAC5FbUHA8DTlE6HU4oE
GCSdX78+jMfhhWeVhljljEGmsp4r9lrrslyHa6BoKSUut69FSFDOraHE0D4M
QV8YFhJ38Y/+MFQ4QdAGZEjyGaQzDNophhtTgRX0Q3HiSqSltDU8tiNiiLro
mlzQ3h+r38xxyVYX91b2uYRssAfCCcm0EOZT6odtMp1ZW+3EkhhMycYyHBSa
AD3cXl4VrYNyIf+dHOyMhnm2Ke0toh+aY+r9Pa1LLPPxJyvE7LQl0kBWhFb1
O1YG09kunFfGHJc3dO/0v04GZPMLl0X34oFwfTQPXh0/YE/13VkuaOE61xMa
HW77ww1+MBTQaJ/tv9tenbjfHq3e6sxzprW5rGbV4vRwYoxSwim4PjnNVY5H
vYs5DRR6QiSApKCBC/ySjUmrTWRQJDSQ2TXNz9rlQ7dZuVRnq1MnQ+eBUO9k
OGxbmnd4k5+OqsKKpglbmKywpfUjcb3ze19+OBycCrbUio/xbKEDbAVthwCu
TH+VMERvgCqwVpFGzEfmG3BVJivOQ9+QVqvkdswxBdUokpB9WlDA9G1fSmhB
m8BOW0EUycecpi2cevwOrTA/0WegIbn7yf4CHpjPwF3CFn0BqIM5Fjb5nX4x
/2lT+w8eeYTHQdqJSq2aDsYI72k/6gfYHcdENUOw4SftH8VG4XAgjM9Pjg5t
9AS23LZye6IfACv0Bc6jW4o9wmBAVeMYBabyCBhmWFEKAUPNIwKiPD4YXXFQ
3O5//ud/xmERFSj8Q8kqoBSUBdQ17knb0VQ2RcYNffBjfYj8YfjUKooJxUk1
++B0UF9UQUZhOK7zKMfegN3WcHWUm2kpjblmKZCzxFWsU8JSu7l7E96BckEF
V/ZN+NzvLnSE962I6eEM94cV/unKuLML6b+83BHjrIfStsQ606Y8vipfZZyb
9sZLrqustPPDSX7WWY7nq2JqmOtj7DXFSE+z18b32xPNt1QiM1RtZjYjLjjA
Cvx/rLrXXpu83z7VSeBCTg+cujOcEYkh9yL4PGq+3R4fvdmldCVSQVfS5/C/
oD4yQd90hSBaC42l1pq1cGX1Wds/8oI9Mvmi3Tn4vJ3sl23PZtpJYb/NrSy3
icpm2x6uswWlUbu28umoFKAMXFre71zbYK2lDutub3dKPBgVzIpUAJwQW8o4
rSBmYKqof+aIgn2BMfOPuUk+SuYcmgASG0OU98Wu0NgWc9YpoZg3t8S5h5hB
u0C0QUEKaUJ00q5CqvgNOgHqytcpcaScWMq8phhJ5jV4454UIwjEoQM0Be6T
tQMV+UDMglNty1SYFOeCa2WJo89QDJTB+SrBx/WUWEo5KLQOgRbCObShKsHg
C2eCCnRpVZNz1GcVb4S+UD0YW+hYPheeC7iUJifK1jhA71A2eSL0G74V/sFR
ygXENVTVgO+0C5x7UDkjxka7RxirYs2qxmc8B7juMGpBfZHNDrUgS1Kfyq32
sd68fg1F8maVeu2Cyhl2XDjKgTs/grVaFJ3wllGem/xve5pXxGmPnzpiIfJK
EeSDiK8W7/30BFnvhyLtjw9TbhDU2bF1YzDFWZl9PHzMf9sU1rj5PmBfmLrP
Plm9sRxZoOwQPSraC9gITzQ71Nfs92+hgtRJitzZfQXo87+fbL4tVtv4ZDO5
TvPvNobJeCMQQbmgAxYpiW1AM6jESuQd1p+4Dfjw8Gf9lMcnnrEnpp7hlQSX
w5/JIk9UaxqDjIWb5z9pj0x93vYNf74wGlK/lUutNe1xzQObdWd4KTREnmgK
7XZu+daoLvRlbqI3nWyrw2a31NqtmtTbr7/11MEp4rFIEaoUplAbJL5SaKsY
B9Bn+mhJEqVfoU4qqMFU5T0ijc9otMCd4AaOZepqaRKqYarJS8EUhXqUBgbq
gBqAhCIk0Vi1Y1IbwugPmgW/A1faBV6IaDQDpjpwxrTnMzDhd6CrFLEci2jU
OoM2ewJpKAVPg+oIQgXACu2Bc4HZ9GqfuAm0IVW7ynmFcjgHiNFHYKuEDByv
lNb0iXboM9fmlShN1kqgFcaPsYUmeMWry/Oj74oQ1T4U6EOV02ib56f7pM9Q
HePCs4dmGT9ojzHgPlAZCOzgfqUu5JYPCb7K8XlzbWgM7eswFNFQWA67Tt8U
VYNFjp6XJx+MFNGXdduFLWcgUGV9b3CALaj0R9Blbh/vgBBchT6ucdIuDxT9
4m/Z7gpXRCCfGbZYb9ppzw/i2gPo6TT873N45pxQiWkX9thz/bfbi0N35YdW
ov1ym2OMpvj/4vA99kz/HVlBC2SJuzHmb7i50AgqaAeuJRyI2sK94ZqYqPb2
cHUab6A+3kBv1uO8VXa2WeGducQuCZ/yW/msNSRN+BR9NGCAit3b/xQkYafN
Pjsev7ayHfugXIAfj0FnNsfv8VM18F/b94otbF3hQHeVp9RobckMy6K2NccS
P6ct67If/eljLQcF/5pazkqAJwc1Ex8wIdcVTw/ANKGZFMpvj/MK9yC/q8gW
gEeeQx54D5gk2ryFjFeMARNe5gntoRNwTeWqQr7hjZDXgH4pblMOcK6voiFy
Afr5uZtvMM5rTmN+4khgOYBXktkiphGbiGz4QIE6zH/wyPeoFPji+E7VBfFU
Ijq1MxGcKJUTohZ84iSBm5RZwvkk5AXDJqJXgKHUfi2lidKyBpgHbxTzoq8K
cEKFYIi5VTAHR8J9iHV+V3pzrC2FdcCtDB39UgYJpcMD/yrQDjegBtIPVAK4
UaHXKn5O+ww5n3kMSpzLZzjkMNhvLLDf09Zp7IqitN3LEw/aDtfFWaF7dvCe
6dgHow/N+RjWeSGEs7iYN8MPfXX1ffaJ6s0CJjFDN5Z32utj9xawzyF+rxv7
Lw25EOi8JdcGyrY0mWcb03EOsserN9qbzgpZwRQjySJbl43GRpOiab+KvTG1
n9fad0uS+bYhnSgYgL8N9NJeWXPABlx935YcG9cWAX7q15ybLnUiuADgQ2Ko
AaMhDz3MZX+O/1OckFrcWuhyTlwbyPfQYeeFR3NXAW6D0/2nuXaOU4ej367v
f8XuG3/dBsqrbFllq4/Nq3ZB9TWrT1vcMOi1vvKgLaqutof2XupnH7rusNIg
AFAkNTNI2YeYLQoMwhBAgoAKXqfXEKUNFelAeWVmYGQUmasTpmLINx/CDVyC
yaoKOYCFU5TvEuBg9yq/e4HrWqJELs8EhGuwLQAsE13Ff9Bllb8NcGsys96I
+4zvAC9dZdIDOADPMYAOYCrTtH5TMUNeVQYcECvWh/6o7/CWCioqjYMUB8Ci
OCmuA5i4N+6T4VN0JIoF/SWuCMWBY1HEAKpiknlECH3tUVOJVZV11cKCMkEV
LpfczdEcL83PCm+mq/Air3RXCba1rS4v/kdt1nLNc8Nrkevl8PhviYWHy24s
L0kWxrCc54bvj6UtL3I7veCAuE6Hi/6obFWEln8vDmj3+e1S314Yutue7Lwt
jaAkS/xyW5UuicB+c/K+rFDzF5b6bUtpEvTbk8032asjd3u34ILUbgrnR2ff
Q+Eatp758VXXBu60Z/pui83w/8awMx7zQLguZIUP8Zn+O6NqgIpwveOa3w+E
6yvFeuMV4VwbDyPW6uZPNVDscHGE/4WutdcV+C9kf0R+Vvw9z++5J+v35jr9
+FsSP+A1WMmHBYMAFkgKLhhJj7NZ2RLH/Ofs5sFX7Z7R1yInLCkfa/PLE5EL
rut/3WY3LrQ12UfspL5LXL2abydMrg1tB+WCusgFCGKV7gNouPLBfsQwNfda
I2bk6ccHoKwtKJv4rnD5KTctQkPZF3xe+i04iYQTooAC93zP8Qo6ktGgwB5o
SO48hJ44Qxu+mcBgk71HXBM+UE0P7QnUYj4YALfsfdQyI5OdFYJieTBei+MV
Nwg3cCzHIRjBoLAHljle/jMUYGVX43f6qGVZlHR0Fc6FQ+izMulPr95XrHLk
5TRm11wRDCNPRHoCNgW3T/PTKiZHCkB1UhVmhWhCEwwLzXObSvfHUGoPub9P
4B+3JhkBIM8EUMlyJatRVl3tguF0MSAUcQThB00FFTy098Ko6i5KBuMmgM1N
R8ugrlHBLa7by2OPEf7C8L7c/i5H+5tqEQDxs3132OcG7yqEdMXucwmKMo6a
D5BfHr7bPt18c1LIeuH64UDqYPiggoUQeUL/e9IOHIhpYR342fbGmn01aiC7
43lhW6UgoMKdGH2Eu8LpeR+bbW+4PPZzZtoXVfT6UrMtdOVhg/erNZ1hW/z3
2/ufs0cnXrCHxp63GzufiXuuP6wlJAVLXB4etPnZMjdG2mxNcmE5skTVZmQD
dnRybnQrLisfY3Ndj7ll8Ut2x/BrNWthON3iZLQqssO+yTdcOzjaFpXX2dXL
HrIm16oW9S7Ed3NwglhaIwhmNvOBKcisVq4W5gUqJdNLO3ZBpRb/QQFMwToi
bgM83rRBe0hFRA3noIzALvI8MhchIS0GAAcFG4Bwhb4U1V4SoBu6ojKgr9nL
CPi4JOQFQGmOtQgEtrJDINwJCqaML4DmHDRy14hTmC/kS3TIc1AhPUOKslKd
yLnBpegxgMVuAowAE+RArdhLgBh9gRHlGLgGeQ/foAuowihKOfoG1+WWGGmO
1T4quE1IlR+SYzSqqtbKXSQx8qE/hldgHOFYQB/SfmlIRhUztN+ca2jvtlKz
aE8U98NT4RhIintWPBbt8Sh4ygU7HIIcmgtyGFm4wHrCnBiOt6vzjLgbSHE8
IoeBbJad7Oq2HPavjO0XOVSm+QXQ4l8Z3VcjB/yFJyXralB+2iX+84N3iByA
8IVuakALSWE4FHZEJIZzwmbrS7pqtsZro/dEdjg1bMAhma811ke34pm9m2xW
0m0Dpdl+Ay3ROp+TDruCv9O2h/1+sYvC56IrcY91JH3YCP4J+GcfpoX862ps
5mzvhfOBrQjrreKsMpy5KRie88ahgzLv41pjX7bAxupPR0nwZnMaWJ25QpEt
tUs6XrQ7Rt60Vd6V3myh3Tr6Wbc/Om1u00L72+8+3X5QGmip2QySNExkLdsD
cWCrRApMniIUIFcceyMDYDqgAwBBZLZqZqEDMLc4nbmGTsFx6BkgXoUa9B7m
AWt0Bd3DYZzERawFtY04Cs3H9gc+KlSLn5Ipy3ul1keQIY613ZApq6RyCu/B
fwjMlBUNyAA1xeupYCfnKye8Qy/Pera4lumfnnPnEBJ3zQoE6Ecj0G4ArVTA
ApARzfGey0kT4ZXjuT1uDRQT78BvdAV08zsuTNrSagTtEXAldyeZs51hEnyN
ruRBDEoPBZlwp1J2ALQ2ivI9zx3SY7R8PjhoKCRcH587o6fyPzwwqQ2Q1mHU
hOZiIxQLCs1Zix3feGZcXmtxE2A8HZGnADK4pmEXIUA1T8FrUwciKWBEuE2f
WwnlaMpPV9vfV/3L0R3w+ti9kRAKJAe5DQrTIaIfb8P1YWcN/Z9xVnjFfyPO
8GNhV1Kg/+KwPZagme8U1uaaRMUvh0+u7EbA2oYz7LTy7f4uR3+v6+ZrkzMj
wHPh3/AB9J/SdHnc71zv0O9Px+z08BRAt6v63kht7/Cbzgr3Trxp903l/69e
8YjV+Rg1uCbHWoGQP+X2d1c6YLeOvGIXN79mm8NdfjdddsvKZ6ynPM/m1S+x
5x6+ruOgyO+IyEeE8KSBK5NNKctR4zE7mdjaPMjsQfQIT0B3zpw5CQ5/Z1gm
jpYQQDg4APVISO2CUBwTcOXSHIO1wG98z3vtlsK9pV0/wJJXpCjSFGgyYeka
kxDccRtcB+iilfNZQTYwk7JJqwKdAgbQVWS1K+8j73nFXc5SgRKayVoACNyL
dmPRb11DlTlVM4tzwDpuRigHTsAoA4Del4QbCZ2xO8RGsjKAksDpvDLSeBm1
ukDzoheGAGyTNF+C/qtf/WoRcN1a21gNVXAsbWmXgvLKQh+cq9xu4DkvHY75
UI63zW0J/64ghLwSTxoZl34dBvsthc/gvbc/4ep/g9219GE7LjnbUkdcq8vn
4bAoRuMA/hlZByp3DfyvThyoRfK44S4XQeE1lHhXPMCbk/dFzDe6tbA3XFAu
vANYA6ucrifT5QXUWfs/KVJDh5MRuwpbvCWWIhtLHTY7Xe62+um2yenFQRft
8WVhm0v7Zban+rw9MP6y7Rt5yfGdY/70cG/ENBK/GjFfdnPigC0I41YtNUWe
WNdAElhEerstTDa5AdFua/y88XCPX3tGDBTgOkeHq6zHRf2tK16K2v2prho0
p122Z9EDNpRstBlJv21dN+Uz5mDIHorIBp0omSAYpRTeBiYIVpxKKj6DvoyM
B3ao/zx/HFfaQAcsmRfoBYI2LIHQ5lwURjnvgDXQlccc/YHr8FrkCfS548D3
B8q1EWfMWSiC+a6Uq0CD98qXyvXpP7AFrsASQ5+QQeY15ur06HuOh6Uk1YEb
855XqAMakUOQ95wLlSgwAHNHDkF+U9ydduzQFxXKoT1gjSjn+hyDPOR+FLyg
VUTa5zvwTJs4MvlMO5wHVYBr8I0MVm5qbTyEepDj2gXFd3KGIMM5D9pEPoNN
5dQugoHisfLy5+GcrP/V1SrSQFPa6q1VxUNDu7WA9o6TN1i368WsiU85sgYc
KSNuuzazbO3Q7Sp3Wquby2fG6MB8yZ0w3jlZr50RNge5/93st7Majo8CW6t+
mPurKovt6GxlyBHdYveHK+2crk0xgm5pmO86+ayIYMxyUNyS9Dg3zPffToro
O3vmXtvT/HI1Ss+qC99mOy3cDXzj/xv6XDhPvWy39JNa+38X5Lmvv862hqtd
6va7AtDst7jZLf/POEl8zhrc5D4lPJ6r7Jkf9qA1OabnZEfb8eHNxMH9dqDs
8KetJeu2Vel2m52stMvaX/VH4CD336CA03qvtWOdcipOFO317W70Htq9BxSl
GeLu5zPQ9imQgE0fF+UiFAIRVtKV+aziirznyXOcImBVAoLfmfGgSr4rVHSQ
rU33ygTKTEPAKr1KkQolF0jdUYAx+RFKHAaQ0W8hKsiACQ8A/vVf/zVmM6Me
JUmMACnCUVWtp2caiSuESKxTaoXvwJoiAcAPuNBKuawG7T2gO9NLWapoLl0C
l8hQcEqXVY2OriJLaYf3WCS0oTQKPBCux/fwkwIPaZtrSpVgNMEc5ynwh/dK
MoN8Bq+cA7ewoYr7gsu0g0nFtnU+3/OZ+6NP8DNtce/0i1eejJLPHBrfbcXf
rqYOG3Pj/JPjz1hX1mentl5he/ue9cl7IDrEy/itknkRe7xnVy1usv5Kr+O+
qUwcjjd9ZsNxMbp/U1jjM9/Fr4vQGL0TZuf/y7PzjGSlWQl4diBkRd159G2W
09C9+5JhG012eDN32LYYnZ+DaKH3cH42aZc1v2wHJl+3qzpf8W+BfBoV5o5k
VgR3DvGq3Tn0oj048bJd1fx8pIHpcjwp5PiysNHlL6HBXbbcWWdLeCPuN/xa
9Od/1DpdCT87vOht5j7+abI9Znt529nx3M63bbx7e2Si5lKPy/yLnPWetN7y
AlvZuMWOcVrh/vp7e8OMwyQ8Qs1UMBpzRaH2qn0AwpHVimSR1YsskM+MlWTQ
jUGOvEYfZIUZHYDvcexwHvOF6zB/uC7XQOVFn0DOcC3mEAyDjqiSEXIfot4z
v5mnOKWQ10S/YJ6yHwiZhXxVVMxvfvObmHbk7bffjphTokHtPMZUVqplFYbj
PYt8UARYU7Afc59rcg7jpJxp/AYOoRowrUJOHA9maU+bE8EdbdJPrksb/Kb+
aBEQDuB7VXHhnum3+q8aFYw/7XEu18MkgH+Q16o7Qf8UwKs9T+j3LFzQJ64h
eY7erjVa2qe/SuImhx0yn+eIrsBz4zp8dyS4b7e/f/dZS0uZzXRheLPL4WYX
dJc2usY0/HwMfDnVxVVjqc32rX7O5//HXfLdHP1ho87G+Mfak5kxHcE8/4sm
3Oh6K3KZ/73pELt3whnUYQkd1p+N2dbqXRHVbhX7b7k0xQGGY2z3jCft3jVv
ViLYK9GAltJ8UfXluIB+bd8rWYH3trTbW7o6Ij3X0+vswOqXbf/oSzY3W2GL
sjXWnyzzXtbZrHTSJsI91QjrHr/ZseiFwyzn/4fEOaC2s5vftutH37ZbJt+2
i/vftu5smVPBMpffX3JauM0vP99IVF8ilZl3nvjB3u4Ol4GHDvWHrhEbPHpV
bQZmZAHSGh0Qhe61JUTlTZjOTA+EN8cqF5qqLwBNpoHSDfKe9oECIkX13aAE
1HnUfY5jCgJ92pCOwWf6wfmIV6T5j3/84+hux3slmGPWMh3JU0qgDtKe7+in
pib3obhVPkvccV9FDhQfRZ/8To6KAVDuMGApVVxZ0rXNUDuHoAQgqiKx3C+w
LLITedtOIE7TJBHAswY1Id5FI7SvJMrAOw8AchJwicVnVAW0Fq5Bv+gzzwKP
nGiDvkFDQBy40yYw5xlzvkrL0Lei4G18bhLlxXjlO5zqazGJDJcSQCnNbVH2
/lDwbi+W7v7vv/mCdTS6ap702fK2UQfFmF1dfTo6q4D3omTCFmfrMHYRkkkh
PZGTLFrdtuJ5ZK0gF83YDjd/ht4oRHLmCv+zrh232pnNj+DXKhdO7SXp1tr6
1Q2Db9jtIzoldSRe6pJ6dtEofyvOL6/F1XHALiu5NemuFvA+Plxrc8Oo1ccc
hvU21uCG0vLXErtmGDl9Yd/XgHaEdzn+rbNGqh8400heT2X7aoDeM/h2rrOT
Y/UhZ5oOG8ou8Gd+fHjHr3bZsreso26Oaysn2sae6y0ppfbgbRf2HBTavRHa
QEuaJ9IKVkdCAWVCO4CqwkyAF9CTvi64M42QssAQ13uRfiY3qo+tZT5G2EP+
vOdUBBjCQvvzUN05lt9U2RrhgMDmVX43ZixdRVCBZlbbQRbvcZ2D8l/96lfR
j6bU5AhlFAbQBYJABAyhlXTVRgCJvGobPEgDdUxh3mvnP0KP65KpkOGC8WgL
tMI6/E5/UBhAr7eZ12RZE2UgXaFb6EOQBMEFjDxd5hXgKaCIppDt0u+R1fKf
cTt0k9+5BZ6EEijTJX6H0CAgjkMHkI0PsDmOW1V0sSJ2lcwRQmLoaYfzeCQq
gsejoh2I5NDA7pgG7Hk9A9abLLEmh9+JrqkC6EcnPx9fmx0oyOrrOl+we4Zf
FLAXJlPOAetRnAlEydEHYg44RprtnPB52zfxpl3SjKab69wsOaGXIyivH3wz
urBzXbjiwG9zyNwbUc7/24bfgBzSAujEv29w5HKRrLjUHcOv2e3DeQhMTzZo
k8k5xcJavV8qD5sruzytK7k8Tk93ReMpW+KWfEsyx2/ySwW8U7t88GuAPxJA
Ynun3vYrjPeeZqlDf2nlPLt0/p+UC+18UXq297TbeeeTtq36jl0/8Q3b3Plx
/67T1tTfYEs7NsUEfl9/ZV/oPSjG76iZ5IhFbGJAw6T9x3/8x/iKeNXmWsQr
GjUiGG1dOXsQ2drGxVNHE4cLtJuT97wyuxARgBp1AcsPzY/ZwrWZOfSD/sAh
aItKRUYb8Ab8opS9Su8BgEjQxxI1wGXWkVMHQxwxxQxEFGrlCBkEiBVjDpoA
pWoxQEL8Rh8Rh9rNylhwn8rdATo4j6VzBaYoVTDnquAJ/grArwSIKoEJWrhP
PnMPeNFVFFHbXxC93BOExrmQEYwAEUmdoK8iGJDOeSpDLWuB8x3RyjTAadw2
JAHPyREnXgPgalYGG48TAlG1cMQ371Ws6dAg7yz+AvJlA4ttYXmdm5b1ti6c
G8F9/8jzdmr9NY6JGXaBf8a0xbuF65r3jQ7LreGuiLG7Rl6LZnJS4G9uMuYS
f3OE6+Wdr6NwF1CvWEc2y9alV9f04jtH32TZStFta8M10e+Wgzs/5a7RN+zq
vtdjcyxRNbqkPTd8rhKvVh9F+keHH4sa8qJwtGvNM11jZqfQclsYrndIohYc
E77r381KtkUNHHznmnrF5oWTrep305ausNlht0O2y1anN6UR2U1uq79pM8qL
XTkfte3dX7Ibp75hpzd/w4bC5T4I3Xb24KPWXu63ukqd/fa9F/oOCu6GCG4V
GcGFDsiYrDwtJBEmqD/VJPq42+NCGPIc2a0tc0oRCK7BpkLSkFDMQ1Rwpf8i
L3ledWddLWUF+ERCsFhGu4p40bynXdU1wTpX2hyVawe/TEq6C76RSljacBPc
AQanV0wE53wHjzExUauRbuBUMaZKBwQH0AachPRk4oNjxcFzbXkYwCTSGHxx
He4XnQcenJiYSFiGCBNx+LhFblVbjxh1VXhm9Bk+blHVA2Rsgzk5AbVlQNtj
+J3PygKi+kt0k8/ctrIbKwMz7UvfYRg4TmEB3Crtof8Q5k+fGBYeE33mthh+
jqcPh1HNu4r9d4B7eN6QzajMs2rAs90W7dXdPbfZwoYVtiLbEpLCrsWPdUv/
56MaDOiJJQXce5qjWaygMSzmreH+D4hjQkt5f2J4wOr9Em5sJ4X03lV93fZN
fcEubn49wr0rm5eHqeWaPYrA5Z2vxcWq8eTcXIDX2Vg4z2aGEdcw+lzYsk5e
dW1+1DZ2P2RnzflGXYHmzvJSW55dVEjrXDE/Ibxhc8LxljkbzEiPdjv6RTJO
hB96s+Phv1pL1m9zy5v8Hr4c9fJGN/HXtF5r163+Rq6al22WE0R7Nt/OG3za
iaHRejrbw6yDwrotwho4M1fBJmHWmL08NB4mKa8heKWnRJ4p8UQMvWaX7Iwo
ymhCiy/MJ+m8fC+LG/HMK65yLqdIKuaH5nlRw8zv3AkjrKplEgXailqlfeYZ
MOI7rEwcZ3/9139tP/zhD+NnIEcflLIPMUpVZOAP9PgN0cYrv4EZ4Ih5Qr+m
R54xbzFdYDngTx+IZgcnhArQZ1QNKA58MVTMf/rOb053CW/8KcAAfJWvBbre
E3IthafAIgYwwuWPqo+IhKm4LLcDxIHbdD+/whPpCrcgIx8zAlaiHcFUzgXa
hQq4bXzqaDwMGe9hONV9hfmwE7hlvucYWJhZoPV4wgP4/tConjEtA/DOU7ba
7JYFjqfFtqLhfBd+rT61e6LneVu4PUgZxyv9wJqX3U4ethXlk6WM3zr0ql3f
/2o0gduSWSjltVUkNo0QNcLr/OQoW5gdUyjjZduDNHfM4s3CeHfLPORY7orH
37TqmSiH57vI6UjnWZ1bvXEpLV1iM0u7bEF4xFaGrzsSf2LN2VwbTu8Ay7a5
+l27ePjbdu3Ut+3KsW/Zjv5vpxHk9XZUeNsP7XMI3x/tb5bKZiZrXYFvtp50
syv0X3KeAeCZ9WUn+OXbrau0yrZ1fl62Nv60VmqMNW20TdUnozNycnTp7MNk
1wJMrGajV6s0EK+svDCLeJpYb+i2PEFmHZO/CDqNIEaeKe0vYIPkAYGK59Em
ShuAQUaj00qG81kyn9mOkc0r62u8MoOZWQAfoSZvMMJGCiVRroCa/Jb0T6vJ
gI8ZygxGzyVlBAVK6R8zXlEi0t8BP+0qnR4zGAIBqNwfqODa2lfH+W6jJECV
ElWFHNauPiCb/5bHvTDUvErdUQwPZg5qPCqGKhhIvQC0LJgzBLxiiMt7qRg2
JfDRojo8BDFwW6j4fM/vHKuEItw+vgAeKbcO0PlM2zxCeUo5Fl4uMgnG6YCP
ARkPH9I+Q3gYWd1ThLe89dk7rL2h0/XM5XbD+Fs2ld1r3enK6PwtO6pRa3vD
kKuzO+zKpfdEBfyU8FBaWL54rw9Mve4QWGyj2VlynV3d9xp+sWhFbw77ctdZ
SzSyl7dusLnpWDS+54a11h2WuMCdafXpjKg/x/31pRZXtxfa6vYDtrzsKrcD
Nwaif9sa0l4MZ3+44LRhGoS/ZZePftuOn/GC97HLOhPy3ra4VD3Dv/taYruG
3/Umrpz8nl019Rf8D3z3fVe1l7Tt9Cs2+WlD3vxsF/sVH4LV3rszor0+Ix2x
llK/96xkN16+fc5B8TsW8YuNCBZ5JQqFyUS2GpWCUhg0WARnGFDa866oRG2j
UiAZwkz1rlnxwg7mNx42GNAkkssVHQDcKT5OJTrk2QHrCgDDHkYigJ/33nsv
nge/uG6dEKoS5sbFLyXHY85DQ0CTy+MZnz6f+Z5jwQuX4xXKwKElbGjnGcOk
2FHmLm0xTNBfsQJAciXXKLJa7nxoyV9zmbyo5mWU14BTuSOsfpiIrjEiQJj3
cqbTJUYUVgJqKvKhhBzAVuFwnPPTn/403j5tqCiQaiRzPc7FGinqICdcxMUI
X/OVLosxopHh7v03v0Mfbr9DHgB5dOjOocHbW8SlsodtZmefdaXDtnv2l+yq
oa85rm520C6x8a7rfAbvttZ0yLLQ6LOaFBfkzGtIZ6TWExazaltdFjeHzQiL
/GeHonejp27ApVlzBOaMknOpI9OBVknyILN8QbvOAXacI+M0b+hyGwifsMHw
nGu975EL668cQF3l9Ta7siOK3F0jP7Q9k9+30/p/lBVQHnalvMHVbKzkSoRy
xSX0p6zLLemyS+/UcZf5HS4Lz1YLKTvgFgKdaE8n/WtH9Krwc1fQt8z9E2ss
90XvWGMy29qrQ7Z2dCVjE/oPCtWmCFU4+913341PBWjh4kLMYY7ydDD3mIf+
XYoi6+qGktHLRYxJx5RXnjaQzBQGgVrZUEE4mlVpXHRDl6C5u7c1ghrAcxhE
gPRRDlwEtSr5EjqGYo/w/OUvf8mU8yfq4tafkLLTMSV5j6XHpRQaVoSFJIiR
MFyLEQf7zGhepR1O9x0xEHIGIc9ZzUVPUP1SuIW7pesKKld5QhUkUbofjuMY
0MWSG8tVXAd+K/an1wLF6TII9T6EPF9uf82o5Td8YjwFacY8RC1BAS/6znda
xYdHIS+YQRF7IiIEKt/h54MZEMIsBzLc77zzTp6sqxxlPfKWV0b2MDJ2ZgHT
TWvHfHpW3bZchzvXRrLL3NIbth3z3omyC1UUfbPd5W63G4lH9X7c5/vMcCkL
U2GNlX3eDdRd4x1wsAVK+pEud7UtbCQb5LzwvE/9BeGLjopfx/+L3OCsczk5
1vyWXTjxE9s+9LNyhGVqrW67DpZvjChMCiye1Pdjh+cPgGntu8FwwJqSua6p
/1f/Lhe10/GZlTqsMz3PQfkVGwq/8dc/daO10wayy7KI12ZXxm/1XnS7cF9q
Sxzux3X+1C5a8yM7f/SbzjFHRek81LTbVvVcZKuHV9gv3vlUGDgoYMcjYFHU
VM6NeQiyyD7N7m4MTdVaVcV3ZKQq4eFLYs4oe6IEmQpQ89w5VhGbQJK5KP8U
lhLfczySAF2X37mOSkapzq9yIMiBAhwV9fnb3/42vvoc86F1U9TJmXmuZJJI
JNpHIaRPTDjeM+e9n8Vy8tyISeYv8C6yxtVK2CPx0DG4V8QPlqR2SmCxgktw
yH0xNkhQ7rMQrvFVBX94RbLSHgLacVIsIVfi9ZV3QT7mSDGsTTdGWCruDThy
m+jQChxj2BnCPCEea9NdsQlgDa1wed7TbSWhVOYqhkuZ8RD0+o7bxOjl8bhK
lBNsFkdVboNDo3ZWoRnfsOcMq2TVKDxn14/aqo7tbveuBBJ22ci33Vj8TkTu
nPIpEbXnDf/Ido/+MI0Iytz0vcLasjE7fcn3fcr/JIsALFtHZcpmVi6yE/p/
YRdM/Mwmm3/p13fUOj/MCy9ZYzbgaPkzjrbj+35uF0/9xE7s/7kfkwO4IZ1l
S7JPFhfhb4MdVf0JV7bLJn5gi1sucZG/5I8BtQJSQ5sb7GPWmY1Hv9Ti8FjU
eRuTQVs/83m7ZPJHdsbgT5CtTjYXOkhbbV7TNhvputDm9MxhIWn+QTG6IWIU
5wlziTkDJhBHvLI3Q9qZCrnzvaJ1mRjMXeYZcwnjhxQJhGQo4pmnx/nMdzDC
PFeYBLJLUdk4tdC/tSsIKQ2/M/HgBLDNq7JF0yYYRSYh4xTpLC8OfWAiKwSD
Y8GC8lQVnpd8u3Rn7KaWbegSh/Adtzo9yFKVabkF1G5sONW0Qu8guVECIF1D
UHAc0NR7BbTxmff4eBFhqnwJ3rxb3oZ32icft0U/wFQR8eG/+cCGhbVoGlW+
4RFwDOeAMegPkaglMh4Zw6gd69yrMu4hbrknRZfwKKEgTBSGnD20CipXBIyC
57neEdivcwqU3nr1RxylbGjut6as1zrSFRGhIPOjE9+yUzu/U0MouuiZgxGl
uZyr2Mx0h3Vk62tw273mPRuv/pW02ObyIptbvidK1dXVX9mu8Z/ZmcM/TyJg
U9evn3LteK5/ercAaMVOHfyZXTT5nm3s/IUtD+9aXdLt2u4raYHVFeGrNstV
5uawyqouo0k4l5TqHGh9tqb3K3bq8K/s/MlfVmzn1C+8tbNGf2mnDf/SOhtW
RXd0fVhgixtvT6PyW7H+cGc0nFvTxTav7gLraum1R++4bMFhatGqoGzcDshK
zTHxcUC3WIsqS6ZAKxACopCOfOaxFWmLoyqkuAPFAjOtkUQy9UAqtIxkRnpq
P4La1gZlFURFitKOkpYiOphSwAOEYmfJ5YEUZ6oqCSrswRTCXcxxTFsVplYM
s9wyRXEph4D/6hqx4hnoRyFtazmYeWU6c02mu7ZOasemXvmeV6QoEFU0DJoL
94/yTqyo3DqMmfZGQAv0S1Qhd5IKTSmQKw/8IovTQNSGgfz/T9qdQFt6lXXC
f+85595b063p1nQrlcpQVCpJJRUyVzEkIRBICJCQEAYRCEMAmQeZZwgyKwqI
Cooz2g5t09C2fv1hi7oaR2itDxtsaUQaKLR1qd3atdru/T2/fc7/5qKQoqHW
unXOeYf97nfv//8Z9vA8HEf0UkdtoqyMksWfzbA61ahfXEfcOG48Oenx9HVm
3rPmw+gjsZFY+aT63TN0/2x/hdmgRz/kQW3z4krbUCydK0G0qdTNacOt7bL5
d/eRm9PWXd32zt8yMz/neYrtKZf/VmfsnskNxd6HDuHk/Zb/oLTilGBou740
4oHJe6ZKdKE9YOWT7YnHfrddtfzJdvrwtrZhdBa/dGoAb2mPPPy77YGH3ttp
ubV05MbJPcrZ3Fq1WlclXVG8fEFbHn6+rQyfLQv8v9Y1by9uLrfTRm8cpgp0
S51/atswOVj3LJZ1e13Z6M9uG4YHlbVrCnjStpRtPl+Kdlx8N49kOOvs0/dr
iRK0X4+a9+vUxDH9RkSagktkDFotPiQxi0dwmeTD+gmvzMg6B2tJGgAz+sy5
pAKEKzj2PTOoSVzKBMO/rFpQRgKvJp5xtgjCcDQv9ZMpx6xkyD4mGhOnPJ9W
9115ZA0rQF3EShv1tCvzqxEWMx0qCeLIr+HBncuuV1fYzLBokrjDsjqxROKd
epeoS7+z+4OXqp3g2VCAaSjDvkkWmwWU3psMSoYDdcj6a7/x13fWAhXpt/6h
+nicSVdJHnlWlpwlbrS24w1nOjhL1ZTpncgJ76geZvkMU2Shq2mstXtG9MHd
c/PMGTfL52qPuvG6tjhvt8KOtm7uYKF1a6ma9W3T/BltU3Fr9+SmMhPfN+Pm
pLuLuLlj4Wg7beH28cywvWLxk+32y3+nXbv7Y0WOfd0tne+c3NK+/dLfaxfv
fXHbXMp5ZXh+2zbc0DYOl5UCPK0tdCU4FHHWt/Ho9Prc0Haue067+tzfaLce
+7SVi4f/M2/4v1b9dpU8WD9/qLznG9rB+s713FV+5oayeEd146bxfYudby8V
+cl2w+H/1G657FPt2gt+ou3afGUfUhoXE30ePnioffA9Lzn3FFuMuZUIotON
wiSUXlKNOQekOhpxgZIvkoQh1Smjnmr8ltXEHPoxKw70F27BamL7K4puMBiY
KH44BrPRl3GLcF61YE3/w7cy6EamGj1G/ifKKO6plvzq5gvJf3oy84YJ1J3o
orirPvQkPrKS6RW/PQsvs/LCczMaM/MC+ztoClMl7AX1zhxqTNnwkb5Ujilg
07zqhBe4zMaQFLp016jnRL2gPyY5o716hnZ9elW3ZxAp16AfSqNovnt9VHQM
3bL1MVuispaa2szikljIzut1r2GQP5l30dV1yvecu6fi2bNNC8ZyX/bMx5Yx
u6EouNzO3vTyds8931VwflaHbedHmb19fqQcO8YjhbNutLstzp0+j1DCim84
UrdvK0PxPDpqVPxaqTuxKqO3c720TW3r4vPbjg1vbpuGnyu196Gq17bhr6iv
4T+2dfPndXW4Z/hE515n4bC9GPmZds0FP92W1h3uo8CTYaVtHt3cztv+vnb/
cz7RSXfG8LlS7r9VFbqpV2VcgmbD5EDbtW1Pe++bnulNzz9FAhEDsYnvizUJ
+zLb0V2S4NOf/vRwbR9T0WWJKUVCRhtmE33WlZOouiyaE9J1IyhBF9Y471gW
+9JUhlk/9alPtePHj7fPf/7zfY4EnDAP5LAriZWxU7nZSazeWJNUp5ia5f1J
t4l5mOJ5mIOZn/nMZ/qMA+TTCOpD6GQ8lW+tLVzb/U7zCBuzvG91c182AGcj
X4zJ+j7z+87p92Qzr9dXPQIKaX3PWqFsMGQAO5/lhzGqEzcpofo0e6IVYphr
KXryE9kp3iyljLvP9dadd8+YgzPGvP5F31443VroL2Ny8aXtxsP/pnD4umLH
ctHg8e2Ks/51O3f557s5x6wbDzuLSae17etf0bave72MAEJlzw83Fx02F6Hu
087d90vt4J6P1OWfMfT6N8NSGXY/V3ppV1uavAw/2j33f6k94OLPt4ce+y/t
qsNfaAeXT/Tj64dXdN7uHFOV1NX2Ov7eOv7wKvpAOXlL9bejWHVLWxieUbW5
sri5r895Lo4O1nMeUIySRWjUmUVNnX+PA2LgXHgKtlhSlugwmleTsv90AYtp
ypZLVgO/Q+HaZeeE5Uc+8pG+vhyi3CfulOMJCKeLschvDLDCKLaQ43QNncO/
AUFMVN5f/uVf9mvjm2UfZ6JoYzddkrTWPjEpyWwTtBJjCeEC7XQ0Y1evOoJC
DaIw2RAUcbweBrjda9vDo0peLSMbiMQEnDGin6/PkZPDns5RpHC7GgFs0nUB
OzVjfAiwWXhudy7empU51AuDIFuGEuOu3mY6VjTpHKHoZk7gCFmKymZo7XFM
4D6U0TZ8NEsJ2JHfwJK8Wc7X4fhbh+F9H/3ImpTe46F99DnD8Nb3rtlVc0Z7
y8uf2F709Ee2w/c4v+uKAztuadvWXVLI3llo/v526cp/abce/Qxt0F2jcXFt
0+Q72tnbPtMedOmftRuu+Fw7vPLlKSNGjy8U7y5n79241O5z+Ivtwcc+3669
+AvtwPJf1rHPt3WTe7X50bn1/bcF1Sz9s6GtbPz1dvae17bd2x5UXN7dddVo
ONAW5q5uyxte2c7Z86Eq6xOjduOxPyvVdtHZP9y2bqxiJlv6qoWpiptrWzZv
MF1v3dJwz1MwiDWddCUQGusKYsv6qqph0Hj48J3DcOeHP91/Lc6OfXp6cPqr
/7+wuoiOVW8uiUdQlswIvcoqZoRZImP/CeQWEWdjdCurU1zIwBGhmlgcWWOC
MIwqJAS57MxCOo/LmjdlIDDiMjA5PKZL5IseMcWGh65GqExEywRxSDIa5WSS
O+kp1d01VC8QEiKuZ0ElNLzXDTXQIdMMhIX6RxfFWnO9ejN0CRMDP9Qo0nvn
DORwSj1HvQgcNFSG5/7+7/9+P6c9sksuhrF6ZGCH7sJ+x+kav5kZVGsiebHi
svkl00Ge8w1lnhgPX/ngzatkW7eGbC+orr5rneym9ms/V6r1Bd9WYv7wbAxi
XJ9Lbb4U2obJxe2Mnbe1zesvqWM7GWmjzo99nV8PvvJz7d6Hf62tX7igtMvR
Ov27nWObyu5aHN5cDs+d7Zx9r23bl+5TWme5/s4oru7pmmzqbW1pk/ElpYGe
UJrolfX74fX7wjq/o1uaC6NymIajdd/6aVKbcdu4fkM7esmh9iPveN5w+Sn4
ZBQRqDQoD0anJyuZXYDjGXc+/oHbV/m0fg2fbv/Ax/uvUf//1t651pPRKAm6
kLVmgMhrMMJA3iIUI8Ucm2sy/k/zCczA+4mxk13YPA7yGmiVCSAAR7UoI0FH
M29Bu1If3geJeDDsM0Qz+me0Iet21AVRESEpYjKHDXyen01v2QWuPtm8xjbk
ShAGQEgPuZ7xpI1pUl4VVYa0VFwWlmcHvPKAeBodifl3dn9uNqwREuZLvE/S
SWZXPK8tGX89l/enHTJSERIjd9LgIjjvMiNCCOkdeHPaMhMd30iCt+LOH945
vGCmqO5SaDcPv/qHH1mzlm2pvfI5j243X3+s7Vze1RYnKwXe8vZHO7sSMr43
dO2wsb6fUX8X1N/Oqb6oe6fnZHA9WPcdK8XzoHLFHts2rnthW9rw1tIoe+r4
zjo/qc/T2vyYGC3qGClZ/+S2bfO92tLGfZ1cp+890FZ2nd42L21sD7rm0r77
6tgpGJNkBVkIAj1rdlPNmFDs+PgHhttn2mZj///q0kq3Dx/4eGdR/yOO2XGM
IOPC1AV0s8P8xiRMIcoxyic1w4rxfKzFgj/6oz/qY2J6j60HMdSWY9QP8Zg4
R9QDGxICEwAUmjAFarDfOyY+XwKHOgdxkIgZbFgWV1iOBZCVGAhJeMZmtHF0
1GOB7+11gSqWmrF2qPZMznlW0mELliSMW2YHeXAJeYihUTGJrZRsyYXs6VTB
/t492bCCENmZmklz1UvidMLAo7w2x9CrJpSC5iKwCBwOKEtQM3tNgsc55p5X
+8bIstbSG03tvaF94YPDr94xrPn3nOH4Fz4y+hqG4Gkz58qofeG26yd/V5V6
XNm1UlygQLbW34bixI6O+z07jratm89rG9adXlbYLgpn0mm1vk0mi+2ehy9p
B/af05a37a7LltvznnJTHweg/qr2w9WnoEbCvhFGWcyR3N4l3FapsdY4mx5b
nBpn+Xf77cPt0y/oMrvmwWsNuP6HDujDt6BcUMQUC9oQaIG/86ajTARTLJRF
QlL+8R//8WpIEGU5rx/dyxexeJugzGwp4eu6WE4onDEmEEw4HJTy3qCamAfu
Z92w8IiMLBRPplLUzCKrDGXPtjF0PFJejF4YzYYsosiYVkKh9M1NlmNe1KGO
YcnCrFg6JkNkqugVMTbZlbPuBsyxWHd6jD3jWVeeDVPoEn2qy7OJRNWM6GsO
r6QMzYI2iWRGV6INiYG9Sc5KF53CeFsMGb7w3uF9Q1cuM/4s3sWfO+4cvvKF
Kbcopfd98IPDaK2SmvJqyPyrsqG8/srq9/+4b6NoszKu/7rIX1pFftZ6R/1q
YqYCMwR+P/3pDw93fhWiF6dKwvvOFMX09/Saqel1ZHbszuHDM9RDH1RCuCal
EPIbcikQNjFTizlmoiTj3MwLXc4Dh3wDAe7BHN2inM9+9rOdMcyGDAZ4N10T
AUvwZvkSUwID+BNJldXDBdSLl5QCdEJAMVCVMXMo9BndBC0EqqbMCinf3Ztl
yY4lkhh0Z75oFpNo6OmKp6mmLljtB/XDVu+iAIqOso7/lrC7mOUzQQexiXaI
mZglVh7qOqxNxgDPUlkvFIWZWAZoFPNQ+6gLBUqR6avZ+sRvBPFrkPvVaJ6y
YOFrMOMlp0CulmACJL1w8icweAmDu1DZEbiKXA7BcBcqvwZyj61FfEcu1GUK
HCK1EGeACeMTOhmfxoXIa+h1DSQycQx1kd3OWejDm+S0Y8Sf//mf9/sMAqu7
ntXCPMskomNaQDEhlDBoej3hEMn4BKGNt8uk8izXaB/H9arnlvwXDfgd7ygj
XZmZ9kmCuWwwgIwksUv89sSkdjzribNkOWYQeyWDWFlY5b3QJOvP/Wasz0am
Rm4aNq8yI/sIE+WBlca69NqAn5UFGLa6CG9Tx2WCVGV1MtlGxCetk5ZgQH4L
2GXOTCX1N4Vd7UVqeRGSNhMQ2kmN7xa7t39g+PjXxe7iP8Mu5upz64tH5Ga5
JnCWUKGUF+zBqVEQJrbGhnc2xZe//OWOUVL5E5/4RPvCF77Q7RGdYcJCX+qE
TDjAJlshIbVhKaEEq/VnIbOnkxikN3yyC3AFHnRqNp/FwVZ2kvWtDWVGRAeP
yZMW2w12mepsFqByHIZJw+xsyowDrZDQ7uoKIeqfHZ6zqcGuiZKJ3TXpQ1KU
MZEIM9oB/qGMbMjUO1vIM333nrCvb/QFFRPuFmZGfhQIUYrtour+4J6S/EZt
ja8reafHvhn06t3kp6dH9XAyz6r910Pv1FK+O8n7in+GXpISpw1NJN5l9LVe
IFVNnbGEnSdJ2Qm8Gr0K2X/913/d/v7v/75/QjA0czIhPBtn9RTRkqA43se7
eccszqJdksKOaGJ+uj+LRbIWGRv0eBalOe6+tZt6XAcxyZ6d4R8Slt6ONwfB
JGq2cWWcE8LVA4qVTUwqx7Mgl4TBFBoGwjArC7O0G0mTqFwJVeL9lZvAPKDm
nizYyfgs9GozkpxGydpS97AVyF3PcC4BCbGVLaEu38C+hq8P37tM5Yx1Tq/p
LuldEP+G4Ly4upsuS2kzWztd/2aD1eSfwnkVzZ/++DAVx9OBxKldsRbNF/0z
NJu6gky9Aq0W6kM2eadlfIecyFpo5gdCsUFFkV//6q/+qv3d3/1dl8Ms3v/x
P/5H8w/q01NZipgcKbHs4q9BaEbPE8YxkVhmW9Tq9W2LWVzNGU0QrZndnW2a
ceX9OoqgMT6hHlcXYxjstCSMJPsSDjNRAaA8aRWS0x3Kk2cOMkkcdh6UQbW2
iiyG0iwJUzcIJRUwTD2gTp20hXf3LpjPnHdPZjA8IxshsrWdjCYZPAtqM3aS
QB8JBPRNOH7jrzdwMjUrvpasPpVc1gOJz+FNtUAWgWn5f+rLzaaSZsfW/uvn
p6eX/5kbR6ExiDUyBQ6EjptqAmjGLmMYkLlqGs+1f/qnf1qAqauG5fYP//AP
7eTJk+2Tn/xkH7A4ceJEjwTle5L/6FhuHkOAWCFeiFl89WqzOJ5VppV7S/1c
khYCi/M6OzvXs50jMYOtmpruVJtfHQjR4erLA5wuX1jf79GMWaoAbNkpPktD
Mts9ds9VEukGaiShKTLyTVwDGPVFDQAZcqt3kqUjDvJTWdSOtmRoGU/1PsCp
LsQruZVE81QJNeE5ATxiehYDQ9lMYO0Yn5ahnqhN//eDfxvWmsOz0b2vD9Lp
UFv2EqtR0kzmu3WZX2uobX7tyPRXgffifza0pqWIStP0kOgYhZ+9dhQ/saH1
GBeQzJTlKqG14TSi1aoCyDOgwJ0jrpWlXPeGATlHpOjZzFdkeZf308tQnbhC
WeE9W5k3TLN4XdhJmmh3WeGGCdlj6B7Pdpw4TzT9zK8QZ0QzkZm9JNldnGQ7
ngEZrs/IuDKgLBsoMp/CPYBO6E+cBMcx2ztPF/lUKw4rvU29p/ppC8/jThLl
WQHLuMl3OEik4hgP3onBkBy/nLaI/FOI2G90IudU8Mw2T4KAhE9ikBnxv+Yk
ydeH5/X/bOIEJLMFSFNpXoITNB0DXcKQkCWICFDa/r//9//ehYJ7ffLUQJ11
oDv8ds6YGYiCe56jq1zDBkwg5SyU1rQJcTfbz9ab3G/wYGvq9qxwTKZZwpRQ
A1dCKUtYEhwatJURGiQBBein/GrTkQoNe3px0JC9zYwBxoOivErpjq4f6A0I
gR5uAXZ6JUhjVCRZre6iWzy6ZN10QnKh9yyV5XZLmkwi92AeZ5555rClR9kR
Gthp2ifBsXzywUh0jZSAHopz/v9i0j5icq04jSH70lNgE01ROv5DIvDO/Jev
mvL+6uUik7vGa6f4XCtlv3om/EA3OukaTi/YgBHDFcQMCICcTy7X5z73uX6O
pAC1xA3VLwYU/uIv/qLbB6Qu181xsNWfJK2BBM/LXCJJ7JlgUnCtOlXvDdeu
pt00UEUSgo9nkbjcIz0EgonKhsYZnKILSV/nSB6wTZ6DxDrPvpbs2mZvKDsh
JLLgF768HxRkrTKswah35WJqF3YMA5tUZNyTuHmHxHv3jtoIjj2HUatraSLv
pi7cTAMKs3BpI4gdNnchauW4z+RKZktT5zxB6DDOYbwBXfz+xlZxtY/euSor
F9bI1F+dqfyXnQKjXjoxsHQIrnsh3omxpyxz+vSHPxC5eJcdepf8XHW6PvDh
T09v2dI1Lc3iT3EGpjhEf/M3f9Ntyb/927/tohI+nYc3mK3vwzTMyObeT8Sr
MrS738o1hJABWiIapg2EwWJxYbqJ+pFdGqNFFnARNYkE7K3BhFDwxgnQ4pMk
1QfJJErpJtwtqQmO8ZpJ10zPU+SgSTl7JvFIAoCu32DjWa5RdfRRH4ZCwuqC
c2hFo/Da0c53dcoiEM9znddm3IAm+IL9LI5I71F4MgJA3NoaIvCM7SG2E5Gp
MJcR14Qtm6VV7p+CPxovo/C9+93j8nu+Lt5e3/HGhPM2CEdo0aV6yXfeNMFE
lGtBhEuwNLqQzqV/CST/KJf/83/+T/uf//N/dhAgNEBRJPQqIQZQnkdPc3bo
dMBjLrpeGX7TuZ6fdXTZ8KOFPRfo9AShB4QEqR70Pq7xnZAkaNybxRXek37/
b//tv/V6JZ5jloRChN6ProACUiEjk5wf9+i9bMDIwt6Me0EFByGhuoxTZZFu
1r3NFOvq+jfvgBnspmyUYu6yNfSyawg9Nk+WJPnuerZOQnhhAPJ5z5iU2hq7
3JcRUv03U/YjlCof2ysDnTWtiKfKfK8CYPG/oFfXWJeRUJleN1E5T6HBvz4K
T+8oVEsihW1B7FBn3izx/ckEeMdVSNTrzmuR5L2lJozl6F3Iokqgi2iDLOqS
WKv76nVKAZd8/uIXv9iRBJUCnUFRF1clG4fTuiaa3dLBlrVtwITOmSDJpyqq
BsB5HOnKd6LtaWnE4hsBp6oBsn8FzJkXfvPqQGmyc2RwFOCSOje5Sok6TcDa
o8WTp5s6y5CRsoAzaVCJz2wiz2od5elt3aBOieWKtJ5NFeptz9RNWeemW4CM
CHQPTQ7E2kcXIRjSKTeBH3Sftss4PGGgW5M8UTuxWol4mj5JnolGotBaBGqb
KLQWAYEIJe/+zYLwzA5C4knv0Ifogy5ZK+Vt0dKbqa3ehgRv5hgxkwh6WscA
pDfndhhwBEw01FroSaTRl8RriamRphq2d5zCLlOdSnVZhnSyV0mjAg8wAmUi
diZXR+msacqJ9b0PQJtw8XYZHo0VWvAv3FXdhlu7r65IuMiEBCEFI96UYHW/
VsgugGSVpH5JAQKPGswO8qj4DJATnNQrD4WwzbBqomp6vQw5ZmFzJgDgT328
YvbhEMAEd6w9dVFXLU8owpj3IuwyZUeoqkeS4sKZsrMrlSCFcSIIrvSuXsrS
Hu9ORSeRuXgZ7qcwmRTftCQ8u4NQ7wLLl770pd51CWOjOVkOupETgPaA6Hz0
pNfVJV5BE7JQGMVEGFEGiKAAhF7PayoDFIgmevcrX/nKqOPieV2tqw4V77JE
qNEqWoTgdA2gerwe0Rs+tbRrqahUM8tQ9A5TAqiV6ZWYDP/4j//Y/tf/+l+d
f5kgzEY/ksFrQi6pSkp5BsnnOeoCSVAJidAGaZGYiQrvGk1DamR/Z0LYQkTc
wsyOQ3B8Iyjnf/Ap/NYlmbbiUykzsQ0YgfycLDDQXskTl61apLTy1QuaGHiY
kdi0pCoGZ7kN6UrKkX5MCu+uPlkvY6w0q56/WRAurxqF1LBey5R0YnKTEYxE
b4gbOANgxBSk4N9stLdki20TN/Vr9DjdoLdJPj0InMDoe5Ly6UlSGAEAkiEJ
hdCTNctR/Vo6wYkZe8oCaj2sh8iUuBPux1GywntBbIxcZXou5DHbvZ+6egaE
a4/kGUA+z1Mn9c9CCe+lPmSf50MVnZ1IAFAImVl2k2UdZFhkUMY6E2fH/Nmo
58Q90tGQmFfKSUw41yYFUeJm6SsshUDvDW3af21AG7IKqyBrtnu/1zOrcbVb
zCvITnZuv9ka4q3zqull1zOSjf2wICGSvfHNovCsjkI1wIPkicNPtfcdlyLq
WAyQo0dZX1DpM7E0WBjQnHGBLNglb7gU0ATV0EtMUqo2AY2Yg8NyNyC5I9FQ
5E5CXENf8sCpLxZAlGdAQVwI15XmqTLrzLC/D0GSjf5oKO/AJYF4/6gAspLc
UNdYjsomP51nRzAE3Jtxj8wXkRVZCIsJEFauSIL+A2EMOp3FaNT5FDhQaYIk
EEpg8kQCBWiiJkk6MuWScArAlW2EmT1HOAAMaV0HcBktTWo7Bh/xxeDzXMZE
9v/Fz1a+pjcYbnEqEAItYnBNGInWoriWCvhmQfiQ1fiTidePqpkuCBgdy7LZ
+MYZJaAYiRWd9L//9//u3oVWBU6AJTIAwW9iS4cCr+9oFv9WuRG5WpBoyipk
Zo0WDpCTRkWLucb1WiuJBonnmDfZUsPOAHwil7uiTsRp/HGi2TFWKZfAd/cT
t+rlvQrcI108LPVHJNmY5lE9TUUqZbLccQCgz2QonwLzylWw6byEq3U/29kr
kXzJOwwsVvTE5c7Yd3I0JzelrlJexipZgEmV7j7fsxPH/YlwBqjqQN+CgNfV
zD4T0SzbzwCP7k0qCYOLrER1n+U5/uZQeEZH4SwvXK9OQuP6jPBOCJRsvUjC
Gz1NpAjgrSf5uEZkiBGoJNagwm9KWG+aNp2tHZvFvX1hFyNZYUwJ6uLMiHim
5sVvbo9rcDWmG2awYKFSnaCUqHKvcj0rTiNWGO6GsEyTE3VEMEOAmIZUSppi
di4iN+jGnKynUwbYZIMbmUe+eX5CwGQ43H0UNmeZoZ+1oNo5qS7do5td4xh4
KTupypXlHIhS+AlBlcCmseTThtpM+2BpQl4l5S9jANS0jb439KJNqTNtmFjE
yvRcijdBpI0rckw4yRQztYcW3zQM79lhmM2YyYSQOU1NkyWL2cSZKMy63T2q
iS00nlcwBkKgEZCawXmvhOm8AaPTIMnOAj02F3jqak6MV8+QcdIbZg43A5bq
OwvaN13furu3bMzByGkKFQoTXhAryDfnHKOYyW8hH5i6esWjPYYpS04WGost
hf/h3NUJHb1EftMDXsE92aKYPcBJhaPJvBp0EG4cFkhIzhg9bCzREA7zC+qS
nD0hxyHWsA/UEYw0acYufWcE9DlDC5fHnbQzj36YxsDZ3gUM4eHReg65vYbX
ieVMXsYrdkwzukb1ZDi55pprpqk3FlZFoWFEgHHJNwvBMQj+HTZPXQsLT9av
Ts+reKSftiTEZ8HB61oq5hH9WoaRts/iG/DT90x8fav/SUyuAH3ot1FCEtTE
B+kDGwmkACv6WBl0Y4KYaigM9x0EGacgCeYklXs8k+8NY9wKOjdlJtMpasAh
SYcSMEQKqD/JR5mhkToxYJWj3nx9uhx90Ebd1F35OiyrgfFBRyahMQmedOyk
mI5GQ9JO+8IXJV0SckTUDed0GCbhqNd2GSGYhWguB1f6GBx1C8WkqTBeM7kv
a3OyuY4ESQwxTUiXEuheW1Wz+CyDw6qKCrM4aNMMNwvdPjRoaBATAr72QOHO
5S3tXped1645dmFh0P/jtm9lx0sKL2swuOnGIszJ888//2RZmCeLZycvv/zy
kyV5TxbC+2c96WRZrycL/86NfBm+62QJ5pNXXHHFycsuu6yfKiF9sshwsip1
sup7sjyok0Xrk0Xvk9X0J0sEnCwRcLKa+WS138kytk+W8urXVTuerJfox6td
ezk+lVPdc/J+97vfyXr1kyUCTlZ792qVwX6ybJqTZSudrL45WaKgl1ee/ckS
OSdLcp4sOJysNjxZ9DhZ7d2vdY1z1Q8nSwydLEXZj6ujOhWMThYc+/Hqj5Ml
zk4W2U6WlD9ZsD5ZfXmyiHqyoHyy+qpfq6zqv5PV3/1+1xesT5bm6OU47hne
QTOXku1tUcq51927lvHf265srN6WJf5OPuxhD+ttoQ3cox1K7PV2KLF78uab
b+5llAI/WRDvzywR3uvod4mRk6WxTpbx0t+5RGs/XuLkZOG7Hyt8nSzM9nYq
MPV38dyy+3r7u147F/b7uxR8Thbe+zG/taHnVfv/w7p1674ahIeKoIScv+F7
+v/jB5p9ddbf/PS6q0pw/dPrLjKAnOtOmxbbf3zHN/d9VqVXVoO8toDhb/ie
/v/4B0p/ncE1XiObt/71X//191en9SveOb3uzeKA/ZMqzYo9sWvXrndW+64t
9hNFnWcQ7WuK9fbt7P177G8d3tn/7+lHvnaxW/6xuuAvy8Y94V9J7hMFuRMl
IU8U7E5UV5woEXKioHfiYx/72IkyQvq5eviJgvMwOlHvNWw9UVA5UdQ6Ufbi
iYJd/yxoniiqnCgtc6LgeaK69ETR5ERB4UTBwp0nSkO7dlrM6b3Y6vET5VKf
KDb3W4vdJ0qQ9mPFnl50oXL1kSUdThRjTxS7TxTCTxS6T5RU6Ncow3UlAfrx
YseJMjFPFKJP1GufEIJ4pORRf5vFE0WJE2Uznigd3Asu8XOimvhEz7DjaF3j
t/MKKxHVv5dPfcIqidGJkm/VVe5VGck8Rv3M5hNFq36PiqRcx5Rx8ODBE+WD
nzjzzDNPnHvuub28c84550TZouN++7p+WQnHE2ecccaJ0047rd9y4MCBE2Wy
qsLI9cOWXmoR60TJU7XutXCpyzzVE8q68Or9uO9nnXXW7A3rIcNSr2XJ5t5M
mrIE6okSEL25NWVVyDM+Vg33gRIu3eaYv8veoAm6RfLOmV3ydcF3dTf4YzbM
UgV3a5czxCpmdjAZqX3OS/KVJFk45ySbfqjj2QhgV/e5lznA5qLKOXBrw38p
I5HUXE9fcmSYkmw6ZhGHhfnpeGZ3/E7U7WwEoqcNojAj6dQ4et6Do8Gos3Bh
liqxTKxLLrlkWOymq/oaSDI75/wsvVNdU5AcsSyG6/sANq8peetoZZ5LvJik
atUomXIxyE2Tu4cdkjn3rJI3DGlEiMPOCDCgbmWFVWqOs0Y56MowYuQlWaau
sVXaNSrNVraz2neN6X5WhM5RV/c5r06mgBi9yvU+vLTkrFNfjaye2e+hs3l0
PN2sO+TCFCg+UzZhMPhNQXBPt3G+8pWvdAgalWEaMbfAI4H2PBGUmE4cMRZw
Bvqzxj9xubRukmmWMBv1NWUL3ZDN6i4GqMuJvr4Md3F1kgRY3anN/J46Goaz
l1cDFmtTAM3+aW2u3RLcGqD0f1KZJsCZNxWCcPv27cN0+eEj2ubNm3s/us7o
oJFAGNDvhqZ5xECevbtZm8FfUmfP19eJMwQn+hWukMFx1+W7eiK9TxNP2UEH
RwjiWa63oAImPB9u1Mkn3Khb0jC7bs+ePf1e59Qrk1fulUZD2cpNPkg49h44
A6PeQV0SgFQ76yZCKFMhjOnkSI8/PFtod7zQ8C1hcLHX2hgOh51JDmPMdSkx
Rgbrhl29Jpm79nReik9AMhajtpnUyNQa7GJK4sZl6N3b8WhK7EwDtl3RRwR5
HTp5tsuhNxaQARDpCiDIm6jgGp/gcB0h5LyORWoeCNAhfPLqookGJiEBzf0A
uXXr1rZx48a2c+fO3knKzDIv4CQRE0kGwNyfaK1ZZJT8DJnl89yq5zTPwLS/
E8qSY6XPFaHK2YXs0Yr22LyKZbeqCl/4oDrkVVICZYcyDua3slVJk+Ir2egV
YNh1mlQzO+fZSUOsXnxyvcyIy4ABmeA7xUNJ8Cs5fJSV6bg6frx69VvTxVv6
axheN9yeUAnELV1JoKmaJsw+ECNHQFSPnm3cGq9uuhZrMKEA9XwGGntC5oLX
8Kx+KUEIu94MfrPAQQtlQUvC7NBejhntwVY9oGfMewAH0AGijtebAJkAHckO
4TxeJCS/+yTwKInYJeHS0lKXGHpML+txn0l2VyZ4T1pJ0gAjjanHSTZSkMTR
i3ofmgAxgabUK8l8fGpuxwDX9Yl7QiJqE3V1zmfCDEOKTxI2CfC8p7Zwr+u0
nbZwr/dyjFzI+LI2cR5Zsj9P12pfn7pXv+haUEDi6uIRBVi9GU7PdjSNvGMd
LlvieLX0tyQHt3QtYXRHHQxbgCAmkFn6L1uWkq0yS6an+eaAbrI6QjiLAzDu
u6QuXs2sAImZafFppi8RkhTl9qy3SYYzshAMKcnsstJUiA4e5nXBkNzS7AQH
CGlmza46lJp7yUCk1/QMMF1I1i0sLLQNGzZ0CO7YsaPDg9DR1cqerigs8A03
dBiSneAPOmCoO9WFwAJJz44Qw9pEUQUfwiYGn091jRzPeybiFHnrOMoll6rf
4IceltbqNrBXJzRRvusp8PXr1/f3Sywd6gs14CdWu7YwMZeI2IktiboUuSEo
g3VUmHdAlUwX+A7yJRSPlxj51oTgxZ1hWf6U3fZJqQV55HC2G6Vq2JJFPu4x
IIdpiZfCGdDtmMZmcJ3zSfBBOmWbVMInx0nRBF4VJMElKcBcm/DLjtFloDRN
4lwWT1kMoOEY+ICcpgIDz1amY7oyMEcH9dV1upG+IqlAimp2rLp4RPwNp3VB
GNNLsykC4gikuAvJUKaqyf6p11RNsYpPCPq8gt8Yh+Sz5cD1SsWx6jmmHFTW
c+pYYWHY2tHLnXE/Rmzbtq2zCfKgRbNBplfAEHVIyqAeZdrQ/kInKhdUz9PA
eqlkzjRGyLi/3SzzYT253mtYtxqqxBOAoTr6eOH5WxKC4/4+pj6mKY4kEZsu
TQM7DCKlDLGrYFaZJO91XsDLZF8qGIFLsiJm3QMB71qCFQuzHjObqpO9LYG8
9Is39qnvtClokSikG1ZThCSRa2Ag6ZwSXiDplDBWi+pf/QbCJILWNL9CSsAJ
s8mzSCOmE6kT3MVC9AmqJFj2oya7G2nsOEmtHUgcveg3zMFbMBr3yfuglfow
EvJucZWj7E0UwqJ7s9hDmeoCZwwKxgVMJuAYye3Z2oVRoV2JBXXLwhCaSd/Q
MDEgYvHGwIlE1obq5Tr3q2/13/ESS9+aJNzdu48fAlaUZAKPRTJmfzrpmLSy
Hk8iJnKT85kSS4Sc6QKtkofD3tVEZ9leR0kQ8qxeJmcW1PK+Ei3YcV0IHqBP
kqEBmGn2NBcY6J5q6qkTcI9uJnlkEltkWloPxKDHZT2k2lmmw6wjTfQuVHh0
9C0ExVSECr0PSZlWVm4knx6EBM8tVE7jFR/p8jfZUMnkpCUHXJdHTrOGvfHa
GFsxORBJ1dxHAHu0ewgTRFVmTAM+jCp6bYLT9QipaRLTnrFOUACYe4BO9ZMC
0qBpD62zvh/C26yQm+WMOV4d/q1h8A3dPoczs3xGf6KJE/eKXQgvxBn8eTz6
aFGfsAtbmUj3ZkkL5Lx7iEbU1UnETJazJEAt35lRogyanKj0SSRobWJAZyd6
ih5hEAKDloZBPZYMAUkgmFBvnq08z4cAvRkPUZ2Je+eTeJuRSIz4rkcSSBCo
9KrfEKPtIuKAkNUA1J6jrhAD7MS9uiWUHLECOUn1S6WHU9Dke3wV9VVXxFEm
VeGYZwU5Ea3EtHf3TGh0jzaKMRgxHEuEjEkU6ypzmMJtyyoj4u8kfZvf2edG
RpBB5c4e/+Vf/uVvDYbbexOaPM6qQkMvDDnGIOOPtk1s9GRPoukwwav5Xfbt
qM/C717di8TW86dXSLdIUD2Z1YHmprPk12O1ilZOpDRKmoRkhrP6pi7CpZ3z
FCUFCgWQCpV6U2tRoJ6jpbRglA0E6H0oQWykVpds/0/aDs/2agwAZelhKNcL
ZEriBmU/t08ohkQ9TpJDtB6HCPclqbRneUcyp8qtd6oalbZQXjxuxkAQ6L0g
i3LX+9kZqP1onATEVR6ly73yjqQFpKqfc96/2nK6/3dDrwa5lijREX0u9302
LNqH6Otyh5122JvxCEw5/Mmf/MnxP/zDP/yWjMLbe0VMlDCOso7BGhxY0j8k
mu/gp23jKTvnd5IFMiRjEGZYDuaSkAueshTaCLd+IAFp5MS3BPlZCoGOIW9M
SsMEzJFAmKlf4UnbRk/pm+CFJKEuSRqYoI98KnsWCHl1o0CkMh3lHUiIhPLG
HdjLGBs8kH4w4jP1yFJv5aofayP+jzrgiPI8DyfchyuF5anwGXe4EV7s/1Gf
oVnXL3HcaxJq4KUqXrVeYxrSZUdnlKd5CrmHCWrt6RijGG/C5tILjifWcuIb
giGM1Wf3SIZNq2IvFrUX0CkWyJim+NCHPnS8QPMtwW97h59/JkIoRQoXDEAk
q+fXDkJrQl2VveqUcDX/dJhwGlY7cSaxzne3JuKXsXDjQM4nM0PCaGcQBkoc
gzZIViXV1E5+6z1CODqNhIDOyWTSB5xJAmN9BlwgkitBV7tP+0N+dgQlbpW6
aQLfNTzTnqTDINKQdPWMDFZDPDSqFwkI3ZCXTV5QFvdI/fQzG8T3xDHOyLXv
0A07ScZE+tL93g+juCee5z1AkMvrOs+OAwuqro17nc0V+oEUMQijvhiRlXBZ
QTcD2NT/naxiD1Trb+R9ihBqA6lkhlG8clzXjk9/UxDc0IFtOT87ENTYceDH
NgOx2ebPESAML+iQ8lqZqY3wg0jdFQ83OpoicD3UJkS5QR7mJVMz4VOJdU0W
CKJszC8uDwjrdrDKkLDuyMQqP0G3GKXwm7TgKYIiaGoA5t3aCV7P4P3P+NyV
GjOUSCE6vEuGyxPmesuWLX1uBRwYA6CRyFAZN0MPHZWMr6iUbvY+CfOeoIGe
5V2Ycpn0yzsmYTPoK2c2VtJHh3jB4OyYMjNgpc66kPFh5IICigHimXXNVPfP
r0bZjNNbyJ1ZhEsdxarnz2tFCujCzBkXi48XML41S3Chtxwr0HoCUy+zHZDT
Nd8P6gBiCPJTiDygI4uAjDyJlUe7JtdfoqsAkw4FrgwnABQjk+Xnn5WI1ncb
DAWAhBihJb298rLDHejpGnoGADJMooNYR4DHlzCXQVawIB0DUOAkE8fjcU86
BJwARXYgCGJkTiVDS6xQ9fEe0cyer2wDhiMlSzY7i9mgXhl8LrU5HWeb5lJ3
G5FHXBI/wSB863xqIEnX1mYihkX4hp9phDTm45Z+X4xE1cqkOJ2Z0a9EKyMv
cMJzGXbjNV5uxvuiZ5Nzfeag1/OMVa7vXNCFFpQy1oDMRHHJj28NgPOdWjCd
DRoCYU3X6m5fzVlHWybDI6moqZKgTO8Qf6hHnNGgmoMEdX1fo2q5yebeA8xN
Ck9gABsKYD4RwmZx6FZzSgNftf50WfT6/iS1RX5YCs4ySVFYq5oX0oaNXeAR
ioSmjnK9uSuYM/DiO+FY5+ue+fn5YbELo4SaM16bN6ODpkPDy10Q0/NwC298
ZmXjgNdTF3qfcMxQY1ayqAfdOUv2U2VKWHJGV3paVTNEQCo7dp0yPI+eBwSc
Uw4F41hirCQNt57i3VntTEYAteuVHWkHaBKCTH2NhVU/IyNDs5GZuCIZsDGR
wVEgrWbBWI9Xb36Lk3Qaxy2EQIJ8Z1Na8vXGBmTAJUOSpY0jYJvOGU7VclSZ
VtF7rKLMzgJWAnEJCsAqzD6uLNZiBaBtRg3QWW8k0mfmUNA1A6hUm+dobShA
a0hh8eg9iMhMMARamgCh1DXE+D7M0rG5RoNQhZmqgyBoyIQINUwsUYHuxwRl
UbmuJZmhjfOQayAUWpWbtV3KysiN+npP76SrPc9zIDB+X5LRusYz/IbCDE/o
LFY2/846fZoGdAi8SRfHu1bNgbVoy56KmSeymr1EG3seQBi3yE6c2Ybxb9kG
fFlvRUaQv0Rw8fa4xAgi4bKkz5uSfIR/jMG1W9wIaNcTY1l34HfGsdyjFRMf
nTWRLez0O4Xhu+ckUVVGIDxL+WSS7yQz/eg+ut49ZEBCfSW2OGMoQ/7QQCby
VXzSzZBGQZKF5CL9DYWLi4v9OijIuDc5R6653nfIhqR8aks6P0ozqwidzwgz
FOZ+Mtg10Jc1DxmB1uueBf10v+PQlkFvhiwm6jO+FPRhPhspAST0TfVlAYAq
XVyd5oj/AV3QxvKb79Jw6vx6X2LIXjdGeoKkaNt6xvEy2L8l1F3dW0hNWV90
L8RoYa2QcJhJEp3dvHoxso1FpwUgj0zKXDA5l2CrEEAWxVMjOO1RodmSiDTJ
pMivZGjSGxlBhdqEFPF8MtQxPcIipOdpF6hUftwiiE/8JkOYkKu3N23aNNPQ
m7v8gEAI4PWSNY6RUX5DTJK3Qw5UFGqm2XWm4yHErNcDqIijiOQ4zJoVmYg3
IkVRxCWwAQgwVFmjPg273DHndBZEwLNLXJoI4ZQgMyZb1vE2I4JJxjM13urO
qQU37kCbgW82/LhtVdxF9M0GpnsTWrhH1AGfobekKa7P4wW8u7X6puly5tuH
f+y17V13fkdS67Tvee1TqybW70/aE267fzt26bntJc+8rf3L979y9DWy7lx5
KiC/prd8tsNmqyQwUkJAYQhG82TALYleAhJAThhtoMwO4oScAyKA1QrMGeVp
KcdRMu5RdjIndRhQERVak2jIGhy2tvpBDsJAR/JfO4YI2amf4NNaXdnqo/7q
Cx5EJVOUuOCXEqlZuKystUusIDOzxpnDo5R9h1RARyTv5jpi2XFl+EyoRMeR
MT5JFgdmHSPIcoeIXM+YpaTq35Xjk7HD5cvubh6ndyQItBUGZfRxDWpXc3XP
hgxnKF5eRa56eV78GccZXFxNSKaOjIMk+Jnhtfp9vL7fLZrv1//f3H7gzc+C
1Pb0xz+4nXfgHm3n9h1tcbyljWcp20dlxm6cX2lLC6e37eOj9Xu+TYZN08SF
C23TXHmqOx7Tzlu5dzt960Vt3+aL2vx4YXp60lZ27mnbNi33HG5FhUtPhf2d
vT29T1LUMRzh3yeDyYQnLGXxMIGbpYKJ5g0ncOn4NBS9xdvn9XbLWqUkakje
zYyjwHc2WGZWIRIPJt2rT7ISI5MuBDmu6mtCP9mj8TPT8tnRp5/W5pWHl5nU
rLqK+nz5aiA+bgnxGcM2g/LeX1s5B0OwBcsksrrCNuxm6aHrlJVMhK6lEGCX
UUs8O45TcWtiHriPJlD22vSCMKutvFeCP5jqpd5JVnVS5szPGaZjB9MQj45F
Us8mqlczY/mu7dema1EWPPDTk27JCI/nZp80nPzKr/zK8ZJrd4v9+/T/J+2J
jyqZdsm5bee2XW1hPMP0YpurU4vDvoL6YlscbW3rR/Km72wbx7vN2w3n1vkN
5ccvDktt63h32zU5a1wndwxbeg5d2C6GtO2jy+pzYfp7brEdHB7Zrijpfq+9
j2lnbb+wH7/88IXhxnDRqRUD4ZaN34Q2W83LAxf/2m5WTmRmBYFqNs3fG49Q
jlVBOUQpxMcFZMRhgbB7CWxeB6vKefcnLIV74q0xF4CTANXxyKDTmAOZKwdG
igm4dCyQEu6EqvcCAmSJR4mACUHlWQCsPgDp+a4BXPdmiZHnIEp2H6iP6zN3
Q5BnUXx2zqgj5ZJ5APWKEnKMBcWON95Wllb/jDLSFmxpdfDpWObkCRjCBdm1
PyGA1GYHDdUgZWxnJMj3kCJz57MdGLNUo8urg1sZW9C+2jy5hxCQ4CFUkAMe
ENTxsuuP//RP//TdkmNqn2xtP/P9L2mPf8T924HTiwmjWWLzqsXG8XLbVcL0
jOFe7ZLhce0+w7Pbrvmz2hmTi9ujhh9oT1r8ifbGYx8ct8cNP17oPzgp92h8
RnvM8N3tScMPt+cuf6C96tCPTfwoY+3i8Y1FlD3t6vnHtMs2PKDtHR8s3o2L
c0ulbg62Q+NHtWdc9FPtvvPf1c4ZHtP2b54S58g5h9qxy85rv/j+VwyHT0Wc
pa69Y+9lYUm21iMScxqZdNQsJ1+9alGmGoKGTRbJTPsDOOlNmuvYzK2R5r4n
rGlJohG2Dgd60foO/tJvDL3M/+AHwQq/JhoIaFZ7JiHMV2UXEJ/Sd9Z/Fy+F
T2PAcOe1VClJr7NrAc/vMjIstNqwursHdy3FVA4suydr3YuzPQPhcE6HeKas
spxm7WRxqpPVpijJtsq+Ea/od3RCxpDplIQbSRJ4s5ZEEZGk54ghQQLYp1mI
hSJ97qGHfzKmtuerxnxRJO6o71nmojwrMw1+mMY1XcVuys4Jz9SzxE9Rdu14
8NdizKUzxvyHD72j3XLDsbZuYV1vhrKD2pbJ3rZ3uLitm1tqZ0+OFkN+tH3b
8FPtDcd+tn9eN7y6bR7vaMfmHz/pjJlvTzvw1nbbxre0LaVyzp2/V3vC8APD
lC4r7S3HfqKzyN+hyb3a/sl57SnDu9rTinjPWvzB9rbLP9C/P2J4RbvXcFvb
Pz6/LQzr27bRme2c8c1tw9xyW5jbUNXZ3LaO9rWF0bq2brypXX3FJe27X3MH
R2U4dCo6TTf6MH7INo5C0qloWLI5mZ5QJ+uwEvhNB5PF2VkDo6jkGA87S36N
tybRH7rRA6iq/GnkC/sIdvWyAYlPmVjSOER+k90J3A+Ume6nL3KeHsAvYHUd
DhQXpsbAdL2+BRuZ2kYNlCS+SQK4hankiFUF5z1GldA2DnhWU8f+UgUqCCdc
5zsVy74jHjyLHecVVI+95hrPyLwlbGcto3r4niVbOBAfUt01oS5IWl/+nzlT
v9XJO8w4tTo2nT0Kqx72bKur7NdbeymGWzjshlzs/bWYJrEwKWlvooNnCR6P
//Ef//HdsWlqBi23P/73P9jzND/wXkfbxnUby5RaVzA+vV2y7pb24ot+tBTK
T5c5dUdbX1A+e3SfrovoJLppZ7Fu9/jsgv58Wzf4X2eOy1vZUMcW2ua5pRnA
17VNo41FtS39b3sx8fKNN7SNc1vqmuX22OGNE3yqi99xbMosv0b9/6V65IOL
UUtt86iMwbl1/fG3Du/vVbtq16Pr+J7yo8pJWr/UXv7Mb5PVejh46oF7VkpW
Nkb0EU+YhBUsPUyglJJxa5Z7Y5hOCo27RYZRJfWHaTCTXV0zZAo9gX9jAc5W
/PaOwmxwdyz7HbA32T6zqHvGoBHMDed3YwyBnMIAp6PAEBKCDcP7TeKTtIw0
yKN7s0ESXiA4kXR5drSOAVSKL2u6MyPvExti9GWY3/M917XqpMFL20y3c69f
HUulM8mFTML7PtswUy1XKq8sfY/MpDkCI4TW4nRkTWuCRTETKBKRbthfZKQW
75sci2Ely8Op2eeMVhi23Hms80yG42aSG2IX8YhZguHYAm1ihWh0vUd94hOf
OF6+192adxf0/zd1ep2nd7Yst92bTmuH1z+gnTvcUIbX5nZk/qZ29fDidvZw
v7ZrfFZRYfdoxpaV8oX2j/e0o+ML2wOHsoKHa4stG9pD11/dXrn9jvn2tuE7
6w2vGl/WDk8Otncuvay978BrR+0tw4vr8HOH24s6j+5/jx8ePmo757YPpSAn
u9s8qpaXtFwUPL3QRHs9sWzGt1z2I12z4d6l4xuK1vvq+5vbc4bvbS+64NXt
gvHRovRi2z050B5QLtLrrvzZdv/hlWVz3qO4uautm2xoT7rtRkGYDpyKepPe
0UawUKOk/ogZUI1FZ2Eh/0p/Z0V2MjHHH9P3fcV1YXt4+qp6c6l+ymK1THuw
VfwGH+e4XckYnZB3ht2xwyNAFpKNh2ENlFN9PpltWALt4Itt2MHuyg6QbKQF
ZfonjGKDGbfy1rPNSf367F1TBpeI+5Ptl+4Lsz3Pdc7TeyjkuN/KDkvVjT5L
jG3PYJf5dM77sSeVlTw62SuchfSsagPu6svdYQ/iSiYV6Th8oYUSKVTX0aXR
kbhXn+NuC+9cXbrAkjCkZv5SqDZFoFriSokfxWRMvghFu56HVYLqeHXR3VLv
vP7/tj4a/IHvfn47/6wDBfsN7dzJ/dsdZ3xfe/45P9pW5i4slTHpnBqV/Nla
6uXS8bnt4jLLtpdW+uFzX9G+dxHF3jG8oChzcHJ6u2FyX7RrP3zg1e37ll5a
CEfChfby4altaW5je+XwTPwLGSedjOP2vOGJZQNubq8YnlUPes/Kq6sqLynU
Pm64pV0zd7SdPl7pVdgwt76dt3hp21nKd+/4zPbM4e1j9CsF+H3HfqiT8aoR
03JT6c+VdvPeF7YnLX2w3Ti8vZ1V5Nw+d36ZmJvb/Y9d3j7xK+8q6/EULNzV
sUy0UjzJbUaM6t/kSEteM+fiO8AGux0NmZdoi1+4VlpkqhsP9kMoiZ6JR8fU
oU9BxrmEDKYvsZxi8ohk403mzKSpY7b5ndwTmSuHK/BONFdwpkXoULRieW7Z
smWYytcHdsoRQujGJDRjiA6xYHl53Ck00kyup+jQPSt2aLSsJsqKCc+hIJXn
+ihiKohZSvOhR4YU0QX9iBbPIhLUnWLORipNjYZmbHCAGPPuJCGKZvNb9jIa
+TASgcZZ4RiXjBmb3UJGKpK3xSqpnvG4OFyAQzmH0NGGY7MXaOqT0tV99X3t
ZOLXpOLUx1nqWvBJj7ihbdu4tU3mFsqY3NLOHO7dds+d0w1D+F+2mWG4T3tG
aaS3Ds+uI9892C+/ZbSpaPAYRGwfvOx1487IcbtpuKZrSBwczZg4Y2Znqb/T
5ne1R44ePJ4xcUbM/iuq0iW3jR7c3jy8xF8n6MS3Ku6Fw1PahfUOm0o1LXad
udwuGq6asnJzZyX16O/64Qltz3h/2zMqt3vxWW3fcFm95Kaypue7nGFV79u5
0l76jEeccWrLlPJJtuCsR0VQtpBxSCZbcrpmhQiSCoA7XYw6jfqBWSFmgohn
wsN3bOJcJQ1XMslkMad7fRrjICQoE4o2PimrOOx0LdvOc7PiKmNxmI/dUE5Z
ZXO31SQUVtYfY+78/PzqGifM5Sdy8LDMcSzDoAyIKK/un1rH1/XTmgVxsk4O
8ZCBYCEsVMPtbvUYxMhEMfsAKRERIenpzK0he+aVNAPSaQrdRGAlQlPG5s1T
JWEzZUbWYhbBlrohp++6RFMnPAnmKT/Jm5PBQPnKMS5vKlfSI+P0SZU+Swx+
yt1mB2fMNMu6dcO2tmfz3nZ4eEgfEFxfdh5GHigbECNvGx7QtpcGe+PwjPYv
jr6+sIuZ43be5Mx23fyVnZCjmaL82WOv70x9YynDjaXRXj7cUfCfWqvo+T2L
Ly6y3KedPT59vlNwfi0t20PLzi2FOEz+CRk3dDHxrOHJ7QcOvKE9buER7fD4
ULFqUqw7rQzRR3cWFiOn5NzQrhseW3bu+k7AoyVR7hh+qN20/nlVzLZyT3e2
xdH6duuDrt5/ai1JJWh9vZhFMlnOYGYki1VZldn9rDcgKuFVGLKISmPOAv9O
V4ePu1KdBeRPeKvnPOc5w839YOJduxcKEMnzMvOKkNHULDTXQZdnsjqpqITz
zqaKhHdBVCoKGVmasS4dQzSWZQZEPSuWruPYgTXOaTlExiQCwL1ITYhlnUKi
33h3CMUeAsh3baq+VJ46YCa25TiGZHIhAZiVE+FGWGUHqzabxfWeJo440LWm
rksqEr4FApFNSEn2aRJFJZcbAhpTU70kbdW8uiCDl7oYLJBcGDXno6WTeMag
5qms1QMzIopee/kF53fVuDIcblvH25t1nUfKvbujTMW3DM9ZJdbyeEv5eI+e
qcj59lNHXuNbe1QJwNPHu107s1zH7WevfH1XcvcdXVrHHjbcrxTbfYZLyuk8
vV218eJSx5O2t2Bev+fRry76jvWPad971kvLal0qNj1xfpWLo87Fve2S0QXt
sslFVZeX9z+cfPvSq9qrqn43DdeXFtzVncyzRue3Vx5+U+fmI4bnth3lgN5R
1z9q1+NKrW9rZ02OdGI+Z/e728GFS9u2yZ62d/1Zbd/y3vblT/zUvlOR897d
ntLaSfsLIEimF7nqxK8e05vZjMuUBRhkAjLiG8kSD85wnfKAyW/kRuYEwsvS
Z+gAxmQMzA5tmpIGZNexBblmQJlYFsl6Ts3QYECeTfbqqhyEQxJqxf2l4aq3
rRF+VCe2mSKaEvHYmsiWmT4qEIloTaTMbBv1hcQI7joaNXHAIJqdjoRc3azJ
9EkoKJ9diozqg/juJdi0S5ZyIGF2oSM+0icog3u9p7Zzrf5IkAUuuBjY8gMk
kxsDlDBLtHPHCLpstEoqJ6xN3GY2MWGnDRNh3ko4QlJfeVdl6l/9ZqZuzXaw
r8nQs2bZOf/6U/+iPeOxN5UpuKHUyriPel44Ptj2jna2+8zfs7176cXt/ftf
MZoRj8t44+TenaJTom5q71l6UXvXvheUFlrfrhouLU1473Zg2NfOntvbdow3
FikWZxOAc+WSLk7aOeOtRch7lZ372OEeJRc2tHNG28rBGg6VTzreXr93zGrj
ts1V7I7yAXH78uFIe8hw//ba4l34W5e9ZPiO0n8b20uH59avIm8VEfqGzt9Z
Iuaqcildt290j9Ljm9F2VCfeVpe/5fDb2pWTq+slNtcLPKe95tAH2nULT26b
yzy+eOsD2mQ0b+HWaadi74s6iqg49iuk6zWIEbtf72JDVuIlpQIVlhSuvidq
uXNYplcxLBH8IJv9m6nFbFnF7MzPJwK439m/YZQCWqE2AydJbw/RjLYEX1M+
feI8iZIFVerAiINSEoTHx7vEQCoSu6hMLYRl2TjlmPsxhXRLKJFEEvQO8TgZ
pJ6XNQDaIAtqjLtmcYh2ii/A2MyQrfqSZNoj+8ezgVI7ZYIiaxAS2oA/kvQX
pB1D9Hd+53cK6qVVixlWUmMRXat9sWvUg6NtWo06vzbTNQxgN4M3m8vo6mL6
SCeVA6UrdY3XAJvqiuPV7Hc3y3Fm/39/e/sr72gLo3I8zUQUYx48um97dVHh
EcODojG7dv2hlZe39y6/ZNW7pFUfN9zY7jvcs0i6UuwyszEqn26uHSotfGFp
6ceXhHhK6fF3lFb9weGKdtp4U3vN+NL2sQOPWWi/PFxfHNhexHzLcFX72BVP
K5X+S8NNpfC31bE3rruhvW33TcXKa9qtwwXt3uMzy+reUcWXeHdfFXXBwoG2
rRh4+eie1awYO27vP/xd7S2Lr5z98v+kK9xt463dS3308Myw9T1Xvqdkx7NK
mS93ffvmy360DPrXV5VW2hWbbir9P9+uueLivadi67Vdd0BDlhxCJgtKXgOy
Nutns3+YLoHo7IGH4gSA9Zl1vY77jHeKdZ5B7ie8FkSy0uggejNBbjErK3MS
2st9WdaU5ZnKVSflZfwE6mLMYxzjNnu9IZsud4+6x16ouk/XxN68agQCrlcl
JBBFMyASome2EREREqmp7djbmjOLTJAL+ZWboBPI67fy3EvVr11dlsS+vNTE
jtK0CIqwXlczc8aZRIQbVWjBTBKyUJFC+wvxrzvdmwVCWZZNcPpE5MTcJ2it
REM3w7XKy6wncyrbVzK1VWUer266O7buny39NcO/ZYMJv51tY8mLb1++cTbG
M+6jrYaEXjE8ZeZ0biykP67dd+M969p5arPL09NGG9p9xrtKcZ3d7ixduL7u
/ejh2+qKfzfcv/7/oeHKtnluof2r4YHt/11+ePu1lUcUidB1vr29zm2Z60Tt
f7957Ol1FG3n25vKed08t6799PCY9ovLT2y/tPLkuq9+lWR5/3Bre2Xp3G8r
abGpfm8pSbO+nrF/vFKO9AOmTN3dfuTIKnv731XDvUrRH6hqvqI9fs8tpk3b
mZOzy919AxK37z9ant3wplWl+/xz39SeNLynnTd/r3bZwq1tabSjbdm4xGQe
9pyKx6/o/ElquSwFYSubSCaVE6rDcXZc0qhmtZp7XJNoKQAK/I77rdPZYXiT
XWNZx58wqc4pL0uH2XABo+exf8kF2sl90RjZRUHbZlEQwCKIOuIy4pkQXZsI
ERFoT7JFmQCZbc9kgWd4HuIZF86SzhCRHZ2VDcryTpxgZXKSOb3s6yyXydgw
8iNxlhQjeFbnEQ5sbNNE6Ydk7lZnu3qyvDMyNDm52M2JRMUD5d0aMqJ1aU9E
Fm503KfIxr0tkNc823RFx7aubd2vrxDZvbxXcy1rE1spn09Ezhr0PdW+4anb
tr3Pvzzupgd2Ni6VrqR3nzU8to/M/uTFr18doX3M6EHdED6z9DADeGPxaZPp
2/m97d3DpZP20XJaJ+3B5Xjev4hU9G2/f/T2SefxQruyZMQjxmdjbv8rrdv+
3dJN45nmvWhuuT1q7txO3lH/f9x+8+jTQ+3ZsUm7cG5nu2Xugk7r+hvh9Xyn
9VnlNJ/fLhjvaz+z8qz2PcuPKzf7aDtrvLNr6L2Tne3YcFl3fdfy2nDVM4en
dE6/efFV7d3nva49cHJNiYN17ZISIXj9fRe/u39GPd+69bntCcM72965c8rI
2FDlr2ujuXF726ueXFLjFLx+d8dO8qvAC86x6mDLcZhPqM7syHJtLEaWIfzi
NrwytZSRWCm4n+xWWSqMG5keTXwt/Dfgg9fwz2+jIMgJ06GZh8Cx7PJWBrng
N+wn4pN6KotcIRMyAJVUwIksjhuxTJMB0HvQ2/S9d8hSIPM5SQiJo47zp71D
tl1kvibRcMmE+MPqkJVMiZHi2Yk2mygluK489VFHSlF9EyDftdos09TkHnnF
KvbefFw72y1N4HXgN55SvuQWeaEv2V5kWGLBkAtJnUxO2KSc4efkELIyVhvo
K1yfReA4Xp7T3SnoqU+30H7xfa9om9dvbusL5ffDhvl97WGTa6Y6emN78fyT
2oFyfzf12Y+5biV/x3BOt45/aSglVjbnzxfjf+/IY4Ypvefb8mhde1cRCb0/
uvig9tuHra/B8XE5oPPtR+s+lB71/xfabx15/Crn/S2Vnn33cP9J5/NC+43L
n7aqvv1tKnX+9uHG8Sq5pzp7c9s/2daeWKb5+4cnd4J/sP58/76yKRy/pExy
5viu8bZ207br2sUTY1/3HGN2CdG3LZUBuv8N/Ok+JL00WmoPn398e8uB7+vc
prfPGB2sIsYlM85tR4fr+jqKfaPpAtxnPO5hw65TcfuOjkV9xQaNHqGb9DN9
4DNhbX2He/zBd/rKvXQSQzThOfV/oh3DabYl4Kbv9F329SXQqPJgmZGHrxmz
gu3E1cJBzw6ulW0MyrOVndhG5FFmscgufGLk4pe6JR1tbJG1UWzIC3Ugu9TP
OUsZ6GGcJQ+Um5C7md9lp+A8PpveMc/rPbLL03sb6zI1hOM55xnZOjFbMliY
qJKGC7usydIJss37enb2FJNv7C08xGljT8mbSa/SwUmWhpv0b0apjXUli4KV
5yZhzdlaI4HD1kxkKQuZgMc4rmxtoo34aWVfHS89f7d6e+9sJPrKI4fauNSO
ESRzMvcfH2uHJme2N5SauqLed894c1u0drz+XllW978p/o5nVvW1ZYA+eHwa
TrffXL6x/Ua33D/ar3jVcLhb5a4cza7/2PJD26/XH9Y/YzjYx7vmO8Mn7beP
Prkz+3nlGJ8x2hwD/F8v3tJ+/chTOqtfVbJneW7DMNXUY7xuv1BGuV+j/v9C
19LIjNRrSD7xo2585vCAdt8i5nw9cWfJqUcNZmWm5P6+ldeXwn9tV+JPG25v
O0bb2z0Wzmmv2fF2Lna558vtmsX7tR3zO6v239Ueuu1Rbdtkud178tBu9Rw6
48xh56nIvX41SUUirCJIhr5mIVPqbUoVD2/pQMiQGZIDJSWtoxmslI3zQIec
DHCA5m2acrUggcJL7I8M+yAdkiNcpnwZ0YhIgSI0gxXJM5jrfoRMsM7stYsi
RHhEQwjEUwfkVC+KKQPuyGEYyBSw8in6DM8RfJk10i4Jt4isSc6B5Bx4wkWZ
icGkPTwvIeoZ7+qRdfUEDqL7TfnrhyRCIEw9X3tnLZN6Z6gSibNOJnnAGc+M
ZYsykNE0kmOJgWgQ27XO87YNdDtOoSM8B4wRLqs0b5rxTfj5zCSFgQ4xFwkG
z6C8q/xTGuVTv3BLN8offu29S91uLd314vbjF99ZvuStfb53TxnpCwXVa4rA
rx4ubvcZrbSbJvvbfzj0KCp5leRbRwvlPl/eSe7vd488epXk50+2tqePzpkp
bv9PqPJO8P3jTaUnL8qg2G8ffUo7d7K9PWl0YdF0aoYj90cPPTHm+ELn8Hz7
8IGntZ9feny3zh83XML6HqYEHrefO/C89uNLT5/98v9CkfV+bWe94c07790/
d5byvnm4cTTj9XsP3NmNcrz2d9Po+mqQnWVnbCoev6i9rLj86H2PaDsnuzuv
H7Ly8LZjsqddtO2SLhn379k97DgVrx/ZlQKO4mLWCoTXOEU5OgfTiU0P64xd
CgzO8ZqxyyCnRHGXUsKVLOTBf1j3PNcxcHE5STzwmLGgTM+jsDivFA4l4dk4
hHfwHxmjnupGObsnofdc45kJU4rjDIckqPHOHHrcpdjIKIo9SznwJsPGnmFk
SrkMeyNp6pPwN5S3MhNvq+owDWM0WfVv6Nmyv0d97+MVvZZJGorhJCCVPwus
tBoiPtGUksh8FpOlq2jMTGJcLjeXWm29jWGHzLcztbPqn5rm6jDXSSvXUOfO
UdcSDidYr94nXbKyA8uVTTpkotle+WL+3Znju2czU1/6xE+2C8+0gHhTGZ1P
bq8bntMuKhJSjJeUo1qkM841minWreVkM8Vx8veO3T6akfWFw3ntrNGmGZGn
TvcfXPm49qHhvn3Mu/R8Bs/ee851pTBHJTkOFdfObfcadtUtFw7b65Yzxhvb
7vFiPXxcCnNxvizndeXInleO+AXDcru8XHhC5oziIccanV8zPGBqjk9WmX6P
Uq3lZ89/DZKP+v8b2pHR6e0B40tKuT+7/cLR17SnDDe2veVGbxsvtQeXmY3Z
P3zkTVNlPm6nTVbattGWdu68sLBF8arU4097XCf5cxbf1O6z6bp2Rin3XetW
2qYycZ74yAcun4rj13cEJfNagsYGTVCAF76T3VBIL+FHnFMcoXfoTzopUy5x
tJO6yP14l4E4+jWJDHAYl+PMO68MfKTH6HOyBsKUy5GEQror+1aSvGqW+bTb
AQZ8sEM9Gdwmm6NzlU8XenaiXPrNWbaiZDa5PDIXN5yxOresCCo5uyvRPLse
qeGE60zUFyIweYF8z3bvLDtN5ArNSOSpXvx09093dNZLFLaJSKLEvdkpGns8
GwsTCZsgSNI7qpb61VS6gRr3un4rg6Cg0gkIdXMM4S2cJL6TZYqZo/uYVKCi
O6oLTrmNeuoerreqt11w2ll9rfGjxjd2hm8sr3fX3IZ2abH845c/aciw1yOH
s9tl4x1rbO2vVsOvHA5PHe917d8vXtfut2FvO2duc3vMcGa7aNjaziv87ykO
b50bJ8TAvjmz3Rv63+PG28ft2Z3t31OWxQuL1juqIu/ddZFx9YPFzWeXN/G0
OnVL6cntpZC/beGsYv6Odm6ZGFvnppu1x8PcqDTz+irlUKn7B6w7py3OTdrj
h/sszNT4Gtb3P9Nhzx5K0hflS/j9wrHXdPLXoZI6u/u0gLH0H7/yLZ38zy7H
2QLv1wwvbZdvLvtzfqU9f3h1u3P5re2xS08oQbHc3nLoPe3C+cvb5Zuu7oOU
86P59pEff92w/dTjbWibcRl4yXgauqKH/obLrH2mvuEbxYkFai65s5JtiE8M
nzBCbcILfMJmUtL4nlAd6Iq28EukxGyFdQrQ8SztJ0ooGH4krPIv4Z94SLxq
daawiABYpgDVKbutiQO8TfAa9csSchxlhjPziTL1p7KjhPGbv43v3A8iJWtZ
+Of87UyIxURJtCMywLtpc8/2mXCF6hCXxDMz5+d4xky0uTK0sbbFf+2Au1mP
o50zFua8tqP8EwfIHIl207/MOWKP/818UYa+NRajXOETJA9jBGT1wlqx73fJ
mVNNX0+dx43tJ7/3Re3QtjPa2ZPTC9GLnfY3Tg60D5QGos3fU6j/f5Zu6pNY
o5kIMA39unLh7xIBO9pvrtzcfmTjfduWuv/fDld3l/zhw77O+T3jhdLZo7a1
7j1cZV5VRH9eeQyvLkX9syWEPjqstD8b9rfzx+vancWk/7L/6EL7TLEdZbe2
+5WJ/R+Xjrb/b/+1C+0Phovr8DPqjiN1+LdWHuZvalNs6g/+7nIv/Jmdu7YK
X1dGxfa59d2o2FUVP1Sy49HDlRz30cxRJww+sPjU7svP9+Vtz+iefZcER6eS
wN8Lhtuqjme0pdGG9qxdT2j7J/vaDaPr2huGV7Y3Lb663br1xrZ7wmF/cXvv
Ze9sD52/ta3M723vuvK97fTx2e2hux9ZkmS5j7x/7rc/UG9/CknwlI5UDKCE
oZckSKqdrMCHRpoq07O+Y0RGj7A4a1TcD2UMa4iGIGxJUKKMUEMoI4BhTati
kPsxmLbEnsycqxfTFctpR04ttDIEsgkqSbEYEBjhOOmlHliTWG0kgTJdi5We
ldlE2pvUIBFJAe/pXYzqkz5Zikp6YDFJpTy/rYlh8Fv3zVLIKFz2BWanh+cm
ehjmJxrubJZt1IOindsPed0kiUqaN92SlBW6TrFeHcnZPKqfuEIEfJaBUux8
et5BAqgTfnbl8tt1W/ZL6SbkN6nptQkXxgCjQTfW/aO+Xn/iluPVQncnB3bM
TIArj5zbLtx6sF28cH437iMDjIV953BZmb8bh1j5v3Hose1XFh9Slu5Fht2m
zvimPu/98OH08hXKkZ/uh2lnltJ7UJntLxiW2s/Vwz4x7Onj9p+//JoFnK/S
to8m5ULsb59dubz956Uj853546L3hnrwaZ3wo/ZHK9fM96/jJs7sw8end8qP
sH+hf91cLsPZ7XBZK7964Pb2wU0PLxF0rzL0z7WarT9zy2hdO32yrV0xHGhv
2H9bu3F8T3Se70xf137+8levMt3fS4ZH1617+1Lwxwy3jdC83vJd+9/Qbl98
TFuebC8P46ntBy//3k70fQv720u3v71kzGnt2hKYS3Pb26Z1G07J8eU+ss1t
S0ZUGoZGibZO1DlaVgdnvwNuZxXLLPtDNYi8ZA9ZjRPMmce5tZl+gTIOvGdk
xBrvkoQUoIHcb2W5hsZjcQK5+pkZZolmEIFGc9zzvEt25TmGv+QYS50B7529
QxyPWYTdbugDOzDjNlnCaraR1jWxpBM0KCmqvZOys8Exq0sTKzYDdL4btGSt
JzFfTy1xV/DrLDTw6j31eg+zO02fkvE/r5rxDWMYRBLRmMnsKPysZnHM4Lqx
OOKQPDDI7hgeWyXjuqzC11QcAq9MLvCnGBhZ4OR8MmabXKvn3x3Jl2erX970
kttLaa30BaSLVqOcbuhtOnW9t3Sjobm7ZsI2tN8+9uRyl7e024qemH1O+b9l
uDexgR9Y12+u7+/dsX++faEwPWnfX7YtwtPlX7746vkZwXHvj4Z74HX7syPX
Tgm+0K2CMumxuv996sB1peaPTWYq/lCV//zhnAwFdqbPz2b07lOS5MbxPdov
Dg/vbP/llW+vN6hfw2Ip72vbs4ZLy38/q62U2b5gWKL8muuGS4dQ/WcvftVX
Uf2Yze/jM9vmuv68ycEp1de1H73iraXL72g7SoA8et23tzeWdY/qR9df3Z46
vG5U7XFPq3Xn1rUrLjpvNgx6ygwPDFSUQXkGWxaQoQK5jyqwB2uM/EA3QR8d
65v2rdw+3Bd9GfpKThksSKI4zAE1UgOL4/bzDZL/hYpJ9iN+BK1J67LxQQ50
zQHbC8ivBDtlGKDCQizFeNCMrQ+WVB1mZ89j+ePDNKHh7k6z+MXZ7uy6RMIh
AZKYEJMTysx7YLx6RDJm+H8WRrCeYQZtXW/SRIVKTF/1IkmreUd+lHLQTIrW
E5qD4PNoTeKc18JqzMwur+Sow8QsC0/iV81orI7rxnQneI24mzazq8oIuy3J
vnv9oEATkiKsAq+o2auJpvnbFlbzvtUjjhfh747s22dDd7/xi29tG0fry4rf
UC72lnZx+bG0+a9ffEf/tNxs69zi1K/f1JX5gXLOGerh9xursBjnf1TG/Lpi
8meXDrQvLZ876ZyfbzeX7fCoEgsu+fOlQ+0LK0cK/og/Lt9huZ0xmpryo5la
//Oj13dBsPaYIcBfL39iquqnWv5Th65vn1y8/KuOLZfv8O6i9lTzRyhkFQ9B
9bThnl0o/KLQBCUVFrpQWCh/fGO7dsN57fDktD5rd9pkud0y3Dfu/nsWn9t+
5sgrVuXB3smO9sjhhva2bS9sV62/tG0fby2Zckc39H/08reWafC8tjLZ3R6/
9/F9RJ9QOHN8Tls/t6EvsJ/uzRy3d7z6jlNKhFGPeT5eDS1T3KyXK9SWRZMp
K348jZXFmLRW1nUlyipfGM7r+mkCgNP7ZYkm6laGQhKXJ/WT7x7jEabhP/Wp
T/Uw4PDnfsrSo5KT0aeZJ+Ukm8SXvvSlvqRMuulRTxG8sSt9ipkRQaygHSs3
25FRliG+bt26IQNBhteMAGqpOj49PN8H/VQjq3fr9zCVfou92IQZsaLFCBoJ
WNJLN592WtmApEByQmcCI8EVkxUrwX9UF3XxTTkkFUpnlVy22WU2XtOQpCSi
pmQYEANG5ZJbzXHHspua5OIvKTe7rZOlNquB+UfeJxs8s2pY+Qm6WueOlzS+
O1mwbSYRvvyJn2obyrteqiazjHSlGPuyvmTmpvaRpdvar6x8W58we+rovD4p
fm5fVDfu7L2ohOm1k03t84sHJjON/pYq8lCdKhHQThy511QWLJTxvdhFBlng
74uHjrprNBMHjyop85AqeEp6/8+3P79yVRy09w172+45e1/QfaH9pyMPWTUO
/On1Dw33nawyfzybULAG/s3l+uP6aJX78/33mWXoGEt8dPuFA89pP7jpCe3J
JfessXPcwsAnDg/qAuCnDr2sk99q95eVYf/W4UXth/a/qj1l8bYydDa2e42v
7F7+u/ff2V4xfGfdu789dcfT2w3DLVWWdTf72/7F/e3w3D37nOe8pUS/9LbN
p7IItnbeGeJJZszk9qX5nQPMpN0iDvAS8GdZNEY9RtCmjmFGKV/A7ahm1Mzk
V1bEEwF8hpIaI6Ar44qrThq41Dw+OlkMYpApg3zcZsoTq9XC9e5DN1Bmx1pc
kkVyKOI+Cpyt6vHmylHYd4IODUkBhgbXvC/mXFrq1EpalOTqcZwrE5864ScN
TWgRRklcdc93jecnMZ9BQm5BkgOoR2bypsn8ShjMklITqsklzh3TrKjHoFE+
C0Ev0ewozujizzPA0BKt2e7onBiz2oktz+bnzzNkaHt0NlDImGJN+M6oUkaS
gxoTMBDIkCM+mAExxJRTLtnaXMhfc6B/28wB2LF+c3F6W1nqD2/PKdFYBvLM
AdjQnrXlsq7819ffOeUqv3zY2X6t+IOaR8br+2jdl6+8dioDyquvW55YYoQM
8PcXl19dRREEFLX17nv6laPZ9V8+ev9VwXDRuBdfBJxKgT9ZPL997tBV/VGz
Eb8hQ32fvuLmzv4fLl9g69zCwir7sy7AwN5PlMv7i315zfT/f730qO4YrEqE
UqY/WddYbvcjwxP7H3nwMyvP6N/Jh8eUPNw92tyX1R+ZP7u9cPk2C4vHBEHV
6cePvL7dufDcdsHkYNs7v7vdedqLuzhgExycP9Cjkn3H8Ny+F+ihJRI2lMjY
Ob+zbRJjdt3mU4qBhc5NeiTRumaDSyOeQNU/xvksB3vHZnKzU29xsRnhCXNa
2B8jdtkyfib0L0ED0mCUUADgGnqjCCMWvE06gya6zBKCd8nC7jYeTfHz1mlM
BgGKoa/zqAi2yVyajd4+Kf/kl8yGlSh/tPUMU36+Ew/K5EeQXsRKMj0QJTz9
hKTM3tHsnUXXjAZ4juu0bMIqZz3+dN1dNeR08OzI6mJGBeKjoEJkU+ZZcY9a
zuSdLkuaJnKAV+B8xu3IAmt5yBacNtxhck8csL/927/t3zUWb8NmBbKA1+Ba
XE6W8GwiJv1nIcyOl4y5OzNg6yxk2NYS40fmVtqPDY/sC172lb3/wuGybgY8
udT+vjKTeev3Lz/4t4azJ7NB+JXxfB+nR90vHb731LxfXwrQbNryqgT4r4tn
ti+vXNC/f6q8hskwN2QM4MsXX91vX6l7fmLYNz8r+U+XL26fXbksg32LM0P/
M8duKbW8u10+Xi7FGsL3NTiX9604GD0/s+3XcL3/vWDK4zFi26VeFJ/RfEr+
uvGtw23tYaWm183N9wH/xw5STk55/tNXvrGr/keNbmhbRkvtO898aue4wf6N
o43tvuOr2/Ubrm9byyc4c8MZ7YLRJW2pxAbcXnb+OUun4vmBjkDoZUtSmJQl
4EA25eOcYxlwotgSOIS3jIkYABDIjyUYBc1MBaMBWZyW5HHJ2Ol+12GjzE3T
1JrHOlAByngej8IzxE5JcjvPwCQsj3LPjDpCACWiJOYKm90MfFK0+0QeAE6+
leSUSIZc4/3eI1mAKH/nKG9ykcDz3TtksYAFSOpCIFLE2sQ7kz6uSQba6UAe
r+qy1VEB7cqoycKjZFPMDiJGTZbkUODqpx7In50DnptFSQiuHczkJXiLxXik
KNKTqIIAcv1JTrvQ+QcEht/sfUKA4udWGefMqv3kb1e2DHvVjndH+C2zBbe3
3XifskXn2g/M39L+7ZFnlZV8Q9myi+1+5R1uG82Xxb6pvWM4ux2cbKhzu9vn
D18zM80X2u8VVDn8n6lrUfcLKxetteaX5kbtP5SOp/FHswHAE4ePdva/rXh0
yAKdKfln4wKlIueUujDzAD534N5tZ8mDW4blHhJpXzHTxN6lJanOKINjR3H/
4XXUdN/BfsW5qwsDTfzdsXSu8f7FmTQgBz56+CldBtxSxsKFY7feJQTo++mv
qRAwEXjB3NnVDkt9Fd+ThlvrRaZC4INHp0KAH7Ay2tlu2fCQUugWHzyzhMCG
MlLuaGevP6udPzpcQmJrW55fbpuqHM7/R378dZtOJQTO7EBOrBGCICvjEBth
qOJk5kC05ECJ9ZkUzkl0iECuS5aDpLfKljNCxzk1Kit/1DO83dQ5hqt9j39p
ZprRxJNiE+iIkcz/Jk/IAiOO+JktpJwEK1kYwYx0ssase/LK+cRHI3IMeX6z
e5Tt+kQi5ZMn03FW1CfCWva0Z8euY57jumT6UjdyCzddozwWT7J+qS+lnbnB
5GxPZLQsmOKf46VycJR1pL6Zg2HlTONhidd6Vm9+MjMx213D8iFTk1PX8ews
5ihllQSZ4ZOMcS6ZXCn4OGbKSZbB7LAquXDK+C+bZ1N7/+5n3thGc3OlZFe6
1v/ZxW9vy6VwGfvXj5fbB4dzZ0Nsk+70M/op5v+8dCQjdG8s2VCEXmPQT/gC
XS78fJ1bnhvPz2z/vzh2v3b9sK7dPt480/7jfskLt+1lW9TtVwwW5hwYL7a9
dZe/kiWjWYDf7X3qb72/un36/+VV2ecWK4mcGyY72jVj64POH9vKd4/RNMvJ
7G9klKBkxc665fTyTg4PO9p9h31lTRxhGEx9gUn7pcVHtF87cke7uCr24Lkj
8zPB8JNLT10VE1NbYX3bN1lu3zZc19679MJ2x9aHtm1zS31r3vOH27uI+ImL
3zATG5t6oMWluU3ttcOr2+3bHtM2l331jM3PaJvLPrhgy3nt7PIdNpe42Dy3
tZ21snIqMTEC35LClFSynbD4s1QtGWkyS5AsIIYKM/lP0VKYUVIIgBxJIhaj
ISQjJ8iMbIejzJGT6V2e+Gys7rrVUDhkFtllgMz4nXJjqif4hPOUGDIllAv5
llnyCAnPVAYjgNxj/Rort3qdMlVvJrxykyBNGd5X3Qkq9VD/xM1SfrKVkJcZ
GCELtZ/z2i+r8HlSGRQ0gZnEqUkhmKj02tO6W4JvtkJxmGapOae3TdL/2Z74
Z3/2Zz1UjPbSf+qjb7LKmsevDMKXoaCtKP4YeREEvAgCQltkFaVjSchJaBBG
zhGi1vmuWb3/tWTE1FxdZzlKWz9vae1Ce9NwfTcUdpc3YKntv9x26biLh/nu
hG+fm6wO2f35FQ9aHcV/QBGgSD+j/PT/8hZKeW9uV4+tKSAgNnY3Yf9koRlz
OFoq/rI5gmBSxJouGdhZn7vr78oB2l7chcX7qux/VeX4+4Nh26j9ZdkMU4B9
8Yr7t88OZ1VB/h+3cybr22tKgn362K31Xr83XFrGEIvi4eMz21t23bdUerl2
Rarrx+Yzt1rY0Msxukhq7J9YR7iuXVhS42XDg4epbNjXZcO/Ovz81eGD7SVd
njXc2t5ZPj/Z8GMHXt7lxKaSAWdO9rZXLT6jvf/Aa7qMYF6cNz8dNyAbHrL7
AW1lfk+7cdeD6nOlh5PjWyzMLfR5g3e+9o6NpzIhLulQBVM6DzTpazasY+AA
PiAfqKELUYBmWQsTOzvxD9EENVGA7nR/0sahNd+CmMkO81mMxK7X6fyswmNT
EFMC+YI00YVynuN5ubbH6S8ZMTysM8ZjsVyVWUcGKDDUIzCcZMgmfCw0N/7F
L36xD0IkmSk1TeoxN7y2wQCfcX24Odm8TEJEsmJN0kJrxlhZyaGEtZ5B4ia8
Jassm/LUWfNhNNaSWpkRxGCulWdlntfAirwVAlMxEwQsxuTkVWKSUPXWDKRe
WV6RALclJabZSbauZsuMAMhMhNmDWcb2fi6WRFXleAmxUwuH9W1nyecz58ph
G+9utxV9do3WtSeX4bO93OfZPN3qHN3Nw/LqIP9o5uV//uIHdGlxRqn8Hxp2
TkcQt3SH4qJi62vru6UDz6wHHiv5c1ZZBDtnK7e3lUF9z9G4vaKKeX1x8d8W
zz8xmDL6+8EuwSfU8VvKXPibo/euO0mFScmBbcYeyAPSYSoYJm3/eF17exG/
REL7T8cesdhlw6TLBvLgVxdvbB+/+Ake8aAq4OeH+xd1L+9LIqwdPrPMAME5
zB7uLOpnGeG7h8d2cfBji09pHzrygv59fUm0V3cTooRDGSARD28bntUePrqq
bbRTf/G89q5dL+uri+zwv3JLOawLZ7U7F1/bDte5KxaubCtlsJ2z4R7t4Pyh
Eknb2nyJh4XJ/ClFw3ScUGfDZQbtkqiSOQn7TNTkWktwu7jYuJYUHIkdnpCq
GTDLxDuzm9XhHLEQUz1paNznfmIHL9GfKIFl5m/VLbno0NxlWbdPwtQt09PT
ITvMVWpmGUgCQogNQOgowhPcjkEccEvmTb5lV4E3JNAIUMwk5AwjeiPUYT94
gyRqTaa6/5+xN4Gy6yruvXefc4eebo+aWkNraEktqeWWNXa35EGWJVmebRlP
4Hm25XmW59kGzxODbfCAsTEQEngQAiSBkIFAEkheFAJ833vJg0dIeEkgK8lj
yFqpr351zv/6io+4rbWu7u1zz9lnn313/etftWtXqcyn3JaMqip8MCoKh4Y3
gA6MKBINEKOztQqAjNEnuAOGAF5BYgRwBBCOwWdWXzhOuC8iKw+jiqngRMBl
q8BNngG3rvLkgIwYZEqtAvfg/pyvVRtWF1QZBWeDyp6ypddnzltBQ3cZZDC6
aJ6N14adK/Q4HLRHUC7774nQOS2fFZ77707tFjrIz9CKDuEDHFxn9QgTml+Y
F40IHjje6cIKpwq9/hU/6IjPi+1OFW5j345f+nVHhJ9HNRCX9pWj/un/Bl04
hewkjgqOB/aT8Q3VAIaqfcaBxi2VAIYAh4kdfgnoUI09CR9wdgM6BEJMnhQ+
EIKG1jjlP9e/c2SI19cnz3MYAicakVvv1rTdvjBxjb1QO9X5ymG2Ox3QzLVF
doAFlQHbki2z55acX650gwv1Ji5AIR5Ml9gR+YRj64CTLtZgyOjTZZt719qK
2lJ7epzEWv127oIzHBxnBR50t/U4a5oRq41u5PnPMe0aAz4zFf1D2MuMiRlz
20kTuowZjFkPRog5M5PQV6qFqYQySJpqFEABcA2wXqeC3YT6gQfgBLdGWhQz
h5TA2DkOrXApLgT9zFC3wBdqGKagpcFU1gLnFggxtxXbQFgRROBOzhIVLWlN
Isv5sBBVqcNNT35Iohm1Io/6RaAUwABYsPwCJQDWAAWApzWSQKF7QC6PCJhA
O1TZDvpBn2gPdY5Qopu/+93vxn0ZegQcUPje974XHgWMDLyGnPNP//RPsSfg
n//5nyMrLKG/tIO3gp8LSqBlBfS7qnIzFpwHlcJYAPA4h+cHDLiG1OwZK0E+
4ZTzjHUhPI6ADNyiDDHe5/d7S69DV7nUyM7BmV09dsqsyci5c2O2stzK227z
nWfjdgQdvlnfaH81siM+D2RVQoGLdYdOe3HJgbEcIQuh4j//EicDZ+c1l9Wa
m9pt9qPlS2pgQGkNuPzbzzau8/uDBFW3/cOECCT4p/oc+/HImPelsB5a4MDP
KqyHv5vaKXhIefn/TO/Vi2lFgEEW/+f2nU0nCir8r+L/kUq3XefKF2DI4v/c
vjZxnmDD78v/1SZkvOrU4TOje+wTg+yu8r8cEt6TjrWL0pRtzZfajKwr8m/O
q8ywo9IUdoHDxuB+sMFrs1MyPA+LqvODSpBwc3V91CaqG2zv4iutP+uzbe3b
bE11bQQp9LT1RMDCjql100PGspjoTH6FGSNoTGYlvdOmHW2QgacqESsTCM2j
5HwICO0gkAg02ICAI5TiCHgM0MAIEW3CwdHACCVCU4Q5E/5zcfATMCeoonMK
3GNK/IqGjs1ghecivuee9F2gAi7B5bXhCK0NLgEunKsKSAAMdgfuSjwO9JNz
0My49Fm/w4WPwOIRQXjRsAgi+AnucQ8+o6XBWACDezIuyjKN/cO4AhoqEMG7
SkrSBuP5/e9/P5YIAEmYAbgM08FW4DdgnNHqpKX+13/917AtVP5TZToRaFyN
MBJtmlRyEwBAu5W5jufBewPTAHD4js+AhFJt8hy4SrnWx8V/I/81fNJTWMX7
81Zsoqss53r5u46xo/IDfTZX7cz2kSK+p94aH9iMFP5cfY25GVCyiCJaYZ0L
wYysAIIVbVnTYPjn1JGX9gIQ8i+NXvvFEJngfx6Vxb6byN7ZFtjxf+u99rPh
Rf5dwSTWO+zc5/0DP/yV2Y+HluUlfjzhLAinaCtWtOKHMAWf6qedErRiBfjx
jfrEfpjSih95+f8fjZ8Zlsmbx2qxj+H+dFTgB69fH7rQPj1yaTUgZJ5DwM7Y
ybV75hZbms+NQO8FTsVOTIfs56zg8wFu+GzON9iWvrUR5Mi+xudG77NV1WV2
TO9OO7m22w5v324rs7EIaKDGU2cZ5EgttI7p4KNYfVSovPJFK30HNAD9hF5V
DiFERFUYEGERaMwF5cBGDDDLyxCH0LVQCMQS8UYfI57oXYU1ATVAi9KKYKpA
UeAQzgcK6jESp6H2WYHH7xplIB1hQA9O5zZ8lgODW6nYK1KEVGFngBTQDCSZ
boEgSDOPia1RrsMElUD9k5gYVc+iI7TAJc4nhiteH2OQAcnVQjBSyrk8CpTC
yVwqdiZNxrBwb45zH+wieVXoI4hKjDEUA6qBW4DPoMdPf/rTsCtgelARpW9E
+nEwaas0f4Mc0AkQmWeGYtAui5igET+ZsumqwJpsECgXtAKbA5RUrLQCORU5
UdKzff57vBV6dJZuChKQNNo7Ypcfe5DYBfhn68+I9UK2Iy7I2lOxu6DTjh+Y
7/Qhd8GoBiYc6JTidj/+ZecEJzlkXFBtt58OzRcM/DB1xGkYG78YGy2Qo2Zf
IrNPW4kc9GBovv20MSiwWVWp2tMOEsBF4bKsOQFZbf/UWCBAMVj7eN5RDayo
teJHvErsqAZE1Oxb48cKNuJVQka1xIc/GDnNfnfwhP0YCFj6eDohwCGL/3N7
vX6WfX791eVf/D/brvdR6m/rtmfSHntt9GZ7pO9COy0dGtufgZCF+Ry7uP3Y
gI6FRdZReyDttT2L3xlFqE50RHp+w922tLLIrh++1KaqZDrtDbHK4Bt+J3yb
l519dOlzngY65jdtcKXPUkUTZQVC1JnryJDgBOgAYhB1hREhN8gPc5o5iXwi
44q3R8M5q8jBoVQU5URsRAIgJ6AMbBrygkJWNDYeijdDmIdCeeKFA9GwVCA6
WkoBiSAUiD1tKrAQkeSRaB+nnhKyADPABm1ggSCORS0P7tUX0IISBqYQHURL
CYG0LKOUvxANggwRWdDY4SBDvtxMV20augxKwE+0IVwJWZUHCo8BUouHAs5D
7NKf/umfBnoRr+RGRhGuNhL2B0ChHI04Mhh0fgicLFig/AD0FjpBs4rIgFbg
wOB6FXsGEHgCruUp6Q62CsACCEE7FH3B6mjL/udfaad0loGRj952QYQUXZoX
EcbsIS7zi+3nxfiKExCcm/Pygjoe71r4jdRjP0gsWRaMYIvjAZ7Kn4+tLBkE
aU3qgRFAB6//mMIRUlgsj/hrXV6cWXg0a/azteNNPOE17N/7fSqlD+Mn4xua
2LHXH2Jj3ln6MCr4M5rA4V2sl+6LVtCYlXfg1ky1kkt8eeikQA25Nkq0KLhE
zb44dU2TZvA6w5tYlM/OQAnv2wcHr7HXHSvAjAfSuY6cB9kstzZYIyUn6wmx
l8xRwkHwkfEbfOzm2PrKuD278m6HrkV2Yv24oBSVor6rkc0Fh2h/V2NaZlEN
mWDGqIgSOx9zwMKpoOoT847xoNqfMAVYhWIAIMMIgEIsgAZmH+1pzyTfufz7
kziwOFIq/z0CAjShcoEiZBuYQhUid8gn96cd7qEgZ1yU0ACoBpQCjCkLDhPO
Wq2yZd6NDSVMaSX/GB98BtbAEFyf3BeMADtwprjwZrGNZE7AEY8J6nEpwqOs
QGhzBAdtDSRIYwMbQAnCxuPL20l3QFYev1xaypDEtCZkkObhamxwYrET2eZW
EAWIBjjALk78LMAHodDkHMVkYMQZeQAaMMakoFsQAQgKIwiCiSSAYpiWfKf8
sbxzDd/TDiNPW+AGEMajcw3RU44nb4kNHaUPA0Yxo9ZlJ9VWRgTBiry39GF0
kpos/BjvcEFc4RY926OPy3vsRR/20UrdnusMj0OlXJQ4wAnGU4Vbwn4+tUEU
4b1+aCwr8CAr7ZFfjK1oosVdoEpebaLJzyY3NJEBl8inElEWxS1+MrE5YOEM
l3zviQyTv9u4XYhQLohWbN/IEfbNxhbBQb30TPxO41j7w7EzAgnYHvFs2u19
AAqq9rm1V9rHGue0woA3Dg7k9r76lfbJidvjrwIb+u3udJbV22rxWp4vshvT
ZcEXXth4j22o+ljWR+y+vhvd8upwvOgvcaAScdTwBDftpjcvnglBYuIrr7xK
7yj9PtMQIIA3K/UvAoSWg4+jyOEQcOWyWFZoP1x3+OyVoU/VvBF8pADhVpoU
zkE48VRwX4QT/qFCcpgYCD2qDUlDTDhP+fA5Lk8IQICNoXrIkBEEHDIB2Kgi
plYdlTaUe2IOMR60AfdBUrHWGR/6ijkEmLEKiUjwLFzPOfSFZ0cMEWXO4ZkQ
LVQ144oY8qy0pXTEACnjzT1Q06qkgQijkmEMqH9En13OrGngpUDciKhm9Rb2
wGfOBSqwExBXBaUitowT9+U5eW6gRWQJlyYeEewW7Y4AIqAJCpzkt1RaYyiH
lkj9Xvv8/LeyL4QGp5+w1dY4GybAcHnOeuXSEg2qkWG02/9iw9S9zhr+PC1s
2v/ESb/ivPJfNk0lqfElodVrb/ocRkaaa5rv8e/xO+yHCc4df97oD0xgYfHk
vNbEhLh+bFW01dPGUkt/uRaasy4qPHDhL/rz9TUH4Top2UFhWNyWFhKBGa8H
B517xi6GYWqnr/DL73WBF0XghUviaxvPLTEFgKjYbwxfHK6IEhyqgQMz7RMb
bg18gCPwIofaO9NxNtk7HvmmVmcr7I50jX1444N2QvUIW1MZC/nvdlski3iu
IjoRfMDt8PhdF05vOxwfcoA6YB7jOmAeoELKYOBm6n/kSKVEmO/YEKxKoNBV
U0O7n5jv8hpC5pFTZJ5rwRKIvbYs8B2yj/ZEbvlexX5YFeEcZBy5pj3OARfw
OygjJ/MUGs214IeCuMEW7gNeQCDoo/ZpCtsgOzB6nk9xS/SfJQslWSHoEDlh
bDjOMXLBFhvKDg8ZQ/54IZuyEkSaZBUwruAILIHxw+AAe6HveBBZqkDm8TEQ
8YDVgNcUux9VzTPDNlR5Ehxh/ZPPMBGCSIh74hxUOpgOdcD4wX5TsgmMKXAM
OdcmSWLIMCHAAG2soQ2uBSfkg2CuYDrIpPBrWr2Wb0ETOm1uT5/d1ndwAIMy
mD7odAF6sMDNhFkuHf9raG2lpOlEPBLIFKuTazcVxkOHk+M8vJVNZ8LwQhft
nvhMmMOpQQOAg4r9Yu3qgIKd/ltd21YLWpHZTwfnYPC7kHzLFXDhbyiowbr2
TjvU27nNb3l26sltIrXn7OsIB0Hm5CUvN9sWC/FEVa7Ku5uv9kSO8UZRNSx3
e6ZDAZflheRsrkZwRE8GtgzmXS6leGJWplnN19a01M6vT9lpjXU+CgO1gIgZ
9urIjfbS0HVNeLgonR5Vc98zdrVtrq6LTGsbnGZ+aPx+B6Ud/oSdNjMfDHMh
D6duJRY0InpsoHdadOhvcmJmCBwXDceMRVLkQVMly9ZiBEgYbID03FlsMl4Q
XkCkGQlgrQCpVBlaEABpVWkupJ9zoescQyMLNeRlhF0g8aAPJgNIg6TBXOiT
83O/t+OaD7jyhCD93KvYPE4xvwIhVGSAkcCdoQSBPDvPi3bnmfFiYvIIGegD
qKCwZRAUhoR5o/RTjBkaWiHKvKOZtSZEO3g2y9woGQ9A0i8/TS4DBA6BUsIE
wrgQQIIf2YiOkAIwAACu0Awo8kfjZ1N6V6VMxo5AkCEgDAs+BQgI9+Bd27I4
l2voKu3Tde7BOQAw/fiHf/iH5rKVqg0DLnJakl9tmtip9nJhg9SK9dhzcKR9
bM0ZEZg0Vullo3NEIz1J8T03un8wdlCqlAq6USjx0m/4z4OLFe9InMNfe9Nv
+gsqbhGsD4hgB9OlebVauhb+Y+JAm2rLWQMpwyJquCViJuBzvMibwV2xqa2W
YUn415UyjJoNI2va6hGGvSNv5MReU91gyJv9oFs3bBklurKjXLfAiHikMmFf
myBeuvA6ggQfnnuOPTkXdXJr2u7Ao9AIvbbkiyNMwhHDelNXXMPmSyIrF+Qz
bVmaa8ekifAqPNe4yj46tlfwkIp6oY2o7nvn4OW2Nl/l0Ntru7oOiQ3cvf5Z
0ABzEDxUs8r07OHYmOdoCRVF0L5mtBsaHSwAJ+SdBB8USc35SjUAe+c8NCNt
wLqRScx2XIIwfJgCWh03Idqc75FVjmGdoPnBFAUzgCFcxzlKY6YiCGAJuAEL
YJKrEAIYBw7RPnhFv7iedmEV4AyYBH7RVywH8EGJBWEuPCPPBFvhWhiDctJQ
t6woD76jmTUFAVO+eRUVAcNgB6pLjaZFcBF22AYCiUVAwANAAXtgXRUtThsI
KZqcdnEo/uhHPwrWgLDjeOBeYjtgpQIfcAziiKAtrWbg51AFMvqBFYGAlxmS
Ays5RxtNAQNYCI4LAkZ+/OMfB1jhvAB4+H3BUxibj3vrqsWvZA/tZcWT0446
JBIVwR6WVPqNspzXZAuy0lSHkSOJEbA0tTMv45WIlvofaaDpC/zJ+IYkmKj7
vP5hCRNyNPxsfHUEQ9yW8iJoyqH45/VuG3NNdV5pdBA2xTnL3fiAjXSVYVfs
AmOB5Ki8PYIpbk9sHSlcDz8o+3CUP8mZlT773+OHloZGJa6NWKr1J+CAlD8S
WkRYJYbEH689236ncVySB6JltSKcj6/Xzyo9EAtkWITX8dllexyWTogViqOc
bi3L58VKRYFfmdW9ndltM5wgHaw6pfZE4xZ7YfQeCg/bYNbvmNPjULyi6XXQ
e7X0Rn79s497v6bBig0hPyrwhZxofR3WrGSrWrXQ5mnhBnoW+VFMhXZtwD+U
F0ruPfAADAAvwAHFdapQGMewLOALeDBoV9ureFdpUPoLJiG7xEWAAbRBX51L
ZEzitCroiVYwEHlgiMejCSBGEEV3uAXQyKNiIPCIiJ8MHoV9qZA2ECF4AGIg
5UAVxgg7IIEEqBe0Q4s6iDLfE7vEIikxUK+//npGvEcaiv0TSCqjzvop65DY
N3B/UJzTQRmknPOIvwRdQANtzEKSsUWIFYWicC1dLhNf+rTyDqfZgRC4JkE0
uiSkEJLQF6o1aC2XpQwoBJneiPaGgsgvQ0hVS4rGX4kU9RIpcEfWK9VIfXam
m8lV5wlXdyzJS7k63qk0HkiQ4m/qy+37o1uaPgimbwkVTZj4l9JfWBB/YGIG
JoStckh4PnIz1GKF4lS/4hCHACBhwGcEBsaQv7NyQSgWKx4vx4pC3f6mgJ24
30+mDqqX9kfpgohuOULUSxATQPD6q9Ej7ZuNzWXQZa01GiJesVIxeroWLqhx
epcf1soE3ofPjO7RwkXraiYvuMMrw9dXwuLocYi5JHI6T1TX2MLq3ICMPu/f
ch+6UypH20cmHogiNYRKzcuHnJL0QyEyMMJHRIbH3itOmR4hdoY0qsII01oZ
HJgTaCxEAXTgPEVJIkqIWJmhpBltjYQj6UIB/HGIGL4ELAttuMYvoZJDIALi
rHAJ7kN72kSJuNKGUqiDMlxL25zHtTANrBo0K/1Gbpj/oAjfYWXQJ3wPsAiu
0WKLdl5AzeVTdHkpUrCtikdSkYlyX3rT2IK4KIQZA4tuocRR6BAULVqCFBAE
XI2IGElWCFiC3SvcGfcg4k2AGAANcSDVFVAAueN6rgM6QCNchFgmHHfYyCKq
aVF0CS6AUYIRQ/fgVow4o4L+V/ErUEVF1PiMMYFnFATBIwIysE+EXW7yiDC6
nA/X4T5vw9iol//ffd0ZsZa5Khu01fmAa8Ueu9Y1pyvg0t/XblM+/S9u62su
FH5veEOI5cccRGe0ZQqOJFjyc7MXshur5BANe8UFC0/EZBvuuTZXlsnN/hTO
ynPKsOwv+vf/nUUN1yyPDwwW/owWAPqXKW3UqDZRQYD1d5sOL9cya5GF5vMu
gYKH/z60jVWLamlzkInyCp87rZEOOCW/PnV+S6xl3hprWUY65OIV+0VEEDTV
aOso1zOK/z85eXvYHW+uagxEZriT01HBJz40do9dMfgu29o2GZvE4Q/zslk+
ZDMci48Je0S8ohoZ4bJAjXcevW1a0MiDCpTblPw6hwf/7bTFCCGEPkMrEDgk
xkGjSK9YCVlUglPHg2KDVVGxDNHmKxkWKvSArEESVKwJEVaVMs6FiPAOhHAO
19G8jBPgR84T1QXXkkGZla6Z5wxij+wiNBgstM29BW88lfpHX2AMyn/BPYBQ
ZJ57yRWpXLL8zcgglMp6yb0wGlDFPCsqGhbBhiwED0LPsgOCidDyDmagpmEj
hEURSKka4ixh4JrEBYkKV8EkcMVVf4aV4JY9MILnU8nhYQpAF4ujwJAKTNA9
PnOe6mmArDwCNpEioYj35DFU+IEcXTAKHovbgxucV9bM2OeP+TZYRZdNrl4R
/r1DXQ+iaEkCg2fizwcPiTVCpG/Mj90WuFCuKU7ssKfSLFucVcrlx067sneG
T3O2mVdsThmFOeLvJztFIBJzoX9+cHBA0doABEHcP5vc0Ny30fOm44PVkmqJ
RWWcw/6B2sW2z/2CL1sDLRVUyRMQANEafKktX61AQaClGyL7AcqiSm8EYxfr
GwWx+MTgefab41c0eccTboTUUqVY7aiFbVKuhMaLyu670qF56a54ddMD9tTg
bXZnutrWOblhaQeImJPNjrhKoEKLHgvTQpvXP2t6grGkGfyEJGFWaDMTyp9j
SArSwTloWiRbZEELGShyCIU2fHNcOzshIarXiHQh+ZyD24H7oPq8jYyOOCjT
LLAEt1DmNvQ/t0TItQYB6ABlKHEEHkFmtoNfcB88MEq4qJKKKmsMkNEtoI9H
UkQ5oMK96RZtoIlR6lrn5Xi5zlsUvtvedARoSRF5RnCh8JgMGPl4DhEejiFs
HEMIwQFCJHEuQG8QPhQ53kMEHhDge85FuQMAKH/uB//A1ABXwBQwiWt4bKwi
zBKuZ0sYDgnlmwT7AAo4EXQKrOUdvFX+btrCDFHOGi2lACCYLnwGB+mHk5Lp
8kjWyjkoC4R6TIWU1KnEpO0RzW0Ri/MOezLNKj2aXXb30Eh4ENhycZWbB5va
ahG+EHH7LvQLUhbREV9O9XJZk+jJSpghvxgbLT0WlTBDbi3OsJ9NrNcuj1bc
KLGjucujDLDcP0q7BTwEKL1tFftEGiu9LoUN8u3Jk5oEhFcJHLJBCLVUuASv
kbzPzk2b6iVgfGHj1fZGGTER4VhARCUCpgiwxL25PW2pBDR02yP1vfba1AN2
avvRNttZxI3pGjssP9g6nJVgbxR5ZVk9mmO1vDotKnSGmMFrtdEKp6HSvKJP
kWT/LkOWvCWkpUyZ7oNCcqh7QzqRGCRHIZGKqOQ7mlOANbdASpFe/Ix8Vya0
jXaRXgBJxZoAHaRXvgn+ViFYpjHTWhEJSrsEIGFNINWse6AzZbXwmAAhKAMI
ghI4KuiPCjjRJx4d1f2f//mfAYg8F/fSnjeGTJuguDfiCBXAL0kUA6YHMFHm
hw+9jFeBaxB9dDt6mc1aiLq8AEAJMgXnh05AP/A3ch/lfKRdIIBrWbggVQzw
wGIHq8JKA6tUXfgjMWXwqypnOI4X4EGhb/xecAwWVeAH2CjADd4P0JVVWeAA
iIKewSOwVbzv+/w+b8khaiWT+NLHH4qAocMq8xSA7Nq4gjZuauK/Hj8ucr6z
kFAIXXcYHae4XuzNinVLN0B80rdHKLaWSNlmscq//9na8WrJE6AYT7MY2ugn
MkIbOVrRgZXTN8Mwa4EyX019TYjAvvnJ+IZftZej8l/EYpdbRLUr9NsTu5vA
sMtNg135AhfTglN8rTBDbNxBaXc6QCESIg+sdFyTducsbZABIy0LNNBrluNI
e1aznsRSS18k0qmU/lS93JAojvj/ggbS1b0daLg+eCfyw1yCTzLvmMPMReYa
MoDM4bVAtSAHnIe8qWAZcwQ5VLkH5iRzhzmNd0OFzdHO4ACaX7smkEUYAP5H
jrP+gLMRM0HJ4KH7EAxkF22PHCOvqEGIiNZE5bvkWOz8cTyh76hs5FrrKcoX
CwZwLXKifWxgglJAYQ4Q28wx2mcsGCecljAUnplIBMaLQEbcCkQrsHiJfY+s
cX8FPaL2wQjUPXKPLYBa53pUOOYG1//bv/1b0AvaAWfAAVS1PIrIJr4E3BX8
LXPExz0r9vDiTpkfbSqqQ3u6wAaeg99FmMZvC1WA9oBdrLHQHrii+sC0A90B
m6A22CXs53IaMT1dqNlFpxcBM8fni9g0HSIRwQJIUEdYGL3O2U8m6N6lntIS
bMjEJ7DB5eKIWmczuBHmQGaYnzYGiYxQ7FO5pFFEVo8uZUmjjK5uBke8GVBR
XKoVkTJ8cr/dGSUqNFGi3CKqTeKtiFCiQVIeiW+NHY3/Mrywh+VztRD6h2Pv
soNqQ7Y1I1jsjDj1OKcZColYlA8U0RKVWPtktNht4XZDzoKGc6epfLXjy0Tz
dX46xja77bCobb490HOT3Td8je1dcIk90H+j349g646wIe5Ie+3ItNPxo1gK
BSUIthzJF9vMyuD0dkXhjVPApFgyU1L1CKEATC1UipLKAyEya5mKqsuOWUtb
TGfUmIJ0eAceCLLCkQgUAAsKi4AiaGkDOAEmoAHQBd6BEuVxFYVRuVgggXaB
AZXCRfRhQjw1Xg7UPn3Qsi6Qw/3KsrXkSNu1y38woEkZ6FHLik/gfIWQ8A4N
kcmPR4CFBERae69R7cAAbagoKwYKYse4Itb8DcziGoSqoOaBPmCI4ClgB/ej
1DiQxHf055Of/KT32e2PtDR+EwVOASmczzHug3grGYTojlQCDmne+X20T0Nl
bYALIA2oEHQAK8wH7s9z0hbP7+3t8znwdqBi/sBgxElQ8xVH3gu9hxFokJVM
/NI0z0WlM9yCU/5OjOUXSRZRkPdLIml0O0sOzRBLIUbYCsOLCJMsPZn7w0ZA
x8Y1zU0ZZXjlfpsyyo1dvxx6rVvFzvLRNa2QkcQlhBlLvHsPpMVFBHbd/nJ4
u13avSjKawKLlN/g2c+OzBjjEcK5qNITKal45eVa7MzUyLytmRFSPt/R5sB4
nZWm2Oh+ZGwhPzmy0MxwFL04nWAvDu+1T0zcxb5P7ypbyHO7KB3vaNsTaJGX
GzQ+MHKPvTr1kD27+vZIRIU/Yn4+zw5oWx3+CPADNybGSHtWnxY+as2SijBx
RBzxdFaQoYrSlvATIqUqRIv0MNNQtEg0M4jPEFyINJLLDAU9QCMt5aHYUNZI
IgocxY4Esz8ChQ+BgHRwTOjAu8o3K78t7gottWA4KISSz7SpajqgnDaXQyDo
P/0CRegj/aB9ZaMgmLLYbHV8SB9BC/gBQCMV6oaEQGy4HoWNdPF8oAz3BRWQ
Op4V5U/wA74DjAkIAYYH/WLN4gc/+EEQD8gCCxQQFFBHeS1pSyHStKVS1OXu
iPBdYCzwrCAF98dQgMSAAJxP/1QEi+/oM4gPIoAYkEGMDRYw+My1kB7Qjr/5
bUE8BYaARvQL5OAZmQds/XTS+TYMEPLF9rtG7m7GFdyyaLPNcgq90Sc5bsG1
OZOd/ZSZfWXlJoViEg+JXyIiKMbW5r8COgI+1h/YDKQo46z2j86eXNuEkl+O
zo7I7HpvtENgxfNO6kVq2AjKhtBvupnQntraW7yrZRq70npq2JcdHxSgzRIO
rohFeRclsK09SnIVAU5EklDwbiyn3NKpaYVLK+Ww7kkHx+uNdJxdlkgEMRBp
sT+76fr2yHBXt8Utm8R5PVO/1j628U57dfTWMmVN4dRlFweQUezsqtuhacqG
KrMikzYEY3s63HZUDmfRtFjxiHgwgKNujax7euJxcyAH7izFTiFSiCkcHdFH
wfIZhc3finGCoAAFyi2FElMhd+0SQVRVFIspDDnBToassGTIOYgjdoj2QoJe
tKH4RqWD5TjnQFzwfwBbylcHNBAswVMCJRAhpjliwcoqthDwxHH5NxAniAyI
yX3oCzCADwG/wk9+8pNmKTxEiwUhIJJnZLxoF/FD3BFnxgARx/YAQukHIo1L
EZ8E7ZMbgt0X9AuxJI6KseEaIiIQN8SeMaYvfMYHgr2AWHMN4824Qw6BDhW3
xq8BrGEXihx84QtfyOi8G7oglup48fMg9YoR4TFAKW7HbZTbjp8YU4jjoBlm
KV1gCBSQTuLLaZZMq2UE99989UO2sbHIBrJ2n+IT9nJyi9E/ExF9Ydvc/TwY
bBj/SueIfW9obdOV2IIgRaymMETZaJoYMrl+v6x1p/4Shvy83mW/wIJxDLnB
zzk8ryb5O362cV20UW4o1+aOgI/hFWUAR2GisCpDn45zfJhw2e9swxboaav6
34XfoC2q+/A6rW2hd2URJbtjs/zdblWwfExm3M8NndFeJtj/gOMpeKbMlyVs
1MqkuevSsB2SHxgAUcBEXyvnCCghJPOGdJntTkfGJlAeeHm+xE5yW+budGNE
dw9lcxyyZwIbFM+pltGbeYkU06LGMyF9Sq2kPRlIJR5BefaU3BKEQRoU6ag6
WUwf3ksFFAoaxKBNph3kA6lhqnEtZIHPXM9x7otEIumKwqJPSAfmEvdnevOO
4tM+LqLHFDmNJHOt8ujyDDKhQAdMGtZYuDcIyfOo/Dt0H4TA5MCzB0nAs/CL
X/wi8tUiRpg63BvUkekCuig/HO0wPkrYz/jQZ0SOqAWuZZwgCrQJeYMkqLAv
JEQJsEEpno+FVMwPng1UAREYI8wlxhtSAToQqIFJAxoBCZAEroEcqNoO99ZW
chU3ZWxUNEFVNyBFPBPngmr0lz5qoUV71Pi9+I0ctfb5bzg9bLSHw3NNz/xQ
vYc7kvW1kch2ho1Wugl1zEunQCBGWkAoFhEOWSmkrbSjpB5J20B+GTdwZP7M
Vcmv3AYyONN+7q9yH3lNsZ5TGwQVZaxFbzg4H+iZGc2DC2xjxxtbK9IJxD4V
qgGckM9wq2GOjfg5O6tz7aMzt/mNi01uqrTzqfo77CtTl5FFO9XLijvVCJt4
V0vq7FxA0ZJ1P3eCsc6WulUBTtTi/94gGqfNOywsjsVpoa3JV9tZvSfZIyN7
7YWxB+yVTQ+FZbJx4ICwRLalrVZtq8YWUYVkAZb81bpa9V9CRXc4JVGOWP+q
Ic20xibAPtA2T8RsyZIleeSbur+ZD4rT4B+qOUUzzDIlX2XWKxcUhjuSCsdg
liIZSBncRcXnaQ9LidkLqmBuyAyiO6xxIPn8jX9TQZFIDuhDn1QoE8nlkeAw
mDTcl888MvdGb+OAIKEcpgPOhn/8x3+Mv0EO/J/aNA06IWFIJ0uccAhQA0SQ
owNJRcqQJJUYR9djfmBO4MDATFGOXnyPmAugISYgqMcxpBgnAigDCqLUaRcn
CTyC8xhr/Ms4NPgO1IF/yXSkfcZcY8xPyvMzxjyTQlL4nTBF4H8qGwiygDwg
qPKW8dxwGYgI2oDfxa/f58//lmaJYOLFx5yPdo6ElG12vfe6z1ysfPZUfWfy
JMFEuSxSxHhP7pRX40Muh3Pb8hYPZQUPRxM2wvnfsvPrev9zey5wKPeBOKV4
rFIHHspYrF7b3NHhoFWNRDfsAVnqWECNn1rpY6D61wF5RzhbLqzNc7keiUq9
v5fGy+J8lSjUQbLPrzR22Z9tcq4ARNRaS/HFy2mE/e74hbUSJahFeqsjCFhQ
1OaotaJEvK5OO0ggoSSZV6aTnWKMRg5tBHxJToXxBvlnvAmSZNYibRXpq8Yr
qyMTHkAykA1EHEWTRmRvj0Z0h5Ch8pmgCBmTCFXBBFJyOAQS9exCF06GlDeD
oknjUFTgXNxMZIuWRh6YuzAJ3pEbmmZO4S5QqW756JWXBVygXdgM81i5p2Ea
wJNSbtMdui48QmO7feJ98aPprMAucEA7t1X6GxwTnoBZyAZyi6MRJyUMgg1R
rE0wBMgLw4FWL+tPxTG0Ohoezc7wEYr57//+75HwgfaQD2wDMBD54hqYBnYI
8As+ELrJZ1iKHIngKhjHddqvBw6pVLpqZeEUZWzBA+w7tDztyDCgT62R14qx
grEo/Q7nMv5gOOcr/Qd/gxewH347fkv6D0YxZuAg2MVv5f3a5zg+PYvI7cG9
50SC2CJHUrF0eLWTcbZfsqz4rbGjFbbZChG8frD2sHjfL2yzApMIaCi3gCiW
AidEua28cFM4R/+DFSM2ry2LqE6+2+HnTbYV21MHy/gtfH4rvYMnR264AXvc
EenDaT5VfPIy7T9E4pnKMvvOhuNTvazc+bQDxqy29ma1nj8dP92B4ohaWbGv
pVJvUsW+0ubY79j8OG9riRP837sfWtBDrIuj0lSkp+r0W5J2ZiIfd6p0gj2Q
ron0+4e5XefWRgSD3OJjud0BijIdZ6R3Rjr+7ozF31F5OQUbykbztihFTyxU
aA8pbk1ki/kJF2AuoTfxDeATQKeXezUyhDsVAUxK3IAqR0QRZ5pEZSksmM+o
T6Y005gmgQIt9Sk0Q4V3Uft4MRX9CdTQVQwTtpwCCxgYQAzuDG3epn15aLkO
WgHdULI7oATxQAyVlw8VippEbQIRUA2yymb4INPRIaaoVSgB32vLFyqe99Zc
TtASoIPIJSACUaZdIETrR4gzVAD3CBCjCCeogPIGCm4wLCD/QIjSHCPK9AfY
4hqeHeigP7gvEGvawE9B/6APiLmojiq04bbRs3MOY6ckJNyPZ+E5oBFQIWgH
0IO3Wh5qb6c1CustaEXDjts2afOy3mKXUrmu+mja5Gqz2gyWZi2Sz/uHXFTs
bxurcGD8MnCEL2FombaYaj/IawuHI7z7U35K614QPJksgrA1jM1gizKK9bTb
JW29dpODC+UCywqgUQBki9tF/2t8W73M+b0y77Rb3C4q04MLN3BOkH9LuEEO
rj8ZP61a4gbpuNj7UtTwKTCi1RbJymNlVZ/SrVn8f07aYmvqww6MxFV0BY04
Nm1zznR+FAS8IfV7R093/OgCJeyGtCfKdVDl986uvfahTQ/bCXN2OQ2ZaZW2
SoRlpSgbUmtuLsUemZZfXByKHTBQcJWkFNLKjEL6mFHaaM1MRhKZKSCENo8i
sbSBawHnKEFXrCkw45h9clSi3HBsMrNVEpz7QAC0vQl3A2jDPZmNoBFPgNGB
BGBggBasoSitJOQD9GEmcw731JYTbCfuX25Yj+flfpyDFINmSJyK3GLe0z8k
lbULxVtDMEA9SAZeQKSc4yAAz6aiu6ACQMtzaXM60sb5CobgHNqA5OPI5DjX
cB5jzApNsfttrJlGCAVP+4yzsllxb5CK7+gbpEDZyrXplGfjmXlXGiK+Y/xB
Lu4LYkJkuJb7g6wgutL+ozSUVhQE15YfH/O3iRS5LV8w11XhxpJh/O7gCa7T
WpEigjY3FoFMFMh4f5otzyY+i49XFwAS5YLFYCxyahP6d2KtsRoLIuINHaE8
29xqqbgVX7fT3c65NpL5D9jHXXq/6ZCAkP/NukNcboo6Yi+lmTanrap6QrWy
/CDlhJR7j9d31h5nf9GYrJaVBPrLPBsFMhT/f2PyLPtyfUf8perA56UlrIWU
rsyiUuBnB0+3L629OAyUo52qrMsXlv6J3vBh4KOgvsdAXvhM52aDtr1tvQ9a
j52SjrTH6jfZy2N3R5XA1yfvi89+LKmEKN7O7emQwJJzB99pH1z/cNT1eEc6
KXL335zuDHLR48CozSHaKJKnfFoIeSgUB2Kr2r9AAfYD0wUSgOJC3JSxVZss
EQ2txApCmFJ8BkYgCdyVcyAa2Blcp1grpiFkQVXHgArO5R6IidLsMWXpG98r
9wRtENQBTCmbLEoYuAB24EqcQx8hMdwbSFTWLmWeAmKAChQ0oswiAGIEAQLq
sH1YXkUZI2J8j5JHaUvhA4fADNcjjqr0xfUKVFFwC2IOfHAcWIBkaBsZxES5
NJQgQnYLfQIesBsQa+wO+g/kKTGF6oRjS0COgDR+T6CCfjH2WhyRZ5px4R5K
eIcHFkjU+o1DccbDp85m6k6lNYdywi39Z9zniDO9iVK3M47ealfPOdy6XEJf
9jkN3Xhf2kxsRnM/xV+vPT4qe7wnSnqDHgMR9tCy6dRecHFmHwf+hhWVekR7
5uXecogDlcNEHH7LZY88Gf8wNln7pYrif7/psCZw0HyzENnErmppkFzsmnzK
LQdwQnVH/mp4m/3l0Nbyr+J/wklY+QAnKqX74o+GT7SvjZ7cJCBlveGOAI7O
MFLuGNxqAy7YR6XxWDHtzbrCuYBT80hH1iuI63wqXcEWrrTKsWVloELBMWr2
zOAtgRfvXnNF8IhDsoPtwb67MgwRpyVAxFBljtOSW+20RSf4c88IelFP7c19
6Qx8/naoxsqm/GIgMJeRWeVHUK5+5leZ06Ypc9AP1DeyzPcqy4uMKNUlmIF8
o7KZ+6gvJhgUhe+1J13YpNJhUAboATjiGJGKhLHF9ZyDz5L+EQjGVjMFbils
A7+pclQoIAtZAG804WkfaqUCH8gesggVAcO4BvlHLWvhERqCn1FjplAT5Bfa
gH8DvAB3UN/IGjQGvIEO0RdkFtlWVVblyYeGcFzFOugvuISPgiAv1QgHf6AN
XM89uCdyD2bI14pRRVvyVyhkhO/LkvHNGHDuTxvQHQworQMrpwXXcBz/BvhJ
//gd+N1Y//bn2udtvw2qUSDF9SM7m0hBFBepZVMz4jO3vxh0nVHrDqRQDHiZ
kypWJeAOiDozmlR6G/Ou8DtQM2iOmxiPDy2plaUFsTq+2bXI/n5kXVlasKgp
+rTTjChUPn5QUX60GnGlv5UWvgkWU0emSokWz6e5kYunFRn+ojFl3x47cj8E
2ew9ZL20WAkp0AKu8Y2ps5poAbN5Ix1X0Iz2CLOYcCtrnoMRCfnb/cKp2pjt
Tgc7KTq5XqLE1S7yeC3eRImqI+XFtrAyLzJfLXQ7aVVOiVYgotsZzTk2qzLT
bui90R5dfb+f02UXpsut3lbARFau6JTejGlRYmFIOtqIma+tpcwCZZyC2DJT
QAncE6CJcr5xLsYHx5i5SLo0PseU9h8DB/RRPk2k3I2MVHhPVwQaaPMnjEJZ
LGgH6UJqQS7e0ZDMTv7Ge6k1UtXvBEWUYYbn4F1R3lzDd9pQisSggRkDjAak
Aa0qLV+mos0QEad+OEFZyoQQYPMAfmVGqAAaBZ7jVORvvlfmagQdwYW88B1C
DdBwW6UDUMkuPAe0hWDzPcQAIEZIAVv9LGh1gAiQwavAvfhpaB+AoV8IOtco
xzEgw7Ucg9BA5vgOYJBzk7aYDoCjypjRDn0Q0Mhr5Mf2eTtvGyT2dB/cBAk8
F2y9LOwTQKIrUmKd5jSgp42ioMW2TqYUy5OH5f2xPEmOuQ/3LUtS+pT+gD64
1CeVHV+Qkzlm0H44uML+fmh1JUCiahvb2uNUQOJ79ZG4pFKCChUK3+si+2Z9
Micgk0c2kYMXddGdndTKkqjfnTixaaOc6zC1MR9MxWrIYFAJKpX3ZnW3uraF
wXG/PzVGx4q2GcR9x5MRjHV4PmYXOYjc53DQyHia0+xDQzfYr03eaa+P3ZIE
FxgXlCUHKLLScQFcLMsXxdrHkdkOuzPdbLem68OguC3d4hBzVdQgvm/Z7XZv
4wFbVFlsh1V22LrBNXZgZSOwsV+kVkDF2/F6PhhyymRTpR6cCLyrEiaTCDbB
Z3Z18B3al0nEd8ghWl75+cELcAAZhknAOhTDwWRDUBAQvgMDOI/zYQY4LVSo
HO+rCpfTN+WzYOJzL9gB2IE3Vjk+FYQJe9BmdvCQyc51YIlyYoA1aG80J0KE
NYAgonFxXiikWjlI0eisrgIIKoiKAOLCVLUezledQTEAnBZofFZiuJYxgkGo
Pjxtcw3vCDtgQbtocu3k4nsABdCSo4JrYX/gJUJOv+mzcvjSjmJEYEIAEcKv
1SP+5h6wD8YI3Fc8DSBTpC3w0XSBpg9cxzgCTso+zvj7s+/ze70N8OixK846
NpJAzXYgIFaLGp1nu0Sid4mDjHeX7oOcls92gdlVn2mfSWOVUoXjCX25Z6n9
v40DSvVfsWNSw07NGwEEfzeysVIyhjXeGmVJHTGADvu7xlJvAPwgW1a37XTB
BT9aMEQljzd4B65zDlLgUgEh3994xH4QAqJ5x2rlWioQQhm0ctmkQI+OMD6u
qK+wbic+vS7Z9dgh3+EmxSI7KW2wG6I68Qvp/JSHJQKvACOyEimeH7zOfm2i
QI9KHGuP/BW4MFgWuSddYQdko+GmYKepI0Zu96bb/Lln5TPsiLTT5rgpct/I
7Q4i9/pQnWCzstn25IYHo2Dx+p71NpS7XdDWHRzkbQdqFYkpMPflRsDLCL3n
XYFUTGImDV5GvmPCMZF5R6AhEAAKJIXJrIQ2uBcAAMwUhBVQwJRgYiK0uCC0
X553zodgcD334X7aMopw0x98gsEAijqJhb8D5GGjCiciMSCTWAcdR22CVLAk
boDkYUegYjmOdLMwAKVAcpXMEvrAw6OOic8Qgkj9IsW0gTtSuWSEFLQBmiCZ
KmHAvUBOBp1+0TYPFn4Cfzq2TvjYaH8JYEDTgA3gRPOMOaSN2yO0kDmaLgO8
CjlfEHgCMUG+eWL4FTgFaYHAKJuovDnimtq9qpquTA2wh17yHU/DZ0bUu9ga
o/UWeNFhd17rU8zFrdOJRF9W4AO+QIqa39J+AEsNTT/h6c6D8Rp8e/yYVCnl
krT+dzsR+d7YVvt/6qsKaa66Bp8de0UR/v89OEYd41RIf82FptPOdTwBOAI8
RtYDHlnpxnjYB7u8NGXlJSV+NPHkHIek7XlPtbwbxZP95oEbsdaaRsp11tz+
evQIfKKliVXUJSDx8Ilpvq3xW83IOwM12EY3krvJ7tC1ubLMXl29p6MEjiPT
GrcuFgY8VOP/ziZwfHT8No40/RibvGkskqnKBqcnV1cDLBo2nlbbTB+mO/rv
DKDAd9GT9dreRTfaymy1baputt5Kny2ouxrPhxzDegsTZVqkuDMmLdKO5OKg
QAWjnlH9CBuqjCkEvVBIJzOVacgUU8E7UkMwJcsaOqF+oB7QA8wT2mX6gkZQ
GkwQ1fcBaWgXpIAu0DbSAuVgXYTvOZ+pqlVYwEBJI1F/WrWFVuAc0flCJegS
/VKxcdQxK4W8s/aB4wGwwCyhLYx6xEnhqTgAkVacE9AL9mfQB9rjHPg8/VC2
XOgFx5B2OQ04hrjSnjaKgwIlWASFop/aoK+yYoinNgjTBmMsBy7Prx2EfEaE
OV4GSsR12Eo4k/gtFPDi90sF2A7G+KiGEdDAMzEXoBwgOPfit1PwmYLI6LP3
fdo9JNWy+uDhB60xiul0+euU2kqtJs51tnH3jA0tqwqVEDK8BngK9g1vy0vA
wElwYdtA4WRYv1Pq/9OOLY1C3uP1g+F19v3GaFYyhutdUjc54QAistJI+dH4
ZvtBfVFgyNccb9pTWxI5aQWMd6cBwrVSTaXWxw8PtCgXWAug6IriRTc69SFc
dYkbAgADQjfYRmadBU4nVrvoHu62z4nehdfS6d7glWmzzfZzHSfs9aHL7TOT
N9krjYtrJXC8O50aUeEFryjg44Gu821t79JY3Di24wh7fOxWb+6Vqffk9tzY
g26oPDN8n9OP3WGM4Ku4Ot0UkLHUQenYxjF2Y/3O4BZ7Ri4JXtHIe2ywMujH
igQYjXrX9KixIyRXxSKUllcZo/gOpNBKHRKu2rzMaI4zW5XxCulWsQAUGrNX
u8I4h2tkXGCIgE58x/YOUAOOAudABUvxgV744bX2T59UEpk+M7NBNJVsVwC6
SvGo0Lj2rEI/kHjoAMYYNAPyjxTgxHCFWaYMHw00oS2kGgMGKqGsMJwv6582
lfZY22hwkzJ2ICb3RjLhZFAWeIICvkEIuAJjRjvKyqWkhvyNJGs7DkhWpDXf
s2ePT1d5U/jN+I24B+eL69FfkMbH269xIuYSwm/Md9xTW3W4lt+SvjMPQHZ4
Hr8XfZT2YOwZUxCM69m36sj4tlDj2fsvs20zxmxZ22w7rbFaqFEWCME/WKrm
SvCPP3Z9y2qEq+2s9CDgNTjIQabVPVlAR4eKojeh44djW0L++fwJv46dpnJs
/J/1hzR5R2d4U+aVmFEp7JvRSfujNBffSRGH0Wt/O7LFdlV69ytyxg6zXS6r
B7r8zcxJPlP0fFneH7tDjqqttDsq271z4EQ9Ir+fSmcGTvB6pXGJfXbqZnt1
8LKmeSKHxpsso+aMa1uYIyxvbMwPdDOnyy5K59aCVfTbusp4LJZe5pbKQrd4
tmU73MI5xQd2hd3deNA2pClbV9tkyyorbFvnEd5NH602FlX7osnFc+e8HYKB
+EAYEGWmBSYIih2xZGowdVBwTAvEmRyYiLhWJZne8FgUEcdR7KrPQxutPg1l
21CGSESQayEWqvujTBfAEiKOKcNuMmX+1qZUreDQb/wcXMe9gQfaR7HLUcj5
wI5gDItC0Y2IKX/jlCQsixVNRAeiwd4LRI3VA8KXEHGIAZYM4kcbcjoialgp
QIZ8tQpLQ3x553x8HFL8jAFjpRUZxJFnAmIgS1qR5Vq+0z2BDfrOMwHHwJay
jih5FufwrPSPPgNZRNAqI4lDlouIA4UTDPmUuA6/B7+pSsUCZ/qt+KwqCcwZ
Pvvv/DajwTvtq59+1MZmLHCbZJVN5PPsyxuKGISDXeKO8r9ZQ/iTsVNEMshI
9cm0MgTTzRKtROAlKOMlSh+lU4INO5rwMSur2G+k2aVJUrW/X39YEz5Ycf0f
aW4JGRX7PxNbAy6I/n4jzZLn1MkJ3pBAkT9MSwpnSXfwGOosE5oxtwJRquyH
DjtcTM/0Z7svbbEX067Mu3G8f73DL9viX/3a4Ln2hQ1Xtgdu4I7pcYTcHghR
KXHiMxtvtDeGr4i/sv/StdHh5OPisEp6sm6bk/H9sXaXc4n73PQYzZbawTkJ
wACSwXCELqjOswOr6+2GdI/tTQ/YBenKCBIfyufa7b33+FPdb12OP3fNv8c6
iCDt3Gwb6hPh0xhqmxtl2CfWjU4PKD2h72GyTDblk0DnKTybScMEZHIjnOjE
qNjn0u7jyjxnvnMql0EVtEeNOQkGIJ9l2s+MyZo2Nu0dtDVTWZtQ6Q1MAw+I
yoMhYrAdmkBEYRowHW4JAxFk0EulGGbqIxpy5fJkaNkyy0McVxZvxUex2Mg/
7BjciogiWp3gC5iHnBmsg8jxAdvBlfr+97/ff2wHC0dzzgO6gA4+A9FArYKz
eT5GkesVBALklstWWRSGXBRNgOR0k0sZUUZSa6cgBp9BAZZrCALFI8rjgDAK
/GQoQFfOZagZckwYug7iQK44FwLGY/N4PixFZFlXrKQwcvhYsNYAPn4NmvHf
cp+/vy1n6I+/9TFr1NrtptlHx6Zvgpr+W+PUWHVcnDWa8ZPUMuUzWfcfTUsy
+Rwndzc1fiW1ybeB7fC3o4cEkIy4TfJ0mtHkEP8wtT1AhODwzwMWhU/jR1Pb
bCyv2/1poAzNaNhfNRyH8pod7TN6k8srsRZ4aBEbUGN53hdJgU5OS4xQ60+t
PtOtAeCi5rbVQdbTFigRr98cvdQ+O3pprYSNNWnIjmxbE+BQ2CJd9hvj19uv
j10b9KPFoWGXpOOi9DlBnwfmq+3idE6invut3s6F6azwfAISWfxfHOt102RX
FdxyoPBHwfQ4LntHQMTmdIhtqx/h99jtgLfKZlfm2FTnQdbv4Dc/WxCb0n7n
jQemh4kiSJKJjKBC95nQ0FB0H8fgEwgjs5bvgQucE6qBjP5X7kslgeQzwo0w
wDc4BidAgBFQ3qHDTD9FM6mungACEECotEeWWc350GP6gNOEPtAvhBFQQO9z
LiaPdmghEdxTVJ/pjZPi8ccf9+F2Le0TjIgMAOOHP/yh/cd//EfsQmMXCBKD
BBKNwWecIAg37QE4SCTig5QRNcFnJZ9QPTB0uHZ1MS4ADY4R+iFugH7XeJUm
XLlmUY3j9FsOCwoPFYlL+uJecAbGhmdg7YZnVqS/gj6F1VorKe9b5B0djC7S
NF3ha8BFj0DTgBLDzM/MY9A8PzXDjV/Du/a2kvNRE/3Day8LNQ3d+MrEpfa4
k28XxKZD40/GTg2UWN3GRo+5cmh8Z8PxgRIsWHwpLcpLL8P/HFxn/3NooxOX
LiK+q6Uj4+8nD49ihy9ELq3CKDm7f5Ztychl0WdUBplMdb/p7Ly9jJmmUyw+
rm4bsHe5vXSzi++70ya/8nNpV+S0q3tnt9rvb7zYPts4uR4gUVQ1f9Kl+7Wo
BVQgwxc3XmWfdI5R/FX8f2Za5wRiZuBEe/xft4+PXGWPrTozlDsEgkQ4x6Uj
7bZ0nX8LOtRiJfXKdCm44HRtq/Vl/XZeuiILUOi19659wp6beMome6ZsUWW5
j0/Drk23OzTOsls7HnBuM88u778+1kUWZSOOfbNtRttMa9Q7py8/NKPpp+CX
Z+KitVkkRZurfgYTGUGEX6CNpcE5F8KgcCwX6gzD18eSeY7GQpZd+RdZxY8J
ccdcYV7xNVNftciZl1jMwJHybnMX/J7AAfpWwVYqTCTOAVzRFjBBu8AM8KHC
YoIHIANeoLgJZIC/EXPl3IUzaHs5x1noQCaQGXZ2cL5iwYEUYrrxhvA3z8Ax
TC/6w73xlrDRlVgOfKu0DU9BfFUzXeUT+axicd7nDOz1+clwIdHKl+inpIKO
jQRyg05YU9AeHhnx5QdlgQlmBwehSbqqktEMMYgBuitrEsPLZOCHhZrxOCAK
NIcuAhFy0vCIv1Qv4C2god3WLV1id1SPC3F6fzoi4OG3R8+L/aqfTgdrcYQg
J9YUDsv7k6Dhz+sb7Vuju2JN4oU0T/FUfzM8aedVZ9jOvLvJBnZ29btsd8WK
6ulktPNvyBA82y/V/nPyXY1GTopFdlak5X00rcvst9PhsThTJMr62hTyCzBU
bU3boJ3atgI8sM8Nnma/N36BN1Ggw8JKn+v+if2Q4BONs+y3p662N+pnNBHj
hXRSuC/e57xAXAK/5kFpNJJwFpXDanZp/5n2ysZ348m0lzY8ZM+PPWAPN+7w
b0GL2TbinT6s7WBbVhkJX8Wt/XfbByaeDJi4vf5QmByb8i3+/Zhdkx6zNdmU
W3d9dlr1HLs63Wnz2hbaO9K5tt6PD+aDNiObEZl0xlcsnh4uKjErmDGIuwti
oV+6Q0aRSSYWiID4Kw02FIMJpABx/5yF/ru5mY8XjQgjkaWN6MuYQYwReaBA
zlLmLqIiSo6zTd4MLBeiLAAsRJ7ucGs54DCWuCddlUjDnZEv2uPp6CaMhT5x
jKdWHKXS9xO9pfVPZA45oU1VU1W+TZZPOAc4QXvDNnQ/5Jlr4fxABR4DJUxX
3Uj6yH0g88CObAFUuSoBqRKpTBtktLW6Mn1C1XNfPDBgA9fRNyAQrwu4wDjz
7ModwDPQLvYF99J9+I0YU62qalYosq3cA5BFJcVaNE23fQha0/y+FVoctG6V
0+8FtsTl+/a0OdDiCyPnRL6cZ9J6bcO4b+5E7GBtDan8y8GDbG2tB/dBGbPV
a48NjdpMJxYt1MDZOrDQ7oqz0oQFUtUcns9pTVVTwJO3C3z8wcZ3Bk5Uy/8/
krZEKkHHCfvq2nPsi43jSzpRpBfEVQFOZCValNSi/Kv4Xz4LcKJaLoj8xtD5
9vm1VzQNk8G8mxiMPICj4/8HHAfmY45674jdZCuypXZIPumNABjt9r6R+wJE
PjxVgMrumTut08HnXb1n2qMjj1ZKmnFY5QjHsmXOyN4TuHGZ4whrK6dk5/ho
bbWTamfach+RCzouD9tjrtMOfJ+feunO6XFj/3w4KG38kPK3MdO1mMmMY2Zp
ayozS4uWSDIzEP7P7GamIqEKYgQ1+A7U0PZWqIxcJCVFCYQAlLCJ8GeiJVm0
xYkBkHEfKWX6wv2RbPoHOQGZ0JzKbIzWVYAj/dGOeJ4LkxtJhRQQmY19AQHA
d4hE03ekjbZpU8nyQA42gEEakPqy+EjGALi24VEFhEqIrPJiqnjGkNM9bsHw
KgwM96JiQVXziO7xznBzDNBQuWJAT8HlgBR2Ae9cA3AInJSSiHZU20QB+/QT
FFBYHI/M+RwTwJXmj8uKD4bPLJ6LZ6FP/jz7AI23QzRuufwUt5K7Q9vOSp02
5iz33DRuw5UeOyLNySmg7prsoo7lhn3AGsS5bEVbH9nyZrhRQTpxXAiR8C4p
nUNXuBNITLP8TfJgd3vLTh/sVUcCocGfjJ+WtAGdiqV8/2cTZ/uxAjVIAPZ4
mgzU+PLwqfZ7w6ekSokaH0/bw03xsXRsEyFKzrEfkrS4Lnys+L/TPje2xz4z
crGNtc2xY9vW/lcwUaSyeNMtAU4UxkjVrk+X25LKIm+6LyyNU8ON8ash4rHx
99rCjsU2VTnKBiozbGY2x27KH7Shynw7I7/ImV6XU4tOm93XX9avfguI6It5
pVAdxB2RJQYCMUVhAR/MIywWxAXTQuHafl2GEeA/vzJCcViiweXoVtf7RY7d
m0M4WeAAZFC5WuHnbkgXgssdtLWEBRZoihKNAhLa0gb9AFwUUQGdRgJpg27w
ZFp/RLJQoaqogXAz+xF6rA8lnUIts36KhJU1iWNkyLBJigx2brL1jEhvrkN6
aIt7QE0I4lTyKySY9klSRaIupBrJU/kfaALSyr2EDrSjiGz6yt8MpWiOEo8h
vTgmcEpwL0LDlFmTZ1ZkuAKrQBe+w2sLTaLPAKcCshiT1oUj7q/SDHwHxQDJ
tH2PvnMf7+M+H/O3wy3IwzfUGLDNrs7m+Dw/DjemU/6ai/2M1MXejsHQ96SP
6LO1OQscpyVKg2xJ89y4breHKxO4DlzuDiu0v//PAuZjw4fY79aPKPlB3izR
/mebzii3clRtbVu/ndm2hDPs6+PvjPMrcX7Nvxuwd7YtDWTg9fn6MfbVDecI
HGbnXXZHmioXOwofZguliFfprmgvmcSN6VBb2j4zbIsWDGgvMYBKhOenM0rp
LxwSm7J1ERFxSGWX48HDNpEO8yFZlgcM9O0HAw+OPGOPjL3XJvIdfmyFH3vK
jq1eEAEXq/JxG02rgzXEllPv2OdevWdaJHgmLGdt60SeQAJtG0NG0TJKRqd1
e+QSLwDvSjfD+cxFpbxkniDvEAAIAiYCx5ADFdZErhU4jhxwXKWyOEa7eCPA
Ai2SMF9FzZELzgFP1BeVCIYUcA7ygMwgb3gE0Ky0gSxq6xTmvOSEfiCzBHVD
IjAjaA+Z4zh/Y0LwHQup7OiGSPDMYgHch7bBBMkj9yHSi+uUBE8rIyr/pXSn
yKGyJytXt7aZcQ+u4zkwb5SWEycs91DZatpErmlXLg36yLlgi4o2cj8IkuRb
cRkQPuaEijXBalR9jbbodxlL8vbKGPokXTBsN8w5JTZMfXjBZeHWvyrttIG2
Thx8sugX5wN2Ud86+2/13aXg5VHI7NeX70ZGS+1NVNYsOyEfllwXYk367H67
IBsJt+c3Js/UFtDbXTLmufUCEvD66sg77CuDx+YleDhPidWLQvb5v2Zfm7yg
CQ68uOEx+Ujhjaja54f8vqPnBhCUngm/fcEOHkpHOv9ZbgsqA7Gzo8/V+waX
UWTzkYU+Q9xAeG70PiHDGu8csRLFEgb/V5wNnGiNrGGrKgfapekO4skeToPW
lbFV7IrwPQgd9g48Yk9PvC+IwgmRM2uWXZTebTc2nrG+6qAdmy6zGdlQIAXL
oN1tvdZo7/J+TgMP62LqI/ZyTyoYEzgAFhBPLT7KrakkFFrTh9cr9AlCqpT/
tEMYFipd2XQhHngf8ERwX8RRi5PAAG3RF/F+hXUr5Ju+cA1TnKnK9PZ2MrDD
2R6X8EgY6Ko3ijQzm+HRyn1N15FqFgtZt6RJpEBhBzADtC1aFU2rRFFIKe3i
hyTiCgcG7ILucC8kUJl/GCq0uPJxa/M6bILvOI9hVNFp0AAkAxlBaa3l8j39
QmrR2Ei1igZpSUPIouTK/Awu4RmdSzMDUHh8utKavVPEQqnAmQEqx8htGGGt
3GgvPcPgt3Xy7A+b8mm3kNXLqO47rjzdTpl3aGRn2Nt/nL1YvygQAh373PBp
+zn4jkuroArhHKyUGpqqftemA+yPxs8CJvLSn3hPWm8znUW0MoC8tA0QerwQ
2uhJUJfwohbs/9AmXvzB0An2h8O75brkq1jhTDtLQKra74++035n8MTAir2R
+ba7XP3ssj+cutSOyBaF8wH3JE8wks9wCe+MBNqr8+VRgPSmxJYESoeRy3O2
He9t4Wng9Ujjdnt5/UORN/PxwTsrZdorsuQRvq1ACcyKeZW5bvnMcPZxebUE
jpJZOECcFlbDe9Y9YXsbTzQdEF1Zj53hl9817BSje5uNVA6wq+rP+vGG7a7s
CfBouGVy3/VnTw8ca2Kma3MVs1VF+nAGoPOZhXB3jHgEW3GR6BjVImQaYp0A
LGTHwZUIeOAUUFAUx4nDRBqYssx63lUmS6sTXANIcG/6BZfQ4iiOCPoGH/Hz
U+EyPb65OYoXVrnyWakEPM4F0ANuwd+IDojAZ1Jxa3ODArdAHVJCwDeUSkIZ
9uEeytavQCw+8z1oxMoIiAQKgB4CONoGFUAO+gPKgCaIqFZF6AdcALsDZODZ
sbGIJ4W/8FvA1QBlVZTT4jQACzAz1jh3+BsuRp/hBNyD34y2GSN+K3afZFhl
aSB+C34H5gHjLpev7A+eg2elf3zmeegvG0L82ul5RUfEX432zLdNXStslyvZ
z07eHMixxNUgC4VfWH9liRyVkL3S5IfN56UuP8mRYH0+K0S3BJAkBMFnicdB
CPLlxpFpfxjIWrac1OwbE2c2EYXXvNhuMp6XZseXG0fZ18ZOawILpoybN9Xy
bgDI74++K3pCENaLQUXoZXv4Iejp0tpgVBNiS/hovsSO8WauJMQS3KD62JER
PQU8VEuG8f6Re0U6/KLiG1Jrnu1osDpbEbRgR7bbbwJa5FEpZDyfsFv6n0gU
NXssddvs6lw/55328PgH7OKuexyZG3auI8e6wUlbXZm0lV1u4tcWWyWrUFFy
WpBYHsRU9fl41xIkjEChPggskxHhxGGAlkdoEXhl3GaCKRmedpTSJm2oTZwH
TF4mKJMMVYn6FDBpa0hEXzF3jw3VR7eQD1UQoTmaAVcUa85cRmZhBMxjVi1h
EUrfz3nIHfKmCADsC2oIwSY4B4xR/DbyDotgeLTsgYzAKvhb5dm0zMjj8FgM
FxgCHvGuVJjaLoZ6Z9MpARQEfvKZ+9E/ZFEZvcAVhkxBqdwX3EPuOUZAK1ig
YVNCdsrEZhG9Xey9YwwUjAEtAAN51qhq5p310/iaYebXErOAY/LZT83QBT6H
8KgwKj4Sfgdvj1S1l122z3+dt0KI9hIhannFrpp/UnPfA0FFJzgxWOkaFpf/
b09d3UQI9lAQ6Qitd4TIStP/+bTDOhMZ83a2okRW2gqLKz12g+v0VvPCgUI4
MSfHJljTstmkat/YeKbSWtlRaa4dng+VvokqLMX+ZMMZ0VTpp/CbcKv+8FN8
bfL8KCN0ZVobHf1IOtrOd/t/tSv6OXlvJOIn+cRovtiOjJRVnXbtzHOiUPEj
9b0+MAVUYJtcn/YEINTL/99dv81eXPugzanNsj5H8G2dR9l9y99j75161q94
79R7c3tsjDKNj4w+bUsrq6zqjSzKRwUT49mUraissycmngsfxZzKsB2WnWIP
bnw6NoFcuvBmh5sua7gVctKOg7umg4ki9S3EXhXN0efMRYwH9D2+BXQ7+px5
iGwi7kAF8xc5BD6ADZYumbdanFB1HtphHhPsxKIJvAKfBtdxb2AIHahoSnn/
mbzKCoecAiHAlxZBeGcy46PUEqR8HaVdnyGQ6R0BHZj0uA+gPSAULga2enAZ
lEoLDFrRxOyXOY4xAd2AkqhAD+LGNUpshxgrQwzn0q4WJoAWaAnfI0XAA0YJ
NIVj2uvNkGlvp9aVoHEMI8EXWA08OhAitw2fgVCgE8TV3/wUDB9QJlcH9+NZ
5YqgbT0zcKXEF0qawfV8B4zxXPyUESAKDylwwrs7PU40bHLNCuvPG5HW5aF0
Knsd7Pn+C4IxvJxOCaz44qYr431Dmo83oFwkqAbDl1+w1OkpK5V6CRYBHKek
JbYhn9E0QkqkCFHf4rbYifmC0gipRIJdIOJJZzF9bbVaiSZ/OnW2HBYlKnRG
gRNWQYdq3dYRFXk6gx8M50OUI7az0ol2W9rDBq8bCZtMK21TvgYYsCcat9pr
kw/as0N3iEIsbVto29oOKvNwF/+TOnN1ttKqEdKx1urIcrqjHoxhhl3kFkpf
PmgHVnbahek5m1EZsqPzM8O+ODqdaYPZHHtkw/sCErb5+M3I5trjky/Y0uxA
O7C+xYbrS21Z+6pwcHzz809PCwvPNMuUM48QVbQ94oYIAhHoEcSVZQVMBOAC
ZkBeGa7Bf4HaVAo10VsYBH/LymVe4cJULhv8DcAL0KI5h6wpmQsyokx9XI/o
cw/6C4TQT/rHMfrI+aLzyCguQ0wEgqmRQeg9fyPryC/f41pExqEFQImqvaJP
wRGl7+U7UQj+pn0tiWiZgOPcG9ckeIDcyeXIvZQ5jOuQOSgLpgnUg2cDd6Ab
+IQwV8AT2lWBMM7he8ZKuMDvAL6pDCS0QikBGCd+K2BSez0Er9ybcVW6APrD
mHMP+gR+aj8Jz807MK2gGLABTOGY419rWPZbAcMPv/mqjbaPWI/r0XNdn0Ii
PrX2htjscG06OADhjfoZ9ltjl8UGS0z/vHRM/H4JDJNpiODo/JcwAcGFWPxm
LG8UPszSOekCuxqnZbWEA/LOfKVxhCySAg4aLHeGESII2Oo3Yp8anpSihkbF
YWCOTbWtCWJwz5I9/mDgQG43p0vC/3Bfus7/KoT/pfH77JW195V/Ff9fkt6l
HLpJjgfWNIcrC1ypd7rUH2wXpHv94Z+0ZdkaW1/ZXCtNiSNctXVnfbYrXUXh
gfRc6rXd6U5vrsfNs+ttwE2V20ceD2C4OL3bkavPrlp0l5/5cPCFq5bd4uZI
3YF50FYML3SGMS0yKCsU71rIYNYpYxR/QyogqaojjNQTmcBMVA5M5aNDg3EN
xzgHDSaEUfgVM5aZzGeQAmKM1GAMIJn0A8ThOtpUSltsF6XeFSKoKKl2qiGJ
sAIWINDkqv8FoecY0QvK04/xjzZHwlVoC3cl3ysUFGmRg5/zWutFa0FUjIFn
4BqQgMUDxVeBElqchXAxrvQbgwkUoV0MDYwR0EgLSVoIUr5MbQNhbHE8yEbj
en4j0Az6r3L33EOeXeqmUQqRZwFFlTJAqay02ZVxABV4BvoOsoBQoDPjTd9A
FOUu9fZbw7B/FTJ0lC6IPe861lZVl4egHZAN211pt71j5gSOvqZJQYzip4cv
LFyZaYdCDf5g6hK73entzLaO5qKGUGFmEcoQ9kCG89HPR+xfS1MtmS1z++OR
k2xF1QUmrSidEt1BDQitJFXEwkpvEwdw+IMD5NE/zo2OS5zh3JOuIH0FJUZm
u3xh9b536HbEv14iBIdPT8cFDlRKNHCmYK9NPeDM4ZbSW9kRIdeXpLOb3soT
01GRVbuT1c3sBBfth/xKx4dAk4cKUyDd4W0WMLGissZm5cN2WnrQjwETua3K
DrZuf4orex5io3N6yu+zpDJmh3Ydb1fXn3UTaKVN9h4WiLOkNhobRZ07TA8R
S2IaMRXh+Uw7xB/7gbBcpjUQoPSP2AOIP+fJ5mXKMW2UpAqlznmqNITPQFkp
tL+boCcSUvEZJebTOQM30tXRbOuWcy3LyjxRQgf4DLdVjjxVuAAJcP0pYRyu
OCWiZgEDaQNBmMLwZSQbSeB8dCTSzsIDSIK5jy5VaWClwUci5eFX+WCkE36g
iEjt2wBFkFKu5R19y1Dw6HA0EEeZSuEPhF/QnvQz33Ee+l25sBhW2RRILQhE
u7gp+R60wLzjZwOB6Bd7T8ikKy4n9ONaLSXTR5Z3GQNFnipDMUhC26ojB9qX
GYCmC4HoaAmBOKAxav1u726pbQh1O7vSF8ugD6UjtaZBGOLi6gAmfXPZ8yub
Lo6Uei+lQ5tBSyDEunwGYQ1l6EM9FidGa312o7N63AnYCwUKsJHeccAlojsj
VWWtmUcSJFiRL7KdjiinpSP8/JNtKq2x0coie22Tiz+oUAugWOA2hINBvJ4f
ucteHLunWqLDTic/5NwHA2olEjxS32uvbrzfXhi9J+wMVjan0gZX7D2xDLkr
nR0FgJ70wSm5QsQ+8MKKGKjMstXVrXZeejYv+cKdoy/aI1Mv2ZyOYWu0DdhE
bUfwhZNcdGY56l7XeK8/xN7wK1zWeDBsE/Z2LF0w1wnSNGBQbNRTOhQkEYuT
mYY0cowZImlkBgME2oUFgKDTmV1IAVYBMxQnmRYcBCoKRELncb0SRaBzOFeZ
LLkHwMPsV0Y71eXiXXmomKUgAG1zDuigVC9IuAIgQAClnGFJEr3LLAdVtKjP
edriCYfgHcnkHf0JmoAGBBzwme8UFw0agAQcQ5IcVdALDz3kswNUgjfQJ3Sw
aonyrppeSKQCkJB2LB5QhPsgoUidNt7yW2n7Bp8ZZ34vJZKAZ3Gu/MjwCVCL
Mf/+979vP/3pT+MzyMFx+q4qjIwX/VE6HdCR5+F7frdWh6a8J+Xx1mDrX7nO
2VmWND5y80Yb7VpsOzsOCVfbqemEkEtgAdnE/0DYwHzX6vOyRhW/ns/eJbV+
O8SJvRN8hwL+z+0d/aPW5/CwLc0pxbzDLfP+UPi86m3VyOXCxG+QcrYQeda3
0qRff76rdTyAj62iItej6Vo/FwPhjnSpvTh6pz03fFstYCCPjVPXu9GD1Gel
7L84dm/AQfFX8T+X35ouDySox/8kwniHDbfP9e/abX39ELt4NiiB/M9tZQJN
Q+GI/NLwINw+8iF7ePIlu3/8Jbus/rydnZ6wXmcUB1XPd8PhFVtYOyCAYIbD
05WNx2yPM/+hymLb2jg2cGWpMwU2g33nK89NiwHFoiHyy7xDXiEEKHQ4JzxS
ed9kbSqxHN4A5Bi5VxIXtAWyy3oF8o9toAR1yCfzFxnmPOanbBM0P7YG12IF
8x1zXGmtwAzaQ14VKcH843xwQ5+lsZE35B55wluALBOWgEwib8grbal0N1oZ
OWb+63yVRwcvuA7tD04gF7CKMrI6crwU8QRbQy5UOEeZMMEQ7qlQCZUSR+sj
e/QZ7QsO06Z2iLJ9C0YChnGOErugwRlrfgMWFfn95CBGPmEB4DTjCe5ynHbA
P22Do0+MDZ4J2uU3VnlzvgMH8brQP65XCiz9zgqPdRtsnz/jW7EBif+rT99g
WVvmmqrdnlhRUOVD0mbbVBu3hxs3uQI8PQIBDkkbIe1VHHgpD3ded8HfU7X8
H7t+k89xNDiv49NWl03X47EhYrffom7PrL7GseWxdE2k0Z5vR2cH2Wtr77Jn
GjdWQ+Jrtqxt2Ha0TSHo9nj9Rvvo1P28V0rJX5ktsa35RMh3pfQe4h34wPAd
TVKwxFvelR1SLcUegR9pWxiOgUZbv212FTvLSYKbAaUJULUHR99n7xl7vz2x
0U3EKX9NfoC8t2Pv8+uvrT8VAtzj1y6ujNtNq56wh9a/5EL+fMpL0+D09KD1
OVHYUaGTDgeYIPmANdKAHZ7O8DG8Ie5/SrrOx5FV3B576t5LUs90SNAZWkaF
btCUzDYkGKsfyWcm+EzJmBapUA4ABcKuHAZMEm2PkMWAokLZK8MlwgtoMEHl
tkZhMaFZMQAUcGUCFlgZXAsIqH6Q9j1quweKj64yKVVknO+V+REBR7kiyNB7
XIu8Q9lxHCBcGPcIpLY1AyBKk4IwU4wPEFAxQMwL/uY7hJbhQrAV44RAA54I
mGKZEH4ECxKA8CGcIi2txT7pD1EFODhwhRI5wfdcxzFFaTPOKnbIc2s1FiEV
gWLMGVd+D7n/tNUe0FMENuOj8DU+8yyMEc4TwIjPCkfjeswKzlfGU571qaee
2udg9VZg0FWaBhtWL3clXQtX+4enHgowQNPePedyvPJZaW4vqsyzYxtb/dDe
UgRzV5SddueyC0rbvRDVA7LldlB9jb08yh7GQp8vrsy1E7JD7Y2Nd9uT9esq
gQVVu8FFpKNQ+va+wZvs1fE7/WQuIdDwTBeXDnswsSpaNP3c8O32yvjd8ZeO
XevWPufdHzBS4MNHnPc/PXirc/eT2ICdlYYB7sOx5Eow6w5E2NB2tBOfuzLH
qfdDZNLtQd33pEdKZlBxi+FoHxt2NTQc2W6ulnKP57DX5X5n2usdQe6rduPI
R2z7/FNtbmWVbUjn2mBlfrmPJA/SAQ5cc94pbkdM6zkUc0f7M3GYyEoMiSBq
+V95CNAoaGqsAHkQlUNIid1h9wg2+EH7uAAQbIScicn5aBEmkyr7os25DrwB
PHBXACqAhHYlKleVkifCLrgnE5z+obXoh3JOa9M0mhRAYHsCFoEq2dAu2l/+
doCBzwg/wgYbljdTm7nR7oCBcjRxb/qoXaAIJoKI8CEkWAIIJ+wBVsHf9Iv2
uA/PRN8Zd9pF8Hgm/BIAANfwLAq74H5abxELoD1VEAFo8QmoRA5go4Js9JNx
VIwpz8/1AAJjR98UjiWvIddrB6Z+B2Waod9sjfDz3kr4u8s1he5ql3X6dL/b
FShhfYThbK6sD0rNkhxLc1el80LEnph9M365kmZXwqzGjffq2nvsqcZNcuHd
ki4KW+KR+lX20Yl7JNCXp1MjAgDRz+yDw7cUKFCL4rvnuhEACvB6Y8K5Xv36
vLyOrym4WYh74Q94beN99uzgLcEWeHHOWenEwlvYbo/Wb7bXJh+wnqzLlqVF
DlM9LtkNG88Pcym/tVYK/EKX1InqjhD1Wvxft13pHGu4Bp+Tr7Cj0yO23SW9
q60PN0CSH+BYH6seNwGOTveFCXDr2Gt2x/hrDhbnuRmwyDHlJXtn+oiNDU7a
yurhdvLMW/34PNu8an3qm176Ua+oEGYPs1abD+Sv51dnRjOrsDGZfagf/P6g
BkEFXCPUoC1mBTY65zADVe6NmcY9UP/Kqg91kC9CQYyy8ekTMxaJVuUOpAB+
jkSCQvRFCRBlq6KWtXMS1c9KInycqAJW55S5TbxbJTC0QUJpGORDL3MRhCRK
KuQJ5H7KY4Atovrk9I3+c1/6oXQPSl+rjVgKQNL6BeofaWQc4eXcX1sYtcWd
8xkHkJbnV3SCmBrjyTjz26nmF2PKdyqTyPPzWSkttHGKcdCqqYqYaiWR9hln
fg+hjyPOdCFJ3WWep6995vHY83uoM2/cAE8suy1sAoznVgSQV/6Jxi0cL2zv
qoPGlXE6pvoHR+6w9w/dVopo1enCXDveVX6LRKdCpKtNiXf5t6fq19lHN93t
34EG5IzeHDYCZ2alcfDC8K3QiSZC7Epb/JwF1fJWTzVuxlkYSEA53tF8caqW
UMDS4mFp0ua6ed7uijxzgBpsm2+XLbrbbh56vr2EgnPTY+EBuCDd6ycUuv9d
PHhl2FFktpP522D7r6UZbhM4o65sDOcAr8PThdabz7YTvYm71r5mtzkagAoH
pz3OAYYdcJ63SwZfs0NnneaostyuWPgB68r6bLR/FSu60wLCUc18xkxSfmiE
FVWGoCL8TAgmpSYGqhrA0O5GqAJCzwRUGkQmHALD5EL142AAEODv2vUEVVBY
jfYsACpcg/AhnEx6JqGS1DN5mcQs46PaASr1U45L2uM5EE4EFQAgCvHb3/52
gAiUhl2OChfgnXYBEwQAoZBBj3oui+pl3CTtamaiQobI8oT2RLNzGbfmEcFH
+TqRZa0DtuZkk49Qm6cYLvk0YQ4ME1gFZimSgaGgyzweeKI0S9qbyrWwCZkO
tMMwStsrQ73qFKooAT+ZvP/KrqUajTA27q/t3IqqUiZL/761ztavwoNGiQfH
biMtIXx9kT3Yf5Mtry+27W1bAgOEB6en421G1h8mN4r25fF7hQfI/HHZ1hBE
hPLF0TtLnl6zM9IxNtOnvWT45dHbnfPfnJVa/vC0KRYCCnZQEIPSWgiY4NUZ
xXXOqZQo8sbUPc3WcCDeki5MhadwhhyH4Qm8zQWRzlKRd5GLPmyASuUL8jHb
7FbGSa7Gz0sfdLOgATsAEYAGe3jji/bwphf5XA2YaLeRbG0EGRBgwAvH4XA+
6rdv2Kbs3FpARM36K3PCf3hIOsshYIFdv+oDmAeFpdBpR6TbnD/MdiviWbt7
0xu2s+NG68vn2HUrPhDcY2Vjg33p4w/1Tx+6jEpjGipRARQBqYLAI21MeVQC
U4KpwLmoMaajitlAI0AMZV1S1SfQhimE9EJeQQcRWlQqbSjDI+pNyxbehyyS
Qnc3E6bzFYLKKjzaFCniGNJHk5znhmvGAf/BFE6H4LFc6Eo5FRkODw1BZhcC
PdNTcTk0GQFDmMAIhRVxTMto4By4qL3lCKmCtuW8px2EWkuJrUU3IS3lwkKE
+MgM0Q5qMBjhRjjl1EMwIRqYNzy6lkZVYodrAR2BjRLO4HDERNJuBG8/FbGE
s5qZr7k319EG2KgFBH554bF2TfId/eO4Qi29n9NlZ+kpPQXzBmfb4mxV6MjN
jfWx1ee+dN1+wDCYQ5NPLj3zFXt10/0hd1e7MexWvoAA7560Na/BvNf16G7p
evwArbq+FjzjoqAHYTYUTMHWZMvs4MqBTRcDeAJPGMf9UFlbAEG7nZ9OssPz
SZerTjfki2jEWY4zG/z4MenWKpLvLY67mh3OV4WYV+L/7l/GgMCFFp5gK7MN
VnNKcUB+op2SXq6H8FecwDzkhztsZb7d9sx6JW8R+n7Hx1M73J5d/4Yd7/DR
5TB62fJHbbh2gI20r7abLz59YDqhXxrTF4HVyjCCjzCjwilIw/RQpmI+KyUa
UwPaAPdH2Jny+KexF3BJAR4ACecxTRBmLFbV1OR85VSSN2DTpk0ZqOFYJCqr
VELK3Y60am8xIEC3cCzAVJA43pmpzHQeB+lTET3+5nyugyXgKEB1qjgUsxsp
4Z5IGhKnxI6oQpfwjHFK/fE0PKX2e8qxSTcRPASbprDruaVWILldaZvDRx99
1B8VEOI8LBMeD2AAsJTrhUcBMGAAsAm1i3UCBhJPTTd5BMgOjyWQwCJSIQ7A
CMFWrkiGQ6CkVQjwk1/Lz8liy2NXMyxRu7rAOSYNmsB/mX0+mm+5SCihJwts
p5vQ58y+ypblB0RS47G2ZXZXuqop+Ntrm4Nvyyfw+lQh9KXVLp/ARyffpOcr
CD8sVPiT9etxEYSgr8oW27Z8Q5JzsDQM7PZ0frgT3p2uLIW9N657bPVV4ZW4
I10W8QGrXTTmuhbt8TtHKti2AZvvvV6Rdljdn+b2NR+wu8ZedkwoRL5F3bvd
X/yPmN+79lkbqM6ybkfadR27bc/Ic3bP1Mf8inun3sjt5rGPkWRh9I0Q9O58
pvVmeBhmYABIw+92mGjkM+zCxU849389bIDeymw7dfgGR553Wb/3c9PY6sHp
q02oBBx+d6aQylMyhZXFkakB6VWKV4RUqeHh/loXkA9ftoNSsWoHPtofQFBU
ElML3ci9kViVXaItfY+kK68QUomkaw8z0x19hy5lPiKRfNeamAyphg4ol6Oy
iiDNtIseVSJk5nFRycG/8V8c8aQt3mlXbj1ViZABjagoqwk6UzVouIZzAUhE
GjFWyJIykij9qgwE2sfpoGoYSm+voAXlW2KtgO+5F/Ci1O8KJUakeR7kEyDn
OYEQxkNuXunyMkw4yD995b1MBJcKeOtsrm207l4ty1vtc2XwVjq+txT3Dz5y
lXW6KfDQmqedFx/jmhd1mftkHQi3+bVzzoo6Clelc5or7Xja4dXDsW2okPUP
j9+NOzA0913p4kqpoHEC3FQ9J2T2PemKamnvQ/KHnS+flLaX9n6Xa9cTWUd0
0V3kLH1uiDSMvTP1ObAsdtW6wybSOeF+r4TI1Wxh5UBbUzkimPx1Qy/au6c+
7O8vScGv8ybn5ctCzv+/9u482tKrrhP+U+fcW/fWcGuep1RSqVQqlVSSqlSS
MhBkSEICQiLIbAhBAxIFyasLRBFlaGz6VbRR6FYhKGqCre1CohhWm6aVoYz6
2tAFGAemFxRxOc+i7vf32ed8LxcMdWlZ/d9ba9065zznOfvZw/f7m/bev71y
+v/jSyDtqmuU+N7x1W3VivUc/fmuyFeXo//I0vUb2+XDd7fHDPdUn/z7rrGF
/RB848zO9ryDPzgS66vSts2e3b5y65PKqnhVDzauLbumJOiyHP/BrgHhGKfw
NTnS+c6u4V52HFHeeJ8jJFjrVBs54N4sM8fhbE1wXXm+I0tyFGVSKZhqzPGa
2YAY3zt7+5PgMFt0kpIYlvE1ub9co4Xhni0sc5FsRu9///s7txKuz+LdLEDI
QlnPUjc8zbyf9zkKwjMSGAyHw9/kJlvKabzyTGXhcrITeb46Rg559Xv3CObF
nvd8/E5mpQQ63Z/liOSnuuM9XiexpWcsdcRjgyvLTmnj5/4EUX1PXuFtphaS
jcb7JJDPERdZEijL4jILhSdRpo3t0sMH23mjS/qEN/v1ilXXt8fNfWOPjJsS
4/ybAztn2NuuGo51bovylZPfFor7LxxuXpzoMxt3YtWFS6zw2W6F757dWpy8
oVvpL+1nLVgTsL5dNBxoB4Y9bUd939lcCjiKeuv4nDItyq4sf7wo2B7WJ84X
2kuOvpnnXHdj+bg9uWxwZvxTh++rTxNqv/TQj7VXX/6WdvvCmxavbRhvK4v7
udPonv9XtRPD49r6UrxzRfPDo69t1ww/XmR9ez3rdcXrzaW/X18t+JwRT7fv
LWf/2qHUfgmAuvyI4U116/q2ccXe9pR1rw31z565vF2w9iG9dvMr1vaWfeC/
/dCW5ai/bfHUlJzWQi2jYrIgJlEACOV4ZWrdva5nn0CyFFINZRqMTAzUoNPo
OX0OMzIxRqIohoQhAZJIBRuzyLdnbXVuxNcsrmB3GeizD8i+PPYqJx15Ekm7
//772+/+7u+2U6dO9XRA7kXGkNh9DANk4CLkOCeCwb1Il+AeEiXNGJsY4bN2
mABAxCQ2D9k9x+dsQaaYc9yk5+Y3SdzsPaGVPUQEQw6dy4KARP4Ii+lZkV3Q
JPFJzsP1WRcmA7OuJyQ8Q7vtgpg4847M2ty/z1ZMAtnv/F7dCCP1IiT0v7LV
iUD3O9mYSzic0ZjfOOW/zSuHVhzrzF9bEH7G+pe0lx14Y/dqv3Z4TXdZj889
pp09vrQ7yDQ/Z3llP/l99SwlbAlQabXZspTXjdcPk2szbX60ugTHyk7mIvao
bRmf01OrXldG+RM6p1eX3nz4hmcJhK/spJlt22fObSdGT+ux8u+YzKDV1QnN
zyrRdGTm4Z3MM/3/te05c29qrzr+lvbyoz/elfzDh+e0DaNtvQFPL5177nCi
zZZo2Do+UjZ2efbF7Srq0Phr2u6Zizqvx9P/l2j2YULthXbj3D3tjkvvadef
801t1WhD0Xx7NXS+LJvj7ZwVV/VZAHbHTDV+bryqffq3fnLYuhzBH971Zc5d
zzStWHxseHoc+xJUzsmnydeP4Kbq6WXT9mx2uj67Avw2i29zTAFhkvw6WJ5z
LU0WgmKSgNP3BAc4ZUMQmoAz+9VR09bnWKyH5uJg6OMVtcHMfT7nSOfo1YiK
0rcFoiLmsKt/l/Us2oeGoRSxkUhBtgijsj6JnY/eKBfqKl9d0dOzUbbKHFGu
BSUhOkWSAtNdvVWVethwdHHHoqr4eYqLGeFz1ivqTtJHU7HcNdWNmZA4C+Gp
PAxnxme9MUaT3YY+OxFc99uYL9kJkLzSOeGquul0XT+Tat84/f/en3xFWzWz
um2Z2d2+9uxnl1u6pVTi69v3XHpn58ijhq9rG0c72ytOvLFzCYeeWdevL299
danE67c4Uo1JPW5byqU9d/7Kdv3cS+vaI/v5JRvK3L1m223tBfvunqrJ2a4m
qelnzL2Zd9y+boHyxO9x93mp6icOr5uukRn3NTIvv6zPjy1eozTXlni4cXhZ
UQvX59o3by4D/sq3lAreWGbJ1iLi6ra/yPeI+na+E3tb2dvnt8tmnq4mX6iu
O5lfcPSe9uKTv9Ced+gXuvm+c+ZEmQUH2kNL3lw73Ftl/WzbOn+oS64NM3va
WDLIDRu2L8fpszsO4ReX4iPyb0XTcZR/nJMAk+GO/Y53yaDhs/k1/MdVv8+x
KHiLj2z2xGtxOJNQxXWHWlxoRbZnTWM802tPWDxKnp2fw4cAFrfwmNoWfhJj
9p7tLgMPTrNL489qX+xYxABoYFcnddEP+KcvgBohEA13kcb3IQxyIdW73vWu
vs7P/KDycNyymoTJmBZIq099j//kTybikTpzAOovVOa9OntuzsTNOQ3u1efZ
qMgUyFpCMgXJZVQyJmx7bUBkBK37LWV93vPKeFQW3yFySxk52k1ZlhxPVPra
3kdInKyoOaGSzNV3Vc7p+v2ZSL1pOk0vBLd9/Y62uQi5Z35/u2z2+k7m773y
zf3VEpZjs49pLznwY+1F+948mmpMupHCsirljn0/OYlBz0yptqndtFA20mV3
z0w18Q3Dq8vo31Au+I+2l1/50+3ZC3fVzZOprL0zl7YLZ27o61mevfBTneXP
nPup8ZTk+0Yn2uGZR02pPPHEn7/zJ9orLv+pduvcW7pyv3B4bLnXF0488VXt
SWVsXDA8sri4qwwMbsCuevrW9oxz3tSef+Tt7VuPv7168sUn2dsvuvzt/Zq/
Jy+8fdSpb5HO3aWfN7XdZc/Q4zds+55QfarP10xM9fH2dmDmCSX63t4eO3dv
e+Hlv9S2rzrcds1c0R6/6z90yj/6YZcPO760bf74hAuOMkxmXZhJSnHz8viP
f/hrojnrZfm07k0eb/ob51nk9G6OJQzfkzUHrygk2Ek2Yj45mcHPZIpm8yvO
ew9zyeeNf7BLj+M8DoRnsv+QB9nOjzfqk6wgiW/hH95lIgHnvVKKOX8t2cXI
G3VXhnv4/DiMv8qm5JRLSbrH/bEd3DvlUrdJeCc5w4W8lM3MM8mKZDIjJ3zO
rID+ws3EGNO2nHFELuC2dkU+5V4yQnnTU1r7PJznKYOcSGwhE/n6IccyaQcb
LalLsqBKO4zR2972ttP1jDNxfvMSzh/cdaDtGh0txbxucU7aPNRtc6/tDqg5
a0q8/N5wfvfMoXZs5omddq86edd4uizVorSNo72dwN9x9K3tm/fdNYynxD9n
5NiQh3UVeuvCXUX+ty7ayIQB1f74gRCcsF0o24S1T7m2arQuC+GmsbiN7fbN
P6EK7TkLb6nvF6j2bm5cO7ygnTVcWtc2ldqdKz/jqnZ4+M52Vannhw3vageG
byzz5XAJpJ8tQYHrM+3w+mvbTPkmM2UCXDX837NTeh8dvqmsiw3lXLyqPWnz
ve1bTv5Se8zGH2+rx1vaxfO3tOvOuqONVozbd77wqcPO5elN5KMUahLfIGgJ
CtWQSXDDi9JR7e4FUdRjSqMjXxxV/SYnARj+rIlLwrpkh+D5Ukn8feUmZJdl
MnkOWoOSz14DO/egrZkoNid1nlCWZfLoCdagnlNb1YlnSgyANtr5LVWqrNip
qSPqqzPvFE2zvg7NlEENJsGQtoZm3AL1TYIkfZUcA8yWHFTpt/oPFT0nyf4y
MZi0qGiMWklW7hlEi7bmSCdlxJZ3f9bquc89vlN3feFaDpbWRsnI9EHKiCvm
vXa63++IQW0w1tpjXKutpwszZ6L3lul+XPS+5NwL27lzX9Ftz/3ljlh6/t2H
3tgeNX9z2zRyUvut3dLl796+8Kb2jOF1nYzWmFGp33boJ+vvp0ZTjbtt5kA7
Pnp653gp5yjphKdWlzt7zfDyTnN/ZcG3bz/61tGU6RcMj2u7xxdN+TyRDCUl
2ksvfetkGWt9v2d8UfHV0+ba41a/tJ23/lgxcr4c7jVVsTK8xze1S4fX18OK
x1XKzpmr24GyVXB44onPd629a/QVxeY1bXsZ85cMd7WLqzGkwYUzt0Zxs9PX
lbnztP13tztO3Ntt9aPDS/ptj933XW3//NV979Lb7nxp+ZTLMHuhG15QxOnm
7Mqhgw0f/OAHe3o7I5wgO4QyrsewXPVOZg2Mds9kIUrhaHhUNwSyC8w9mcpO
Sj4soBRyGCq0Q0t243He3UtRCPjGGYZObIG+LAqRXeLd7353l0aMDwHkBKAh
mNNuTjlHm1PyFBb2Z/18kE/BMg78jkOgDKiPRwvdJB8m5kxo7MzR6K5jrWuk
4rRtk4NQZ3uTssBuGrMYJukFLukks3w+61t81k2qkuxlCJs4gaokI6lhClnp
+OzbIaizBicpBAxv0haxc9gGfATNzMkFbHndGV9Dd2d9JCGtHuULnS7hciZS
b11C6qPnHmp71x5qa1fsKr29uS2UQ3r5muvajvl97arRM4YoarNTYtampHbK
WDdR1BQm3c1INyP11cMPDWEwOn770bs7Ha8qzbdhtNuSk/HUDS8yd1Ijt4Xp
D++r8ermUXvJkbuHDX196leW8iU7lG8OevtwfjeQx1X92TKit4yvLirvaAdX
P6U97/h97QUnf7k9+8h97Zq5d4XV62b2tcvG39L5PJpy+5Gl17eNL64iFsoE
+epq1c/2fTPvrWpvmj3Sbe2rRdjrUccXbm+3Hbp3hNP9mLabqpN2t2cc+OGq
4d42N7uyffzX7ty9/DnIWYtGtSB1cl8AO3IAKpQJTCd/fpFr1COvF33eURS4
m1XgXhnfrgExox0XGfAx5nzPUiAbPJ7M4Ki7ltX6ATG5AVhAB3DeqyInG6ct
en3Pe97TNViCCkBOO7tPHjv/Sk7Zlvia15Qpgyju08TskE1qfZrRM3AZr2l6
TdcFND3rAGdznKNX1gWNr+7ajMaTJT0bF9Mbh+chdVbPIot6cJ5zolkWzpGt
Ra4qSwhwZpGg/qpuo35I+trFQBieKipJAjRT07IMhg9SinmE2GUpoy13hhvB
lE8S0tg02QaoZwFBDfXKdO/BUlP8QaPm26e8ftFznta2rNndthWSr9/2itKT
V5beK8LU35HhGhbtlNfjPuO8ZXZvcf3rhnjcd+z7iR7c5gOXjp143DN9AZg1
4TvL2L1k5kmZdeJ8X7fqxW1htM0mkokyXtMjaYLoFPH2+f2dsXOl01eg5Ljc
2eHr23nDD5RCfUddOTHcb2fezJ520fjlnbij/v9Me8q+/76U2ZPL8936Xj3a
Uiz9gT4Xtmnm/GLzurZvfEsJirfPTsl885FfbU85/I62Ye6cbrzvHn9lPfFl
EzLPVssPt51zF7fLZr69NPxc275547B3OSZvWjwjCsywGtTMcWcRm4EW90FP
tORHGmy+JPU7XesyOeRnff8Ku5OhDWux188IBhoZG2kztmr2assSP4LxEpLs
b4zGKuxRRexmg6sSlYNRDuGBJ7NdcGimi6qBN1iEw+xyg79PfvKTfSo8q8Ky
x9s9MJzZrLjvnpWjzbO0Nb+BfV2TZTlZj5cshLozyc0jmbzGh8n5n37Lbmdd
UMlYisWerR/VS119ZlV4pv7zHX5lP446sZv9lup93/vetxi+WzrFri+0A53f
8Y53fN6sIMsl4cLk/SBVjCOI8F34KUIWcc1Loi1d3vKgXN4xXdQmQ/eWhW2l
rS5sLzz2M+2mNXe3HcPJtrJwM79iy2QuutzHLeOz2oE1F/V56ScOr5uZBreE
tDbP7m4PGd8+hMciYt9x2Y91fX3T8PqJRb2x+84I6+/oysdXqc7W2t514KrS
z560on6+dnxB21ASZfvw3LIYzisp8/D2nCvf024+inATIl863Fem79Z2fPjR
Ih3GriqFeV/7xhP3tcNbri9JtLatX1EyecN3tluP3dtuP/k/2nNP/Eqh+eYj
766WPWrhPQjc/7YNX1XcXGg7Zr6mHRxe3zYNj6467e6CZOQ40hUToWIa7fwD
+4Z9y/H3qX26lrw2uLSwZZUIlylU6gWngS+zzclYS+4Dek58ygaIJEDIltJk
lQZO8aAkfwAAatZvgVecPampXANG4EZmZSjLswEMaaWaoneQUvzbGhVHhLMT
ATDT3Eu3oyb5nTIANhvBgDObwyifxJAQF5DjTCe+5RQeAoKJgLjImD4KabkJ
k5MAKOWTi8k3sjbI7+hHcXu2rH7Jxjb18tyctJO98pnsyuaTBAXiGjA/tDFL
Vo0hU4QgTNsELZgwbHll5eSuZPln1+fkH4KSQFC/2PwEJcvMstdyuk+XQDkj
gXcuCYxdcPbBtmV0QXvyxp9p33z07UUxezEPtNtP/FK7bO77CtZ3dGd05YoN
sx23pqc39bDQqJgzP94yi4IF9pWjdV2TwvaUkNXTRcn6bv34ZNs83FJk2dAu
2vRd7fLNbypCXjz8z6LgxpXH2/7Z29CzXTV3f7vl0ve22654T3vMzlOL2vf8
0tiIdXL4r1Ua0s61fWVzL8ycU89ZWTW+qq2ztbzU7uHxq+sKHVsGdAkMqnfr
+Lp20fDOat1vtkfv/PV204VvaZtXHypBsLvtnnt0O2vtI9pzn36jHhnOWo6k
t/ZB0dkUKfCZfHbQHrIkY1F2drJ52blLF5PmhD2kZVFlkgTgaFSaMdpWABtA
RHUQmaRHBsBBJnVI0ggKXTTJs/0WcUl6wKfJkZS/y1aWNQkh+bkIi6RJjEAb
IKU2Jt9csjshhLIibNimgIkAgI8A2UCX6E7S6LOXaTv1MlmHmGxf9rJ6IilS
6kcaNpE6/aZNNK36EC5lfYwUPOxaDEDhpD/VjELNFvmliaqSltdvslEVP71m
rouiNDxkgzUCdW3U7e/5xaVwWa7H64nYrkeNHDk6rO6dh5UY6msdjPlluiy3
gnT3NJPElcePdCqtHe9pTz//35e/d2vbMnNJe+yme9s3XfHLE4NzTds7+7i2
a+4xXdVhECYdHt5UrHlD2+pAu9E57WF772yHZn5UwpjB/2tHR9rOVY9vz7zi
N9qVC++fKYv6fxVtziuSzEsoNfxce8y+32zPPnl/u3bnb850rrKCz24Hx6+Y
stL/69qN+94XJdufvH/49uL7wfbQKkoQ+gt5umN4dUmV+0ft0PDbVciB4Zfb
6vKD98yKE01ou7+sxrnR5raxdPnFsz/bbr70VPu6K9/Xrt9zX9s8c1Xp1c3t
yIZntwu3fU17yLHL2off9Z+Hs5ff6JFgMJqAI5hmnyZ6GsgcRg3KaAcnWSPo
u2xRAOWcjJf06yicZU/JyZIEcoxlhrEypvupRn3x9aUdbn6a5eMkBDs6eepM
7zrFVvjFoxVLpbCRSYOobtWhCuBQvNlnTIbRwD3bTD3T9Uwj5yAHn9El+zCV
i/0kBUqoU6JV3k9VbAn6IkqBnhrF2OyvF6XD9uSwVa/uXpTzWO5Mln7E1I2w
Uc1QDFsTzEt1CZssAGO604rRrgQoYZGz+FhASxLiTzedzHcu6h7VIhUIaUKU
MOuxjeqfgmxiGSUgTtflM9F2z3T596//4ve3XVt39MDsQpHp3PUnO20x4in7
7mu3Hb2vMwNvt82Wath8qj335LvbwxdOsU2KVbNt38w3tA0z5VgsnOokfPjm
3xrGnYWzbdPKk23Xylvb8bkPtJtP/Ea78dD/U98h8LidPfx4WzOzv/j/iz17
HA37hEO/0Z51RS/DldKEv1qU20M+TM3i+S43Hrb/FW39PG907Reyda6zda58
2WtLdJxTj/m/ygbYWc16RLv+wFvbU4/8Wj2u1Kvo+fCUavratn/tDe3wpie3
vdv3OrbywPIbs6GK3hLvpcdyABoHNlnRsqiDAYqgyTmaTYOIhyU8sKw+ykns
Oc4JvHhaSGnoPS/50ukideAMQ7Oy6djsPM7J7eDkNyAp5mRxl4UXWJI8q6AF
rsnEjLXi5O7PaqXkInGfetHxjNhsdKS4Mnntc8F6cir82sV1KJpIEEB5TvlM
4sjYtvU6ciGH/CInPwLahc1oq9it9ciR/hyOLs4TKdpfMqqGnHozBz2RFdQo
YmVjmR7mFmTdV/I6JHqewzmTk46iVIbfingpUy9qUnI9ZPlLRhzRsbMEx5nY
OXG+ttkJ3Das2VQ66jCrtq0vTXhieEtnpPgsZ3D77Fe0PSuf0vVZsTLs7J93
zd7Utsxe05l0+dz/bLecuL/dsO83J2Qrws+e186a/S507H+P3vdbUbL9897h
P5QaPVjvf3WYqNUN7RmX3t9uvuz+dvHcL5Uxvb0I+tP9URcPbysT9rltYTjW
5kqQSH00O9pfQuUpVfVDpSP3lHp960wn56b2qH3/qz3+yAcW/x5y9o+1HQsP
baMio5Uhcyt2tR0rntnOHV7XLeF9w0vLOl5fhD63bRydaOtXb2uve8XtB5dP
q5hFs7ys7IhLXuSsnECWaFRkyW4aw59z5JAqaVgRwfchi/JirfkuqyISkM3h
BDxSqjOHlUTLhjwJDakbNcZryvnOvC7kRjr3Iy1I0e48rJz1RkCoZxZKe37q
7RX8QZs+ilcYeKKN+uRQ+mrL5BTFRyzauol5xxlNpvssUNHNCIsJn/70p9uH
PvShHgFD/GR4xAJdm8yP2fCBVZmvysYT8lETdKXvLCITfSMTc/Qso8Y9fo+d
zFcRJs6n7tOt6b5EpdyH8eof51u9BTIIpgSny0habvHG/ml+xe9+4S1t7ar1
nanDsKKNC8usyW3Do0rvfX/ZsJe3fStvjtqkxp5z5bu7St1aumnH7BMnanPU
nnr01ydvu7l59vi1U525cqkebTv5vzMXt6PDr42njKYudw3f2raPn9o2rb6g
qLSm9NvWUpHzxdbLi513lHP7M/XTj1SRu4ZP1f+bS6DMjYtuMy8YJvTcUFbt
z7e1Ve1ZqzVWsG6/vu7+5XbW8LG2ZfjBNjdcWU50olnjrkNXz21o133lsfax
X7vzvOVoebBT0hh65S/qe7oMPWED3ZJVgz6hNEjqSO1k8eRz0r/olPFPJFFZ
iaAq05hm8aHv4C9ZeyYLK2vkh/MW9SC9BseojrYwhor8Unpa/WAKFdGdCyW4
Q9PAHR82m5b8PvMgOW8oSVvYBkSI++hrdVXvaKvpyaYTM291fxxacC2ZAHQj
XyHruLnQRccRbNeI+uiJGFG2+Ug1h+OdHCJe5Ed2IKpU5BZixjNNhIfHIAyb
iFBOqtUpGq9jyK1sDNHRfEpmPlLqlCQ510ADSTBoIJJmwsygEDa8IGFqpHTN
wLqvgLA0w+GDRo7Onm5t/Lvf/7n2hlff3jat29RmRuvbmhUn2ua5RxZLdxQ9
5krTbO/aZmG4xGlFPVHpOTN3dGruWHNl273ylonum+le5tOOvautnT2nHZj5
oVHn5JF2wfDezkV/52/4lrZ2bn+Vvq24e25bWapwRT1FMGpufEmR8Po2P7yo
/p5ZtdnWNs58a7ty30fbtUd+r9144nfaE04+0G664oH++aEHPoKiZdd+uNTw
FW3V6GCp5DvbOhs0x2q/0LasvK1dvuee9sTLP9SefPKD7abjH27nbL2trSrv
V9BLHRbmDrTn3XxTdz0PL8fMVb2zk70PEqeb6Tsyp9nqhy3tgQceGC5ZzLAP
5dgA0e6hDZKDDFPYYPEVSXaMhnYsJdEBI6DDaqAwA/rRj360/cEf/EFPD8Qa
JQFY2Vkh4X7gTU5sTOJQeVbODGaLUbgAnO3C0+28o77O95rFTKICTEgLq8w2
mEu0NfumsE3RViTyyZKEES8Y1PCdDU6JkGbjUjhFkMA+JhNsmqJJWeXApMzE
qrL83jVcpcBwSpcpPxGkcNT7HI6AS5rqes6BxKksVDFk7lGH4s7puveMnDp3
yqlykdr+3Xu797V15lnt+sO/2C7Y8Lo2U8AYrdjU1oyuLZfr8jY/PrqYB5MK
GpdNu3K8TZbvnkC43vfro2H3NBbrmJCV40vwcnhxqZ6DVd6Otm/jf2rXHPtQ
u/rIJ9vBzX9kY/Lwp1XK+lJH8zMny7g8VFr2f8x2jbax3v63cghvLSPxaBsV
5YeqxHjY2jaUObx1+OEi0Qe6Jts8vLZ+ur+qIJfxjnrwpvboqx/afu5HnXu0
DFHmeliQtQgV0yPfskCuHli0GHeWjId7XjkMr7zngf5pbnrtgcnF/mlm+n/M
tmmy14n3f35HGImarXN8IKgKwrI1DKoQhYqkTqAA+RTnCArSmd5gPn3qU59q
n/jEJ7oURpIcaUfdQkdSYAqKIH/yyFBjWZRHqtfvRio2XLe4GokWFu9BJNFb
yoGiieum2rqKMUwGiBcB9XTZfVcGDPIcPpopppwllKmXbBPS9biv53zOKSDI
xYDWbHWLP6asLBBxv+ck/7emZadhlgt7LvIkS4jXrNdkAdOvCclpN8Lcdddd
p2uIvoR8/OPh9GuG4Ufu+4X+aeX0Wrvv+cPwmjd83v7dEt9tz47dRYq5tn3d
Ze3Qxu9sl+37d0Wy3W3N+Op29Xnv7qrjos0f72pj5ehwkWdL27Hu+9vRs+5t
Z2/++YLlwvDzhcG1w11FnKNl3x1uF+67r91w8hPtYUc/1fYs/Ends274i2FX
Wz38l66i1grvDH+IckW+z3QSftXJj7brLvt4O3HgU3XfDxRzdrfNo+/tzFsz
3Fp1OlL13FDEXtdV3qrh39WTf6XK+bP6/o1tYf7aevZ2oRvyQWa+8Yp1bdOG
TWVCHje3cXR5RaXjM3DJ8ZA14EBklcloSrdTd96ySMFVSyh4y52nJp+mCo2J
ljXvWa5jSRzOsLcoJcFNr9lvkrXgwOyz/QGkM/6Rrnjj/Xvf+94+X+cZWcaj
HEDE50QYAZTixUvmcfI5sO0otnio3uNrFFqRa2IiHuz6NjEO/MIbkRzrgk3d
iV0QBXigebiSLT1+QzFY4US0RGnpDtzyKDxVVVzQ5TjIi8opebhJmWqqZk1W
MRXzh32Ly+0//OEP920UxFumPHJqoO7AQ0OLh9piiJOfT31wUHyXB2e1Ij2f
LYPTVVSn67fLn5AzHj5z142LFJxfQsE77rpryZacC3o85mV3PK0dO3JJWzmz
0DavPlYUW9fWj7+xbRr+c7fYWHBHd76zKLGnLL4rS0f9djtr4Y/bdcc/3h5z
xcfakZ2f7pQZF7XWzDyvyPZHCNeO7vujdt2J/7c9+opP9PfzM9cW/c4q2ryz
U2/98P763atKL95WevaqKv9gm53Z0fUnBTdTunLdyhe2s7f8l7L8j3yyGrdj
9a+UXntcfbWrrzlApdmZ+XbonP3tWU++hmk8HFuOZ7N9ektEQnB8uolxot/q
uyxJw54HTt053PLKe8omiNq7Zbjz1IRzEx7u6QNuCo/blBRLohdASXhyn+gq
AMEzXgpO0as5pZ6OM3mQ0+4JbeXl6ChAnUZgRkym8ujIefSETdjiESZFvmte
Ewyim6i9eKOKokMS/E+UPdPqDD/lw6174ZOe428l5y2K04MmANTDTGs/IZbb
OdO1KzZrSVFrsml2R38ishMetKBB0Ggop9kw03cESeYyCQNKPytpsAY7vSZh
Huu7h3aqKaVYjANCJ7iJiIifKVQ/9Z4M9BjyrGyKpUHMB1Vwi0z6wCuHO6bK
7HNK78bhnR/4hSULadf2RTove+HT2vzKtT18OLEIy3QrE27W8pmVewvG68pk
e2L5T88doUNpzB3rXt4O7fm2trDqeCmRs8rSO1Z/lzH5HlL25ux4X5sZ76o/
YZDV01K3Fbe+os3PPrWMxO9tOzfd3fbveGc7fv4ftIP77i5f8Ultbvbcrj4n
3tuoR3RWzs63i87f377nJc+6YjnerO2bGTgjLG1/+s0QJMShT7Fiah5OKDI/
PPDAqaG01ef+3XLL0D/ecudw6oEHRg9iQI6mek0YmsYi2mkxwQ7MorkE/UuM
1r1lSw6XdrGLiWpBhMKf3//+7/9+Vwk51JjIN6q0l+/BGxghQ/k5xcH9aRka
JcNMto+wHKkHTM5BrUsTr1NJtCVR7xqa5tWz/D6pUKcqQi7xN76xH/xSA4qj
7DCBAzd6ePI/2wEgQoQtvks6GeIs68qYvHRflh9OZzpGMD9MDuOlgbmwWRhL
ZOR4Ld8RKaIwOR0jp0joY8R0TTuJBNJOf6Yvc7wNaVhm8+m6/iWxa6n5OOr/
z3Z99rl/zx9Od6j+a9Ny59Src0KcFFBXXXa0bd9iUdjG4kc5RivmF5m4ong6
Go4WxW4sLj2xjceX1jVMdc/K4sqRUi7PaRvWvrbM1B9sO7e+vG3e8FVtzarL
6vqBKktUdFW9P9ZWr5qEDndv398uOXKsfcPNX9316g+/5vnt277pSVctzy12
UZaNEG96Psm4XTNmDzxwz1AWHh20yC2kqYv3PDBRS4ufT91Tf5/jFk02uW3K
rVs7V2wTYkKBC464RhOdPn2676jEM26P++pXHU7wj2sf+chH+nekKImLl2II
rEXj6nN2Q4Iq9QIfVAqM0LKZQsITUhm847bAGBOIRcj61RM5pky5JHwORsyy
zSyVBn3LRxPcRyMuk7KS+Q1nEzfAAbRybxbAZBkqVymuWLJDoFq2p+VkF/X3
2fO1KWdU4hIOZTVcDqScHt06yUuzebEKukB3egwxQ/zFMiVKsDsL4xgJRFYN
3+mq0hnpNRe6fPINw48MXVlN6TU3vfY52nVKTWk2Wqr0ptf2TQlrERsT0p+Q
5Fddc0U7fHBfWzW3qWi3f4wLxaQLDl7Ydm7b29auWSi2bG4XnHe03fCIR4xR
pIyFO7/vhe3u17+o/ceXP0cS8Ucsb8Blqil7Gmq4pwllZ7Pw8kEgP7dEE3US
LWXPkNjGEpJNf/fQ7tSALprEsAN19DA+KCMaIDpgtTAPhWXE2PNb1xl5vjN/
hCLGkQdjrpwIpTKompz2yx7yanyJUqoFLQL1eC9ZdgGmIhB+D+5es5QDdmCG
qkM1ZWQDMOGCWtRRhI7555FeHq5c3OBtr5d7liZSNM8ROuUgoOwIVX6SK7Aq
jRlNlB2NcWzRBi1SrufwgkJdWs8MtPuTTI5qyhmlRBE7Ut8xmHMCgyARbzCb
opJoocbsdPXDmbyouQeB/BelyifvGt759f3z56iyhGIvXl70Jy5N8NHlPvNd
9dL0XLWlaJ4E12a/wKxaDsQv6uAFYqBkupPbzHogNsehs3gzPBa2VYSLlcRA
TAfQCcDqOk+HSwDYf/zHf9zBTVCRswCnSWwd9gQ5T+Yz1HNoju88P9k5Mves
jIDG4CZLjmeSuYkjew4d4DdA7PcAkvVHmfuO++M6lz7ZBROBQJocZJ8U9Fap
EbaAzPVPtkDDwqbRPvaPsL5hAkRl0k1Z4U0nKAeByPvk/UV0fUCfeFWO68gK
tNqY48K1Uxs9O46OOpkvKkJ/aQL/X6F4vBTFi8hmd03jA1Nk/2+hGLfJpJwg
kEMedN907c9SFK9cavV/CeiFUAZx4lXEGHQQvZANuawRPUA8QweEf+Yzn+mb
VYhcYtnkDH9cL//O7/xOF9uZRoe4JFFCRijKAQVGhghikWiq60bU841KlhNB
tHqpK6YROcqElOR18R7KIZ+KJ66zzj85L4jhXCdes9KCOIxV5D710FaoYLn4
TjuyPhI7MIbDjrmYj+mQlbzskAWlmOpZnq1tmIN92qOf1JtVA63GAEOUk3R5
XrM5zTO0FYol9M42O2VXn52ue/6N6P3iMrjQ+2+VwVmenMWK5C7NBGZQbc3I
EvR+zqBYRGq/cqoL5OXQ/LTe89DIB01aA4+CHnL04x//eDcOyGY9TW7zfyk4
aP6TP/mTfhC3jKSZSoRoaEx2I71PNi1dQQuJSeanyd5DM4S713MSBU5ybvUi
e/kGWED+KQtDcgIAtLgGQRCb7J7Jz0gOZjaGfMwiQmhP1uYsSUvGZIhRP8+I
nw1x+iPoooOS8BybGEoEkPIK1SNCfti9eOoSFeYWTVLtnKoCxL5n2yU5qnvy
O48iJAwPQmVtvccWyZfd9PGlgDn29sT2Xmqf/2+DmZmYaIRqJk+0VzJISrkl
qBxPDYpTnxekEZ45NZ3JezAHcraLOKKWdQvI9bm+e/Ob3zx8cwe3qQGGhO+J
3Ew7mDvjPP7VX/1V+8u//MueXfP3fu/32t///d93QKti0tMmjQ8uJt6Z0/KA
JEDPNqYEJYwMAwOos5WHWM+RGH6T/YBGOifTZQVNpkHcQxZQ7smekFRGrGVi
OWcPAzQwM0KStt71HMeZKR2IiqiEvlip5ExygGi71+z/RdbsZcx0JaFBfHvV
3wRJUhwpL+nGkjcQggkIZEaa5FnxfZHqdD3zS7KK/5UDuXKJRA6YuzQePwju
vwT8Rm95hVsDqwHJf4auS+KMa79oAHF7Nw3glOEqgMHbsh6euQCfGJ2d69hv
Dudv/uZvugD+0z/90/aP//iP7c///M97QARGYdb1khISe734xcWDmCG8jGlq
9fpOQvNHLu5TySopY6kZ7s2xMMYi2V1dN+YMyKzxhW26Kfj2PrvgGZm6I/iG
5Zw7n9WJMJcz6HxO2sqExRMIgW31g9PsP0jWVopHXyby4FneU0QUFq8Ot/Uj
CZsstuoJXw68GWHGCG2GDZ1sSXrjpqT5oFVUNKRWCMCX7XK67j0TQOeXGLJT
02CJITsxdh9sPnpZRK5c3O2YrBxTBTHZBDXTG7JkwuiLzxcd7DYnjQ1gWbPA
bgU8AhKYROR0pg6njti+iAzAf/3Xf93+7M/+rAsOoCRMDYDvAF2/Gizg5snR
6IREJnn0c44VnR4ZOk3HcOPigodo9+RHBDwDHjs3UzFZuAA06kmgZfOLMpLC
JZ5a9vb4fc5GyIZsgMkKX0IbKNm7WQTvefChfX5D4bDls8TWyCCfJbrsbveY
sM0GngAxe2DZ3dkkA/A8w+nm+S7w1RsG9Ue22BGWlA+iqB8vbJmF78Hkkimj
L4rJpVNIy2Jy1aLqo04SC83mimnG3c9bLRDRuGoRncO/Wi3AjtSzkGjeBDKJ
NoiybI3YNNJ6Uk/zrgS00N730EjEEqlGxwh4pe5temQGiBl4BmNMEI0INrJZ
d54sOtqVhBw5WhOSeT18+QSQEivo2/8KUsM1iwcCLl04JE6Xc22jTUlX3M1A
J+GOx7ueVTnApBzl5vC/OJgcS+TVFODwe01TZVXzmyQF1jTdqcnJhkDr08S0
t/KEIkhjYWMLsqwK4ECJr3HSCAJdQkgahhy6oRxtdi6yaxL+LNHoD2qXrpqq
7z698po3LLFFOzJnl8zIZOXAty0HzHEfNPqsXofJlOzM4gp110skLfpG99y5
KCHnlpiad05XtkzMzzXd9+Df6CB408EaQq0zL0lCcaqSrvXIkp/D0S5pp8Hx
jk/Y4zNFcijToLmuTFLXYMJv9ieQHPHNNCHWdM6FSsZH91CXwGEwgIaaTPZn
+HQ9uevFwgAqEieHJve58hKNpSCNpx5jHeYkx0xmw4tehrWc6JjtHjBfzRwx
rYfzu7FCp6i9XlCcp/HjGag51wVTsZdxkD24ik9uXTUXehXytVDMYhqLVPj0
ZkmEbcn+HBnlGeIRrpH1cinw5mpETldTziQzV08n/dp9r+xG5lJZObPEonzn
1P1/yfKyMktosgQu85O0ARyUrJsuAd7W5ROC0hxwQbNatkvWwRQ5Ri7CEXzQ
uomr6kUuD4FAZsImXNXrCNBK1vsKVBXPvScPqvUjMnd4bB8jehG6SMQcg52z
9RjxPGDih5MBYdmmRgO4xjHxGxDJ4b/EEHGmJ3LeRhwha8OSK9T4JecxRJK6
nqtH9AboZacmCQ3JWq1n9ARmapJehTllxKZQR+2DKWVhmXIJhWxz8XyxKvA3
Awdj1h3kqHc4c30aWZ3kuVm1mNNSAALUVL+qdxrKziQBv3/5dJqsK7LH+Gph
3NrMc/pOjX2PfISz3jT+cKOl5A5Xl3v72c9+tv3d3/1dl11/+Id/2OM59K5X
OlWvxHJhJYqt/+3f/m13j//5n/+5J9FiNXK9yTY9DWOel0wg9LQyySSf9TpJ
EHdIFJU7Y7SMIn0PVbDvXs+EXSOX7FXJjJH0lNniDE0UItRRUNn3kMzTUJVl
8z4TWMolUcSKKDz3Jt2V3yatJ/RCDQmCa9qjDcnIAX05pEIdyXtyO1nztIv0
ojShTJnaq436CxJZycZCvZKF173uwyh1TMLDnGrkc7ZTQihpSEn7znsS0aSV
uheiT994441nknjLonBucXUF1BllLTBi1Wul8aquw9mdq1pvhCGSrMAjrTdS
JNc//dM/dTRxaqENQv/lX/6liyWIyS49z4BWvkYWPv/DP/xD7yn3/cVf/EW3
6lh6njntyWkA6MYuA4wWE4XFqA7ugThaHLq1BeoFgIxuLEd18bxIUk431CU/
hFEKSrJDgJ5B/szgEABL13xBJ5SRi9AKkcnRk21KAji+i86KtsgRKDkOBnKy
eJoWgAKx+vg+2KsfqerIMn1AvhkTYwHFIKCNUOt+ctZ9hb4RaJcy8tHQZ6ZU
FxKZyQGQM9mtB4qYTGZOM7O+91sgLJH5ZYHwaFeFgOdVw7I6NSYSN0Tt0NLg
axRwxMGPyDDgqAl8RKFXwNQZTDPiiTGSZSSeByBcEtEZoPAbjjTFQ48CWM7x
AVDl+G0p03FfW/WMPpbGwm2qRmoqEhbhzeNIa5IRDvnnqoonmkVqZbIWsxOY
M27pClINBpPrXJNJFvijswxWdpmx/GA6W+dIlJxxQHfmDJJEHEjHpUcBkVBk
QCaNk5lB+xJgwj9yw/Cov2GjMXBcH+CcIYFLw5gzEzyfJM+5xSSuZ7MVaAnd
rS8BUltyiBM/WuS+JOCoJ0yd7UUXhpee2/1v08XrO0jYYV5JOS1VC1IAG42o
2tHBqAOEJNEkXCfWMTnUSeuBAwtJMfqZlHGv30dvRD+QgnQi0EFF5lywn33g
WZ6vd/QM9PArGHqaqOeSgo5Eop/c6xnq6L1nKk9vqz/9RVp6tn/aTYfzdUim
ZJNNyDe2J0QrE8qgjbSCAuiDzBzilL3j9HJOWcwpE9CUkCN0JtNXUILQ3ufU
msxlKzsHXiWBp+teU4a2aRfkGr+smM5Je9kcHb1u7RRRBlVJhgSV6qDfvM9m
6WTXJ/ZIbFI9qRGxrX5/uiT8lwfDuS4gDBWypJuQV/RhYuef6MOnaYYGAQkY
Q0Q2JhqPpMlYjozJT2HIQFH5mshNBTkKk8kIgmDhPdnoO1BSXranEkqIvPS3
nqH7kqhJlyN/zCZl+C1hF9NWG5T7sY99rNpWonC4oD87dSN7CTkwMJyeRyYz
k/0ueWBR0/CDGpORMuaEEKaGjAK1oDjOBQGU7Iw5bJAQUndDm2zooAwqxADI
U+yUeH03gqfygRPDI08zE6qqJIgugjoMCUMVn1W6ijS0WJLVsO7LgUy6K8ub
NFP1OCOsQr4ym8RvNY+C5kPfcMMNp8uS/LKU8bibBZ42OQrK8oq53jq1SXoi
r2RRybq6p+yu4emde1qvtiwS9wAAEGqV94BI1uEqngI7TUhWZisc8JGZrETK
OTP/BsbAKYtMDNApZOUm8XeSHCCD+pChiEIjIQoQerbPWTjHB2IwIFO2+/ie
P0SLAz3fh9/EiEAO99APPpPH2WMKkO7PaovkyEj2xnjAEOB7so13DfjagBi0
s+/Im8hCKCFnq4xhki1m3+I6H3KNZaB8FgOZn0WdmQby3Jy8m3VOkZ+QmTWl
ObgvR3AhVQ7nI4MLbZOjE1ctJlKzZs+BydnwUNX+cr1jNcx5SdkclZh+1tPg
EoQQJ0aaaIQiYo7IMbq8Y6LEqOqVRI1L7HQtDDGu+4330fbZoEgkJUEy5GTf
GeTl2jQo2RHp99CfeSe97Nm0rxFWR6iHwPgq7EATXtDFAuFDYQkLAbKgjehT
dyzzHmqJa+jGCHVneaiDvsManyEtmljfGc2cI6sdhsznrKzIJHH8KmUrgzgl
i9iREYXQ4Dt+TlaRQVJiQPoBG5NLXh/oE/ISorOjm5h1LT5UNsjzdKFbP1Nf
YkSZ+/Ec3rKQNmZxTMQPEw+sZy+F4b9RISe7drY5aLHX6sX6IS0wu3jCrhaS
2jWixc/PfvazI9bVsLobToaHwGQiIzm4aRaPw1D2LYklIYdv7cglr6Dan9sg
R7wlUbRsxaAM8Tu5dLL/HQr0NJRGm/g9xPmd8rAC8rCBbPNMzhHE89xdgzTz
L1BK2RsFCKaMszUyya4yZ5SDSrGWbDNaDITst/ddllFk/Y4RxG71jTxKH1Di
kAehrlv7Q+slrR30QJyyzLxZ4EsOarP+Ul5YkkU3SYEHvV4pfKzBSoz2DPIQ
g0gH/ak++p1BABfcYeuNuMwiiEGfMp1kVP3w5QnB44sGxnQaajFFAnIhDDMW
PJNnLNmgs51JQITpTlBoBoGY8J2uIUwidARMuCg58IrwgUzqjdok2BAwAi+H
x4G9ZxE4hhUcsiAxh0kXVIYJvA91eIOh33geKGFFlqUR6IShf5jjWuxI3zEP
/NMW9TIsmaAGeeWqd5xmKlS/qV8Ov9N/XkFZPxKAJSSrjiY393YogpWAD2Fn
UhbEcpIleHBMCdas3smpw4I9yfnkGdpvXJK0H8SSaW2a539q33Mj53sfGjdw
9R5dsvGz4DsilUvqQCzEsQVFD8svriJKfw8ruz2IhbySLzdCON95nmVTOW00
2457VjlpHPZ3hezrTN7DRnYwa4vxoviS3SB+CJOLkrYAAVZhIy4x0UPExV2G
V2OmSnCa+c4+vVUDPDx3Uff5SbrcbT57ZOKdYIcSJIxqkY5JVKdo/+jdrGeN
RaU8ZYBs4qUoxCv3OxB1TXVJTdA0hNG/9J6uYdeQiuoFoqSb+9CNpMzqypxM
zaOOrqaF3EtHkkbTTbL93pxzC7pwAb7oGhh6pn7IKIJi0kChNGnJRjBkNI9+
SmQ8q8jpcfXWz9P82x3ygoTwKP+q6WJecz3jo1WPd5Sn/IUYPHbhATt8CoP+
PwMGtySdTn/NDuec9h5rhA6hJ/RUsnLoWb2mdwjQaY6myb7hx/ZGG2CGiEGO
+NdQnIM1HQcUZItXgwfTBimGTVLckc3xG8mKGDg5X9vvcwIZIAEJFRvjUyeH
L+5j8Ols3MoJWzjgWqYIlUVGCuOIHwAQAJKBygdWgwWwWepAvmibOrmuzcmx
pfvcF9MfIKaG2Uh/D5f0Hk+kh/hUjCbr/USCMlKuRRurajImkybex0PLAQfw
qBuzXILIzmqRaN7kwseDHD6x9FALXIOWRJiqOX9f8vGDF1xwwdcWpqcYPKHY
c/fvIgsLg/4f/3a511+Iwf7hG/7/9/+n3w8r/j8nJMU/\
\>"]]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->None,
WindowSize->{1272, 902},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
DockedCells->(FrontEndExecute[{
   FrontEnd`NotebookApply[
    FrontEnd`InputNotebook[], #, Placeholder]}]& ),
PrintingCopies->1,
PrintingPageRange->{Automatic, Automatic},
PageHeaders->{{None, None, None}, {None, None, None}},
PrintingOptions->{"FacingPages"->False,
"FirstPageHeader"->True,
"PrintCellBrackets"->False,
"PrintMultipleHorizontalPages"->False,
"PrintRegistrationMarks"->False,
"PrintingMargins"->{{71.875, 71.875}, {53.875, 53.875}}},
ShowSelection->True,
Magnification->1.25,
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (February 23, 2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 194, 4, 69, "Text"],
Cell[742, 26, 487, 10, 34, "Text"],
Cell[CellGroupData[{
Cell[1254, 40, 41, 0, 88, "Section"],
Cell[1298, 42, 533, 12, 55, "Text"],
Cell[CellGroupData[{
Cell[1856, 58, 184, 4, 35, "Input"],
Cell[2043, 64, 12709, 316, 145, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[14801, 386, 59, 0, 88, "Section"],
Cell[14863, 388, 70, 0, 34, "Text"],
Cell[CellGroupData[{
Cell[14958, 392, 3564, 92, 476, "Input"],
Cell[18525, 486, 15407, 276, 198, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[33981, 768, 142, 2, 88, "Section"],
Cell[CellGroupData[{
Cell[34148, 774, 4816, 124, 564, "Input"],
Cell[38967, 900, 18168, 403, 198, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[57184, 1309, 220, 3, 88, "Section"],
Cell[CellGroupData[{
Cell[57429, 1316, 5242, 129, 674, "Input"],
Cell[62674, 1447, 7513, 165, 378, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[70236, 1618, 125, 2, 88, "Section"],
Cell[70364, 1622, 1309, 37, 102, "Input"],
Cell[CellGroupData[{
Cell[71698, 1663, 15058, 354, 1378, "Input"],
Cell[86759, 2019, 53753, 1316, 288, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[140561, 3341, 250, 3, 88, "Section"],
Cell[CellGroupData[{
Cell[140836, 3348, 6767, 160, 872, "Input"],
Cell[147606, 3510, 15112, 311, 378, "Output"]
}, Open  ]],
Cell[162733, 3824, 26, 0, 35, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[162796, 3829, 276, 8, 88, "Section"],
Cell[163075, 3839, 446, 7, 55, "Text"],
Cell[CellGroupData[{
Cell[163546, 3850, 9316, 228, 1268, "Input"],
Cell[172865, 4080, 34156, 690, 234, 26420, 562, "CachedBoxData", "BoxData", \
"Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[207070, 4776, 116, 1, 88, "Section"],
Cell[207189, 4779, 211, 6, 35, "Text"],
Cell[207403, 4787, 771, 13, 159, "Text"],
Cell[208177, 4802, 778, 15, 97, "Text"],
Cell[CellGroupData[{
Cell[208980, 4821, 404, 8, 35, "Input"],
Cell[209387, 4831, 210, 6, 37, "Output"]
}, Open  ]],
Cell[209612, 4840, 176, 2, 34, "Text"],
Cell[209791, 4844, 2691, 60, 146, "Input"],
Cell[212485, 4906, 177, 2, 34, "Text"],
Cell[212665, 4910, 3890, 102, 212, "Input"],
Cell[216558, 5014, 176, 2, 34, "Text"],
Cell[216737, 5018, 3944, 100, 146, "Input"],
Cell[220684, 5120, 135, 2, 34, "Text"],
Cell[CellGroupData[{
Cell[220844, 5126, 12565, 279, 1642, "Input"],
Cell[233412, 5407, 80851, 1642, 558, "Output"]
}, Open  ]],
Cell[314278, 7052, 251, 6, 55, "Text"],
Cell[314532, 7060, 87043, 1824, 558, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[401612, 8889, 265, 3, 88, "Section"],
Cell[401880, 8894, 217, 4, 34, "Text"],
Cell[402100, 8900, 92, 1, 34, "Text"],
Cell[402195, 8903, 714, 14, 35, "Input"],
Cell[402912, 8919, 102, 1, 34, "Text"],
Cell[403017, 8922, 1116, 31, 80, "Input"],
Cell[404136, 8955, 176, 4, 34, "Text"],
Cell[404315, 8961, 789, 23, 58, "Input"],
Cell[405107, 8986, 1833, 42, 168, "Input"],
Cell[406943, 9030, 4155, 101, 476, "Input"],
Cell[411101, 9133, 159, 3, 34, "Text"],
Cell[411263, 9138, 939, 26, 80, "Input"],
Cell[412205, 9166, 101, 1, 34, "Text"],
Cell[CellGroupData[{
Cell[412331, 9171, 22589, 526, 2852, "Input"],
Cell[434923, 9699, 462401, 7295, 396, 387116, 6059, "CachedBoxData", \
"BoxData", "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[897373, 17000, 134, 1, 88, "Section"],
Cell[897510, 17003, 366, 8, 34, "Text"],
Cell[897879, 17013, 483, 9, 35, "Input"],
Cell[898365, 17024, 263, 7, 34, "Text"],
Cell[898631, 17033, 739, 14, 35, "Input"],
Cell[CellGroupData[{
Cell[899395, 17051, 5575, 117, 806, "Input"],
Cell[904973, 17170, 1022957, 17037, 378, 859903, 14362, "CachedBoxData", \
"BoxData", "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
